<div align="center">
    <img src="logo.png" alt="CliqueTrees.jl" width="200">
</div>
<h1 align="center">
    CliqueTrees.jl
    <p align="center">
        <a href="https://algebraicjulia.github.io/CliqueTrees.jl/stable">
            <img src="https://img.shields.io/badge/docs-stable-blue.svg" alt="documentation (stable)">
        </a>
        <a href="https://algebraicjulia.github.io/CliqueTrees.jl/dev">
            <img src="https://img.shields.io/badge/docs-dev-blue.svg" alt="documentation (development)">
        </a>
        <a href="https://github.com/AlgebraicJulia/CliqueTrees.jl/actions/workflows/julia_ci.yml">
            <img src="https://github.com/AlgebraicJulia/CliqueTrees.jl/actions/workflows/julia_ci.yml/badge.svg" alt="build status">
        </a>
        <a href="https://codecov.io/gh/AlgebraicJulia/CliqueTrees.jl">
            <img src="https://codecov.io/gh/AlgebraicJulia/CliqueTrees.jl/branch/main/graph/badge.svg" alt="code coverage">
        </a>
        <a href="https://github.com/fredrikekre/Runic.jl">
            <img src="https://img.shields.io/badge/code_style-%E1%9A%B1%E1%9A%A2%E1%9A%BE%E1%9B%81%E1%9A%B2-black" alt="Runic">
        </a>
        <a href="https://github.com/JuliaTesting/Aqua.jl">
            <img src="https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg" alt="Aqua">
        </a>
        <a href="https://github.com/aviatesk/JET.jl">
            <img src="https://img.shields.io/badge/%F0%9F%9B%A9%EF%B8%8F_tested_with-JET.jl-233f9a" alt="JET">
        </a>
    </p>
</h2>

CliqueTrees.jl implements *clique trees* in Julia. You can use it to construct [clique trees](https://en.wikipedia.org/wiki/Tree_decomposition) and [chordal completions](https://en.wikipedia.org/wiki/Chordal_completion) of graphs. Additionally, you can use the submodule `CliqueTrees.Multifrontal` to compute Cholesky and LDLt factorizations of sparse matrices.

## Getting Help

If you have a question about the library, feel free to open an [issue](https://github.com/AlgebraicJulia/CliqueTrees.jl/issues) or leave a message in the [cliquetrees.jl](https://julialang.zulipchat.com/#narrow/channel/513749-cliquetrees.2Ejl) Zulip channel.

## Projects using CliqueTrees

- [BandedMatrices.jl](https://github.com/JuliaLinearAlgebra/BandedMatrices.jl)
- [BayesNets.jl](https://github.com/sisl/BayesNets.jl)
- [CausalInference.jl](https://github.com/mschauer/CausalInference.jl)
- [EinExprs.jl](https://github.com/bsc-quantic/EinExprs.jl)
- [IncrementalInference.jl](https://github.com/JuliaRobotics/IncrementalInference.jl)
- [OMEinsumContractionOrders.jl](https://github.com/TensorBFS/OMEinsumContractionOrders.jl)
- [Scruff.jl](https://github.com/charles-river-analytics/Scruff.jl)
- [SparseMatrixColorings.jl](https://github.com/gdalle/SparseMatrixColorings.jl)
- [SumOfSquares.jl](https://github.com/jump-dev/SumOfSquares.jl)
- [TSSOS.jl](https://github.com/wangjie212/TSSOS)

## Installation

To install CliqueTrees.jl, enter the Pkg REPL by typing `]` and run the following command.

```
pkg> add CliqueTrees
```

## Clique Trees

A clique tree (also tree decomposition, junction tree, or join tree) partitions a graph into a tree of overlapping subgraphs.
The key invariant of a clique tree is the *running intersection property*: if two subgraphs in the tree contain the same
vertex, then so do all the subgraphs on the unique path between them.

<div align="center">
    <img src="tree.svg" alt="clique tree" width="400">
</div>

Clique trees play an important role in algorithms for

- graph coloring
- probabilistic inference
- tensor network contraction
- matrix factorization
- semidefinite programming
- polynomial optimization

and more. In all of these applications, it is important that the subgraphs in a clique tree be as small as possible.
Consider, for example graph coloring. 3-coloring is NP-Hard, and the fastest known algorithm for deciding if a graph is
3-colorable runs in $O(1.3289^n)$ time. However, if we are given tree decomposition of a graph with $m$ subgraphs,
and whose largest subgraph contains $k$ vertices, then we can decide if it is 3-colorable in $O(m3^k)$ time. This
is very powerful, but only if $k$ is very small.

## Constructing Clique Trees

Clique trees can be constructed using the function `cliquetree`. The function returns two objects: a vertex permutation
and a clique tree.

```julia-repl
julia> using CliqueTrees

julia> graph = [
           0 1 0 0 0 0 0 0
           1 0 1 0 0 1 0 0
           0 1 0 1 0 1 1 1
           0 0 1 0 0 0 0 0
           0 0 0 0 0 1 1 0
           0 1 1 0 1 0 0 0
           0 0 1 0 1 0 0 1
           0 0 1 0 0 0 1 0
       ];

julia> perm, tree = cliquetree(graph; alg=MF());

julia> tree
6-element CliqueTree{Int64, Int64}:
 [6, 7, 8]
 └─ [5, 7, 8]
    ├─ [1, 5]
    ├─ [3, 5, 7]
    │  └─ [2, 3]
    └─ [4, 5, 8]
```

The clique tree object behaves like a vector of vectors, with `perm[tree[i]]` containing the vertices in the i-th
subgraph. The tree also implements the [indexed tree interface](http://juliacollections.github.io/AbstractTrees.jl/stable/#The-Indexed-Tree-Interface)
from AbstractTrees.jl.

## Algorithms

The `alg` keyword argument specifies which algorithm is used to construct the clique tree. CliqueTrees.jl implements
a large number of algorithms for solving problems. It also interfaces with libraries like TreeWidthSolver.jl, Metis.jl,
and AMD.jl, so that users can use the algorithms implemented there as well. Algorithms for computing clique trees
can be divided into two categories: exact and approximate.

### Exact Algorithms

Exact algorithms construct optimal clique trees. CliqueTrees.jl exports two exact algorithms.

- `BT`: Bouchite-Toudinca
- `PIDBT`: positive-instance driven Bouchitte-Toudinca

Beware! These algorithms are solving an NP-Hard problem. Users are advised to wrap them in the
pre-processing algorithms `SafeSeparators` and `SafeRules`.

```julia-repl
julia> alg = SafeRules(SafeSeparators(PIDBT()));
```

If a graph is [chordal](https://en.wikipedia.org/wiki/Chordal_graph), then an optimal clique tree can be computed in
linear time using either of the following algorithms.

- `MCS`: maximum cardinality search
- `LexBFS`: lexicographic breadth-first search

Users can detect whether a graph is chordal using the function `ischordal`.

### Heuristic Algorithms

Because computing optimal clique trees is NP-Hard, a large number of approximate algorithms have been developed for
quickly computing non-optimal ones. These include the following.

- `RCM`: reverse Cuthill-McKee
- `MMD`: multiple minimum degree
- `MF`: minimum fill
- `AMD`: approximate minimum degree
- `AMF`: approximate minimum fill
- `METIS`: nested dissection
- `ND`: nested dissection

For large graphs, the algorithms `AMD` and `METIS` are the state-of-the practice. They are implemented in the C libraries
SuiteSparse and METIS. The current default algorithm is `MF`: a slower but more reliable alternative to `AMD`.

### Pre-Processing Algorithms

The performance of clique tree algorithms can be improved by wrapping them one or more of the following pre-processing
algorithms.

- `ConnectedComponents`
- `Compression`
- `SimplicialRule`
- `SafeRules`
- `SafeSeparators`

## Matrix Factorization

An important application of clique trees is sparse matrix factorization. The multifrontal Cholesky factorization algorithm
uses a clique tree to schedule computations, performing a dense matrix factorization at each subgraph. This algorithm is
implemented in the submodule `CliqueTrees.Multifrontal`.

```julia-repl
julia> using CliqueTrees.Multifrontal, LinearAlgebra

julia> A = [
           4  2  0  0  2
           2  5  0  0  3
           0  0  4  2  0
           0  0  2  5  2
           2  3  0  2  7
       ];

julia> F = cholesky!(ChordalCholesky(A))
5×5 FChordalCholesky{:L, Float64, Int64} with 10 stored entries:
 2.0   ⋅    ⋅    ⋅    ⋅
 0.0  2.0   ⋅    ⋅    ⋅
 0.0  1.0  2.0   ⋅    ⋅
 1.0  0.0  0.0  2.0   ⋅
 0.0  1.0  1.0  1.0  2.0
```

The multifrontal LDLt factorization algorithm is implemented as well. It can be used to factorize quasi-definite matrices.

```julia-repl
julia> F = ldlt!(ChordalLDLt(A))
5×5 FChordalLDLt{:L, Float64, Int64} with 10 stored entries:
 1.0   ⋅    ⋅    ⋅    ⋅
 0.0  1.0   ⋅    ⋅    ⋅
 0.0  0.5  1.0   ⋅    ⋅
 0.5  0.0  0.0  1.0   ⋅
 0.0  0.5  0.5  0.5  1.0

 4.0   ⋅    ⋅    ⋅    ⋅
  ⋅   4.0   ⋅    ⋅    ⋅
  ⋅    ⋅   4.0   ⋅    ⋅
  ⋅    ⋅    ⋅   4.0   ⋅
  ⋅    ⋅    ⋅    ⋅   4.0
```

## Graphs

Users can input graphs as adjacency matrices. Additionally, CliqueTrees.jl supports the `HasGraph` type from [Catlab.jl](https://github.com/AlgebraicJulia/Catlab.jl) and the `AbstractGraph` type from [Graphs.jl](https://github.com/JuliaGraphs/Graphs.jl). Instances of the latter should implement the following subset of the [abstract graph interface](https://juliagraphs.org/Graphs.jl/stable/core_functions/interface/).

  - `is_directed`
  - `ne`
  - `nv`
  - `outneighbors`
  - `vertices`

Self-edges are always ignored.

## Citation

If you use CliqueTrees.jl for a publication, please cite it as follows.

```bibtex
@misc{cliquetrees2025samuelson,
  author = {Samuelson, Richard and Fairbanks, James},
  url = {https://github.com/AlgebraicJulia/CliqueTrees.jl},
  title = {CliqueTrees.jl: A Julia library for computing tree decompositions and chordal completions of graphs},
  year = {2025}
}
```

# AMFLib.jl

The approximate minimum fill algorithm.

## Basic Usage

The function `amf` computes a fill-reducing permutation of a simple graph.

```julia-repl
julia> using CliqueTrees.AMFLib, SparseArrays

julia> graph = sparse([
           0 1 0 0 0 0 0 0
           1 0 1 0 0 1 0 0
           0 1 0 1 0 1 1 1
           0 0 1 0 0 0 0 0
           0 0 0 0 0 1 1 0
           0 1 1 0 1 0 0 0
           0 0 1 0 1 0 0 1
           0 0 1 0 0 0 1 0
       ]);

julia> perm, invp = amf(8, graph.colptr, graph.rowval);

julia> perm
8-element Vector{Int64}:
 4
 1
 2
 6
 5
 3
 8
 7
```

# MMDLib.jl

The multiple minimum degree algorithm.

## Basic Usage

The function `mmd` computes a fill-reducing permutation of a simple graph.

```julia-repl
julia> using CliqueTrees.MMDLib, SparseArrays

julia> graph = sparse([
           0 1 0 0 0 0 0 0
           1 0 1 0 0 1 0 0
           0 1 0 1 0 1 1 1
           0 0 1 0 0 0 0 0
           0 0 0 0 0 1 1 0
           0 1 1 0 1 0 0 0
           0 0 1 0 1 0 0 1
           0 0 1 0 0 0 1 0
       ]);

julia> invp = mmd(8, graph.colptr, graph.rowval)
8-element Vector{Int64}:
 2
 3
 6
 1
 5
 7
 8
 4
```

# Differential.jl

## Supported Automatic Differentiation Libraries

- [ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl/)
- [Mooncake.jl](https://github.com/chalk-lab/Mooncake.jl)
- [Zygote.jl](https://github.com/fluxml/zygote.jl)

# Heuristics for finding small tree decompositions.
# Based on Tamaki_Tree_Decomp/Heuristics.cs, using 1-based vertex indexing
# and AbstractPackedSet bitsets.
#
# Only the min-degree elimination ordering is retained (min_fill and min_defect
# were only used by the initial safe separator preprocessing, now removed).

# ==================== HeuristicBagsAndNeighbors ====================

"""
    heuristic_bags_and_neighbors(graph, weights)

Compute an elimination ordering using the min-degree heuristic.

Operates on the provided (mutable) graph, eliminating vertices one at a time.
Each step yields a `(bag, parent)` pair where:
- `bag`    = N[v] (closed neighborhood of v) at the time of elimination
- `parent` = N(v) (open neighborhood of v) at the time of elimination

Returns `(pairs, remaining)` where `pairs` is a `Vector{Tuple{PSet, PSet}}` of
(bag, parent) pairs and `remaining` is the set of vertices still present
(a clique) when the heuristic stops early.
"""
function heuristic_bags_and_neighbors(weights::Vector{Int}, graph::Graph{PSet}) where {PSet <: AbstractPackedSet}
    total_weight = wt(weights, vertices(graph))
    mindegree = total_weight
    result = Tuple{PSet, PSet}[]

    closed_nbrs = Vector{PSet}(undef, domain(PSet))

    for v in vertices(graph)
        closed_nbrs[v] = neighbors(graph, v) ∪ v
    end

    # Bucket Queue #############
    head = zeros(Int, total_weight)
    prev = Vector{Int}(undef, domain(PSet))
    next = Vector{Int}(undef, domain(PSet))

    function set(degree::Int)
        return DoublyLinkedList(view(head, degree), prev, next)
    end

    for v in vertices(graph)
        degree = wt(weights, closed_nbrs[v])
        pushfirst!(set(degree), v)
        mindegree = min(mindegree, degree)
    end
    ############################

    R = vertices(graph)
    eliminated_weight = 0

    while mindegree + eliminated_weight < total_weight
        v = first(set(mindegree))

        W = closed_nbrs[v]; V = PSet()

        for w in W
            if closed_nbrs[w] == W
                U = setdiff(W, V)
                V = V ∪ w
                eliminated_weight += weights[w]
                push!(result, (U, setdiff(U, w)))
                delete!(set(mindegree), w)
            end
        end

        R = setdiff(R, V)

        for w in setdiff(W, V)
            degree = wt(weights, closed_nbrs[w])
            delete!(set(degree), w)
            closed_nbrs[w] = setdiff(closed_nbrs[w] ∪ W, V)

            degree = wt(weights, closed_nbrs[w])
            pushfirst!(set(degree), w)
            mindegree = min(mindegree, degree)
        end

        while isempty(set(mindegree))
            mindegree += 1
        end
    end

    return (result, R)
end

"""
    LDLTFact{T, I} <: Factorization{T}

An LDLt factorization object.
"""
struct LDLTFact{T, I} <: Factorization{T}
    symbfact::SymbFact{I}
    blkptr::FVector{I}
    blkval::FVector{T}
    diaval::FVector{T}
    status::FScalar{Bool}
    mapping::BipartiteGraph{I, I, FVector{I}, FVector{I}}
end

"""
    SymbFact(ldltfact::LDLTFact)

Get the underlying symbolic factorization of an LDLT
factorization.
"""
function SymbFact(ldltfact::LDLTFact)
    return ldltfact.symbfact
end

"""
    ldlt(matrix::AbstractMatrix;
        alg::EliminationAlgorithm=DEFAULT_ELIMINATION_ALGORITHM,
        snd::SupernodeType=DEFAULT_SUPERNODE_TYPE,
    )

Compute the LDLt factorization of a sparse quasi definite matrix.
The factorization occurs in two phases: symbolic and numeric. During the
symbolic phase, a *tree decomposition* is constructed which will control
the numeric phase. The speed of the numeric phase is dependant on the
quality of this tree decomposition.

The symbolic phase is controlled by the parameters `alg` and `snd`.
See the function [`cliquetree`](@ref) for more information.

```julia-repl
julia> import CliqueTrees

julia> matrix = [
           3 1 0 0 0 0 0 0
           1 3 1 0 0 2 0 0
           0 1 3 1 0 1 2 1
           0 0 1 3 0 0 0 0
           0 0 0 0 3 1 1 0
           0 2 1 0 1 3 0 0
           0 0 2 0 1 0 3 1
           0 0 1 0 0 0 1 3
       ];

julia> ldltfact = CliqueTrees.ldlt(matrix)
LDLTFact{Float64, Int64}:
    nnz: 19
    success: true
```

### Parameters

  - `matrix`: sparse quasi-definite matrix
  - `alg`: elimination algorithm
  - `snd`: supernode type

"""
function ldlt(matrix::AbstractMatrix; alg::PermutationOrAlgorithm=DEFAULT_ELIMINATION_ALGORITHM, snd::SupernodeType=DEFAULT_SUPERNODE_TYPE)
    ldltfact = ldlt(matrix, alg, snd)
    return ldltfact
end

function ldlt(matrix::AbstractMatrix, alg::PermutationOrAlgorithm, snd::SupernodeType)
    ldltfact = ldlt(matrix, symbolic(matrix, alg, snd))
    return ldltfact
end

function ldlt(matrix::AbstractMatrix, symbfact::SymbFact)
    ldltfact = ldlt(sparse(matrix), symbfact)
    return ldltfact
end

function ldlt(matrix::SparseMatrixCSC{<:Any, I}, symbfact::SymbFact{I}) where {I}
    @assert size(matrix, 1) == size(matrix, 2)
    @assert size(matrix, 1) == nov(separators(symbfact.tree))
    return ldlt!(ldltinit(matrix, symbfact)..., matrix) 
end

"""
    ldlt!(ldltfact::LDLTFact, ldltwork::LDLTWork, matrix::AbstractMatrix)

Compute the LDLT factorization of a sparse quasi definite matrix
using a pre-allocated workspace. See [`ldlt`](@ref).

```julia-repl
julia> import CliqueTrees

julia> matrix = [
           3 1 0 0 0 0 0 0
           1 3 1 0 0 2 0 0
           0 1 3 1 0 1 2 1
           0 0 1 3 0 0 0 0
           0 0 0 0 3 1 1 0
           0 2 1 0 1 3 0 0
           0 0 2 0 1 0 3 1
           0 0 1 0 0 0 1 3
       ];

julia> symbfact = CliqueTrees.symbolic(matrix)
SymbFact{Int64}:
    nnz: 19

julia> ldltfact, ldltwork = CliqueTrees.ldltinit(matrix, symbfact);

julia> CliqueTrees.ldlt!(ldltfact, ldltwork, matrix, symbfact)
LDLTFact{Float64, Int64}:
    nnz: 19
    success: true
```

### Parameters

  - `ldltfact`: LDLT factor
  - `ldltwork`: workspace
  - `matrix`: sparse quasi-definite matrix
"""
function ldlt!(ldltfact::LDLTFact{T, I}, ldltwork::LDLTWork{T, I}, matrix::AbstractMatrix) where {T, I}
    return ldlt!(ldltfact, ldltwork, sparse(matrix))
end

function ldlt!(ldltfact::LDLTFact{T, I}, ldltwork::LDLTWork{T, I}, matrix::SparseMatrixCSC{<:Any, I}) where {T, I}
    symbfact = ldltfact.symbfact

    tree = symbfact.tree
    invp = symbfact.invp

    mapping = ldltfact.mapping

    blkptr = ldltfact.blkptr
    blkval = ldltfact.blkval
    diaval = ldltfact.diaval

    updptr = ldltwork.updptr
    updval = ldltwork.updval
    frtval = ldltwork.frtval
    wrkval = ldltwork.wrkval

    pattern0 = BipartiteGraph(matrix)
    pattern1 = ldltwork.pattern1
    pattern2 = ldltwork.pattern2

    nzval0 = matrix.nzval
    nzval1 = ldltwork.nzval1
    nzval2 = ldltwork.nzval2

    cholesky_permute!(pattern0, pattern1, nzval0, nzval1, invp)
    cholesky_reverse!(pattern1, pattern2, nzval1, nzval2)

    ldltfact.status[] = ldlt_impl!(mapping, blkptr, updptr, blkval, diaval, updval, frtval, wrkval, tree, pattern2, nzval2) 

    return ldltfact
end

function ldlt_impl!(
        mapping::BipartiteGraph{I, I},        
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        diaval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        wrkval::AbstractVector{T},
        tree::CliqueTree{I, I},
        pattern::BipartiteGraph{I, I},
        nzval::AbstractVector,
    ) where {T, I}
    separator = separators(tree)
    relidx = targets(mapping)
    status = true; ns = zero(I)

    cholesky_init!(relidx, blkptr, updptr,
        blkval, tree, pattern, nzval)

    @inbounds for j in vertices(separator)
        iterstatus, ns = ldlt_loop!(mapping, blkptr, updptr,
            blkval, diaval, updval, frtval, wrkval, tree, ns, j)

        status = status && iterstatus
    end

    return status
end

function ldlt_loop!(
        mapping::BipartiteGraph{I, I},        
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        diaval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        wrkval::AbstractVector{T},
        tree::CliqueTree{I, I},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    if isone(nn)
        status, ns = ldlt_loop_nod!(mapping, blkptr, updptr,
            blkval, diaval, updval, frtval, wrkval, tree, ns, j)
    else
        status, ns = ldlt_loop_snd!(mapping, blkptr, updptr,
            blkval, diaval, updval, frtval, wrkval, tree, ns, j)
    end

    return status, ns
end


function ldlt_loop_snd!(
        mapping::BipartiteGraph{I, I},        
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        diaval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        wrkval::AbstractVector{T},
        tree::CliqueTree{I, I},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = neighbors(residual, j)

    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁  F₂  ] nj
    #
    #       = [ F₁₁ F₁₂ ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    # only the lower triangular part is used
    @inbounds F = reshape(view(frtval, oneto(nj * nj)), nj, nj)
    @inbounds F₁ =  view(F, oneto(nj),      oneto(nn))
    @inbounds F₁₁ = view(F, oneto(nn),      oneto(nn))
    @inbounds F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    @inbounds F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    # W has the same dimensions as F.
    #
    #           nn  na
    #     W = [ W₁₁ W₁₂ ] nn
    #         [ W₂₁ W₂₂ ] na
    #
    @inbounds W = reshape(view(wrkval, oneto(nj * nj)), nj, nj)
    @inbounds W₁₁ = view(W, oneto(nn),      oneto(nn))
    @inbounds W₂₁ = view(W, nn + one(I):nj, oneto(nn))

    # B is part of the lower triangular factor
    #
    #          res(j)
    #     B = [ B₁₁  ] res(j)
    #         [ B₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds B = reshape(view(blkval, pstrt:pstop - one(I)), nj, nn)

    # D₁₁ is part of the diagonal factor
    #
    #          res(j)
    #         [ D₁₁ ] res(j)
    #
    @inbounds D₁₁ = view(diaval, res) 

    # copy B into F₁
    #
    #     F₁₁ ← B₁₁
    #     F₂₁ ← B₂₁
    #
    lacpy!(F, B); fill!(F₂₂, zero(T))

    @inbounds for i in Iterators.reverse(childindices(tree, j))
        cholesky_add_update!(F, ns, i, mapping, updptr, updval)
        ns -= one(I)
    end

    # factorize F₁₁ as
    #
    #     F₁₁ = L₁₁ D₁₁ L₁₁ᴴ
    #
    # and store F₁₁ ← L₁₁
    status = qdtrf!(W₁₁, F₁₁, D₁₁)

    if ispositive(na)
        ns += one(I)

        # U₂₂ is the update matrix for node j
        @inbounds pstrt = updptr[ns]
        @inbounds pstop = updptr[ns + one(I)] = pstrt + na * na
        @inbounds U₂₂ = reshape(view(updval, pstrt:pstop - one(I)), na, na)
        lacpy!(U₂₂, F₂₂)

        # solve for L₂₁ in
        #
        #     L₂₁ D₁₁ L₁₁ᴴ = F₂₁
        #
        # and store F₂₁ ← L₂₁
        rdiv!(F₂₁, UnitLowerTriangular(F₁₁) |> adjoint)
        copyto!(W₂₁, F₂₁)
        rdiv!(F₂₁, Diagonal(D₁₁))

        # compute the difference
        #
        #    L₂₂ = U₂₂ - L₂₁ D₁₁ L₂₁ᴴ
        #
        # and store U₂₂ ← L₂₂
        trrk!(W₂₁, F₂₁, U₂₂)
    end
 
    # copy F₁ into B
    #
    #     B₁₁ ← F₁₁
    #     B₂₁ ← F₂₁
    #
    lacpy!(B, F₁)
    return status, ns
end

function ldlt_loop_nod!(
        mapping::BipartiteGraph{I, I},        
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        diaval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        wrkval::AbstractVector{T},
        tree::CliqueTree{I, I},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    nn = one(I)

    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = only(neighbors(residual, j))

    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁  F₂  ] nj
    #
    #       = [ F₁₁ F₁₂ ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    # only the lower triangular part is used
    @inbounds F = reshape(view(frtval, oneto(nj * nj)), nj, nj)
    @inbounds F₁ =  view(F, oneto(nj),      nn)
    @inbounds F₁₁ = view(F, nn,             nn)
    @inbounds F₂₁ = view(F, nn + one(I):nj, nn)
    @inbounds F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    # W has the same dimensions as F.
    #
    #           nn  na
    #     W = [ W₁₁ W₁₂ ] nn
    #         [ W₂₁ W₂₂ ] na
    #
    @inbounds W = reshape(view(wrkval, oneto(nj * nj)), nj, nj)
    @inbounds W₁₁ = view(W, nn,             nn)
    @inbounds W₂₁ = view(W, nn + one(I):nj, nn)

    # B is part of the Cholesky factor
    #
    #          res(j)
    #     B = [ B₁₁  ] res(j)
    #         [ B₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds B = view(blkval, pstrt:pstop - one(I))
    @inbounds B₁ = view(B, nn)
    @inbounds B₂ = view(B, nn + one(I):nj)

    # D₁₁ is part of the diagonal factor
    #
    #          res(j)
    #         [ D₁₁ ] res(j)
    #
    @inbounds D₁₁ = view(diaval, res)

    # copy B into F₁
    #
    #     F₁₁ ← B₁₁
    #     F₂₁ ← B₂₁
    #
    F₁₁[] = B₁[]; copyto!(F₂₁, B₂); fill!(F₂₂, zero(T))

    @inbounds for i in Iterators.reverse(childindices(tree, j))
        cholesky_add_update!(F, ns, i, mapping, updptr, updval)
        ns -= one(I)
    end

    # factorize F₁₁ as
    #
    #     F₁₁ = L₁₁ D₁₁ L₁₁ᴴ
    #
    # and store F₁₁ ← L₁₁
    d₁₁ = D₁₁[] = F₁₁[]

    if !iszero(d₁₁)
                      status = true
    else
        d₁₁ = one(T); status = false
    end

    if ispositive(na)
        ns += one(I)

        # U₂₂ is the update matrix for node j
        @inbounds pstrt = updptr[ns]
        @inbounds pstop = updptr[ns + one(I)] = pstrt + na * na
        @inbounds U₂₂ = reshape(view(updval, pstrt:pstop - one(I)), na, na)
        lacpy!(U₂₂, F₂₂)

        # compute the difference
        #
        #    L₂₂ = U₂₂ - F₂₁ D₁₁⁻¹ F₂₁ᴴ
        #
        # and store U₂₂ ← L₂₂
        syr!(d₁₁, F₂₁, U₂₂)

        # solve for L₂₁ in
        #
        #     L₂₁ D₁₁ L₁₁ᴴ = F₂₁
        #
        # and store F₂₁ ← L₂₁
        F₂₁ ./= d₁₁
    end

    # copy F₁ into B
    #
    #     B₁₁ ← F₁₁
    #     B₂₁ ← F₂₁
    #
    copyto!(B₂, F₂₁)
    return status, ns
end

function rdiv!_ldlt_loop_fwd!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractArray{T},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    if isone(nn)
        ns = rdiv!_ldlt_loop_fwd_nod!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, B, ns, j)
    else
        ns = rdiv!_ldlt_loop_fwd_snd!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, B, ns, j)
    end

    return ns
end

function rdiv!_ldlt_loop_fwd_snd!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractVector{T},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = neighbors(residual, j)
    
    # L is part of the lower triangular factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = reshape(view(blkval, pstrt:pstop - one(I)), nj, :)
    @inbounds L₁₁ = view(L, oneto(nn),      :)
    @inbounds L₂₁ = view(L, nn + one(I):nj, :)

    # F is part of B
    #
    #     F = [ F₁ ] res(j)
    #         [ F₂ ] sep(j)
    #
    @inbounds F = view(frtval, oneto(nj))
    @inbounds F₁ = view(F, oneto(nn))
    @inbounds F₂ = view(F, nn + one(I):nj)

    @inbounds F₁ .= view(B, res)
    F₂ .= zero(T)

    @inbounds for i in Iterators.reverse(childindices(tree, j))
        rdiv!_fwd_add_update!(F, ns, i, mapping, updptr, updval)
        ns -= one(I)
    end

    # solve for Y₁ in
    #
    #     L₁₁ Y₁ = F₁
    #
    # and store F₁ ← Y₁
    ldiv!(UnitLowerTriangular(L₁₁), F₁)
 
    if ispositive(na)
        # U₂ is the update matrix for node j
        ns += one(I)
        @inbounds pstrt = updptr[ns]
        @inbounds pstop = updptr[ns + one(I)] = pstrt + na
        @inbounds U₂ = view(updval, pstrt:pstop - one(I))
        U₂ .= F₂

        # compute the difference
        #
        #     Y₂ = U₂ - L₂₁ F₁
        #
        # and store U₂ ← Y₂ 
        mul!(U₂, L₂₁, F₁, -one(T), one(T))
    end
   
    # copy B ← F₁
    @inbounds B[res] .= F₁
    return ns
end

function rdiv!_ldlt_loop_fwd_snd!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractMatrix{T},
        ns::I,
        j::I,
    ) where {T, I}
    nrhs = convert(I, size(B, 1))

    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = neighbors(residual, j)
    
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = reshape(view(blkval, pstrt:pstop - one(I)), nj, :)
    @inbounds L₁₁ = view(L, oneto(nn),      :)
    @inbounds L₂₁ = view(L, nn + one(I):nj, :)

    # F is part of B
    #
    #         res(j) sep(j)
    #     F = [ F₁    F₂ ]
    #
    @inbounds F = reshape(view(frtval, oneto(nj * nrhs)), :, nj)
    @inbounds F₁ = view(F, :, oneto(nn))
    @inbounds F₂ = view(F, :, nn + one(I):nj)

    @inbounds F₁ .= view(B, :, res)
    F₂ .= zero(T)

    @inbounds for i in Iterators.reverse(childindices(tree, j))
        rdiv!_fwd_add_update!(F, ns, i, mapping, updptr, updval)
        ns -= one(I)
    end

    # solve for Y₁ in
    #
    #     Y₁ L₁₁ᴴ = F₁
    #
    # and store F₁ ← Y₁
    rdiv!(F₁, UnitLowerTriangular(L₁₁) |> adjoint)
 
    if ispositive(na)
        # U₂ is the update matrix for node j
        ns += one(I)
        @inbounds pstrt = updptr[ns]
        @inbounds pstop = updptr[ns + one(I)] = pstrt + na * nrhs
        @inbounds U₂ = reshape(view(updval, pstrt:pstop - one(I)), nrhs, na)
        U₂ .= F₂

        # compute the difference
        #
        #     Y₂ = U₂ - Y₁ L₂₁ᴴ
        #
        # and store U₂ ← Y₂ 
        mul!(U₂, F₁, L₂₁ |> adjoint, -one(T), one(T))
    end
   
    # copy B ← F₁
    @inbounds B[:, res] .= F₁
    return ns
end

function rdiv!_ldlt_loop_fwd_nod!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractVector{T},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = one(I)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = only(neighbors(residual, j))
    
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = view(blkval, pstrt:pstop - one(I))
    @inbounds L₁₁ = view(L, nn)
    @inbounds L₂₁ = view(L, nn + one(I):nj)

    # F is part of B
    #
    #     F = [ F₁ ] res(j)
    #         [ F₂ ] sep(j)
    #
    @inbounds F = view(frtval, oneto(nj))
    @inbounds F₁ = view(F, nn)
    @inbounds F₂ = view(F, nn + one(I):nj)

    @inbounds F₁[] = B[res]
    F₂ .= zero(T)

    @inbounds for i in Iterators.reverse(childindices(tree, j))
        rdiv!_fwd_add_update!(F, ns, i, mapping, updptr, updval)
        ns -= one(I)
    end

    # solve for Y₁ in
    #
    #     L₁₁ Y₁ = F₁
    #
    # and store F₁ ← Y₁
    f₁ = F₁[]
 
    if ispositive(na)
        # U₂ is the update matrix for node j
        ns += one(I)
        @inbounds pstrt = updptr[ns]
        @inbounds pstop = updptr[ns + one(I)] = pstrt + na
        @inbounds U₂ = view(updval, pstrt:pstop - one(I))
        U₂ .= F₂

        # compute the difference
        #
        #     Y₂ = U₂ - L₂₁ F₁
        #
        # and store U₂ ← Y₂
        mul!(U₂, L₂₁, f₁, -one(T), one(T))
    end
   
    # copy B ← F₁
    @inbounds B[res] = f₁

    return ns
end

function rdiv!_ldlt_loop_fwd_nod!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractMatrix{T},
        ns::I,
        j::I,
    ) where {T, I}
    nrhs = convert(I, size(B, 1))

    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = one(I)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = only(neighbors(residual, j))
    
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = view(blkval, pstrt:pstop - one(I))
    @inbounds L₁₁ = view(L, nn)
    @inbounds L₂₁ = view(L, nn + one(I):nj)

    # F is part of B
    #
    #         res(j) sep(j)
    #     F = [ F₁    F₂ ]
    #
    @inbounds F = reshape(view(frtval, oneto(nj * nrhs)), :, nj)
    @inbounds F₁ = view(F, :, nn)
    @inbounds F₂ = view(F, :, nn + one(I):nj)

    @inbounds F₁ .= view(B, :, res)

    F₂ .= zero(T)

    @inbounds for i in Iterators.reverse(childindices(tree, j))
        rdiv!_fwd_add_update!(F, ns, i, mapping, updptr, updval)
        ns -= one(I)
    end

    # solve for Y₁ in
    #
    #     Y₁ L₁₁ᴴ = F₁
    #
    # and store F₁ ← Y₁
    F₁
 
    if ispositive(na)
        # U₂ is the update matrix for node j
        ns += one(I)
        @inbounds pstrt = updptr[ns]
        @inbounds pstop = updptr[ns + one(I)] = pstrt + na * nrhs
        @inbounds U₂ = reshape(view(updval, pstrt:pstop - one(I)), :, na)
        U₂ .= F₂

        # compute the difference
        #
        #     Y₂ = U₂ - Y₁ L₂₁ᴴ
        #
        # and store U₂ ← Y₂ 
        mul!(U₂, F₁, L₂₁ |> adjoint, -one(T), one(T))
    end
   
    # copy B ← F₁
    @inbounds B[:, res] .= F₁
    return ns
end

function rdiv!_ldlt_loop_bwd!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractArray{T},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    if isone(nn)
        ns = rdiv!_ldlt_loop_bwd_nod!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, B, ns, j)
    else
        ns = rdiv!_ldlt_loop_bwd_snd!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, B, ns, j)
    end

    return ns
end

function rdiv!_ldlt_loop_bwd_snd!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractVector{T},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = neighbors(residual, j)
 
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = reshape(view(blkval, pstrt:pstop - one(I)), nj, :)
    @inbounds L₁₁ = view(L, oneto(nn),      :)
    @inbounds L₂₁ = view(L, nn + one(I):nj, :)

    # F is part of B
    #
    #     F = [ F₁ ] res(j)
    #         [ F₂ ] sep(j)
    #
    @inbounds F = view(frtval, oneto(nj))
    @inbounds F₁ = view(F, oneto(nn))
    @inbounds F₂ = view(F, nn + one(I):nj)

    @inbounds F₁ .= view(B, res)
    
    if ispositive(na)
        # U₂ is the update matrix for node j
        @inbounds pstrt = updptr[ns]
        pstop = pstrt + na
        @inbounds U₂ = view(updval, pstrt:pstop - one(I))
        ns -= one(I)

        # compute the difference
        #
        #     Y₁ = F₁ - L₂₁ᴴ U₂
        #
        # and store F₁ ← Y₁ 
        mul!(F₁, L₂₁ |> adjoint, U₂, -one(T), one(T))

        # copy F₂ ← U₂
        F₂ .= U₂
    end

    # solve for Z₁ in
    #
    #     L₁₁ᴴ Z₁ = Y₁
    #
    # and store F₁ ← Z₁
    ldiv!(UnitLowerTriangular(L₁₁) |> adjoint, F₁)

    @inbounds for i in childindices(tree, j)
        ns += one(I)
        rdiv!_bwd_add_update!(F, ns, i, mapping, updptr, updval)
    end

    # copy B ← F₁
    @inbounds B[res] .= F₁
    return ns
end

function rdiv!_ldlt_loop_bwd_snd!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractMatrix{T},
        ns::I,
        j::I,
    ) where {T, I}
    nrhs = convert(I, size(B, 1))

    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = neighbors(residual, j)
 
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = reshape(view(blkval, pstrt:pstop - one(I)), nj, :)
    @inbounds L₁₁ = view(L, oneto(nn),      :)
    @inbounds L₂₁ = view(L, nn + one(I):nj, :)

    # F is part of B
    #
    #         res(j) sep(j)
    #     F = [ F₁    F₂ ]
    #
    @inbounds F = reshape(view(frtval, oneto(nj * nrhs)), :, nj)
    @inbounds F₁ = view(F, :, oneto(nn))
    @inbounds F₂ = view(F, :, nn + one(I):nj)

    @inbounds F₁ .= view(B, :, res)

    if ispositive(na)
        # U₂ is the update matrix for node j
        @inbounds pstrt = updptr[ns]
        pstop = pstrt + na * nrhs
        @inbounds U₂ = reshape(view(updval, pstrt:pstop - one(I)), :, na)
        ns -= one(I)

        # compute the difference
        #
        #     Y₁ = F₁ - U₂ L₂₁
        #
        # and store F₁ ← Y₁ 
        mul!(F₁, U₂, L₂₁, -one(T), one(T))

        # copy F₂ ← U₂
        F₂ .= U₂
    end

    # solve for Z₁ in
    #
    #     Z₁ L₁₁ = Y₁
    #
    # and store F₁ ← Z₁
    rdiv!(F₁, UnitLowerTriangular(L₁₁))

    @inbounds for i in childindices(tree, j)
        ns += one(I)
        rdiv!_bwd_add_update!(F, ns, i, mapping, updptr, updval)
    end

    # copy B ← F₁
    @inbounds B[:, res] .= F₁
    return ns
end

function rdiv!_ldlt_loop_bwd_nod!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractVector{T},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = one(I)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = only(neighbors(residual, j))
 
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = view(blkval, pstrt:pstop - one(I))
    @inbounds L₁₁ = view(L, nn)
    @inbounds L₂₁ = view(L, nn + one(I):nj)

    # F is part of B
    #
    #     F = [ F₁ ] res(j)
    #         [ F₂ ] sep(j)
    #
    @inbounds F = view(frtval, oneto(nj))
    @inbounds F₁ = view(F, nn)
    @inbounds F₂ = view(F, nn + one(I):nj)

    @inbounds f₁ = F₁[] = B[res]
    
    if ispositive(na)
        # U₂ is the update matrix for node j
        @inbounds pstrt = updptr[ns]
        pstop = pstrt + na
        @inbounds U₂ = view(updval, pstrt:pstop - one(I))
        ns -= one(I)

        # compute the difference
        #
        #     Y₁ = F₁ - L₂₁ᴴ U₂
        #
        # and store F₁ ← Y₁ 
        f₁ -= dot(L₂₁, U₂)

        # copy F₂ ← U₂
        F₂ .= U₂
    end

    # solve for Z₁ in
    #
    #     L₁₁ᴴ Z₁ = Y₁
    #
    # and store F₁ ← Z₁
    F₁[] = f₁

    @inbounds for i in childindices(tree, j)
        ns += one(I)
        rdiv!_bwd_add_update!(F, ns, i, mapping, updptr, updval)
    end

    # copy B ← F₁
    @inbounds B[res] = F₁[]
    return ns
end

function rdiv!_ldlt_loop_bwd_nod!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractMatrix{T},
        ns::I,
        j::I,
    ) where {T, I}
    nrhs = convert(I, size(B, 1))

    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = one(I)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = only(neighbors(residual, j))
 
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = view(blkval, pstrt:pstop - one(I))
    @inbounds L₁₁ = view(L, nn)
    @inbounds L₂₁ = view(L, nn + one(I):nj)

    # F is part of B
    #
    #         res(j) sep(j)
    #     F = [ F₁    F₂ ]
    #
    @inbounds F = reshape(view(frtval, oneto(nj * nrhs)), :, nj)
    @inbounds F₁ = view(F, :, nn)
    @inbounds F₂ = view(F, :, nn + one(I):nj)

    F₁ .= view(B, :, res)
    
    if ispositive(na)
        # U₂ is the update matrix for node j
        @inbounds pstrt = updptr[ns]
        pstop = pstrt + na * nrhs
        @inbounds U₂ = reshape(view(updval, pstrt:pstop - one(I)), :, na)
        ns -= one(I)

        # compute the difference
        #
        #     Y₁ = F₁ - U₂ L₂₁
        #
        # and store F₁ ← Y₁
        mul!(F₁, U₂, L₂₁, -one(T), one(T))
 
        # copy F₂ ← U₂
        F₂ .= U₂
    end

    # solve for Z₁ in
    #
    #     Z₁ L₁₁ = Y₁
    #
    # and store F₁ ← Z₁
    F₁

    @inbounds for i in childindices(tree, j)
        ns += one(I)
        rdiv!_bwd_add_update!(F, ns, i, mapping, updptr, updval)
    end

    # copy B ← F₁
    @inbounds B[:, res] .= F₁
    return ns
end

function Base.size(ldltfact::LDLTFact)
    tree = ldltfact.symbfact.tree
    separator = separators(tree)
    neqns = convert(Int, nov(separator))
    return (neqns, neqns)
end

function SparseArrays.nnz(ldltfact::LDLTFact)
    return nnz(ldltfact.symbfact)
end

function Base.show(io::IO, ::MIME"text/plain", ldltfact::LDLTFact{T, I}) where {T, I}
    println(io, "LDLTFact{$T, $I}:")
    println(io, "    nnz: $(nnz(ldltfact))")
    print(io,   "    success: $(issuccess(ldltfact))")
end

###########################
# Factorization Interface #
###########################

function LinearAlgebra.ldiv!(ldltfact::LDLTFact, B::AbstractArray)
    return linsolve!(B, ldltfact, Val(false))
end

function LinearAlgebra.rdiv!(B::AbstractArray, ldltfact::LDLTFact)
    return linsolve!(B, ldltfact, Val(true))
end

function LinearAlgebra.issuccess(ldltfact::LDLTFact)
    return ldltfact.status[]
end

function LinearAlgebra.isposdef(ldltfact::LDLTFact)
    tree = ldltfact.symbfact.tree
    diaval = ldltfact.diaval
    separator = separators(tree)

    if !issuccess(ldltfact)
        return false
    end

    for j in outvertices(separator)
        if !ispositive(diaval[j])
            return false
        end
    end

    return true
end

function LinearAlgebra.det(ldltfact::LDLTFact{T, I}) where {T, I}
    tree = ldltfact.symbfact.tree
    diaval = ldltfact.diaval
    separator = separators(tree)

    det = one(real(T))

    for j in outvertices(separator)
        det *= real(diaval[j])
    end

    return det
end

function LinearAlgebra.logdet(ldltfact::LDLTFact{T, I}) where {T, I}
    tree = ldltfact.symbfact.tree
    diaval = ldltfact.diaval
    separator = separators(tree)

    logdet = zero(real(T))

    for j in outvertices(separator)
        logdet += log(real(diaval[j]))
    end

    return logdet
end

##################################
# Dense Numerical Linear Algebra #
##################################

# factorize A as
#
#     A = L D Lᴴ
#
# and store A ← L
function qdtrf2!(A::AbstractMatrix{T}, D::AbstractVector{T}) where {T}
    n = size(A, 1)
    
    @inbounds @fastmath for j in axes(A, 1)
        Ajj = real(A[j, j])

        for k in 1:j - 1
            Ajj -= abs2(A[j, k]) * D[k]
        end

        if iszero(Ajj)
            return false
        end

        Djj = D[j] = Ajj; iDjj = inv(Djj)

        for i in j + 1:n
            for k in 1:j - 1
                A[i, j] -= A[i, k] * D[k] * conj(A[j, k])
            end

            A[i, j] *= iDjj
        end
    end
    
    return true
end

# factorize A as
#
#     A = L D Lᴴ
#
# and store A ← L
function qdtrf!(W::AbstractMatrix{T}, A::AbstractMatrix{T}, D::AbstractVector{T}; blocksize::Int = 64) where {T}
    n = size(A, 1)
    
    for bstrt in 1:blocksize:n
        bsize = min(blocksize, n - bstrt + 1)
        bstop = bstrt + bsize - 1

        A11 = view(A, bstrt:bstop, bstrt:bstop)
        D11 = view(D, bstrt:bstop)
        status = qdtrf2!(A11, D11)
        
        if !status
            return false
        end
        
        if bstop < n
            A21 = view(A, bstop + 1:n, bstrt:bstop)
            W21 = view(W, bstop + 1:n, 1:bsize)
            A22 = view(A, bstop + 1:n, bstop + 1:n)
            
            rdiv!(A21, UnitLowerTriangular(A11) |> adjoint)
            copyto!(W21, A21)
            rdiv!(A21, Diagonal(D11))
            trrk!(W21, A21, A22)
        end
    end
    
    return true
end

# compute the lower triangular part of the difference
#
#     C = L - A * Bᴴ
#
# and store L ← C
function trrk!(A::AbstractMatrix{T}, B::AbstractMatrix{T}, L::AbstractMatrix{T}) where {T <: BLAS.BlasReal}
    BLAS.syr2k!('L', 'N', convert(T, -1/2), A, B, one(T), L)
    return
end

function trrk!(A::AbstractMatrix{T}, B::AbstractMatrix{T}, L::AbstractMatrix{T}) where {T <: BLAS.BlasComplex}
    BLAS.her2k!('L', 'N', convert(T, -1/2), A, B, one(real(T)), L)
    return
end

# compute the lower triangular part of the difference
#
#     C = L - a * aᴴ / alpha
#
# and store L ← C
function syr!(alpha::T, a::AbstractVector{T}, L::AbstractMatrix{T}) where {T <: BLAS.BlasReal}
    BLAS.syr!('L', -inv(alpha), a, L)
    return
end

function syr!(alpha::T, a::AbstractVector{T}, L::AbstractMatrix{T}) where {T <: BLAS.BlasComplex}
    BLAS.her!('L', -inv(real(alpha)), a, L)
    return
end

# This file is part of the Scotch distribution.
# It does not include the standard Scotch header because it is an
# adaptation of the MUMPS_HAMF4 routine which was released under
# the BSD3 license.
# Consequently, this file is distributed according to the terms of
# the BSD3 licence, see copyright notice below.
#
# Copyright 2004,2007,2010,2012,2018-2020,2023,2024 IPB, Universite de Bordeaux, INRIA & CNRS & others
#
#============================================================#
#
#     NAME       : hall_order_hf.c
#
#     AUTHOR     : Patrick AMESTOY & al.
#                  Francois PELLEGRINI
#
#     FUNCTION   : This module orders a halo graph or mesh
#                  structure using the block-oriented Halo
#                  Approximate (Multiple) Minimum Fill
#                  algorithm, with super-variable
#                  accounting HAMF4 (v20190828).
#
#     DATES      : # Version 3.4  : from : 15 may 2001
#                                   to   : 23 nov 2001
#                  # Version 4.0  : from : 10 jan 2003
#                                   to   : 29 aug 2007
#                  # Version 5.1  : from : 08 dec 2010
#                                   to   : 08 dec 2010
#                  # Version 6.0  : from : 08 mar 2012
#                                   to   : 30 apr 2018
#                  # Version 6.1  : from : 29 oct 2019
#                                   to   : 10 feb 2020
#                  # Version 7.0  : from : 19 jan 2023
#                                   to   : 06 aug 2024
#
#     NOTES      : # This module contains pieces of code
#                    that belong to other people; see
#                    below.
#
#============================================================#

module AMFLib

using Base: oneto
using FillArrays
using ..Utilities

export amf

const FLOAT = Float64

function anint(::Type{I}, x::F) where {I, F}
    return floor(I, x + convert(F, 0.5))
end

function amf(n::V, xadj::AbstractVector{E}, adjncy::AbstractVector{V}) where {V, E}
    vwght = Ones{V}(n)
    return amf(n, vwght, xadj, adjncy)
end

function amf(n::V, vwght::AbstractVector, xadj::AbstractVector{E}, adjncy::AbstractVector{V}) where {V, E}
    @assert n <= length(vwght)
    @inbounds nn = n + one(V); mm = xadj[nn]; m = mm - one(E)

    norig = zero(V)
    iwlen = m + convert(E, 4n + 10000)

    @inbounds for i in oneto(n)
        norig += trunc(V, vwght[i])
    end

    nbbuck = twice(norig)

    len = FVector{V}(undef, n)
    pe = FVector{E}(undef, nn)
    iw = FVector{V}(undef, iwlen)
    nv = FVector{V}(undef, n)
    elen = FVector{V}(undef, n)
    last = FVector{V}(undef, n)
    degree = FVector{V}(undef, n)
    wf = FVector{E}(undef, n)
    next = FVector{V}(undef, n)
    w = FVector{Int}(undef, n)
    head = FVector{V}(undef, nbbuck + two(V))

    perm, invp = amf_impl!(norig, n, nbbuck, iwlen, pe,
        len, iw, nv, elen, last, degree, wf, next, w, head,
        vwght, xadj, adjncy)

    return convert(Vector{V}, perm), convert(Vector{V}, invp)
end

function amf_impl!(
        norig::V,
        n::V,
        nbbuck::V,
        iwlen::E,
        pe::AbstractVector{E},
        len::AbstractVector{V},
        iw::AbstractVector{V},
        nv::AbstractVector{V},
        elen::AbstractVector{V},
        last::AbstractVector{V},
        degree::AbstractVector{V},
        wf::AbstractVector{E},
        next::AbstractVector{V},
        w::AbstractVector,
        head::AbstractVector{V},
        vwght::AbstractVector,
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
    ) where {V, E}
    @inbounds nn = n + one(V); mm = xadj[nn]; m = mm - one(E)

    nbelts = zero(V)
    pfree = mm

    @inbounds for p in oneto(m)
        iw[p] = adjncy[p]
    end

    @inbounds p = pe[begin] = xadj[begin]

    @inbounds for i in oneto(n)
        pp = pe[i + one(E)] = xadj[i + one(E)]
        nv[i] = trunc(V, vwght[i])
        len[i] = convert(V, pp - p)
        p = pp
    end

    ncmpa = hamf_impl!(norig, n, nbelts, nbbuck, iwlen, pe,
        pfree, len, iw, nv, elen, last, degree, wf, next, w, head)

    @inbounds for j in oneto(norig)
        head[j] = zero(V)
    end

    @inbounds for i in oneto(n)
        j = abs(elen[i])
        head[j] = i
    end

    k = zero(V)

    @inbounds for j in oneto(norig)
        i = head[j]

        if ispositive(i)
            last[i] = k += one(V)
            elen[k] = i
        end
    end

    return elen, last
end

#  -- translated by f2c (version 19970219).
#  -- hand-made adaptation (as of HAMF 20191101).
#  -- hand-made adaptation (as of HAMF 20200111).

#------------------------------------------------------------------------#
#   Version generated on October 29th 2019
#
#   This file includes various modifications of an original
#   LGPL/ CeCILL-C compatible
#   code implementing the AMD (Approximate Minimum Degree) ordering
#     Patrick Amestoy, Timothy A. Davis, and Iain S. Duff,
#      "An approximate minimum degree ordering algorithm,"
#      SIAM J. Matrix Analysis  vol 17, pages=886--905 (1996)
#      MUMPS_ANA_H is based on the original AMD code:
#
#      AMD, Copyright (c), 1996-2016, Timothy A. Davis,
#      Patrick R. Amestoy, and Iain S. Duff.  All Rights Reserved.
#      Used in MUMPS under the BSD 3-clause license.
#      THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
#      CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#      INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#      MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#      DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE
#      FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
#      CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#      PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
#      OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#      THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
#      TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#      OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
#      OF SUCH DAMAGE.
#
#     MUMPS_HAMF4 is a major modification of AMD
#     since the metric used to select pivots in not anymore the
#     degree but an approximation of the fill-in.
#     In this approximation
#     all cliques of elements adjacent to the variable are deducted.
#     MUMPS_HAMF4 also enables to take into account a halo in the graph.
#     The graph is composed is partitioned in two types of nodes
#     the so called internal nodes and the so called halo nodes.
#     Halo nodes cannot be selected the both the initial degrees
#     and updated degrees of internal node should be taken
#     into account.
#     Written by Patrick Amestoy between 1999 and 2019.
#     and used by F. Pellegrini in SCOTCH since 2000.
#
#     Unique version to order both graph of variables and
#     graphs with both elements and variables.
#
#     Notations used:
#     Let us refer to as
#       Gv a graph with only variables
#       Ge a graph with both variables and elements
#
#     Let V be the set of nodes in the graph
#         V = Ve + V0 + V1
#             V0 = Set of variable nodes (not in halo)
#             V1 = Set of variable nodes (in halo)
#             Ve = Set of element nodes |Ve|=nbelts
#
#     All 3 sets are disjoint, Ve and V1 can be empty
#     If nbelts>0 then a bipartite graph bewteen
#        (V0 U V1) and Ve is provided on entry.
#
#     A graph of elements and variables is a bipartite
#     graph between the set of variables (that may
#     include halo variables) and the set of elements.
#     Thus variables are only adjacent to elements and
#     in the element list we only have variables.
#     Elements are "considered" as already eliminated and
#     are provided here only to describe the adjacency between
#     variables. Only variables in V0 need to be eliminated.
#
#     Comments relative to 64/32 bits integer representation:
#     This is [based on] a restrictive integer 64 bit variant:
#     It is assumed that IW array size can exceed 32-bit integer and
#     thus IWLEN is INTEGER(8) and PE is an INTEGER(8) array.
#     Graph size n must be smaller than 2x10^9 but number of
#     edges is a 64-bit integer.
#
#   Parameters
#      Input only, not modified on output :
#        N : number of nodes in the complete graph including halo
#            N = size of V0 U V1
#        NBBUCK : should be greater than norig
#                 advised value is 2*norig
#        IWLEN : Should be uint64_t # Patch FP: used Gnum as well #
#      Input, undefined on output:
#        LEN(1..N)
#        IW(1..IWLEN)
#        NV(N) : also meaningful as input to encode compressed graphs
#      Output only :
#        NCMPA
#        not ELEN(N)  # Patch FP: always initialized before call #
#        LAST(N)
#      Input/output
#        ELEN(N)  # Patch PA+FP #
#        PFREE
#        PE(N) : Should be uint64_t # Patch FP: used Gnum as well #
#      Internal workspace only
#        Min fill approximation one extra array of size NBBUCK+2
#         is also needed
#        NEXT(N)
#        DEGREE(N)
#        W(N)
#        HEAD(0:NBBUCK+1)
#        WF(N)
#
#    Comments on the OUTPUT :
#    ------------------------
#    Let V= V0 U V1 the nodes of the initial graph (|V|=n).
#    The assembly tree corresponds to the tree
#      of the supernodes (or supervariables). Each node of the
#      assembly tree is then composed of one principal variable
#      and a list of secondary variables. The list of
#      variable of a node (principal + secondary variables) then
#      describes the structure of the diagonal bloc of the supernode.
#    The elimination tree denotes the tree of all the variables(=node)
#      and is therefore of order n.
#
#    The arrays NV(N) and PE(N) give a description of the assembly tree.
#
#     1/ Description of array nv(N) (on OUTPUT)
#      nv(i)=0 i is a secondary variable
#      nv(i) >0 i is a principal variable, nv(i) holds the number of
#        elements in column i of L (true degree of i)
#      nv(i) can be greater than N since degree can be as large as NORIG.
#
#     2/ Description of array PE(N) (on OUTPUT)
#         Note that on
#         pe(i) = -(father of variable/node i) in the elimination tree:
#         If nv (i) .gt. 0, then i represents a node in the assembly
#         tree, and the parent of i is -pe (i), or zero if i is a root.
#         If nv (i) = 0, then (i,-pe (i)) represents an edge in a
#         subtree, the root of which is a node in the assembly tree.
#
#     3/ Example:
#        Let If be a root node father of Is in the assembly tree.
#        If is the principal variable of the node If and let If1, If2,
#        If3 be the secondary variables of node If.
#        Is is the principal variable of the node Is and let Is1, Is2 be
#        the secondary variables of node Is.
#
#        THEN:
#          NV(If1) = NV(If2) = NV(If3) = 0  (secondary variables)
#          NV(Is1) = NV(Is2) = 0  (secondary variables)
#          NV(If) > 0  (principal variable)
#          NV(Is) > 0  (principal variable)
#          PE(If) = 0 (root node)
#          PE(Is) = -If (If is the father of Is in the assembly tree)
#          PE(If1)=PE(If2)=PE(If3)= -If  ( If is the principal variable)
#          PE(Is1)=PE(Is2)= -Is  ( Is is the principal variable)
#
#
#    Comments on the OUTPUT:
#    ----------------------
#    Let V= V0 U V1 the nodes of the initial graph (|V|=n).
#    The assembly tree corresponds to the tree
#      of the supernodes (or supervariables). Each node of the
#      assembly tree is then composed of one principal variable
#      and a list of secondary variables. The list of
#      variable of a node (principal + secondary variables) then
#      describes the structure of the diagonal block of the
#      supernode.
#    The elimination tree denotes the tree of all the variables(=node)
#      and is therefore of order n.
#
#    The arrays NV(N) and PE(N) give a description of the
#    assembly tree.
#
#     1/ Description of array nv(N) (on OUTPUT)
#      nv(i)=0 i is a secondary variable
#      nv(i) >0 i is a principal variable, nv(i) holds the number of
#        elements in column i of L (true degree of i)
#      with compressed graph (nv(1).ne.-1 on input), nv(i) can be
#      greater than N since degree can be as large as NORIG.
#
#     2/ Description of array PE(N) (on OUTPUT)
#         Note that on
#         pe(i) = -(father of variable/node i) in the elimination tree:
#         If nv (i) .gt. 0, then i represents a node in the assembly
#         tree, and the parent of i is -pe (i), or zero if i is a root.
#         If nv (i) = 0, then (i,-pe (i)) represents an edge in a
#         subtree, the root of which is a node in the assembly tree.
#
#     3/ Example:
#        Let If be a root node father of Is in the assembly tree.
#        If is the principal
#        variable of the node If and let If1, If2, If3 be the secondary
#        variables of node If.
#        Is is the principal
#        variable of the node Is and let Is1, Is2 be the secondary
#        variables of node Is.
#
#        THEN:
#          NV(If1)=NV(If2)=NV(If3) = 0  (secondary variables)
#          NV(Is1)=NV(Is2) = 0  (secondary variables)
#          NV(If) > 0  ( principal variable)
#          NV(Is) > 0  ( principal variable)
#          PE(If)  = 0 (root node)
#          PE(Is)  = -If (If is the father of Is in the assembly tree)
#          PE(If1)=PE(If2)=PE(If3)= -If  ( If is the principal variable)
#          PE(Is1)=PE(Is2)= -Is  ( Is is the principal variable)
#
#
#
#   HALOAMD_V1: (September 1997)
#   **********
#   Initial version designed to experiment the numerical (fill-in)
#   impact of taking into account the halo. This code should be able
#   to experiment no-halo, partial halo, complete halo.
#   DATE: September 17th 1997
#
#   HALOAMD is designed to process a gragh composed of two types
#              of nodes, V0 and V1, extracted from a larger gragh.
#              V0^V1 = {},
#
#              We used Min. degree heuristic to order only
#              nodes in V0, but the adjacency to nodes
#              in V1 is taken into account during ordering.
#              Nodes in V1 are odered at last.
#              Adjacency between nodes of V1 need not be provided,
#              however |len(i)| must always corresponds to the number
#              of edges effectively provided in the adjacency list of i.
#            On input :
#            ********
#              Nodes INODE in V1 are flagged with len(INODE) = -degree
#                             if len(i) =0 and i ∈ V1 then
#                             len(i) must be set on input to -NORIG-1
#            ERROR return (negative values in ncmpa)
#            ************
#              negative value in ncmpa indicates an error detected
#                 by HALOAMD.
#
#              The graph provided MUST follow the rule:
#               if (i,j) is an edge in the gragh then
#               j must be in the adjacency list of i AND
#               i must be in the adjacency list of j.
#      REMARKS
#      -------
#
#          1/  Providing edges between nodes of V1 should not
#              affect the final ordering, only the amount of edges
#              of the halo should effectively affect the solution.
#              This code should work in the following cases:
#                1/ halo not provided
#                2/ halo partially provided
#                3/ complete halo
#                4/ complete halo+interconnection between nodes of V1.
#
#                1/ should run and provide identical results (w.r.t to
#                   current implementation of AMD in SCOTCH).
#                3/ and 4/ should provide identical results.
#
#          2/ All modifications of the AMD initial code are indicated
#             with begin HALO .. end HALO
#
#
#     Given a representation of the nonzero pattern of a symmetric
#         matrix A, (excluding the diagonal) perform an approximate
#         minimum fill-in heuristic. Aggresive absorption is
#         used to tighten the bound on the degree.  This can result an
#         significant improvement in the quality of the ordering for
#         some matrices.
#  ---------------------------------------------------------------------
#   INPUT ARGUMENTS (unaltered):
#  ---------------------------------------------------------------------
#   n:    number of nodes in the complete graph including halo
#         n = size of V0 U V1 U Ve
#         Restriction:  n .ge. 1
#
#   norig   if compressed graph (nv(1).ne.-1) then
#              norig is the sum(nv(i)) for i \in [1:n]
#              and could be larger than n
#           else norig = n
#
#   nbelts number of elements (size of Ve)
#              =0 if Gv (graph of variables)
#              >0 if Ge
#           nbelts > 0 extends/changes the meaning of
#                     len/elen on entry (see below)
#
#
#   iwlen:        The length of iw (1..iwlen).  On input, the matrix is
#         stored in iw (1..pfree-1).  However, iw (1..iwlen) should be
#         slightly larger than what is required to hold the matrix, at
#         least iwlen .ge. pfree + n is recommended.  Otherwise,
#         excessive compressions will take place.
#         *** We do not recommend running this algorithm with ***
#         ***      iwlen .lt. pfree + n.                      ***
#         *** Better performance will be obtained if          ***
#         ***      iwlen .ge. pfree + n                       ***
#         *** or better yet                                   ***
#         ***      iwlen .gt. 1.2 * pfree                     ***
#         *** (where pfree is its value on input).            ***
#         The algorithm will not run at all if iwlen .lt. pfree-1.
#
#         Restriction: iwlen .ge. pfree-1
#  ---------------------------------------------------------------------
#   INPUT/OUPUT ARGUMENTS:
#  ---------------------------------------------------------------------
#   pe:   On input, pe (i) is the index in iw of the start of row i, or
#         zero if row i has no off-diagonal non-zeros.
#
#         During execution, it is used for both supervariables and
#         elements:
#
#         * Principal supervariable i:  index into iw of the
#                 description of supervariable i.  A supervariable
#                 represents one or more rows of the matrix
#                 with identical nonzero pattern.
#         * Non-principal supervariable i:  if i has been absorbed
#                 into another supervariable j, then pe (i) = -j.
#                 That is, j has the same pattern as i.
#                 Note that j might later be absorbed into another
#                 supervariable j2, in which case pe (i) is still -j,
#                 and pe (j) = -j2.
#         * Unabsorbed element e:  the index into iw of the description
#                 of element e, if e has not yet been absorbed by a
#                 subsequent element.  Element e is created when
#                 the supervariable of the same name is selected as
#                 the pivot.
#         * Absorbed element e:  if element e is absorbed into element
#                 e2, then pe (e) = -e2.  This occurs when the pattern
#                 of e (that is, Le) is found to be a subset of the
#                 pattern of e2 (that is, Le2).  If element e is "null"
#                 (it has no nonzeros outside its pivot block), then
#                 pe (e) = 0.
#
#         On output, pe holds the assembly tree/forest, which implicitly
#         represents a pivot order with identical fill-in as the actual
#         order (via a depth-first search of the tree).
#
#         On output:
#         If nv (i) .gt. 0, then i represents a node in the assembly
#         tree, and the parent of i is -pe (i), or zero if i is a root.
#         If nv (i) = 0, then (i,-pe (i)) represents an edge in a
#         subtree, the root of which is a node in the assembly tree.
#
#   pfree:        On input, the matrix is stored in iw (1..pfree-1) and
#         the rest of the array iw is free.
#         During execution, additional data is placed in iw, and pfree
#         is modified so that components  of iw from pfree are free.
#         On output, pfree is set equal to the size of iw that
#         would have been needed for no compressions to occur.  If
#         ncmpa is zero, then pfree (on output) is less than or equal
#         to iwlen, and the space iw (pfree+1 ... iwlen) was not used.
#         Otherwise, pfree (on output) is greater than iwlen, and all
#         the memory in iw was used.
#
#   nv:   On input, encoding of compressed graph:
#         During execution, abs (nv (i)) is equal to the number of rows
#         that are represented by the principal supervariable i.  If i
#         is a nonprincipal variable, then nv (i) = 0.  Initially,
#         nv (i) = 1 for all i.  nv (i) .lt. 0 signifies that i is a
#         principal variable in the pattern Lme of the current pivot
#         element me.  On output, nv (e) holds the true degree of
#         element e at the time it was created (including the diagonal
#         part).
#   begin HALO
#         On output, nv(I) can be used to find node in set V1.
#         Not true anymore : ( nv(I) = N+1 characterizes nodes in V1.
#                   instead nodes in V1 are considered as a dense root
#                   node)
#   end HALO
#  ---------------------------------------------------------------------
#   INPUT/MODIFIED (undefined on output):
#  ---------------------------------------------------------------------
#   len:  On input, len (i)
#             positive or null (>=0) : i ∈ V0 U Ve and
#                     if (nbelts==0) then (graph of variables)
#                       len(i) holds the number of entries in row i of
#                       the matrix, excluding the diagonal.
#                     else (graph of elements+variables)
#                       if i ∈ V0 then len(i) = nb of elements adjacent
#                           to i
#                       if i ∈ Ve then len(i) = nb of variables
#                           adjacent to i
#                     endif
#             negative (<0) : i ∈ V1, and
#                     if (nbelts==0) then (graph of variables)
#                       -len(i) hold the number of entries in row i of
#                        the matrix, excluding the diagonal.
#                        len(i) = - | Adj(i) | if i ∈ V1
#                                or -N -1 if | Adj(i) | = 0 and i ∈ V1
#                     else  (graph of elements+variables)
#                       -len(i) nb of elements adjacent to i
#                     endif
#         The content of len (1..n) is undefined on output.
#
#   elen: defined on input only if nbelts>0
#         if e ∈ Ve then elen (e) = -N-1
#         if v ∈ V0 then elen (v) = External degree of v
#                                   that should thus be provided
#                                   on entry to initialize degree
#
#         if v ∈ V1 then elen (v) = 0
#
#   iw:   On input, iw (1..pfree-1) holds the description of each row i
#         in the matrix.  The matrix must be symmetric, and both upper
#         and lower triangular parts must be present.  The diagonal must
#         not be present.  Row i is held as follows:
#
#                 len (i):  the length of the row i data structure
#                 iw (pe (i) ... pe (i) + len (i) - 1):
#                         the list of column indices for nonzeros
#                         in row i (simple supervariables), excluding
#                         the diagonal.  All supervariables start with
#                         one row/column each (supervariable i is just
#                         row i).
#                 if len (i) is zero on input, then pe (i) is ignored
#                 on input.
#
#                 Note that the rows need not be in any particular
#                 order, and there may be empty space between the rows.
#
#         During execution, the supervariable i experiences fill-in.
#         This is represented by placing in i a list of the elements
#         that cause fill-in in supervariable i:
#
#                 len (i):  the length of supervariable i
#                 iw (pe (i) ... pe (i) + elen (i) - 1):
#                         the list of elements that contain i.  This
#                         list is kept short by removing absorbed
#                         elements.
#                 iw (pe (i) + elen (i) ... pe (i) + len (i) - 1):
#                         the list of supervariables in i.  This list
#                         is kept short by removing nonprincipal
#                         variables, and any entry j that is also
#                         contained in at least one of the elements
#                         (j in Le) in the list for i (e in row i).
#
#         When supervariable i is selected as pivot, we create an
#         element e of the same name (e=i):
#
#                 len (e):  the length of element e
#                 iw (pe (e) ... pe (e) + len (e) - 1):
#                         the list of supervariables in element e.
#
#         An element represents the fill-in that occurs when
#         supervariable i is selected as pivot (which represents the
#         selection of row i and all non-principal variables whose
#         principal variable is i). We use the term Le to denote the
#         set of all supervariables in element e. Absorbed
#         supervariables and elements are pruned from these lists when
#         computationally convenient.
#
#         CAUTION:  THE INPUT MATRIX IS OVERWRITTEN DURING COMPUTATION.
#         The contents of iw are undefined on output.
#
#  ---------------------------------------------------------------------
#   OUTPUT (need not be set on input):
#  ---------------------------------------------------------------------
#   elen: See the description of iw above.  At the start of execution,
#         elen (i) is set to zero.  During execution, elen (i) is the
#         number of elements in the list for supervariable i.  When e
#         becomes an element, elen (e) = -nel is set, where nel is the
#         current step of factorization.  elen (i) = 0 is done when i
#         becomes nonprincipal.
#
#         For variables, elen (i) .ge. 0 holds
#         For elements, elen (e) .lt. 0 holds.
#
#   last: In a degree list, last (i) is the supervariable preceding i,
#         or zero if i is the head of the list.  In a hash bucket,
#         last (i) is the hash key for i.  last (head (hash)) is also
#         used as the head of a hash bucket if head (hash) contains a
#         degree list (see head, below).
#
#   ncmpa:        The number of times iw was compressed.  If this is
#         excessive, then the execution took longer than what could
#         have been. To reduce ncmpa, try increasing iwlen to be 10%
#         or 20% larger than the value of pfree on input (or at least
#         iwlen .ge. pfree + n).  The fastest performance will be
#         obtained when ncmpa is returned as zero.  If iwlen is set to
#         the value returned by pfree on *output*, then no compressions
#         will occur.
#   begin HALO
#          on output ncmpa <0 --> error detected during HALO_AMD:
#             error 1: ncmpa = -NORIG , ordering was stopped.
#   end HALO
#
#  ---------------------------------------------------------------------
#   LOCAL (not input or output - used only during execution):
#  ---------------------------------------------------------------------
#   degree:       If i is a supervariable, then degree (i) holds the
#         current approximation of the external degree of row i (an
#         upper bound).  The external degree is the number of nonzeros
#         minus abs (nv (i)) (the diagonal part).  The bound is equal to
#         in row i, the external degree if elen (i) is less than or
#         equal to two.
#         We also use the term "external degree" for elements e to refer
#         to |Le \ Lme|.  If e is an element, then degree (e) holds
#         |Le|, which is the degree of the off-diagonal part of the
#         element e (not including the diagonal part).
#   begin HALO
#         degree(I) = n+1 indicates that i belongs to V1
#   end HALO
#
#   head: head is used for degree lists.  head (deg) is the first
#         supervariable in a degree list (all supervariables i in a
#         degree list deg have the same approximate degree, namely,
#         deg = degree (i)).  If the list deg is empty then
#         head (deg) = 0.
#
#         During supervariable detection head (hash) also serves as a
#         pointer to a hash bucket.
#         If head (hash) .gt. 0, there is a degree list of degree hash.
#                 The hash bucket head pointer is last (head (hash)).
#         If head (hash) = 0, then the degree list and hash bucket are
#                 both empty.
#         If head (hash) .lt. 0, then the degree list is empty, and
#                 -head (hash) is the head of the hash bucket.
#         After supervariable detection is complete, all hash buckets
#         are empty, and the (last (head (hash)) = 0) condition is
#         restored for the non-empty degree lists.
#   next: next (i) is the supervariable following i in a link list, or
#         zero if i is the last in the list.  Used for two kinds of
#         lists:  degree lists and hash buckets (a supervariable can be
#         in only one kind of list at a time).
#   w:    The flag array w determines the status of elements and
#         variables, and the external degree of elements.
#
#         for elements:
#            if w (e) = 0, then the element e is absorbed
#            if w (e) .ge. wflg, then w (e) - wflg is the size of
#                 the set |Le \ Lme|, in terms of nonzeros (the
#                 sum of abs (nv (i)) for each principal variable i that
#                 is both in the pattern of element e and NOT in the
#                 pattern of the current pivot element, me).
#            if wflg .gt. w (e) .gt. 0, then e is not absorbed and has
#                 not yet been seen in the scan of the element lists in
#                 the computation of |Le\Lme| in loop 150 below.
#
#         for variables:
#            during supervariable detection, if w (j) .ne. wflg then j
#            is not in the pattern of variable i
#
#         The w array is initialized by setting w (i) = 1 for all i,
#         and by setting wflg = 2.  It is reinitialized if wflg becomes
#         too large (to ensure that wflg+n does not cause integer
#         overflow).
#
#   wf : integer array  used to store the already filled area of
#        the variables adajcent to current pivot.
#        wf is then used to update the score of variable i.
function hamf_impl!(
        norig::V,                  # uncompressed matrix order
        n::V,                      # current matrix order
        nbelts::V,                 # number of elements
        nbbuck::V,                 # number of buckets
        iwlen::E,                  # length of array `iw`
        pe::AbstractVector{E},     # array of indices in `iw` of start of row `i`
        pfree::E,                  # useful size in `iw`
        len::AbstractVector{V},    # array of lengths of adjacency lists
        iw::AbstractVector{V},     # adjacency list array
        nv::AbstractVector{V},     # array of element degrees (weights)
        elen::AbstractVector{V},   # array that holds the inverse permutation
        last::AbstractVector{V},   # array that holds the permutation
        degree::AbstractVector{V}, # array that holds degree data
        wf::AbstractVector{E},     # flag array
        next::AbstractVector{V},   # linked list structure
        w::AbstractVector{I},      # flag array
        head::AbstractVector{V},   # linked list structure
    ) where {I, V, E}
    @assert nbelts <= n
    @assert pfree <= iwlen <= length(iw)
    @assert norig <= nbbuck
    @assert n < length(pe)
    @assert n <= length(len)
    @assert n <= length(nv)
    @assert n <= length(elen)
    @assert n <= length(last)
    @assert n <= length(degree)
    @assert n <= length(wf)
    @assert n <= length(next)
    @assert n <= length(w)
    @assert nbbuck + two(V) <= length(head)

    @inbounds for i in oneto(n)
        elen[i] = zero(V)
        last[i] = zero(V)
        degree[i] = zero(V)
        wf[i] = zero(E)
        next[i] = zero(V)
        w[i] = zero(I)
    end

    @inbounds for i in oneto(nbbuck + two(V))
        head[i] = zero(V)
    end

    #=====================================================================#
    #
    # deg :       the degree of a variable or element
    # degme :     size, |Lme|, of the current element, me (= degree (me))
    # dext :      external degree, |Le \ Lme|, of some element e
    # dmax :      largest |Le| seen so far
    # e :         an element
    # elenme :    the length, elen (me), of element list of pivotal var.
    # eln :       the length, elen (...), of an element list
    # hash :      the computed value of the hash function
    # hmod :      the hash function is computed modulo hmod = max (1,n-1)
    # i :         a supervariable
    # ilast :     the entry in a link list preceding i
    # inext :     the entry in a link list following i
    # j :         a supervariable
    # jlast :     the entry in a link list preceding j
    # jnext :     the entry in a link list, or path, following j
    # k :         the pivot order of an element or variable
    # knt1 :      loop counter used during element construction
    # knt2 :      loop counter used during element construction
    # knt3 :      loop counter used during compression
    # lenj :      len (j)
    # ln :        length of a supervariable list
    # maxint_n :  large integer to test risk of overflow on wflg
    # maxmem :    amount of memory needed for no compressions
    # me :        current supervariable being eliminated, and the
    #                     current element created by eliminating that
    #                     supervariable
    # mem :       memory in use assuming no compressions have occurred
    # mindeg :    current minimum degree
    # nel :       number of pivots selected so far
    # newmem :    amount of new memory needed for current pivot element
    # nleft :     n - nel, the number of nonpivotal rows/columns remaining
    # nvi :       the number of variables in a supervariable i (= nv (i))
    # nvj :       the number of variables in a supervariable j (= nv (j))
    # nvpiv :     number of pivots in current element
    # slenme :    number of variables in variable list of pivotal variable
    # we :        w (e)
    # wflg :      used for flagging the w array.  See description of iw.
    # wnvi :      wflg - nv (i)
    # x :         either a supervariable or an element
    # wf3 :       off diagoanl block area
    # wf4 :       diagonal block area
    # mf :        minimum fill
    # nbflag :    number of flagged entries in the initial gragh.
    # nreal :     number of entries on which ordering must be perfomed
    #             (nreal = n - nbflag)
    # nelme :     number of pivots selected when reaching the root
    # lastd :     index of the last row in the list of dense rows
    #
    #=====================================================================#

    #=====================================================================#
    #
    #             Any parameter (pe (...) or pfree) or local variable
    #             starting with "p" (for Pointer) is an index into iw,
    #             and all indices into iw use variables starting with
    #             "p."  The only exception to this rule is the iwlen
    #             input argument.
    # p :         pointer into lots of things
    # p1 :        pe (i) for some variable i (start of element list)
    # p2 :        pe (i) + elen (i) -  1 for some var. i (end of el. list)
    # p3 :        index of first supervariable in clean list
    # pdst :      destination pointer, for compression
    # pend :      end of memory to compress
    # pj :        pointer into an element or variable
    # pme :       pointer into the current element (pme1...pme2)
    # pme1 :      the current element, me, is stored in iw (pme1...pme2)
    # pme2 :      the end of the current element
    # pn :        pointer into a "clean" variable, also used to compress
    # psrc :      source pointer, for compression
    #
    #=====================================================================#

    idummy = typemax(E) - one(E)
    dummy = convert(FLOAT, idummy)
    n2 = -one(V) - nbbuck                   # variable with degree `n2` are in halo; ; bucket `nbbuck + 1` used for halo variables
    pas = max(div(norig, eight(V)), one(V)) # distance between elements of the `n`, ..., `nbbuck` entries of `head`
    wflg = two(I)
    maxint_n = typemax(I) - convert(I, norig)
    ncmpa = zero(I)
    nel = zero(V)
    totel = zero(V)
    hmod = max(one(E), nbbuck - one(E))
    dmax = zero(V)
    mem = pfree - one(E)
    maxmem = mem
    mindeg = zero(V)
    nbflag = zero(V)
    lastd = zero(V)

    if iszero(nbelts)                         # if graph has no elements and only variables
        @inbounds for i in oneto(n)
            w[i] = one(I)

            if isnegative(len[i])
                degree[i] = n2
                nbflag += one(V)

                if len[i] == -one(V) - norig  # variable in V1 with empty adj. list
                    len[i] = zero(V)          # because of compress, we force skipping this entry (which is anyway empty)
                    pe[i] = zero(E)
                else
                    len[i] = -len[i]
                end
            else
                totel += nv[i]

                if n == norig                 # if graph not compressed
                    degree[i] = len[i]
                else
                    degree[i] = zero(V)

                    for p in pe[i]:(pe[i] + convert(E, len[i]) - one(E))
                        degree[i] += nv[iw[p]]
                    end
                end
            end
        end
    else                                      # graph has elements
        @inbounds for i in oneto(n)
            w[i] = one(I)

            if isnegative(len[i])
                degree[i] = n2
                nbflag += one(V)

                if len[i] == -one(V) - norig
                    len[i] = zero(V)          # because of compress, we force skipping this entry (which is anyway empty)
                    pe[i] = zero(E)
                    elen[i] = zero(V)         # already done before calling
                else
                    len[i] = -len[i]
                    elen[i] = len[i]
                end
            else                              # non-halo vertex or element
                if isnegative(elen[i])        # if `i` ∈ Ve
                    nel += nv[i]
                    elen[i] = -nel

                    if n == norig
                        degree[i] = len[i]
                    else
                        degree[i] = zero(V)

                        for p in pe[i]:(pe[i] + convert(E, len[i]) - one(E))
                            degree[i] += nv[iw[p]]
                        end
                    end

                    if degree[i] > dmax
                        dmax = degree[i]
                    end
                else                          # `i` ∈ V0
                    totel += nv[i]
                    degree[i] = elen[i]
                    elen[i] = len[i]
                end
            end
        end
    end

    nreal = n - nbflag                        # number of entries to be ordered

    @inbounds for i in oneto(n)               # initialize degree lists and eliminate rows with no off-diag. nz.
        if isnegative(elen[i])                # skip element vertices (Ve)
            continue
        end

        deg = degree[i]

        if deg == n2                          # V1 variables (`deg == n2`): flagged variables stored in degree list of `nbbuck + 1`
            deg = nbbuck + one(V)

            if iszero(lastd)                  # degree list is empty
                lastd = i
                head[deg + one(V)] = i
                next[i] = zero(V)
                last[i] = zero(V)
            else
                next[lastd] = i
                last[i] = lastd
                lastd = i
                next[i] = zero(V)
            end
        elseif ispositive(deg)
            wf[i] = convert(I, deg)           # version 1

            if deg > norig
                deg = min(div(deg - norig, pas) + norig, nbbuck)  # note the if `deg == 0`, no fill-in will occur but one variable adjacent to i
            end

            inext = head[deg + one(V)]

            if !iszero(inext)
                last[inext] = i
            end

            next[i] = inext
            head[deg + one(V)] = i
        else                                  # variable can be eliminated at once because no off-diagonal non-zero in its row
            nel += nv[i]
            elen[i] = -nel
            pe[i] = zero(E)
            w[i] = zero(I)
        end
    end

    nleft = totel - nel                       # if elements provided (`nbelts > 0`), they are eliminated

    @inbounds while nel < totel
        deg = mindeg - one(V); me = zero(V)

        while deg < nbbuck && !ispositive(me)
            deg += one(V); me = head[deg + one(V)]
        end

        mindeg = deg

        if !ispositive(me)
            error()
        end

        if deg > norig                        # linear search to find variable with best score in the list
            j = next[me]
            k = wf[me]

            while ispositive(j)               # L55: CONTINUE
                if wf[j] < k
                    me = j
                    k = wf[me]
                end

                j = next[j]
            end

            ilast = last[me]
            inext = next[me]

            if !iszero(inext)
                last[inext] = ilast
            end

            if !iszero(ilast)
                next[ilast] = inext
            else
                head[deg + one(V)] = inext    # `me` is at the head of the degree list
            end
        else                                  # remove chosen variable from link list
            inext = next[me]

            if !iszero(inext)
                last[inext] = zero(V)
            end

            head[deg + one(V)] = inext
        end

        elenme = elen[me]                     # `me` represents the elimination of pivots `nel + 1` to `nel + nv[me]`
        elen[me] = -one(V) - nel              # place `me` itself as the first in this set. it will be moved
        nvpiv = nv[me]                        # to the `nel + nv[me]` position when the permutation vectors are
        nel += nvpiv                          # computed
        nv[me] = -nvpiv                       # at this point, `me` is the pivotal supervariable
        degme = zero(V)                       # it will be converted into the current element

        if iszero(elenme)                     # construct the new element in place
            pme1 = pe[me]
            pme2 = pme1 - one(E)

            for p in pme1:(pme1 + convert(E, len[me]) - one(E)) # scan list of the pivotal supervariable `me`
                i = iw[p]
                nvi = nv[i]

                if ispositive(nvi)            # `i` is a principal variable not yet placed in Lme
                    degme += nvi              # store `i` in new list
                    nv[i] = -nvi              # flag `i` as being in Lme by negating `nv[i]`
                    pme2 += one(E)
                    iw[pme2] = i

                    if degree[i] != n2        # remove variable `i` from degree list. (only if `i` ∈ V0)
                        ilast = last[i]
                        inext = next[i]

                        if !iszero(inext)
                            last[inext] = ilast
                        end

                        if !iszero(ilast)
                            next[ilast] = inext
                        else
                            if wf[i] > norig
                                deg = min(div(wf[i] - norig, pas) + norig, nbbuck)
                            else
                                deg = wf[i]
                            end

                            head[deg + one(V)] = inext
                        end
                    end
                end
            end                               # L60:

            newmem = zero(E)
        else                                  # construct the new element in empty space, `iw[pfree...]`
            p = pe[me]
            pme1 = pfree
            slenme = len[me] - elenme
            knt1_updated = zero(V)

            for knt1 in oneto(elenme + one(V))
                knt1_updated += one(V)

                if knt1 > elenme              # search the supervariables in `me`
                    e = me
                    pj = p
                    ln = slenme
                else                          # search the elements in `me`
                    e = iw[p]; p += one(E)
                    pj = pe[e]
                    ln = len[e]
                end

                knt2_updated = zero(V)

                for knt2 in oneto(ln)              # search for different supervariables and add to new list
                    knt2_updated += one(V)
                    i = iw[pj]; pj += one(E)
                    nvi = nv[i]

                    if ispositive(nvi)
                        if pfree > iwlen      # compress `iw` if necessary
                            pe[me] = p        # prepare for compressing iw by adjusting pointers and lengths so that the lists
                            len[me] -= knt1_updated  # being searched in the inner and outer loops contain only the remaining entries
                            knt1_updated = zero(V)   # reset `knt1_updated` in case of recompress at same iteration of the loop 120

                            if iszero(len[me])       # check if anything left in supervariable `me`
                                pe[me] = zero(E)
                            end

                            pe[e] = pj
                            len[e] = ln - knt2_updated
                            knt2_updated = zero(V)   # reset `knt2_updated` in case of recompress at same iteration of the loop 110

                            if iszero(len[e])
                                pe[e] = zero(E)
                            end

                            ncmpa += one(I)

                            for j in oneto(n) # store first item in `pe`; set first entry to `-item`
                                pn = pe[j]

                                if ispositive(pn)
                                    pe[j] = convert(E, iw[pn])
                                    iw[pn] = -j
                                end
                            end               # L70

                            pdst = one(E)
                            psrc = one(E)
                            pend = pme1 - one(E)

                            while psrc <= pend # L80
                                j = -iw[psrc]
                                psrc += one(E)

                                if ispositive(j)
                                    iw[pdst] = convert(V, pe[j])
                                    pe[j] = pdst; pdst += one(E)
                                    lenj = len[j]

                                    for knt3 in zero(V):(lenj - two(V)) # L90
                                        iw[pdst + convert(E, knt3)] = iw[psrc + convert(E, knt3)]
                                    end

                                    pdst += convert(E, lenj - one(V))
                                    psrc += convert(E, lenj - one(V))
                                end
                            end

                            p1 = pdst         # move the new partially-constructed element

                            for psrc in pme1:pfree - one(E) # L100
                                iw[pdst] = iw[psrc]
                                pdst += one(E)
                            end

                            pme1 = p1
                            pfree = pdst
                            pj = pe[e]
                            p = pe[me]
                        end

                        degme += nvi          # `i` is a principal variable not yet placed in Lme; store `i` in new list
                        nv[i] = -nvi
                        iw[pfree] = i; pfree += one(E)

                        if degree[i] != n2    # remove variable `i` from degree link list (only if `i` in V0)
                            ilast = last[i]
                            inext = next[i]

                            if !iszero(inext)
                                last[inext] = ilast
                            end

                            if !iszero(ilast)
                                next[ilast] = inext
                            else
                                if wf[i] > norig
                                    deg = min(div(wf[i] - norig, pas) + norig, nbbuck)
                                else
                                    deg = wf[i]
                                end

                                head[deg + one(V)] = inext
                            end
                        end
                    end
                end                           # L110:

                if e != me                    # set tree pointer and flag to indicate element `e` is absorbed into new element `me` (the parent of `e` is `me`)
                    pe[e] = convert(E, -me)
                    w[e] = zero(I)
                end
            end                               # L120:

            pme2 = pfree - one(E)
            newmem = pfree - pme1             # this element takes `newmem` new memory in `iw` (possibly zero)
            mem += newmem
            maxmem = max(maxmem, mem)
        end

        degree[me] = degme                    # `me` has now been converted into an element in `iw[pme1...pme2]`
        pe[me] = pme1                         # `degme` holds the external degree of new element
        len[me] = convert(V, pme2 - pme1 + one(E))

        if wflg > maxint_n                    # make sure that `wflg` is not too large; `wflg + n` must not cause integer overflow
            for x in oneto(n)
                if !iszero(w[x])
                    w[x] = one(I)
                end
            end

            wflg = two(I)                     # L130:
        end

        for pme in pme1:pme2                  # compute `w[e] - wflg` = |Le\Lme| for all elements
            i = iw[pme]
            eln = elen[i]

            if ispositive(eln)                # note that `nv[i]` has been negated to denote `i` in Lme
                nvi = -nv[i]
                wnvi = wflg - convert(I, nvi)

                # L140:
                for p in pe[i]:(pe[i] + convert(E, eln) - one(E))
                    e = iw[p]
                    we = w[e]

                    if we >= wflg             # unabsorbed element `e` has been seen in this loop
                        we -= convert(I, nvi)
                    elseif !iszero(we)        # `e` is an unabsorbed element; this is the first time we have seen `e` in all of scan 1
                        we = convert(I, degree[e]) + wnvi
                        wf[e] = zero(E)
                    end

                    w[e] = we
                end                           # L140:
            end
        end                                   # L150:

        for pme in pme1:pme2                  # degree update and element absorption
            i = iw[pme]
            p1 = pe[i]
            p2 = p1 + convert(E, elen[i]) - one(E)
            pn = p1
            hash = zero(E)
            deg = zero(V)
            wf3 = zero(E)
            wf4 = zero(E)
            nvi = -nv[i]

            for p in p1:p2                    # scan the element list associated with supervariable `i`
                e = iw[p]
                dext = convert(V, w[e] - wflg) # `dext` = |Le\Lme|

                if ispositive(dext)
                    if iszero(wf[e])          # first time we meet `e`: compute `wf[e]` which is the surface associated to element `e`
                        wf[e] = convert(E, dext) * convert(E, twice(degree[e]) - dext - one(V))
                    end

                    wf4 += wf[e]
                    deg += dext
                    iw[pn] = e; pn += one(E)
                    hash += convert(E, e)
                elseif iszero(dext)           # aggressive absorption: `e` is not adjacent to `me`, but |Le\Lme| is 0, so absorb it into `me`
                    pe[e] = convert(E, -me)
                    w[e] = zero(I)
                end
            end                               # L160:

            elen[i] = convert(V, pn - p1) + one(V) # count the number of elements in `i` (including `me`)
            p3 = pn

            for p in (p2 + one(E)):(p1 + convert(E, len[i]) - one(E)) # scan the supervariables in the list associated with `i`
                j = iw[p]
                nvj = nv[j]

                if ispositive(nvj)            # `j` is unabsorbed, and not in Lme; add to degree and add to new list
                    deg += nvj
                    wf3 += nvj
                    iw[pn] = j; pn += one(E)
                    hash += convert(E, j)
                end
            end

            if degree[i] == n2
                deg = n2
            end

            if iszero(deg)                    # mass elimination
                pe[i] = convert(E, -me)
                nvi = -nv[i]
                degme -= nvi
                nvpiv += nvi
                nel += nvi
                nv[i] = zero(V)
                elen[i] = zero(V)
            else                              # update the upper-bound degree of `i`
                if degree[i] != n2            # `i` does not belong to halo
                    if degree[i] < deg        # our approx degree is loose; we cannot subtract `wf[i]`
                        wf4 = zero(E)
                        wf3 = zero(E)
                    else
                        degree[i] = deg
                    end
                end

                wf[i] = wf4 + convert(E, twice(nvi)) * wf3
                iw[pn] = iw[p3]               # add `me` to the list for `i`
                iw[p3] = iw[p1]
                iw[p1] = me                   # add new element to front of list
                len[i] = convert(V, pn - p1) + one(V) # store the new length of the list in `len[i]`

                if deg != n2                  # place in hash bucket; save hash key of `i` in `last[i]`
                    hash = (hash % hmod) + one(E)
                    j = head[hash + one(E)]

                    if !ispositive(j)         # the degree list is empty; hash head is `-j`
                        next[i] = -j
                        head[hash + one(E)] = -i
                    else                     # degree list is not empty; use `last[head[hash + 1]]` as hash head
                        next[i] = last[j]
                        last[j] = i
                    end

                    last[i] = hash
                end
            end
        end                                  # L180:

        degree[me] = degme

        if degme > dmax                      # clear the counter array `w` by incrementing `wflg`
            dmax = degme
        end

        wflg += dmax

        if wflg > maxint_n                   # make sure that `wflg + n` does not cause integer overflow
            for x in oneto(n)
                if !iszero(w[x])
                    w[x] = one(I)
                end
            end

            wflg = two(I)
        end

        for pme in pme1:pme2                 # supervariable detection
            i = iw[pme]

            if isnegative(nv[i]) && (degree[i] != n2) # `i` is a principal variable in Lme
                hash = last[i]
                j = head[hash + one(E)]

                if iszero(j)
                    continue                 # goto L250:
                end

                if isnegative(j)             # degree list is empty
                    i = -j
                    head[hash + one(E)] = zero(V)
                else                         # degree list is not empty: restore `last` of head
                    i = last[j]
                    last[j] = zero(V)
                end

                while !iszero(i) && !iszero(next[i]) # while loop L200:
                    ln = len[i]
                    eln = elen[i]

                    for p in (pe[i] + one(E)):(pe[i] + ln - one(E))
                        w[iw[p]] = wflg
                    end

                    jlast = i
                    j = next[i]

                    while !iszero(j)         # while loop L220:
                        L240 = false
                        L240 = L240 || len[j] != ln   # jump if `i` and `j` do not have same size data structure
                        L240 = L240 || elen[j] != eln # jump if `i` and `j` do not have same number adj elts

                        if !L240
                            for p in (pe[j] + one(E)):(pe[j] + convert(E, ln) - one(E))
                                L240 && break
                                L240 = w[iw[p]] != wflg # jump if an entry `w[iw[p]]` is in `j` but not in `i`
                            end
                        end

                        if L240
                            jlast = j        # `j` cannot be absorbed into `i`
                            j = next[j]
                        else
                            pe[j] = convert(E, -i) # found it! `j` can be absorbed into `i`

                            if wf[j] > wf[i]
                                wf[i] = wf[j]
                            end

                            nv[i] += nv[j]   # both `nv[i]` and `nv[j]` are negated since they are in Lme
                            nv[j] = zero(V)
                            elen[j] = zero(V)
                            j = next[j]      # delete `j` from hash bucket
                            next[jlast] = j
                        end
                    end

                    wflg += one(I)
                    i = next[i]
                end
            end
        end

        p = pme1                             # restore degree lists and remove nonprincipal supervariable from element
        nleft = totel - nel

        for pme in pme1:pme2
            i = iw[pme]
            nvi = -nv[i]

            if ispositive(nvi)               # `i` is a principal variable in Lme; restore `nv[i]` to signify that `i` is principal
                nv[i] = nvi

                if degree[i] != n2           # compute the external degree (add size of current elem)
                    deg = degree[i]

                    if degree[i] + degme > nleft
                        rmf1 = convert(FLOAT, deg) * convert(FLOAT, deg - one(V) + twice(degme)) - convert(FLOAT, wf[i])
                        degree[i] = nleft - nvi
                        deg = degree[i]
                        rmf = convert(FLOAT, deg) * convert(FLOAT, deg - one(V)) - convert(FLOAT, degme - nvi) * convert(FLOAT, degme - nvi - one(V))
                        rmf = min(rmf, rmf1)
                    else
                        degree[i] += degme - nvi
                        rmf = convert(FLOAT, deg) * convert(FLOAT, deg - one(V) + twice(degme)) - convert(FLOAT, wf[i])
                    end

                    rmf /= convert(FLOAT, nvi + one(V))

                    if rmf < dummy
                        wf[i] = anint(E, rmf)
                    elseif rmf / convert(FLOAT, n) < dummy
                        wf[i] = anint(E, rmf / convert(FLOAT, n))
                    else
                        wf[i] = idummy
                    end

                    if !ispositive(wf[i])
                        wf[i] = one(E)
                    end

                    deg = wf[i]

                    if deg > norig
                        deg = min(div(deg - norig, pas) + norig, nbbuck)
                    end

                    inext = head[deg + one(V)]

                    if !iszero(inext)
                        last[inext] = i
                    end

                    next[i] = inext
                    last[i] = zero(V)
                    head[deg + one(V)] = i

                    if mindeg > deg          # save the new degree, and find the minimum degree
                        mindeg = deg
                    end
                end

                iw[p] = i; p += one(E)       # place the supervariable in the element pattern
            end
        end # L260:

        nv[me] = nvpiv + degme               # finalize the new element
        len[me] = convert(V, p - pme1)

        if iszero(len[me])                   # there is nothing left of the current pivot element
            pe[me] = zero(E)
            w[me] = zero(I)
        end

        if !iszero(newmem)                   # element was not constructed in place: deallocate part of it
            pfree = p
            mem = mem - newmem + len[me]
        end
    end                                      # end while (selecting pivots)

    if ispositive(nbflag)                    # begin halo v2
        deg = mindeg - one(V); me = zero(V)

        @inbounds while deg < nbbuck + one(V) && !ispositive(me)
            deg += one(V); me = head[deg + one(V)]
        end

        mindeg = deg
        nelme = -one(V) - nel

        @inbounds for x in oneto(n)
            if ispositive(pe[x]) && isnegative(elen[x]) # `x` is an unabsorbed element
                pe[x] = convert(E, -me)
            elseif degree[x] == n2          # `x` is a dense row, absorb it in ME (mass elimination)
                nel += nv[x]
                pe[x] = convert(E, -me)
                elen[x] = zero(V)
                nv[x] = zero(V)             # patch 12/12/98 <PA+FP> (old: `n + 1`)
            end
        end

        @inbounds elen[me] = nelme          # `me` is the root node
        @inbounds nv[me] = n - nreal        # correct value of `nv` is principal variable = `nbflag`
        @inbounds pe[me] = zero(E)
    end

    @inbounds for i in oneto(n)
        if iszero(elen[i])
            j = convert(V, -pe[i])

            while !isnegative(elen[j])      # L270:
                j = convert(V, -pe[j])
            end

            e = j
            k = -elen[e]                    # get the current pivot ordering of `e`
            j = i

            while !isnegative(elen[j])      # L280:
                jnext = convert(V, -pe[j])
                pe[j] = convert(E, -e)

                if iszero(elen[j])
                    elen[j] = k; k += one(V)
                end

                j = jnext
            end

            elen[e] = -k
        end
    end                                     # L290:

    return ncmpa
end

end

# ===== DivisionWorkspace =====

abstract type AbstractDivisionWorkspace{T} end

struct DivisionWorkspace{T} <: AbstractDivisionWorkspace{T}
    Mval::FVector{T}
end

struct DenseDivisionWorkspace{T} <: AbstractDivisionWorkspace{T} end

function DivisionWorkspace{T}(S::ChordalSymbolic, nrhs::Integer) where {T}
    Mval = FVector{T}(undef, S.nFval * nrhs)
    return DivisionWorkspace{T}(Mval)
end

function AbstractDivisionWorkspace{T}(L::ChordalTriangular, nrhs::Integer) where {T}
    return DivisionWorkspace{T}(L.S, nrhs)
end

function AbstractDivisionWorkspace{T}(A::AbstractTriangular, nrhs::Integer) where {T}
    return DenseDivisionWorkspace{T}()
end

function AbstractDivisionWorkspace{T}(A::AdjOrTrans, nrhs::Integer) where {T}
    return AbstractDivisionWorkspace{T}(parent(A), nrhs)
end

function AbstractDivisionWorkspace{T}(F::AbstractFactorization, nrhs::Integer) where {T}
    return AbstractDivisionWorkspace{T}(triangular(F), nrhs)
end

# ================================== \ ==================================

# --- Permutation ---

function Base.:\(A::Permutation, B::AbstractVecOrMat)
    return inv(A) * B
end


# --- ChordalTriangular ---

function Base.:\(A::MaybeAdjOrTransTri, B::AbstractVecOrMat)
    T = promote_eltype(A, B)
    return ldiv!(A, copyto!(similar(B, T), B))
end

# ================================== / ==================================

# --- Permutation ---

function Base.:/(A::AbstractMatrix, B::Permutation)
    return A * inv(B)
end

function Base.:/(A::TransVec, B::Permutation)
    return transpose(transpose(B) \ parent(A))
end

function Base.:/(A::AdjVec, B::Permutation)
    return adjoint(adjoint(B) \ parent(A))
end


# --- ChordalTriangular ---

function Base.:/(B::AbstractMatrix, A::MaybeAdjOrTransTri)
    T = promote_eltype(A, B)
    return rdiv!(copyto!(similar(B, T), B), A)
end

function Base.:/(A::TransVec, B::MaybeAdjOrTransTri)
    return transpose(transpose(B) \ parent(A))
end

function Base.:/(A::AdjVec, B::MaybeAdjOrTransTri)
    return adjoint(adjoint(B) \ parent(A))
end

function Base.:/(A::ChordalTriangular, α::Number)
    B = similar(A, promote_eltype(A, α))
    copyto!(B, A)
    rdiv!(B, α)
    return B
end

function Base.:\(α::Number, A::ChordalTriangular)
    return A / α
end

function Base.:\(α::Number, A::HermOrSymTri)
    return A / α
end

function Base.:/(A::HermTri{UPLO}, α::Number) where {UPLO}
    return Hermitian(parent(A) / α, UPLO)
end

function Base.:/(A::HermTri{UPLO}, α::Real) where {UPLO}
    return Hermitian(parent(A) / α, UPLO)
end

function Base.:/(A::HermTri{UPLO}, α::Complex) where {UPLO}
    @assert iszero(imag(α))
    return Hermitian(parent(A) / real(α), UPLO)
end

function Base.:/(A::SymTri{UPLO}, α::Number) where {UPLO}
    return Symmetric(parent(A) / α, UPLO)
end

function Base.:\(α::Number, A::AdjTri)
    return adjoint(conj(α) \ parent(A))
end

function Base.:/(A::AdjTri, α::Number)
    return adjoint(parent(A) / conj(α))
end

function Base.:\(α::Number, A::TransTri)
    return transpose(α \ parent(A))
end

function Base.:/(A::TransTri, α::Number)
    return transpose(parent(A) / α)
end

# ================================ ldiv! ================================

# --- ChordalTriangular ---

function LinearAlgebra.ldiv!(α::Number, C::ChordalTriangular)
    ldiv!(α, C.Dval)
    ldiv!(α, C.Lval)
    return C
end

function LinearAlgebra.ldiv!(α::Number, A::HermTri)
    ldiv!(α, parent(A))
    return A
end

function LinearAlgebra.ldiv!(α::Number, A::SymTri)
    ldiv!(α, parent(A))
    return A
end

function LinearAlgebra.ldiv!(α::Number, A::AdjTri)
    ldiv!(conj(α), parent(A))
    return A
end

function LinearAlgebra.ldiv!(α::Number, A::TransTri)
    ldiv!(α, parent(A))
    return A
end

function LinearAlgebra.ldiv!(A::MaybeAdjOrTransTri, B::AbstractVecOrMat{R}) where {R}
    W = AbstractDivisionWorkspace{R}(A, size(B, 2))
    return ldiv!(W, A, B)
end

function LinearAlgebra.ldiv!(W::DivisionWorkspace, A::MaybeAdjOrTransTri, B::AbstractVecOrMat)
    @assert size(A, 1) == size(B, 1)
    A, tA = unwrap(A)
    B, tB = unwrap(B)
    return div_impl!(B, W, A, tA, tB, Val(:L))
end

# --- AbstractFactorization ---

function LinearAlgebra.ldiv!(α::Number, F::AbstractFactorization{DIAG}) where {DIAG}
    if DIAG === :N
        ldiv!(sqrt(α), triangular(F))
    else
        ldiv!(α, F.D)
    end

    return F
end

function LinearAlgebra.ldiv!(F::NaturalFactorization, B::AbstractVecOrMat{R}) where {R}
    W = AbstractDivisionWorkspace{R}(F, size(B, 2))
    return ldiv!(W, F, B)
end

function LinearAlgebra.ldiv!(W::AbstractDivisionWorkspace, F::NaturalFactorization{DIAG}, B::AbstractVecOrMat) where {DIAG}
    @assert size(F, 1) == size(B, 1)

    if DIAG === :N
        return ldiv!(W, F.U, ldiv!(W, F.L, B))
    else
        return ldiv!(W, F.U, ldiv!(F.D, ldiv!(W, F.L, B)))
    end
end

function LinearAlgebra.ldiv!(F::AbstractFactorization, B::AbstractVecOrMat)
    @assert size(F, 1) == size(B, 1)
    T = promote_eltype(F, B)
    C = FArray{T}(undef, size(B))
    return ldiv!!(C, F, B)
end

# --- Permutation ---

function LinearAlgebra.ldiv!(C::AbstractVecOrMat, A::Permutation, B::AbstractVecOrMat)
    return mul!(C, inv(A), B)
end

function LinearAlgebra.ldiv!(C::Permutation, A::Permutation, B::Permutation)
    return mul!(C, inv(A), B)
end

# ================================ rdiv! ================================

# --- ChordalTriangular ---

function LinearAlgebra.rdiv!(C::ChordalTriangular, α::Number)
    rdiv!(C.Dval, α)
    rdiv!(C.Lval, α)
    return C
end

function LinearAlgebra.rdiv!(A::HermTri, α::Number)
    rdiv!(parent(A), α)
    return A
end

function LinearAlgebra.rdiv!(A::SymTri, α::Number)
    rdiv!(parent(A), α)
    return A
end

function LinearAlgebra.rdiv!(A::AdjTri, α::Number)
    rdiv!(parent(A), conj(α))
    return A
end

function LinearAlgebra.rdiv!(A::TransTri, α::Number)
    rdiv!(parent(A), α)
    return A
end

function LinearAlgebra.rdiv!(B::AbstractMatrix{R}, A::MaybeAdjOrTransTri) where {R}
    W = AbstractDivisionWorkspace{R}(A, size(B, 1))
    return rdiv!(W, B, A)
end

function LinearAlgebra.rdiv!(W::DivisionWorkspace, B::AbstractMatrix, A::MaybeAdjOrTransTri)
    @assert size(A, 1) == size(B, 2)
    A, tA = unwrap(A)
    B, tB = unwrap(B)
    return div_impl!(B, W, A, tA, tB, Val(:R))
end

# --- AbstractFactorization ---

function LinearAlgebra.rdiv!(F::AbstractFactorization{DIAG}, α::Number) where {DIAG}
    if DIAG === :N
        rdiv!(triangular(F), sqrt(α))
    else
        rdiv!(F.D, α)
    end

    return F
end

function LinearAlgebra.rdiv!(B::AbstractMatrix{R}, F::NaturalFactorization) where {R}
    W = AbstractDivisionWorkspace{R}(F, size(B, 1))
    return rdiv!(W, B, F)
end

function LinearAlgebra.rdiv!(W::AbstractDivisionWorkspace, B::AbstractMatrix, F::NaturalFactorization{DIAG}) where {DIAG}
    @assert size(F, 1) == size(B, 2)

    if DIAG === :N
        return rdiv!(W, rdiv!(W, B, F.U), F.L)
    else
        return rdiv!(W, rdiv!(rdiv!(W, B, F.U), F.D), F.L)
    end
end

function LinearAlgebra.rdiv!(B::AbstractMatrix, F::AbstractFactorization)
    @assert size(F, 1) == size(B, 2)
    T = promote_eltype(F, B)
    C = FMatrix{T}(undef, size(B))
    return rdiv!!(C, B, F)
end

# --- Permutation ---

function LinearAlgebra.rdiv!(C::AbstractMatrix, A::AbstractMatrix, B::Permutation)
    return mul!(C, A, inv(B))
end

function LinearAlgebra.rdiv!(C::Permutation, A::Permutation, B::Permutation)
    return mul!(C, A, inv(B))
end

# ================================ lpdiv! ===============================

# --- ChordalTriangular ---

function lpdiv!(A::MaybeAdjOrTransTri, B::AbstractVecOrMat{R}) where {R}
    W = AbstractDivisionWorkspace{R}(A, size(B, 2))
    return lpdiv!(W, A, B)
end

function lpdiv!(W::DivisionWorkspace, A::MaybeAdjOrTransTri, B::AbstractVecOrMat)
    @assert size(A, 1) == size(B, 1)
    A, tA = unwrap(A)
    B, tB = unwrap(B)
    return div_impl!(B, W, A, tA, tB, Val(:L), Val(true))
end

# ================================ rpdiv! ===============================

# --- ChordalTriangular ---

function rpdiv!(B::AbstractMatrix{R}, A::MaybeAdjOrTransTri) where {R}
    W = AbstractDivisionWorkspace{R}(A, size(B, 1))
    return rpdiv!(W, B, A)
end

function rpdiv!(W::DivisionWorkspace, B::AbstractMatrix, A::MaybeAdjOrTransTri)
    @assert size(A, 1) == size(B, 2)
    A, tA = unwrap(A)
    B, tB = unwrap(B)
    return div_impl!(B, W, A, tA, tB, Val(:R), Val(true))
end

# ============================== div_impl! ==============================

function div_impl!(
        B::AbstractVecOrMat{R},
        W::DivisionWorkspace{R},
        L::ChordalTriangular{DIAG, UPLO, T, I},
        tA::Val{TA},
        tB::Val{TB},
        side::Val{SIDE},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, DIAG, UPLO, TA, TB, SIDE, PIV}
    return div_impl!(B, W.Mval, L, tA, tB, side, piv)
end

function div_impl!(
        B::AbstractVecOrMat{R},
        Mval::AbstractVector{R},
        L::ChordalTriangular{DIAG, UPLO, T, I},
        tA::Val{TA},
        tB::Val{TB},
        side::Val{SIDE},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, DIAG, UPLO, TA, TB, SIDE, PIV}
    return div_impl!(
        B, Mval,
        L.S.Dptr, L.Dval,
        L.S.Lptr, L.Lval,
        L.S.res, L.S.sep,
        tA, tB, L.uplo, side, L.diag, piv)
end

function div_impl!(
        B::AbstractVecOrMat{R},
        Mval::AbstractVector{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}

    if B isa AbstractVector
        nrhs = one(I)
    elseif SIDE === :L
        nrhs = convert(I, size(B, 2))
    else
        nrhs = convert(I, size(B, 1))
    end

    if isforward(UPLO, TA, SIDE)
        for j in vertices(res)
            div_fwd_loop!(B, Mval, Dptr, Dval, Lptr, Lval, res, sep, nrhs, j, tA, tB, uplo, side, diag, piv)
        end
    else
        for j in Iterators.reverse(vertices(res))
            div_bwd_loop!(B, Mval, Dptr, Dval, Lptr, Lval, res, sep, nrhs, j, tA, tB, uplo, side, diag, piv)
        end
    end

    return B
end

function div_fwd_loop!(
        C::AbstractVecOrMat{R},
        Mval::AbstractVector{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        nrhs::I,
        j::I,
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}

    nn = eltypedegree(res, j)

    if T <: Real && isone(nn)
        return div_fwd_loop_nod!(
            C, Dptr, Dval,
            Lptr, Lval,
            res, sep, nrhs, j, tA, tB, uplo, side, diag, piv
        )
    else
        return div_fwd_loop_snd!(
            C, Mval, Dptr, Dval,
            Lptr, Lval,
            res, sep, nrhs, nn, j, tA, tB, uplo, side, diag, piv
        )
    end
end

function div_fwd_loop_snd!(
        C::AbstractVecOrMat{R},
        Mval::AbstractVector{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        nrhs::I,
        nn::I,
        j::I,
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(sep, j)
    Dp = Dptr[j]
    Lp = Lptr[j]
    #
    # L is part of the factor
    #
    #          res(j)
    #     L = [ D₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # determine the rank of D₁₁
    #
    if PIV
        rank = one(I)

        @inbounds while rank ≤ nn && ispositive(D₁₁[rank, rank])
            rank += one(I)
        end

        rank -= one(I)
    else
        rank = nn
    end
    #
    # extract the full-rank submatrix of D₁₁:
    #
    #   D₁₁ = [ rD₁₁   ]
    #         [      0 ]
    #
    rD₁₁ = view(D₁₁, oneto(rank), oneto(rank))
    #
    # extract the full-rank submatrix of L₂₁:
    #
    #   L₂₁ = [ rL₂₁ 0 ]
    #
    if UPLO === :L
        rL₂₁ = view(L₂₁, oneto(na), oneto(rank))
    else
        rL₂₁ = view(L₂₁, oneto(rank), oneto(na))
    end
    #
    # C₁ is part of the right-hand side
    #
    #   C = [ C₁  ] res(j)
    #       [ C₂  ] sep(j)
    #
    #     = [ rC₁ ]
    #       [ nC₁ ]
    #       [  C₂ ]
    #
    if C isa AbstractVector
        C₁  = view(C, neighbors(res, j))
        rC₁ = view(C₁,      oneto(rank))
        nC₁ = view(C₁, rank + one(I):nn)
    elseif SIDE === :L
        C₁  = view(C,  neighbors(res, j), oneto(nrhs))
        rC₁ = view(C₁,  oneto(rank),      oneto(nrhs))
        nC₁ = view(C₁,  rank + one(I):nn, oneto(nrhs))
    else
        C₁  = view(C,  oneto(nrhs), neighbors(res, j))
        rC₁ = view(C₁, oneto(nrhs),       oneto(rank))
        nC₁ = view(C₁, oneto(nrhs),  rank + one(I):nn)
    end
    #
    #     nC₁ ← 0
    #
    PIV && zerorec!(nC₁)
    #
    #     rC₁ ← rD₁₁⁻¹ rC₁
    #
    if ispositive(rank)
        if C isa AbstractVector
            trsv!(uplo,       tA, diag,         rD₁₁, rC₁)
        else
            trsm!(side, uplo, tA, diag, one(R), rD₁₁, rC₁)
        end
    end

    if ispositive(na) && ispositive(rank)
        if C isa AbstractVector
            M₂ = view(Mval, oneto(na))
        elseif SIDE === :L
            M₂ = reshape(view(Mval, oneto(na * nrhs)), na, nrhs)
        else
            M₂ = reshape(view(Mval, oneto(na * nrhs)), nrhs, na)
        end
        #
        #     M₂ ← -rL₂₁ rC₁
        #
        if C isa AbstractVector
            if UPLO === :L
                gemv!(Val(:N), -one(R), rL₂₁, rC₁, zero(R), M₂)
            else
                gemv!(tA,      -one(R), rL₂₁, rC₁, zero(R), M₂)
            end
        elseif SIDE === :L
            if UPLO === :L
                gemm!(Val(:N), tB, -one(R), rL₂₁, rC₁, zero(R), M₂)
            else
                gemm!(tA, tB,      -one(R), rL₂₁, rC₁, zero(R), M₂)
            end
        else
            if UPLO === :L
                gemm!(tB, tA,      -one(R), rC₁, rL₂₁, zero(R), M₂)
            else
                gemm!(tB, Val(:N), -one(R), rC₁, rL₂₁, zero(R), M₂)
            end
        end
        #
        #     C₂ ← C₂ + M₂
        #
        if C isa AbstractVector
            addscatterrec!(C, M₂, neighbors(sep, j))
        else
            addscatterrec!(C, M₂, neighbors(sep, j), side)
        end
    end

    return
end

function div_fwd_loop_nod!(
        C::AbstractVecOrMat{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        nrhs::I,
        j::I,
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(sep, j)
    #
    # L is part of the factor:
    #
    #          res(j)
    #     L = [ d₁₁  ] res(j)
    #         [ l₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    Rp = pointers(res)[j]
    Sp = pointers(sep)[j]
    d₁₁ = Dval[Dp]
    #
    #     c₁ ←      d₁₁⁻¹ c₁
    #     c₂ ← c₂ - l₂₁   c₁
    #
    if C isa AbstractVector
        if PIV && !ispositive(d₁₁)
            c₁ = zero(R)
        else
            c₁ = C[Rp]

            if DIAG === :N
                c₁ /= d₁₁
            end
        end

        C[Rp] = c₁

        @inbounds for i in oneto(na)
            l =         Lval[Lp + i - one(I)]
            s = targets(sep)[Sp + i - one(I)]

            C[s] -= l * c₁
        end
    elseif SIDE === :L
        if PIV && !ispositive(d₁₁)
            @inbounds for k in oneto(nrhs)
                C[Rp, k] = zero(R)
            end
        elseif DIAG === :N
            @inbounds for k in oneto(nrhs)
                C[Rp, k] /= d₁₁
            end
        end

        @inbounds for i in oneto(na)
            l =         Lval[Lp + i - one(I)]
            s = targets(sep)[Sp + i - one(I)]

            for k in oneto(nrhs)
                C[s, k] -= l * C[Rp, k]
            end
        end
    else
        if PIV && !ispositive(d₁₁)
            @inbounds for k in oneto(nrhs)
                C[k, Rp] = zero(R)
            end
        elseif DIAG === :N
            @inbounds for k in oneto(nrhs)
                C[k, Rp] /= d₁₁
            end
        end

        @inbounds for i in oneto(na)
            l =         Lval[Lp + i - one(I)]
            s = targets(sep)[Sp + i - one(I)]

            for k in oneto(nrhs)
                C[k, s] -= l * C[k, Rp]
            end
        end
    end

    return
end

function div_bwd_loop!(
        C::AbstractVecOrMat{R},
        Mval::AbstractVector{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        nrhs::I,
        j::I,
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}
    nn = eltypedegree(res, j)

    if T <: Real && isone(nn)
        return div_bwd_loop_nod!(
            C, Dptr, Dval,
            Lptr, Lval,
            res, sep, nrhs, j, tA, tB, uplo, side, diag, piv
        )
    else
        return div_bwd_loop_snd!(
            C, Mval, Dptr, Dval,
            Lptr, Lval,
            res, sep, nrhs, nn, j, tA, tB, uplo, side, diag, piv
        )
    end
end

function div_bwd_loop_snd!(
        C::AbstractVecOrMat{R},
        Mval::AbstractVector{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        nrhs::I,
        nn::I,
        j::I,
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(sep, j)
    Dp = Dptr[j]
    Lp = Lptr[j]
    #
    # L is part of the factor
    #
    #          res(j)
    #     L = [ D₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # determine the rank of D₁₁
    #
    if PIV
        rank = one(I)

        @inbounds while rank ≤ nn && ispositive(D₁₁[rank, rank])
            rank += one(I)
        end

        rank -= one(I)
    else
        rank = nn
    end
    #
    # extract the full-rank submatrix of D₁₁:
    #
    #   D₁₁ = [ rD₁₁   ]
    #         [      0 ]
    #
    rD₁₁ = view(D₁₁, oneto(rank), oneto(rank))
    #
    # extract the full-rank submatrix of L₂₁:
    #
    #   L₂₁ = [ rL₂₁ 0 ]
    #
    if UPLO === :L
        rL₂₁ = view(L₂₁, oneto(na), oneto(rank))
    else
        rL₂₁ = view(L₂₁, oneto(rank), oneto(na))
    end
    #
    # C₁ is part of the right-hand side
    #
    #        nrhs
    #   C = [ C₁  ] res(j)
    #       [ C₂  ] sep(j)
    #
    #     = [ rC₁ ]
    #       [ nC₁ ]
    #       [  C₂ ]
    #
    if C isa AbstractVector
        C₁  = view(C,  neighbors(res, j))
        rC₁ = view(C₁,       oneto(rank))
        nC₁ = view(C₁,  rank + one(I):nn)
    elseif SIDE === :L
        C₁  = view(C,  neighbors(res, j), oneto(nrhs))
        rC₁ = view(C₁,  oneto(rank),      oneto(nrhs))
        nC₁ = view(C₁,  rank + one(I):nn, oneto(nrhs))
    else
        C₁  = view(C,  oneto(nrhs), neighbors(res, j))
        rC₁ = view(C₁, oneto(nrhs),       oneto(rank))
        nC₁ = view(C₁, oneto(nrhs),  rank + one(I):nn)
    end

    if ispositive(na) && ispositive(rank)
        if C isa AbstractVector
            M₂ = view(Mval, oneto(na))
        elseif SIDE === :L
            M₂ = reshape(view(Mval, oneto(na * nrhs)), na, nrhs)
        else
            M₂ = reshape(view(Mval, oneto(na * nrhs)), nrhs, na)
        end
        #
        #     M₂ ← C₂
        #
        if C isa AbstractVector
            copygatherrec!(M₂, C, neighbors(sep, j))
        else
            copygatherrec!(M₂, C, neighbors(sep, j), side)
        end
        #
        #     rC₁ ← rC₁ - rL₂₁ᴴ M₂
        #
        if C isa AbstractVector
            if UPLO === :L
                gemv!(tA,      -one(R), rL₂₁, M₂, one(R), rC₁)
            else
                gemv!(Val(:N), -one(R), rL₂₁, M₂, one(R), rC₁)
            end
        elseif SIDE === :L
            if UPLO === :L
                gemm!(tA,      Val(:N), -one(R), rL₂₁, M₂, one(R), rC₁)
            else
                gemm!(Val(:N), Val(:N), -one(R), rL₂₁, M₂, one(R), rC₁)
            end
        else
            if UPLO === :L
                gemm!(Val(:N), Val(:N), -one(R), M₂, rL₂₁, one(R), rC₁)
            else
                gemm!(Val(:N), tA,      -one(R), M₂, rL₂₁, one(R), rC₁)
            end
        end
    end
    #
    #     nC₁ ← 0
    #
    PIV && zerorec!(nC₁)
    #
    #     rC₁ ← rD₁₁⁻ᴴ rC₁
    #
    if ispositive(rank)
        if C isa AbstractVector
            trsv!(uplo,       tA, diag,         rD₁₁, rC₁)
        else
            trsm!(side, uplo, tA, diag, one(R), rD₁₁, rC₁)
        end
    end

    return
end

function div_bwd_loop_nod!(
        C::AbstractVecOrMat{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        nrhs::I,
        j::I,
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(sep, j)
    #
    # L is part of the factor:
    #
    #          res(j)
    #     L = [ d₁₁  ] res(j)
    #         [ l₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    Rp = pointers(res)[j]
    Sp = pointers(sep)[j]
    d₁₁ = Dval[Dp]
    #
    #     c₁ ←       c₁ - l₂₁ᴴ c₂
    #     c₁ ← d₁₁⁻¹ c₁
    #
    if C isa AbstractVector
        if PIV && !ispositive(d₁₁)
            C[Rp] = zero(R)
        else
            Δ = zero(R)

            @inbounds for i in oneto(na)
                l =         Lval[Lp + i - one(I)]
                s = targets(sep)[Sp + i - one(I)]

                Δ += l * C[s]
            end

            c₁ = C[Rp] - Δ

            if DIAG === :N
                c₁ /= d₁₁
            end

            C[Rp] = c₁
        end
    elseif SIDE === :L
        if PIV && !ispositive(d₁₁)
            @inbounds for k in oneto(nrhs)
                C[Rp, k] = zero(R)
            end
        else
            @inbounds for i in oneto(na)
                l =         Lval[Lp + i - one(I)]
                s = targets(sep)[Sp + i - one(I)]

                for k in oneto(nrhs)
                    C[Rp, k] -= l * C[s, k]
                end
            end

            if DIAG === :N
                @inbounds for k in oneto(nrhs)
                    C[Rp, k] /= d₁₁
                end
            end
        end
    else
        if PIV && !ispositive(d₁₁)
            @inbounds for k in oneto(nrhs)
                C[k, Rp] = zero(R)
            end
        else
            @inbounds for i in oneto(na)
                l =         Lval[Lp + i - one(I)]
                s = targets(sep)[Sp + i - one(I)]

                for k in oneto(nrhs)
                    C[k, Rp] -= l * C[k, s]
                end
            end

            if DIAG === :N
                @inbounds for k in oneto(nrhs)
                    C[k, Rp] /= d₁₁
                end
            end
        end
    end

    return
end

# ================================ ldiv!! ================================

# C is a workspace. Returns B.
function ldiv!!(C, F::AbstractFactorization, B)
    ldiv!(B, F.P, ldiv!(NaturalFactorization(F), mul!(C, F.P, B)))
end

# ================================ rdiv!! ================================

# C is a workspace. Returns B.
function rdiv!!(C, B, F::AbstractFactorization)
    mul!(B, rdiv!(rdiv!(C, B, F.P), NaturalFactorization(F)), F.P)
end

"""
    BipartiteGraph{V, E, Ptr, Tgt} <: AbstractGraph{V}

A directed bipartite multigraph G = (U, V, E).
"""
struct BipartiteGraph{V <: Integer, E <: Integer, Ptr <: AbstractVector{E}, Tgt <: AbstractVector{V}} <: AbstractGraph{V}
    """
    U is equal to the set

        U := {1, 2, ..., nov}

    """
    nov::V

    """
    V is equal to the set

        V := {1, 2, ..., nv}

    """
    nv::V

    """
    E is equal to the set

        E := {1, 2, ..., ne}

    """
    ne::E

    """
    Each vertex v ∈ V is the source of the arcs

        {ptr[v], ptr[v] + 1, ..., ptr[v + 1] - 1} ⊆ E

    """
    ptr::Ptr

    """
    Each arc e ∈ E has target vertex

        tgt[e] ∈ V

    """
    tgt::Tgt

    function BipartiteGraph{V, E, Ptr, Tgt}(
            nov::Integer,
            nv::Integer,
            ne::Integer,
            ptr::AbstractVector,
            tgt::AbstractVector,
        ) where {V <: Integer, E <: Integer, Ptr <: AbstractVector{E}, Tgt <: AbstractVector{V}}
        @assert !isnegative(nov)
        @assert !isnegative(nv)
        @assert !isnegative(ne)
        @assert nv < length(ptr)
        @assert ne <= length(tgt)
        return new{V, E, Ptr, Tgt}(nov, nv, ne, ptr, tgt)
    end
end

"""
    const FBipartiteGraph{V, E} = BipartiteGraph{V, E, FVector{E}, FVector{V}}
"""
const FBipartiteGraph{V, E} = BipartiteGraph{V, E, FVector{E}, FVector{V}}

function BipartiteGraph{V, E, Ptr, Tgt}(graph::BipartiteGraph) where {V, E, Ptr, Tgt}
    return BipartiteGraph{V, E, Ptr, Tgt}(nov(graph), nv(graph), ne(graph), pointers(graph), targets(graph))
end

function BipartiteGraph{V, E, Ptr, Tgt}(nov::Integer, nv::Integer, ne::Integer) where {V, E, Ptr, Tgt}
    ptr = Ptr(undef, nv + one(nv))
    tgt = Tgt(undef, ne)
    graph = BipartiteGraph{V, E, Ptr, Tgt}(nov, nv, ne, ptr, tgt)
    return graph
end

function BipartiteGraph{V, E, Ptr, OneTo{V}}(nov::Integer, nv::Integer, ne::Integer) where {V, E, Ptr}
    ptr = Ptr(undef, nv + one(nv))
    tgt = OneTo{V}(ne)
    graph = BipartiteGraph{V, E, Ptr, OneTo{V}}(nov, nv, ne, ptr, tgt)
    return graph
end

function BipartiteGraph{V, E}(nov::Integer, nv::Integer, ne::Integer, ptr::AbstractVector, tgt::AbstractVector) where {V, E}
    graph = BipartiteGraph(
        convert(V, nov),
        convert(V, nv),
        convert(E, ne),
        convert(AbstractVector{E}, ptr),
        convert(AbstractVector{V}, tgt),
    )

    return graph
end

function BipartiteGraph{V, E}(nov::Integer, nv::Integer, ne::Integer) where {V, E}
    return BipartiteGraph{V, E, FVector{E}, FVector{V}}(nov, nv, ne)
end

function BipartiteGraph{V, E}(graph::AbstractGraph) where {V, E}
    n = convert(V, nv(graph)); nn = n + one(V)
    m = convert(E, de(graph))
    ptr = FVector{E}(undef, nn)
    tgt = FVector{V}(undef, m)
    ptr[begin] = p = one(E)

    @inbounds for j in vertices(graph)
        jj = convert(V, j)

        for i in neighbors(graph, jj)
            ii = convert(V, i)
            tgt[p] = ii; p += one(E)
        end

        jj += one(V); ptr[jj] = p
    end

    return BipartiteGraph{V, E}(n, n, p - one(E), ptr, tgt)
end

function BipartiteGraph{V, E}(graph::BipartiteGraph) where {V, E}
    graph = BipartiteGraph{V, E}(
        nov(graph),
        nv(graph),
        ne(graph),
        pointers(graph),
        targets(graph),
    )

    return graph
end

function BipartiteGraph{V, E}(matrix::SparseMatrixCSC) where {V, E}
    graph = BipartiteGraph{V, E}(
        size(matrix)...,
        nnz(matrix),
        getcolptr(matrix),
        rowvals(matrix),
    )

    return graph
end

function BipartiteGraph{V, E}(matrix::AbstractMatrix) where {V, E}
    graph = BipartiteGraph{V, E}(sparse(matrix))
    return graph
end

function BipartiteGraph(
        nov::V,
        nv::V,
        ne::E,
        ptr::Ptr,
        tgt::Tgt,
    ) where {V <: Integer, E <: Integer, Ptr <: AbstractVector{E}, Tgt <: AbstractVector{V}}
    return BipartiteGraph{V, E, Ptr, Tgt}(nov, nv, ne, ptr, tgt)
end

function BipartiteGraph(graph::AbstractGraph{V}) where {V}
    E = etype(graph)
    return BipartiteGraph{V, E}(graph)
end

function BipartiteGraph(matrix::SparseMatrixCSC{<:Any, I}) where {I}
    return BipartiteGraph{I, I}(matrix)
end

function BipartiteGraph(matrix::AbstractMatrix)
    return BipartiteGraph(sparse(matrix))
end

function Base.Matrix{T}(graph::BipartiteGraph) where {T}
    return Matrix(sparse(T, graph))
end

function Base.Matrix(graph::BipartiteGraph)
    return Matrix(sparse(graph))
end

function SparseArrays.SparseMatrixCSC{T, I}(graph::BipartiteGraph) where {T, I}
    colptr = convert(Vector{I}, pointers(graph))
    rowval = convert(Vector{I}, targets(graph))
    nzval = Vector{T}(undef, ne(graph))
    return SparseMatrixCSC{T, I}(nov(graph), nv(graph), colptr, rowval, nzval)
end

function SparseArrays.SparseMatrixCSC{T}(graph::BipartiteGraph{V, E}) where {T, V, E}
    I = promote_type(V, E)
    return SparseMatrixCSC{T, I}(graph)
end

function SparseArrays.SparseMatrixCSC(graph::BipartiteGraph)
    return SparseMatrixCSC{Bool}(graph)
end

function SparseArrays.sparse(::Type{T}, ::Type{I}, graph::BipartiteGraph) where {T, I}
    graph = reverse(reverse(graph))
    matrix = SparseMatrixCSC{T, I}(graph)
    fill!(nonzeros(matrix), 1)
    return matrix
end

function SparseArrays.sparse(::Type{T}, graph::BipartiteGraph{V, E}) where {T, V, E}
    I = promote_type(V, E)
    return sparse(T, I, graph)
end

function SparseArrays.sparse(graph::BipartiteGraph)
    return sparse(Bool, graph)
end

function SparseArrays.permute(graph::BipartiteGraph{V, E}, order::AbstractVector, index::AbstractVector) where {V, E}
    m = de(graph); n = nv(graph)
    pointer = FVector{E}(undef, n + one(V))
    target = FVector{V}(undef, m)
    return permute_impl!(pointer, target, graph, order, index)
end

function SparseArrays.permute!(graph::BipartiteGraph{V, E}, order::AbstractVector, index::AbstractVector) where {V, E}
    copy!(graph, permute(graph, order, index))
    return graph
end

function permute_impl!(
        pointer::AbstractVector{E},
        target::AbstractVector{V},
        graph::AbstractGraph{V},
        order::AbstractVector,
        index::AbstractVector,
    ) where {V, E}
    @assert nv(graph) < length(pointer)
    @assert de(graph) <= length(target)
    @assert nv(graph) <= length(order)
    @assert nov(graph) <= length(index)

    @inbounds pointer[one(V)] = p = one(E)

    @inbounds for i in vertices(graph)
        for w in neighbors(graph, order[i])
            target[p] = index[w]; p += one(V)
        end 

        pointer[i + one(V)] = p 
    end

    h = nov(graph); n = nv(graph); m = p - one(E)
    return BipartiteGraph(h, n, m, pointer, target)
end

# Direct Methods for Sparse Linear Systems §2.11
# Davis
# cs_symperm
#
# Permute the vertices of a graph and orient the edges from lower to higher.
# The complexity is O(m), where m = |E|.
function sympermute(graph::AbstractGraph{V}, index::AbstractVector, order::Ordering) where {V}
    E = etype(graph); m = half(de(graph)); n = nv(graph); nn = n + one(V)
    pointer = FVector{E}(undef, nn)
    target = FVector{V}(undef, m)
    return sympermute!_impl!(pointer, target, graph, index, order)
end

function sympermute!_impl!(
        target::BipartiteGraph{V, E},
        source::AbstractGraph{V},
        index::AbstractVector{V},
        order::Ordering
    ) where {V, E}
    sympermute!_impl!(pointers(target), targets(target), source, index, order)
    return target
end

function sympermute!_impl!(
        pointer::AbstractVector{E},
        target::AbstractVector{V},
        source::AbstractGraph,
        index::AbstractVector,
        order::Ordering,
    ) where {V, E}
    @assert nv(source) < length(pointer)
    @assert nv(source) <= length(index)
    @assert half(de(source)) <= length(target)
    n = nv(source)

    @inbounds for i in oneto(n)
        pointer[i + one(V)] = zero(E)
    end

    @inbounds for j in vertices(source)
        jj = index[j]

        for i in neighbors(source, j)
            if lt(order, i, j)
                ii, kk = index[i], jj

                if lt(order, kk, ii)
                    kk = ii
                end

                if kk < n
                    pointer[kk + two(V)] += one(E)
                end
            end
        end
    end

    @inbounds pointer[one(V)] = p = one(E)

    @inbounds for i in oneto(n)
        pointer[i + one(V)] = p += pointer[i + one(V)]
    end

    @inbounds for j in vertices(source)
        jj = index[j]

        for i in neighbors(source, j)
            if lt(order, i, j)
                ii, kk = index[i], jj

                if lt(order, kk, ii)
                    ii, kk = kk, ii
                end

                target[pointer[kk + one(V)]] = ii
                pointer[kk + one(V)] += one(E)
            end
        end
    end

    @inbounds m = pointer[n + one(V)] - one(E)
    return BipartiteGraph(n, n, m, pointer, target)
end

# Compute the transpose of a graph.
# The transposed graph has sorted adjacency lists.
function Base.reverse(graph::BipartiteGraph{V, E}) where {V, E}
    result = BipartiteGraph{V, E}(nv(graph), nov(graph), ne(graph))
    return reverse!(result, graph)
end

function Base.reverse!(result::BipartiteGraph{V, E}, graph::AbstractGraph{V}) where {V, E}
    n = nov(graph)
    reverse!_impl!(result, graph)
    return result
end

function reverse!_impl!(
        target::BipartiteGraph{V, E},
        source::AbstractGraph{V},
    ) where {V, E}
    @assert nov(target) == nv(source)
    @assert nov(source) == nv(target)
    @assert de(source) == de(target)
    reverse!_impl!(pointers(target), targets(target), source)
    return target
end

function reverse!_impl!(
        pointer::AbstractVector{E},
        target::AbstractVector{V},
        graph::AbstractGraph{V},
    ) where {V, E}
    @assert nov(graph) < length(pointer)
    @assert de(graph) <= length(target)
    h = nov(graph); n = nv(graph); m = de(graph)
    
    @inbounds for i in outvertices(graph)
        pointer[i + one(V)] = zero(E)
    end

    @inbounds for j in vertices(graph), i in neighbors(graph, j)
        if i < h
            pointer[i + two(V)] += one(E)
        end
    end

    @inbounds pointer[one(V)] = p = one(E)

    @inbounds for i in outvertices(graph)
        pointer[i + one(V)] = p += pointer[i + one(V)]
    end

    @inbounds for j in vertices(graph), i in neighbors(graph, j)
        target[pointer[i + one(V)]] = j
        pointer[i + one(V)] += one(E)
    end

    return BipartiteGraph(n, h, m, pointer, target)
end

function simplegraph!(ptr::AbstractVector{E}, tgt::AbstractVector{V}, graph::AbstractGraph) where {V, E}
    @assert length(ptr) > nv(graph)
    @assert length(tgt) ≥ de(graph)

    n = convert(V, nv(graph))
    m = convert(E, de(graph))

    p = zero(E)

    @inbounds for j in vertices(graph)
        ptr[j] = p + one(E)

        for i in neighbors(graph, j)
            if i != j
                p += one(E); tgt[p] = i
            end
        end
    end

    ptr[n + one(V)] = p + one(E)
    return BipartiteGraph{V, E}(n, n, p, ptr, tgt)
end

function simplegraph(::Type{V}, ::Type{E}, graph) where {V, E}
    return simplegraph(V, E, BipartiteGraph(graph))
end

function simplegraph(::Type{V}, ::Type{E}, graph::AbstractGraph{W}) where {W, V, E}
    ptr = FVector{E}(undef, nv(graph) + one(W))
    tgt = FVector{V}(undef, de(graph))
    return simplegraph!(ptr, tgt, graph)
end

function simplegraph(graph)
    return simplegraph(BipartiteGraph(graph))
end

function simplegraph(graph::AbstractGraph{V}) where {V}
    E = etype(graph)
    return simplegraph(V, E, graph)
end

function linegraph(ve::AbstractGraph{V}, ev::AbstractGraph{V}) where {V}
    @assert nv(ve) == nov(ev)
    @assert nv(ev) == nov(ve)
    @assert ne(ve) == ne(ev)

    E = etype(ve); n = nv(ve); m = zero(E)
    marker = FVector{V}(undef, n)

    @inbounds for v in vertices(ve)
        marker[v] = zero(V)
    end

    @inbounds for v in vertices(ve)
        tag = v

        for w in neighbors(ve, v), x in neighbors(ev, w)
            if v != x && marker[x] < tag
                marker[x] = tag
                m += one(E)
            end
        end
    end

    target = FVector{E}(undef, m)
    pointer = FVector{V}(undef, n + one(V))
    @inbounds pointer[one(V)] = p = one(E) 

    @inbounds for v in vertices(ve)
        tag = n + v

        for w in neighbors(ve, v), x in neighbors(ev, w)
            if v != x && marker[x] < tag
                marker[x] = tag
                target[p] = x; p += one(E)
            end
        end

        pointer[v + one(V)] = p
    end

    return BipartiteGraph{V, E}(n, n, m, pointer, target)   
end

function symmetric(graph)
    return symmetric(BipartiteGraph(graph))
end

function symmetric(graph::AbstractGraph{V}) where {V}
    E = etype(graph)

    fwd = graph; bwd = reverse(fwd)

    n = nv(fwd)
    m = ne(fwd) + ne(bwd)

    mrk = FVector{V}(undef, n)
    ptr = FVector{E}(undef, n + one(V))
    tgt = FVector{V}(undef, m)

    for v in vertices(fwd)
        mrk[v] = zero(V)
    end

    p = zero(E)

    for v in vertices(fwd)
        mrk[v] = v
        ptr[v] = p + one(E)

        for w in neighbors(fwd, v)
            if mrk[w] < v
                mrk[w] = v
                p += one(E); tgt[p] = w
            end
        end

        for w in neighbors(bwd, v)
            if mrk[w] < v
                mrk[w] = v
                p += one(E); tgt[p] = w
            end
        end
    end

    ptr[n + one(V)] = p + one(E)
    return BipartiteGraph{V, E}(n, n, m, ptr, tgt)
end

function pointers(graph::BipartiteGraph)
    return graph.ptr
end

function targets(graph::BipartiteGraph)
    return graph.tgt
end

@propagate_inbounds function incident(graph::BipartiteGraph{V}, i::Integer) where {V <: Integer}
    @boundscheck checkbounds(vertices(graph), i)
    range = @inbounds incident(graph, convert(V, i))
    return range
end

@propagate_inbounds function incident(graph::BipartiteGraph{V, E}, i::V) where {V <: Integer, E <: Integer}
    @boundscheck checkbounds(vertices(graph), i)
    @inbounds pstrt = pointers(graph)[i]
    @inbounds pstop = pointers(graph)[i + one(V)]
    return pstrt:pstop - one(E)
end

function Base.convert(::Type{BipartiteGraph{V, E, Ptr, Tgt}}, graph) where {V, E, Ptr, Tgt}
    return BipartiteGraph{V, E, Ptr, Tgt}(graph)
end

function Base.convert(::Type{BipartiteGraph{V, E, Ptr, Tgt}}, graph::BipartiteGraph{V, E, Ptr, Tgt}) where {V, E, Ptr, Tgt}
    return graph
end

function Base.show(io::IO, ::MIME"text/plain", graph::G) where {G <: BipartiteGraph}
    h = nov(graph)
    n = nv(graph)
    m = ne(graph)
    return println(io, "{$h, $n, $m} $G")
end

function Base.:(==)(left::BipartiteGraph, right::BipartiteGraph)
    if nov(left) != nov(right)
        return false
    end

    if nv(left) != nv(right)
        return false
    end

    if ne(left) != ne(right)
        return false
    end

    for v in vertices(left)
        if neighbors(left, v) != neighbors(right, v)
            return false
        end
    end

    return true
end

function Base.copy(graph::BipartiteGraph)
    return BipartiteGraph(
        nov(graph),
        nv(graph),
        ne(graph),
        copy(pointers(graph)),
        copy(targets(graph)),
    )
end

function Base.copy!(dst::BipartiteGraph{V, E}, src::BipartiteGraph) where {V, E}
    @assert nov(dst) == nov(src)
    @assert nv(dst) == nv(src)
    @assert ne(dst) == ne(src)
    copyto!(pointers(dst), one(V), pointers(src), one(V), nv(src) + one(V))
    copyto!(targets(dst), one(E), targets(src), one(E), ne(src))
    return dst
end

function Base.copy!(dst::BipartiteGraph{V, E, Ptr, OneTo{V}}, src::BipartiteGraph) where {V <: Integer, E <: Integer, Ptr <: AbstractVector{E}}
    @assert nov(dst) == nov(src)
    @assert nv(dst) == nv(src)
    @assert ne(dst) == ne(src)
    @assert targets(dst) == targets(src)
    copyto!(pointers(dst), one(V), pointers(src), one(V), nv(src) + one(V))
    return dst
end

#############################
# Bipartite Graph Interface #
#############################

function nov(graph::BipartiteGraph)
    return graph.nov
end

function nov(graph::AbstractGraph)
    return nv(graph)
end

function outvertices(graph::AbstractGraph)
    return oneto(nov(graph))
end

function arcs(graph::AbstractGraph)
    return oneto(ne(graph))
end

function etype(::G) where {G}
    return etype(G)
end

function etype(::Type)
    return Int
end

function etype(::Type{<:BipartiteGraph{<:Any, E}}) where {E}
    return E
end

############################
# Abstract Graph Interface #
############################

function Base.zero(::Type{BipartiteGraph{V, E, Ptr, Tgt}}) where {V, E, Ptr, Tgt}
    return BipartiteGraph{V, E, Ptr, Tgt}(
        zero(V),
        zero(V),
        zero(E),
        oneto(one(E)),
        oneto(zero(V)),
    )
end

function Graphs.is_directed(::Type{<:BipartiteGraph})
    return true
end

function Graphs.nv(graph::BipartiteGraph)
    return graph.nv
end

function Graphs.ne(graph::BipartiteGraph)
    return graph.ne
end

# slow
function Graphs.has_edge(graph::BipartiteGraph, i::Integer, j::Integer)
    return j in neighbors(graph, i)
end

function Graphs.vertices(graph::BipartiteGraph{V}) where {V}
    return oneto(nv(graph))
end

@propagate_inbounds function Graphs.outneighbors(graph::BipartiteGraph, i::Integer)
    @boundscheck checkbounds(vertices(graph), i)
    @inbounds neighbors = view(targets(graph), incident(graph, i))
    return neighbors
end

# slow
function Graphs.inneighbors(graph::BipartiteGraph, i::Integer)
    return Iterators.filter(vertices(graph)) do j
        has_edge(graph, j, i)
    end
end

@propagate_inbounds function Graphs.outdegree(graph::BipartiteGraph, i::Integer)
    @boundscheck checkbounds(vertices(graph), i)
    @inbounds degree = length(incident(graph, i))
    return degree 
end

# slow
function Graphs.indegree(graph::BipartiteGraph{V}, i::Integer) where {V}
    n::Int = sum(j -> has_edge(graph, j, i), vertices(graph))
    return n
end

function Graphs.Δout(graph::BipartiteGraph)
    return maximum(vertices(graph); init = 0) do i
        outdegree(graph, i)
    end
end

"""
    DynamicRegularization{T} <: AbstractRegularization

The simplest dynamic regularization strategy. Small pivots are replaced with
a fixed number ``\\delta``.

### Example

```julia-repl
julia> using CliqueTrees.Multifrontal, LinearAlgebra

julia> A = [
           1 1 2
           1 1 3
           2 3 1
       ];

julia> isposdef(A)
false

julia> F = cholesky!(ChordalCholesky(A); reg=DynamicRegularization());

julia> B = Matrix(F)
3×3 Matrix{Float64}:
 1.0  1.0      2.0
 1.0  1.00001  3.0
 2.0  3.0      1.65144e5

julia> isposdef(B)
true
```

### Fields

- `delta`: minimum pivot
- `epsilon`: pivot tolerance
"""
struct DynamicRegularization{T} <: AbstractRegularization
    delta::T
    epsilon::T
end

function DynamicRegularization{T}(; delta=-one(T), epsilon=-one(T)) where {T}
    return DynamicRegularization{T}(delta, epsilon)
end

function DynamicRegularization(; kw...)
    return DynamicRegularization{Float64}(; kw...)
end

function initialize(::AbstractMatrix{T}, S::AbstractVector, R::DynamicRegularization) where {T}
    if isnegative(R.delta)
        delta = dynm_delta(real(T))
    else
        delta = convert(real(T), R.delta)
    end

    if isnegative(R.epsilon)
        epsilon = dynm_epsilon(real(T))
    else
        epsilon = convert(real(T), R.epsilon)
    end

    return DynamicRegularization{real(T)}(delta, epsilon)
end

function dynm_delta(::Type{T}) where {T}
    return cbrt(eps(real(T)))
end

function dynm_epsilon(::Type{T}) where {T}
    return sqrt(eps(real(T)))
end

function regularize(R::DynamicRegularization, S::AbstractVector, Djj, j::Integer)
    if real(S[j]) * Djj < R.epsilon
        return R.delta * real(S[j])
    else
        return Djj
    end
end

# Fast path for nn = 1: D is scalar, L is vector (l is ignored)
function regularize(R::DynamicRegularization, s, Djj, ::AbstractVector)
    if real(s) * Djj < R.epsilon
        return R.delta * real(s)
    else
        return Djj
    end
end

module MooncakeExt

using CliqueTrees.Multifrontal: ChordalCholesky, HermOrSymSparse, HermSparse, SymSparse, project
using CliqueTrees.Multifrontal.Differential: selinv
using CliqueTrees.Multifrontal.Differential: logdet_frule_impl, logdet_rrule_impl!, logdet_rrule_frule_impl!
using CliqueTrees.Multifrontal.Differential: selinv_frule_impl, selinv_rrule_impl!
using CliqueTrees.Multifrontal.Differential: ldiv_frule_impl!, ldiv_rrule_impl!, rdiv_frule_impl!, rdiv_rrule_impl!
using Base: AbstractVecOrMat
using LinearAlgebra: Hermitian, Symmetric, HermOrSym, logdet, ldiv!, rdiv!
using SparseArrays: SparseMatrixCSC, nonzeros
using Mooncake
using Mooncake: @is_primitive, CoDual, Dual, FData, MinimalCtx, NoFData, NoRData, NoTangent, Tangent, primal, tangent, build_tangent, fdata
using Mooncake: FriendlyTangentCache, AsRaw

function Mooncake.tangent_type(::Type{<:ChordalCholesky})
    return NoTangent
end

function Mooncake.friendly_tangent_cache(::ChordalCholesky)
    return FriendlyTangentCache{AsRaw}(nothing)
end

include("utils.jl")
include("logdet.jl")
include("selinv.jl")
include("ldiv.jl")

end

"""
    EliminationAlgorithm

A *graph elimination algorithm* computes a total ordering of the vertices of a graph. 
The algorithms implemented in CliqueTrees.jl can be divided into five categories.

  - triangulation recognition algorithms
  - bandwidth minimization algorithms
  - local algorithms
  - global algorithms
  - exact treewidth algorithms

# Triangulation Recognition Algorithms

| type             | name                                         | time     | space    | package |
|:-----------------|:-------------------------------------------- |:-------- |:-------- | :------ |
| [`MCS`](@ref)    | maximum cardinality search                   | O(m + n) | O(n)     |         |
| [`LexBFS`](@ref) | lexicographic breadth-first search           | O(m + n) | O(m + n) |         |
| [`MCSM`](@ref)   | maximum cardinality search (minimal)         | O(mn)    | O(n)     |         |
| [`LexM`](@ref)   | lexicographic breadth-first search (minimal) | O(mn)    | O(n)     |         |

These algorithms will compute perfect orderings when applied to chordal graphs.

# Bandwidth Minimization Algorithms

| type            | name                                   | time     | space    | package |
|:----------------|:---------------------------------------|:-------- |:-------- | :------ |
| [`RCMMD`](@ref) | reverse Cuthill-Mckee (minimum degree) | O(m + n) | O(m + n) |         | 
| [`RCMGL`](@ref) | reverse Cuthill-Mckee (George-Liu)     | O(m + n) | O(m + n) |         |

These algorithms try to minimize the *bandwidth* and *envelope* of the ordered graph.

# Local Algorithms

| type             | name                              | time   | space    | package                                                   |
|:-----------------|:----------------------------------|:-------|:-------- | :-------------------------------------------------------- |
| [`MMD`](@ref)    | multiple minimum degree           | O(mn²) | O(m + n) |                                                           |
| [`MF`](@ref)     | minimum fill                      | O(mn²) |          |                                                           |
| [`AMD`](@ref)    | approximate minimum degree        | O(mn)  | O(m + n) | [AMD.jl](https://github.com/JuliaSmoothOptimizers/AMD.jl) |
| [`SymAMD`](@ref) | column approximate minimum degree | O(mn)  | O(m + n) | [AMD.jl](https://github.com/JuliaSmoothOptimizers/AMD.jl) |
| [`AMF`](@ref)    | approximate minimum fill          | O(mn)  | O(m + n) |                                                           |

These algorithms simulate the graph elimination process, greedily eliminating
vertices that minimize a cost function. They are faster then the global
algorithms, but have worse results.

# Global Algorithms

| type             | name              | time   | space | package                                             |
|:-----------------|:------------------|:-------|:----- | :-------------------------------------------------- |
| [`METIS`](@ref)  | nested dissection |        |       | [Metis.jl](https://github.com/JuliaSparse/Metis.jl) |
| [`ND`](@ref)     | nested dissection |        |       |                                                     |

These algorithms recursively partition a graph, then call a local algorithm on the leaves.
These are slower than the local algorithms, but have better results.

# Exact Treewidth Algorithms

| type          | name              | time  | space | package                                                                 |
|:--------------|:------------------|:------|:------| :---------------------------------------------------------------------- |
| [`BT`](@ref)  | Bouchitte-Todinca |       |       | [TreeWidthSolver.jl](https://github.com/ArrogantGao/TreeWidthSolver.jl) |

The orderings computed by these algorithms induce minimum-width tree decompositions.

!!! warning
    Exact treewidth is an NP-hard problem.
"""
abstract type EliminationAlgorithm end

"""
    MinimalAlgorithm <: EliminationAlgorithm
"""
abstract type MinimalAlgorithm <: EliminationAlgorithm end

"""
    PermutationOrAlgorithm = Union{
        AbstractVector,
        Tuple{AbstractVector, AbstractVector},
        EliminationAlgorithm,
    }

Either a permutation or an algorithm.
"""
const PermutationOrAlgorithm = Union{
    AbstractVector,
    Tuple{AbstractVector, AbstractVector},
    EliminationAlgorithm,
}

"""
    BFS <: EliminationAlgorithm

    BFS()

The [breadth-first search algorithm](https://en.wikipedia.org/wiki/Breadth-first_search).
"""
struct BFS <: EliminationAlgorithm end

"""
    MCS <: EliminationAlgorithm

    MCS()

The maximum cardinality search algorithm.

### References

  - Tarjan, Robert E., and Mihalis Yannakakis. "Simple linear-time algorithms to test chordality of graphs, test acyclicity of hypergraphs, and selectively reduce acyclic hypergraphs." *SIAM Journal on Computing* 13.3 (1984): 566-579.
"""
struct MCS <: EliminationAlgorithm end

"""
    LexBFS <: EliminationAlgorithm

    LexBFS()

The [lexicographic breadth-first-search algorithm](https://en.wikipedia.org/wiki/Lexicographic_breadth-first_search).

### References

  - Rose, Donald J., R. Endre Tarjan, and George S. Lueker. "Algorithmic aspects of vertex elimination on graphs." *SIAM Journal on Computing* 5.2 (1976): 266-283.
"""
struct LexBFS <: EliminationAlgorithm end

"""
    RCMMD{A} <: EliminationAlgorithm

    RCMMD(alg::Algorithm)

    RCMMD()

The [reverse Cuthill-McKee algorithm](https://en.wikipedia.org/wiki/Cuthill%E2%80%93McKee_algorithm).
An initial vertex is selected using the minimum degree heuristic.

### Parameters

  - `alg`: sorting algorithm

### References

  - Cuthill, Elizabeth, and James McKee. "Reducing the bandwidth of sparse symmetric matrices." *Proceedings of the 1969 24th National Conference.* 1969.
"""
struct RCMMD{A <: SortingAlgorithm} <: EliminationAlgorithm
    alg::A
end

function RCMMD()
    return RCMMD(DEFAULT_UNSTABLE)
end

"""
    RCMGL{A} <: EliminationAlgorithm

    RCMGL(alg::Algorithm)

    RCMGL()

The [reverse Cuthill-McKee algorithm](https://en.wikipedia.org/wiki/Cuthill%E2%80%93McKee_algorithm).
An initial vertex is selected using George and Liu's variant of the GPS algorithm.

### Parameters

  - `alg`: sorting algorithm

### References

  - Cuthill, Elizabeth, and James McKee. "Reducing the bandwidth of sparse symmetric matrices." *Proceedings of the 1969 24th National Conference.* 1969.
  - George, Alan, and Joseph WH Liu. "An implementation of a pseudoperipheral node finder." *ACM Transactions on Mathematical Software (TOMS)* 5.3 (1979): 284-295.
"""
struct RCMGL{A <: SortingAlgorithm} <: EliminationAlgorithm
    alg::A
end

function RCMGL()
    return RCMGL(DEFAULT_UNSTABLE)
end

"""
    LexM <: EliminationAlgorithm

    LexM()

A minimal variant of the [lexicographic breadth-first-search algorithm](https://en.wikipedia.org/wiki/Lexicographic_breadth-first_search).

### References

  - Rose, Donald J., R. Endre Tarjan, and George S. Lueker. "Algorithmic aspects of vertex elimination on graphs." *SIAM Journal on Computing* 5.2 (1976): 266-283.
"""
struct LexM <: MinimalAlgorithm end

"""
    MCSM <: EliminationAlgorithm

    MCSM()

A minimal variant of the maximal cardinality search algorithm.

### References

  - Berry, Anne, et al. "Maximum cardinality search for computing minimal triangulations of graphs." *Algorithmica* 39 (2004): 287-298.
"""
struct MCSM <: MinimalAlgorithm end

"""
    AMF <: EliminationAlgorithm

    AMF()

The approximate minimum fill algorithm.

### References

  - Rothberg, Edward, and Stanley C. Eisenstat. "Node selection strategies for bottom-up sparse matrix ordering." SIAM Journal on Matrix Analysis and Applications 19.3 (1998): 682-695.
"""
struct AMF <: EliminationAlgorithm end

"""
    MF <: EliminationAlgorithm

    MF()

The greedy minimum fill algorithm.

### References

  - Ng, Esmond G., and Barry W. Peyton. "Fast implementation of the minimum local fill ordering heuristic." *CSC14: The Sixth SIAM Workshop on Combinatorial Scientific Computing.* 2014.
"""
struct MF <: EliminationAlgorithm end

"""
    MMD <: EliminationAlgorithm

    MMD(; delta=0)

The [multiple minimum degree algorithm](https://en.wikipedia.org/wiki/Minimum_degree_algorithm).

### Parameters

  - `delta`: tolerance for multiple elimination

### References

  - Liu, Joseph WH. "Modification of the minimum-degree algorithm by multiple elimination." *ACM Transactions on Mathematical Software (TOMS)* 11.2 (1985): 141-153.
"""
@kwdef struct MMD <: EliminationAlgorithm
    delta::Int = 0
end

"""
    AMD <: EliminationAlgorithm

    AMD(; dense=10.0, aggressive=1.0)

The approximate minimum degree algorithm.

### Parameters

  - `dense`: dense row parameter
  - `aggressive`: aggressive absorption

### References

  - Amestoy, Patrick R., Timothy A. Davis, and Iain S. Duff. "An approximate minimum degree ordering algorithm." *SIAM Journal on Matrix Analysis and Applications* 17.4 (1996): 886-905.
"""
@kwdef struct AMD <: EliminationAlgorithm
    dense::Float64 = 10.0
    aggressive::Float64 = 1.0
end

"""
    SymAMD <: EliminationAlgorithm

    SymAMD(; dense_row=10.0, dense_col=10.0, aggressive=1.0)

The column approximate minimum degree algorithm.

### Parameters

  - `dense_row`: dense row parameter
  - `dense_column`: dense column parameter
  - `aggressive`: aggressive absorption

### References

  - Davis, Timothy A., et al. "A column approximate minimum degree ordering algorithm." *ACM Transactions on Mathematical Software* (TOMS) 30.3 (2004): 353-376.
"""
@kwdef struct SymAMD <: EliminationAlgorithm
    dense_row::Float64 = 10.0
    dense_col::Float64 = 10.0
    aggressive::Float64 = 1.0
end

"""
    METIS <: EliminationAlgorithm

    METIS(; ctype=-1, rtype=-1, nseps=-1, niter=-1, seed=-1,
            compress=-1, ccorder=-1, pfactor=-1, ufactor=-1)

The multilevel [nested dissection](https://en.wikipedia.org/wiki/Nested_dissection) algorithm implemented in METIS.

### Parameters

  - `ctype`: matching scheme to be used during coarsening
  - `rtype`: algorithm used for refinement
  - `nseps`: number of different separators computed at each level of nested dissection
  - `niter`: number of iterations for refinement algorithm at each stage of the uncoarsening process
  - `seed`: random seed
  - `compress`: whether to combine vertices with identical adjacency lists
  - `ccorder`: whether to order connected components separately
  - `pfactor`: minimum degree of vertices that will be ordered last
  - `ufactor`: maximum allowed load imbalance partitions

### References

  - Karypis, George, and Vipin Kumar. "A fast and high quality multilevel scheme for partitioning irregular graphs." *SIAM Journal on Scientific Computing* 20.1 (1998): 359-392.
"""
@kwdef struct METIS <: EliminationAlgorithm
    ctype::Int = -1
    rtype::Int = -1
    nseps::Int = -1
    niter::Int = -1
    seed::Int = -1
    compress::Int = -1
    ccorder::Int = -1
    pfactor::Int = -1
    ufactor::Int = -1
end

"""
    ND{S, A, D} <: EliminationAlgorithm

    ND{S}(alg::EliminationAlgorithm, dis::DissectionAlgorithm;
        width = 120,
        level = 6,
        imbalance = 130,
    )

The [nested dissection algorithm](https://en.wikipedia.org/wiki/Nested_dissection).
The algorithm `dis` is used to compute vertex separators, and the algorithm `alg` is called on the of the separator tree.
The type parameter `S` controls the behavior of the algorithm: if `S` is equal to `1` or `2`, then `alg` is additionally called
on the branches of the separator tree. At each branch, the ordering computed by `alg` is compared to the ordering computed
by the nested dissection algorithm, and the worse of the two is discarded.

  - `1`: minimize width (slow)
  - `2`: minimize fill (slow)
  - `3`: no strategy (fast)

CliqueTrees currently has two vertex separator algorithms, both of which require loading an external package.

| type                | name                               | package                                              |
|:--------------------|:-----------------------------------|:-----------------------------------------------------|
| [`METISND`](@ref)   | multilevel vertex separation       | [Metis.jl](https://github.com/JuliaSparse/Metis.jl)  |
| [`KaHyParND`](@ref) | multilevel hypergraph partitioning | [KayHyPar.jl](https://github.com/kahypar/KaHyPar.jl) |

The algorithm `KaHyParND` computes a vertex separator indirectly, by partitioning a quasi-clique-cover of the original graph.
The parameters `width` and `level` control the recursion depth of the algorithm, and the parameter `imbalance` controls the
maximum imbalance of the vertex separator.

### Parameters

  - `S`: strategy
    - `1`: minimize width (slow)
    - `2`: minimize fill (slow)
    - `3`: no strategy (fast)
  - `alg`: elimination algorithm
  - `dis`: separation algorithm
  - `width`: minimum width
  - `level`: maximum level
  - `imbalance`: separator imbalance
"""
struct ND{S, A <: EliminationAlgorithm, D <: DissectionAlgorithm} <: EliminationAlgorithm
    alg::A
    dis::D
    width::Int
    level::Int
    imbalance::Int
    scale::Int
end

function ND{S}(
        alg::A = DEFAULT_ELIMINATION_ALGORITHM, dis::D = DEFAULT_DISSECTION_ALGORITHM;
        width::Integer = 120,
        level::Integer = 6,
        imbalance::Integer = 130,
        scale::Integer = 1,
    ) where {S, A, D}
    @assert ispositive(width)
    @assert ispositive(level)
    @assert ispositive(imbalance)
    @assert ispositive(scale)
    return ND{S, A, D}(alg, dis, width, level, imbalance, scale)
end

function ND(args...; kwargs...)
    return ND{1}(args...; kwargs...)
end

struct NDS{S, A <: EliminationAlgorithm, D <: DissectionAlgorithm} <: EliminationAlgorithm
    alg::A
    dis::D
    width::Int
    level::Int
    imbalances::StepRange{Int, Int}
end

function NDS{S}(
        alg::A = DEFAULT_ELIMINATION_ALGORITHM, dis::D = DEFAULT_DISSECTION_ALGORITHM;
        width::Integer = 120,
        level::Integer = 6,
        imbalances::AbstractRange = 130:130,
    ) where {S, A, D}
    @assert ispositive(width)
    @assert ispositive(level)
    @assert ispositive(first(imbalances))
    return NDS{S, A, D}(alg, dis, width, level, imbalances)
end

function NDS(args...; kwargs...)
    return NDS{1}(args...; kwargs...)
end

"""
    Spectral <: EliminationAlgorithm

    Spectral(; tol=0.0)

The spectral ordering algorithm only works on connected graphs.
In order to use it, import the package [Laplacians](https://github.com/danspielman/Laplacians.jl).

### Parameters

  - `tol`: tolerance for convergence

### References

  - Barnard, Stephen T., Alex Pothen, and Horst D. Simon. "A spectral algorithm for envelope reduction of sparse matrices." *Proceedings of the 1993 ACM/IEEE Conference on Supercomputing.* 1993.
"""
@kwdef struct Spectral <: EliminationAlgorithm
    tol::Float64 = 0.0
end

"""
    FlowCutter <: EliminationAlgorithm

    FlowCutter(; time=5, seed=0)

The FlowCutter algorithm.

### Parameters

  - `time`: run time
  - `seed`: random seed

### References

  - Strasser, Ben. "Computing tree decompositions with flowcutter: PACE 2017 submission." arXiv preprint arXiv:1709.08949 (2017).
"""
@kwdef struct FlowCutter <: EliminationAlgorithm
    time::Int = 5
    seed::Int = 0
end

"""
    BT <: EliminationAlgorithm

    BT()

The Bouchitte-Todinca algorithm.

### References

  - Korhonen, Tuukka, Jeremias Berg, and Matti Järvisalo. "Solving Graph Problems via Potential Maximal Cliques: An Experimental Evaluation of the Bouchitté-Todinca Algorithm." *Journal of Experimental Algorithmics (JEA)* 24 (2019): 1-19.
"""
struct BT <: EliminationAlgorithm end

struct PIDBT{A <: WidthOrAlgorithm} <: EliminationAlgorithm
    alg::A
end

function PIDBT()
    return PIDBT(DEFAULT_LOWER_BOUND_ALGORITHM)
end

"""
    MinimalChordal{A} <: EliminationAlgorithm

    MinimalChordal(alg::PermutationOrAlgorithm)

    MinimalChordal()

Evaluate an elimination algorithm, and them improve its output using the MinimalChordal algorithm. The result is guaranteed to be minimal.

### Parameters

  - `alg`: elimination algorithm

### References

  - Heggernes, Pinar, and Barry W. Peyton. "Fast computation of minimal fill inside a given elimination ordering." *SIAM journal on matrix analysis and applications* 30.4 (2009): 1424-1444.
"""
struct MinimalChordal{A <: PermutationOrAlgorithm} <: MinimalAlgorithm
    alg::A
end

function MinimalChordal()
    return MinimalChordal(DEFAULT_ELIMINATION_ALGORITHM)
end

"""
    CompositeRotations{C, A} <: EliminationAlgorithm

    CompositeRotations(clique::AbstractVector, alg::EliminationAlgorithm)

    CompositeRotations(clique::AbstractVector)

Evaluate an eliminaton algorithm, ensuring that the given clique is at the end of the ordering.

### Parameters

  - `clique`: clique
  - `alg`: elimination algorithm

### References

  - Liu, Joseph WH. "Equivalent sparse matrix reordering by elimination tree rotations." *Siam Journal on Scientific and Statistical Computing* 9.3 (1988): 424-444.
"""
struct CompositeRotations{C <: AbstractVector, A <: PermutationOrAlgorithm} <:
    EliminationAlgorithm
    clique::C
    alg::A
end

function CompositeRotations(clique::AbstractVector)
    return CompositeRotations(clique, DEFAULT_ELIMINATION_ALGORITHM)
end

"""
    Compression{A} <: EliminationAlgorithm

    Compression(alg::EliminationAlgorithm; tao = 1.0)

Preprocess a graph by identifying indistinguishable vertices.
The algorithm `alg` is run on the compressed graph.

### Parameters

  - `alg`: elimination algorithm
  - `tao`: threshold parameter for graph compression


### References

  - Ashcraft, Cleve. "Compressed graphs and the minimum degree algorithm." *SIAM Journal on Scientific Computing* 16.6 (1995): 1404-1411.

"""
struct Compression{A <: EliminationAlgorithm} <: EliminationAlgorithm
    alg::A
    tao::Float64
end

function Compression(alg::EliminationAlgorithm; tao::Float64 = 1.0)
    return Compression(alg, tao)
end

function Compression(; kwargs...)
    return Compression(DEFAULT_ELIMINATION_ALGORITHM; kwargs...)
end

"""
    SafeRules{A, L, U} <: EliminationAlgorithm

    SafeRules(alg::EliminationAlgorithm, lb::WidthOrAlgorithm)

    SafeRules()

Preprocess a graph using safe reduction rules. The algorithm `lb` is used to compute a lower bound
to the treewidth; better lower bounds allow the algorithm to perform more reductions.

### Parameters

  - `alg`: elimination algorithm
  - `lb`: lower bound algorithm (used to lower bound the treiwidth)
  - `ub`: elimination algorithm (used to upper bound the treewidth)
  - `tao`: threshold parameter for graph compression

### References

  - Bodlaender, Hans L., et al. "Pre-processing for triangulation of probabilistic networks." (2001).
  - Bodlaender, Hans L., Arie M.C.A. Koster, and Frank van den Eijkhof. "Preprocessing rules for triangulation of probabilistic networks." *Computational Intelligence* 21.3 (2005): 286-305.
  - van den Eijkhof, Frank, Hans L. Bodlaender, and Arie M.C.A. Koster. "Safe reduction rules for weighted treewidth." *Algorithmica* 47 (2007): 139-158. 
"""
struct SafeRules{A <: EliminationAlgorithm, L <: WidthOrAlgorithm, U <: EliminationAlgorithm} <: EliminationAlgorithm
    alg::A
    lb::L
    ub::U
    tao::Float64
end

function SafeRules(alg::EliminationAlgorithm, lb::WidthOrAlgorithm, ub::EliminationAlgorithm; tao::Float64 = 1.0)
    return SafeRules(alg, lb, ub, tao)
end

function SafeRules(alg::EliminationAlgorithm, lb::WidthOrAlgorithm; kwargs...)
    return SafeRules(alg, lb, DEFAULT_ELIMINATION_ALGORITHM; kwargs...)
end

function SafeRules(alg::EliminationAlgorithm; kwargs...)
    return SafeRules(alg, DEFAULT_LOWER_BOUND_ALGORITHM; kwargs...)
end

function SafeRules(; kwargs...)
    return SafeRules(DEFAULT_ELIMINATION_ALGORITHM; kwargs...)
end

struct SimplicialRule{A <: EliminationAlgorithm} <: EliminationAlgorithm
    alg::A
    tao::Float64
end

function SimplicialRule(alg::EliminationAlgorithm; tao::Float64 = 1.0)
    return SimplicialRule(alg, tao)
end

function SimplicialRule(; kwargs...)
    return SimplicialRule(DEFAULT_ELIMINATION_ALGORITHM; kwargs...)
end

"""
    SafeSeparators{A, M} <: EliminationAlgorithm

    SafeSeparators(alg::EliminationAlgorithm, min::PermutationOrAlgorithm)

Apple an elimination algorithm to the atoms of an almost-clique separator decomposition. The algorithm
`min` is used to compute the decomposition.

!!! warning
    The algorithm `min` must compute a *minimimal* ordering. This property is guaranteed by the following
    algorithms:
      - [`MCSM`](@ref)
      - [`LexM`](@ref)
      - [`MinimalChordal`](@ref)

### Parameters

  - `alg`: elimination algorithm
  - `min`: minimal elimination algorithm

### References

  - Bodlaender, Hans L., and Arie MCA Koster. "Safe separators for treewidth." *Discrete Mathematics* 306.3 (2006): 337-350.
  - Tamaki, Hisao. "A heuristic for listing almost-clique minimal separators of a graph." arXiv preprint arXiv:2108.07551 (2021).
"""
struct SafeSeparators{A <: EliminationAlgorithm, M <: MinimalAlgorithm} <: EliminationAlgorithm
    alg::A
    min::M
end

function SafeSeparators(alg::EliminationAlgorithm=DEFAULT_ELIMINATION_ALGORITHM)
    return SafeSeparators(alg, DEFAULT_MINIMAL_ALGORITHM)
end

"""
    ConnectedComponents{A} <: EliminationAlgorithm

    ConnectedComponents(alg::PermutationOrAlgorithm)

    ConnectedComponents()

Apply an elimination algorithm to each connected component of a graph.

### Parameters

  - `alg`: elimination algorithm

"""
struct ConnectedComponents{A <: PermutationOrAlgorithm} <: EliminationAlgorithm
    alg::A
end

function ConnectedComponents()
    return ConnectedComponents(DEFAULT_ELIMINATION_ALGORITHM)
end

struct Best{S, A <: NTuple{<:Any, PermutationOrAlgorithm}} <: EliminationAlgorithm
    algs::A
end

const BestWidth = Best{1}
const BestFill = Best{2}

function Best{S}(algs::A) where {S, A <: Tuple}
    return Best{S, A}(algs)
end

function Best{S}(algs::PermutationOrAlgorithm...) where {S}
    return Best{S}(algs)
end

struct Log{A <: PermutationOrAlgorithm} <: EliminationAlgorithm
    alg::A
    num::Scalar{Int}
end

function Log{A}(alg::PermutationOrAlgorithm=DEFAULT_ELIMINATION_ALGORITHM) where {A <: PermutationOrAlgorithm}
    return Log{A}(alg, zeros(Int))
end

function Log(alg::A=DEFAULT_ELIMINATION_ALGORITHM) where {A <: PermutationOrAlgorithm}
    return Log{A}(alg)
end

"""
    permutation([weights, ]graph;
        alg::PermutationOrAlgorithm=DEFAULT_ELIMINATION_ALGORITHM)

Construct a fill-reducing permutation of the vertices of a simple graph.

```julia
julia> using CliqueTrees

julia> graph = [
           0 1 0 0 0 0 0 0
           1 0 1 0 0 1 0 0
           0 1 0 1 0 1 1 1
           0 0 1 0 0 0 0 0
           0 0 0 0 0 1 1 0
           0 1 1 0 1 0 0 0
           0 0 1 0 1 0 0 1
           0 0 1 0 0 0 1 0
       ];

julia> order, index = permutation(graph);

julia> order
8-element Vector{Int64}:
 4
 1
 2
 8
 5
 3
 6
 7

julia> index == invperm(order)
true
```
"""
function permutation(graph; alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM)
    return permutation(graph, alg)
end

function permutation(graph, alg::PermutationOrAlgorithm)
    return permutation(BipartiteGraph(graph), alg)
end

function permutation(graph::AbstractGraph{V}, alg::PermutationOrAlgorithm) where {V}
    n = nv(graph); weights = Ones{V}(n)
    return permutation(weights, graph, alg)
end

function permutation(weights::AbstractVector, graph; alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM)
    return permutation(weights, graph, alg)
end

function permutation(weights::AbstractVector, graph, alg::PermutationOrAlgorithm)
    return permutation(weights, BipartiteGraph(graph), alg)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::A) where A <: EliminationAlgorithm
    name = package(A)
    message = "`import $name` to use algorithm $A."
    throw(ArgumentError(message))    
end

function permutation(weights::AbstractVector, graph::AbstractGraph{V}, order::AbstractVector) where {V}
    order = Vector{V}(order)
    return order, invperm(order)
end

function permutation(weights::AbstractVector, graph::AbstractGraph{V}, (order, index)::Tuple{AbstractVector, AbstractVector}) where {V}
    order = Vector{V}(order)
    index = Vector{V}(index)
    return order, index
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::BFS)
    order = bfs(graph)
    return order, invperm(order)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::MCS)
    index, size = mcs(graph)
    return invperm(index), index
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::LexBFS)
    index = lexbfs(graph)
    return invperm(index), index
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::RCMMD)
    order = rcmmd(graph, alg.alg)
    return order, invperm(order)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::RCMGL)
    order = rcmgl(graph, alg.alg)
    return order, invperm(order)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::LexM)
    index = lexm(graph)
    return invperm(index), index
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::MCSM)
    index = mcsm(graph)
    return invperm(index), index
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::AMF)
    return amf(weights, graph)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::MF)
    return convert.(Vector, mlf(weights, graph))
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::MMD)
    index = mmd(weights, graph; delta = alg.delta)
    return invperm(index), index
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::NDS{S}) where {S}
    return dissectsearch(weights, graph, alg.alg, alg.dis, alg.width, alg.level, alg.imbalances, Val(S))
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::PIDBT)
    return permutation(trunc.(Int, weights), graph, alg)
end

function permutation(weights::AbstractVector{Int}, graph::AbstractGraph, alg::PIDBT)
    order = pidbt(weights, graph, lowerbound(weights, graph, alg.alg))
    return order, invperm(order)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::MinimalChordal)
    return mcs_etree(weights, graph, alg.alg)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::CompositeRotations)
    return compositerotations(graph, alg.clique, alg.alg)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::Compression)
    order = compress(weights, graph, alg.alg, alg.tao)
    return order, invperm(order)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::SafeRules)
    order = saferules(weights, graph, alg.alg, alg.lb, alg.tao)
    return order, invperm(order)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::SimplicialRule)
    order = simplicialrule(weights, graph, alg.alg, alg.tao)
    return order, invperm(order)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::SafeSeparators)
    return safeseparators(weights, graph, alg.alg, alg.min)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::ConnectedComponents)
    return connectedcomponents(weights, graph, alg.alg)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::BestWidth)
    return bestwidth(weights, graph, alg.algs)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::BestFill)
    return bestfill(weights, graph, alg.algs)
end

function permutation(weights::AbstractVector, graph::AbstractGraph, alg::Log)
    num = alg.num[] += 1

    if isone(num)
        print(  "|   #   |       |V|       |       |E|       |")
        print("\n| ----- | --------------- | --------------- |")
    end

    i = rpad(num,       5)
    n = rpad(nv(graph), 15)
    m = rpad(de(graph), 15)
    print("\n| $i | $n | $m |")

    return permutation(weights, graph, alg.alg)
end

# Algorithmic Aspects of Vertex Elimination on Graphs
# Rose, Tarjan, and Lueker
# BFS
#
# Perform a breadth-first search of a simple graph.
# The complexity is O(m), where m = |E|.
function bfs(graph::AbstractGraph{V}) where {V}
    n = nv(graph)
    order = Vector{V}(undef, n)
    marker = FVector{Bool}(undef, n)

    @inbounds for node in vertices(graph)
        marker[node] = false 
    end

    hi = n

    @inbounds for root in vertices(graph)
        if !marker[root]
            lo = hi; order[lo] = root; marker[root] = true

            while lo <= hi
                node = order[hi]; hi -= one(V)

                for nbr in neighbors(graph, node)
                    if !marker[nbr]
                        lo -= one(V); order[lo] = nbr; marker[nbr] = true 
                    end
                end
            end
        end
    end

    return order
end

# Simple Linear-Time Algorithms to Test Chordality of Graphs, Test Acyclicity of Hypergraphs, and Selectively Reduce Acyclic Hypergraphs
# Tarjan and Yannakakis
# Maximum Cardinality Search
#
# Construct a fill-reducing permutation of a graph.
# The complexity is O(m + n), where m = |E| and n = |V|.
function mcs(graph::AbstractGraph{V}, clique::AbstractVector{V} = oneto(zero(V))) where {V}
    j = one(V); n = nv(graph)
    size = FVector{V}(undef, n)
    alpha = Vector{V}(undef, n)

    @inbounds for v in vertices(graph)
        size[v] = one(V)
    end

    # construct bucket queue data structure
    head = FVector{V}(undef, n + one(V))
    prev = FVector{V}(undef, n)
    next = FVector{V}(undef, n)

    function set(i)
        @inbounds h = view(head, i)
        return DoublyLinkedList(h, prev, next)
    end

    @inbounds for i in oneto(n + one(V))
        empty!(set(i))
    end

    @inbounds prepend!(set(j), vertices(graph))

    # run algorithm
    @inbounds for v in Iterators.reverse(clique)
        delete!(set(j), v)
        alpha[v] = n
        size[v] = one(V) - j

        for w in neighbors(graph, v)
            if ispositive(size[w])
                delete!(set(size[w]), w)
                size[w] += one(V)
                pushfirst!(set(size[w]), w)
            end
        end

        j += one(V)

        while ispositive(j) && isempty(set(j))
            j -= one(V)
        end

        n -= one(V)
    end

    @inbounds while ispositive(n)
        v = popfirst!(set(j))
        alpha[v] = n
        size[v] = one(V) - j

        for w in neighbors(graph, v)
            if ispositive(size[w])
                delete!(set(size[w]), w)
                size[w] += one(V)
                pushfirst!(set(size[w]), w)
            end
        end

        j += one(V)

        while ispositive(j) && isempty(set(j))
            j -= one(V)
        end

        n -= one(V)
    end

    return alpha, size
end

function rootls_impl!(
        xls::AbstractVector{V},
        ls::AbstractVector{V},
        graph::AbstractGraph{V},
        marker::AbstractVector{V},
        root::V,
        tag::V,
    ) where {V}
    @assert nv(graph) < length(xls)
    @assert nv(graph) <= length(ls)
    @assert nv(graph) <= length(marker)

    # initialization...
    n = nv(graph)
    nlvl = lvlend = zero(V)
    @inbounds marker[root] = tag
    @inbounds ccsize = one(V); ls[ccsize] = root

    # compute the current level width;
    # if it is nonzero, generate the next level
    @inbounds while lvlend < ccsize
        # `lbegin` is the pointer to the beginning of the current
        # level, and `lvlend` points to the end of this level
        lbegin = lvlend + one(V)
        lvlend = ccsize
        nlvl += one(V); xls[nlvl] = lbegin

        # generate the next leel by finding all the masked
        # neighbors of nodes in the current level
        for i in lbegin:lvlend
            node = ls[i]

            for nbr in neighbors(graph, node)
                if marker[nbr] < tag
                    ccsize += one(V); ls[ccsize] = nbr
                    marker[nbr] = tag
                end
            end
        end
    end

    @inbounds xls[nlvl + one(V)] = ccsize + one(V)
    return BipartiteGraph(n, nlvl, ccsize, xls, ls)
end

function fnroot_impl!(
        xls::AbstractVector{V},
        ls::AbstractVector{V},
        graph::AbstractGraph{V},
        marker::AbstractVector{V},
        root::V,
    ) where {V}
    @assert nv(graph) < length(xls)
    @assert nv(graph) <= length(ls)
    @assert nv(graph) <= length(marker)

    # initialize `tag`
    tag = one(V)

    # determine the level structure rooted at `root`
    level = rootls_impl!(xls, ls, graph, marker, root, tag)
    nlvl = nv(level); ccsize = ne(level)
    pnlvl = one(V)

    # increment `tag`
    tag += one(V)

    @inbounds while pnlvl < nlvl < ccsize
        pnlvl = nlvl

        # pick a node with minimum degree from the last level
        mindeg = ccsize

        for node in neighbors(level, nlvl)
            ndeg = eltypedegree(graph, node)

            if ndeg < mindeg
                root, mindeg = node, ndeg
            end
        end

        # and generate its rooted level structure
        level = rootls_impl!(xls, ls, graph, marker, root, tag)
        nlvl = nv(level)

        # increment `tag`
        tag += one(V)
    end

    return level
end

# Algorithms for Sparse Linear Systems
# Scott and Tuma
# Algorithm 8.3: CM and RCM algorithms for band and profile reduction
#
# Apply the reverse Cuthill-Mckee algorithm to each connected component of a graph.
# The complexity is O(m + n), where m = |E| and n = |V|.
function rcmgl(graph::AbstractGraph, alg::SortingAlgorithm)
    return rcmgl!(simplegraph(graph), alg)
end

function rcmgl!(graph::BipartiteGraph{V}, alg::SortingAlgorithm) where {V}
    n = nv(graph); nn = n + one(V)
    order = Vector{V}(undef, n)
    xls = FVector{V}(undef, nn)
    ls = FVector{V}(undef, n)
    marker = FVector{V}(undef, n)

    @inbounds for v in vertices(graph)
        marker[v] = zero(V)
        sort!(neighbors(graph, v); alg, scratch = order, by = w -> eltypedegree(graph, w))
    end

    resize!(order, n)
    hi = n

    @inbounds for root in vertices(graph)
        if iszero(marker[root])
            level = fnroot_impl!(xls, ls, graph, marker, root)

            for i in vertices(level), v in neighbors(level, i)
                order[hi] = v; hi -= one(V)
            end
        end
    end

    return order
end

function rcmmd(graph::AbstractGraph, alg::SortingAlgorithm)
    return rcmmd!(simplegraph(graph), alg)
end

function rcmmd!(graph::BipartiteGraph{V}, alg::SortingAlgorithm) where {V}
    n = nv(graph)
    order = Vector{V}(undef, n)
    marker = FVector{V}(undef, n)

    @inbounds for v in vertices(graph)
        marker[v] = zero(V)
        sort!(neighbors(graph, v); alg, scratch = order, by = w -> eltypedegree(graph, w))
    end

    resize!(order, n)
    hi = n

    @inbounds for root in vertices(graph)
        if iszero(marker[root])
            nhi = hi
            mindeg = eltypedegree(graph, root)
            lo = hi; order[lo] = root; marker[root] = one(V)

            while lo <= hi
                node = order[hi]; hi -= one(V)
                ndeg = eltypedegree(graph, node)

                if ndeg < mindeg
                    root, mindeg = node, ndeg
                end

                for nbr in neighbors(graph, node)
                    if iszero(marker[nbr])
                        lo -= one(V); order[lo] = nbr; marker[nbr] = one(V) 
                    end
                end
            end

            hi = nhi
            lo = hi; order[lo] = root; marker[root] = two(V)

            while lo <= hi
                node = order[hi]; hi -= one(V)

                for nbr in neighbors(graph, node)
                    if isone(marker[nbr])
                        lo -= one(V); order[lo] = nbr; marker[nbr] = two(V) 
                    end
                end
            end
        end
    end

    return order
end

# Algorithmic Aspects of Vertex Elimination on Graphs
# Rose, Tarjan, and Lueker
# LEX P
#
# Perform a lexicographic breadth-first search of a simple graph.
function lexbfs(graph::AbstractGraph{V}) where {V}
    I = promote_type(V, etype(graph))
    n = convert(I, max(ne(graph) * (2 - is_directed(graph)), nv(graph)) + 2)

    flag = Vector{I}(undef, n)
    head = Vector{I}(undef, n)
    next = Vector{I}(undef, n)
    back = Vector{I}(undef, n)

    alpha = Vector{V}(undef, nv(graph))
    cell = Vector{V}(undef, nv(graph))

    fixlist = Vector{I}(undef, Δout(graph))

    # (implicitly) assign label ∅ to all vertices
    head[one(I)] = two(I)
    back[two(I)] = one(I)
    head[two(I)] = back[one(I)] = next[one(I)] = flag[one(I)] = flag[two(I)] = zero(I)
    c = three(I)

    # c is the number of the first empty cell
    @inbounds for v in vertices(graph)
        head[c] = v
        cell[v] = next[c - one(I)] = c
        flag[c] = two(I)
        back[c] = c - one(I)
        c += one(I)
        alpha[v] = zero(V)
    end

    next[c - one(I)] = zero(I)

    @inbounds for i in reverse(oneto(nv(graph)))
        # skip empty sets
        while iszero(next[head[one(I)]])
            head[one(I)] = head[head[one(I)]]
            back[head[one(I)]] = one(I)
        end

        ##########
        # select #
        ##########

        # pick next vertex to number
        p = next[head[one(I)]]

        # delete cell of vertex from set
        next[head[one(I)]] = next[p]

        if !iszero(next[head[one(I)]])
            back[next[head[one(I)]]] = head[one(I)]
        end

        v = head[p]

        # assign v the number i
        alpha[v] = i
        f = zero(V)

        ###########
        # update2 #
        ###########

        for w in neighbors(graph, v)
            if iszero(alpha[w])
                # delete cell of w from set
                next[back[cell[w]]] = next[cell[w]]

                if !iszero(next[cell[w]])
                    back[next[cell[w]]] = back[cell[w]]
                end

                h = back[flag[cell[w]]]

                # if h is an old set then create a new set
                if iszero(flag[h])
                    head[c] = head[h]
                    head[h] = c
                    back[head[c]] = c
                    back[c] = h
                    flag[c] = one(I)
                    next[c] = zero(I)
                    f += one(V)
                    fixlist[f] = c
                    h = c
                    c += one(I)
                end

                # add cell of w to new set
                next[cell[w]] = next[h]

                if !iszero(next[h])
                    back[next[h]] = cell[w]
                end

                flag[cell[w]] = back[cell[w]] = h
                next[h] = cell[w]
            end
        end

        @views flag[fixlist[one(V):f]] .= zero(I)
    end

    return alpha
end

# Algorithmic Aspects of Vertex Elimination on Graphs
# Rose, Tarjan, and Lueker
# LEX M
#
# Perform a lexicographic breadth-first search of a simple graph.
# Returns a minimal ordering.
# The complexity is O(mn), where m = |E| and n = |V|.
function lexm(graph::AbstractGraph{V}) where {V}
    k = one(V); n = nv(graph)
    alpha = fill(-n - one(V), n)
    label = fill(twice(k), n)

    # construct stack data structure
    stack = Vector{V}(undef, n)

    # construct bucket queue data structures
    shead = zeros(V, twice(n) + two(V))
    sprev = Vector{V}(undef, n)
    snext = Vector{V}(undef, n)

    function set(j)
        @inbounds head = @view shead[j]
        return DoublyLinkedList(head, sprev, snext)
    end

    rhead = zeros(V, n)
    rprev = Vector{V}(undef, n)
    rnext = Vector{V}(undef, n)

    function reach(j)
        @inbounds head = @view rhead[j]
        return DoublyLinkedList(head, rprev, rnext)
    end

    @inbounds prepend!(set(twice(k)), vertices(graph))

    ########
    # loop #
    ########

    @inbounds while ispositive(n)
        ##########
        # select #
        ##########

        # assign v the number i
        v = popfirst!(set(twice(k)))
        alpha[v] = n

        for w in neighbors(graph, v)
            if isnegative(alpha[w])
                alpha[w] = -n
                pushfirst!(reach(half(label[w])), w)
                delete!(set(label[w]), w)
                label[w] += one(V)
                pushfirst!(set(label[w]), w)
            end
        end

        ##########
        # search #
        ##########

        for j in oneto(k)
            while !isempty(reach(j))
                w = popfirst!(reach(j))

                for z in neighbors(graph, w)
                    if alpha[z] < -n
                        alpha[z] = -n

                        if label[z] > twice(j)
                            pushfirst!(reach(half(label[z])), z)
                            delete!(set(label[z]), z)
                            label[z] += one(V)
                            pushfirst!(set(label[z]), z)
                        else
                            pushfirst!(reach(j), z)
                        end
                    end
                end
            end
        end

        ########
        # sort #
        ########

        m = twice(k) + one(V)
        k = zero(V)

        for j in oneto(m)
            w = shead[j]

            if ispositive(w)
                k += one(V)

                for v in set(j)
                    label[v] = twice(k)
                end

                stack[k] = w
                shead[j] = zero(V)
            end
        end

        for j in oneto(k)
            shead[twice(j)] = stack[j]
        end

        n -= one(V)
    end

    return alpha
end

# Maximum Cardinality Search for Computing Minimal Triangulations
# Berry, Blair, and Heggernes
# MCS-M
#
# Perform a maximum cardinality search of a simple graph.
# Returns a minimal ordering.
# The complexity is O(mn), where m = |E| and n = |V|.
function mcsm(graph::AbstractGraph{V}, clique::AbstractVector{V} = oneto(zero(V))) where {V}
    k = one(V); n = nv(graph)
    alpha = fill(-n - one(V), n)
    size = ones(V, n)

    # construct bucket queue data structures
    shead = zeros(V, n + one(V))
    sprev = Vector{V}(undef, n)
    snext = Vector{V}(undef, n)

    function set(j)
        @inbounds head = @view shead[j]
        return DoublyLinkedList(head, sprev, snext)
    end

    rhead = zeros(V, n)
    rprev = Vector{V}(undef, n)
    rnext = Vector{V}(undef, n)

    function reach(j)
        @inbounds head = @view rhead[j]
        return DoublyLinkedList(head, rprev, rnext)
    end

    @inbounds prepend!(set(k), vertices(graph))

    # run algorithm
    @inbounds for v in reverse(clique)
        delete!(set(k), v)
        alpha[v] = n

        for w in neighbors(graph, v)
            if isnegative(alpha[w])
                alpha[w] = -n
                pushfirst!(reach(size[w]), w)
                delete!(set(size[w]), w)
                size[w] += one(V)
                pushfirst!(set(size[w]), w)
            end
        end

        for j in oneto(k)
            while !isempty(reach(j))
                w = popfirst!(reach(j))

                for z in neighbors(graph, w)
                    if alpha[z] < -n
                        alpha[z] = -n

                        if size[z] > j
                            pushfirst!(reach(size[z]), z)
                            delete!(set(size[z]), z)
                            size[z] += one(V)
                            pushfirst!(set(size[z]), z)
                        else
                            pushfirst!(reach(j), z)
                        end
                    end
                end
            end
        end

        k += one(V)

        while ispositive(k) && isempty(set(k))
            k -= one(V)
        end

        n -= one(V)
    end

    @inbounds while ispositive(n)
        v = popfirst!(set(k))
        alpha[v] = n

        for w in neighbors(graph, v)
            if isnegative(alpha[w])
                alpha[w] = -n
                pushfirst!(reach(size[w]), w)
                delete!(set(size[w]), w)
                size[w] += one(V)
                pushfirst!(set(size[w]), w)
            end
        end

        for j in oneto(k)
            while !isempty(reach(j))
                w = popfirst!(reach(j))

                for z in neighbors(graph, w)
                    if alpha[z] < -n
                        alpha[z] = -n

                        if size[z] > j
                            pushfirst!(reach(size[z]), z)
                            delete!(set(size[z]), z)
                            size[z] += one(V)
                            pushfirst!(set(size[z]), z)
                        else
                            pushfirst!(reach(j), z)
                        end
                    end
                end
            end
        end

        k += one(V)

        while ispositive(k) && isempty(set(k))
            k -= one(V)
        end

        n -= one(V)
    end

    return alpha
end

function AMFLib.amf(weights::AbstractVector, graph::AbstractGraph)
    simple = simplegraph(graph)
    return amf(nv(simple), weights, pointers(simple), targets(simple))
end

function mlf(weights::AbstractVector{W}, graph::AbstractGraph; kwargs...) where {W <: Union{Int8, Int16, Int32}}
    intweights = FVector{Int}(undef, nv(graph))

    @inbounds for v in vertices(graph)
        intweights[v] = convert(Int, weights[v])
    end

    return mlf(intweights, graph; kwargs...)
end

function mlf(weights::AbstractVector, graph::AbstractGraph{V}; kwargs...) where {V}
    E = etype(graph)
    n = nv(graph)
    m = de(graph)
    ptr = FVector{E}(undef, n + 1)
    tgt = FVector{V}(undef, m + 2n)
    simple = simplegraph!(ptr, tgt, graph)
    return mlf!(nv(simple), weights, pointers(simple), targets(simple); kwargs...)
end

function MMDLib.mmd(weights::AbstractVector, graph::AbstractGraph; kwargs...)
    simple = simplegraph(graph)
    return mmd(nv(simple), weights, pointers(simple), targets(simple); kwargs...)
end

function dissectsearch(weights::AbstractVector, graph::AbstractGraph, alg::EliminationAlgorithm, dis::DissectionAlgorithm, width::Integer, level::Integer, imbalances::AbstractRange, ::Val{S}) where {S}
    minscore = minpair = nothing

    for imbalance in imbalances
        curalg = ND{S}(alg, dis; width, level, imbalance)
        curpair = permutation(weights, graph, curalg)

        if isone(S)
            curscore = (treewidth(weights, graph, curpair), treefill(weights, graph, curpair))
        else
            curscore = (treefill(weights, graph, curpair), treewidth(weights, graph, curpair))
        end

        if isnothing(minscore) || curscore < minscore
            minscore, minpair = curscore, curpair
        end
    end

    return minpair
end

function twins(graph::AbstractGraph{V}, ::Val{S}) where {V, S}
    n = nv(graph); nn = n + one(V)
    new = FScalar{V}(undef)
    var = FVector{V}(undef, nn)
    svar = FVector{V}(undef, n)
    flag = FVector{V}(undef, n)
    size = FVector{V}(undef, n)
    head = FVector{V}(undef, n)
    prev = FVector{V}(undef, n)
    next = FVector{V}(undef, n)
    partition = twins_impl!(new, var, svar, flag, size, head, prev, next, graph, Val(S))
    return svar, partition
end

# Exploiting Zeros on the Diagonal in the Direct Solution
# of Indefinite Sparse Symmetric Linear Systems
# Duff and Reid
# 2.5 Recognition of Supervariables
function twins_impl!(
        new::AbstractScalar{V},
        var::AbstractVector{V},
        svar::AbstractVector{V},
        flag::AbstractVector{V},
        size::AbstractVector{V},
        head::AbstractVector{V},
        prev::AbstractVector{V},
        next::AbstractVector{V},
        graph::AbstractGraph{V},
        ::Val{S},
    ) where {V, S}
    @assert nv(graph) < length(var)
    @assert nv(graph) <= length(svar)
    @assert nv(graph) <= length(flag)
    @assert nv(graph) <= length(size)
    @assert nv(graph) <= length(head)
    @assert nv(graph) <= length(prev)
    @assert nv(graph) <= length(next)

    n = nv(graph); m = zero(V)

    @inbounds for i in oneto(n)
        flag[i] = zero(V)
        size[i] = zero(V)
        head[i] = zero(V)
    end

    new[] = zero(V); free = SinglyLinkedList(new, var)
    @inbounds prepend!(free, oneto(n))

    function set(i::V)
        @inbounds h = @view head[i]
        return DoublyLinkedList(h, prev, next)
    end

    if ispositive(n)
        s = popfirst!(free); m += one(V)
        @inbounds prepend!(set(s), oneto(n)); size[s] = n

        @inbounds for i in oneto(n)
            svar[i] = s
        end
    end

    @inbounds for j in oneto(n)
        for i in neighbors(graph, j)
            if i != j
                # `s` is the old supervariable of `i`
                s = svar[i]

                # first occurance of `s` for column `j`
                if flag[s] < j
                    flag[s] = j

                    if size[s] > one(V)
                        delete!(set(s), i); size[s] -= one(V)
                        var[s] = i
                        ns = svar[i] = popfirst!(free); m += one(V)
                        pushfirst!(set(ns), i); size[ns] += one(V)
                    end
                    # second of later occurrence of `s` for column `j`
                else
                    # `k` is the first variable of `s` encountered in column `j`.
                    delete!(set(s), i); size[s] -= one(V)
                    k = var[s]
                    ns = svar[i] = svar[k]
                    pushfirst!(set(ns), i); size[ns] += one(V)

                    if isempty(set(s))
                        pushfirst!(free, s); m -= one(V)
                    end
                end
            end
        end

        if S
            # `s` is the old supervariable of `j`
            s = svar[j]

            # first occurance of `s` for column `j`
            if flag[s] < j
                flag[s] = j

                if size[s] > one(V)
                    delete!(set(s), j); size[s] -= one(V)
                    var[s] = j
                    ns = svar[j] = popfirst!(free); m += one(V)
                    pushfirst!(set(ns), j); size[ns] += one(V)
                end
                # second or later occurrence of `s` for column `j`
            else
                # `k` is the first variable of `s` encountered in column `j`.
                delete!(set(s), j); size[s] -= one(V)
                k = var[s]
                ns = svar[j] = svar[k]
                pushfirst!(set(ns), j); size[ns] += one(V)

                if isempty(set(s))
                    pushfirst!(free, s); m -= one(V)
                end
            end
        end
    end

    partition = BipartiteGraph(n, m, n, var, flag)
    t = one(V); pointers(partition)[t] = p = one(V)

    @inbounds for s in oneto(n)
        isempty(set(s)) && continue

        for i in set(s)
            svar[i] = t
            targets(partition)[p] = i; p += one(V)
        end

        t += one(V); pointers(partition)[t] = p
    end

    return partition
end

# Algorithms for Sparse Linear Systems
# Scott & Tuma
#
# Algorithm 3.8: Find approximately indistinguishable vertex sets
# in an undirected graph
#
# Finding Exact and Approximate Block Structures for ILU Preconditioning
# Yousef Saad
#
# Algorithm 2.2: Cosine-based compression
function twins(graph::AbstractGraph{V}, ::Val{S}, tao::Number) where {V, S}
    if isone(tao)
        return twins(graph, Val(S))
    else
        n = nv(graph); nn = n + one(V)
        head = FScalar{V}(undef)
        prev = FVector{V}(undef, nn)
        next = FVector{V}(undef, n)
        adjmap = FVector{V}(undef, n)
        cosine = FVector{V}(undef, n)
        degree = FVector{V}(undef, n)
        partition = twins_impl!(head, prev, next, adjmap, cosine, degree, graph, Val(S), tao)
        return adjmap, partition
    end
end

function twins_impl!(
        head::AbstractScalar{V},
        prev::AbstractVector{V},
        next::AbstractVector{V},
        adjmap::AbstractVector{V},
        cosine::AbstractVector{V},
        degree::AbstractVector{V},
        graph::AbstractGraph{V},
        ::Val{S},
        tao::T,
    ) where {V, S, T}
    @assert nv(graph) < length(prev)
    @assert nv(graph) <= length(next)
    @assert nv(graph) <= length(adjmap)
    @assert nv(graph) <= length(cosine)
    @assert nv(graph) <= length(degree)
    @assert zero(T) < tao <= one(T)
    n = nv(graph); nb = zero(V)
    list = DoublyLinkedList(head, prev, next)

    @inbounds for i in vertices(graph)
        adjmap[i] = zero(V)
        cosine[i] = zero(V)

        if S
            degree[i] = one(V)
        else
            degree[i] = zero(V)
        end

        for j in neighbors(graph, i)
            i == j && continue
            degree[i] += one(V)
        end
    end

    @inbounds head[] = zero(V)

    @inbounds for i in vertices(graph)
        if iszero(adjmap[i])
            # start a new set
            adjmap[i] = nb += one(V)

            # for each entry j in row i...
            for j in neighbors(graph, i)
                i == j && continue
                    
                for k in neighbors(graph, j)
                    j == k && continue
                        
                    # both rows i and k have an entry
                    # in column j
                    if i < k
                        # k has not yet been added to a part
                        if iszero(adjmap[k])
                            # increase partial dot product
                            iszero(cosine[k]) && pushfirst!(list, k)
                            cosine[k] += one(V)
                        end
                    end
                end

                if S && i < j
                    # k has not yet been added to a part
                    if iszero(adjmap[j])
                        # increase partial dot product
                        iszero(cosine[j]) && pushfirst!(list, j)
                        cosine[j] += one(V)
                    end
                end
            end

            if S
                for k in neighbors(graph, i)
                    # both rows i and k have an entry
                    # in column j
                    if i < k
                        # k has not yet been added to a part
                        if iszero(adjmap[k])
                            # increase partial dot product
                            iszero(cosine[k]) && pushfirst!(list, k)
                            cosine[k] += one(V)
                        end
                    end
                end
            end

            for k in list
                cos = convert(T, cosine[k])
                nzi = convert(T, degree[i])
                nzk = convert(T, degree[k])

                # test similarity of row patterns
                if cos * cos >= tao * tao * nzi * nzk
                    adjmap[k] = nb
                end

                delete!(list, k)
                cosine[k] = zero(V)
            end
        end
    end

    pointer = prev; target = next
    
    @inbounds for j in oneto(nb)
        jj = j + one(V)
        pointer[jj] = zero(V)
    end

    @inbounds for i in vertices(graph)
        j = adjmap[i]

        if j < nb
            jj = j + two(V)
            pointer[jj] += one(V)
        end
    end

    @inbounds pointer[begin] = p = one(V)

    @inbounds for j in oneto(nb)
        jj = j + one(V)
        pointer[jj] = p += pointer[jj]
    end

    @inbounds for i in vertices(graph)
        j = adjmap[i]; jj = j + one(V)
        target[pointer[jj]] = i
        pointer[jj] += one(V)
    end
        
    partition = BipartiteGraph(n, nb, n, pointer, target)
    return partition  
end

# Engineering Data Reduction for Nested Dissection
# Ost, Schulz, Strash
# Reduction 2 (Indistinguishable node reduction)
# Reduction 3 (Twin Reduction)
function compress(graph::AbstractGraph{V}, ::Val{S}) where {V, S}
    E = etype(graph); n = nv(graph); m = de(graph); nn = n + one(V)
    new = FScalar{V}(undef)
    var = FVector{V}(undef, nn)
    svar = FVector{V}(undef, n)
    flag = FVector{V}(undef, n)
    size = FVector{V}(undef, n)
    head = FVector{V}(undef, n)
    prev = FVector{V}(undef, n)
    next = FVector{V}(undef, n)
    outptr = FVector{E}(undef, nn)
    outtgt = FVector{V}(undef, m)
    return compress_impl!(new, var, svar, flag, size, head, prev, next, outptr, outtgt, graph, Val(S))
end

function compress_impl!(
        new::AbstractScalar{V},
        var::AbstractVector{V},
        svar::AbstractVector{V},
        flag::AbstractVector{V},
        size::AbstractVector{V},
        head::AbstractVector{V},
        prev::AbstractVector{V},
        next::AbstractVector{V},
        outptr::AbstractVector{E},
        outtgt::AbstractVector{V},
        graph::AbstractGraph{V},
        ::Val{S},
    ) where {V, E, S}
    @assert nv(graph) < length(outptr)
    @assert ne(graph) <= length(outtgt)

    partition = twins_impl!(new, var, svar, flag, size, head, prev, next, graph, Val(S))
    project = svar; marker = size; tag = zero(V)

    @inbounds for v in vertices(graph)
        marker[v] = zero(V)
    end

    outptr[begin] = p = one(E)

    @inbounds for i in vertices(partition)
        ii = i + one(V)
        v = first(neighbors(partition, i))

        for w in neighbors(graph, v)
            j = project[w]

            if i != j && marker[j] < i
                marker[j] = i; outtgt[p] = j; p += one(E)
            end
        end

        outptr[ii] = p
    end

    outn = nv(partition); outm = p - one(E)
    outgraph = BipartiteGraph(outn, outn, outm, outptr, outtgt)
    return outgraph, partition
end

function compress(graph::AbstractGraph{V}, ::Val{S}, tao::Number) where {V, S}
    if isone(tao)
        return compress(graph, Val(S))
    else
        E = etype(graph); n = nv(graph); m = de(graph); nn = n + one(V)
        head = FScalar{V}(undef)
        prev = FVector{V}(undef, nn)
        next = FVector{V}(undef, n)
        adjmap = FVector{V}(undef, n)
        cosine = FVector{V}(undef, n)
        degree = FVector{V}(undef, n)
        outptr = FVector{E}(undef, nn)
        outtgt = FVector{V}(undef, m)
        return compress_impl!(head, prev, next, adjmap, cosine, degree, outptr, outtgt, graph, Val(S), tao)
    end
end

function compress_impl!(
        head::AbstractScalar{V},
        prev::AbstractVector{V},
        next::AbstractVector{V},
        adjmap::AbstractVector{V},
        cosine::AbstractVector{V},
        degree::AbstractVector{V},
        outptr::AbstractVector{E},
        outtgt::AbstractVector{V},
        graph::AbstractGraph{V},
        ::Val{S},
        tao::Number,
    ) where {V, E, S}
    @assert nv(graph) < length(outptr)
    @assert ne(graph) <= length(outtgt)

    partition = twins_impl!(head, prev, next, adjmap, cosine, degree, graph, Val(S), tao)
    project = adjmap; marker = cosine; tag = zero(V)

    @inbounds for v in vertices(graph)
        marker[v] = zero(V)
    end

    outptr[begin] = p = one(E)

    @inbounds for i in vertices(partition)
        ii = i + one(V)

        for v in neighbors(partition, i), w in neighbors(graph, v)
            j = project[w]

            if i != j && marker[j] < i
                marker[j] = i; outtgt[p] = j; p += one(E)
            end
        end

        outptr[ii] = p
    end

    outn = nv(partition); outm = p - one(E)
    outgraph = BipartiteGraph(outn, outn, outm, outptr, outtgt)
    return outgraph, partition
end

function compress(weights::AbstractVector{W}, graph::AbstractGraph{V}, alg::EliminationAlgorithm, tao::Number) where {W, V}
    order = Vector{V}(undef, nv(graph))
    cmpgraph, project = compress(graph, Val(true), tao)
    cmpweights = compressweights(weights, project)
    cmporder, cmpindex = permutation(cmpweights, cmpgraph, alg)
    i = zero(V)

    @inbounds for vcmp in cmporder, v in neighbors(project, vcmp)
        i += one(V); order[i] = v
    end

    return order
end

function compressweights(weights::AbstractVector{W}, project::AbstractGraph) where {W}
    cmpweights = FVector{W}(undef, nv(project))
    compressweights_impl!(cmpweights, weights, project)
    return cmpweights
end

function compressweights_impl!(cmpweights::AbstractVector, weights::AbstractVector{W}, project::AbstractGraph) where {W}
    @assert nv(project) <= length(cmpweights)
    @assert nov(project) <= length(weights)

    @inbounds for vcmp in vertices(project)
        wgt = zero(W)

        for v in neighbors(project, vcmp)
            wgt += weights[v]
        end

        cmpweights[vcmp] = wgt
    end

    return
end

function saferules(weights::AbstractVector, graph::AbstractGraph{V}, alg::EliminationAlgorithm, lb::WidthOrAlgorithm, tao::Number) where {V}
    n = nv(graph)
    width = lowerbound(weights, graph, lb)
    innerweights, innergraph, inject, project, innerwidth = compressreduce(pr4, weights, graph, width, tao)
    innerorder, innerindex = permutation(innerweights, innergraph, alg)

    order = Vector{V}(undef, n); i = zero(V)

    for v in inject
        i += one(V); order[i] = v
    end

    for j in innerorder, v in neighbors(project, j)
        i += one(V); order[i] = v
    end 

    return order
end

function simplicialrule(weights::AbstractVector{W}, graph::AbstractGraph{V}, alg::EliminationAlgorithm, tao::Number) where {W, V}
    n = nv(graph)
    width = zero(W)
    innerweights, innergraph, inject, project, innerwidth = compressreduce(sr, weights, graph, width, tao)
    innerorder, innerindex = permutation(innerweights, innergraph, alg)

    order = Vector{V}(undef, n); i = zero(V)

    for v in inject
        i += one(V); order[i] = v
    end

    for j in innerorder, v in neighbors(project, j)
        i += one(V); order[i] = v
    end 

    return order
end

function connectedcomponents(graph::AbstractGraph{V}) where {V}
    E = etype(graph); n = nv(graph); m = de(graph)

    cmp = Vector{Tuple{View{V, V}, BipartiteGraph{V, E, View{E, V}, View{V, E}}}}(undef, n)
    ptr = Vector{E}(undef, twice(n) + one(V))
    tgt = Vector{V}(undef, m)
    prj = Vector{V}(undef, n)
    inj = Vector{V}(undef, n)
    
    cmpend = one(V)
    injbeg = one(V)
    ptrbeg = one(V)
    tgtbeg = one(E)

    for v in vertices(graph)
        prj[v] = zero(V)
    end

    for v in vertices(graph)
        if iszero(prj[v])
            injcur = injbeg
            injend = injbeg
            prj[v] = injend; inj[injend] = v; injend += one(V)

            tgtend = tgtbeg
            ptrend = ptrbeg
            ptr[ptrend] = one(E); ptrend += one(V)

            while injcur < injend
                v = inj[injcur]; injcur += one(V)

                for w in neighbors(graph, v)
                    prjnbr = prj[w]

                    if iszero(prjnbr)
                        prj[w] = prjnbr = injend; inj[injend] = w; injend += one(V)
                    end

                    tgt[tgtend] = prjnbr - injbeg + one(V); tgtend += one(E)
                end 

                ptr[ptrend] = tgtend - tgtbeg + one(E); ptrend += one(V)
            end

            cmp[cmpend] = (
                view(inj, injbeg:injend - one(V)),
                BipartiteGraph(
                    injend - injbeg,
                    injend - injbeg,
                    tgtend - tgtbeg,
                    view(ptr, ptrbeg:ptrend - one(V)),
                    view(tgt, tgtbeg:tgtend - one(E)),
                )
            )

            cmpend += one(V)
            injbeg = injend
            ptrbeg = ptrend
            tgtbeg = tgtend
        end
    end

    return cmp, cmpend - one(V)
end

function connectedcomponents(weights::AbstractVector{W}, graph::AbstractGraph{V}, alg::EliminationAlgorithm) where {W, V}
    n = nv(graph); j = zero(V)
    order = Vector{V}(undef, n)
    index = Vector{V}(undef, n)
    subweights = Vector{W}(undef, n)
    components, m = connectedcomponents(graph)

    for i in oneto(m)
        label, subgraph = components[i]

        for v in vertices(subgraph)
            vv = label[v]
            subweights[v] = weights[vv]
        end

        suborder, subindex = permutation(subweights, subgraph, alg)
        
        for v in suborder
            vv = label[v]
            j += one(V); order[j] = vv; index[vv] = j
        end
    end

    return order, index
end

function Base.show(io::IO, ::MIME"text/plain", alg::A) where {A <: EliminationAlgorithm}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "$A")
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::RCMMD{A}) where {A}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "RCMMD{$A}:")

    for line in eachsplit(strip(repr(alg.alg)), "\n")
        println(io, " "^indent * "    $line")
    end

    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::RCMGL{A}) where {A}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "RCMGL{$A}:")

    for line in eachsplit(strip(repr(alg.alg)), "\n")
        println(io, " "^indent * "    $line")
    end

    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::MMD)
    indent = get(io, :indent, 0)
    println(io, " "^indent * "MMD:")
    println(io, " "^indent * "    delta: $(alg.delta)")
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::AMD)
    indent = get(io, :indent, 0)
    println(io, " "^indent * "AMD:")
    println(io, " "^indent * "    dense: $(alg.dense)")
    println(io, " "^indent * "    aggressive: $(alg.aggressive)")
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::SymAMD)
    indent = get(io, :indent, 0)
    println(io, " "^indent * "SymAMD:")
    println(io, " "^indent * "    dense_row: $(alg.dense_row)")
    println(io, " "^indent * "    dense_col: $(alg.dense_col)")
    println(io, " "^indent * "    aggressive: $(alg.aggressive)")
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::METIS)
    indent = get(io, :indent, 0)
    println(io, " "^indent * "METIS:")
    println(io, " "^indent * "    ctype: $(alg.ctype)")
    println(io, " "^indent * "    rtype: $(alg.rtype)")
    println(io, " "^indent * "    nseps: $(alg.nseps)")
    println(io, " "^indent * "    niter: $(alg.niter)")
    println(io, " "^indent * "    seed: $(alg.seed)")
    println(io, " "^indent * "    compress: $(alg.compress)")
    println(io, " "^indent * "    ccorder: $(alg.ccorder)")
    println(io, " "^indent * "    pfactor: $(alg.pfactor)")
    println(io, " "^indent * "    ufactor: $(alg.ufactor)")
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::ND{S, A, D}) where {S, A, D}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "ND{$S, $A, $D}:")
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.alg)
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.dis)
    println(io, " "^indent * "    width: $(alg.width)")
    println(io, " "^indent * "    level: $(alg.level)")
    println(io, " "^indent * "    imbalance: $(alg.imbalance)")
    println(io, " "^indent * "    scale: $(alg.scale)")
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::Spectral)
    indent = get(io, :indent, 0)
    println(io, " "^indent * "Spectral:")
    println(io, " "^indent * "    tol: $(alg.tol)")
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::FlowCutter)
    indent = get(io, :indent, 0)
    println(io, " "^indent * "FlowCutter:")
    println(io, " "^indent * "    time: $(alg.time)")
    println(io, " "^indent * "    seed: $(alg.seed)")
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::A) where {A <: PIDBT}
    indent = get(io, :indent, 0)
    println(io, " "^indent * string(A))
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.alg)
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::MinimalChordal{A}) where {A}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "MinimalChordal{$A}:")
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.alg)
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::CompositeRotations{C, A}) where {C, A}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "CompositeRotations{$C, $A}:")
    println(io, " "^indent * "    clique: $(alg.clique)")
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.alg)
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::Compression{A}) where {A}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "Compression{$A}:")
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.alg)
    println(io, " "^indent * "    tao: $(alg.tao)")
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::SimplicialRule{A}) where {A}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "SimplicialRule{$A}:")
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.alg)
    println(io, " "^indent * "    tao: $(alg.tao)")
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::SafeRules{A, L, U}) where {A, L, U}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "SafeRules{$A, $L, $U}:")
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.alg)
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.lb)
    println(io, " "^indent * "    tao: $(alg.tao)")
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::SafeSeparators{A, M}) where {A, M}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "SafeSeparators{$A, $M}:")
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.alg)
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.min)
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::ConnectedComponents{A}) where {A}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "ConnectedComponents{$A}:")
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.alg)
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::BestWidth{A}) where {A}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "BestWidth{$A}:")

    for alg in alg.algs
        show(IOContext(io, :indent => indent + 4), "text/plain", alg)
    end

    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::A) where {A <: Log}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "$A:")
    show(IOContext(io, :indent => indent + 4), "text/plain", alg.alg)
    return
+end

"""
    DEFAULT_ELIMINATION_ALGORITHM = AMF()

The default algorithm.
"""
const DEFAULT_ELIMINATION_ALGORITHM = AMF()

"""
    DEFAULT_MINIMAL_ALGORITHM = MinimalChordal(AMF())
"""
const DEFAULT_MINIMAL_ALGORITHM = MinimalChordal(DEFAULT_ELIMINATION_ALGORITHM)

"""
    RCM = RCMGL

The default variant of the reverse Cuthill-Mckee algorithm.
"""
const RCM = RCMGL

struct PackedSet{I} <: AbstractPackedSet{I}
    data::I

    function PackedSet{I}(data::I) where {I}
        return new{I}(data)
    end
end

function PackedSet{I}() where {I}
    return PackedSet{I}(zero(I))
end

function domain(::Type{PackedSet{I}}) where {I}
    return 8sizeof(I)
end

function packedset(::Type{PackedSet{I}}, i::Int) where I
    return PackedSet{I}(one(I) << (i - 1))
end

function packedset(::Type{PackedSet{I}}, range::AbstractUnitRange{Int}) where I
    return interval(PackedSet{I}, first(range), last(range))
end

function packedset(::Type{PackedSet{I}}, range::OneTo{Int}) where I
    return downset(PackedSet{I}, length(range))
end

# upset: {start, start+1, ..., domain}
function upset(::Type{PackedSet{I}}, start::Int) where {I}
    return PackedSet{I}(typemax(I) << (start - 1))
end

# downset: {1, 2, ..., stop}
function downset(::Type{PackedSet{I}}, stop::Int) where {I}
    return PackedSet{I}(typemax(I) >> (8sizeof(I) - stop))
end

# interval: {start, start+1, ..., stop}
function interval(::Type{PackedSet{I}}, start::Int, stop::Int) where {I}
    return PackedSet{I}((typemax(I) >> (8sizeof(I) - (stop - start + 1))) << (start - 1))
end

function nextset_nonempty(subset::PackedSet{I}, set::PackedSet{I}) where {I}
    return PackedSet{I}((subset.data - one(I)) & set.data)
end

function prevset_nonempty(subset::PackedSet{I}, set::PackedSet{I}) where {I}
    return PackedSet{I}(((subset.data | ~set.data) + one(I)) & set.data)
end

function first_nonempty(set::PackedSet)
    return trailing_zeros(set.data) + 1
end

function last_nonempty(set::PackedSet{I}) where {I}
    return 8sizeof(I) - leading_zeros(set.data)
end

function Random.rand(rng::AbstractRNG, ::SamplerType{PackedSet{I}}) where {I}
    return PackedSet{I}(rand(rng, I))
end

# ------------------- #
# Iteration Interface #
# ------------------- #

function Base.length(set::PackedSet)
    return count_ones(set.data)
end

# ---------------------- #
# Abstract Set Interface #
# ---------------------- #

function Base.isempty(set::PackedSet)
    return iszero(set.data)
end

function Base.union(left::T, right::T) where {T <: PackedSet}
    return T(left.data | right.data)
end

function Base.intersect(left::T, right::T) where {T <: PackedSet}
    return T(left.data & right.data)
end

function Base.setdiff(left::T, right::T) where {T <: PackedSet}
    return T(left.data & ~right.data)
end

function Base.symdiff(left::T, right::T) where {T <: PackedSet}
    return T(left.data ⊻ right.data)
end

function Base.hash(set::PackedSet, h::UInt)
    return hash(set.data, h)
end

function Base.:(==)(left::T, right::T) where {T <: PackedSet}
    return left.data == right.data
end

module CliqueTrees

using AbstractTrees
using Base: OneTo, oneto, @kwdef, @propagate_inbounds
using Base.Iterators
using Base.Order
using Base.Sort: DEFAULT_UNSTABLE, Algorithm as SortingAlgorithm
using FillArrays
using FixedSizeArrays
using Graphs
using Graphs: AbstractSimpleGraph, Coloring, SimpleEdge
using LinearAlgebra
using LinearAlgebra: ldiv
using SparseArrays
using SparseArrays: getcolptr

include("./Utilities.jl/src/Utilities.jl")
include("./AMFLib.jl/src/AMFLib.jl")
include("./MLFLib.jl/src/MLFLib.jl")
include("./MMDLib.jl/src/MMDLib.jl")
include("./PIDBTLib.jl/src/PIDBTLib.jl")

using .Utilities
using .AMFLib
using .MLFLib
using .MMDLib
using .PIDBTLib

const View{T, I} = SubArray{T, 1, Vector{T}, Tuple{UnitRange{I}}, true}

# Graphs
export BipartiteGraph, FBipartiteGraph, BipartiteEdgeIter, pointers, targets

# Lower Bound Algorithms
export MMW, lowerbound

# Dissection Algorithms
export METISND, KaHyParND

# Elimination Algorithms
export BFS,
    MCS,
    LexBFS,
    RCMMD,
    RCMGL,
    RCM,
    LexM,
    MCSM,
    AMF,
    MF,
    MMD,
    AMD,
    SymAMD,
    METIS,
    ND,
    NDS,
    Spectral,
    FlowCutter,
    BT,
    PIDBT,
    MinimalChordal,
    CompositeRotations,
    Compression,
    SafeRules,
    SimplicialRule,
    SafeSeparators,
    ConnectedComponents,
    BestWidth,
    BestFill,
    permutation

# Trees
export Tree, FTree, eliminationtree, setrootindex!

# Supernode Types
export Nodal, Maximal, Fundamental

# Supernode Trees
export SupernodeTree, supernodetree, residuals

# Cliques
export Clique, separator, residual

# Clique Trees
export CliqueTree, cliquetree, treewidth, treefill, separatorwidth, separators

# Abstract Trees
export rootindices, ancestorindices

# Filled Graphs
export FilledGraph, FilledEdgeIter, ischordal, isperfect

include("union_find.jl")
include("abstract_linked_lists.jl")
include("singly_linked_lists.jl")
include("doubly_linked_lists.jl")
include("bipartite_graphs.jl")
include("bipartite_edge_iter.jl")
include("lower_bound_algorithms.jl")
include("dissection_algorithms.jl")
include("elimination_algorithms.jl")
include("parent.jl")
include("trees.jl")
include("supernode_types.jl")
include("supernode_trees.jl")
include("cliques.jl")
include("clique_trees.jl")
include("abstract_trees.jl")
include("filled_graphs.jl")
include("filled_edge_iter.jl")
include("chordal_graphs.jl")
include("ambiguities.jl")
include("packages.jl")
include("mcs_etree.jl")
include("acsd.jl")
include("pr3.jl")
include("pr4.jl")
include("deprecated/symb_facts.jl")
include("deprecated/chol_works.jl")
include("deprecated/ldlt_works.jl")
include("deprecated/chol_facts.jl")
include("deprecated/ldlt_facts.jl")
include("deprecated/lin_works.jl")
include("io.jl")

# Multifrontal submodule
include("Multifrontal.jl/src/Multifrontal.jl")

end

# ===== gemmt! =====
# Triangular gemm: C = α * op(A) * op(B) + β * C, writing only to the triangle specified by uplo

# WARNING: OVER-WRITES OTHER TRIANGLE
function gemmt!(uplo::Val, tA::Val, tB::Val, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T <: BlasFloat}
    gemm!(tA, tB, α, A, B, β, C)
    return
end

function gemmt!(uplo::Val{UPLO}, tA::Val{TA}, tB::Val{TB}, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T, TA, UPLO, TB}
    n = size(C, 1)

    if n <= THRESHOLD
        gemmt2!(uplo, tA, tB, α, A, B, β, C)
        return
    end

    m = prevpow(2, n) >> 1

    C₁₁ = view(C,     1:m,     1:m)
    C₂₂ = view(C, m + 1:n, m + 1:n)

    if TA === :N
        A₁ = view(A,     1:m, :)
        A₂ = view(A, m + 1:n, :)
    else
        A₁ = view(A, :,     1:m)
        A₂ = view(A, :, m + 1:n)
    end

    if TB === :N
        B₁ = view(B, :,     1:m)
        B₂ = view(B, :, m + 1:n)
    else
        B₁ = view(B,     1:m, :)
        B₂ = view(B, m + 1:n, :)
    end

    if UPLO === :L
        C₂₁ = view(C, m + 1:n, 1:m)
        gemx!(tA, tB, α, A₂, B₁, β, C₂₁)
    else
        C₁₂ = view(C, 1:m, m + 1:n)
        gemx!(tA, tB, α, A₁, B₂, β, C₁₂)
    end

    gemmt!(uplo, tA, tB, α, A₁, B₁, β, C₁₁)
    gemmt!(uplo, tA, tB, α, A₂, B₂, β, C₂₂)
    return
end

# ===== gemmt2! =====

function gemmt2!(::Val{UPLO}, ::Val{:N}, ::Val{:N}, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T, UPLO}
    m, n = size(C)

    @inbounds @fastmath for j in axes(C, 2)
        if UPLO === :L
            rng = j:m
        else
            rng = 1:j
        end

        for i in rng
            Δ = zero(T)

            for k in axes(A, 2)
                Δ += A[i, k] * B[k, j]
            end

            if iszero(β)
                C[i, j] = α * Δ
            else
                C[i, j] = α * Δ + β * C[i, j]
            end
        end
    end

    return
end

function gemmt2!(::Val{UPLO}, ::Val{:N}, ::Val{TB}, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T, UPLO, TB}
    m, n = size(C)

    @inbounds @fastmath for j in axes(C, 2)
        if UPLO === :L
            rng = j:m
        else
            rng = 1:j
        end

        if iszero(β)
            for i in rng
                C[i, j] = β
            end
        else
            for i in rng
                C[i, j] *= β
            end
        end
    end

    @inbounds @fastmath for k in axes(A, 2)
        for j in axes(C, 2)
            if UPLO === :L
                rng = j:m
            else
                rng = 1:j
            end

            if TB === :C
                Bjk = conj(B[j, k])
            else
                Bjk = B[j, k]
            end

            for i in rng
                C[i, j] += α * A[i, k] * Bjk
            end
        end
    end

    return
end

function gemmt2!(::Val{UPLO}, ::Val{TA}, ::Val{:N}, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T, UPLO, TA}
    m, n = size(C)

    @inbounds @fastmath for j in axes(C, 2)
        if UPLO === :L
            rng = j:m
        else
            rng = 1:j
        end

        for i in rng
            Δ = zero(T)

            for k in axes(A, 1)
                if TA === :C
                    Aki = conj(A[k, i])
                else
                    Aki = A[k, i]
                end

                Δ += Aki * B[k, j]
            end

            if iszero(β)
                C[i, j] = α * Δ
            else
                C[i, j] = α * Δ + β * C[i, j]
            end
        end
    end

    return
end

function gemmt2!(::Val{UPLO}, ::Val{TA}, ::Val{TB}, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T, UPLO, TA, TB}
    m, n = size(C)

    @inbounds @fastmath for j in axes(C, 2)
        if UPLO === :L
            rng = j:m
        else
            rng = 1:j
        end

        for i in rng
            Δ = zero(T)

            for k in axes(A, 1)
                if TA === :C
                    Aki = conj(A[k, i])
                else
                    Aki = A[k, i]
                end

                if TB === :C
                    Bjk = conj(B[j, k])
                else
                    Bjk = B[j, k]
                end

                Δ += Aki * Bjk
            end

            if iszero(β)
                C[i, j] = α * Δ
            else
                C[i, j] = α * Δ + β * C[i, j]
            end
        end
    end

    return
end

function compressreduce(reduce::F, weights::AbstractVector{W}, graph::AbstractGraph{V}, width::W, tao::Number) where {F <: Function, W <: Number, V <: Integer}
    weights00 = weights; graph00 = graph; width00 = width; n00 = nv(graph00)
    inject03 = Vector{V}(undef, n00); n03 = zero(V)
    # V01
    #  ↓ inject01
    # V00
    #  ↑ inject02
    # V02
    #  ↓ project10
    # V10
    graph02, inject01, inject02, width10 = reduce(weights00, graph00, width00)
    graph10, project10 = compress(graph02, Val(true), tao)
    n02 = nv(graph02); n10 = nv(graph10)

    @inbounds for v01 in oneto(n00 - n02)
        v00 = inject01[v01]
        n03 += one(V); inject03[n03] = v00
    end
    #   inject02 V02
    #        ↙    ↓ project10
    #   V00  →   V10
    #     project11
    weights10 = Vector{W}(undef, n10)
    project11 = BipartiteGraph{V, V}(n00, n10, n00 - n03)
    @inbounds pointers(project11)[begin] = p = one(V)

    @inbounds for v10 in vertices(graph10)
        w10 = zero(W); vv10 = v10 + one(V)

        for v02 in neighbors(project10, v10)
            v00 = inject02[v02]
            w10 += weights00[v00]
            targets(project11)[p] = v00; p += one(V)
        end

        weights10[v10] = w10
        pointers(project11)[vv10] = p
    end

    lo = n10; hi = n00

    @inbounds while lo < hi
        hi = lo
        # V11
        #  ↓ inject11
        # V10
        #  ↑ inject12
        # V12
        #  ↓ project20
        # V20
        graph12, inject11, inject12, width20 = reduce(weights10, graph10, width10)
        graph20, project20 = compress(graph12, Val(true), tao)
        n12 = nv(graph12); n20 = nv(graph20)

        for v11 in oneto(n10 - n12)
            v10 = inject11[v11]

            for v00 in neighbors(project11, v10)
                n03 += one(V); inject03[n03] = v00
            end
        end
        #            inject12
        #          V10  ←   V12
        # project11 ↑        ↓ project20
        #          V00  →   V20
        #           project21

        weights20 = Vector{W}(undef, n20)
        project21 = BipartiteGraph{V, V}(n00, n20, n00 - n03)
        pointers(project21)[begin] = p = one(V)

        for v20 in vertices(graph20)
            w20 = zero(W); vv20 = v20 + one(V)

            for v12 in neighbors(project20, v20)
                v10 = inject12[v12]
                w20 += weights10[v10]

                for v00 in neighbors(project11, v10)
                    targets(project21)[p] = v00; p += one(V)
                end
            end

            weights20[v20] = w20
            pointers(project21)[vv20] = p
        end

        lo = n10 = n20; weights10 = weights20; graph10 = graph20; width10 = width20; project11 = project21
    end

    return weights10, graph10, view(inject03, oneto(n03)), project11, width10
end

# Pre-processing for Triangulation of Probabilistic Networks
# Bodlaender, Koster, Eijkhof, and van der Gaag
#
# Preprocessing Rules for Triangulation of Probabilistic Networks
# Bodlaender, Koster, Eijkhof, and van der Gaag
#
#  PR-4 (PR-3 + Simplicial)
function pr4(weights::AbstractVector{W}, graph::AbstractGraph, width::Number) where {W}
    weights0 = weights; graph0 = graph; width0 = width
    n0 = nv(graph0); weights1 = Vector{W}(undef, n0)

    graph1, stack1, inject1, width1 = pr3(weights0, graph0, width0)
    n1 = nv(graph1); m1 = n0 - n1

    @inbounds for i in oneto(n1)
        weights1[i] = weights0[inject1[i]]
    end

    graph2, stack2, inject2, width2 = sr(weights1, graph1, width1)
    n2 = nv(graph2); m2 = n1 - n2

    @inbounds for i in oneto(m2)
        stack1[i + m1] = inject1[stack2[i]]
    end

    @inbounds for i in oneto(n2)
        inject2[i] = inject1[inject2[i]]
    end

    return (graph2, stack1, inject2, width2)
end

function sr(weights::AbstractVector{W}, graph::AbstractGraph, width::Number) where {W <: Number}
    return sr(weights, graph, convert(W, width))
end

function sr(weights::AbstractVector{W}, graph::AbstractGraph{V}, width::W) where {W <: Number, V <: Integer}
    @assert nv(graph) <= length(weights)

    E = etype(graph); n = nv(graph); m = de(graph); nn = n + one(V)

    # `totdeg` is the total weight of the
    # vertices in the graph
    totdeg = zero(W)

    @inbounds for v in oneto(n)
        totdeg += weights[v]
    end

    marker = FVector{E}(undef, n)
    stack0 = FVector{V}(undef, n)
    stack1 = FVector{V}(undef, n)
    tmpptr = FVector{E}(undef, nn)

    fillin = FVector{E}(undef, n)
    degree = FVector{W}(undef, n)
    number = FVector{V}(undef, n)
    source = FVector{V}(undef, m)
    target = FVector{V}(undef, m)
    begptr = FVector{E}(undef, nn)
    endptr = FVector{E}(undef, n)
    invptr = FVector{E}(undef, m)

    kernel, stack, inject, width = sr_impl!(marker, stack0, stack1,
        tmpptr, fillin, degree, number, source,
        target, begptr, endptr, invptr, totdeg, weights, graph, width)

    return kernel, stack, inject, width
end

function sr_impl!(
        marker::AbstractVector{E},
        stack0::AbstractVector{V},
        stack1::AbstractVector{V},
        tmpptr::AbstractVector{E},
        fillin::AbstractVector{E},
        degree::AbstractVector{W},
        number::AbstractVector{V},
        source::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        totdeg::W,
        weight::AbstractVector{W},
        graph::AbstractGraph{V},
        width::W,
    ) where {W, V, E}
    @assert nv(graph) <= length(marker)
    @assert nv(graph) <= length(stack0)
    @assert nv(graph) <= length(stack1)
    @assert nv(graph) < length(tmpptr)
    @assert nv(graph) <= length(fillin)
    @assert nv(graph) <= length(degree)
    @assert nv(graph) <= length(number)
    @assert de(graph) <= length(source)
    @assert de(graph) <= length(target)
    @assert nv(graph) < length(begptr)
    @assert nv(graph) <= length(endptr)
    @assert de(graph) <= length(invptr)

    # `n` is the number of vertices in the input graph
    n = nv(graph)

    # `hi0` is the number of simplicial vertices
    # `mindeg` is the minimum weighted degree
    hi0, mindeg = sr_init!(marker, stack0, tmpptr, fillin, degree, number,
        target, begptr, endptr, invptr, totdeg, weight, graph)

    # the weighted treewidth is at least the minimum
    # weighted degree
    width = max(width, mindeg)

    # `hi` is the number of eliminated vertices
    hi1 = zero(V)

    # while there exists a simplicial vertex...
    @inbounds while ispositive(hi0)
        # `v` is a simplicial vertex
        hi0, v = pr3_stack_pop!(stack0, hi0)

        # add `v` to the stack of eliminated
        # vertices
        hi1 = pr3_stack_add!(stack1, hi1, v)

        # `deg` is the weighted degree of `v`
        deg = degree[v]

        # `num` is the degree of `v`
        num = number[v]

        # `wgt` is the weight of `v`
        wgt = weight[v]

        # `v` is simplicial: update the lower bound
        width = max(width, deg)

        # `v` is incident to the arcs
        # {`p`, ..., `pend` - 1}
        p = begptr[v]; pend = endptr[v]

        while p < pend
            # `p` is the arc (`v`, `w`)
            w = target[p]

            # `wfil` is the degeneracy of `w`
            wfil = fillin[w]

            # `wdeg` is the weighted degree of `w`
            wdeg = degree[w]

            # `wnum` is the degree of `w`
            wnum = number[w]

            # `q` is the arc (`w`, `v`)
            q = invptr[p]

            # `qend` is the last arc incident to `w`
            qend = endptr[w] -= one(E)

            # replace `v` with a vertex `x` in the
            # neighborhood of `w`
            if q < qend
                # `qend` is the arc (`w`, `x`)
                x = target[q] = target[qend]

                # `qinv` is the arc (`x`, `w`)
                qinv = invptr[q] = invptr[qend]
                invptr[qinv] = q
            end

            # increase the degeneracy of `w` by the
            # degree of `v` and decrease it by the
            # degree of `w`
            fillin[w] = wfil - convert(E, wnum - num)

            # decrease the weighted degree of `w` by
            # the weight of `v`
            degree[w] = wdeg - wgt

            # decrement the degree of `w`
            number[w] = wnum - one(V)

            # if `w` is simplicial...
            if iszero(fillin[w]) && ispositive(wfil)
                # add `w` to the stack of simplicial
                # vertices
                hi0 = pr3_stack_add!(stack0, hi0, w)
            end

            # increment `p`
            p += one(E)
        end
    end

    # construct the reduced graph
    m, n = sr_make!(stack1, target, begptr, endptr,
        stack0, number, tmpptr, source, hi1, n)

    # `kernel` is the reduced graph
    kernel = BipartiteGraph(n, n, m, tmpptr, source)
    return kernel, stack1, stack0, width
end

function sr_make!(
        stack1::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        inj::AbstractVector{V},
        prj::AbstractVector{V},
        ptr::AbstractVector{E},
        tgt::AbstractVector{V},
        hi1::V,
        n::V,
    ) where {V, E}

    # mark eliminated vertices with -1
    @inbounds for i in oneto(hi1)
        w = stack1[i]; prj[w] = -one(V)
    end

    # `v` is a vertex in the reduced graph
    v = one(V)

    # for a vertices `w`...
    @inbounds for w in oneto(n)
        # if `w` is not eliminated...
        if !isnegative(prj[w])
            # associate `v` and `w`
            prj[w] = v
            inj[v] = w

            # increment `v`
            v += one(V)
        end
    end

    # `v` is a vertex in the reduced graph
    @inbounds v = one(V)

    # `p` is an edge incident to `v`
    @inbounds ptr[v] = p = one(E)

    @inbounds while v + hi1 <= n
        # `w` is the vertex associated
        # to `v`
        w = inj[v]

        # `w` is incident to the arcs
        #     {`q`, ..., `qend` - 1}
        q = begptr[w]; qend = endptr[w]

        while q < qend
            # `q` is the arc (`w`, `x`)
            x = target[q]; q += one(E)
            tgt[p] = prj[x]; p += one(E)
        end

        v += one(V); ptr[v] = p
    end

    # `m` is the number of arcs in the
    # reduced graph
    m = p - one(E)

    # `n` is the number of vertices in the
    # reduced graph
    n = v - one(V)
    return m, n
end

function sr_init!(
        marker::AbstractVector{E},
        stack0::AbstractVector{V},
        tmpptr::AbstractVector{E},
        fillin::AbstractVector{E},
        degree::AbstractVector{W},
        number::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        totdeg::W,
        weight::AbstractVector{W},
        graph::AbstractGraph{V},
    ) where {W, V, E}

    # `n` is the number of vertices in the
    # input graph
    n = nv(graph); nn = n + one(V)

    # `hi0` is the number of simplicial
    # vertices
    hi0 = zero(V)

    # `tag` is used for marking vertices
    tag = zero(E)

    # `mindeg` is the minimum weighted degree
    mindeg = totdeg

    # `p` is the current arc
    p = one(E)

    @inbounds  for v in vertices(graph)
        marker[v] = tag
    end

    @inbounds for v in vertices(graph)
        tmpptr[v] = begptr[v] = endptr[v] = p

        # `deg` is the weighted degree of `v`
        deg = weight[v]

        # `num` is the degree of `v`
        num = zero(V)

        # `fil` is the degeneracy of `v`
        fil = zero(E)

        # for all neighbors `w` of `v`...
        for w in neighbors(graph, v)
            # ignore self loops
            if v != w
                # `p` is the arc (`v`, `w`)
                p += one(E)

                # increase `deg` by the weight of `w`
                deg += weight[w]

                # increment `num`
                num += one(V)

                # increment `tag`
                tag += one(E)

                # mark neighbors of `w` with `tag`
                for x in neighbors(graph, w)
                    if x != w
                        marker[x] = tag
                    end
                end

                # for all neighbors `ww` of `v`...
                for ww in neighbors(graph, v)
                    w == ww && break

                    # if `ww` is not adjacent to `w`...
                    if v != ww && marker[ww] < tag
                        # increment `fil`
                        fil += one(E)
                    end
                end
            end
        end

        # if `v` is simplicial...
        if iszero(fil)
            # add `v` to the stack of simplicial vertices
            hi0 = pr3_stack_add!(stack0, hi0, v)
        end

        # update the minimum weighted degree
        mindeg = min(mindeg, deg)
        fillin[v] = fil
        degree[v] = deg
        number[v] = num
    end

    @inbounds for v in vertices(graph), w in neighbors(graph, v)
        if v != w
            # `q` is the arc (`w`, `v`)
            q = endptr[w]; target[q] = v; endptr[w] = q + one(E)
        end
    end

    @inbounds for v in vertices(graph)
        # the arcs {`p`, ..., `pend` - 1} are incident
        # to `v`
        p = begptr[v]; pend = endptr[v]

        while p < pend
            # `p` is the arc (`v`, `w`)
            w = target[p]

            # `q` is the arc (`w`, `v`)
            q = tmpptr[w]; invptr[p] = q; tmpptr[w] = q + one(E)
            p += one(E)
        end
    end

    if ispositive(n)
        @inbounds begptr[nn] = endptr[n]
    end

    return hi0, mindeg
end

struct NoRegularization <: AbstractRegularization end

function initialize(::AbstractMatrix, S::AbstractVector, R::NoRegularization)
    return R
end

function checksigns(S::AbstractVector, ::NoRegularization)
    for s in S
        if !iszero(s) && !isone(s) && !isone(-s)
            return false
        end
    end

    return true
end

function checksigns(S::AbstractVector, ::AbstractRegularization)
    for s in S
        if !isone(s) && !isone(-s)
            return false
        end
    end

    return true
end

function regularize(::NoRegularization, S::AbstractVector, Djj, j::Integer)
    if !iszero(S[j]) && !ispositive(real(S[j]) * Djj)
        return zero(Djj)
    else
        return Djj
    end
end

# Fast path for nn = 1: D is scalar, L is vector (l is ignored)
function regularize(::NoRegularization, s, Djj, ::AbstractVector)
    if !iszero(s) && !ispositive(real(s) * Djj)
        return zero(Djj)
    else
        return Djj
    end
end

"""
    LowerBoundAlgorithm

An algorithm for computing a lower bound to the treewidth of a graph. The options are

| type          | name            | time | space    |
|:--------------|:----------------|:-----|:---------|
| [`MMW`](@ref) | minor-min-width |      | O(m + n) |
"""
abstract type LowerBoundAlgorithm end

"""
    WidthOrAlgorithm = Union{Number, LowerBoundAlgorithm}
"""
const WidthOrAlgorithm = Union{Number, LowerBoundAlgorithm}

"""
    MMW{S} <: LowerBoundAlgorithm

    MMW{S}()

The minor-min-width heuristic.

### Parameters

  - `S`: strategy
    - `1`: min-d (fast)
    - `2`: max-d (fast)
    - `3`: least-c (slow)

### References

  - Gogate, Vibhav, and Rina Dechter. "A complete anytime algorithm for treewidth." *Proceedings of the 20th conference on Uncertainty in artificial intelligence.* 2004.
  - Bodlaender, Hans, Thomas Wolle, and Arie Koster. "Contraction and treewidth lower bounds." *Journal of Graph Algorithms and Applications* 10.1 (2006): 5-49.
"""
struct MMW{S} <: LowerBoundAlgorithm end

function MMW()
    return MMW{3}()
end

"""
    lowerbound([weights, ]graph;
        alg::WidthOrAlgorithm=DEFAULT_LOWER_BOUND_ALGORITHM)

Compute a lower bound to the treewidth of a graph.

```jldoctest
julia> using CliqueTrees

julia> graph = [
           0 1 0 0 0 0 0 0
           1 0 1 0 0 1 0 0
           0 1 0 1 0 1 1 1
           0 0 1 0 0 0 0 0
           0 0 0 0 0 1 1 0
           0 1 1 0 1 0 0 0
           0 0 1 0 1 0 0 1
           0 0 1 0 0 0 1 0
       ];

julia> lowerbound(graph)
2
```
"""
function lowerbound(graph; alg::WidthOrAlgorithm = DEFAULT_LOWER_BOUND_ALGORITHM)
    return lowerbound(graph, alg)
end

function lowerbound(graph, alg::WidthOrAlgorithm)
    return lowerbound(BipartiteGraph(graph), alg)
end

function lowerbound(graph::AbstractGraph{V}, width::Integer) where {V}
    return convert(V, width)
end

function lowerbound(graph::AbstractGraph{V}, alg::LowerBoundAlgorithm) where {V}
    n = nv(graph); weights = Ones{V}(n)
    return lowerbound(weights, graph, alg) - one(V)
end

function lowerbound(weights::AbstractVector, graph; alg::WidthOrAlgorithm = DEFAULT_LOWER_BOUND_ALGORITHM)
    return lowerbound(weights, graph, alg)
end

function lowerbound(weights::AbstractVector, graph, alg::WidthOrAlgorithm)
    return lowerbound(weights, BipartiteGraph(graph), alg)
end

function lowerbound(weights::AbstractVector{W}, graph::AbstractGraph, width::Number) where {W}
    return convert(W, width)
end

function lowerbound(weights::AbstractVector, graph::AbstractGraph, ::MMW{S}) where {S}
    return mmw(weights, graph, Val(S))
end

function mmw(weights::AbstractVector{W}, graph::AbstractGraph{V}, strategy::Val) where {W, V}
    @assert nv(graph) <= length(weights)

    n = nv(graph)
    intweights = FVector{V}(undef, n)

    @inbounds for v in vertices(graph)
        intweights[v] = trunc(V, weights[v])
    end

    width = mmw(intweights, graph, strategy)
    return convert(W, width)
end

function mmw(weights::AbstractVector{V}, graph::AbstractGraph{V}, strategy::Val) where {V}
    @assert nv(graph) <= length(weights)

    E = etype(graph); n = nv(graph); m = de(graph); nn = n + one(V)

    # `totdeg` is the total weight of the
    # vertices in the graph
    totdeg = zero(V)

    @inbounds for v in oneto(n)
        totdeg += weights[v]
    end
    
    marker = FVector{V}(undef, n)
    vstack = FVector{V}(undef, n)
    tmpptr = FVector{E}(undef, n)

    degree = FVector{V}(undef, n)
    source = FVector{V}(undef, m)
    target = FVector{V}(undef, m)
    begptr = FVector{E}(undef, nn)
    endptr = FVector{E}(undef, n)
    invptr = FVector{E}(undef, m)

    head = FVector{V}(undef, totdeg)
    prev = FVector{V}(undef, n)
    next = FVector{V}(undef, n)
    
    width = mmw_impl!(marker, vstack, tmpptr, degree, source, target, begptr,
        endptr, invptr, head, prev, next, totdeg, weights, graph, strategy)
    
    return width
end

"""
  mmw_impl!(marker, vstack, tmpptr, degree, source, target, begptr,
    endptr, invptr, head, prev, next, totdeg, weight, graph, strategy)  

Contraction and Treewidth Lower Bounds
Bodlaender, Koster, and Wolle
MMD+ heuristic

A Complete Anytime Algorithm for Treewidth
Gogate and Dechter
minor-min-width

Find a lower bound to the weighted treewidth of a graph
by constructing a sequence of graph minors. The treewidth
of the graph is lower-bounded by the treewidth of each
minor, and the treewidth of each minor is lower-bounded by
its minimum degree.

The algorithm employs a data structure called a *quotient graph.*
It is a directed graph with two types of vertices: elements and
supernodes. The arcs in the graph obey the following invariant
  - every supernode w has at most one predecessor v, which must
    be an element
We say that an element w is *reachable* by another element v if
there exists a path (v, x₁, ..., xₙ, w) from v to w through
supernodes {x₁, ..., xₙ}. Reachability is a symmetric, irreflexive
relation on the set of elements.

input parameters:
  - `totdeg`: total vertex weight
  - `weight`: vertex weight
  - `graph`: input graph
  - `S`: strategy
    - `1`: min-d (fast)
    - `2`: max-d (fast)
    - `3`: least-c (slow)

output parameters:
  - `maxmindeg`: maximum minimum degree

working arrays:
  - miscellaneous:
    - `marker`: marker array
    - `vstack`: vertex stack
    - `tmpptr`: temporary pointer array 
  - quotient graph:
    - `source`: the source vertex of an edge
    - `target`: the target vertex of an edge
      - positive vertices are elements
      - negative vertices are supernodes
    - `begptr`: the first edge incident to a vertex
    - `endptr`: the final edge incident to a vertex
    - `invptr`: the reverse of an edge
 - vertex-degree bucket queue:
    - `head`: the first vertex in a bucket
    - `prev`: the predecessor of a vertex
    - `next`: the successor of a vertex
"""
function mmw_impl!(
        marker::AbstractVector{V},
        vstack::AbstractVector{V},
        tmpptr::AbstractVector{E},
        degree::AbstractVector{V},
        source::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        head::AbstractVector{V},
        prev::AbstractVector{V},
        next::AbstractVector{V},
        totdeg::V,
        weight::AbstractVector{V},
        graph::AbstractGraph{V},
        strategy::Val,
    ) where {V <: Signed, E}
    
    @assert nv(graph) <= length(marker)
    @assert nv(graph) <= length(degree)
    @assert nv(graph) <= length(vstack)
    @assert ne(graph) <= length(source)
    @assert ne(graph) <= length(target)
    @assert nv(graph) <= length(tmpptr)
    @assert nv(graph) <  length(begptr)
    @assert nv(graph) <= length(endptr)
    @assert ne(graph) <= length(invptr)
    @assert totdeg    <= length(head)
    @assert nv(graph) <= length(prev)
    @assert nv(graph) <= length(next)

    # `set(i)` constructs the bucket for weighted degree `i`
    function set(i::V)
        @inbounds h = view(head, i)
        return DoublyLinkedList(h, prev, next)
    end

    # `n` is the number of vertices in the graph    
    n = nv(graph)

    # `mindeg` is the minimum weighted degree
    # `maxdeg` is the maximum weighted degree
    mindeg, maxdeg = mmw_init!(marker, tmpptr, degree, source, target,
        begptr, endptr, invptr, head, prev, next, totdeg, weight, graph)

    # `maxmindeg` is the largest value of `mindeg`
    # encountered during the algorithm
    maxmindeg = zero(V)

    @inbounds for tag in oneto(n)
        # find the new minimum degree        
        while isempty(set(mindeg))
            mindeg += one(V)
        end

        # find the new maximum degree
        while isempty(set(maxdeg))
            maxdeg -= one(V)
        end

        # update `maxmindeg`
        maxmindeg = max(maxmindeg, mindeg)

        # select a vertex of minimum degree
        v = popfirst!(set(mindeg))

        # find a neighbor according to strategy `S`
        w = mmw_search!(marker, vstack, degree, target,
            begptr, endptr, invptr, weight, tag, v, n, strategy)

        # if a neighbor was found, contract the edge
        # {`v`, `w`}, turning `v` into a supernode
        if ispositive(w)
            mmw_contract!(marker, vstack, degree, source, target,
                begptr, endptr, invptr, head, prev, next, weight, tag, v, w)

            # the weighted degree of `w` may have increased
            maxdeg = max(maxdeg, degree[w])

        # otherwise, remove `v` from the graph
        else
            mmw_remove!(vstack, degree, source, target,
                begptr, endptr, invptr, head, prev, next, weight, v)
        end

        # the weighted degree of every element reachable by
        # `v` has decreased by the weight of `v`
        mindeg = max(mindeg - weight[v], one(V))
    end

    return maxmindeg
end

"""
    mmw_init!(marker, tmpptr, degree, source, target, begptr,
        endptr, invptr, head, prev, next, totdeg, weight, graph)

Initialize quotient graph and degree bucket queue.

input parameters:
  - `weight`: vertex weight
  - `graph`: input graph
  - `totdeg`: total vertex weight

output parameters:
 - `mindeg`: minimum weighted degree
 - `maxdeg`: maximum weighted degree
"""
function mmw_init!(
        marker::AbstractVector{V},
        tmpptr::AbstractVector{E},
        degree::AbstractVector{V},
        source::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        head::AbstractVector{V},
        prev::AbstractVector{V},
        next::AbstractVector{V},
        totdeg::V,
        weight::AbstractVector{V},
        graph::AbstractGraph{V},
    ) where {V, E}
 
    n = nv(graph); nn = n + one(V)

    # `set(i)` constructs the bucket for weighted degree `i`    
    function set(i::V)
        @inbounds h = view(head, i)
        return DoublyLinkedList(h, prev, next)
    end
   
    # empty the bucket queue
    @inbounds for v in oneto(totdeg)
        head[v] = zero(V)
    end
 
    # `mindeg` is the minimum weighted degree
    # `maxdeg` is the maximum weighted degree
    mindeg = totdeg; maxdeg = zero(V)

    # `p` is the current arc
    p = one(E)

    @inbounds for v in vertices(graph)
        tmpptr[v] = begptr[v] = endptr[v] = p
        marker[v] = zero(V)

        # `deg` is the weighted degree of `v`
        deg = weight[v]
        
        for w in neighbors(graph, v)
            if v != w
                # `p` is the arc (`v`, `w`)
                source[p] = v; p += one(E)
                deg += weight[w]
            end
        end
        
        mindeg = min(mindeg, deg)
        maxdeg = max(maxdeg, deg)
        degree[v] = deg; pushfirst!(set(deg), v)
    end
    
    @inbounds for v in vertices(graph), w in neighbors(graph, v)
        if v != w
            # `q` is the arc (`w`, `v`)
            q = endptr[w]; target[q] = v; endptr[w] = q + one(E)
        end
    end
    
    @inbounds for v in vertices(graph)
        # the arcs {`p`, ..., `pend` - 1} are incident
        # to `v`
        p = begptr[v]; pend = endptr[v]
        
        while p < pend
            # `p` is the arc (`v`, `w`)
            w = target[p]

            # `q` is the arc (`w`, `v`)
            q = tmpptr[w]; invptr[p] = q; tmpptr[w] = q + one(E)
            p += one(E)
        end
    end

    if ispositive(n)
        @inbounds begptr[nn] = endptr[n]
    end
    
    return mindeg, maxdeg
end

"""
    mmw_search!(marker, vstack, degree, target,
        begptr, endptr, invptr, weight, tag, v, n, strategy)

Find an element reachable by `v` using the min-d or
max-d heuristics. The min-d heuristic selects an element
with the least weighted degree. The max-d heuristic
selects an element with the greatest weighted degree.

input parameters:
 - `tag`: tag for marking vertices
 - `v`: minimum degree vertex
 - `n`: number of vertices
 - `S`: strategy
   - `1`: min-d
   - `2`: max-d

output parameters:
 - `w`: chosen element
"""
function mmw_search!(
        marker::AbstractVector{V},
        vstack::AbstractVector{V},
        degree::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        weight::AbstractVector{V},
        tag::V,
        v::V,
        n::V,
        strategy::Val{S},
    ) where {V, E, S}
   
    # `wgt` is the weight of `v` 
    @inbounds wgt = weight[v]

    # `w` is the chosen element
    w = deg = zero(V)

    w, deg = mmw_reach!((w, deg), vstack,
            target, begptr, endptr, invptr, v) do (w, deg), pp, ww
        # `ww` is reachable by `v`; `wwgt` is its weight
        @inbounds wwgt = weight[ww]

        if wwgt <= wgt
            # `ddeg` is the weighted degree of `ww`
            @inbounds ddeg = degree[ww]

            if iszero(w) || (isone(S) && ddeg < deg) || (istwo(S) && ddeg > deg)
                w, deg = ww, ddeg
            end
        end

        return (w, deg)
    end

    return w
end

"""
    mmw_search!(marker, vstack, degree, target,
        begptr, endptr, invptr, weight, tag, v, n, strategy)

Find an element reachable by `v` using the least-c
heuristic. The least-c heuristic selects a neighbor
`w` that minimizes the sum
   Σ weight(x)
 x ∈ N(v) ∩ N(w)

input parameters:
 - `tag`: tag for marking vertices
 - `v`: minimum degree vertex
 - `n`: number of vertices

output parameters:
 - `w`: chosen element
"""
function mmw_search!(
        marker::AbstractVector{V},
        vstack::AbstractVector{V},
        degree::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        weight::AbstractVector{V},
        tag::V,
        v::V,
        n::V,
        strategy::Val{3},
    ) where {V, E}

    # mark the elements reachable by `v` and write them
    # to `vstack`
    numend = n + one(V)

    numend = mmw_reach!(numend, vstack, 
            target, begptr, endptr, invptr, v) do numend, p, w
        # `w` is reachable by `v`; mark `w` and push it
        # to the stack
        @inbounds numend -= one(V); vstack[numend] = w
        @inbounds marker[w] = -tag
        return numend
    end
   
    # `w` is the chosen neighbor of `v`
    w = zero(V)

    # `scr` is the score of `w`
    scr = zero(V)

    # `wgt` is the weight of `v`
    @inbounds wgt = weight[v]

    # elements reachable by `v` are located at the
    # indices (`numend`, ..., `n`) in `vstack`
    @inbounds while numend <= n
        # `ww` is reachable by `v`
        ww = vstack[numend]; numend += one(V)

        # if the weight of `ww` is no greater than
        # the weight of `v`, compute its score
        if weight[ww] <= wgt
            # `sscr` is the score of `ww`
            sscr = zero(V)

            sscr = mmw_reach!(sscr, vstack,
                    target, begptr, endptr, invptr, ww) do scr, p, w
                # `ttag` indicates whether `w` is reachable by `v`
                #  - `ttag` = `-tag`: reachable
                #  - `ttag` ≠ `-tag`: not reachable
                @inbounds ttag = marker[w]

                # if `w` is reachable by `v`, increase
                # the score of `ww` by the weight of `w`
                if ttag == -tag
                    @inbounds scr += weight[w]
                end

                return scr
            end

            # store the element `w` with the smallest
            # score
            if iszero(w) || sscr < scr
                w, scr = ww, sscr
            end
        end
    end

    return w
end

"""
    mmw_contract!(marker, vstack, degree, source, begptr,
        endptr, invptr, head, prev, next, weight, tag, v, w)

Contract the edge {`v`, `w`}, turning the
element `v` into a supernode.

input parameters:
 - `tag`: tag for marking vertices
 - `v`: minimum degree vertex
 - `w`: neighbor of `v`
"""
function mmw_contract!(
        marker::AbstractVector{V},
        vstack::AbstractVector{V},
        degree::AbstractVector{V},
        source::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        head::AbstractVector{V},
        prev::AbstractVector{V},
        next::AbstractVector{V},
        weight::AbstractVector{V},
        tag::V,
        v::V,
        w::V,
    ) where {V, E}
    
    # `set(i)` constructs the bucket for weighted degree `i`
    function set(i::V)
        @inbounds h = view(head, i)
        return DoublyLinkedList(h, prev, next)
    end

    # mark `w`
    @inbounds marker[w] = tag

    # mark the elements reachable by `w`
    mmw_reach!(nothing, vstack,
            target, begptr, endptr, invptr, w) do _, pp, ww
        # `ww` is reachable by `w`; mark it
        @inbounds marker[ww] = tag
        return
    end

    # `wgt` is the weight of `v`
    @inbounds wgt = weight[v]

    # `del` is the difference between the weight
    # of `v` and the weight of `w`
    @inbounds del = wgt - weight[w]

    # `deg` is the weighted degree of `w`
    @inbounds deg = degree[w]

    # push `v` to the stack
    @inbounds num = one(V); vstack[num] = v

    @inbounds while ispositive(num)
        # `vv` is a supernode adjacent to `v`
        vv = vstack[num]; num -= one(V)

        # the arcs {`pp`, ..., `ppend` - 1} are incident
        # to `vv`
        pp = begptr[vv]; ppend = endptr[vv]

        while pp < ppend
            # `ww` is adjacent to `vv` and reachable by `v`
            ww = target[pp]

            # if `ww` is an element, update the graph
            if ispositive(ww)
                # `qq` is the reverse of `pp`
                qq = invptr[pp]

                # if `ww` is not equal to or reachable by `w`, add
                # it to the neighborhood of `ww`
                if marker[ww] < tag
                    target[qq] = w; pp += one(E)

                    # increase the weighted degree of `w` by the
                    # weight of `ww`
                    deg += weight[ww]

                    # increase the weighted degree of `ww` by the
                    # weight of `w` and decrease it by the weight
                    # of `v`
                    if ispositive(del)
                        delete!(set(degree[ww]), ww)
                        degree[ww] -= del; pushfirst!(set(degree[ww]), ww)
                    end

                # otherwise, `ww` is either equal to or reachable by `w`
                else
                    # replace `ww` with a vertex `xx` in the neighborhood
                    # of `vv`
                    ppend -= one(E)

                    if pp < ppend
                        # `xx` is adjacent to `vv` and reachable by `v`
                        xx = target[pp] = target[ppend]

                        if ispositive(xx)
                            # `xx` is an element; `ppinv` is the arc
                            # (`xx`, `v`)
                            ppinv = invptr[pp] = invptr[ppend]
                            invptr[ppinv] = pp
                        end
                    end

                    # if `ww` is equal to `w`, replace `v` with `-v` in
                    # the neighborhood of `ww`
                    if w == ww
                        target[qq] = -v

                        # decrease the weighted degree of `w` by the
                        # weight of `v`
                        deg -= wgt

                    # otherwise, replace `v` with a vertex `xx` in the
                    # neighborhood of `ww`
                    else
                        qqend = endptr[source[qq]] -= one(E)

                        if qq < qqend
                            # `xx` is adjacent to `ww` and reachable by `v`
                            xx = target[qq] = target[qqend]

                            if ispositive(xx)
                                # `xx` is an element; `qqinv` is the arc
                                # (`xx`, `v`)
                                qqinv = invptr[qq] = invptr[qqend]
                                invptr[qqinv] = qq
                            end
                        end

                        # increase the weighted degree of `ww` by
                        # the weight of `v`
                        delete!(set(degree[ww]), ww)
                        degree[ww] -= wgt; pushfirst!(set(degree[ww]), ww)
                    end

                end

            # otherwise, `ww` is a supernode
            else
                # push `ww` to the stack
                ww = -ww
                num += one(V); vstack[num] = ww                           
                pp += one(E)
            end
        end

        endptr[vv] = ppend
    end

    # update the weighted degree of `w`
    @inbounds delete!(set(degree[w]), w)
    @inbounds degree[w] = deg; pushfirst!(set(deg), w)
    return
end

"""
    mmw_remove!(vstack, degree, source, target,
        begptr, endptr, invptr, head, prev, next, weight, v)

Remove the vertex `v` from the graph.

input parameters:
 - `v`: minimum degree vertex
"""
function mmw_remove!(
        vstack::AbstractVector{V},
        degree::AbstractVector{V},
        source::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        head::AbstractVector{V},
        prev::AbstractVector{V},
        next::AbstractVector{V},
        weight::AbstractVector{V},
        v::V,
    ) where {V, E}
   
    # `wgt` is the weight of `v` 
    @inbounds wgt = weight[v]

    # `set(i)` constructs the bucket for weighted degree `i`
    function set(i::V)
        @inbounds h = view(head, i)
        return DoublyLinkedList(h, prev, next)
    end

    # remove `v` from the graph
    mmw_reach!(nothing, vstack,
            target, begptr, endptr, invptr, v) do _, p, w
        # `w` is reachable by `v` through a path
        #    (`v`, ..., `vv`, `w`),
        # and `p` is the arc (`vv`, `w`)
        #
        # `v` is reachable by `w` through a path
        #    (`w`, ..., `ww`, `v`),
        # and `q` is the arc (`ww`, `v`)
        @inbounds q = invptr[p]; ww = source[q]

        # `qend` = (`ww`, `x`) is the last arc incident
        # to `ww`
        #
        # if `w` is not equal to `x`, replace `w` with `x`
        # in the neighborhood of `ww`
        @inbounds qend = endptr[ww] -= one(E)
        if q < qend
            @inbounds x = target[q] = target[qend]

            if ispositive(x)
                # `x` is an element; `qinv` is the arc
                # (`x`, `w`)
                @inbounds qinv = invptr[q] = invptr[qend]
                @inbounds invptr[qinv] = q
            end
        end

        # decrease the weighted degree of `w` by the
        # weight of `v`
        @inbounds delete!(set(degree[w]), w)
        @inbounds degree[w] -= wgt; pushfirst!(set(degree[w]), w)
        return
    end
     
    return
end

"""
    mmw_reach!(combine, result, vstack,
        target, begptr, endptr, invptr, v)

Compute the linear fold
  combine(combine(combine(combine(result, w), x), y), ...)
where {w, x, y, ...} are the elements reachable by `v`.

input parameters:
 - `v`: an element

output parameters:
 - `result`: folded value
"""
function mmw_reach!(
        combine::Function,
        result,
        vstack::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        v::V,
    ) where {V, E}
    # push `v` to the stack
    @inbounds num = one(V); vstack[num] = v

    @inbounds while ispositive(num)
        # `vv` is a supernode adjacent to `v`
        vv = vstack[num]; num -= one(V)

        # the arcs {`pp`, ..., `ppend` - 1} are incident
        # to `vv`
        pp = begptr[vv]; ppend = endptr[vv]

        # `ppnxt` is the largest possible value of `ppend`
        ppnxt = begptr[vv + one(V)]

        while pp < ppend
            # `ww` is adjacent to `vv` and reachable by `v`
            ww = target[pp]

            # if `ww` is an element, fold it into `result`
            if ispositive(ww)
                result = combine(result, pp, ww)
                pp += one(E)

            # otherwise, `ww` is a supernode
            else
                # the arcs {`qq`, ..., `qqend` - 1} are incident
                # to `ww`
                ww = -ww; qq = begptr[ww]; qqend = endptr[ww]

                # while there is space, move neighbors of `ww` 
                # into the neighborhood of `vv`
                while ppend < ppnxt && qq < qqend
                    qqend -= one(E)

                    # `xx` is adjacent to `ww` and reachable by `v`
                    xx = target[ppend] = target[qqend]

                    if ispositive(xx)
                        # `xx` is an element; `ppinv` is the arc
                        # (`xx`, `v`)
                        ppinv = invptr[ppend] = invptr[qqend]
                        invptr[ppinv] = ppend
                    end

                    ppend += one(E)
                end

                endptr[ww] = qqend

                # if `ww` has more than two neighbors, push
                # it to the stack
                if qq < qqend - one(E)
                    num += one(V); vstack[num] = ww                           
                    pp += one(E)

                # if `ww` has only one neighbor `xx`, replace
                # `ww` with `xx` in the neighborhood of `vv` 
                elseif qq == qqend - one(E)
                    xx = target[pp] = target[qq]

                    if ispositive(xx)
                        # `xx` is an element; `ppinv` is the arc
                        # (`xx`, `v`)
                        ppinv = invptr[pp] = invptr[qq]
                        invptr[ppinv] = pp
                    end

                # if `ww` has no neighbors, replace it with a vertex
                # `xx` in the neighborhood of `vv`
                else
                    ppend -= one(E)

                    if pp < ppend
                        # `xx` is adjacent to `vv` and reachable by `v`
                        xx = target[pp] = target[ppend]

                        if ispositive(xx)
                            # `xx` is an element; `ppinv` is the arc
                            # (`xx`, `v`)
                            ppinv = invptr[pp] = invptr[ppend]
                            invptr[ppinv] = pp
                        end
                    end
                end
            end
        end

        endptr[vv] = ppend
    end
    
    return result
end

function Base.convert(::Type{MMW{S}}, alg::MMW) where {S}
    return MMW{S}()
end

function Base.show(io::IO, ::MIME"text/plain", alg::MMW{S}) where {S}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "MMW{$S}")
    return nothing
end

"""
    DEFAULT_LOWER_BOUND_ALGORITHM = MMW()
"""
const DEFAULT_LOWER_BOUND_ALGORITHM = MMW()

function unfactorize!(L::AbstractTriangular{T}, d::AbstractVector) where {T}
    M = parent(L)
    W = FVector{T}(undef, length(L))

    if L isa LowerTriangular || L isa UnitLowerTriangular
        uplo = Val(:L)
    else
        uplo = Val(:U)
    end

    if L isa LowerTriangular || L isa UpperTriangular
        diag = Val(:N)
    else
        diag = Val(:U)
    end

    unchol_dense!(M, d, W, uplo, diag)
    return 0
end

function unchol_dense!(
        A::AbstractMatrix{T},
        d::AbstractVector{T},
        Wval::AbstractVector{T},
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {UPLO, DIAG, T}
    W = reshape(view(Wval, 1:length(A)), size(A))
    fill!(W, zero(T))
    copytri!(W, A, uplo)

    if UPLO === :L
        side = Val(:R)
    else
        side = Val(:L)
    end

    if DIAG === :U
        @inbounds for i in diagind(W)
            W[i] = one(T)
        end
    end

    cmul!(side, diag, W, d)
    trmm!(side, uplo, Val(:C), diag, one(T), A, W)

    copytri!(A, W, uplo)
    return
end

struct CMPLHessian{UPLO, T, I}
    A::FChordalTriangular{:N, UPLO, T, I}
    B::FChordalTriangular{:N, UPLO, T, I}
    C::FChordalTriangular{:N, UPLO, T, I}
    Mptr::FVector{I}
    Mval::FVector{T}
    Fval::FVector{T}
    fill::FVector{I}
    frow::FVector{I}
    fcol::FVector{I}
    prec::FVector{T}
end

function Base.size(H::CMPLHessian)
    return (length(H.fill), length(H.fill))
end

function Base.eltype(::CMPLHessian{UPLO, T}) where {UPLO, T}
    return T
end

function LinearAlgebra.mul!(c::AbstractVector{T}, H::CMPLHessian{UPLO, T, I}, b::AbstractVector{T}) where {UPLO, T, I}
    fill!(H.C, zero(T))

    for i in eachindex(H.fill)
        setflatindex!(H.C, b[i] / 2, H.fill[i])
    end

    info = fisher_impl!(H.Mptr, H.Mval, H.Fval, H.B, H.A, H.C, Val(true))

    ispositive(info) && throw(PosDefException(info))

    for i in eachindex(H.fill)
        c[i] = 2 * getflatindex(H.C, H.fill[i])
    end

    return c
end

function complete!(
        F::AbstractCholesky,
        A::HermOrSym;
        alpha::Real = 0.01,
        beta::Real = 0.5,
        tol::Real = 1e-7,
        maxiter::Integer = 50,
        cgmaxiter::Integer = 100,
    )
    C = sympermute(parent(A), F.invp, A.uplo, char(F.uplo))
    F.info[] = complete!(triangular(F), C; alpha, beta, tol, maxiter, cgmaxiter)
    return F
end

function complete!(
        L::FChordalTriangular{:N, UPLO, T, I},
        A::SparseMatrixCSC;
        alpha::Real = 0.01,
        beta::Real = 0.5,
        tol::Real = 1e-7,
        maxiter::Integer = 50,
        cgmaxiter::Integer = 100,
    ) where {UPLO, T, I}
    copyto!(L, A)

    n = size(L, 1)
    m = half(ndz(L.S) + ncl(L.S)) + nlz(L.S) - nnz(A)
    diag = FVector{I}(undef, n)
    fill = FVector{I}(undef, m)
    frow = FVector{I}(undef, m)
    fcol = FVector{I}(undef, m)
    complete_gen_diag_ind!(diag, L.S)
    complete_gen_fill!(fill, frow, fcol, diag, L.S, A, L.uplo)

    B = similar(L)
    C = similar(L)

    Mptr = FVector{I}(undef, L.S.nMptr)
    Mval = FVector{T}(undef, L.S.nMval)
    Fval = FVector{T}(undef, L.S.nFval * L.S.nFval)
    Wval = FVector{T}(undef, L.S.nFval * L.S.nFval)

    dual = FVector{T}(undef, length(fill))
    grad = FVector{T}(undef, length(fill))
    prec = FVector{T}(undef, length(fill))
    workspace = cgworkspace(T, length(fill))
    H = CMPLHessian(L, B, C, Mptr, Mval, Fval, fill, frow, fcol, prec)

    complete_gen_impl!(workspace, L, B, C, H, Mptr, Mval, Fval, Wval, fill, dual, grad,
        convert(Int, cgmaxiter), convert(Int, maxiter), convert(T, alpha), convert(T, beta), convert(T, tol))

    return zero(I)
end

function complete_gen_prec!(H::CMPLHessian{UPLO, T, I}) where {UPLO, T, I}
    C = H.C

    for k in eachindex(H.fill)
        Xinvii = getflatindex(C, H.frow[k])
        Xinvjj = getflatindex(C, H.fcol[k])
        Xinvij = getflatindex(C, H.fill[k])
        H.prec[k] = Xinvii * Xinvjj + Xinvij * Xinvij
    end

    return
end

#
# Newton-CG for maximum determinant matrix completion.
#
# Let Ω ⊆ [n] × [n] index the specified entries, and let
#
#     P: Rⁿˣⁿ → R^Ω    denote projection onto Ω
#     E: R^Ω → Rⁿˣⁿ    denote extension by zero
#
# We solve the dual problem
#
#     maximize    logdet(C + E(y))
#     subject to  C + E(y) ≻ 0
#
# where y ∈ R^m are the fill entries. Let X be the max-det completion
# of C + E(y), and let ψ(S) = -logdet(S) be the dual barrier. Then
#
#     ∇f(y)     = -P ∇ψ(X)
#     ∇²f(y)[z] = -P ∇²ψ(X)[E(z)]
#
#
function complete_gen_impl!(
        workspace,
        A::ChordalTriangular{:N, UPLO, T, I},
        B::ChordalTriangular{:N, UPLO, T, I},
        C::ChordalTriangular{:N, UPLO, T, I},
        H::CMPLHessian{UPLO, T, I},
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Fval::AbstractVector{T},
        Wval::AbstractVector{T},
        fill::AbstractVector{I},
        dual::AbstractVector{T},
        grad::AbstractVector{T},
        cgmaxiter::Int,
        maxiter::Int,
        alpha::T,
        beta::T,
        tol::T,
    ) where {UPLO, T, I}

    d = Ones{T}(size(A, 1))

    iter = 0; drop = typemax(T)
    #
    #     y ← 0
    #
    fill!(dual, zero(T))

    while iter <= maxiter && drop >= tol
        iter += 1
        #
        #     A ← C + E(y)
        #
        for i in eachindex(fill)
            setflatindex!(A, dual[i] / 2, fill[i])
        end
        #
        #     B ← chol(-∇ψ(X))
        #
        copyto!(B, A)

        info = complete_impl!(Mptr, Mval, Fval, B)

        ispositive(info) && throw(PosDefException(info))
        #
        #     C ← -∇ψ(X)
        #
        copyto!(C, B)

        unchol_impl!(Mptr, Mval, Fval, Wval, C, d)

        complete_gen_prec!(H)
        #
        #     g ← ∇f(y) = -P ∇ψ(X)
        #
        for i in eachindex(fill)
            grad[i] = 2 * getflatindex(C, fill[i])
        end

        if norm(grad) > one(T)
            rtol = convert(T, 1e-3)
        else
            rtol = convert(T, 1e-8)
        end
        #
        # solve for descent direction d:
        #
        #     ∇²f(y)[d] = g
        #
        desc = cgsolution(cg!(workspace, H, grad, H.prec, rtol, cgmaxiter))
        #
        # Newton decrement:
        #
        #     δ ← dᵀ g
        #
        drop = dot(desc, grad)
        cost = 2 * logdet(B)
        step = one(T)
        #
        #     A ← C + E(y + d)
        #
        for i in eachindex(fill)
            setflatindex!(A, (desc[i] + dual[i]) / 2, fill[i])
        end
        #
        #     B ← chol(-∇ψ(X))
        #
        copyto!(B, A)

        info = complete_impl!(Mptr, Mval, Fval, B)

        ispositive(info) && throw(PosDefException(info))
        #
        # Armijo backtracking: find t such that
        #
        #     f(y + t d) ≤ f(y) - α t δ
        #
        while 2 * logdet(B) > cost - alpha * step * drop
            step *= beta
            #
            #     A ← C + E(y + t d)
            #
            for i in eachindex(fill)
                setflatindex!(A, (step * desc[i] + dual[i]) / 2, fill[i])
            end
            #
            #     B ← chol(-∇ψ(X))
            #
            copyto!(B, A)

            info = complete_impl!(Mptr, Mval, Fval, B)

            ispositive(info) && throw(PosDefException(info))
        end
        #
        #     y ← y + t d
        #
        axpy!(step, desc, dual)
    end
    #
    #     A ← C + E(y)
    #
    for i in eachindex(fill)
        setflatindex!(A, dual[i] / 2, fill[i])
    end
    #
    #     A ← chol(-∇ψ(X))
    #
    info = complete_impl!(Mptr, Mval, Fval, A)

    ispositive(info) && throw(PosDefException(info))
    return
end

function complete_gen_diag_ind!(diag::AbstractVector{I}, S::ChordalSymbolic{I}) where {I}
    dp = one(I)

    for f in fronts(S)
        res = neighbors(S.res, f)
        deg = eltypedegree(S.res, f)
        off = first(res)

        for v in res
            diag[v] = dp + (v - off) * (deg + one(I))
        end

        dp += deg * deg
    end

    return
end

function complete_gen_fill!(fill::AbstractVector{I}, frow::AbstractVector{I}, fcol::AbstractVector{I}, diag::AbstractVector{I}, S::ChordalSymbolic{I}, C::SparseMatrixCSC, ::Val{:L}) where {I}
    fp = one(I)
    dp = one(I)
    lp = one(I) + convert(I, ndz(S))

    for f in fronts(S)
        res = neighbors(S.res, f)
        sep = neighbors(S.sep, f)

        for j in res
            cp = C.colptr[j]
            cpstop = C.colptr[j + one(I)]

            for i in res
                if cp < cpstop && i == rowvals(C)[cp]
                    cp += one(I)
                elseif i >= j
                    fill[fp] = dp; frow[fp] = diag[i]; fcol[fp] = diag[j]; fp += one(I)
                end

                dp += one(I)
            end

            for i in sep
                if cp < cpstop && i == rowvals(C)[cp]
                    cp += one(I)
                else
                    fill[fp] = lp; frow[fp] = diag[i]; fcol[fp] = diag[j]; fp += one(I)
                end

                lp += one(I)
            end
        end
    end

    return
end

function complete_gen_fill!(fill::AbstractVector{I}, frow::AbstractVector{I}, fcol::AbstractVector{I}, diag::AbstractVector{I}, S::ChordalSymbolic{I}, C::SparseMatrixCSC, ::Val{:U}) where {I}
    fp = one(I)
    dp = one(I)
    lp = one(I) + convert(I, ndz(S))

    for f in fronts(S)
        res = neighbors(S.res, f)
        sep = neighbors(S.sep, f)

        for j in res
            cp = C.colptr[j]
            cpstop = C.colptr[j + one(I)]

            for i in res
                while cp < cpstop && rowvals(C)[cp] < i
                    cp += one(I)
                end

                if cp < cpstop && i == rowvals(C)[cp]
                    cp += one(I)
                elseif i <= j
                    fill[fp] = dp; frow[fp] = diag[i]; fcol[fp] = diag[j]; fp += one(I)
                end

                dp += one(I)
            end
        end

        for j in sep
            cp = C.colptr[j]
            cpstop = C.colptr[j + one(I)]

            for i in res
                while cp < cpstop && rowvals(C)[cp] < i
                    cp += one(I)
                end

                if cp < cpstop && i == rowvals(C)[cp]
                    cp += one(I)
                else
                    fill[fp] = lp; frow[fp] = diag[i]; fcol[fp] = diag[j]; fp += one(I)
                end

                lp += one(I)
            end
        end
    end

    return
end

struct NPackedSet{P, I} <: AbstractPackedSet{I}
    packs::NTuple{P, PackedSet{I}}
end

function NPackedSet{P, I}() where {P, I}
    return NPackedSet{P, I}(ntuple(_ -> PackedSet{I}(), Val(P)))
end

function domain(::Type{NPackedSet{P, I}}) where {P, I}
    return P * 8sizeof(I)
end

function getpack(set::NPackedSet{P, I}, i::Int) where {P, I}
    return set.packs[i]
end

function setpack(set::NPackedSet{P, I}, pack::PackedSet{I}, i::Int) where {P, I}
    return NPackedSet{P, I}(setindex(set.packs, pack, i))
end

function packedset(::Type{NPackedSet{P, I}}, i::Int) where {P, I}
    n = 8sizeof(I)
    p, b = divrem(i - 1, n) .+ 1
    return setpack(NPackedSet{P, I}(), packedset(PackedSet{I}, b), p)
end

function packedset(::Type{NPackedSet{P, I}}, range::OneTo{Int}) where {P, I}
    return downset(NPackedSet{P, I}, length(range))
end

function packedset(::Type{NPackedSet{P, I}}, range::AbstractUnitRange{Int}) where {P, I}
    return interval(NPackedSet{P, I}, first(range), last(range))
end

# upset: {start, start+1, ..., domain}
function upset(::Type{NPackedSet{P, I}}, start::Int) where {P, I}
    n = 8sizeof(I)
    packs = ntuple(p -> upset(PackedSet{I}, clamp(start - (p - 1)n, 1, n + 1)), Val(P))
    return NPackedSet{P, I}(packs)
end

# downset: {1, 2, ..., stop}
function downset(::Type{NPackedSet{P, I}}, stop::Int) where {P, I}
    n = 8sizeof(I)
    packs = ntuple(p -> downset(PackedSet{I}, clamp(stop - (p - 1)n, 0, n)), Val(P))
    return NPackedSet{P, I}(packs)
end

# interval: {start, start+1, ..., stop}
function interval(::Type{NPackedSet{P, I}}, start::Int, stop::Int) where {P, I}
    n = 8sizeof(I)
    packs = ntuple(p -> interval(PackedSet{I}, max(start - (p - 1)n, 1), min(stop - (p - 1)n, n)), Val(P))
    return NPackedSet{P, I}(packs)
end

function first_nonempty(set::NPackedSet{P, I}) where {P, I}
    i = 1

    for p in 1:P
        pack = getpack(set, p)
        i += first_nonempty(pack) - 1
        isempty(pack) || break
    end

    return i
end

function last_nonempty(set::NPackedSet{P, I}) where {P, I}
    n = 8sizeof(I); i = P * n

    for p in P:-1:1
        pack = getpack(set, p)
        i += last_nonempty(pack) - n
        isempty(pack) || break
    end

    return i
end

function nextset_nonempty(subset::NPackedSet{P, I}, set::NPackedSet{P, I}) where {P, I}
    for p in 1:P
        subpack = getpack(subset, p)
        pack = getpack(set, p)
        subset = setpack(subset, nextset_nonempty(subpack, pack), p)
        isempty(subpack) || break
    end

    return subset
end

function prevset_nonempty(subset::NPackedSet{P, I}, set::NPackedSet{P, I}) where {P, I}
    for p in 1:P
        subpack = getpack(subset, p)
        pack = getpack(set, p)
        subset = setpack(subset, prevset_nonempty(subpack, pack), p)
        subpack == pack || break
    end

    return subset
end

function Random.rand(rng::AbstractRNG, ::SamplerType{NPackedSet{P, I}}) where {P, I}
    return NPackedSet{P, I}(ntuple(_ -> rand(rng, PackedSet{I}), Val(P)))
end

# ------------------- #
# Iteration Interface #
# ------------------- #

function Base.length(set::NPackedSet)
    return sum(length, set.packs)
end

function Base.iterate(set::NPackedSet{P, I}, (p, pack)::Tuple{Int, PackedSet{I}}=(1, getpack(set, 1))) where {P, I}
    n = 8sizeof(I)

    while isempty(pack) && p < P
        p += 1; pack = getpack(set, p)
    end

    if !isempty(pack)
        i, pack = popfirst_nonempty(pack)
        return ((p - 1)n + i, (p, pack))
    end

    return
end

function Base.iterate(iter::Iterators.Reverse{NPackedSet{P, I}}, (p, pack)::Tuple{Int, PackedSet{I}}=(P, getpack(iter.itr, P))) where {P, I}
    n = 8sizeof(I)

    while isempty(pack) && p > 1
        p -= 1; pack = getpack(iter.itr, p)
    end

    if !isempty(pack)
        i, pack = pop_nonempty(pack)
        return ((p - 1) * n + i, (p, pack))
    end

    return
end

# ---------------------- #
# Abstract Set Interface #
# ---------------------- #

function Base.isempty(set::NPackedSet)
    return all(isempty, set.packs)
end

function Base.in(i::Int, set::NPackedSet{P, I}) where {P, I}
    n = 8sizeof(I)
    p, b = divrem(i - 1, n) .+ 1
    return b in getpack(set, p)
end

function Base.union(left::T, right::T) where {T <: NPackedSet}
    return T(left.packs .∪ right.packs)
end

function Base.intersect(left::T, right::T) where {T <: NPackedSet}
    return T(left.packs .∩ right.packs)
end

function Base.setdiff(left::T, right::T) where {T <: NPackedSet}
    return T(setdiff.(left.packs, right.packs))
end

function Base.symdiff(left::T, right::T) where {T <: NPackedSet}
    return T(symdiff.(left.packs, right.packs))
end

function Base.hash(set::NPackedSet, h::UInt)
    return hash(set.packs, h)
end

function Base.:(==)(left::NPackedSet{P, I}, right::NPackedSet{P, I}) where {P, I}
    return left.packs == right.packs
end

module LaplaciansExt

using CliqueTrees
using CliqueTrees: simplegraph
using Graphs
using Laplacians
using SparseArrays

function CliqueTrees.permutation(weights::AbstractVector, graph::AbstractGraph, alg::Spectral)
    order = spectralorder(graph; tol = alg.tol)
    return order, invperm(order)
end

# A Spectral Algorithm for Envelope Reduction of Sparse Matrices
# Barnard, Pothen, and Simon
# Algorithm 1: Spectral Algorithm
#
# Compute the spectral ordering of a graph.
function spectralorder(graph::AbstractGraph{V}; tol::Float64 = 0.0) where {V}
    order = Vector{V}(undef, nv(graph))
    matrix = sparse(Float64, simplegraph(graph))
    value, vector = fiedler(matrix; tol)
    return sortperm!(order, reshape(vector, size(matrix, 2)))
end

end

struct NullspaceWorkspace{T, I}
    idx::FVector{I}
    head::FVector{I}
    next::FVector{I}
    Fval::FVector{T}
end

function NullspaceWorkspace{T}(S::ChordalSymbolic{I}, nrhs::Integer) where {T, I <: Integer}
    idx  = FVector{I}(undef, ncl(S))
    head = FVector{I}(undef, nfr(S))
    next = FVector{I}(undef, max(convert(I, nrhs), one(I)))
    Fval = FVector{T}(undef, max(S.nFval * convert(I, nrhs), one(I)))
    return NullspaceWorkspace{T, I}(idx, head, next, Fval)
end

function NullspaceWorkspace{T}(L::ChordalTriangular, nrhs::Integer) where {T}
    return NullspaceWorkspace{T}(L.S, nrhs)
end

function LinearAlgebra.nullspace(F::AbstractFactorization{DIAG, UPLO, T}; kw...) where {DIAG, UPLO, T}
    L = triangular(F)
    d = F.d

    k = nullity(L, d, nulltol(L, d; kw...))
    W = NullspaceWorkspace{T}(L, k)
    C = Matrix{T}(undef, ncl(L), k)
    nullspace!(C, W, L, d; kw...)

    return F.P \ C
end

function nullspace!(C::AbstractMatrix{T}, W::NullspaceWorkspace{T, I}, L::ChordalTriangular{DIAG, UPLO, T, I}; kw...) where {DIAG, UPLO, T, I}
    d = Ones{T}(ncl(L))
    return nullspace!(C, W, L, d; kw...)
end

function nullspace!(C::AbstractMatrix{T}, W::NullspaceWorkspace{T, I}, L::ChordalTriangular{DIAG, UPLO, T, I}, d::AbstractVector{T}; kw...) where {DIAG, UPLO, T, I}
    tol = nulltol(L, d; kw...)
    k = nullsym!(W.idx, W.head, W.next, L, d, tol)
    null_impl!(C, W, L, L.uplo, L.diag, k)
    return k
end

function null_impl!(C, W, L, uplo, diag, nrhs)
    S = L.S
    @assert size(C, 1) >= ncl(S)
    @assert size(C, 2) >= nrhs
    @assert length(W.next) >= nrhs
    @assert length(W.Fval) >= S.nFval * nrhs

    res = S.res
    sep = S.sep
    Dptr = S.Dptr
    Dval = L.Dval
    Lptr = S.Lptr
    Lval = L.Lval

    idx = W.idx
    head = W.head
    next = W.next
    Fval = W.Fval

    fill!(C, false)

    if ispositive(nrhs)
        for f in reverse(vertices(res))
            null_loop!(C, Fval, Dptr, Dval, Lptr, Lval, res, sep,
                       idx, head, next, f, uplo, diag)
        end
    end

    return C
end

function null_loop!(
        C::AbstractMatrix{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        idx::AbstractVector{I},
        head::AbstractVector{I},
        next::AbstractVector{I},
        f::I,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, I, UPLO, DIAG}
    #
    # nn is the size of the residual at node f
    #
    #     nn = | res(f) |
    #
    nn = eltypedegree(res, f)
    #
    # na is the size of the separator at node f
    #
    #     na = | sep(f) |
    #
    na = eltypedegree(sep, f)
    #
    # nanc is the number of columns of C that are
    # ancestors of f
    #
    nanc = zero(I)
    #
    # rank is the rank of Dₙₙ
    #
    rank = nn

    jhed = head[f]
    janc = zero(I)
    j = jhed

    @inbounds while !iszero(j)
        nanc += one(I)

        if idx[j] == f
            rank -= one(I)
        elseif iszero(janc)
            janc = j
        end

        j = next[j]
    end

    if ispositive(nanc)
        if isone(nn)
            null_loop_nod!(C, Dptr, Dval, Lptr, Lval, res, sep, next,
                           f, na, rank, jhed, janc, uplo, diag)
        else
            null_loop_snd!(C, Fval, Dptr, Dval, Lptr, Lval, res, sep, next,
                           f, nn, na, nanc, rank, jhed, janc, uplo, diag)
        end
    end

    return
end

function null_loop_snd!(
        C::AbstractMatrix{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        next::AbstractVector{I},
        f::I,
        nn::I,
        na::I,
        nanc::I,
        rank::I,
        jhed::I,
        janc::I,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, I, UPLO, DIAG}
    if UPLO === :L
        trans = Val(:C)
    else
        trans = Val(:N)
    end

    Rp = pointers(res)[f]
    Sp = pointers(sep)[f]
    Dp = Dptr[f]
    Lp = Lptr[f]
    #
    # L is part of the factor
    #
    #           rank
    #     L = [ D₁₁ ] rank
    #         [ D₂₁ ] null
    #         [ L₃₁ ] sep
    #
    Dₙₙ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)
    D₁₁ = view(Dₙₙ, oneto(rank), oneto(rank))

    if UPLO === :L
        L₃ₙ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
        D₂₁ = view(Dₙₙ, rank + one(I):nn, oneto(rank))
        L₃₁ = view(L₃ₙ,        oneto(na), oneto(rank))
    else
        L₃ₙ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
        D₂₁ = view(Dₙₙ, oneto(rank), rank + one(I):nn)
        L₃₁ = view(L₃ₙ, oneto(rank),        oneto(na))
    end
    #
    # F is the frontal matrix at node f, packed into Fval:
    #
    #            null      anc - res
    #   F = [    F₁₂         F₁₃    ] rank
    #       [     I           0     ] null
    #       [     0          F₃₃    ] sep
    #
    F₁  = reshape(view(Fval, oneto(rank * nanc)), rank, nanc)
    F₁₂ = view(F₁, oneto(rank),        oneto(nn - rank))
    F₁₃ = view(F₁, oneto(rank), nn - rank + one(I):nanc)

    if ispositive(nanc + rank - nn) && ispositive(na)
        F₃₃ = reshape(view(Fval, rank * nanc + one(I):rank * nanc + na * (nanc + rank - nn)), na, nanc + rank - nn)
        #
        #     F₃₃ ← C₃₃
        #
        jloc = zero(I)
        j = janc

        @inbounds while !iszero(j)
            jloc += one(I)

            for iloc in oneto(na)
                i = targets(sep)[Sp + iloc - one(I)]

                F₃₃[iloc, jloc] = C[i, j]
            end

            j = next[j]
        end
        #
        #     F₁₃ ← -L₃₁ᴴ F₃₃
        #
        gemm!(trans, Val(:N), -one(T), L₃₁, F₃₃, zero(T), F₁₃)
    end
    #
    #     F₁₂ ← - D₂₁ᴴ
    #
    if ispositive(rank)
        @inbounds for jloc in oneto(nn - rank)
            for iloc in oneto(rank)
                if UPLO === :L
                    F₁₂[iloc, jloc] = -conj(D₂₁[jloc, iloc])
                else
                    F₁₂[iloc, jloc] = -D₂₁[iloc, jloc]
                end
            end
        end
        #
        #     F₁ ← D₁₁⁻ᴴ F₁
        #
        trsm!(Val(:L), uplo, trans, diag, one(T), D₁₁, F₁)
    end
    #
    # scatter F into C
    #
    jloc = zero(I)
    j = jhed

    @inbounds while !iszero(j)
        jloc += one(I)

        for iloc in oneto(rank)
            i = Rp + iloc - one(I)

            C[i, j] = F₁[iloc, jloc]
        end

        j = next[j]
    end

    i = Rp + rank - one(I)
    j = jhed

    @inbounds while !iszero(j) && j != janc
        i += one(I)

        C[i, j] = one(T)

        j = next[j]
    end

    return
end

function null_loop_nod!(
        C::AbstractMatrix{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        next::AbstractVector{I},
        f::I,
        na::I,
        rank::I,
        jhed::I,
        janc::I,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, I, UPLO, DIAG}

    Rp = pointers(res)[f]
    Sp = pointers(sep)[f]
    Dp = Dptr[f]
    Lp = Lptr[f]

    if iszero(rank)
        @inbounds C[Rp, jhed] = one(T)
    else
        d₁₁ = Dval[Dp]
        j = janc

        @inbounds while !iszero(j)
            acc = zero(T)

            for s in oneto(na)
                i = targets(sep)[Sp + s - one(I)]

                if UPLO === :L
                    acc += conj(Lval[Lp + s - one(I)]) * C[i, j]
                else
                    acc += Lval[Lp + s - one(I)] * C[i, j]
                end
            end

            if DIAG === :N
                if UPLO === :L
                    acc /= conj(d₁₁)
                else
                    acc /= d₁₁
                end
            end

            C[Rp, j] = -acc
            j = next[j]
        end
    end

    return
end

function nulltol(L::ChordalTriangular{DIAG}, d::AbstractVector; kw...) where {DIAG}
    if DIAG === :N
        return nulltol(L; kw...)
    else
        return nulltol(Diagonal(d); kw...)
    end
end

function nulltol(L::ChordalTriangular{DIAG, UPLO, T, I}; atol::Real = 0, rtol::Real = atol > 0 ? 0 : ncl(L.S) * eps(real(T))) where {DIAG, UPLO, T, I}
    S = L.S
    maxdiag = zero(real(T))

    for f in vertices(S.res)
        D, _ = diagblock(L, f)

        for i in axes(D, 1)
            maxdiag = max(maxdiag, abs(D[i, i]))
        end
    end

    return convert(T, max(atol, rtol * maxdiag * maxdiag))
end

function nulltol(D::Diagonal{T}; atol::Real = 0, rtol::Real = atol > 0 ? 0 : size(D, 1) * eps(real(T))) where {T}
    maxdiag = zero(real(T))

    for i in axes(D, 1)
        maxdiag = max(maxdiag, abs(D[i, i]))
    end

    return convert(T, max(atol, rtol * maxdiag))
end

function nullity(L::ChordalTriangular{DIAG}, d::AbstractVector, tol::Real) where {DIAG}
    if DIAG === :N
        return nullity(L, tol)
    else
        return nullity(Diagonal(d), tol)
    end
end

function nullity(L::ChordalTriangular, tol::Real)
    S = L.S
    nrhs = 0

    for f in vertices(S.res)
        D, _ = diagblock(L, f)

        for i in diagind(D)
            if abs2(D[i]) <= tol
                nrhs += 1
            end
        end
    end

    return nrhs
end

function nullity(D::Diagonal, tol::Real)
    nrhs = 0

    for i in axes(D, 1)
        if -tol <= D[i, i] <= tol
            nrhs += 1
        end
    end

    return nrhs
end

function nullsym!(
        idx::AbstractVector{I},
        head::AbstractVector{I},
        next::AbstractVector{I},
        L::ChordalTriangular{DIAG, UPLO, T, I},
        d::AbstractVector{T},
        tol::T,
    ) where {DIAG, UPLO, T, I}
    S = L.S; nrhs = zero(I)

    @inbounds for f in vertices(S.res)
        if DIAG === :N
            D, _ = diagblock(L, f)

            for i in diagind(D)
                if abs2(D[i]) <= tol
                    nrhs += one(I); idx[nrhs] = f
                end
            end
        else
            for i in neighbors(S.res, f)
                if -tol <= d[i] <= tol
                    nrhs += one(I); idx[nrhs] = f
                end
            end
        end
    end

    j = nrhs

    @inbounds for f in reverse(vertices(S.res))
        g = S.pnt[f]

        if iszero(g)
            k = zero(I)
        else
            k = head[g]
        end

        while ispositive(j) && idx[j] == f
            next[j] = k; k = j; j -= one(I)
        end

        head[f] = k
    end

    return nrhs
end

"""
    selinv!(F::ChordalCholesky)

Compute the selected inverse of a sparse positive-definite
matrix. This computes the inverse of the matrix *only* in the
structural nonzeros of the sparsity pattern of the Cholesky
factor `F.L`.

Use [`ChordalCholesky`](@ref) to construct a factorization object,
use [`cholesky!`](@ref) to perform the factorization, and use
[`selinv!`](@ref) to compute the selected inverse.

```julia-repl
julia> using CliqueTrees.Multifrontal, LinearAlgebra

julia> A = [
           4  2  0  0  2
           2  5  0  0  3
           0  0  4  2  0
           0  0  2  5  2
           2  3  0  2  7
       ];

julia> F = selinv!(cholesky!(ChordalCholesky(A)))
5×5 FChordalCholesky{:L, Float64, Int64} with 10 stored entries:
  0.328125    ⋅         ⋅        ⋅       ⋅
  0.0        0.328125   ⋅        ⋅       ⋅
  0.0       -0.09375   0.3125    ⋅       ⋅
 -0.15625    0.0       0.0      0.3125   ⋅
  0.0       -0.0625   -0.125   -0.125   0.25
```

### Parameters

  - `F`: factorized positive definite matrix

"""
function selinv!(F::ChordalCholesky{UPLO, T}) where {UPLO, T}
    F.info[] = selinv!(triangular(F))
    return F
end

function selinv!(
        L::ChordalTriangular{:N, UPLO, T, I},
    ) where {UPLO, T, I <: Integer}
    Mptr = FVector{I}(undef, L.S.nMptr)
    Mval = FVector{T}(undef, L.S.nMval)
    Fval = FVector{T}(undef, L.S.nFval * L.S.nFval)

    info = selinv_impl!(Mptr, Mval, Fval, L)
    return info
end

#
# Convenience wrapper that unpacks ChordalTriangular types.
#
function selinv_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Fval::AbstractVector{T},
        L::ChordalTriangular{:N, UPLO, T, I},
    ) where {UPLO, T, I <: Integer}
    info = selinv_impl!(
        Mptr, Mval,
        L.S.Dptr, L.Dval,
        L.S.Lptr, L.Lval,
        Fval,
        L.S.res, L.S.rel, L.S.chd,
        L.uplo)

    return info
end

function selinv_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    ns = zero(I); Mptr[one(I)] = one(I)

    for j in reverse(vertices(res))
        ns = selinv_loop!(Mptr, Mval, Dptr, Dval, Lptr, Lval, Fval, res, rel, chd, ns, j, uplo)
    end

    return zero(I)
end

function selinv_loop!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    nn = eltypedegree(res, j)

    if isone(nn)
        return selinv_loop_nod!(
            Mptr, Mval,
            Dptr, Dval,
            Lptr, Lval,
            Fval,
            res, rel, chd, ns, j, uplo
        )
    else
        return selinv_loop_snd!(
            Mptr, Mval,
            Dptr, Dval,
            Lptr, Lval,
            Fval,
            res, rel, chd, ns, nn, j, uplo
        )
    end
end

function selinv_loop_snd!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        nn::I,
        j::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁₁ F₁₂ ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₁₁ = view(F, oneto(nn), oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
    end
    #
    # L is part of the lower triangular factor
    #
    #          res(j)
    #     L = [ D₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    #     F₁₁ ← 0
    #
    zerorec!(F₁₁)

    if ispositive(na)
        #
        # M₂₂ is the update matrix from the parent of node j
        #
        strt = Mptr[ns]
        M₂₂ = reshape(view(Mval, strt:strt + na * na - one(I)), na, na)
        ns -= one(I)
        #
        #     F₂₂ ← M₂₂
        #
        copytri!(F₂₂, M₂₂, uplo)
        #
        #     L₂₁ ← L₂₁ D₁₁⁻¹
        #
        if UPLO === :L
            trsm!(Val(:R), Val(:L), Val(:N), Val(:N), one(T), D₁₁, L₂₁)
        else
            trsm!(Val(:L), Val(:U), Val(:N), Val(:N), one(T), D₁₁, L₂₁)
        end
        #
        #     F₂₁ ← -M₂₂ L₂₁
        #
        if UPLO === :L
            symm!(Val(:L), Val(:L), -one(T), M₂₂, L₂₁, zero(T), F₂₁)
        else
            symm!(Val(:R), Val(:U), -one(T), M₂₂, L₂₁, zero(T), F₂₁)
        end
        #
        #     F₁₁ ← F₁₁ - L₂₁ᴴ F₂₁
        #
        if UPLO === :L
            trrk!(Val(:L), Val(:C), -one(real(T)), L₂₁, F₂₁, one(real(T)), F₁₁)
        else
            trrk!(Val(:U), Val(:N), -one(real(T)), F₂₁, L₂₁, one(real(T)), F₁₁)
        end
    end
    #
    #     D₁₁ ← D₁₁⁻¹
    #
    trtri!(uplo, Val(:N), D₁₁)
    #
    #     F₁₁ ← F₁₁ + D₁₁ᴴ D₁₁
    #
    if UPLO === :L
        tril!(D₁₁)
        syrk!(Val(:L), Val(:C), one(real(T)), D₁₁, one(real(T)), F₁₁)
    else
        triu!(D₁₁)
        syrk!(Val(:U), Val(:N), one(real(T)), D₁₁, one(real(T)), F₁₁)
    end
    #
    #     D₁₁ ← F₁₁
    #
    copyrec!(D₁₁, F₁₁)
    #
    #     L₂₁ ← F₂₁
    #
    copyrec!(L₂₁, F₂₁)

    for i in neighbors(chd, j)
        #
        # send update matrix to child i
        #
        #     Mᵢ ← Rᵢᵀ F Rᵢ
        #
        ns += one(I)
        selinv_send!(F, Mptr, Mval, rel, ns, i, uplo)
    end

    return ns
end

# Fast path for nn = 1 (residual size is 1)
# In this case, diagonal blocks are scalars and off-diagonal blocks are vectors
function selinv_loop_nod!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    #
    # nn = 1 (the size of the residual at node j)
    #
    nn = one(I)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) | = 1 + na
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           1   na
    #     F = [ f₁₁     ] 1
    #         [ f₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        f₂₁ = view(F, nn + one(I):nj, one(I))
    else
        f₂₁ = view(F, one(I), nn + one(I):nj)
    end
    #
    # L is part of the lower triangular factor (d₁₁ is scalar, l₂₁ is vector)
    #
    #          res(j)
    #     L = [ d₁₁  ] res(j)
    #         [ l₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    d₁₁ = Dval[Dp]
    l₂₁ = view(Lval, Lp:Lp + na - one(I))
    #
    #     f₁₁ ← 0
    #
    f₁₁ = zero(T)

    if ispositive(na)
        #
        # M₂₂ is the update matrix from the parent of node j
        #
        strt = Mptr[ns]
        M₂₂ = reshape(view(Mval, strt:strt + na * na - one(I)), na, na)
        ns -= one(I)
        #
        #     F₂₂ ← M₂₂
        #
        copytri!(F₂₂, M₂₂, uplo)
        #
        #     l₂₁ ← l₂₁ / d₁₁
        #
        rdiv!(l₂₁, d₁₁)
        #
        #     f₂₁ ← -M₂₂ l₂₁ (symv)
        #
        symv!(uplo, -one(T), M₂₂, l₂₁, zero(T), f₂₁)
        #
        #     f₁₁ ← f₁₁ - l₂₁ᴴ f₂₁ (dot product)
        #
        f₁₁ -= dot(l₂₁, f₂₁)
    end
    #
    #     d₁₁ ← 1 / d₁₁
    #
    d₁₁ = inv(d₁₁)
    #
    #     f₁₁ ← f₁₁ + |d₁₁|²
    #
    f₁₁ += abs2(d₁₁)
    #
    #     Write back scalars: D₁₁ ← f₁₁, F[1] ← f₁₁
    #
    Dval[Dp] = f₁₁
    F[one(I)] = f₁₁
    #
    #     l₂₁ ← f₂₁
    #
    copyrec!(l₂₁, f₂₁)

    for i in neighbors(chd, j)
        #
        # send update matrix to child i
        #
        #     Mᵢ ← Rᵢᵀ F Rᵢ
        #
        ns += one(I)
        selinv_send!(F, Mptr, Mval, rel, ns, i, uplo)
    end

    return ns
end

function selinv_send!(
        F::AbstractMatrix{T},
        ptr::AbstractVector{I},
        val::AbstractVector{T},
        rel::AbstractGraph{I},
        ns::I,
        i::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    #
    # na is the size of the separator at node i
    #
    #     na = | sep(i) |
    #
    na = eltypedegree(rel, i)
    #
    # inj is the subset inclusion
    #
    #     inj: sep(i) → bag(parent(i))
    #
    inj = neighbors(rel, i)
    #
    # M is the update matrix for child i
    #
    strt = ptr[ns]
    stop = ptr[ns + one(I)] = strt + na * na
    M = reshape(view(val, strt:stop - one(I)), na, na)
    #
    # copy F into M
    #
    #     M ← Rᵢᵀ F Rᵢ
    #
    copygathertri!(M, F, inj, uplo)
    return
end

module PIDBTLib

using Base: oneto, setindex, OneTo, @propagate_inbounds
using Random
using Random: SamplerType
import Graphs

export pidbt

const AbstractScalar{T} = AbstractArray{T, 0}
const Scalar{T} = Array{T, 0}

# Packed set types
include("packed_sets/abstract_packed_set.jl")

# Linked list types
include("linked_lists/abstract_linked_lists.jl")

# DAG pool
include("dags.jl")

# Data structures
include("mutable_graph.jl")
include("immutable_graph.jl")
include("ptd.jl")
include("sieve.jl")
include("layered_sieve.jl")

# Algorithm components
include("heuristics.jl")
include("safe_separator.jl")

# Main algorithm
include("treewidth.jl")

# Public API
include("pidbt.jl")

end

using CliqueTrees
using Documenter

makedocs(;
    modules = [CliqueTrees],
    format = Documenter.HTML(),
    sitename = "CliqueTrees.jl",
    checkdocs = :none,
    pages = ["CliqueTrees.jl" => "index.md", "Library Reference" => "api.md"],
)

deploydocs(;
    target = "build", repo = "github.com/AlgebraicJulia/CliqueTrees.jl.git", branch = "gh-pages"
)

# ===== factorize! with DenseFactorizationWorkspace (bridge to existing methods) =====

function factorize!(
        ::DenseFactorizationWorkspace,
        L::AbstractTriangular{T},
        d::AbstractVector,
        pivot::NoPivot;
        signs::AbstractVector,
        reg::AbstractRegularization,
        check::Bool,
        tol::Real,
    ) where {T}
    return factorize!(L, d, pivot; signs, reg, check, tol)
end

function factorize!(
        ::DenseFactorizationWorkspace,
        L::AbstractTriangular{T},
        d::AbstractVector,
        pivot::RowMaximum,
        perm::AbstractVector,
        invp::AbstractVector;
        signs::AbstractVector,
        reg::AbstractRegularization,
        check::Bool,
        tol::Real,
    ) where {T}
    return factorize!(L, d, pivot, perm, invp; signs, reg, check, tol)
end

# ===== factorize! Level 2: Dense triangular with kwargs =====

function factorize!(
        L::AbstractTriangular{T},
        d::AbstractVector,
        pivot::NoPivot;
        signs::AbstractVector,
        reg::AbstractRegularization,
        check::Bool,
        tol::Real,
    ) where {T}
    @assert checksigns(signs, reg)

    info = factorize!(L, d, pivot, signs, reg, tol)

    if ispositive(info) && check
        if L isa LowerTriangular || L isa UpperTriangular
            throw(PosDefException(info))
        else
            throw(ZeroPivotException(info))
        end
    end

    return info
end

function factorize!(
        L::AbstractTriangular{T},
        d::AbstractVector,
        pivot::RowMaximum,
        perm::AbstractVector,
        invp::AbstractVector;
        signs::AbstractVector,
        reg::AbstractRegularization,
        check::Bool,
        tol::Real,
    ) where {T}
    @assert checksigns(signs, reg)

    info = factorize!(L, d, pivot, perm, invp, signs, reg, tol)

    if ispositive(info) && check
        throw(RankDeficientException(info))
    end

    return info
end

# ===== factorize! Level 3: Dense triangular all positional =====

function factorize!(
        L::AbstractTriangular{T},
        d::AbstractVector,
        pivot::NoPivot,
        signs::AbstractVector,
        reg::AbstractRegularization,
        tol::Real,
    ) where {T}
    S = permuteto(T, signs, eachindex(signs))
    R = initialize(L, S, reg)
    M = parent(L)

    if L isa LowerTriangular || L isa UnitLowerTriangular
        uplo = Val(:L)
    else
        uplo = Val(:U)
    end

    if L isa LowerTriangular || L isa UpperTriangular
        diag = Val(:N)
    else
        diag = Val(:U)
    end

    if diag === Val(:N)
        W = Ones{T}(length(L))
    else
        W = FVector{T}(undef, length(L))
    end

    if R isa SE99
        if diag === Val(:N)
            e = LinearAlgebra.diag(M)
        else
            e = d
            e .= view(M, diagind(M))
        end
    else
        e = d
    end

    return potrf!(uplo, W, M, e, S, R, diag)
end

function factorize!(
        L::AbstractTriangular{T},
        d::AbstractVector,
        pivot::RowMaximum,
        perm::AbstractVector,
        invp::AbstractVector,
        signs::AbstractVector,
        reg::AbstractRegularization,
        tol::Real,
    ) where {T}
    S = permuteto(T, signs, eachindex(signs))
    R = initialize(L, S, reg)
    M = parent(L)

    if L isa LowerTriangular || L isa UnitLowerTriangular
        uplo = Val(:L)
    else
        uplo = Val(:U)
    end

    if L isa LowerTriangular || L isa UpperTriangular
        diag = Val(:N)
    else
        diag = Val(:U)
    end

    W = FVector{T}(undef, length(L))

    if R isa SE99 || R isa GMW81
        if diag === Val(:N)
            e = LinearAlgebra.diag(M)
        else
            e = d .= view(M, diagind(M))
        end
    else
        e = d
    end

    info, rank = pstrf!(uplo, W, M, e, invp, S, R, tol, diag)

    zerotri!(M, rank + 1:size(M, 1), uplo)

    for i in eachindex(perm)
        perm[i] = invp[perm[i]]
    end

    for i in eachindex(perm)
        invp[perm[i]] = i
    end

    return info
end

# ===== DenseDivisionWorkspace bridging methods =====

function LinearAlgebra.ldiv!(::DenseDivisionWorkspace, A::AbstractTriangular, B::AbstractVecOrMat)
    return ldiv!(A, B)
end

function LinearAlgebra.ldiv!(::DenseDivisionWorkspace, A::AdjOrTrans{<:Any, <:AbstractTriangular}, B::AbstractVecOrMat)
    return ldiv!(A, B)
end

function LinearAlgebra.rdiv!(::DenseDivisionWorkspace, B::AbstractMatrix, A::AbstractTriangular)
    return rdiv!(B, A)
end

function LinearAlgebra.rdiv!(::DenseDivisionWorkspace, B::AbstractMatrix, A::AdjOrTrans{<:Any, <:AbstractTriangular})
    return rdiv!(B, A)
end

"""
    Tree{I, Prnt, Ptr, Tgt} <: AbstractUnitRange{I}

A rooted forest T = (V, E) with edges oriented from leaf to root.
This type implements the [indexed tree interface](https://juliacollections.github.io/AbstractTrees.jl/stable/#The-Indexed-Tree-Interface).
"""
struct Tree{I, Prnt, Ptr, Tgt} <: AbstractUnitRange{I}
    """
    The forest T.
    """
    tree::Parent{I, Prnt}

    """
    A bipartite graph G = (V, V ∪ {r}, E'). E' contains an arc

        (v, w) ∈ E'

    for each arc (w, v) ∈ E. Additionally, E' contains an arc

        (r, w) ∈ E'

    for each root vertex w of T.
    """
    graph::BipartiteGraph{I, I, Ptr, Tgt}

    function Tree{I, Prnt, Ptr, Tgt}(tree::Parent{I, Prnt}, graph::BipartiteGraph{I, I, Ptr, Tgt}) where {I, Prnt, Ptr, Tgt}
        @assert last(tree) == nov(graph)
        @assert last(tree) == nv(graph) - one(I)
        @assert last(tree) == ne(graph)
        return new{I, Prnt, Ptr, Tgt}(tree, graph)
    end
end

const FTree{I} = Tree{I, FVector{I}, FVector{I}, FVector{I}}

function Tree{I, Prnt, Ptr, Tgt}(tree::Parent{I, Prnt}) where {I, Prnt, Ptr, Tgt}
    n = last(tree); nn = n + one(I)
    graph = BipartiteGraph{I, I, Ptr, Tgt}(n, nn, n)
    return tree_impl!(graph, tree)
end

function Tree(tree::Tree)
    return Tree(tree.tree, tree.graph)
end

function Tree(tree::Parent{I, Prnt}, graph::BipartiteGraph{I, I, Ptr, Tgt}) where {I, Prnt, Ptr, Tgt}
    return Tree{I, Prnt, Ptr, Tgt}(tree, graph)
end

function Tree(tree::Parent{I, Prnt}) where {I, Prnt}
    return Tree{I, Prnt, FVector{I}, FVector{I}}(tree)
end

function Tree(nv::Integer, prnt::AbstractVector)
    tree = Parent(nv, prnt)
    return Tree(tree)
end

"""
    eliminationtree([weights, ]graph;
        alg::PermutationOrAlgorithm=DEFAULT_ELIMINATION_ALGORITHM)

Construct a [tree-depth decomposition](https://en.wikipedia.org/wiki/Tr%C3%A9maux_tree) of a simple graph.

```julia-repl
julia> using CliqueTrees

julia> graph = [
           0 1 0 0 0 0 0 0
           1 0 1 0 0 1 0 0
           0 1 0 1 0 1 1 1
           0 0 1 0 0 0 0 0
           0 0 0 0 0 1 1 0
           0 1 1 0 1 0 0 0
           0 0 1 0 1 0 0 1
           0 0 1 0 0 0 1 0
       ];

julia> label, tree = eliminationtree(graph);

julia> tree
8-element Tree{Int64, Vector{Int64}, Array{Int64, 0}, Vector{Int64}, Vector{Int64}}:
 8
 └─ 7
    ├─ 5
    └─ 6
       ├─ 1
       ├─ 3
       │  └─ 2
       └─ 4
```
"""
function eliminationtree(graph; alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM)
    return eliminationtree(graph, alg)
end

function eliminationtree(graph, alg::PermutationOrAlgorithm)
    return eliminationtree(BipartiteGraph(graph), alg)
end

function eliminationtree(graph::AbstractGraph, alg::PermutationOrAlgorithm)
    return eliminationtree(graph, permutation(graph, alg))
end

function eliminationtree(graph::AbstractGraph{V}, (order, index)::Tuple{Vector{V}, Vector{V}}) where {V}
    E = etype(graph); n = nv(graph); m = half(de(graph)); nn = n + one(V)
    ancestor = FVector{V}(undef, n)
    pointer = FVector{E}(undef, nn)
    target = FVector{V}(undef, m)
    tree = Parent{V}(n)
    eliminationtree_impl!(ancestor, pointer, target, tree, graph, index)
    return order, Tree(tree)
end

function eliminationtree(weights::AbstractVector, graph; alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM)
    return eliminationtree(weights, graph, alg)
end

function eliminationtree(weights::AbstractVector, graph, alg::PermutationOrAlgorithm)
    return eliminationtree(weights, BipartiteGraph(graph), alg)
end

function eliminationtree(weights::AbstractVector, graph::AbstractGraph, alg::PermutationOrAlgorithm)
    return eliminationtree(graph, permutation(weights, graph, alg))
end

function eliminationtree_impl!(
        ancestor::AbstractVector{V},
        pointer::AbstractVector{E},
        target::AbstractVector{V},
        tree::Parent{V},
        graph,
        index::AbstractVector{V},
    ) where {V, E}
    upper = sympermute!_impl!(pointer, target, graph, index, Forward)
    etree_impl!(tree, ancestor, upper)
    return upper
end

function tree_impl!(
        graph::BipartiteGraph{V, V},
        tree::Parent{V},
    ) where {V}
    reverse!_impl!(graph, tree)
    return Tree(tree, graph)
end

function tree_impl!(
        pointer::AbstractVector{V},
        target::AbstractVector{V},
        tree::Parent{V},
    ) where {V}
    n = last(tree); nn = n + one(V)
    graph = BipartiteGraph(n, nn, n, pointer, target)
    return tree_impl!(graph, tree)
end

function Base.copy(tree::Tree)
    return Tree(copy(tree.tree), copy(tree.graph))
end

function Base.copy!(dst::Tree, src::Tree)
    copy!(dst.tree, src.tree)
    copy!(dst.graph, src.graph)
    return dst
end

function Base.:(==)(left::Tree, right::Tree)
    return left.tree == right.tree && left.graph == right.graph
end

##########################
# Indexed Tree Interface #
##########################

@propagate_inbounds function AbstractTrees.parentindex(tree::Tree, i::Integer)
    @boundscheck checkbounds(tree, i)
    @inbounds j = parentindex(tree.tree, i)
    return j
end

function rootindices(tree::Tree)
    n = nv(tree.graph)
    @inbounds roots = neighbors(tree.graph, n)
    return roots
end

function AbstractTrees.rootindex(tree::Tree)
    roots = rootindices(tree)

    if isempty(roots)
        root = nothing
    else
        root = first(roots)
    end

    return root
end

@propagate_inbounds function AbstractTrees.childindices(tree::Tree, i::Integer)
    @boundscheck checkbounds(tree, i)
    @inbounds children = neighbors(tree.graph, i)
    return children
end

@propagate_inbounds function ancestorindices(tree::Tree, i::Integer)
    @boundscheck checkbounds(tree, i)
    @inbounds ancestors = ancestorindices(tree.tree, i)
    return ancestors
end

#################################
# Abstract Unit Range Interface #
#################################

function Base.first(tree::Tree)
    return first(tree.tree)
end

function Base.last(tree::Tree)
    return last(tree.tree)
end

"""
    LinWork{T, I}

A workspace for the function [`linsolve!`](@ref).
"""
struct LinWork{T, I}
    updptr::FVector{I}
    updval::FVector{T}
    frtval::FVector{T}
    vecval::FVector{T}
end

"""
    lininit(nrhs::Integer, cholfact::CholFact)

Initialize a linear solve workspace.

```julia-repl
julia> import CliqueTrees

julia> matrix = [
           3 1 0 0 0 0 0 0
           1 3 1 0 0 2 0 0
           0 1 3 1 0 1 2 1
           0 0 1 3 0 0 0 0
           0 0 0 0 3 1 1 0
           0 2 1 0 1 3 0 0
           0 0 2 0 1 0 3 1
           0 0 1 0 0 0 1 3
       ];

julia> cholfact = CliqueTrees.cholesky(matrix)
CholFact{Float64, Int64}:
    nnz: 19
    success: true

julia> linwork = CliqueTrees.lininit(2, cholfact)
LinWork{Float64}:
```

### Paramerers

  - `nrhs`: number of right-hand sides
  - `cholfact`: factorized coefficient matrix
"""
function lininit(nrhs::Integer, cholfact::CholFact{T, I}) where {T, I}
    @assert !isnegative(nrhs)
    symbfact = cholfact.symbfact
    tree = symbfact.tree
    separator = separators(tree)

    treln = nv(separator)
    updln = symbfact.lsmax * nrhs
    frtln = symbfact.njmax * nrhs
    vecln = nov(separators(symbfact.tree)) * nrhs

    updptr = FVector{I}(undef, treln + one(I))
    updval = FVector{T}(undef, updln)
    frtval = FVector{T}(undef, frtln)
    vecval = FVector{T}(undef, vecln)

    return LinWork{T, I}(updptr, updval, frtval, vecval)
end

"""
    lininit(nrhs::Integer, ldltfact::LDLTFact)

Initialize a linear solve workspace.

```julia-repl
julia> import CliqueTrees

julia> matrix = [
           3 1 0 0 0 0 0 0
           1 3 1 0 0 2 0 0
           0 1 3 1 0 1 2 1
           0 0 1 3 0 0 0 0
           0 0 0 0 3 1 1 0
           0 2 1 0 1 3 0 0
           0 0 2 0 1 0 3 1
           0 0 1 0 0 0 1 3
       ];

julia> ldltfact = CliqueTrees.ldlt(matrix)
LDLTFact{Float64, Int64}:
    nnz: 19
    success: true

julia> linwork = CliqueTrees.lininit(2, ldltfact)
LinWork{Float64}:
```

### Paramerers

  - `nrhs`: number of right-hand sides
  - `ldltfact`: factorized coefficient matrix
"""
function lininit(nrhs::Integer, ldltfact::LDLTFact{T, I}) where {T, I}
    @assert !isnegative(nrhs)
    symbfact = ldltfact.symbfact
    tree = symbfact.tree
    separator = separators(tree)

    treln = nv(separator)
    updln = symbfact.lsmax * nrhs
    frtln = symbfact.njmax * nrhs
    vecln = nov(separators(symbfact.tree)) * nrhs

    updptr = FVector{I}(undef, treln + one(I))
    updval = FVector{T}(undef, updln)
    frtval = FVector{T}(undef, frtln)
    vecval = FVector{T}(undef, vecln)

    return LinWork{T, I}(updptr, updval, frtval, vecval)
end

"""
    linsolve!(rhs::AbstractArray, cholfact::CholFact, side::Val)

Solve a linear system of equations.

```julia-repl
julia> import CliqueTrees

julia> matrix = [
           3 1 0 0 0 0 0 0
           1 3 1 0 0 2 0 0
           0 1 3 1 0 1 2 1
           0 0 1 3 0 0 0 0
           0 0 0 0 3 1 1 0
           0 2 1 0 1 3 0 0
           0 0 2 0 1 0 3 1
           0 0 1 0 0 0 1 3
       ];

julia> rhs = rand(8, 2);

julia> cholfact = CliqueTrees.cholesky(matrix)
CholFact{Float64, Int64}:
    nnz: 19
    success: true

julia> sol = CliqueTrees.linsolve!(rhs, cholfact, Val(false)) # sol = inv(matrix) * rhs
8×2 Matrix{Float64}:
  0.339907    0.0202252
 -0.364903    0.573497
 -0.243223    0.354763
  0.293368   -0.00477056
 -0.336252    0.507332
  0.600361   -0.655479
  0.452218   -0.266566
 -0.0620433   0.0528108
```

### Parameters

  - `rhs`: right-hand side
  - `cholfact`: factorized coefficient matrix
  - `side`: left or right division
    - `Val(false)`: left division
    - `Val(true)`: right division
"""
linsolve!(rhs::AbstractArray, cholfact::CholFact, side::Val)

function linsolve!(rhs::AbstractMatrix, cholfact::CholFact, side::Val{false})
    return linsolve!(rhs, lininit(size(rhs, 2), cholfact), cholfact, side)
end

function linsolve!(rhs::AbstractMatrix, cholfact::CholFact, side::Val{true})
    return linsolve!(rhs, lininit(size(rhs, 1), cholfact), cholfact, side)
end

function linsolve!(rhs::AbstractVector, cholfact::CholFact, side::Val)
    return linsolve!(rhs, lininit(1, cholfact), cholfact, side)
end

"""
    linsolve!(rhs::AbstractArray, linwork::LinWork{T}, cholfact::CholFact, side::Val)

Solve a linear system of equations using a pre-allocated workspace.

```julia-repl
julia> import CliqueTrees

julia> matrix = [
           3 1 0 0 0 0 0 0
           1 3 1 0 0 2 0 0
           0 1 3 1 0 1 2 1
           0 0 1 3 0 0 0 0
           0 0 0 0 3 1 1 0
           0 2 1 0 1 3 0 0
           0 0 2 0 1 0 3 1
           0 0 1 0 0 0 1 3
       ];

julia> rhs = rand(8, 2);

julia> cholfact = CliqueTrees.cholesky(matrix)
CholFact{Float64, Int64}:
    nnz: 19
    success: true

julia> linwork = CliqueTrees.lininit(2, cholfact)
LinWork{Float64}:

julia> sol = CliqueTrees.linsolve!(rhs, linwork, cholfact, Val(false)) # sol = inv(matrix) * rhs
8×2 Matrix{Float64}:
  0.339907    0.0202252
 -0.364903    0.573497
 -0.243223    0.354763
  0.293368   -0.00477056
 -0.336252    0.507332
  0.600361   -0.655479
  0.452218   -0.266566
 -0.0620433   0.0528108
```

### Parameters

  - `rhs`: right-hand side
  - `linwork`: linear solve workspace
  - `cholfact`: factorized coefficient matrix
  - `side`: left or right division
    - `Val(false)`: left division
    - `Val(true)`: right division

"""
function linsolve!(rhs::AbstractVector, linwork::LinWork, cholfact::CholFact, side::Val{false})
    return linsolve!(rhs, linwork, cholfact, Val(true))
end

function linsolve!(rhs::AbstractMatrix, linwork::LinWork{T, I}, cholfact::CholFact{T, I}, side::Val{false}) where {T, I}
    @assert nov(separators(cholfact.symbfact.tree)) == size(rhs, 1)
    @assert length(linwork.vecval) >= length(rhs)

    tree = cholfact.symbfact.tree
    neqns = nov(separators(tree))
    nrhs = convert(I, size(rhs, 2))

    adj = reshape(rhs, nrhs, neqns)
    tmp = view(linwork.vecval, oneto(nrhs * neqns))

    copyto!(adj, adjoint!(reshape(tmp, nrhs, neqns), rhs))
    linsolve!(adj, linwork, cholfact, Val(true))    
    copyto!(rhs, adjoint!(reshape(tmp, neqns, nrhs), adj))

    return rhs
end

function linsolve!(rhs::AbstractVector, linwork::LinWork{T, I}, cholfact::CholFact{T, I}, side::Val{true}) where {T, I}
    @assert nov(separators(cholfact.symbfact.tree)) == length(rhs)
    @assert length(linwork.frtval) >= cholfact.symbfact.njmax
    @assert length(linwork.vecval) >= length(rhs)

    tree = cholfact.symbfact.tree
    perm = cholfact.symbfact.perm

    mapping = cholfact.mapping

    blkptr = cholfact.blkptr
    blkval = cholfact.blkval

    updptr = linwork.updptr
    updval = linwork.updval
    frtval = linwork.frtval
    vecval = linwork.vecval

    residual = residuals(tree)
    separator = separators(tree)

    neqns = nov(separators(tree))
    vec = view(vecval, oneto(neqns))

    updptr[begin] = one(I); ns = zero(I)

    @inbounds for v in oneto(neqns)
        vec[v] = rhs[perm[v]]
    end

    @inbounds for j in vertices(separator)
        ns = rdiv!_loop_fwd!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, vec, ns, j)
    end

    @inbounds for j in reverse(vertices(separator))
        ns = rdiv!_loop_bwd!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, vec, ns, j)
    end

    @inbounds for v in oneto(neqns)
        rhs[perm[v]] = vec[v]
    end

    return rhs
end

function linsolve!(rhs::AbstractMatrix, linwork::LinWork{T, I}, cholfact::CholFact{T, I}, side::Val{true}) where {T, I}
    @assert nov(separators(cholfact.symbfact.tree)) == size(rhs, 2)
    @assert length(linwork.frtval) >= cholfact.symbfact.njmax * size(rhs, 1)
    @assert length(linwork.vecval) >= length(rhs)

    tree = cholfact.symbfact.tree
    perm = cholfact.symbfact.perm

    mapping = cholfact.mapping

    blkptr = cholfact.blkptr
    blkval = cholfact.blkval

    updptr = linwork.updptr
    updval = linwork.updval
    frtval = linwork.frtval
    vecval = linwork.vecval

    residual = residuals(tree)
    separator = separators(tree)

    neqns = nov(separators(tree))
    nrhs = convert(I, size(rhs, 1))
    vec = reshape(view(vecval, oneto(nrhs * neqns)), nrhs, neqns)

    updptr[begin] = one(I); ns = zero(I)

    @inbounds for c in oneto(nrhs), v in oneto(neqns)
        vec[c, v] = rhs[c, perm[v]]
    end

    @inbounds for j in vertices(separator)
        ns = rdiv!_loop_fwd!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, vec, ns, j)
    end

    @inbounds for j in reverse(vertices(separator))
        ns = rdiv!_loop_bwd!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, vec, ns, j)
    end

    @inbounds for c in oneto(nrhs), v in oneto(neqns)
        rhs[c, perm[v]] = vec[c, v]
    end

    return rhs
end

"""
    linsolve!(rhs::AbstractArray, ldltfact::LDLTFact, side::Val)

Solve a linear system of equations.

```julia-repl
julia> import CliqueTrees

julia> matrix = [
           3 1 0 0 0 0 0 0
           1 3 1 0 0 2 0 0
           0 1 3 1 0 1 2 1
           0 0 1 3 0 0 0 0
           0 0 0 0 3 1 1 0
           0 2 1 0 1 3 0 0
           0 0 2 0 1 0 3 1
           0 0 1 0 0 0 1 3
       ];

julia> rhs = rand(8, 2);

julia> ldltfact = CliqueTrees.ldlt(matrix)
LDLTFact{Float64, Int64}:
    nnz: 19
    success: true

julia> sol = CliqueTrees.linsolve!(rhs, ldltfact, Val(false)) # sol = inv(matrix) * rhs
8×2 Matrix{Float64}:
  0.339907    0.0202252
 -0.364903    0.573497
 -0.243223    0.354763
  0.293368   -0.00477056
 -0.336252    0.507332
  0.600361   -0.655479
  0.452218   -0.266566
 -0.0620433   0.0528108
```

### Parameters

  - `rhs`: right-hand side
  - `ldltfact`: factorized coefficient matrix
  - `side`: left or right division
    - `Val(false)`: left division
    - `Val(true)`: right division
"""
linsolve!(rhs::AbstractArray, ldltfact::LDLTFact, side::Val)

function linsolve!(rhs::AbstractMatrix, ldltfact::LDLTFact, side::Val{false})
    return linsolve!(rhs, lininit(size(rhs, 2), ldltfact), ldltfact, side)
end

function linsolve!(rhs::AbstractMatrix, ldltfact::LDLTFact, side::Val{true})
    return linsolve!(rhs, lininit(size(rhs, 1), ldltfact), ldltfact, side)
end

function linsolve!(rhs::AbstractVector, ldltfact::LDLTFact, side::Val)
    return linsolve!(rhs, lininit(1, ldltfact), ldltfact, side)
end

"""
    linsolve!(rhs::AbstractArray, linwork::LinWork{T}, ldltfact::LDLTFact, side::Val)

Solve a linear system of equations using a pre-allocated workspace.

```julia-repl
julia> import CliqueTrees

julia> matrix = [
           3 1 0 0 0 0 0 0
           1 3 1 0 0 2 0 0
           0 1 3 1 0 1 2 1
           0 0 1 3 0 0 0 0
           0 0 0 0 3 1 1 0
           0 2 1 0 1 3 0 0
           0 0 2 0 1 0 3 1
           0 0 1 0 0 0 1 3
       ];

julia> rhs = rand(8, 2);

julia> ldltfact = CliqueTrees.ldlt(matrix)
LDLTFact{Float64, Int64}:
    nnz: 19
    success: true

julia> linwork = CliqueTrees.lininit(2, ldltfact)
LinWork{Float64}:

julia> sol = CliqueTrees.linsolve!(rhs, linwork, ldltfact, Val(false)) # sol = inv(matrix) * rhs
8×2 Matrix{Float64}:
  0.339907    0.0202252
 -0.364903    0.573497
 -0.243223    0.354763
  0.293368   -0.00477056
 -0.336252    0.507332
  0.600361   -0.655479
  0.452218   -0.266566
 -0.0620433   0.0528108
```

### Parameters

  - `rhs`: right-hand side
  - `linwork`: linear solve workspace
  - `ldltfact`: factorized coefficient matrix
  - `side`: left or right division
    - `Val(false)`: left division
    - `Val(true)`: right division

"""
function linsolve!(rhs::AbstractVector, linwork::LinWork, ldltfact::LDLTFact, side::Val{false})
    return linsolve!(rhs, linwork, ldltfact, Val(true))
end

function linsolve!(rhs::AbstractMatrix, linwork::LinWork{T, I}, ldltfact::LDLTFact{T, I}, side::Val{false}) where {T, I}
    @assert nov(separators(ldltfact.symbfact.tree)) == size(rhs, 1)
    @assert length(linwork.vecval) >= length(rhs)

    tree = ldltfact.symbfact.tree
    neqns = nov(separators(tree))
    nrhs = convert(I, size(rhs, 2))

    adj = reshape(rhs, nrhs, neqns)
    tmp = view(linwork.vecval, oneto(nrhs * neqns))

    copyto!(adj, adjoint!(reshape(tmp, nrhs, neqns), rhs))
    linsolve!(adj, linwork, ldltfact, Val(true))    
    copyto!(rhs, adjoint!(reshape(tmp, neqns, nrhs), adj))

    return rhs
end

function linsolve!(rhs::AbstractVector, linwork::LinWork{T, I}, ldltfact::LDLTFact{T, I}, side::Val{true}) where {T, I}
    @assert nov(separators(ldltfact.symbfact.tree)) == length(rhs)
    @assert length(linwork.frtval) >= ldltfact.symbfact.njmax
    @assert length(linwork.vecval) >= length(rhs)

    tree = ldltfact.symbfact.tree
    perm = ldltfact.symbfact.perm

    mapping = ldltfact.mapping

    blkptr = ldltfact.blkptr
    blkval = ldltfact.blkval
    diaval = ldltfact.diaval

    updptr = linwork.updptr
    updval = linwork.updval
    frtval = linwork.frtval
    vecval = linwork.vecval

    residual = residuals(tree)
    separator = separators(tree)

    neqns = nov(separators(tree))
    vec = view(vecval, oneto(neqns))
    dia = view(diaval, oneto(neqns))

    updptr[begin] = one(I); ns = zero(I)

    @inbounds for v in oneto(neqns)
        vec[v] = rhs[perm[v]]
    end

    @inbounds for j in vertices(separator)
        ns = rdiv!_ldlt_loop_fwd!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, vec, ns, j)
    end

    ldiv!(Diagonal(dia), vec)

    @inbounds for j in reverse(vertices(separator))
        ns = rdiv!_ldlt_loop_bwd!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, vec, ns, j)
    end

    @inbounds for v in oneto(neqns)
        rhs[perm[v]] = vec[v]
    end

    return rhs
end

function linsolve!(rhs::AbstractMatrix, linwork::LinWork{T, I}, ldltfact::LDLTFact{T, I}, side::Val{true}) where {T, I}
    @assert nov(separators(ldltfact.symbfact.tree)) == size(rhs, 2)
    @assert length(linwork.frtval) >= ldltfact.symbfact.njmax * size(rhs, 1)
    @assert length(linwork.vecval) >= length(rhs)

    tree = ldltfact.symbfact.tree
    perm = ldltfact.symbfact.perm

    mapping = ldltfact.mapping

    blkptr = ldltfact.blkptr
    blkval = ldltfact.blkval
    diaval = ldltfact.diaval

    updptr = linwork.updptr
    updval = linwork.updval
    frtval = linwork.frtval
    vecval = linwork.vecval

    residual = residuals(tree)
    separator = separators(tree)

    neqns = nov(separators(tree))
    nrhs = convert(I, size(rhs, 1))
    vec = reshape(view(vecval, oneto(nrhs * neqns)), nrhs, neqns)
    dia = view(diaval, oneto(neqns))

    updptr[begin] = one(I); ns = zero(I)

    @inbounds for c in oneto(nrhs), v in oneto(neqns)
        vec[c, v] = rhs[c, perm[v]]
    end

    @inbounds for j in vertices(separator)
        ns = rdiv!_ldlt_loop_fwd!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, vec, ns, j)
    end

    rdiv!(vec, Diagonal(dia))

    @inbounds for j in reverse(vertices(separator))
        ns = rdiv!_ldlt_loop_bwd!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, vec, ns, j)
    end

    @inbounds for c in oneto(nrhs), v in oneto(neqns)
        rhs[c, perm[v]] = vec[c, v]
    end

    return rhs
end

function Base.show(io::IO, ::MIME"text/plain", linwork::LinWork{T}) where {T}
    print(io, "LinWork{$T}:")
end

struct ChordalTriangular{DIAG, UPLO, T, I, Dvl <: AbstractVector{T}, Lvl <: AbstractVector{T}} <: AbstractMatrix{T}
    S::ChordalSymbolic{I}
    Dval::Dvl
    Lval::Lvl
end

const FChordalTriangular{DIAG, UPLO, T, I} = ChordalTriangular{
    DIAG,
    UPLO,
    T,
    I,
    FVector{T},
    FVector{T},
}

const DChordalTriangular{DIAG, UPLO, T, I} = ChordalTriangular{
    DIAG,
    UPLO,
    T,
    I,
    Vector{T},
    Vector{T},
}

const SymbolicChordalTriangular{UPLO, I} = ChordalTriangular{
    :N,
    UPLO,
    Bool,
    I,
    IOnes{Bool},
    IOnes{Bool},
}

const AdjTri{DIAG, UPLO, T, I, Dvl, Lvl} = Adjoint{T, ChordalTriangular{DIAG, UPLO, T, I, Dvl, Lvl}}
const TransTri{DIAG, UPLO, T, I, Dvl, Lvl} = Transpose{T, ChordalTriangular{DIAG, UPLO, T, I, Dvl, Lvl}}
const HermTri{UPLO, T, I, Dvl, Lvl} = Hermitian{T, ChordalTriangular{:N, UPLO, T, I, Dvl, Lvl}}
const SymTri{UPLO, T, I, Dvl, Lvl} = Symmetric{T, ChordalTriangular{:N, UPLO, T, I, Dvl, Lvl}}

const AdjOrTransTri{DIAG, UPLO, T, I, Dvl, Lvl} = Union{
      AdjTri{DIAG, UPLO, T, I, Dvl, Lvl},
    TransTri{DIAG, UPLO, T, I, Dvl, Lvl},
}

const MaybeAdjOrTransTri{DIAG, UPLO, T, I, Dvl, Lvl} = Union{
        AdjOrTransTri{DIAG, UPLO, T, I, Dvl, Lvl},
    ChordalTriangular{DIAG, UPLO, T, I, Dvl, Lvl},
}

const HermOrSymTri{UPLO, T, I, Dvl, Lvl} = Union{
    HermTri{UPLO, T, I, Dvl, Lvl},
     SymTri{UPLO, T, I, Dvl, Lvl},
}

const MaybeHermOrSymTri{UPLO, T, I, Dvl, Lvl} = Union{
             HermOrSymTri{UPLO, T, I, Dvl, Lvl},
    ChordalTriangular{:N, UPLO, T, I, Dvl, Lvl},
}

function ChordalTriangular{DIAG, UPLO}(S::ChordalSymbolic{I}, Dval::Dvl, Lval::Lvl) where {DIAG, UPLO, I <: Integer, T, Dvl <: AbstractVector{T}, Lvl <: AbstractVector{T}}
    return ChordalTriangular{DIAG, UPLO, T, I, Dvl, Lvl}(S, Dval, Lval)
end

function ChordalTriangular{DIAG, UPLO, T, I, Dvl, Lvl}(S::ChordalSymbolic{I}) where {DIAG, UPLO, T, I, Dvl, Lvl}
    Dval = allocate(Dvl, ndz(S))
    Lval = allocate(Lvl, nlz(S))
    return ChordalTriangular{DIAG, UPLO, T, I, Dvl, Lvl}(S, Dval, Lval)
end

function SymbolicChordalTriangular{UPLO}(S::ChordalSymbolic{I}) where {UPLO, I}
    return SymbolicChordalTriangular{UPLO, I}(S)
end

function ChordalTriangular{DIAG, UPLO}(F::ChordalFactorization) where {DIAG, UPLO}
    return ChordalTriangular{DIAG, UPLO}(getfield(F, :S), getfield(F, :Dval), getfield(F, :Lval))
end

function ChordalTriangular{DIAG}(F::ChordalFactorization{<:Any, UPLO}) where {DIAG, UPLO}
    return ChordalTriangular{DIAG, UPLO}(F)
end

function ChordalTriangular(F::ChordalFactorization{DIAG, UPLO}) where {DIAG, UPLO}
    return ChordalTriangular{DIAG, UPLO}(F)
end

function Base.:(==)(A::ChordalTriangular, B::ChordalTriangular)
    return false
end

function Base.:(==)(A::ChordalTriangular{DIAG, UPLO}, B::ChordalTriangular{DIAG, UPLO}) where {DIAG, UPLO}
    return A.S === B.S && A.Dval == B.Dval && A.Lval == B.Lval
end

function Base.getproperty(A::ChordalTriangular{DIAG, UPLO}, s::Symbol) where {DIAG, UPLO}
    if s === :uplo
        return Val(UPLO)
    elseif s === :diag
        return Val(DIAG)
    else
        return getfield(A, s)
    end
end

function Base.show(io::IO, A::T) where {T <: ChordalTriangular}
    n = ncl(A)
    print(io, "$n×$n $T with $(nnz(A)) stored entries")
    return
end

for Tri in (:FChordalTriangular, :DChordalTriangular)
    @eval function Base.show(io::IO, ::Type{$Tri{DIAG, UPLO, T, I}}) where {DIAG, UPLO, T, I}
        print(io, $("$Tri{"), repr(DIAG), ", ", repr(UPLO), ", ", T, ", ", I, "}")
    end
end

function Base.show(io::IO, ::MIME"text/plain", A::T) where {DIAG, UPLO, T <: ChordalTriangular{DIAG, UPLO}}
    n = ncl(A)
    println(io, "$n×$n $T with $(nnz(A)) stored entries:")

    if n < 16
        print_matrix(io, A)
    else
        showsymbolic(io, A.S, A.uplo)
    end

    return
end

function Base.replace_in_print_matrix(A::ChordalTriangular{DIAG, UPLO}, i::Integer, j::Integer, str::AbstractString) where {DIAG, UPLO}
    if UPLO === :L && i < j || UPLO === :U && i > j
        str = replace_with_centered_mark(str)
    end

    return str
end

function Base.similar(A::ChordalTriangular{DIAG, UPLO}, ::Type{T}=eltype(A)) where {DIAG, UPLO, T}
    return ChordalTriangular{DIAG, UPLO}(A.S, similar(A.Dval, T), similar(A.Lval, T))
end

function Base.similar(A::AdjOrTransTri{DIAG, UPLO}, ::Type{T}=eltype(A)) where {DIAG, UPLO, T}
    P = parent(A)

    if UPLO === :L
        B = ChordalTriangular{DIAG, :U}(P.S, similar(P.Dval, T), similar(P.Lval, T))
    else
        B = ChordalTriangular{DIAG, :L}(P.S, similar(P.Dval, T), similar(P.Lval, T))
    end

    return B
end

function Base.similar(A::HermTri{UPLO}, ::Type{T}=eltype(A)) where {UPLO, T}
    return Hermitian(similar(parent(A), T), UPLO)
end

function Base.similar(A::SymTri{UPLO}, ::Type{T}=eltype(A)) where {UPLO, T}
    return Symmetric(similar(parent(A), T), UPLO)
end

function Base.copy(A::MaybeAdjOrTransTri)
    return copyto!(similar(A), A)
end

function Base.copy(A::HermTri{UPLO}) where {UPLO}
    return Hermitian(copy(parent(A)), UPLO)
end

function Base.copy(A::SymTri{UPLO}) where {UPLO}
    return Symmetric(copy(parent(A)), UPLO)
end

function Base.copyto!(A::MaybeAdjOrTransTri, B::MaybeAdjOrTransTri)
    AP, TA = unwrap(A)
    BP, TB = unwrap(B)
    copy_impl!(AP, BP, TA, TB)
    return A
end

function copy_impl!(A::ChordalTriangular, B::ChordalTriangular, tA::Val{TA}, tB::Val{TB}) where {TA, TB}
    if TA === TB
        copyto!(A.Dval, B.Dval)
        copyto!(A.Lval, B.Lval)
    elseif TA === :N
        copy_impl!(A, B, tB)
    elseif TB === :N
        copy_impl!(A, B, tA)
    else
        conj!(copyto!(A.Dval, B.Dval))
        conj!(copyto!(A.Lval, B.Lval))
    end

    return A
end

function copy_impl!(A::ChordalTriangular, B::ChordalTriangular, ::Val{TRANS}) where {TRANS}
    @inbounds for j in fronts(B)
        DB, _ = diagblock(B, j)
        LB, _ = offdblock(B, j)
        DA, _ = diagblock(A, j)
        LA, _ = offdblock(A, j)

        if TRANS === :C
            adjoint!(parent(DA), parent(DB))
            adjoint!(LA, LB)
        else
            transpose!(parent(DA), parent(DB))
            transpose!(LA, LB)
        end
    end

    return A
end

function Base.copyto!(A::ChordalTriangular, B::Diagonal)
    fill!(A, 0)

    @inbounds for f in fronts(A)
        D, res = diagblock(A, f)

        for (i, j) in enumerate(diagind(D))
            D[j] = B.diag[res[i]]
        end
    end

    return A
end

function Base.copyto!(A::ChordalTriangular, B::UniformScaling)
    fill!(A, 0)

    @inbounds for f in fronts(A)
        D, _ = diagblock(A, f)

        for j in diagind(D)
            D[j] = B.λ
        end
    end

    return A
end

function Base.copyto!(A::HermOrSymTri, B::HermOrSymTri)
    copyto!(parent(A), parent(B))
    return A
end

function Base.copyto!(A::HermOrSymTri, B::HermOrSymSparse)
    @assert char(parent(A).uplo) == B.uplo
    copyto!(parent(A), parent(B))
    return A
end

function Base.copyto!(A::HermOrSymTri, B::Diagonal)
    copyto!(parent(A), B)
    return A
end

function Base.copyto!(A::HermOrSymTri, B::UniformScaling)
    copyto!(parent(A), B)
    return A
end

# ===== Abstract Matrix Interface =====

function SparseArrays.nnz(A::ChordalTriangular)
    return nnz(A.S)
end

function SparseArrays.findnz(A::ChordalTriangular{DIAG, UPLO, T, I}) where {DIAG, UPLO, T, I}
    m = half(ndz(A) + ncl(A)) + nlz(A)
    rows = Vector{I}(undef, m)
    cols = Vector{I}(undef, m)
    vals = Vector{T}(undef, m)

    p = zero(I)

    @inbounds for j in fronts(A)
        D, res = diagblock(A, j)
        L, sep = offdblock(A, j)

        if UPLO === :L
            for w in eachindex(res)
                for v in w:length(res)
                    p += one(I)
                    rows[p] = res[v]
                    cols[p] = res[w]
                    vals[p] = D[v, w]
                end

                for v in eachindex(sep)
                    p += one(I)
                    rows[p] = sep[v]
                    cols[p] = res[w]
                    vals[p] = L[v, w]
                end
            end
        else
            for v in eachindex(res)
                for w in 1:v
                    p += one(I)
                    rows[p] = res[w]
                    cols[p] = res[v]
                    vals[p] = D[w, v]
                end
            end

            for v in eachindex(sep)
                for w in eachindex(res)
                    p += one(I)
                    rows[p] = res[w]
                    cols[p] = sep[v]
                    vals[p] = L[w, v]
                end
            end
        end
    end

    return (rows, cols, vals)
end

function ndz(A::ChordalTriangular)
    return ndz(A.S)
end

function nlz(A::ChordalTriangular)
    return nlz(A.S)
end

function ncl(A::MaybeAdjOrTransTri)
    return ncl(parent(A).S)
end

function nfr(A::MaybeAdjOrTransTri)
    return nfr(parent(A).S)
end

function Base.size(L::ChordalTriangular)
    return size(L.S)
end

function LinearAlgebra.istriu(::ChordalTriangular{DIAG, UPLO}) where {DIAG, UPLO}
    return UPLO === :U
end

function LinearAlgebra.istril(::ChordalTriangular{DIAG, UPLO}) where {DIAG, UPLO}
    return UPLO === :L
end

function LinearAlgebra.isposdef(A::ChordalTriangular{DIAG, UPLO}) where {DIAG, UPLO}
    if DIAG === :N
        @inbounds for j in fronts(A)
            D, res = diagblock(A, j)
            all(ispositive, view(D, diagind(D))) || return false
        end
    end

    return true
end

function LinearAlgebra.det(A::ChordalTriangular{DIAG, UPLO, T}) where {DIAG, UPLO, T}
    out = one(T)

    if DIAG === :N
        @inbounds for j in fronts(A)
            D, res = diagblock(A, j)
            out *= det(D)
        end
    end

    return out
end

function LinearAlgebra.logdet(A::ChordalTriangular{DIAG, UPLO, T}) where {DIAG, UPLO, T}
    out = zero(T)

    if DIAG === :N
        @inbounds for j in fronts(A)
            D, res = diagblock(A, j)
            out += logdet(D)
        end
    end

    return out
end

function LinearAlgebra.logabsdet(A::ChordalTriangular{DIAG, UPLO, T}) where {DIAG, UPLO, T}
    out = (zero(real(T)), one(T))

    if DIAG === :N
        @inbounds for j in fronts(A)
            D, res = diagblock(A, j)
            a, b = out
            c, d = logabsdet(D)
            out = (a + c, b * d)
        end
    end

    return out
end

function LinearAlgebra.tr(A::ChordalTriangular{DIAG, UPLO, T}) where {DIAG, UPLO, T}
    if DIAG === :N
        out = zero(T)

        @inbounds for j in fronts(A)
            D, res = diagblock(A, j)
            out += tr(D)
        end

        return out
    else
        return convert(T, ncl(A))
    end
end

function LinearAlgebra.tr(A::HermOrSymTri)
    return tr(parent(A))
end

function LinearAlgebra.rank(A::ChordalTriangular{DIAG, UPLO, T, I}; kw...) where {DIAG, UPLO, T, I <: Integer}
    if DIAG === :N
        out = 0

        @inbounds for j in fronts(A)
            D, res = diagblock(A, j)
            out += rank(D; kw...)
        end

        return out
    else
        return ncl(A)
    end
end

function LinearAlgebra.diag(A::ChordalTriangular{DIAG, UPLO, T}) where {DIAG, UPLO, T}
    out = Vector{T}(undef, ncl(A))

    if DIAG === :N
        @inbounds for j in fronts(A)
            D, res = diagblock(A, j)
            out[res] .= view(D, diagind(D))
        end
    else
        out .= one(T)
    end

    return out
end

function symdot(A::AbstractMatrix, B::AbstractMatrix)
    return dot_impl(A, B, Val(true))
end

function symdot(A::SparseMatrixCSC, B::ChordalTriangular)
    return symdot(B, A)
end

function LinearAlgebra.dot(A::ChordalTriangular, B::SparseMatrixCSC)
    return dot_impl(parent(A), parent(B), Val(false)) 
end

function LinearAlgebra.dot(A::SparseMatrixCSC, B::ChordalTriangular)
    return dot(B, A)
end

function LinearAlgebra.dot(A::HermOrSymTri, B::Union{HermOrSymSparse, HermOrSymTri})
    @assert A.uplo == B.uplo
    return symdot(parent(A), parent(B))
end

function LinearAlgebra.dot(A::HermOrSymSparse, B::HermOrSymTri)
    return dot(B, A)
end

function dot_impl(A::ChordalTriangular{DIAG, UPLO, T}, B::ChordalTriangular{DIAG, UPLO, T}, ::Val{SYM}) where {DIAG, UPLO, T, SYM}
    @assert checksymbolic(A, B)

    if SYM
        out = zero(real(T))
    else
        out = zero(T)
    end

    @inbounds for j in fronts(A)
        DA, _ = diagblock(A, j)
        DB, _ = diagblock(B, j)

        if SYM
            SA = sym(A.uplo, parent(DA))
            SB = sym(B.uplo, parent(DB))
            out += dot(SA, SB)
        else
            out += dot(DA, DB)
        end
    end

    if SYM
        out += twice(real(dot(A.Lval, B.Lval)))
    else
        out += dot(A.Lval, B.Lval)
    end

    return out
end

function dot_impl(A::ChordalTriangular{DIAG, :L, T, I}, B::SparseMatrixCSC{T}, sym::Val{SYM}) where {DIAG, T, I, SYM}
    out = zero(T)

    @inbounds for f in fronts(A)
        D, res = diagblock(A, f)
        L, sep = offdblock(A, f)

        rlo = first(res)
        rhi = last(res)

        if !isempty(sep)
            slo = first(sep)
            shi = last(sep)
        end

        for jloc in eachindex(res)
            j = res[jloc]
            k = one(I)

            for p in nzrange(B, j)
                i = rowvals(B)[p]

                if i <= rhi
                    i < rlo && continue

                    Δ = D[i - rlo + one(I), jloc] * nonzeros(B)[p]

                    if SYM && i != j
                        Δ += conj(Δ)
                    end

                    out += Δ
                elseif !isempty(sep)
                    i < slo && continue
                    i > shi && break

                    while sep[k] < i
                        k += one(I)
                    end

                    Δ = L[k, jloc] * nonzeros(B)[p]

                    if SYM
                        Δ += conj(Δ)
                    end

                    out += Δ
                    k += one(I)
                end
            end
        end
    end

    return real(out)
end

function dot_impl(A::ChordalTriangular{DIAG, :U, T, I}, B::SparseMatrixCSC{T}, sym::Val{SYM}) where {DIAG, T, I, SYM}
    out = zero(T)

    @inbounds for f in fronts(A)
        D, res = diagblock(A, f)
        L, sep = offdblock(A, f)

        rlo = first(res)
        rhi = last(res)

        for jloc in eachindex(res)
            j = res[jloc]

            for p in nzrange(B, j)
                i = rowvals(B)[p]
                i < rlo && continue
                i > rhi && break

                Δ = D[i - rlo + one(I), jloc] * nonzeros(B)[p]

                if SYM && i != j
                    Δ += conj(Δ)
                end

                out += Δ
            end
        end

        for jloc in eachindex(sep)
            j = sep[jloc]

            for p in nzrange(B, j)
                i = rowvals(B)[p]
                i < rlo && continue
                i > rhi && break

                Δ = L[i - rlo + one(I), jloc] * nonzeros(B)[p]

                if SYM
                    Δ += conj(Δ)
                end

                out += Δ
            end
        end
    end

    return real(out)
end

function LinearAlgebra.dot(A::ChordalTriangular, J::Diagonal)
    out = zero(promote_eltype(A, J))

    @inbounds for f in fronts(A)
        D, res = diagblock(A, f)

        for (i, j) in enumerate(diagind(D))
            out += conj(D[j]) * J.diag[res[i]]
        end
    end

    return out
end

function LinearAlgebra.dot(J::Diagonal, A::ChordalTriangular)
    return dot(A, J)
end

function LinearAlgebra.dot(A::HermOrSymTri, D::Diagonal)
    return dot(parent(A), D)
end

function LinearAlgebra.dot(D::Diagonal, A::HermOrSymTri)
    return dot(D, parent(A))
end

function dist2(A::AbstractVecOrMat{TA}, B::AbstractVecOrMat{TB}) where {TA, TB}
    out = zero(real(promote_type(TA, TB)))

    @inbounds for i in eachindex(A, B)
        out += abs2(A[i] - B[i])
    end

    return out
end

function dist2(A::ChordalTriangular{DIAG, UPLO, TA}, B::ChordalTriangular{DIAG, UPLO, TB}) where {DIAG, UPLO, TA, TB}
    @assert checksymbolic(A, B)
    out = zero(real(promote_type(TA, TB)))

    @inbounds for j in fronts(A)
        DA, _ = diagblock(A, j)
        DB, _ = diagblock(B, j)
        out += dist2(DA, DB)
    end

    out += dist2(A.Lval, B.Lval)
    return out
end

function norm1(A::ChordalTriangular{DIAG, UPLO, T}) where {DIAG, UPLO, T}
    out = zero(real(T))

    @inbounds for j in fronts(A)
        D, _ = diagblock(A, j)
        out += norm(D, 1)
    end

    out += norm(A.Lval, 1)
    return out
end

function norm2(A::ChordalTriangular{DIAG, UPLO, T}) where {DIAG, UPLO, T}
    out = zero(real(T))

    @inbounds for j in fronts(A)
        D, _ = diagblock(A, j)
        out += sum(abs2, D)
    end

    out += sum(abs2, A.Lval)
    return sqrt(out)
end

function norminf(A::ChordalTriangular{DIAG, UPLO, T}) where {DIAG, UPLO, T}
    out = zero(real(T))

    @inbounds for j in fronts(A)
        D, _ = diagblock(A, j)
        out = max(out, norm(D, Inf))
    end

    out = max(out, norm(A.Lval, Inf))
    return out
end

function LinearAlgebra.norm(A::ChordalTriangular, p::Real=2)
    if p == 1
        return norm1(A)
    elseif p == 2
        return norm2(A)
    elseif p == Inf
        return norminf(A)
    else
        error()
    end
end

function Base.isapprox(A::ChordalTriangular{DIAG, UPLO, T}, B::ChordalTriangular{DIAG, UPLO, T}; rtol=sqrt(eps(real(T))), atol=zero(real(T))) where {DIAG, UPLO, T}
    @assert checksymbolic(A, B)
    return sqrt(dist2(A, B)) <= max(atol, rtol * max(norm2(A), norm2(B)))
end

function Base.isapprox(A::HermOrSymTri{UPLO}, B::HermOrSymTri{UPLO}; kw...) where {UPLO}
    return isapprox(parent(A), parent(B); kw...)
end

function SparseArrays.sparse(A::ChordalTriangular{DIAG, UPLO, T, I}) where {DIAG, UPLO, T, I <: Integer}
    return sparse_impl(A, Val(:N))
end

function SparseArrays.sparse(A::Adjoint{T, ChordalTriangular{DIAG, UPLO, T, I}}) where {DIAG, UPLO, T, I <: Integer}
    return sparse_impl(parent(A), Val(:C))
end

function SparseArrays.sparse(A::Transpose{T, ChordalTriangular{DIAG, UPLO, T, I}}) where {DIAG, UPLO, T, I <: Integer}
    return sparse_impl(parent(A), Val(:T))
end

function sparse_impl(A::ChordalTriangular{DIAG, UPLO, T, I}, ::Val{TRANS}) where {DIAG, UPLO, T, I <: Integer, TRANS}
    m = half(ndz(A) + ncl(A)) + nlz(A)

    colptr = Vector{I}(undef, 1 + ncl(A))
    rowval = Vector{I}(undef, m)
    nzval = Vector{T}(undef, m)

    p = zero(I)

    @inbounds for j in fronts(A)
        D, res = diagblock(A, j)
        L, sep = offdblock(A, j)

        for w in eachindex(res)
            colptr[res[w]] = p + one(I)

            for v in w:length(res)
                if UPLO === :L
                    x = D[v, w]
                else
                    x = D[w, v]
                end

                if TRANS === :C
                    x = conj(x)
                end

                p += one(I); rowval[p] = res[v]; nzval[p] = x
            end

            for v in eachindex(sep)
                if UPLO === :L
                    x = L[v, w]
                else
                    x = L[w, v]
                end

                if TRANS === :C
                    x = conj(x)
                end

                p += one(I); rowval[p] = sep[v]; nzval[p] = x
            end
        end
    end

    colptr[end] = p + one(I)

    S = SparseMatrixCSC{T, I}(size(A)..., colptr, rowval, nzval)

    if isforward(UPLO, TRANS, :R)
        S = copy(transpose(S))
    end

    return S
end

function SparseArrays.sparse(A::HermTri{UPLO}) where {UPLO}
    return Hermitian(sparse(parent(A)), UPLO)
end

function SparseArrays.sparse(A::SymTri{UPLO}) where {UPLO}
    return Symmetric(sparse(parent(A)), UPLO)
end

function Base.getindex(A::ChordalTriangular{DIAG, UPLO, T}, v::Integer, w::Integer) where {DIAG, UPLO, T}
    if DIAG !== :U || v != w
        return getflatindex(A, flatindex(A, v, w))
    else
        return one(T)
    end
end

function Base.isstored(A::ChordalTriangular, v::Integer, w::Integer)
    return isstored(A.S, v, w, A.uplo)
end

function Base.setindex!(A::ChordalTriangular{DIAG, UPLO}, x, v::Integer, w::Integer) where {DIAG, UPLO}
    if DIAG !== :U || v != w
        return setflatindex!(A, x, flatindex(A, v, w))
    else
        error()
    end
end

function flatindex(A::ChordalTriangular, v::Integer, w::Integer)
    @boundscheck checkbounds(A, v, w)
    return flatindex(A.S, v, w, A.uplo)
end

function flatindices(A::ChordalTriangular, B::SparseMatrixCSC)
    return flatindices(A.S, B, A.uplo)
end

function getflatindex(A::ChordalTriangular{DIAG, UPLO, T}, p::Integer) where {DIAG, UPLO, T}
    poff = ndz(A)

    if iszero(p)
        return zero(T)
    elseif p <= poff
        return A.Dval[p]
    else
        return A.Lval[p - poff]
    end
end

function setflatindex!(A::ChordalTriangular, x, p::Integer)
    poff = ndz(A)

    if iszero(p)
        error()
    elseif p <= poff
        A.Dval[p] = x
    else
        A.Lval[p - poff] = x
    end

    return A
end


function Base.copyto!(A::ChordalTriangular{DIAG, :L, T, I}, B::SparseMatrixCSC) where {DIAG, T, I}
    zerorec!(A.Dval)
    zerorec!(A.Lval)

    @inbounds for i in fronts(A)
        D, res = diagblock(A, i)
        L, sep = offdblock(A, i)

        rlo = first(res)
        rhi = last(res)

        if !isempty(sep)
            slo = first(sep)
            shi = last(sep)
        end

        for j in eachindex(res)
            k = one(I)

            for p in nzrange(B, res[j])
                row = rowvals(B)[p]

                if row <= rhi
                    row < rlo && continue
                    parent(D)[row - rlo + one(I), j] = nonzeros(B)[p]
                elseif !isempty(sep)
                    row < slo && continue
                    row > shi && break

                    while sep[k] < row
                        k += one(I)
                    end

                    L[k, j] = nonzeros(B)[p]
                    k += one(I)
                end
            end
        end
    end

    return A
end

function Base.copyto!(A::ChordalTriangular{DIAG, :U, T, I}, B::SparseMatrixCSC) where {DIAG, T, I}
    zerorec!(A.Dval)
    zerorec!(A.Lval)

    @inbounds for i in fronts(A)
        D, res = diagblock(A, i)
        L, sep = offdblock(A, i)

        rlo = first(res)
        rhi = last(res)

        for j in eachindex(res)
            for p in nzrange(B, res[j])
                row = rowvals(B)[p]
                row < rlo && continue
                row > rhi && break
                parent(D)[row - rlo + one(I), j] = nonzeros(B)[p]
            end
        end

        for j in eachindex(sep)
            for p in nzrange(B, sep[j])
                row = rowvals(B)[p]
                row < rlo && continue
                row > rhi && break
                L[row - rlo + one(I), j] = nonzeros(B)[p]
            end
        end
    end

    return A
end

function Base.copy!(A::ChordalTriangular, B::AbstractMatrix)
    return copyto!(A, B)
end

function Base.fill!(A::ChordalTriangular, x)
    fill!(A.Dval, x)
    fill!(A.Lval, x)
    return A
end

function Base.fill!(A::AdjOrTransTri, x)
    if A isa Adjoint
        x = conj(x)
    end

    fill!(parent(A), x)
    return A
end

function Base.fill!(A::HermOrSymTri, x)
    if A isa Hermitian && x isa Complex
        @assert isreal(x)
    end

    fill!(parent(A), x)
    return A
end

function LinearAlgebra.cond(F::MaybeAdjOrTransTri, p::Real=2)
    if p == 1
        condest1(F)
    elseif p == 2
        condest2(F)
    elseif p == Inf
        condest1(adjoint(F))
    else
        error()
    end
end

function LinearAlgebra.opnorm(A::MaybeAdjOrTransTri, p::Real=2)
    if p == 1
        opnorm1(A)
    elseif p == 2
        opnormest2(A)
    elseif p == Inf
        opnorminf(A)
    else
        error()
    end
end

function fronts(A::MaybeAdjOrTransTri)
    return fronts(parent(A).S)
end

function diagblock(A::ChordalTriangular, j::Integer)
    return diagblock_impl(A.S.res, A.S.Dptr, A.Dval, A.diag, A.uplo, j)
end

function diagblock_impl(
        res::AbstractGraph{I},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        diag::Val{DIAG},
        uplo::Val{UPLO},
        j::Integer,
    ) where {DIAG, UPLO, T, I}
    @boundscheck checkbounds(vertices(res), j)
    #
    # nn is the length of the residual at node j
    #
    #   nn = | res(j) |
    #
    nn = eltypedegree(res, j)
    #
    # D is the diagonal block of A at front j:
    #
    #        res(j)
    #   A = [ D    ] res(j)
    #
    Dp = Dptr[j]
    D = tri(uplo, diag, reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn))

    return D, neighbors(res, j)
end

function offdblock(A::ChordalTriangular, j::Integer)
    return offdblock_impl(A.S.res, A.S.sep, A.S.Lptr, A.Lval, A.uplo, j)
end

function offdblock_impl(
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        uplo::Val{UPLO},
        j::Integer,
    ) where {UPLO, T, I}
    @boundscheck checkbounds(vertices(res), j)
    #
    # nn is the length of the residual at node j
    #
    #   nn = | res(j) |
    #
    nn = eltypedegree(res, j)
    #
    # na is the length of the separator at node j
    #
    #   na = | sep(j) |
    #
    na = eltypedegree(sep, j)
    #
    # L is the off-diagonal block of A at front j:
    #
    #        res(j)
    #   A = [ L    ] sep(j)
    #
    Lp = Lptr[j]

    if UPLO === :L
        L = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end

    return L, neighbors(sep, j)
end

function symbolic(A::ChordalTriangular)
    return A.S
end

function symbolic(A::HermOrSymTri)
    return symbolic(parent(A))
end

function symbolic(A::AdjOrTransTri)
    return symbolic(parent(A))
end

function project(A::HermOrSymSparse, B::HermOrSymTri, P::Permutation)
    PB = sympermute(parent(A), P.invp, A.uplo, B.uplo)
    selaxpby!(true, parent(B), false, PB)
    PA = sympermute(PB,        P.perm, B.uplo, A.uplo)

    if A isa Hermitian
        return Hermitian(PA, Symbol(A.uplo))
    else
        return Symmetric(PA, Symbol(A.uplo))
    end
end

"""
    Parent{V, Prnt} <: AbstractUnitRange{V}

A rooted forest T = (V, E) with edges oriented from
leaf to root.
"""
struct Parent{V <: Integer, Prnt <: AbstractVector{V}} <: AbstractUnitRange{V}
    """
    V is equal to the set

        V := {1, 2, ..., nv}

    """
    nv::V

    """
    E is equal to the set

        E := {(v, prnt[v]) : v ∈ V and prnt[v] > 0}

    In particular, v is a root if an only if prnt[v] is nonpositive.
    """
    prnt::Prnt

    function Parent{V, Prnt}(nv::Integer, prnt::AbstractVector) where {V <: Integer, Prnt <: AbstractVector{V}}
        @assert !isnegative(nv)
        @assert nv <= length(prnt)
        return new{V, Prnt}(nv, prnt)
    end
end

const FParent{V} = Parent{V, FVector{V}}

function Parent{V, Prnt}(nv::Integer) where {V, Prnt}
    prnt = Prnt(undef, nv)
    return Parent(convert(V, nv), prnt)
end

function Parent(nv::V, prnt::Prnt) where {V <: Integer, Prnt <: AbstractVector{V}}
    tree = Parent{V, Prnt}(nv, prnt)
    return tree
end

function Parent{V}(nv::Integer) where {V}
    return Parent{V, FVector{V}}(nv)
end

# A Compact Row Storage Scheme for Cholesky Factors Using Elimination Trees
# Liu
# Algorithm 4.2: Elimination Tree by Path Compression.
#
# Construct the elimination tree of an ordered graph.
# The complexity is O(m log n), where m = |E| and n = |V|.
function etree_impl!(
        tree::Parent{V},
        ancestor::AbstractVector{V},
        upper::AbstractGraph{V},
        order::AbstractVector{V}=vertices(upper),
        index::AbstractVector{V}=vertices(upper),
    ) where {V}
    @assert nv(upper) == length(tree)
    @assert nv(upper) <= length(ancestor)
    @assert nv(upper) <= length(order)
    @assert nv(upper) <= length(index)
    n = nv(upper); parent = tree.prnt

    @inbounds for i in oneto(n)
        parent[i] = zero(V)
        ancestor[i] = zero(V)

        for k in neighbors(upper, order[i])
            r = index[k]

            if r < i
                while !iszero(ancestor[r]) && ancestor[r] != i
                    t = ancestor[r]
                    ancestor[r] = i
                    r = t
                end

                if iszero(ancestor[r])
                    ancestor[r] = i
                    parent[r] = i
                end
            end
        end
    end

    return
end

# Compute the `root`, `child`, and `brother` fields of a forest.
function lcrs_impl!(
        brother::AbstractVector{V},
        child::AbstractVector{V},
        tree::Parent{V},
    ) where {V}
    @assert length(tree) <= length(brother)
    @assert length(tree) <= length(child)
    root = zero(V)

    @inbounds for i in tree
        child[i] = zero(V)
    end

    @inbounds for i in reverse(tree)
        j = parentindex(tree, i)

        if isnothing(j)
            brother[i] = root; root = i
        else
            brother[i] = child[j]; child[j] = i
        end
    end

    return root
end

function lcrs_impl!(
        brother::AbstractVector{V},
        child::AbstractVector{V},
        tree::Parent{V},
        root::V,
    ) where {V}
    @assert length(tree) <= length(brother)
    @assert length(tree) <= length(child)
    @assert length(tree) >= root >= one(V)

    @inbounds for i in tree
        child[i] = zero(V)
    end

    skip = root; root = zero(V)

    @inbounds for i in reverse(tree)
        if i != skip
            j = parentindex(tree, i)

            if isnothing(j)
                brother[i] = root; root = i
            else
                brother[i] = child[j]; child[j] = i
            end
        end
    end

    brother[skip] = root
    return
end

function reverse!_impl!(
        graph::BipartiteGraph{V, V},
        tree::Parent{V},
    ) where {V}
    @assert length(tree) == nv(graph) - one(V)
    @assert length(tree) == nov(graph)
    @assert length(tree) == ne(graph)

    @inbounds for i in vertices(graph)
        ii = i + one(V)
        pointers(graph)[ii] = zero(V)
    end

    @inbounds for i in tree
        j = parentindex(tree, i)
        
        if !isnothing(j)
            jj = j + two(V)
            pointers(graph)[jj] += one(V)
        end
    end
    
    @inbounds pointers(graph)[begin] = p = one(V)

    @inbounds for i in vertices(graph)
        ii = i + one(V)
        pointers(graph)[ii] = p += pointers(graph)[ii]
    end
    
    @inbounds for i in tree
        j = parentindex(tree, i)
                
        if isnothing(j)
            j = nv(graph)
        end

        jj = j + one(V)
        targets(graph)[pointers(graph)[jj]] = i
        pointers(graph)[jj] += one(V)
    end

    return graph
end

# An Efficient Algorithm to Compute Row and Column Counts for Sparse Cholesky Factorization
# Gilbert, Ng, and Peyton
# Figure 3: Implementation of algorithm to compute row and column counts.
#
# Compute the lower and higher degrees of the monotone transitive extesion of an ordered graph.
# The complexity is O(mα(m, n)), where m = |E|, n = |V|, and α is the inverse Ackermann function.
function supcnt_impl!(
        wt::AbstractVector{W},
        map0::AbstractVector{V},
        inv0::AbstractVector{V},
        inv1::AbstractVector{V},
        fdesc::AbstractVector{V},
        prev_p::AbstractVector{V},
        prev_nbr::AbstractVector{V},
        sets::UnionFind{V},
        weights::AbstractVector{W},
        lower::AbstractGraph{V},
        tree::Parent{V}
    ) where {W, V}
    @assert nv(lower) <= length(wt)
    @assert nv(lower) <= length(map0)
    @assert nv(lower) <= length(inv0)
    @assert nv(lower) <= length(inv1)
    @assert nv(lower) <= length(fdesc)
    @assert nv(lower) <= length(prev_p)
    @assert nv(lower) <= length(prev_nbr)
    @assert nv(lower) <= length(weights)
    @assert nv(lower) <= length(tree)

    n = nv(lower)
    postorder_impl!(map0, inv1, inv0, fdesc, tree)
    firstdescendants_impl!(fdesc, tree, inv0)

    @inbounds for p in oneto(n)
        wt[p] = weights[p]
        map0[inv0[p]] = p
        inv0[p] = p
        inv1[p] = p
        prev_p[p] = zero(V)
        prev_nbr[p] = zero(V)
        sets.rank[p] = zero(V)
        sets.parent[p] = zero(V)
    end

    @inbounds for p in oneto(n)
        r = parentindex(tree, p)

        if !isnothing(r)
            wt[r] = zero(V)
        end
    end

    map1 = inv0

    function find(u::V)
        v = @inbounds inv1[sets[u]]
        return v
    end

    function union(u::V, v::V)
        @inbounds uu = map1[u]
        @inbounds vv = map1[v]
        @inbounds vv = map1[v] = union!(sets, uu, vv)
        @inbounds inv1[vv] = v
        return
    end

    @inbounds for i in oneto(n)
        p = map0[i]
        r = parentindex(tree, p)

        for u in neighbors(lower, p)
            if iszero(prev_nbr[u]) || prev_nbr[u] < fdesc[p]
                wt[p] += weights[u]
                pp = prev_p[u]

                if !iszero(pp)
                    q = find(pp)
                    wt[q] -= weights[u]
                end

                prev_p[u] = p
            end

            prev_nbr[u] = i
        end

        if !isnothing(r)
            wt[r] -= weights[p]
            union(p, r)
        end
    end

    @inbounds for p in oneto(n)
        r = parentindex(tree, p)

        if !isnothing(r)
            wt[r] += wt[p]
        end
    end
    
    return
end

function compositerotations(graph, clique::AbstractVector, alg::PermutationOrAlgorithm)
    return compositerotations(BipartiteGraph(graph), clique, alg)
end

function compositerotations(graph::AbstractGraph{V}, clique::AbstractVector, alg::PermutationOrAlgorithm) where {V}
    n = nv(graph)
    order, index = permutation(graph, alg)
    upper = sympermute(graph, index, Forward)
    alpha = compositerotations(upper, index[clique])
    invpermute!(order, alpha)
    return order, invperm(order)
end

function compositerotations(upper::AbstractGraph{V}, clique::AbstractVector{V}) where {V}
    E = etype(upper); n = nv(upper); m = ne(upper)
    alpha = Vector{V}(undef, n)
    order = Vector{V}(undef, n)
    index = Vector{V}(undef, n)
    fdesc = Vector{V}(undef, n)
    lower = BipartiteGraph{V, E}(n, n, m)
    tree = Parent{V}(n)
    compositerotations_impl!(alpha, order, index, fdesc, lower, tree, upper, clique)
    return alpha
end

# Equivalent Sparse Matrix Reorderings by Elimination Tree Rotations
# Liu
# Algorithm 3.2: Composite_Rotations
#
# Fast Computation of Minimal Fill Inside a Given Elimination Ordering
# Heggernes and Peyton
# Change_Root
function compositerotations_impl!(
        alpha::AbstractVector{V},
        order::AbstractVector{V},
        index::AbstractVector{V},
        fdesc::AbstractVector{V},
        lower::BipartiteGraph{V, E},
        tree::Parent{V},
        upper::AbstractGraph{V},
        clique::AbstractVector{V},
    ) where {V, E}
    @assert nv(upper) <= length(alpha)
    @assert nv(upper) <= length(order)
    @assert nv(upper) <= length(index)
    @assert nv(upper) <= length(fdesc)
    @assert nv(upper) == nv(lower)
    n = nv(upper)
    etree_impl!(tree, fdesc, upper)
    reverse!_impl!(lower, upper)
    postorder_impl!(alpha, fdesc, index, order, tree)
    firstdescendants_impl!(fdesc, tree, index)

    @inbounds for v in vertices(lower)
        i = index[v]
        order[i] = v
        alpha[v] = zero(V)
    end

    if ispositive(n)
        y = n

        @inbounds for v in Iterators.reverse(clique)
            alpha[v] = n; n -= one(V)
            y = min(v, y)
        end

        @inbounds xstop = index[y]; xstart = xstop + one(V)

        @inbounds for z in ancestorindices(tree, y)
            ystart = fdesc[y]; ystop = index[y]

            for i in ystart:(xstart - one(V))
                v = order[i]

                for w in neighbors(lower, v)
                    if y < w && iszero(alpha[w])
                        alpha[w] = n; n -= one(V)
                    end
                end
            end

            for i in (xstop + one(V)):ystop
                v = order[i]

                for w in neighbors(lower, v)
                    if y < w && iszero(alpha[w])
                        alpha[w] = n; n -= one(V)
                    end
                end
            end

            xstart, xstop = ystart, ystop
            y = z
        end

        @inbounds for v in reverse(vertices(lower))
            if iszero(alpha[v])
                alpha[v] = n; n -= one(V)
            end
        end
    end

    return
end

"""
    postorder(tree::Parent)

Compute a postordering of a forest.
"""
function postorder(tree::Parent{V}) where {V}
    n = length(tree)
    brother = Vector{V}(undef, n)
    child = Vector{V}(undef, n)
    index = Vector{V}(undef, n)
    stack = Vector{V}(undef, n)
    postorder_impl!(brother, child, index, stack, tree)
    return index
end

function postorder_impl!(
        brother::AbstractVector{V},
        child::AbstractVector{V},
        index::AbstractVector{V},
        stack::AbstractVector{V},
        tree::Parent{V},
    ) where {V}
    @assert length(tree) <= length(brother)
    @assert length(tree) <= length(child)
    @assert length(tree) <= length(index)
    @assert length(tree) <= length(stack)
    num = zero(V)

    root = lcrs_impl!(brother, child, tree)

    function brothers(i::V)
        @inbounds head = view(child, i)
        return SinglyLinkedList(head, brother)
    end

    roots = SinglyLinkedList(Fill(root), brother)

    @inbounds for i in roots
        num += one(V); stack[num] = i
    end

    @inbounds for i in tree
        j = stack[num]; num -= one(V)

        while !isempty(brothers(j))
            num += one(V); stack[num] = j
            j = popfirst!(brothers(j))
        end

        index[j] = i
    end

    return
end

function postorder_impl!(
        brother::AbstractVector{V},
        child::AbstractVector{V},
        index::AbstractVector{V},
        stack::AbstractVector{V},
        tree::Parent{V},
        root::V,
    ) where {V}
    @assert length(tree) <= length(brother)
    @assert length(tree) <= length(child)
    @assert length(tree) <= length(index)
    @assert length(tree) <= length(stack)
    @assert length(tree) >= root >= one(V)
    num = zero(V)

    lcrs_impl!(brother, child, tree, root)

    function brothers(i::V)
        @inbounds head = view(child, i)
        return SinglyLinkedList(head, brother)
    end

    roots = SinglyLinkedList(Fill(root), brother)

    @inbounds for i in roots
        num += one(V); stack[num] = i
    end

    @inbounds for i in tree
        j = stack[num]; num -= one(V)

        while !isempty(brothers(j))
            num += one(V); stack[num] = j
            j = popfirst!(brothers(j))
        end

        index[j] = i
    end

    return
end

"""
    postorder!(tree::Parent)

Postorder a forest.
"""
function postorder!(tree::Parent{V}) where {V}
    n = length(tree)
    brother = Vector{V}(undef, n)
    child = Vector{V}(undef, n)
    index = Vector{V}(undef, n)
    stack = Vector{V}(undef, n)
    postorder!_impl!(brother, child, index, stack, tree)
    return index
end

function postorder!(tree::Parent{V}, root::V) where {V}
    n = length(tree)
    brother = Vector{V}(undef, n)
    child = Vector{V}(undef, n)
    index = Vector{V}(undef, n)
    stack = Vector{V}(undef, n)
    postorder!_impl!(brother, child, index, stack, tree, root::V)
    return index
end

function postorder!_impl!(
        brother::AbstractVector{V},
        child::AbstractVector{V},
        index::AbstractVector{V},
        stack::AbstractVector{V},
        tree::Parent{V},
    ) where {V}
    postorder_impl!(brother, child, index, stack, tree)
    invpermute!_impl!(stack, tree, index)
    return
end

function postorder!_impl!(
        brother::AbstractVector{V},
        child::AbstractVector{V},
        index::AbstractVector{V},
        stack::AbstractVector{V},
        tree::Parent{V},
        root::V,
    ) where {V}
    postorder_impl!(brother, child, index, stack, tree, root)
    invpermute!_impl!(stack, tree, index)
    return
end

function firstdescendants_impl!(
        fdesc::AbstractVector{V},
        tree::Parent{V},
        index::AbstractVector{V}=tree,
    ) where {V}
    @assert length(tree) <= length(fdesc)
    @assert length(tree) <= length(index)

    @inbounds for i in tree
        fdesc[i] = index[i]
    end

    @inbounds for i in tree
        j = parentindex(tree, i)

        if !isnothing(j)
            fdesc[j] = min(fdesc[i], fdesc[j])
        end
    end

    return
end

function invpermute!_impl!(
        parent::AbstractVector{V},
        tree::Parent{V},
        index::AbstractVector{V},
    ) where {V}
    @assert length(tree) <= length(parent)
    @assert length(tree) <= length(index)

    @inbounds for i in tree
        j = parentindex(tree, i)

        if isnothing(j)
            parent[index[i]] = zero(V)
        else
            parent[index[i]] = index[j]
        end
    end

    @inbounds for i in tree
        tree.prnt[i] = parent[i]
    end

    return
end

function setrootindex!(tree::Parent{I}, root::Integer) where {I <: Integer}
    return setrootindex!(tree, convert(I, root))
end

function setrootindex!(tree::Parent{I}, root::I) where {I <: Integer}
    @assert root in tree
    parent = tree.prnt; i = zero(I); j = root

    @inbounds while ispositive(j)
        k = parent[j]; parent[j] = i; i = j; j = k
    end

    return tree
end

function Base.copy(tree::Parent)
    return Parent(tree.nv, copy(tree.prnt))
end

function Base.copy!(dst::Parent, src::Parent)
    @assert length(dst) == length(src)
    copyto!(dst.prnt, 1, src.prnt, 1, length(dst))
    return dst
end

##########################
# Indexed Tree Interface #
##########################

@propagate_inbounds function AbstractTrees.parentindex(tree::Parent, i::Integer)
    @boundscheck checkbounds(tree, i)
    @inbounds j = tree.prnt[i]

    if !ispositive(j)
        j = nothing
    end

    return j
end

@propagate_inbounds function ancestorindices(tree::Parent, i::Integer)
    @boundscheck checkbounds(tree, i)
    @inbounds head = view(tree.prnt, i)
    return SinglyLinkedList(head, tree.prnt)
end

#################################
# Abstract Unit Range Interface #
#################################

function Base.first(tree::Parent{V}) where {V}
    return one(V)
end

function Base.last(tree::Parent{V}) where {V}
    return tree.nv
end

function complete_dense!(
        X::AbstractMatrix{T},
        L::ChordalTriangular{:N, UPLO, T, I};
        check::Bool=true,
    ) where {UPLO, T, I <: Integer}
    n = ncl(L)

    mark  = FVector{I}(undef, n)
    Wval = FVector{T}(undef, n * L.S.nFval)

    info = complete_dense_impl!(X, Wval, mark, L)
    check && checkinfo(info, L.diag)

    return X
end

function complete_dense_impl!(
        X::AbstractMatrix{T},
        Wval::AbstractVector{T},
        mark::AbstractVector{I},
        L::ChordalTriangular{:N, UPLO, T, I},
    ) where {UPLO, T, I <: Integer}
    info = complete_dense_impl!(
        X, Wval, mark,
        L.S.Dptr, L.Dval,
        L.S.Lptr, L.Lval,
        L.S.res, L.S.sep, L.S.pnt,
        L.uplo)

    return info
end

function complete_dense_impl!(
        X::AbstractMatrix{T},
        Wval::AbstractVector{T},
        mark::AbstractVector{I},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        pnt::AbstractVector{I},
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    fill!(X, zero(T))
    fill!(mark, zero(I))
    #
    # pre-pass: compute nc (last index of subtree root's residual)
    # stored as -nc in mark[j]
    #
    for j in reverse(vertices(res))
        na = eltypedegree(sep, j)

        if iszero(na)
            mark[j] = one(I) - pointers(res)[j + one(I)]
        else
            mark[j] = mark[pnt[j]]
        end
    end

    for j in reverse(vertices(res))
        info = complete_dense_loop!(X, Wval, mark, Dptr, Dval, Lptr, Lval, res, sep, j, uplo)
        ispositive(info) && return info
    end

    return zero(I)
end

function complete_dense_loop!(
        X::AbstractMatrix{T},
        Wval::AbstractVector{T},
        mark::AbstractVector{I},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        j::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    #
    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    nn = eltypedegree(res, j)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(sep, j)
    #
    # nm is the last index of the residual at node j
    #
    nm = last(neighbors(res, j))
    #
    # nc is the last index of the residual at the root of the subtree
    #
    nc = -mark[j]
    #
    # nb is the number of indices after the front within the subtree
    #
    nb = nc - nm - na
    #
    # mark separator indices with current front
    #
    for i in neighbors(sep, j)
        mark[i] = j
    end
    #
    # D₁₁ is the diagonal block
    #
    #          res(j)
    #     D = [ D₁₁ ] res(j)
    #
    Dp = Dptr[j]
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)
    #
    # L₂₁ is the off-diagonal block
    #
    #          res(j)
    #     L = [ L₂₁ ] sep(j)
    #
    Lp = Lptr[j]

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # W₂₁ and W₂₂ are views into the workspace for separator rows
    # W₃₁ and W₃₂ are views into the workspace for remaining rows
    #
    p = one(I)
    if UPLO === :L
        W₂₁ = reshape(view(Wval, p:p + na * nn - one(I)), na, nn); p += na * nn
        W₂₂ = reshape(view(Wval, p:p + na * na - one(I)), na, na); p += na * na
        W₃₁ = reshape(view(Wval, p:p + nb * nn - one(I)), nb, nn); p += nb * nn
        W₃₂ = reshape(view(Wval, p:p + nb * na - one(I)), nb, na)
    else
        W₂₁ = reshape(view(Wval, p:p + nn * na - one(I)), nn, na); p += nn * na
        W₂₂ = reshape(view(Wval, p:p + na * na - one(I)), na, na); p += na * na
        W₃₁ = reshape(view(Wval, p:p + nn * nb - one(I)), nn, nb); p += nn * nb
        W₃₂ = reshape(view(Wval, p:p + na * nb - one(I)), na, nb)
    end
    #
    # gather X entries into W₂₂ and W₃₂
    #
    complete_dense_gather!(X, W₂₂, W₃₂, mark, res, sep, j, uplo)

    if ispositive(na)
        #
        # W₂₁ ← L₂₁
        #
        copyrec!(W₂₁, L₂₁)
        #
        # W₂₂ ← chol(W₂₂)
        #
        info = potrf!(uplo, W₂₂)
        ispositive(info) && return info
        #
        # W₂₁ ← W₂₂⁻¹ W₂₁
        #
        if UPLO === :L
            trsm!(Val(:L), Val(:L), Val(:N), Val(:N), one(T), W₂₂, W₂₁)
            trsm!(Val(:L), Val(:L), Val(:T), Val(:N), one(T), W₂₂, W₂₁)
        else
            trsm!(Val(:R), Val(:U), Val(:N), Val(:N), one(T), W₂₂, W₂₁)
            trsm!(Val(:R), Val(:U), Val(:T), Val(:N), one(T), W₂₂, W₂₁)
        end
        #
        # W₃₁ ← W₃₂ W₂₁  (for :U, transposed: W₃₁ ← W₂₁ W₃₂)
        #
        if UPLO === :L
            gemm!(Val(:N), Val(:N), one(T), W₃₂, W₂₁, zero(T), W₃₁)
        else
            gemm!(Val(:N), Val(:N), one(T), W₂₁, W₃₂, zero(T), W₃₁)
        end
    end
    #
    # write diagonal block to X
    #
    copyscattertri!(X, D₁₁, neighbors(res, j), uplo)
    #
    # write off-diagonal results back to X
    #
    complete_dense_scatter!(X, L₂₁, W₃₁, mark, res, j, uplo)

    return zero(I)
end

function complete_dense_gather!(
        X::AbstractMatrix{T},
        L₂₂::AbstractMatrix{T},
        L₃₂::AbstractMatrix{T},
        mark::AbstractVector{I},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        f::I,
        ::Val{:L},
    ) where {T, I <: Integer}
    nm = last(neighbors(res, f))
    nc = -mark[f]

    j₁ = 0

    for j in neighbors(sep, f)
        j₁ += 1

        i₂ = 0
        i₃ = 0

        for i in nm + one(I):nc
            if mark[i] == f
                i₂ += 1

                if i₂ ≥ j₁
                    L₂₂[i₂, j₁] = X[i, j]
                end
            else
                i₃ += 1

                if i > j
                    L₃₂[i₃, j₁] = X[i, j]
                else
                    L₃₂[i₃, j₁] = X[j, i]
                end
            end
        end
    end

    return
end

function complete_dense_gather!(
        X::AbstractMatrix{T},
        L₂₂::AbstractMatrix{T},
        L₃₂::AbstractMatrix{T},
        mark::AbstractVector{I},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        f::I,
        ::Val{:U},
    ) where {T, I <: Integer}
    nm = last(neighbors(res, f))
    nc = -mark[f]

    i₂ = 0
    i₃ = 0

    for i in nm + one(I):nc
        if mark[i] == f
            i₂ += 1

            j₁ = 0

            for j in neighbors(sep, f)
                j₁ += 1

                if i₂ ≤ j₁
                    L₂₂[i₂, j₁] = X[i, j]
                end
            end
        else
            i₃ += 1

            j₁ = 0

            for j in neighbors(sep, f)
                j₁ += 1

                if i < j
                    L₃₂[j₁, i₃] = X[i, j]
                else
                    L₃₂[j₁, i₃] = X[j, i]
                end
            end
        end
    end

    return
end

function complete_dense_scatter!(
        X::AbstractMatrix{T},
        L₂₁::AbstractMatrix{T},
        W₃₁::AbstractMatrix{T},
        mark::AbstractVector{I},
        res::AbstractGraph{I},
        f::I,
        ::Val{:L},
    ) where {T, I <: Integer}
    nm = last(neighbors(res, f))
    nc = -mark[f]

    j₁ = 0

    for j in neighbors(res, f)
        j₁ += 1

        i₂ = 0
        i₃ = 0

        for i in nm + one(I):nc
            if mark[i] == f
                i₂ += 1
                X[i, j] = L₂₁[i₂, j₁]
            else
                i₃ += 1
                X[i, j] = W₃₁[i₃, j₁]
            end
        end
    end

    return
end

function complete_dense_scatter!(
        X::AbstractMatrix{T},
        L₂₁::AbstractMatrix{T},
        W₃₁::AbstractMatrix{T},
        mark::AbstractVector{I},
        res::AbstractGraph{I},
        f::I,
        ::Val{:U},
    ) where {T, I <: Integer}
    nm = last(neighbors(res, f))
    nc = -mark[f]

    i₂ = 0
    i₃ = 0

    for i in nm + one(I):nc
        if mark[i] == f
            i₂ += 1

            j₁ = 0

            for j in neighbors(res, f)
                j₁ += 1
                X[j, i] = L₂₁[j₁, i₂]
            end
        else
            i₃ += 1

            j₁ = 0

            for j in neighbors(res, f)
                j₁ += 1
                X[j, i] = W₃₁[j₁, i₃]
            end
        end
    end

    return
end

module MetisExt

using Base: oneto
using Base.Order
using CliqueTrees
using CliqueTrees: EliminationAlgorithm, Parent, UnionFind, simplegraph, partition!, sympermute!_impl!, compositerotations_impl!, bestfill_impl!, bestwidth_impl!, nov
using CliqueTrees.MMDLib: mmd_impl!
using CliqueTrees.Utilities
using Graphs

import Metis

const INT = Metis.idx_t
const NOPTIONS = Metis.METIS_NOPTIONS
const OPTION_CTYPE = Metis.METIS_OPTION_CTYPE + one(INT)
const OPTION_RTYPE = Metis.METIS_OPTION_RTYPE + one(INT)
const OPTION_NSEPS = Metis.METIS_OPTION_NSEPS + one(INT)
const OPTION_NUMBERING = Metis.METIS_OPTION_NUMBERING + one(INT)
const OPTION_NITER = Metis.METIS_OPTION_NITER + one(INT)
const OPTION_SEED = Metis.METIS_OPTION_SEED + one(INT)
const OPTION_COMPRESS = Metis.METIS_OPTION_COMPRESS + one(INT)
const OPTION_CCORDER = Metis.METIS_OPTION_CCORDER + one(INT)
const OPTION_PFACTOR = Metis.METIS_OPTION_PFACTOR + one(INT)
const OPTION_UFACTOR = Metis.METIS_OPTION_UFACTOR + one(INT)

function CliqueTrees.permutation(weights::AbstractVector, graph::AbstractGraph{V}, alg::METIS) where {V}
    simple = simplegraph(INT, INT, graph)
    order::Vector{V}, index::Vector{V} = metis(weights, simple, alg)
    return order, index
end

function CliqueTrees.permutation(weights::AbstractVector, graph::AbstractGraph, alg::ND{<:Any, <:EliminationAlgorithm, METISND})
    order = dissect(weights, graph, alg)
    return order, invperm(order)
end

function metis(weights::AbstractVector, graph::BipartiteGraph{INT, INT}, alg::METIS)
    @assert nv(graph) <= length(weights)
    n = nv(graph); new = Vector{INT}(undef, n)

    @inbounds for v in oneto(n)
        new[v] = trunc(INT, weights[v])
    end

    return metis(new, graph, alg)
end

function metis(weights::Vector{INT}, graph::BipartiteGraph{INT, INT}, alg::METIS)
    n = nv(graph)

    # construct options
    options = Vector{INT}(undef, NOPTIONS)
    setoptions!(options, alg)

    # construct METIS graph
    xadj = pointers(graph)
    adjncy = targets(graph)
    vwght = weights

    # construct permutation
    order = Vector{INT}(undef, n)
    index = Vector{INT}(undef, n)

    Metis.@check Metis.METIS_NodeND(
        Ref{INT}(n),
        xadj,
        adjncy,
        vwght,
        options,
        order,
        index,
    )

    return order, index
end

function separator!(options::AbstractVector{INT}, sepsize::AbstractScalar{INT}, part::AbstractVector{INT}, weights::AbstractVector{INT}, graph::BipartiteGraph{INT, INT}, imbalance::INT, alg::METISND)
    @assert NOPTIONS <= length(options)
    @assert nv(graph) <= length(part)
    @assert nv(graph) <= length(weights)
    @assert ispositive(imbalance)
    n = nv(graph); m = ne(graph); nn = n + one(INT)

    # construct options
    setoptions!(options, imbalance, alg)

    # construct METIS graph
    xadj = pointers(graph)
    adjncy = targets(graph)
    vwght = weights

    @inbounds for i in oneto(nn)
        xadj[i] -= one(INT)
    end

    @inbounds for p in oneto(m)
        adjncy[p] -= one(INT)
    end

    # construct separator
    Metis.@check Metis.METIS_ComputeVertexSeparator(
        Ref{INT}(n),
        xadj,
        adjncy,
        vwght,
        options,
        sepsize,
        part,
    )

    @inbounds for i in oneto(nn)
        xadj[i] += one(INT)
    end

    @inbounds for p in oneto(m)
        adjncy[p] += one(INT)
    end

    return
end

function dissect(weights::AbstractVector{W}, graph::AbstractGraph, alg::ND) where {W}
    n = nv(graph)
    scale = convert(W, alg.scale)
    intweights = FVector{INT}(undef, n)

    @inbounds for v in oneto(n)
        w = weights[v]

        if W <: AbstractFloat
            w *= scale
        end

        intweights[v] = trunc(INT, w)
    end

    return dissect(intweights, graph, alg)
end

function dissect(weights::FVector{INT}, graph::AbstractGraph{V}, alg::ND) where {V <: Integer}
    simple = simplegraph(INT, INT, graph)
    order = convert(Vector{V}, dissectsimple(weights, simple, alg))
    return order
end

function dissectsimple(weights::AbstractVector{INT}, graph::BipartiteGraph{INT, INT}, alg::ND{S}) where {S}
    n = nv(graph); m = ne(graph); nn = n + one(INT)
    maxlevel = convert(INT, alg.level)
    minwidth = convert(INT, alg.width)
    imbalance = convert(INT, alg.imbalance)

    work00 = FScalar{INT}(undef)
    work01 = Vector{INT}(undef, m)
    work02 = Vector{INT}(undef, m)
    work03 = FVector{INT}(undef, max(n, NOPTIONS))
    work04 = FVector{INT}(undef, n)
    work05 = FVector{INT}(undef, n)
    work06 = FVector{INT}(undef, n)
    work07 = FVector{INT}(undef, n)
    work08 = FVector{INT}(undef, n)
    work09 = FVector{INT}(undef, nn)
    work10 = FVector{INT}(undef, nn)
    work11 = FVector{INT}(undef, n)
    work12 = FVector{INT}(undef, n)
    work13 = FVector{INT}(undef, n)
    work14 = FVector{INT}(undef, n)
    work15 = FVector{INT}(undef, n)
    work16 = FVector{INT}(undef, n)

    parts = FVector{INT}[]
    orders = FVector{INT}[]

    nodes = Tuple{
        BipartiteGraph{INT, INT, FVector{INT}, FVector{INT}}, # graph
        FVector{INT},                                         # weights
        BipartiteGraph{INT, INT, FVector{INT}, FVector{INT}}, # label
        FVector{INT},                                         # clique
        INT,                                                  # level
    }[]

    label = BipartiteGraph{INT, INT}(n, n, n)
    clique = FVector{INT}(undef, zero(INT))
    level = zero(INT)

    @inbounds for v in oneto(n)
        pointers(label)[v] = v
        targets(label)[v] = v
    end

    pointers(label)[nn] = nn
    push!(nodes, (graph, weights, label, clique, level))

    @inbounds while !isempty(nodes)
        graph, weights, label, clique, level = pop!(nodes)
        n = nv(graph); m = ne(graph); l = ne(label); k = convert(INT, length(clique))

        if !isnegative(level) # unprocessed
            isleaf = n <= minwidth || level >= maxlevel || m == n * (n - one(INT))

            if isleaf # leaf
                push!(nodes, (graph, weights, label, clique, -one(INT)))
            else      # branch
                if m > length(work01)
                    resize!(work01, half(m))
                    resize!(work02, half(m))
                end

                part = FVector{INT}(undef, n)
                separator!(work03, work00, part, weights, graph, imbalance, alg.dis)

                child0, child1, order2 = partition!(work00, work03, work04, work07, work08,
                    work11, work12, work13, work09, work10, work01, work02, work05, work06,
                    part, weights, graph)

                push!(
                    nodes,
                    (graph, weights, label, clique, -two(INT)),
                    (child0..., level + one(INT)),
                    (child1..., level + one(INT)),
                )

                push!(parts, part)
                push!(orders, order2)
            end
        else                  # processed
            isleaf = isone(-level)
            iscomplete = m == n * (n - one(INT))

            if iscomplete # complete graph
                for v in oneto(n)
                    work03[v] = v
                end
            else
                tree = Parent(n, work06)
                upper = BipartiteGraph(n, n, half(m), work09, work01)
                lower = BipartiteGraph(n, n, half(m), work10, work02)

                if isleaf # leaf
                    order, index = permutation(weights, graph, alg.alg)
                else      # branch
                    part = pop!(parts)
                    ndsorder = Vector{INT}(undef, n)
                    ndsindex = Vector{INT}(undef, n)
                    i = zero(INT)

                    for v in pop!(orders)
                        if !istwo(part[v])
                            ndsindex[v] = i += one(INT)
                            ndsorder[i] = v
                        end
                    end

                    for v in pop!(orders)
                        if !istwo(part[v])
                            ndsindex[v] = i += one(INT)
                            ndsorder[i] = v
                        end
                    end

                    for v in pop!(orders)
                        ndsindex[v] = i += one(INT)
                        ndsorder[i] = v
                    end 

                    if isone(S) || istwo(S)
                        sets = UnionFind(n, work03, work04, work05)
                        grdorder, grdindex = permutation(weights, graph, alg.alg)

                        if isone(S)
                            best = bestwidth_impl!(lower, upper, tree, sets, work07,
                                work08, work11, work12, work13, work14, work15,
                                work16, weights, graph, (ndsindex, grdindex))
                        else
                            best = bestfill_impl!(lower, upper, tree, sets, work07,
                                work08, work11, work12, work13, work14, work15,
                                work16, weights, graph, (ndsindex, grdindex))
                        end

                        order = (ndsorder, grdorder)[best]
                        index = (ndsindex, grdindex)[best]
                    else
                        order, index = ndsorder, ndsindex
                    end
                end

                sympermute!_impl!(upper, graph, index, Forward)

                for i in oneto(k)
                    clique[i] = index[clique[i]]
                end

                compositerotations_impl!(index, work03, work04,
                    work05, lower, tree, upper, clique)

                for v in oneto(n)
                    i = index[v]; work03[i] = order[v]
                end
            end

            j = zero(INT); outorder = FVector{INT}(undef, l)

            for i in oneto(n)
                v = work03[i]

                for w in neighbors(label, v)
                    j += one(INT); outorder[j] = w
                end
            end

            push!(orders, outorder)
        end
    end

    return only(orders)
end

function setoptions!(options::AbstractVector{INT}, imbalance::INT, alg::METISND)
    for i in oneto(NOPTIONS)
        options[i] = -one(INT) # null
    end

    options[OPTION_NSEPS] = convert(INT, alg.nseps)
    options[OPTION_NUMBERING] = one(INT)
    options[OPTION_SEED] = convert(INT, alg.seed)
    options[OPTION_UFACTOR] = convert(INT, imbalance)
    return
end

function setoptions!(options::AbstractVector{INT}, alg::METIS)
    for i in oneto(NOPTIONS)
        options[i] = -one(INT) # null
    end

    options[OPTION_CTYPE] = convert(INT, alg.ctype)
    options[OPTION_RTYPE] = convert(INT, alg.rtype)
    options[OPTION_NSEPS] = convert(INT, alg.nseps)
    options[OPTION_NUMBERING] = one(INT)
    options[OPTION_NITER] = convert(INT, alg.niter)
    options[OPTION_SEED] = convert(INT, alg.seed)
    options[OPTION_COMPRESS] = convert(INT, alg.compress)
    options[OPTION_CCORDER] = convert(INT, alg.ccorder)
    options[OPTION_PFACTOR] = convert(INT, alg.pfactor)
    options[OPTION_UFACTOR] = convert(INT, alg.ufactor)
    return
end

end

function permuteto(::Type{T}, v::AbstractVector, perm::AbstractVector) where {T}
    out = FVector{T}(undef, length(v))

    @inbounds for i in eachindex(perm)
        out[i] = v[perm[i]]
    end

    return out
end

function permuteto(::Type{T}, v::AbstractFill, ::AbstractVector) where {T}
    return convert(AbstractFill{T}, v)
end

function char(::Val{:N})
    return 'N'
end

function char(::Val{:C})
    return 'C'
end

function char(::Val{:T})
    return 'T'
end

function char(::Val{:L})
    return 'L'
end

function char(::Val{:U})
    return 'U'
end

function char(::Val{:R})
    return 'R'
end

function checksymtri(A::HermOrSymTri{UPLO, T}) where {UPLO, T}
    return (!(T <: Complex) || A isa Hermitian) && A.uplo == char(parent(A).uplo)
end

function checksymbolic(A)
    return true
end

function checksymbolic(A, B, C...)
    return symbolic(A) === symbolic(B) && checksymbolic(B, C...)
end

function symmetric(graph, uplo::Char)
    return symmetric(BipartiteGraph(graph), uplo)
end

function symmetric(graph::AbstractGraph{V}, uplo::Char) where {V}
    E = etype(graph)

    fwd = graph; bwd = reverse(fwd)

    n = nv(fwd)
    m = ne(fwd) + ne(bwd)

    mrk = FVector{V}(undef, n)
    ptr = FVector{E}(undef, n + one(V))
    tgt = FVector{V}(undef, m)

    for v in vertices(fwd)
        mrk[v] = zero(V)
    end

    p = zero(E)

    for v in vertices(fwd)
        mrk[v] = v
        ptr[v] = p + one(E)

        for w in neighbors(fwd, v)
            uplo === 'L' && w < v && continue
            uplo === 'U' && w > v && continue

            if mrk[w] < v
                mrk[w] = v
                p += one(E); tgt[p] = w
            end
        end

        for w in neighbors(bwd, v)
            if mrk[w] < v
                mrk[w] = v
                p += one(E); tgt[p] = w
            end
        end
    end

    ptr[n + one(V)] = p + one(E)
    return BipartiteGraph{V, E}(n, n, m, ptr, tgt)
end

function sympermute(A::AbstractMatrix, invp::AbstractVector, src::Char, tgt::Char)
    return sympermute!(similar(A), A, invp, src, tgt)
end

function sympermute(A::ChordalTriangular, invp::AbstractVector, src::Char, tgt::Char)
    return sympermute(sparse(A), invp, src, tgt)
end

function sympermute!(C::AbstractMatrix, A::SparseMatrixCSC, invp::AbstractVector, src::Char, tgt::Char)
    return copyto!(C, sympermute(A, invp, src, tgt))
end

function sympermute!(C::AbstractMatrix, A::ChordalTriangular, invp::AbstractVector, src::Char, tgt::Char)
    return copyto!(C, sympermute(A, invp, src, tgt))
end

function sympermute!(C::AbstractMatrix{T}, A::AbstractMatrix{T}, invp::AbstractVector, src::Char, tgt::Char) where {T}
    n = size(A, 1)

    for j in 1:n
        pj = invp[j]

        if src === 'L'
            rng = j:n
        else
            rng = 1:j
        end

        for i in rng
            pi = invp[i]

            if tgt === 'L'
                lo, hi = minmax(pi, pj)
            else
                hi, lo = minmax(pi, pj)
            end

            if (i > j) == (pi > pj)
                C[hi, lo] = A[i, j]
            else
                C[hi, lo] = conj(A[i, j])
            end
        end
    end

    return C
end

function sympermute(A::SparseMatrixCSC{T, I}, invp::AbstractVector, src::Char, tgt::Char) where {T, I}
    n = size(A, 1)
    m = zero(I)
    colptr = zeros(I, n + 1)

    @inbounds for j in axes(A, 2)
        pj = invp[j]

        for p in nzrange(A, j)
            i = rowvals(A)[p]

            src === 'L' && i < j && continue
            src === 'U' && i > j && continue

            pi = invp[i]

            if tgt === 'L'
                hi = max(pi, pj)
            else
                hi = min(pi, pj)
            end

            if hi < n
                colptr[hi + two(I)] += one(I)
            end

            m += one(I)
        end
    end

    @inbounds colptr[1] = p = one(I)

    @inbounds for i in axes(A, 1)
        colptr[i + 1] = p += colptr[i + 1]
    end

    rowval = Vector{I}(undef, m)
    nzval = Vector{T}(undef, m)

    @inbounds for j in axes(A, 2)
        pj = invp[j]

        for p in nzrange(A, j)
            i = rowvals(A)[p]

            src === 'L' && i < j && continue
            src === 'U' && i > j && continue

            pi = invp[i]

            if tgt === 'L'
                lo, hi = minmax(pi, pj)
            else
                hi, lo = minmax(pi, pj)
            end

            q = colptr[hi + one(I)]
            rowval[q] = lo
            v = nonzeros(A)[p]

            if (i > j) == (pi > pj)
                nzval[q] = conj(v)
            else
                nzval[q] = v
            end

            colptr[hi + one(I)] += one(I)
        end
    end

    B = SparseMatrixCSC{T, I}(n, n, colptr, rowval, nzval)
    return copy(adjoint(B))
end

function colpermute(A::SparseMatrixCSC{T, I}, perm::AbstractVector) where {T, I}
    n = size(A, 2)
    m = nnz(A)
    colptr = Vector{I}(undef, n + 1)
    rowval = Vector{I}(undef, m)
    nzval = Vector{T}(undef, m)

    p = 1

    for j in axes(A, 2)
        colptr[j] = p

        for q in nzrange(A, perm[j])
            rowval[p] = rowvals(A)[q]
            nzval[p] = nonzeros(A)[q]
            p += 1
        end
    end

    colptr[end] = p
    return SparseMatrixCSC{T, I}(size(A)..., colptr, rowval, nzval)
end

function rowpermute(A::SparseMatrixCSC, perm::AbstractVector)
    return permute(A, perm, axes(A, 2))
end

function tri(uplo::Val{:L}, diag::Val{:N}, A::AbstractMatrix)
    return LowerTriangular(A)
end

function tri(uplo::Val{:L}, diag::Val{:U}, A::AbstractMatrix)
    return UnitLowerTriangular(A)
end

function tri(uplo::Val{:U}, diag::Val{:N}, A::AbstractMatrix)
    return UpperTriangular(A)
end

function tri(uplo::Val{:U}, diag::Val{:U}, A::AbstractMatrix)
    return UnitUpperTriangular(A)
end

function sym(::Val{UPLO}, A::AbstractMatrix) where {UPLO}
    return Hermitian(A, UPLO)
end

function adj(tA::Val{:N}, A::AbstractMatrix)
    return A
end

function adj(tA::Val{:T}, A::AbstractMatrix)
    return transpose(A)
end

function adj(tA::Val{:C}, A::AbstractMatrix)
    return adjoint(A)
end

function zerotri!(A::AbstractMatrix{T}, ind::AbstractVector, ::Val{UPLO}) where {UPLO, T}
    @assert size(A, 1) == size(A, 2)
    n = length(ind)

    @inbounds for j in eachindex(ind)
        indj = ind[j]

        if UPLO === :L
            rng = j:n
        else
            rng = 1:j
        end

        for i in rng
            A[ind[i], indj] = zero(T)
        end
    end

    return A
end

function zerotri!(A::AbstractMatrix, uplo::Val)
    return zerotri!(A, axes(A, 1), uplo)
end

function iszerotri(A::AbstractMatrix, ::Val{UPLO}) where {UPLO}
    n = size(A, 1)

    @inbounds for j in axes(A, 2)
        if UPLO === :L
            rng = j:n
        else
            rng = 1:j
        end

        for i in rng
            !iszero(A[i, j]) && return false
        end
    end

    return true
end

function zerorec!(A::AbstractVector{T}, ind::AbstractVector, ::Val{:L}) where {T}
    @inbounds for i in eachindex(ind)
        A[ind[i]] = zero(T)
    end

    return A
end

function zerorec!(A::AbstractVector)
    return zerorec!(A, axes(A, 1), Val(:L))
end

function zerorec!(A::AbstractMatrix{T}, ind::AbstractVector, ::Val{:L}) where {T}
    @inbounds for j in axes(A, 2)
        for i in eachindex(ind)
            A[ind[i], j] = zero(T)
        end
    end

    return A
end

function zerorec!(A::AbstractMatrix{T}, ind::AbstractVector, ::Val{:R}) where {T}
    @inbounds for j in eachindex(ind)
        indj = ind[j]

        for i in axes(A, 1)
            A[i, indj] = zero(T)
        end
    end

    return A
end

function zerorec!(A::AbstractMatrix)
    return zerorec!(A, axes(A, 1), Val(:L))
end

function copyrec!(A::AbstractVecOrMat, B::AbstractVecOrMat)
    return copyscatterrec!(A, B, axes(B, 1), Val(:L))
end

function copygatherrec!(A::AbstractVector, B::AbstractVector, ind::AbstractVector)
    return copygatherrec!(A, B, ind, Val(:L))
end

function copyscatterrec!(A::AbstractVector, B::AbstractVector, ind::AbstractVector)
    return copyscatterrec!(A, B, ind, Val(:L))
end

function addgatherrec!(A::AbstractVector, B::AbstractVector, ind::AbstractVector)
    return addgatherrec!(A, B, ind, Val(:L))
end

function addscatterrec!(A::AbstractVector, B::AbstractVector, ind::AbstractVector)
    return addscatterrec!(A, B, ind, Val(:L))
end

function addrec!(A::AbstractVecOrMat, B::AbstractVecOrMat)
    return addscatterrec!(A, B, axes(B, 1), Val(:L))
end

function copytri!(A::AbstractMatrix, B::AbstractMatrix, uplo::Val)
    return copyscattertri!(A, B, axes(B, 1), uplo)
end

function addtri!(A::AbstractMatrix, B::AbstractMatrix, uplo::Val)
    return addscattertri!(A, B, axes(B, 1), uplo)
end

function symmtri!(A::AbstractMatrix{T}, ::Val{:L}) where {T}
    n = size(A, 1)

    @inbounds for j in axes(A, 2)
        for i in 1:j - 1
            A[i, j] = conj(A[j, i])
        end
    end

    return A
end

function symmtri!(A::AbstractMatrix{T}, ::Val{:U}) where {T}
    n = size(A, 1)

    @inbounds for j in axes(A, 2)
        for i in j + 1:n
            A[i, j] = conj(A[j, i])
        end
    end

    return A
end

function symsym!(A::AbstractMatrix)
    @inbounds for j in axes(A, 2)
        for i in 1:j - 1
            Aij = A[i, j]
            Aji = A[j, i]
            A[i, j] = (Aij + conj(Aji)) / 2
            A[j, i] = (Aji + conj(Aij)) / 2
        end
    end

    return A
end

function rdivtri!(A::AbstractMatrix{T}, α, ::Val{:L}) where {T}
    n = size(A, 1)

    @inbounds for j in axes(A, 2)
        for i in j:n
            A[i, j] /= α
        end
    end

    return A
end

function rdivtri!(A::AbstractMatrix{T}, α, ::Val{:U}) where {T}
    @inbounds for j in axes(A, 2)
        for i in 1:j
            A[i, j] /= α
        end
    end

    return A
end

for (f, op) in [(:copy, :(=)), (:add, :(+=))]
    @eval function $(Symbol(f, :gatherrec!))(
            A::AbstractVecOrMat,
            B::AbstractVecOrMat,
            ind::AbstractVector,
            ::Val{:L},
        )
        @assert size(A, 1) <= length(ind)
        @assert size(A, 2) == size(B, 2)

        @inbounds for j in axes(A, 2)
            for i in axes(A, 1)
                $(Expr(op, :(A[i, j]), :(B[ind[i], j])))
            end
        end

        return A
    end

    @eval function $(Symbol(f, :gatherrec!))(
            A::AbstractVecOrMat,
            B::AbstractVecOrMat,
            ind::AbstractVector,
            ::Val{:R},
        )
        @assert size(A, 1) == size(B, 1)
        @assert size(A, 2) <= length(ind)

        @inbounds for j in axes(A, 2)
            indj = ind[j]

            for i in axes(A, 1)
                $(Expr(op, :(A[i, j]), :(B[i, indj])))
            end
        end

        return A
    end

    @eval function $(Symbol(f, :scatterrec!))(
            A::AbstractVecOrMat,
            B::AbstractVecOrMat,
            ind::AbstractVector,
            ::Val{:L},
        )
        @assert size(B, 1) <= length(ind)
        @assert size(A, 2) == size(B, 2)

        @inbounds for j in axes(B, 2)
            for i in axes(B, 1)
                $(Expr(op, :(A[ind[i], j]), :(B[i, j])))
            end
        end

        return A
    end

    @eval function $(Symbol(f, :scatterrec!))(
            A::AbstractVecOrMat,
            B::AbstractVecOrMat,
            ind::AbstractVector,
            ::Val{:R},
        )
        @assert size(A, 1) == size(B, 1)
        @assert size(B, 2) <= length(ind)

        @inbounds for j in axes(B, 2)
            indj = ind[j]

            for i in axes(B, 1)
                $(Expr(op, :(A[i, indj]), :(B[i, j])))
            end
        end

        return A
    end

    @eval function $(Symbol(f, :gathertri!))(
            A::AbstractMatrix,
            B::AbstractMatrix,
            ind::AbstractVector,
            ::Val{UPLO},
        ) where {UPLO}
        @assert size(A, 1) == size(A, 2) <= length(ind)
        n = size(A, 1)

        @inbounds for j in axes(A, 2)
            indj = ind[j]

            if UPLO === :L
                rng = j:n
            else
                rng = 1:j
            end

            for i in rng
                $(Expr(op, :(A[i, j]), :(B[ind[i], indj])))
            end
        end

        return A
    end

    @eval function $(Symbol(f, :scattertri!))(
            A::AbstractMatrix,
            B::AbstractMatrix,
            ind::AbstractVector,
            ::Val{UPLO},
        ) where {UPLO}
        @assert size(B, 1) == size(B, 2) <= length(ind)
        n = size(B, 1)

        @inbounds for j in axes(B, 2)
            indj = ind[j]

            if UPLO === :L
                rng = j:n
            else
                rng = 1:j
            end

            for i in rng
                $(Expr(op, :(A[ind[i], indj]), :(B[i, j])))
            end
        end

        return A
    end
end

function unwrap(A::AbstractVecOrMat)
    return (A, Val(:N))
end

function unwrap(A::Adjoint)
    return (parent(A), Val(:C))
end

function unwrap(A::Transpose)
    return (parent(A), Val(:T))
end

function isforward(UPLO, TRANS, SIDE)
    return UPLO === :L && (TRANS === :N && SIDE === :L || TRANS !== :N && SIDE === :R) ||
           UPLO === :U && (TRANS !== :N && SIDE === :L || TRANS === :N && SIDE === :R)
end

function swaprec!(v::AbstractVector, j::Integer, k::Integer)
    @inbounds v[j], v[k] = v[k], v[j]

    return
end

function swaprec!(::AbstractFill, ::Integer, ::Integer)
    return
end


# Hermitian swap: exchange rows/cols j and k for Hermitian matrix stored in lower triangle
function swaptri!(A::AbstractMatrix, j::Integer, k::Integer, ::Val{:L})
    n = size(A, 1)

    @inbounds begin
        A[j, j], A[k, k] = A[k, k], A[j, j]

        for i in k+1:n
            A[i, j], A[i, k] = A[i, k], A[i, j]
        end

        for i in j+1:k-1
            A[i, j], A[k, i] = conj(A[k, i]), conj(A[i, j])
        end

        for i in 1:j-1
            A[j, i], A[k, i] = A[k, i], A[j, i]
        end

        A[k, j] = conj(A[k, j])
    end

    return
end

# Hermitian swap: exchange rows/cols j and k for Hermitian matrix stored in upper triangle
function swaptri!(A::AbstractMatrix, j::Integer, k::Integer, ::Val{:U})
    n = size(A, 1)

    @inbounds begin
        A[j, j], A[k, k] = A[k, k], A[j, j]

        for i in 1:j-1
            A[i, j], A[i, k] = A[i, k], A[i, j]
        end

        for i in j+1:k-1
            A[j, i], A[i, k] = conj(A[i, k]), conj(A[j, i])
        end

        for i in k+1:n
            A[j, i], A[k, i] = A[k, i], A[j, i]
        end

        A[j, k] = conj(A[j, k])
    end

    return
end

function swapcol!(A::AbstractMatrix, j::Integer, k::Integer)
    @inbounds for i in axes(A, 1)
        A[i, j], A[i, k] = A[i, k], A[i, j]
    end

    return
end

function swaprow!(A::AbstractMatrix, j::Integer, k::Integer)
    @inbounds for i in axes(A, 2)
        A[j, i], A[k, i] = A[k, i], A[j, i]
    end

    return
end


function cdiv!(::Val, ::Val{:N}, ::AbstractMatrix, ::AbstractVector)
    return
end

function cdiv!(::Val{:R}, ::Val{:U}, A::AbstractMatrix{T}, d::AbstractVector{T}) where {T}
    @inbounds for j in axes(A, 2)
        idj = inv(d[j])

        for i in axes(A, 1)
            A[i, j] *= idj
        end
    end

    return
end

function cdiv!(::Val{:L}, ::Val{:U}, A::AbstractMatrix{T}, d::AbstractVector{T}) where {T}
    @inbounds for j in axes(A, 2)
        for i in axes(A, 1)
            A[i, j] *= inv(d[i])
        end
    end

    return
end

function cmul!(::Val, ::Val{:N}, ::AbstractMatrix, ::AbstractVector)
    return
end

function cmul!(::Val{:R}, ::Val{:U}, A::AbstractMatrix{T}, d::AbstractVector{T}) where {T}
    @inbounds for j in axes(A, 2)
        dj = d[j]

        for i in axes(A, 1)
            A[i, j] *= dj
        end
    end

    return
end

function cmul!(::Val{:L}, ::Val{:U}, A::AbstractMatrix{T}, d::AbstractVector{T}) where {T}
    @inbounds for j in axes(A, 2)
        for i in axes(A, 1)
            A[i, j] *= d[i]
        end
    end

    return
end

function revtri!(A::AbstractMatrix, ::Val{UPLO}) where UPLO
    n = size(A, 1)

    @inbounds for i in 1:n ÷ 2
        ri = n - i + 1
        A[i, i], A[ri, ri] = A[ri, ri], A[i, i]
    end

    @inbounds for j in 1:n
        rj = n - j + 1

        if UPLO === :L
            rng = j + 1:n
        else
            rng = 1:j - 1
        end

        for i in rng
            ri = n - i + 1
            A[ri, rj] = A[i, j]
        end
    end
end

# ===== allocate =====

function allocate(::Type{Arr}, dims::Integer...) where {Arr}
    return allocate(Arr, dims)
end

function allocate(::Type{Arr}, dims::Tuple) where {Arr}
    return Arr(undef, dims)
end

function allocate(::Type{Zeros{T, N, NTuple{N, OneTo{Int}}}}, dims::NTuple{N}) where {T, N}
    return Zeros{T, N}(map(OneTo{Int}, dims))
end

function allocate(::Type{Ones{T, N, NTuple{N, OneTo{Int}}}}, dims::NTuple{N}) where {T, N}
    return Ones{T, N}(map(OneTo{Int}, dims))
end

function allocate(::Type{Arr}, (n,)::Tuple) where {Arr <: OneTo}
    return Arr(n)
end

function checkinfo(info, ::Val{DIAG}) where {DIAG}
    if isnegative(info)
        throw(ArgumentError(info))
    elseif DIAG === :N && ispositive(info)
        throw(PosDefException(info))
    elseif DIAG === :U && ispositive(info)
        throw(SingularException(info))
    end

    return
end

"""
    SymbFact{I}

A symbolic factorization object.
"""
struct SymbFact{I}
    tree::CliqueTree{I, I}
    perm::FVector{I}
    invp::FVector{I}
    adjln::I
    blkln::I
    njmax::I
    nsmax::I
    upmax::I
    lsmax::I
end

"""
    symbolic(matrix::AbstractMatrix;
        alg::EliminationAlgorithm=DEFAULT_ELIMINATION_ALGORITHM,
        snd::SupernodeType=DEFAULT_SUPERNODE_TYPE,
    )

Compute a symbolic factorization of a sparse symmetric matrix.
See the function [`cliquetree`](@ref) for more information about
the parameters `alg` and `snd`.

```julia-repl
julia> import CliqueTrees

julia> matrix = [
           3 1 0 0 0 0 0 0
           1 3 1 0 0 2 0 0
           0 1 3 1 0 1 2 1
           0 0 1 3 0 0 0 0
           0 0 0 0 3 1 1 0
           0 2 1 0 1 3 0 0
           0 0 2 0 1 0 3 1
           0 0 1 0 0 0 1 3
       ];

julia> symbfact = CliqueTrees.symbolic(matrix)
SymbFact{Int64}:
    nnz: 19
```

### Parameters

  - `alg`: elimination algorithm
  - `snd`: supernode type
"""
function symbolic(matrix::AbstractMatrix; alg::PermutationOrAlgorithm=DEFAULT_ELIMINATION_ALGORITHM, snd::SupernodeType=DEFAULT_SUPERNODE_TYPE)
    fact = symbolic(matrix, alg, snd)
    return fact
end

function symbolic(matrix::AbstractMatrix, alg::PermutationOrAlgorithm, snd::SupernodeType)
    return symbolic(sparse(matrix), alg, snd)
end

function symbolic(matrix::SparseMatrixCSC{<:Any, I}, alg::PermutationOrAlgorithm, snd::SupernodeType) where {I}
    perm, tree = cliquetree(matrix, alg, snd)
    residual = residuals(tree)
    separator = separators(tree)

    neqns = nov(separator)
    adjln = half(convert(I, nnz(matrix)) - neqns) + neqns
    up = ls = ns = nsmax = njmax = upmax = lsmax = blkln = zero(I)

    @inbounds for j in vertices(separator)
        nn = eltypedegree(residual, j)
        na = eltypedegree(separator, j)
        nj = nn + na

        for i in childindices(tree, j)
            ma = eltypedegree(separator, i)

            ns -= one(I)
            up -= ma * ma
            ls -= ma
        end

        if !isnothing(parentindex(tree, j))
            ns += one(I)
            up += na * na
            ls += na
        end

        nsmax = max(nsmax, ns)
        njmax = max(njmax, nj)
        upmax = max(upmax, up)
        lsmax = max(lsmax, ls)

        blkln = blkln + nn * nj
    end

    perm1 = FVector{I}(undef, neqns)
    invp1 = FVector{I}(undef, neqns)

    @inbounds for v in outvertices(separator)
        w = perm[v]
        perm1[v] = w
        invp1[w] = v        
    end

    return SymbFact{I}(tree, perm1, invp1, adjln, blkln, njmax, nsmax, upmax, lsmax)
end

function SparseArrays.nnz(fact::SymbFact{I}) where {I}
    n = nov(separators(fact.tree))
    weights = Ones{I}(n)
    return treefill(weights, fact.tree)
end

function Base.show(io::IO, ::MIME"text/plain", fact::SymbFact{I}) where {I}
    println(io, "SymbFact{$I}:")
    print(io,   "    nnz: $(nnz(fact))")
end

#**********************************************************************
#**********************************************************************
#*****   MLFWH ... COMPUTE A MIMUM LOCAL FILL ORDERING   **************
#*****             USING THE WING-HUANG UPDATES          **************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       THIS IS A SIMPLE INTERFACE FOR INVOKING GENMF_WH, WHICH
#       COMPUTES A MINMUM LOCAL FILL ORDERING USING THE WING-HUANG
#       UPDATES.
#
#     INPUT PARAMETERS:
#       N           - NUMBER OF EQUATIONS.
#       NNZ         - NUMBER OF NONZERO ENTRIES (NOT COUNTING THE
#                     DIAGONAL ELEMENTS) IN THE MATRIX.
#       ADJLEN      - LENGTH OF THE ADJACENCY STRUCTURE (ADJNCY(*)).
#                     IDEALLY AT LEAST N GREATER THAN INITIAL
#                     XADJ(N+1)-1 (SEE IFLAG).
#       XADJ(*)     - ARRAY OF LENGTH N+1, CONTAINING POINTERS
#                     TO THE ADJACENCY STRUCTURE.
#       ADJNCY(*)   - ARRAY OF LENGTH ADJLEN, CONTAINING THE
#                     ADJACENCY STRUCTURE.
#
#     MODIFIED PARAMETERS:
#       XADJ(*)     - DESTROYED ON OUTPUT.
#       ADJNCY(*)   - DESTROYED ON OUTPUT.
#
#     OUTPUT PARAMETERS:
#       PERM(*)     - ENDS UP WITH THE PERMUTATION VECTOR, WHICH
#                     MAPS NEW NUMBERS TO OLD.
#       INVP(*)     - ENDS UP WITH THE INVERSE PERMUTATION VECTOR,
#                     WHICH MAPS OLD NUMBERS TO NEW.
#       NOFNZ       - NUMBER OF OFF-DIAGONAL NONZEROS IN THE FACTOR
#                     MATRIX PRODUCED BY THE ORDERING.  IT IS A
#                     LONG INTEGER (INTEGER*8).
#       IFLAG       - ERROR FLAG
#                        0 -  NO ERROR OR WARNING.
#                        1 -  WARNING, ADJLEN IS SMALL; IT IS
#                             BETWEEN INITIAL XADJ(N+1)-1 AND
#                             INITIAL XADJ(N+1)+N-1,
#                             INCLUSIVE.  MAY CAUSE EXCESSIVE
#                             GARBAGE COLLECTION.
#                       -1 -  ERROR, ADJLEN IS SMALLER THAN INITIAL
#                             XADJ(N+1)-1.  INSUFFICIENT ROOM
#                             IN ADJNCY(*) FOR THE ADJACENCY
#                             STRUCTURE, OR INCORRECT ADJLEN HAS
#                             BEEN INPUT.
#                       -2 -  FAIL TO ALLOCATE WORK SPACE.
#                       -3 -  FAIL TO DEALLOCATE WORK SPACE.
#                       -4 -  FAIL TO ALLOCATE AND DEALLOCATE
#                             WORK SPACE.
#
#**********************************************************************
#
function mlf!(n::V, vwght::AbstractVector{W}, xadj::AbstractVector{E}, adjncy::AbstractVector{V}) where {V, E, W}
    nnz = xadj[n + one(V)] - one(E)
    adjlen = convert(E, length(adjncy))

    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    perm = FVector{V}(undef, n)
    invp = FVector{V}(undef, n)

    for i in oneto(n)
        perm[i] = i
        invp[i] = i
    end

    #       -----------------------------
    #       SET POINTERS FOR WORK ARRAYS.
    #       -----------------------------
    adjlen2 = nnz

    #       --------------------
    #       ALLOCATE WORK SPACE.
    #       --------------------
    changed = FVector{Bool}(undef, n)
    degree  = FVector{W}(undef, n)
    ecforw  = FVector{V}(undef, n)
    ecliq   = FVector{V}(undef, n)
    heapinv = FVector{V}(undef, n)
    len2    = FVector{V}(undef, n)
    marker  = FVector{Int}(undef, n)
    nvtxs   = FVector{V}(undef, n)
    qsize   = FVector{W}(undef, n)
    qnmbr   = FVector{V}(undef, n)
    umark   = FVector{Int}(undef, n)
    work    = FVector{V}(undef, n)
    work1   = FVector{Int}(undef, n)
    work2   = FVector{W}(undef, n)
    xadj2   = FVector{E}(undef, n)
    adj2    = FVector{V}(undef, adjlen2)

    defncy  = FVector{W}(undef, n)
    heap    = FVector{W}(undef, twice(n))
    
    #       ------------------------------------------------------------
    #       DEFFLAG INDICATES HOW THE INITIAL DEFICIENCIES ARE COMPUTED.
    #       A ZERO VALUE MEANS THAT THE INITIAL DEFICIENCIES WILL BE
    #       COMPUTING USING A STRAIGHTFORWARD WAY.
    #       A NONZERO VALUE MEANS THAT THE INITIAL DEFICIENCIES WILL BE
    #       COMPUTED BY ADDING THE EDGES OF THE GRAPH ONE AT A TIME TO
    #       AN INITIALLY EMPTY GRAPH AND PERFORMING WING-HUANG UPDATING
    #       FOR EACH NEW EDGE.
    #       ------------------------------------------------------------
    defflag = true
    
    #       ----------------------------------------------
    #       GENMF_WH COMPUTES A MINMUM LOCAL FILL ORDERING
    #       USING WING-HUANG UPDATES.
    #       ----------------------------------------------
    nofnz, gbgcnt, iflag = genmf_wh(
        n, adjlen, adjlen2, vwght, xadj,
        adjncy, defflag, perm, invp,
        marker, nvtxs, work,
        qsize, qnmbr, ecforw, defncy, adj2, changed,
        degree, umark, heap, heapinv, ecliq,
        xadj2, len2, work1, work2,
    )
    
    return perm, invp
end

include("blas/potrf.jl")
include("blas/pstrf.jl")
include("blas/gemx.jl")
include("blas/gemmt.jl")
include("blas/syrk.jl")
include("blas/syr2k.jl")
include("blas/trrk.jl")
include("blas/trsx.jl")
include("blas/trmx.jl")
include("blas/symm.jl")
include("blas/trtri.jl")
include("blas/ger.jl")
include("blas/gert.jl")
include("blas/syr.jl")

# ===== ldiv!(F, X) for ChordalCholesky =====

@is_primitive MinimalCtx Tuple{typeof(ldiv!), ChordalCholesky, AbstractVecOrMat}

function Mooncake.rrule!!(
        ::CoDual{typeof(ldiv!)},
        cdF::CoDual{<:ChordalCholesky},
        cdX::CoDual{<:AbstractVecOrMat},
    )
    F = primal(cdF)
    X, dX = primaltangent(cdX)

    # Save X before forward pass (restoration pattern)
    Y = copy(X)

    # Forward pass
    ldiv!(F, X)

    function pullback!!(::NoRData)
        ldiv_rrule_impl!(Y, F, X, dX)
        return NoRData(), NoRData(), NoRData()
    end

    return cdX, pullback!!
end

function Mooncake.frule!!(
        ::Dual{typeof(ldiv!)},
        cdF::Dual{<:ChordalCholesky},
        cdX::Dual{<:AbstractVecOrMat},
    )
    F = primal(cdF)
    X, dX = primaltangent(cdX)

    ldiv_frule_impl!(F, X, dX)

    return cdX
end

# ===== rdiv!(X, F) for ChordalCholesky =====

@is_primitive MinimalCtx Tuple{typeof(rdiv!), AbstractMatrix, ChordalCholesky}

function Mooncake.rrule!!(
        ::CoDual{typeof(rdiv!)},
        cdX::CoDual{<:AbstractMatrix},
        cdF::CoDual{<:ChordalCholesky},
    )
    X, dX = primaltangent(cdX)
    F = primal(cdF)

    # Save X before forward pass (restoration pattern)
    Y = copy(X)

    # Forward pass
    rdiv!(X, F)

    function pullback!!(::NoRData)
        rdiv_rrule_impl!(Y, F, X, dX)
        return NoRData(), NoRData(), NoRData()
    end

    return cdX, pullback!!
end

function Mooncake.frule!!(
        ::Dual{typeof(rdiv!)},
        cdX::Dual{<:AbstractMatrix},
        cdF::Dual{<:ChordalCholesky},
    )
    X, dX = primaltangent(cdX)
    F = primal(cdF)

    rdiv_frule_impl!(F, X, dX)

    return cdX
end

struct SubsetIterator{T <: AbstractPackedSet}
    set::T
end

function subsets(set::AbstractPackedSet)
    return SubsetIterator(set)
end

# ------------------- #
# Iteration Interface #
# ------------------- #

function Base.length(iter::SubsetIterator)
    return 1 << length(iter.set)
end

function Base.eltype(::Type{SubsetIterator{T}}) where {T <: AbstractPackedSet}
    return T
end

function Base.iterate(iter::SubsetIterator)
    return (iter.set, iter.set)
end

function Base.iterate(iter::SubsetIterator{T}, state::T) where {T <: AbstractPackedSet}
    set = iter.set
    next = nextset_nonempty(state, set)
    next == set && return
    return (next, next)
end

function Base.iterate(iter::Iterators.Reverse{SubsetIterator{T}}) where {T <: AbstractPackedSet}
    return (T(), T())
end

function Base.iterate(iter::Iterators.Reverse{SubsetIterator{T}}, state::T) where {T <: AbstractPackedSet}
    set = iter.itr.set
    state == set && return
    next = prevset_nonempty(state, set)
    return (next, next)
end

# ===== syr! =====

function syr!(uplo::Val, α, x::AbstractVector{T}, A::AbstractMatrix{T}) where {T <: BlasFloat}
    if T <: Complex
        BLAS.her!(char(uplo), convert(real(T), α), x, A)
    else
        BLAS.syr!(char(uplo), convert(T, α), x, A)
    end

    return
end

function syr!(::Val{UPLO}, α, x::AbstractVector{T}, A::AbstractMatrix{T}) where {T, UPLO}
    n = length(x)

    @inbounds @fastmath for j in 1:n
        αxj = α * conj(x[j])

        if UPLO === :L
            for i in j:n
                A[i, j] += x[i] * αxj
            end
        else
            for i in 1:j
                A[i, j] += x[i] * αxj
            end
        end
    end

    return
end

module CatlabExt

using CliqueTrees
using Graphs

import Catlab

struct CatlabGraph{G <: Catlab.HasGraph} <: AbstractGraph{Int}
    graph::G
end

function (::Type{G})(graph::BipartiteGraph) where {G <: Catlab.HasGraph}
    m::Int = ne(graph)
    n::Int = nv(graph)
    tgt::Vector{Int} = targets(graph)

    result = G(n)
    Catlab.add_parts!(result, :E, m; tgt = tgt)

    for v::Int in vertices(graph)
        i::Int = pointers(graph)[v]
        j::Int = pointers(graph)[v + 1] - 1
        Catlab.set_subpart!(result, i:j, :src, v)
    end

    return result
end

function CliqueTrees.BipartiteGraph{V, E}(graph::Catlab.HasGraph) where {V, E}
    return BipartiteGraph{V, E}(CatlabGraph(graph))
end

function CliqueTrees.BipartiteGraph(graph::Catlab.HasGraph)
    return BipartiteGraph(CatlabGraph(graph))
end

############################
# Abstract Graph Interface #
############################

function Graphs.is_directed(graph::CatlabGraph)
    return true
end

function Graphs.ne(graph::CatlabGraph)
    return Catlab.ne(graph.graph)
end

function Graphs.nv(graph::CatlabGraph)
    return Catlab.nv(graph.graph)
end

function Graphs.vertices(graph::CatlabGraph)
    return Catlab.vertices(graph.graph)
end

function Graphs.outneighbors(graph::CatlabGraph, i::Integer)
    tgt = Catlab.tgt(graph.graph)::Vector{Int} # type instability
    return @view tgt[Catlab.incident(graph.graph, Int(i), :src)]
end

function Graphs.outdegree(graph::CatlabGraph, i::Integer)
    return length(Catlab.incident(graph.graph, Int(i), :src))
end

end

function fisher!(
        Y::AbstractCholesky{UPLO, T},
        F::AbstractCholesky{UPLO, T},
        S::AbstractCholesky{UPLO, T};
        inv::Bool=false,
        check::Bool=true,
    ) where {UPLO, T}
    info = fisher!(triangular(Y), triangular(F), triangular(S); inv, check)
    Y.info[] = info
    return Y
end

function fisher!(
        Y::ChordalTriangular{:N, UPLO, T, I},
        F::ChordalTriangular{:N, UPLO, T, I},
        S::ChordalTriangular{:N, UPLO, T, I};
        inv::Bool=false,
        check::Bool=true,
    ) where {UPLO, T, I <: Integer}
    @assert checksymbolic(Y, F, S)

    # Allocate workspace
    Uptr = FVector{I}(undef, F.S.nMptr)
    Uval = FVector{T}(undef, F.S.nMval)
    Fval = FVector{T}(undef, F.S.nFval * F.S.nFval)

    if inv
        info = fisher_impl!(Uptr, Uval, Fval, F, S, Y, Val(true))
    else
        info = fisher_impl!(Uptr, Uval, Fval, F, S, Y, Val(false))
    end

    check && checkinfo(info, F.diag)

    return info
end

#
# inv=false: fisherroot_fwd! → fisher_scale! → fisherroot_bwd!
# inv=true:  fisherroot_bwd! → fisher_scale! → fisherroot_fwd!
#
function fisher_impl!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        L::ChordalTriangular{:N, UPLO, T, I},
        S::ChordalTriangular{:N, UPLO, T, I},
        Y::ChordalTriangular{:N, UPLO, T, I},
        inv::Val{INV},
        args...
    ) where {UPLO, T, I <: Integer, INV}
    if INV
        fisherroot_bwd!(Uptr, Uval, Fval, L, Y, inv, args...)
    else
        fisherroot_fwd!(Uptr, Uval, Fval, L, Y, inv, args...)
    end

    info = fisher_scale!(Uptr, Uval, Fval, L, S, Y, inv, args...)
    ispositive(info) && return info

    if INV
        fisherroot_fwd!(Uptr, Uval, Fval, L, Y, inv, args...)
    else
        fisherroot_bwd!(Uptr, Uval, Fval, L, Y, inv, args...)
    end

    return info
end


# fisher_scale!
# =============


function fisher_scale!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        L::ChordalTriangular{:N, UPLO, T, I},
        S::ChordalTriangular{:N, UPLO, T, I},
        Y::ChordalTriangular{:N, UPLO, T, I},
        inv::Val{INV},
        rng::AbstractRange{I} = vertices(L.S.res),
    ) where {UPLO, T, I <: Integer, INV}

    ns = zero(I); Uptr[one(I)] = one(I)

    for j in reverse(rng)
        ns, info = fisher_scale_loop!(
            Uptr, Uval, Fval,
            L.S.Dptr, L.S.Lptr,
            L.Dval, L.Lval,
            S.Dval, S.Lval,
            Y.Dval, Y.Lval,
            L.S.res, L.S.rel, L.S.chd, ns, j, L.uplo, inv
        )
        ispositive(info) && return info
    end

    return zero(I)
end

function fisher_scale_loop!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        LDval::AbstractVector{T},
        LLval::AbstractVector{T},
        SDval::AbstractVector{T},
        SLval::AbstractVector{T},
        YDval::AbstractVector{T},
        YLval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, INV}
    nn = eltypedegree(res, j)

    if isone(nn)
        return fisher_scale_loop_nod!(
            Uptr, Uval, Fval,
            Dptr, Lptr,
            LDval, LLval,
            SDval, SLval,
            YDval, YLval,
            res, rel, chd, ns, j, uplo, inv
        )
    else
        return fisher_scale_loop_snd!(
            Uptr, Uval, Fval,
            Dptr, Lptr,
            LDval, LLval,
            SDval, SLval,
            YDval, YLval,
            res, rel, chd, ns, nn, j, uplo, inv
        )
    end
end

function fisher_scale_loop_snd!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        LDval::AbstractVector{T},
        LLval::AbstractVector{T},
        SDval::AbstractVector{T},
        SLval::AbstractVector{T},
        YDval::AbstractVector{T},
        YLval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        nn::I,
        j::I,
        uplo::Val{UPLO},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, INV}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁₁     ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₁₁ = view(F, oneto(nn), oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
    end
    #
    # Dp and Lp are indices into the diagonal and off-diagonal blocks
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    #
    # S is the selected inverse at node j
    #
    #          res(j)
    #     S = [ S₁₁  ] res(j)
    #         [ S₂₁  ] sep(j)
    #
    S₁₁ = reshape(view(SDval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        S₂₁ = reshape(view(SLval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        S₂₁ = reshape(view(SLval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # Y is the direction matrix at node j
    #
    #          res(j)
    #     Y = [ Y₁₁  ] res(j)
    #         [ Y₂₁  ] sep(j)
    #
    Y₁₁ = reshape(view(YDval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        Y₂₁ = reshape(view(YLval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        Y₂₁ = reshape(view(YLval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # L is the Cholesky factor at node j
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    L₁₁ = reshape(view(LDval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(LLval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(LLval, Lp:Lp + nn * na - one(I)), nn, na)
    end

    if UPLO === :L
        sdL = Val(:L)
    else
        sdL = Val(:R)
    end
    #
    # S₂₂ is the update matrix from the parent of node j
    #
    if ispositive(na)
        strt = Uptr[ns]
        S₂₂ = reshape(view(Uval, strt:strt + na * na - one(I)), na, na)
        ns -= one(I)
        #
        #     F₂₂ ← S₂₂
        #
        copytri!(F₂₂, S₂₂, uplo)
        #
        #     Y₂₁ ← S₂₂ Y₂₁  or  Y₂₁ ← S₂₂⁻¹ Y₂₁
        #
        if INV
            #
            #     S₂₂ ← chol(S₂₂)
            #
            info = potrf!(uplo, S₂₂)
            ispositive(info) && return ns, info

            trsm!(sdL, uplo, Val(:N), Val(:N), one(T), S₂₂, Y₂₁)
            trsm!(sdL, uplo, Val(:C), Val(:N), one(T), S₂₂, Y₂₁)
        else
            copyrec!(F₂₁, Y₂₁)
            symm!(sdL, uplo, one(T), S₂₂, F₂₁, zero(T), Y₂₁)
        end
    end
    #
    #     F ← S
    #
    copytri!(F₁₁, S₁₁, uplo)
    copyrec!(F₂₁, S₂₁)

    for i in neighbors(chd, j)
        #
        # send update matrix to child i
        #
        #     Uᵢ ← Rᵢᵀ F Rᵢ
        #
        ns += one(I)
        fisherroot_get_update!(F, Uptr, Uval, rel, ns, i, uplo)
    end

    return ns, zero(I)
end

# Fast path for nn = 1 (residual size is 1)
# In this case, diagonal blocks are scalars and off-diagonal blocks are vectors
function fisher_scale_loop_nod!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        LDval::AbstractVector{T},
        LLval::AbstractVector{T},
        SDval::AbstractVector{T},
        SLval::AbstractVector{T},
        YDval::AbstractVector{T},
        YLval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, INV}
    #
    # nn = 1 (the size of the residual at node j)
    #
    nn = one(I)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) | = 1 + na
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           1   na
    #     F = [ f₁₁     ] 1
    #         [ f₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        f₂₁ = view(F, nn + one(I):nj, one(I))
    else
        f₂₁ = view(F, one(I), nn + one(I):nj)
    end
    #
    # Dp and Lp are indices into the diagonal and off-diagonal blocks
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    #
    # S is the selected inverse at node j (s₁₁ is scalar, s₂₁ is vector)
    #
    s₁₁ = SDval[Dp]
    s₂₁ = view(SLval, Lp:Lp + na - one(I))
    #
    # Y is the direction matrix at node j (y₁₁ is scalar ref, y₂₁ is vector)
    #
    y₂₁ = view(YLval, Lp:Lp + na - one(I))

    if UPLO === :L
        sdL = Val(:L)
    else
        sdL = Val(:R)
    end
    #
    # S₂₂ is the update matrix from the parent of node j
    #
    if ispositive(na)
        strt = Uptr[ns]
        S₂₂ = reshape(view(Uval, strt:strt + na * na - one(I)), na, na)
        ns -= one(I)
        #
        #     F₂₂ ← S₂₂
        #
        copytri!(F₂₂, S₂₂, uplo)
        #
        #     y₂₁ ← S₂₂ y₂₁  or  y₂₁ ← S₂₂⁻¹ y₂₁
        #
        if INV
            #
            #     S₂₂ ← chol(S₂₂)
            #
            info = potrf!(uplo, S₂₂)
            ispositive(info) && return ns, info
            #
            #     y₂₁ ← S₂₂⁻¹ y₂₁ (triangular solves become trsv)
            #     For UPLO = :U, snd does right mult: Y = Y * S⁻¹ * S⁻ᴴ
            #     Column equivalent: y = S⁻ᵀ * S⁻¹ * y (note order change)
            #
            if UPLO === :L
                trsv!(uplo, Val(:N), Val(:N), S₂₂, y₂₁)
                trsv!(uplo, Val(:C), Val(:N), S₂₂, y₂₁)
            else
                trsv!(uplo, Val(:T), Val(:N), S₂₂, y₂₁)
                trsv!(uplo, Val(:N), Val(:N), S₂₂, y₂₁)
            end
        else
            copyrec!(f₂₁, y₂₁)
            #
            #     y₂₁ ← S₂₂ f₂₁ (symm becomes symv)
            #
            symv!(uplo, one(T), S₂₂, f₂₁, zero(T), y₂₁)
        end
    end
    #
    #     F ← S (f₁₁ ← s₁₁ is scalar, f₂₁ ← s₂₁ is vector copy)
    #
    F[one(I)] = s₁₁
    copyrec!(f₂₁, s₂₁)

    for i in neighbors(chd, j)
        #
        # send update matrix to child i
        #
        #     Uᵢ ← Rᵢᵀ F Rᵢ
        #
        ns += one(I)
        fisherroot_get_update!(F, Uptr, Uval, rel, ns, i, uplo)
    end

    return ns, zero(I)
end

abstract type AbstractPackedSet{I} <: AbstractSet{Int} end

function domain(::T) where {T <: AbstractPackedSet}
    return domain(T)
end

function packedset(::Type{T}, iter) where {T <: AbstractPackedSet}
    return T() ∪ iter
end

function popfirst_nonempty(set::AbstractPackedSet)
    i = first_nonempty(set)
    return (i, nextset_nonempty(set, set))
end

function pop_nonempty(set::AbstractPackedSet)
    i = last_nonempty(set)
    return (i, setdiff(set, i))
end

# -------------------- #
# Iteration Interface  #
# -------------------- #

function Base.iterate(set::AbstractPackedSet)
    isempty(set) && return
    return popfirst_nonempty(set)
end

function Base.iterate(::T, set::T) where {T <: AbstractPackedSet}
    return iterate(set)
end

function Base.iterate(iter::Iterators.Reverse{T}) where {T <: AbstractPackedSet}
    set = iter.itr
    isempty(set) && return
    return pop_nonempty(set)
end

function Base.iterate(::Iterators.Reverse{T}, set::T) where {T <: AbstractPackedSet}
    isempty(set) && return
    return pop_nonempty(set)
end

# ---------------------- #
# Abstract Set Interface #
# ---------------------- #

function Base.in(i::Int, set::AbstractPackedSet)
    return !isempty(set ∩ i)
end

const IntegerOrRange = Union{Integer, AbstractUnitRange}

function Base.union(set::T, x::IntegerOrRange) where {T <: AbstractPackedSet}
    return set ∪ packedset(T, x)
end

function Base.union(x::IntegerOrRange, set::T) where {T <: AbstractPackedSet}
    return packedset(T, x) ∪ set
end

function Base.intersect(set::T, x::IntegerOrRange) where {T <: AbstractPackedSet}
    return set ∩ packedset(T, x)
end

function Base.intersect(x::IntegerOrRange, set::T) where {T <: AbstractPackedSet}
    return packedset(T, x) ∩ set
end

function Base.setdiff(set::T, x::IntegerOrRange) where {T <: AbstractPackedSet}
    return setdiff(set, packedset(T, x))
end

function Base.setdiff(x::IntegerOrRange, set::T) where {T <: AbstractPackedSet}
    return setdiff(packedset(T, x), set)
end

function Base.symdiff(set::T, x::IntegerOrRange) where {T <: AbstractPackedSet}
    return symdiff(set, packedset(T, x))
end

function Base.symdiff(x::IntegerOrRange, set::T) where {T <: AbstractPackedSet}
    return symdiff(packedset(T, x), set)
end

function Base.first(set::AbstractPackedSet)
    isempty(set) && error()
    return first_nonempty(set)
end

function Base.last(set::AbstractPackedSet)
    isempty(set) && error()
    return last_nonempty(set)
end

include("packed_set.jl")
include("n_packed_set.jl")
include("subset_iterator.jl")

# ---------------------- #
# Set Type Selection     #
# ---------------------- #

function settype(dom::Integer)
    N = 8sizeof(UInt)

    if dom ≤ N
        I = UInt8

        while 8sizeof(I) < dom
            I = widen(I)
        end

        T = PackedSet{I}
    else
        P = cld(dom, N) 
        T = NPackedSet{P, UInt}
    end

    return T
end

# ---------------------- #
# Type Aliases           #
# ---------------------- #

const PSet8 = settype(8)
const PSet16 = settype(16)
const PSet32 = settype(32)
const PSet64 = settype(64)
const PSet128 = settype(128)
const PSet256 = settype(256)
const PSet512 = settype(512)

# Amari-Chentsov Tensor
# =====================
#
# Computes the third derivative of the log-det barrier:
#
#     T = -P(X⁻¹ Y X⁻¹ Z X⁻¹ + X⁻¹ Z X⁻¹ Y X⁻¹)P
#
# inv=false: fwd_1 → fwd_2 → scale → bwd
# inv=true:  H⁻¹ → fwd_1 → fwd_2 → scale → bwd → H⁻¹


"""
    amari!(T, Y, Z, L, S; inv=false, check=true)

Compute the Amari-Chentsov tensor (third derivative of log-det barrier).

Given the Cholesky factor `L` of a sparse PD matrix `X`, its selected inverse
`S = selinv(L)`, and two tangent directions `Y` and `Z`, computes:

- `inv=false`: T = ∇³f(X)[Y, Z] = -P(X⁻¹ Y X⁻¹ Z X⁻¹ + X⁻¹ Z X⁻¹ Y X⁻¹)
- `inv=true`:  T = ∇³f*(S)[Y, Z] = H⁻¹(∇³f(X)[H⁻¹(Y), H⁻¹(Z)])

where H = ∇²f(X) is the Hessian at X, and H⁻¹ = fisher!(inv=true).

Note: `Y` and `Z` are used as workspace and will be overwritten.
"""
function amari!(
        T::AbstractCholesky{UPLO, V},
        Y::AbstractCholesky{UPLO, V},
        Z::AbstractCholesky{UPLO, V},
        L::AbstractCholesky{UPLO, V},
        S::AbstractCholesky{UPLO, V};
        inv::Bool=false,
        check::Bool=true,
    ) where {UPLO, V}
    info = amari!(
        triangular(T),
        triangular(Y), triangular(Z),
        triangular(L), triangular(S);
        inv, check)
    T.info[] = info
    return T
end


function amari!(
        T::ChordalTriangular{:N, UPLO, V, I},
        Y::ChordalTriangular{:N, UPLO, V, I},
        Z::ChordalTriangular{:N, UPLO, V, I},
        L::ChordalTriangular{:N, UPLO, V, I},
        S::ChordalTriangular{:N, UPLO, V, I};
        inv::Bool=false,
        check::Bool=true,
    ) where {UPLO, V, I <: Integer}
    @assert checksymbolic(T, Y, Z, L, S)

    # Allocate workspace
    Uptr = FVector{I}(undef, L.S.nMptr)
    Uval = FVector{V}(undef, L.S.nMval)   # fwd stack, then reused as Σ
    Vval = FVector{V}(undef, L.S.nMval)   # σ stack, then reused as V (T₂₂)
    Fval = FVector{V}(undef, L.S.nFval * L.S.nFval)

    if inv
        info = amari_impl!(Uptr, Uval, Vval, Fval, T, Y, Z, L, S, Val(true))
    else
        info = amari_impl!(Uptr, Uval, Vval, Fval, T, Y, Z, L, S, Val(false))
    end

    check && checkinfo(info, L.diag)

    return info
end


function amari_impl!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{V},
        Vval::AbstractVector{V},
        Fval::AbstractVector{V},
        T::ChordalTriangular{:N, UPLO, V, I},
        Y::ChordalTriangular{:N, UPLO, V, I},
        Z::ChordalTriangular{:N, UPLO, V, I},
        L::ChordalTriangular{:N, UPLO, V, I},
        S::ChordalTriangular{:N, UPLO, V, I},
        inv::Val{INV},
    ) where {UPLO, V, I <: Integer, INV}
    #
    # fwd_1: linearize Cholesky once per direction
    #
    if INV
        fisherroot_bwd!(Uptr, Uval, Fval, L, Y, Val(true))
        info = fisher_scale!(Uptr, Uval, Fval, L, S, Y, Val(true))
        ispositive(info) && return info
    else
        fisherroot_fwd!(Uptr, Uval, Fval, L, Y, Val(false))
    end

    if Y !== Z
        if INV
            fisherroot_bwd!(Uptr, Uval, Fval, L, Z, Val(true))
            info = fisher_scale!(Uptr, Uval, Fval, L, S, Z, Val(true))
            ispositive(info) && return info
        else
            fisherroot_fwd!(Uptr, Uval, Fval, L, Z, Val(false))
        end
    end
    #
    # fwd: linearize Cholesky twice → T
    #
    amari_fwd!(Uptr, Uval, Fval, T, Y, Z, L)
    #
    # Phase 2: T₂₁ ← S₂₂ T₂₁ (via fisher_scale! with inv=false)
    # Uval now reused as Σ stack (S values)
    #
    fisher_scale!(Uptr, Uval, Fval, L, S, T, Val(false))
    #
    # Phase 3: Y direction (Uval=Σ, Vval=σ)
    #
    amari_bwd!(Uptr, Uval, Vval, Fval, T, Y, Z, L, S)
    #
    # Phase 4: Z direction (Uval=Σ, Vval=σ reused)
    #
    amari_bwd!(Uptr, Uval, Vval, Fval, T, Z, Y, L, S)
    #
    # bwd: phase 5 + L scaling of T + T-frontal emit
    #
    if INV
        # H⁻¹ pushforward: bwd(true) cancels bwd(false), leaving scale + fwd
        info = fisher_scale!(Uptr, Uval, Fval, L, S, T, Val(true))
        ispositive(info) && return info
        fisherroot_fwd!(Uptr, Uval, Fval, L, T, Val(true))
    else
        fisherroot_bwd!(Uptr, Vval, Fval, L, T, Val(false))
    end

    return zero(I)
end


# Forward Pass
# ============


function amari_fwd!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{V},
        Fval::AbstractVector{V},
        T::ChordalTriangular{:N, UPLO, V, I},
        Y::ChordalTriangular{:N, UPLO, V, I},
        Z::ChordalTriangular{:N, UPLO, V, I},
        L::ChordalTriangular{:N, UPLO, V, I},
    ) where {UPLO, V, I <: Integer}

    ns = zero(I); Uptr[one(I)] = one(I)

    for j in vertices(L.S.res)
        ns = amari_fwd_loop!(
            Uptr, Uval, Fval,
            L.S.Dptr, L.S.Lptr,
            T.Dval, T.Lval,
            Y.Dval, Y.Lval,
            Z.Dval, Z.Lval,
            L.Dval, L.Lval,
            L.S.res, L.S.rel, L.S.chd, ns, j, L.uplo)
    end

    return
end


function amari_fwd_loop!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{V},
        Fval::AbstractVector{V},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        TDval::AbstractVector{V},
        TLval::AbstractVector{V},
        YDval::AbstractVector{V},
        YLval::AbstractVector{V},
        ZDval::AbstractVector{V},
        ZLval::AbstractVector{V},
        LDval::AbstractVector{V},
        LLval::AbstractVector{V},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
    ) where {UPLO, V, I <: Integer}
    #
    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    nn = eltypedegree(res, j)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁₁     ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₁₁ = view(F, oneto(nn), oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
    end
    #
    # Dp and Lp are indices into the diagonal and off-diagonal blocks
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    T₁₁ = reshape(view(TDval, Dp:Dp + nn * nn - one(I)), nn, nn)
    Y₁₁ = reshape(view(YDval, Dp:Dp + nn * nn - one(I)), nn, nn)
    Z₁₁ = reshape(view(ZDval, Dp:Dp + nn * nn - one(I)), nn, nn)
    L₁₁ = reshape(view(LDval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        T₂₁ = reshape(view(TLval, Lp:Lp + nn * na - one(I)), na, nn)
        Y₂₁ = reshape(view(YLval, Lp:Lp + nn * na - one(I)), na, nn)
        Z₂₁ = reshape(view(ZLval, Lp:Lp + nn * na - one(I)), na, nn)
        L₂₁ = reshape(view(LLval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        T₂₁ = reshape(view(TLval, Lp:Lp + nn * na - one(I)), nn, na)
        Y₂₁ = reshape(view(YLval, Lp:Lp + nn * na - one(I)), nn, na)
        Z₂₁ = reshape(view(ZLval, Lp:Lp + nn * na - one(I)), nn, na)
        L₂₁ = reshape(view(LLval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    #     F ← 0
    #
    zerotri!(F₁₁, uplo)
    zerorec!(F₂₁)
    zerotri!(F₂₂, uplo)

    for i in Iterators.reverse(neighbors(chd, j))
        #
        # add the update matrix for child i to F
        #
        #     F ← F + Rᵢ Uᵢ Rᵢᵀ
        #
        amari_add_update!(F, Uptr, Uval, rel, ns, i, uplo)
        ns -= one(I)
    end
    #
    #     T₁₁ ← F₁₁
    #
    copytri!(T₁₁, F₁₁, uplo)

    if UPLO === :L
        sdR, sdL = Val(:R), Val(:L)
    else
        sdR, sdL = Val(:L), Val(:R)
    end
    #
    #     T₁₁ ← L₁₁⁻¹ (sym T₁₁) L₁₁⁻ᴴ
    #
    symmtri!(T₁₁, uplo)
    trsm!(sdL, uplo, Val(:N), Val(:N), one(V), L₁₁, T₁₁)
    trsm!(sdR, uplo, Val(:C), Val(:N), one(V), L₁₁, T₁₁)

    if ispositive(na)
        #
        # U₂₂ is the update matrix for node j
        #
        ns += one(I)
        strt = Uptr[ns]
        stop = Uptr[ns + one(I)] = strt + na * na
        U₂₂ = reshape(view(Uval, strt:stop - one(I)), na, na)
        #
        #     U₂₂ ← F₂₂
        #
        copytri!(U₂₂, F₂₂, uplo)
        #
        #     T₂₁ ← F₂₁ L₁₁⁻ᴴ
        #
        copyrec!(T₂₁, F₂₁)
        trsm!(sdR, uplo, Val(:C), Val(:N), one(V), L₁₁, T₂₁)
        #
        #     U₂₂ -= syr2k(Y₂₁, Z₂₁)
        #
        if UPLO === :L
            syr2k!(uplo, Val(:N), -one(real(V)), Y₂₁, Z₂₁, one(real(V)), U₂₂)
        else
            syr2k!(uplo, Val(:C), -one(real(V)), Z₂₁, Y₂₁, one(real(V)), U₂₂)
        end
        #
        #     U₂₂ -= syr2k(L₂₁, T₂₁)
        #     T₂₁ -= L₂₁ T₁₁
        #     U₂₂ -= syr2k(T₂₁, L₂₁)
        #
        if UPLO === :L
            gemmt!(uplo, Val(:N), Val(:C), -one(real(V)), L₂₁, T₂₁, one(real(V)), U₂₂)
        else
            gemmt!(uplo, Val(:C), Val(:N), -one(real(V)), T₂₁, L₂₁, one(real(V)), U₂₂)
        end

        symm!(sdR, uplo, -one(V), T₁₁, L₂₁, one(V), T₂₁)

        if UPLO === :L
            gemmt!(uplo, Val(:N), Val(:C), -one(real(V)), T₂₁, L₂₁, one(real(V)), U₂₂)
        else
            gemmt!(uplo, Val(:C), Val(:N), -one(real(V)), L₂₁, T₂₁, one(real(V)), U₂₂)
        end
        #
        #     T₂₁ -= Y₂₁ Z₁₁ + Z₂₁ Y₁₁
        #
        symm!(sdR, uplo, -one(V), Z₁₁, Y₂₁, one(V), T₂₁)
        symm!(sdR, uplo, -one(V), Y₁₁, Z₂₁, one(V), T₂₁)
    end
    #
    # Cross-coupling from second-order product rule (only writes uplo triangle;
    # scale's symmtri! will re-sync before un-sandwich)
    #
    #     T₁₁ -= syr2k(Y₁₁, Z₁₁)
    #
    symmtri!(Y₁₁, uplo)
    symmtri!(Z₁₁, uplo)
    syr2k!(uplo, Val(:N), -one(real(V)), Y₁₁, Z₁₁, one(real(V)), T₁₁)

    return ns
end


# amari_bwd!
# ============
#
# Top-level function for single direction backward pass.
# Reads S from Σ stack, reads σ from σ stack, does phase 3 or 4 work,
# emits σ to children, passes S through to children via Σ stack.


function amari_bwd!(
        Uptr::AbstractVector{I},
        ΣUval::AbstractVector{V},
        σUval::AbstractVector{V},
        Fval::AbstractVector{V},
        T::ChordalTriangular{:N, UPLO, V, I},
        Y::ChordalTriangular{:N, UPLO, V, I},
        Z::ChordalTriangular{:N, UPLO, V, I},
        L::ChordalTriangular{:N, UPLO, V, I},
        S::ChordalTriangular{:N, UPLO, V, I},
    ) where {UPLO, V, I <: Integer}

    Uptr[one(I)] = one(I)
    ns = zero(I)

    for j in reverse(vertices(L.S.res))
        ns = amari_bwd_loop!(
            Uptr, ΣUval, σUval, Fval,
            L.S.Dptr, L.S.Lptr,
            T.Dval, T.Lval,
            Y.Dval, Y.Lval,
            Z.Dval, Z.Lval,
            L.Dval, L.Lval,
            S.Dval, S.Lval,
            L.S.res, L.S.rel, L.S.chd,
            ns, j, L.uplo)
    end

    return
end


function amari_bwd_loop!(
        Uptr::AbstractVector{I},
        ΣUval::AbstractVector{V},
        σUval::AbstractVector{V},
        Fval::AbstractVector{V},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        TDval::AbstractVector{V},
        TLval::AbstractVector{V},
        YDval::AbstractVector{V},
        YLval::AbstractVector{V},
        ZDval::AbstractVector{V},
        ZLval::AbstractVector{V},
        LDval::AbstractVector{V},
        LLval::AbstractVector{V},
        SDval::AbstractVector{V},
        SLval::AbstractVector{V},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
    ) where {UPLO, V, I <: Integer}

    nn = eltypedegree(res, j)
    na = eltypedegree(rel, j)
    nj = nn + na

    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)
    F₁₁ = view(F, oneto(nn), oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
        sdR, sdL = Val(:R), Val(:L)
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
        sdR, sdL = Val(:L), Val(:R)
    end

    Dp = Dptr[j]
    Lp = Lptr[j]

    T₁₁ = reshape(view(TDval, Dp:Dp + nn * nn - one(I)), nn, nn)
    Y₁₁ = reshape(view(YDval, Dp:Dp + nn * nn - one(I)), nn, nn)
    L₁₁ = reshape(view(LDval, Dp:Dp + nn * nn - one(I)), nn, nn)
    S₁₁ = reshape(view(SDval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        T₂₁ = reshape(view(TLval, Lp:Lp + nn * na - one(I)), na, nn)
        Y₂₁ = reshape(view(YLval, Lp:Lp + nn * na - one(I)), na, nn)
        Z₂₁ = reshape(view(ZLval, Lp:Lp + nn * na - one(I)), na, nn)
        L₂₁ = reshape(view(LLval, Lp:Lp + nn * na - one(I)), na, nn)
        S₂₁ = reshape(view(SLval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        T₂₁ = reshape(view(TLval, Lp:Lp + nn * na - one(I)), nn, na)
        Y₂₁ = reshape(view(YLval, Lp:Lp + nn * na - one(I)), nn, na)
        Z₂₁ = reshape(view(ZLval, Lp:Lp + nn * na - one(I)), nn, na)
        L₂₁ = reshape(view(LLval, Lp:Lp + nn * na - one(I)), nn, na)
        S₂₁ = reshape(view(SLval, Lp:Lp + nn * na - one(I)), nn, na)
    end

    if UPLO === :L
        trN, trC = Val(:C), Val(:N)
    else
        trN, trC = Val(:N), Val(:C)
    end
    #
    #     F₁₁ ← Y₁₁ - L₂₁ᴴ S₂₂ Y₂₁ - Y₂₁ᴴ S₂₂ L₂₁ + L₂₁ᴴ σ₂₂ L₂₁
    #     F₂₁ ←                              S₂₂ Y₂₁ -      σ₂₂ L₂₁
    #     T₁₁ ← T₁₁                 - Z₂₁ᴴ S₂₂ Y₂₁
    #     T₂₁ ← T₂₁                                  -      σ₂₂ Z₂₁
    #
    copytri!(F₁₁, Y₁₁, uplo)

    if ispositive(na)
        #
        # Pull S₂₂ and σ₂₂ from parent's emits
        #
        strt = Uptr[ns]; ns -= one(I)
        S₂₂ = reshape(view(ΣUval, strt:strt + na * na - one(I)), na, na)
        σ₂₂ = reshape(view(σUval, strt:strt + na * na - one(I)), na, na)

        copytri!(F₂₂, σ₂₂, uplo)
        symm!(sdL, uplo,  one(V),  S₂₂, Y₂₁, zero(V), F₂₁)
        gemmt!(uplo, trN, trC, -one(real(V)), Z₂₁, F₂₁, one(real(V)), T₁₁)
        symm!(sdL, uplo, -one(V), σ₂₂, Z₂₁, one(V),  T₂₁)
        gemmt!(uplo, trN, trC, -one(real(V)), L₂₁, F₂₁, one(real(V)), F₁₁)
        symm!(sdL, uplo, -one(V), σ₂₂, L₂₁, one(V),  F₂₁)
        gemmt!(uplo, trN, trC, -one(real(V)), F₂₁, L₂₁, one(real(V)), F₁₁)
        trsm!(sdR, uplo, Val(:N), Val(:N), one(V), L₁₁, F₂₁)
    end
    #
    # Scale F₁₁
    #
    #     F₁₁ ← L₁₁⁻ᴴ sym(F₁₁) L₁₁⁻¹
    #
    symmtri!(F₁₁, uplo)
    trsm!(sdL, uplo, Val(:C), Val(:N), one(V), L₁₁, F₁₁)
    trsm!(sdR, uplo, Val(:N), Val(:N), one(V), L₁₁, F₁₁)

    # σ emit to children
    ns_start = ns

    for i in neighbors(chd, j)
        ns += one(I)
        amari_get_update!(F, Uptr, σUval, rel, ns, i, uplo)
    end

    # Σ pass-through: emit S to children
    #
    #     F ← S (at this node)
    #
    copytri!(F₁₁, S₁₁, uplo)

    if ispositive(na)
        copyrec!(F₂₁, S₂₁)
        copytri!(F₂₂, S₂₂, uplo)
    end

    ns_local = ns_start

    for i in neighbors(chd, j)
        ns_local += one(I)
        amari_get_update!(F, Uptr, ΣUval, rel, ns_local, i, uplo)
    end

    return ns
end


# Update Matrix Helpers
# =====================


function amari_add_update!(
        F::AbstractMatrix{V},
        ptr::AbstractVector{I},
        val::AbstractVector{V},
        rel::AbstractGraph{I},
        ns::I,
        i::I,
        uplo::Val{UPLO},
    ) where {UPLO, V, I <: Integer}
    #
    # na is the size of the separator at node i
    #
    #     na = | sep(i) |
    #
    na = eltypedegree(rel, i)
    #
    # inj is the subset inclusion
    #
    #     inj: sep(i) → bag(parent(i))
    #
    inj = neighbors(rel, i)
    #
    # U is the update matrix from child i
    #
    strt = ptr[ns]
    U = reshape(view(val, strt:strt + na * na - one(I)), na, na)
    #
    # add U to F
    #
    #     F ← F + inj U injᵀ
    #
    addscattertri!(F, U, inj, uplo)

    return
end


function amari_get_update!(
        F::AbstractMatrix{V},
        ptr::AbstractVector{I},
        val::AbstractVector{V},
        rel::AbstractGraph{I},
        ns::I,
        i::I,
        uplo::Val{UPLO},
    ) where {UPLO, V, I <: Integer}
    #
    # na is the size of the separator at node i
    #
    #     na = | sep(i) |
    #
    na = eltypedegree(rel, i)
    #
    # inj is the subset inclusion
    #
    #     inj: sep(i) → bag(parent(i))
    #
    inj = neighbors(rel, i)
    #
    # U is the update matrix for child i
    #
    strt = ptr[ns]
    stop = ptr[ns + one(I)] = strt + na * na
    U = reshape(view(val, strt:stop - one(I)), na, na)
    #
    # copy F into U
    #
    #     U ← injᵀ F inj
    #
    copygathertri!(U, F, inj, uplo)
    return
end

#**********************************************************************
#**********************************************************************
#*****   MOVE_DOWN ... MOVE NODE DOWN A HEAP   ************************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       MOVE_DOWN MOVES A GIVEN ELEMENT DOWN A BINARY TREE TO MAKE
#       SURE THE BINARY TREE IS A HEAP.
#
#       EACH ELEMENT HAS TWO FIELDS: (WEIGHT,VERTEX).  THE VERTEX
#       FIELD REFERS TO A VERTEX AND THE WEIGHT FIELD REFERS TO A
#       WEIGHT ASSOCIATED WITH THE VERETEX.  THE VERTICES ARE ASSUMED
#       TO BE UNIQUE INTEGERS FROM 1 TO N.  THE HEAP IS CONSTRUCTED
#       USING THE WEIGHTS.
#
#     INPUT PARAMETERS:
#       HEAPSIZE    - IT IS THE NUMBER OF ELEMENTS IN HEAP.
#       VTX_PTR     - THE LOCATION OF THE ELEMENT TO BE MOVED DOWN.
#
#     MODIFIED PARAMETERS:
#       HEAP(*)     - IT IS AN ARRAY OF SIZE 2*HEAPSIZE.  ON INPUT,
#                     IT CONTAINS A SET OF NODES THAT ARE IN A HEAP,
#                     WITH HEAP(2*K-1) CONTAINING THE WEIGHT OF NODE
#                     K AND HEAP(2*K) CONTAINING THE CORRESPONDING
#                     VERTEX.  ON OUTPUT, THE NODES ARE REARRANGED
#                     TO FORM A HEAP.
#       V2HEAP(*)   - V2HEAP IS A MAPPING OF THE VERTICES TO
#                     THE NODES IN HEAP.
#
#**********************************************************************
#
function move_down(heap::AbstractVector{W}, heapsize::V, vtx_ptr::V, v2heap::AbstractVector{V}) where {V, W}
    
    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    
    infty = typemax(W) - convert(W, 100000)
    
    #       --------------------------------------------------------
    #       MOVE THE GIVEN NODE IN LOCATION VTX_PTR DOWN IN HEAP AND
    #       ENSURE THAT HEAP IS A HEAP.
    #       --------------------------------------------------------
    v = vtx_ptr
    #       PRINT *, 'FLD_NOW, FLD_INDEX = ', V, VTX_PTR
    
    while v <= heapsize
        
        #           ----------------------------------------------
        #           DO THE FOLLOWING, AS LONG AS V HAS NOT REACHED
        #           THE BOTTOM OF THE BINARY TREE.
        #           ----------------------------------------------
        
        #           ------------------------
        #           V_WT IS THE WEIGHT OF V.
        #           ------------------------
        v_wt = heap[twice(v) - one(V)]
        #           PRINT *, 'FLD_NOW, VAL = ', V, V_WT
        
        #           ----------------------------------------
        #           C_LEFT AND C_RIGHT ARE THE CHILDREN OF V
        #           IN THE BINARY TREE.
        #           ----------------------------------------
        c_left = twice(v)
        c_right = c_left + one(V)
        #           PRINT *, 'FLD_NEXT1, FLD_NEXT2 = ',
        #    &                C_LEFT, C_RIGHT
        
        #           ---------------------------------
        #           GET THE WEIGHT'S OF THE CHILDREN.
        #           ---------------------------------
        if c_left <= heapsize
            wt_left = heap[twice(c_left) - one(V)]
        else
            wt_left = infty
        end
        
        if c_right <= heapsize
            wt_right = heap[twice(c_right) - one(V)]
        else
            wt_right = infty
        end
        
        #           PRINT *, 'VAL1, VAL2 = ', WT_LEFT, WT_RIGHT
        
        #           ----------------------------
        #           DECIDE WHICH PATH TO FOLLOW.
        #           ----------------------------
        if v_wt <= wt_left && v_wt <= wt_right

            #               ------------------------------------------
            #               THE WEIGHT OF V IS LESS THAN OR EQUAL TO
            #               THOSE OF THE TWO CHILDREN, SO WE ARE DONE.
            #               ------------------------------------------
            v = heapsize + one(V)
            #               PRINT *, 'DONE ...'
            
        else
            
            #               ----------------------------------------
            #               THE WEIGHT OF V IS GREATER THAN THAT OF
            #               AT LEAST ONE OF THE CHILDERN.  DETERMINE
            #               WHICH PATH TO TRAVERSE.
            #               ----------------------------------------
            
            if wt_left <= wt_right
                c = c_left
            else
                c = c_right
            end
            #               PRINT *, 'FLD_NEXT = ', P
            
            #               ---------------------
            #               SWAP V AND THE CHILD.
            #               ---------------------
            
            v_ptr = twice(v)
            c_ptr = twice(c)
            #               PRINT *, 'FLD_NEXT1, FLD_NEXT2 = ',
            #    &                    V_PTR, C_PTR
            
            v_vtx = convert(V, heap[v_ptr])
            #               PRINT *, 'VTX = ', V_VTX
            v2heap[v_vtx] = c
            #               PRINT *, 'FLD_NEXT = ', P

            c_vtx = convert(V, heap[c_ptr])
            v2heap[c_vtx] = v
            #               PRINT *, 'IPOINT, FLD_NOW = ', C_VTX, V
            
            heap[v_ptr] = heap[c_ptr]
            heap[c_ptr] = v_vtx
            #               PRINT *, 'HEAP(FLD_NEXT1), HEAP(FLD_NEXT2) = ',
            #    &                    HEAP(V_PTR), HEAP(C_PTR)
            
            v_ptr -= one(V)
            c_ptr -= one(V)
            heap[v_ptr] = heap[c_ptr]
            heap[c_ptr] = v_wt
            #               PRINT *, 'HEAP(FLD_NEXT1), HEAP(FLD_NEXT2) = ',
            #    &                    HEAP(V_PTR), HEAP(C_PTR)
            
            v = c
            
        end
        
    end
    
    return
end

function mcs_etree(weights::AbstractVector, graph::AbstractGraph{V}, alg::PermutationOrAlgorithm) where {V}
    order, index = permutation(weights, graph, alg)
    return mcs_etree!(order, index, graph)
end

function mcs_etree!(order::AbstractVector{V}, index::AbstractVector{V}, graph::AbstractGraph{V}) where {V}
    E = etype(graph); m = de(graph); n = nv(graph)
    
    begptr = FVector{E}(undef, n + one(V))
    endptr = FVector{E}(undef, n + one(V))
    target = FVector{V}(undef, m)
    tree = Parent{V}(n)
    sets = UnionFind{V}(n)
    fdesc = FVector{V}(undef, n)
    fancs = FVector{V}(undef, n)
    stops = FVector{V}(undef, n)
    count = FVector{V}(undef, n)
    
    work1 = FVector{V}(undef, n)
    work2 = FVector{V}(undef, n)
    work3 = FVector{V}(undef, n)
    work4 = FVector{V}(undef, n)

    mcs_etree_impl!(work1, work2, work3, work4, begptr, endptr,
        target, tree, sets, fdesc, fancs, stops, count,
        graph, order, index)

    return order, index
end

# Fast Computation of Minimal Fill inside a Given Elimination Ordering
# Heggernes and Peyton
# MCS-ETree (blocked implementation)
#
# The time complexity is
#
#     O(mn α(m, n))
#
# m = |E|, n = |V|, and α is the extremely-slow-growing
# inverse of the Ackermann function.
function mcs_etree_impl!(
        work1::AbstractVector{V},
        work2::AbstractVector{V},
        work3::AbstractVector{V},
        work4::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        target::AbstractVector{V},
        tree::Parent{V},
        sets::UnionFind{V},
        fdesc::AbstractVector{V},
        fancs::AbstractVector{V},
        stops::AbstractVector{V},
        count::AbstractVector{V},
        graph::AbstractGraph{V},
        order::AbstractVector{V},
        index::AbstractVector{V},
    ) where {V, E}
    @assert nv(graph) <= length(work1)
    @assert nv(graph) <= length(work2)
    @assert nv(graph) <= length(work3)
    @assert nv(graph) <= length(work4)
    @assert nv(graph) < length(begptr)
    @assert nv(graph) < length(endptr)
    @assert de(graph) <= length(target)
    @assert nv(graph) == length(tree)
    @assert nv(graph) == length(sets)
    @assert nv(graph) <= length(fdesc)
    @assert nv(graph) <= length(fancs)
    @assert nv(graph) <= length(stops)
    @assert nv(graph) <= length(count)
    @assert nv(graph) <= length(order)
    @assert nv(graph) <= length(index)

    # `fancs`, `stops`, and `num` form a stack
    #  - `stops[num]` is the root of the current elimination tree
    #  - `fancs[num]` ... `stops[num] - 1` were ancestors of
    #    `stops[num]` before the previous rotation
    num = zero(V)

    # initialize elimination forest (`tree`) and first
    # descendants (`fdesc`)
    etree_impl!(tree, work1, graph, order, index)
    postorder!_impl!(work1, work2, work3, work4, tree)
    firstdescendants_impl!(fdesc, tree, vertices(graph))

    # - permute `order` and `index`
    # - initialize empty skeleton graph
    # - push roots to `stops`
    begptr[one(V)] = p = one(E)
    endptr[one(V)] = p - one(E)

    @inbounds for v in vertices(graph)
        i = index[v] = work3[index[v]]
        order[i] = v
        begptr[v + one(V)] = p += convert(E, eltypedegree(graph, v))
        endptr[v + one(V)] = p - one(E)

        if isnothing(parentindex(tree, v))
            num += one(V); fancs[num] = v + one(V); stops[num] = v
        end
    end

    @inbounds while ispositive(num)
        # get an unnumbered elimination subtree T
        fanc = fancs[num]
        stop = stops[num]
        strt = fdesc[stop]
        num -= one(V)

        # compute higher degrees and adjust skeleton graph 
        mcs_etree_supcnt!(count, begptr, endptr, target, work1, work2, fdesc,
            work3, work4, sets, order, index, graph, tree, strt, stop, fanc)

        # find a special vertex `root` in T of maximum cardinality
        root = stop; maxcnt = count[stop]
    
        for i in strt:stop
            work1[i] = -one(V)
        end
    
        for i in strt:stop - one(V)
            cum = work1[i]
            cnt = count[i]
            
            if cum < cnt == maxcnt
                root = i
                break
            else
                j = parentindex(tree, i)::V
                work1[j] = max(work1[j], cum, cnt)
            end
        end

        # ensure that the vertices in anc[`root`] are numbered before their siblings
        root = mcs_etree_prescribed!(work3, fdesc, tree, strt, stop, root)
        mcs_etree_invpermute!(work1, order, index, work3, strt, stop)
        mcs_etree_invpermute!(work1, tree, work3, strt, stop)
        mcs_etree_firstdescendants!(fdesc, tree, strt, stop)

        # find a block of vertices to number consecutively
        blck = mcs_etree_findblock!(work1, work2, begptr, endptr, target,
            order, index, graph, fdesc, tree, strt, stop, root)

        # reorder the subtree and change the root to `root`
        fanc = mcs_etree_changeroot!(work1, work2, work3, order, index, graph, fdesc, tree, strt, stop, blck)
        mcs_etree_invpermute!(work1, order, index, work3, strt, stop)
        mcs_etree_invpermute!(work1, tree, work3, strt, stop)    

        # compute the elimination subtree for the new reordering
        mcs_etree_etree!(tree, order, index, work1, graph, strt, stop, fanc)
        mcs_etree_postorder!(work1, work2, work3, work4, tree, strt, stop)
        mcs_etree_firstdescendants!(fdesc, tree, strt, stop)
        mcs_etree_invpermute!(work1, order, index, work3, strt, stop)

        # add `root` to the skeleton graph
        for i in blck:stop
            v = order[i]

            for w in neighbors(graph, v)
                j = index[w]

                if j < stop
                    p = endptr[w] += one(V); target[p] = i
                end
            end
        end

        # number `root` and store the unnumbered subtrees for future processing 
        for i in strt:blck - one(V)
            j = parentindex(tree, i)::V

            if j >= blck
                num += one(V); stops[num] = i

                if fdesc[i] <= fanc <= i
                    fancs[num] = fanc
                else
                    fancs[num] = i + one(V)
                end
            end
        end
    end

    return
end

function mcs_etree_prescribed!(
        index::AbstractVector{V},
        fdesc::AbstractVector{V},
        tree::AbstractVector{V},
        strt::V,
        stop::V,
        root::V,
    ) where {V}
    @assert length(tree) <= length(index)
    @assert length(tree) <= length(fdesc)
    @assert length(tree) >= stop >= root >= strt

    @inbounds n = strt - one(V); curstrt = fdesc[root]; curstop = root

    @inbounds for j in curstrt:curstop
        index[j] = n += one(V)
    end

    i = root; root = n

    @inbounds while i < stop
        i = parentindex(tree, i)::V
        prvstrt, prvstop = curstrt, curstop
        curstrt, curstop = fdesc[i], i

        for j in curstrt:prvstrt - one(V)
            index[j] = n += one(V)
        end

        for j in prvstop + one(V):curstop
            index[j] = n += one(V)
        end
    end

    return root
end

function mcs_etree_findblock!(
        marks::AbstractVector{V},
        block::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        target::AbstractVector{V},
        order::AbstractVector{V},
        index::AbstractVector{V},
        graph::AbstractGraph{V},
        fdesc::AbstractVector{V},
        tree::Parent{V},
        strt::V,
        stop::V,
        node::V,
    ) where {V, E}
    @assert nv(graph) <= length(marks)
    @assert nv(graph) <= length(block)
    @assert nv(graph) < length(begptr)
    @assert nv(graph) < length(endptr)
    @assert de(graph) <= length(target)
    @assert nv(graph) <= length(order)
    @assert nv(graph) <= length(index)
    @assert nv(graph) <= length(fdesc)
    @assert nv(graph) == length(tree)
    @assert nv(graph) >= stop >= node >= strt

    ndeg = zero(V); blck = stop

    @inbounds block[blck] = node

    @inbounds for i in strt:stop
        marks[i] = zero(V)
    end

    @inbounds for i in ancestorindices(tree, stop)
        marks[i] = zero(V)
    end

    if fdesc[node] < node
        nchd = zero(V)

        @inbounds for i in fdesc[node]:node - one(V)
            if parentindex(tree, i) == node
                nchd += one(V); block[strt + nchd - one(V)] = i
            end
        end

        @inbounds for p in begptr[order[node]]:endptr[order[node]]
            i = target[p]
            marks[i] = node; ndeg += one(V)
        end

        i = node

        @inbounds while i < stop
            i = parentindex(tree, i)::V
            ideg = ichd = zero(V)

            for v in neighbors(graph, order[i])
                j = index[v]

                if stop < j
                    if zero(V) < marks[j] < i
                        marks[j] = i; ideg += one(V)
                    end
                elseif j < node
                    for k in view(block, strt:strt + nchd - one(V))
                        if j <= k
                            @assert fdesc[k] <= j

                            if marks[k] < i
                                marks[k] = i; ichd += one(V)
                            end

                            break
                        end
                    end
                end
            end

            if ideg == ndeg && ichd == nchd
                blck -= one(V); block[blck] = i
            end
        end
    else
        @inbounds for v in neighbors(graph, order[node])
            i = index[v]
            marks[i] = strt; ndeg += one(V)
        end

        i = node

        @inbounds while i < stop
            i = parentindex(tree, i)::V

            if ispositive(marks[i])
                ideg = one(V)

                for v in neighbors(graph, order[i])
                    j = index[v]

                    if zero(V) < marks[j] < i
                        marks[j] = i; ideg += one(V)
                    end
                end

                if ideg == ndeg
                    blck -= one(V); block[blck] = i
                end
            end
        end
    end

    return blck
end

# Change_Root2
function mcs_etree_changeroot!(
        head::AbstractVector{V},
        next::AbstractVector{V},
        alpha::AbstractVector{V},
        order::AbstractVector{V},
        index::AbstractVector{V},
        graph::AbstractGraph{V},
        fdesc::AbstractVector{V},
        tree::Parent{V},
        strt::V,
        stop::V,
        blck::V,
    ) where {V}
    @assert nv(graph) <= length(head)
    @assert nv(graph) <= length(next)
    @assert nv(graph) <= length(alpha)
    @assert nv(graph) <= length(order)
    @assert nv(graph) <= length(index)
    @assert nv(graph) <= length(fdesc)
    @assert nv(graph) <= length(tree)
    @assert nv(graph) >= stop >= blck >= strt >= one(V)

    function set(i::V)
        @inbounds h = view(head, i)
        return SinglyLinkedList(h, next)
    end

    @inbounds node = next[stop]; n = strt

    @inbounds for i in strt:stop
        empty!(set(i))

        if i < node || node < fdesc[i]
            alpha[i] = n; n += one(V)
        else
            alpha[i] = zero(V)
        end
    end

    fanc = n

    @inbounds for n in blck:stop
        i = next[n]; alpha[i] = n
    end

    i = node

    @inbounds while i < stop
        i = parentindex(tree, i)::V

        if iszero(alpha[i])
            v = order[i]; n = stop

            for w in neighbors(graph, v)
                if v != w
                    n = min(n, index[w])
                end
            end

            pushfirst!(set(n), i)
        end
    end

    n = blck - one(V)

    @inbounds for m in strt:stop, i in set(m)
        alpha[i] = n; n -= one(V)
    end

    return fanc
end

function mcs_etree_etree!(
        tree::Parent{V},
        order::AbstractVector{V},
        index::AbstractVector{V},
        ancestor::AbstractVector{V},
        graph::AbstractGraph{V},
        strt::V,
        stop::V,
        fanc::V,
    ) where {V}
    @assert nv(graph) == length(tree)
    @assert nv(graph) <= length(order)
    @assert nv(graph) <= length(index)
    @assert nv(graph) <= length(ancestor)
    @assert nv(graph) >= stop >= fanc >= strt >= one(V)
    n = nv(graph); parent = tree.prnt

    @inbounds for i in reverse(strt:fanc - one(V))
        j = parent[i]

        if fanc <= j
            ancestor[i] = -i
        else
            ancestor[i] = abs(ancestor[j])
        end
    end

    @inbounds for i in fanc:stop
        v = order[i]; ancestor[i] = zero(V)

        for w in neighbors(graph, v)
            k = index[w]

            if k < i
                r = k

                while ispositive(ancestor[r]) && ancestor[r] != i
                    t = ancestor[r]
                    ancestor[r] = i
                    r = t
                end

                if !ispositive(ancestor[r])
                    ancestor[r] = i
                    parent[r] = i
                end
            end
        end
    end

    return
end

function mcs_etree_lcrs!(
        brother::AbstractVector{V},
        child::AbstractVector{V},
        tree::Parent{V},
        strt::V,
        stop::V,
    ) where {V}
    @assert length(tree) <= length(brother)
    @assert length(tree) <= length(child)
    @assert length(tree) >= stop >= strt >= one(V)

    @inbounds for i in strt:stop
        child[i] = zero(V)
    end

    @inbounds brother[stop] = zero(V)

    @inbounds for i in reverse(strt:stop - one(V))
        j = parentindex(tree, i)::V
        brother[i] = child[j]; child[j] = i
    end

    return
end

function mcs_etree_postorder!(
        brother::AbstractVector{V},
        child::AbstractVector{V},
        index::AbstractVector{V},
        stack::AbstractVector{V},
        tree::Parent{V},
        strt::V,
        stop::V,
    ) where {V}
    @assert length(tree) <= length(brother)
    @assert length(tree) <= length(child)
    @assert length(tree) <= length(index)
    @assert length(tree) <= length(stack)
    @assert length(tree) >= stop >= strt >= one(V)

    mcs_etree_lcrs!(brother, child, tree, strt, stop)
    
    function brothers(i::V)
        @inbounds head = view(child, i)
        return SinglyLinkedList(head, brother)
    end

    @inbounds num = one(V); stack[num] = stop

    @inbounds for i in strt:stop
        j = stack[num]; num -= one(V)

        while !isempty(brothers(j))
            num += one(V); stack[num] = j
            j = popfirst!(brothers(j))
        end

        index[j] = i
    end

    mcs_etree_invpermute!(stack, tree, index, strt, stop)
    return
end

function mcs_etree_invpermute!(
        work::AbstractVector{V},
        order::AbstractVector{V},
        index::AbstractVector{V},
        alpha::AbstractVector{V},
        strt::V,
        stop::V,
    ) where {V}
    @assert stop <= length(order)
    @assert stop <= length(index)
    @assert stop <= length(alpha)
    @assert stop >= strt

    @inbounds for i in strt:stop
        work[alpha[i]] = order[i]
    end

    @inbounds for i in strt:stop
        v = order[i] = work[i]
        index[v] = i
    end

    return
end

function mcs_etree_invpermute!(
        parent::AbstractVector{V},
        tree::Parent{V},
        index::AbstractVector{V},
        strt::V,
        stop::V,
    ) where {V}
    @assert length(tree) <= length(parent)
    @assert length(tree) <= length(index)
    @assert length(tree) >= stop >= strt >= one(V)

    @inbounds for i in strt:stop - one(V)
        j = parentindex(tree, i)::V
        parent[index[i]] = index[j]
    end

    @inbounds for i in strt:stop - one(V)
        tree.prnt[i] = parent[i]
    end

    return
end

function mcs_etree_firstdescendants!(
        fdesc::AbstractVector{V},
        tree::Parent{V},
        strt::V,
        stop::V,
    ) where {V}
    @assert length(tree) <= length(fdesc)
    @assert length(tree) >= stop >= strt >= one(V)

    @inbounds for i in strt:stop
        fdesc[i] = i
    end

    @inbounds for i in strt:stop - one(V)
        j = parentindex(tree, i)::V
        fdesc[j] = min(fdesc[i], fdesc[j])
    end

    return
end

function mcs_etree_supcnt!(
        wt::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        target::AbstractVector{V},
        map1::AbstractVector{V},
        inv1::AbstractVector{V},
        fdesc::AbstractVector{V},
        prev_p::AbstractVector{V},
        prev_nbr::AbstractVector{V},
        sets::UnionFind{V},
        order::AbstractVector{V},
        index::AbstractVector{V},
        graph::AbstractGraph{V},
        tree::Parent{V},
        strt::V,
        stop::V,
        fanc::V,
    ) where {V, E}
    @assert nv(graph) <= length(wt)
    @assert nv(graph) < length(begptr)
    @assert nv(graph) < length(endptr)
    @assert de(graph) <= length(target)
    @assert nv(graph) <= length(map1)
    @assert nv(graph) <= length(inv1)
    @assert nv(graph) <= length(fdesc)
    @assert nv(graph) <= length(prev_p)
    @assert nv(graph) <= length(prev_nbr)
    @assert nv(graph) <= length(order)
    @assert nv(graph) <= length(index)
    @assert nv(graph) <= length(tree)
    @assert nv(graph) >= stop >= strt >= one(V)
    @assert stop + one(V) >= fanc >= strt

    @inbounds for p in fanc:stop
        v = order[p]
        endptr[v] = begptr[v] - one(E)
    end

    @inbounds for p in strt:stop
        wt[p] = zero(V)
        map1[p] = p
        inv1[p] = p
        sets.rank[p] = zero(V)
        sets.parent[p] = zero(V)
    end

    @inbounds for p in ancestorindices(tree, stop)
        prev_p[p] = zero(V)
        prev_nbr[p] = zero(V)
    end

    function find(u::V)
        v = @inbounds inv1[sets[u]]
        return v
    end

    function union(u::V, v::V)
        @inbounds uu = map1[u]
        @inbounds vv = map1[v]
        @inbounds vv = map1[v] = union!(sets, uu, vv)
        @inbounds inv1[vv] = v
        return
    end

    @inbounds for p in strt:fanc - one(V)
        v = order[p]

        for t in begptr[v]:endptr[v]
            u = target[t]

            if iszero(prev_nbr[u]) || prev_nbr[u] < fdesc[p]
                wt[p] += one(V)            
                pp = prev_p[u]

                if !iszero(pp)
                    q = find(pp)
                    wt[q] -= one(V)
                end

                prev_p[u] = p
            end

            prev_nbr[u] = p
        end

        if p < stop
            r = parentindex(tree, p)::V
            union(p, r)
        end
    end

    @inbounds for p in fanc:stop
        v = order[p]

        for w in neighbors(graph, v)
            u = index[w]

            if u > stop
                if iszero(prev_nbr[u]) || prev_nbr[u] < fdesc[p]
                    wt[p] += one(V)            
                    pp = prev_p[u]
    
                    if !iszero(pp)
                        q = find(pp)
                        wt[q] -= one(V)
                    end
    
                    prev_p[u] = p
                    target[endptr[v] += one(E)] = u
                end
    
                prev_nbr[u] = p
            end
        end

        if p < stop
            r = parentindex(tree, p)::V
            union(p, r)
        end 
    end

    @inbounds for p in strt:stop - one(V)
        r = parentindex(tree, p)::V
        wt[r] += wt[p]
    end

    return
end

module AMDExt

using Base: oneto
using CliqueTrees
using CliqueTrees.Utilities
using Graphs

import AMD as AMDLib

const AMD_DENSE = AMDLib.AMD_DENSE
const AMD_AGGRESSIVE = AMDLib.AMD_AGGRESSIVE
const COLAMD_DENSE_ROW = AMDLib.COLAMD_DENSE_ROW
const COLAMD_DENSE_COL = AMDLib.COLAMD_DENSE_COL
const COLAMD_AGGRESSIVE = AMDLib.COLAMD_AGGRESSIVE

const VECTOR{T} = Union{Vector{T}, FVector{T}}

function CliqueTrees.permutation(weights::AbstractVector, graph::AbstractGraph, alg::Union{AMD, SymAMD})
    order = amd(graph, alg)
    return order, invperm(order)
end

function amd(graph::AbstractGraph{V}, alg::Union{AMD, SymAMD}) where {V}
    new = BipartiteGraph{Cint, Cint}(graph)
    order = convert(Vector{V}, amd(new, alg))
    return order
end

function amd(graph::AbstractGraph{Int64}, alg::Union{AMD, SymAMD})
    new = BipartiteGraph{Int64, Int64}(graph)
    return amd(new, alg)
end

function amd(graph::BipartiteGraph{Cint, Cint, <:VECTOR{Cint}, <:VECTOR{Cint}}, alg::AMD)
    n = nv(graph); m = ne(graph); nn = n + one(Cint)

    # set parameters
    meta = AMDLib.Amd()
    setmeta!(meta, alg)

    # construct AMD graph
    xadj = pointers(graph)
    adjncy = targets(graph)

    @inbounds for v in oneto(nn)
        xadj[v] -= one(Cint)
    end

    @inbounds for v in oneto(m)
        adjncy[v] -= one(Cint)
    end

    # construct permutation
    order = zeros(Cint, n)
    AMDLib.amd_order(n, xadj, adjncy, order, meta.control, meta.info)

    @inbounds for v in oneto(n)
        xadj[v] += one(Cint)
        order[v] += one(Cint)
    end

    xadj[nn] += one(Cint)

    @inbounds for v in oneto(m)
        adjncy[v] += one(Cint)
    end

    return order
end


function amd(graph::BipartiteGraph{Int64, Int64, <:VECTOR{Int64}, <:VECTOR{Int64}}, alg::AMD)
    n = nv(graph); m = ne(graph); nn = n + one(Int64)

    # set parameters
    meta = AMDLib.Amd()
    setmeta!(meta, alg)

    # construct AMD graph
    xadj = pointers(graph)
    adjncy = targets(graph)

    @inbounds for v in oneto(nn)
        xadj[v] -= one(Int64)
    end

    @inbounds for v in oneto(m)
        adjncy[v] -= one(Int64)
    end

    # construct permutation
    order = zeros(Int64, n)
    AMDLib.amd_l_order(n, xadj, adjncy, order, meta.control, meta.info)

    @inbounds for v in oneto(n)
        xadj[v] += one(Int64)
        order[v] += one(Int64)
    end

    xadj[nn] += one(Int64)

    @inbounds for v in oneto(m)
        adjncy[v] += one(Int64)
    end

    return order
end

function amd(graph::BipartiteGraph{Cint, Cint, <:VECTOR{Cint}, <:VECTOR{Cint}}, alg::SymAMD)
    n = nv(graph); m = ne(graph); nn = n + one(Cint)

    # set parameters
    meta = AMDLib.Colamd{Cint}()
    setmeta!(meta, alg)

    # construct AMD graph
    xadj = pointers(graph)
    adjncy = targets(graph)

    @inbounds for v in oneto(nn)
        xadj[v] -= one(Cint)
    end

    @inbounds for v in oneto(m)
        adjncy[v] -= one(Cint)
    end

    # construct permutation
    order = zeros(Cint, nn)
    cfun_calloc = @cfunction(Base.Libc.calloc, Ptr{Cvoid}, (Cint, Cint))
    cfun_free = @cfunction(Base.Libc.free, Cvoid, (Ptr{Cvoid},))
    AMDLib.symamd(n, adjncy, xadj, order, meta.knobs, meta.stats, cfun_calloc, cfun_free)

    @inbounds for v in oneto(n)
        xadj[v] += one(Cint)
        order[v] += one(Cint)
    end

    xadj[nn] += one(Cint)

    @inbounds for v in oneto(m)
        adjncy[v] += one(Cint)
    end

    return resize!(order, n)
end

function amd(graph::BipartiteGraph{Int64, Int64, <:VECTOR{Int64}, <:VECTOR{Int64}}, alg::SymAMD)
    n = nv(graph); m = ne(graph); nn = n + one(Int64)

    # set parameters
    meta = AMDLib.Colamd{Int64}()
    setmeta!(meta, alg)

    # construct AMD graph
    xadj = pointers(graph)
    adjncy = targets(graph)

    @inbounds for v in oneto(nn)
        xadj[v] -= one(Int64)
    end

    @inbounds for v in oneto(m)
        adjncy[v] -= one(Int64)
    end

    # construct permutation
    order = zeros(Int64, nn)
    cfun_calloc = @cfunction(Base.Libc.calloc, Ptr{Cvoid}, (Int64, Int64))
    cfun_free = @cfunction(Base.Libc.free, Cvoid, (Ptr{Cvoid},))
    AMDLib.symamd_l(n, adjncy, xadj, order, meta.knobs, meta.stats, cfun_calloc, cfun_free)

    @inbounds for v in oneto(n)
        xadj[v] += one(Int64)
        order[v] += one(Int64)
    end

    xadj[nn] += one(Int64)

    @inbounds for v in oneto(m)
        adjncy[v] += one(Int64)
    end

    return resize!(order, n)
end

function setmeta!(meta::AMDLib.Amd, alg::AMD)
    meta.control[AMD_DENSE] = alg.dense
    meta.control[AMD_AGGRESSIVE] = alg.aggressive
    return
end

function setmeta!(meta::AMDLib.Colamd, alg::SymAMD)
    meta.knobs[COLAMD_DENSE_ROW] = alg.dense_row
    meta.knobs[COLAMD_DENSE_COL] = alg.dense_col
    meta.knobs[COLAMD_AGGRESSIVE] = alg.aggressive
    return
end

end

# CachedGraph: an immutable snapshot of a Graph for the DP algorithm.
# Shares the same vertex indices as the source Graph (no reindexing).
# Uses AbstractPackedSet for bitset neighborhoods (immutable, functional style).

# ==================== Struct ====================

@enum SeparatorType Neither Cliquish PotentialMaximalClique

struct CachedGraph{PSet <: AbstractPackedSet}
    graph::Graph{PSet}                      # the underlying graph
    cache::Dict{PSet, SeparatorType}        # cache for is_csh! / is_pmc!
end

vertices(g::CachedGraph) = vertices(g.graph)
nv(g::CachedGraph) = nv(g.graph)
neighbors(g::CachedGraph, v::Int) = neighbors(g.graph, v)

# ==================== Constructor from Graph ====================

"""
    CachedGraph(g::Graph{PSet})

Build a CachedGraph from a Graph. Copies the neighborhoods since
the source Graph may be mutated afterward.
"""
function CachedGraph(g::Graph{PSet}) where {PSet}
    graph_copy = Graph{PSet}(copy(g.neighbors), vertices(g))
    return CachedGraph{PSet}(graph_copy, Dict{PSet, SeparatorType}())
end

# ==================== Components and Neighbors ====================

"""
    components(g, S)

Find connected components in G \\ S via BFS.
Returns a lazy iterator of `(component, neighbors_in_separator)` tuples.
"""
function components(g::CachedGraph{PSet}, S::PSet) where {PSet}
    return ComponentsIterator(g.graph, S)
end

# ==================== Neighbors ====================

"""
    neighbors(g, vertex_set)

Open neighborhood of a vertex set: the union of N(v) for v in vertex_set, minus vertex_set itself.
"""
function neighbors(g::CachedGraph{PSet}, vertex_set::PSet) where {PSet}
    result = PSet()

    for v in vertex_set
        result = result ∪ neighbors(g, v)
    end

    return setdiff(result, vertex_set)
end

# ==================== Minimal Separator ====================

"""
    is_minimal_separator(g, separator)

Returns `(is_minimal::Bool, components::Vector{PSet})`.
"""
function is_minimal_separator(g::CachedGraph{PSet}, separator::PSet) where {PSet}
    cmps = PSet[]; count = 0

    for (component, nbrs) in components(g, separator)
        push!(cmps, component)

        if nbrs == separator
            count += 1
        end
    end
    return (count >= 2, cmps)
end

# Definiton 5
#
# A vertex subset K ⊆ V(G) is *cliquish* if for each
# pair of distinct, nonadjacent vertices u, v ∈ K, there
# exists a path from u to v that does not lead through
# other vertices in K.
function is_csh!(work::Vector{PSet}, graph::CachedGraph{PSet}, K::PSet) where {PSet <: AbstractPackedSet}
    return septype!(work, graph, K) ≥ Cliquish
end

# Lemma 6
#
# A vertex subset K ⊆ V(G) is a potential maximal clique if
# and only if the following conditions hold.
#
#   1. K is cliquish.
#   2. K has no full components.
#
function is_pmc!(work::Vector{PSet}, graph::CachedGraph{PSet}, K::PSet) where {PSet <: AbstractPackedSet}
    return septype!(work, graph, K) == PotentialMaximalClique
end

function septype!(work::Vector{PSet}, graph::CachedGraph{PSet}, K::PSet) where {PSet <: AbstractPackedSet}
    return get!(graph.cache, K) do
        csh = 1
        pmc = 1

        @inbounds for v in K
            work[v] = neighbors(graph, v) ∪ v
        end

        for (_, N) in components(graph, K)
            pmc &= N != K

            @inbounds for v in N
                work[v] = work[v] ∪ N
            end
        end

        @inbounds for v in K
            csh &= K ⊆ work[v]
        end

        pmc &= csh
        return SeparatorType(csh + pmc)
    end
end

# ==================== Outlet ====================

"""
    outlet(g, bag, vertices)

Compute the outlet: vertices in `bag` that have neighbors outside `vertices`.

Equivalent to: let external = N(bag) \\ vertices; return N(external) ∩ bag.
Returns an empty bitset if external is empty.
"""
function outlet(g::CachedGraph{PSet}, B::PSet, V::PSet) where {PSet}
    external = setdiff(neighbors(g, B), V)
    return neighbors(g, external) ∩ B
end

# Tests for Mooncake-based AD rules
# Requires MooncakeSparse to be loaded for consistent gradient conventions
using Test
using LinearAlgebra
using SparseArrays
using SparseArrays: nonzeros
using Random: randn!

import Mooncake
using Mooncake: Config, prepare_derivative_cache, prepare_gradient_cache,
                zero_tangent, value_and_derivative!!, value_and_gradient!!

using MooncakeSparse
using MooncakeSparse: ldivwith

using CliqueTrees
using CliqueTrees.Multifrontal: ChordalCholesky, logdet, selinv

function randtangent(A::AbstractArray)
    dA = similar(A)
    randn!(dA)
    return dA
end

function randtangent(A::AbstractSparseArray)
    dA = similar(A)
    randn!(nonzeros(dA))
    return dA
end

function randtangent(A::Union{Hermitian, Symmetric})
    dA = similar(A)
    randn!(nonzeros(parent(dA)))
    return dA
end

function testgradient(f, args...; rtol=1e-4)
    config = Config(friendly_tangents=true)
    fwd_cache = prepare_derivative_cache(f, args...; config)
    rev_cache = prepare_gradient_cache(f, args...; config)

    df = zero_tangent(f)
    tangents = map(randtangent, args)

    _, dy = value_and_derivative!!(fwd_cache, (f, df), zip(args, tangents)...)
    _, (_, gradients...) = value_and_gradient!!(rev_cache, f, args...)

    return isapprox(dy, sum(real ∘ splat(dot), zip(gradients, tangents)); rtol)
end

@testset "Mooncake" begin
    for T in (Float64,)
        @testset "$T" begin
            n = 50
            p = 0.1

            A = sprandn(T, n, n, p)
            Q = parent(Symmetric(A' * A + n * I))
            F = cholesky!(ChordalCholesky(Symmetric(Q)))

            @testset "logdet(Q, F)" begin
                @test testgradient(Q -> logdet(Q, F), Q)
            end

            @testset "dot(selinv, selinv)" begin
                @test testgradient(Q -> (Σ = selinv(Q, F); dot(Σ, Σ)), Q)
            end

            @testset "ldivwith(Q, F, B)" begin
                B = randn(T, n)
                @test testgradient((Q, B) -> (X = ldivwith(Q, F, B); dot(X, X)), Q, B)
            end

            @testset "F \\ x vector" begin
                x = randn(T, n)
                @test testgradient(x -> (y = F \ x; dot(y, y)), x)
            end

            @testset "F \\ X matrix" begin
                X = randn(T, n, 3)
                @test testgradient(X -> (Y = F \ X; dot(Y, Y)), X)
            end

            @testset "X / F matrix" begin
                X = randn(T, 3, n)
                @test testgradient(X -> (Y = X / F; dot(Y, Y)), X)
            end
        end
    end
end

struct BipartiteEdgeIter{V, E, Ptr, Tgt} <: AbstractEdgeIter
    graph::BipartiteGraph{V, E, Ptr, Tgt}
end

function Base.show(io::IO, iter::BipartiteEdgeIter)
    printiterator(io, iter)
    return
end

############################
# Abstract Graph Interface #
############################

function Graphs.edgetype(::BipartiteGraph{V}) where {V}
    return SimpleEdge{V}
end

function Graphs.edges(graph::BipartiteGraph)
    return BipartiteEdgeIter(graph)
end

#######################
# Iteration Interface #
#######################

function Base.iterate(iter::BipartiteEdgeIter{V, E}, (i, p)::Tuple{V, E} = (one(V), one(E))) where {V, E}
    graph = iter.graph; ip1 = i + one(V); pp1 = p + one(E)
    result = nothing

    if p <= ne(graph)
        @inbounds j = targets(graph)[p]
        @inbounds pnext = pointers(graph)[ip1]

        @inbounds while p ≥ pnext
            i = ip1; ip1 = i + one(V); pnext = pointers(graph)[ip1]
        end

        edge = SimpleEdge{V}(i, j)

        if pp1 ≥ pnext
            i = ip1
        end

        result = (edge, (i, pp1))
    end

    return result
end

function Base.length(iter::BipartiteEdgeIter)
    m::Int = ne(iter.graph)
    return m
end

function Base.eltype(::Type{<:BipartiteEdgeIter{V}}) where {V}
    return SimpleEdge{V}
end

function Base.in(edge, iter::BipartiteEdgeIter)
    return has_edge(iter.graph, edge)
end

"""
    ChordalSymbolic{I}

A symbolic factorization of a sparse symmetric matrix. It can
be used to construct a [`ChordalCholesky`](@ref) or [`ChordalLDLt`](@ref) matrix
factorization, determining the sparsity pattern of its lower
and upper triangular factors.

### Fields

  - `S.L`: lower triangular factor (Boolean)
  - `S.U`: upper triangular factor (Boolean)

"""
struct ChordalSymbolic{I}
    res::BipartiteGraph{I, I, FVector{I}, OneTo{I}}
    sep::BipartiteGraph{I, I, FVector{I}, FVector{I}}
    rel::BipartiteGraph{I, I, FVector{I}, FVector{I}}
    chd::BipartiteGraph{I, I, FVector{I}, FVector{I}}
    pnt::FVector{I}
    idx::FVector{I}
    Dptr::FVector{I}
    Lptr::FVector{I}
    nMptr::I
    nMval::I
    nNval::I
    nFval::I
end

"""
    symbolic(A::AbstractMatrix; kw...)

Construct a symbolic factorization. The keyword arguments
`kw` are passed to the function [`cliquetree`](@ref).

### Example

```julia-repl
julia> using CliqueTrees.Multifrontal, LinearAlgebra

julia> A = [
           4  2  0  0  2
           2  5  0  0  3
           0  0  4  2  0
           0  0  2  5  2
           2  3  0  2  7
       ]

julia> P, S = symbolic(A);

julia> S
5×5 ChordalSymbolic{Int64} with 10 stored entries:
  true    ⋅      ⋅      ⋅      ⋅  
 false   true    ⋅      ⋅      ⋅  
 false   true   true    ⋅      ⋅  
  true  false  false   true    ⋅  
 false   true   true   true   true

julia> F = cholesky!(ChordalCholesky(A, P, S))
5×5 FChordalCholesky{:L, Float64, Int64} with 10 stored entries:
 2.0   ⋅    ⋅    ⋅    ⋅ 
 0.0  2.0   ⋅    ⋅    ⋅ 
 0.0  1.0  2.0   ⋅    ⋅ 
 1.0  0.0  0.0  2.0   ⋅ 
 0.0  1.0  1.0  1.0  2.0
```
"""
function symbolic(A::AbstractMatrix; kw...)
    return symbolic(sparse(A); kw...)
end

function symbolic(A::SparseMatrixCSC; check::Bool=true, kw...)
    if !check || ishermitian(A)
        return symbolic(BipartiteGraph(A); kw...)
    elseif istril(A)
        return symbolic(Hermitian(A, :L); kw...)
    elseif istriu(A)
        return symbolic(Hermitian(A, :U); kw...)
    end

    error()
end

function symbolic(A::HermOrSym; check::Bool=true, kw...)
    return symbolic(symmetric(BipartiteGraph(parent(A)), A.uplo); kw...)
end

function symbolic(graph::AbstractGraph{I}; kw...) where {I <: Integer}
    perm, tree = cliquetree(graph; kw...)
    return FPermutation(perm), ChordalSymbolic(tree)
end

function symbolic(weight::AbstractVector{I}, graph::AbstractGraph{I}; kw...) where {I <: Integer}
    blkperm, tree = cliquetree(weight, graph; kw...)

    blkptr = FVector{I}(undef, nv(graph) + one(I))
    v = zero(I)

    for bv in vertices(graph)
        blkptr[bv] = v + one(I)
        v += weight[bv]
    end

    blkptr[nv(graph) + one(I)] = v + one(I)

    perm = FVector{I}(undef, v)
    v = zero(I)

    for bv in vertices(graph)
        bw = blkperm[bv]

        for w in blkptr[bw]:blkptr[bw + one(I)] - one(I)
            v += one(I); perm[v] = w
        end
    end

    v = zero(I)

    for bv in vertices(graph)
        blkptr[bv] = v + one(I)
        v += weight[blkperm[bv]]
    end

    blkptr[nv(graph) + one(I)] = v + one(I)
    return FPermutation(blkperm), FPermutation(perm), ChordalSymbolic(blkptr, tree)
end

function ChordalSymbolic(tree::CliqueTree{I, I}) where {I <: Integer}
    res = residuals(tree)
    sep = separators(tree)
    return ChordalSymbolic(res, sep, Tree(tree))
end

function ChordalSymbolic(blkptr::AbstractVector{I}, tree::CliqueTree{I, I}) where {I <: Integer}
    blkres = residuals(tree)
    blksep = separators(tree)

    nres = zero(I)
    nsep = zero(I)

    for j in vertices(blkres)
        blo = pointers(blkres)[j]
        bhi = pointers(blkres)[j + one(I)]
        nres += blkptr[bhi] - blkptr[blo]

        for bp in incident(blksep, j)
            bv = targets(blksep)[bp]
            nsep += blkptr[bv + one(I)] - blkptr[bv]
        end
    end

    resptr = FVector{I}(undef, nv(blkres) + one(I))
    sepptr = FVector{I}(undef, nv(blkres) + one(I))
    septgt = FVector{I}(undef, nsep)

    res = BipartiteGraph(last(blkptr) - one(I), nv(blkres), nres, resptr, oneto(last(blkptr) - one(I)))
    sep = BipartiteGraph(last(blkptr) - one(I), nv(blkres), nsep, sepptr, septgt)

    rp = zero(I)
    sp = zero(I)

    for j in vertices(blkres)
        pointers(res)[j] = rp + one(I)
        pointers(sep)[j] = sp + one(I)

        blo = pointers(blkres)[j]
        bhi = pointers(blkres)[j + one(I)]

        rp += blkptr[bhi] - blkptr[blo]

        for bp in incident(blksep, j)
            bv = targets(blksep)[bp]

            for v in blkptr[bv]:blkptr[bv + one(I)] - one(I)
                sp += one(I); septgt[sp] = v
            end
        end
    end

    pointers(res)[nv(blkres) + one(I)] = rp + one(I)
    pointers(sep)[nv(blkres) + one(I)] = sp + one(I)

    return ChordalSymbolic(blkptr, res, sep, blkres, blksep, Tree(tree))
end

function ChordalSymbolic(blkptr::AbstractVector{I}, res::BipartiteGraph, sep::BipartiteGraph, blkres::BipartiteGraph, blksep::BipartiteGraph, tree::Tree) where {I}
    chd = tree.graph
    pnt = tree.tree.prnt

    reltgt = FVector{I}(undef, ne(sep))
    rel = BipartiteGraph(nov(sep), nv(sep), ne(sep), pointers(sep), reltgt)

    nMptr = jMptr = one(I)
    nMval = jMval = zero(I)
    nNval = jNval = zero(I)
    nFval = zero(I)
    Dp = zero(I)
    Lp = zero(I)

    idx = FVector{I}(undef, nov(res))
    Dptr = FVector{I}(undef, nv(res) + one(I))
    Lptr = FVector{I}(undef, nv(res) + one(I))

    for j in vertices(blkres)
        Dptr[j] = Dp + one(I)
        Lptr[j] = Lp + one(I)

        bnn = eltypedegree(blkres, j)
        bna = eltypedegree(blksep, j)

        nn = eltypedegree(res, j)
        na = eltypedegree(sep, j)
        nj = nn + na

        jblkres = neighbors(blkres, j)
        jblksep = neighbors(blksep, j)

        for bw in jblkres
            for w in blkptr[bw]:blkptr[bw + one(I)] - one(I)
                idx[w] = j
            end
        end

        for i in neighbors(chd, j)
            p = pointers(sep)[i]
            q = one(I); bq = one(I); bw = jblkres[bq]

            for bp in incident(blksep, i)
                bv = targets(blksep)[bp]

                while bw < bv && bq < bnn
                    q += blkptr[bw + one(I)] - blkptr[bw]; bq += one(I); bw = jblkres[bq]
                end

                while bw < bv
                    q += blkptr[bw + one(I)] - blkptr[bw]; bq += one(I); bw = jblksep[bq - bnn]
                end

                wv = blkptr[bv + one(I)] - blkptr[bv]

                for b in oneto(wv)
                    reltgt[p] = q + b - one(I)
                    p += one(I)
                end
            end

            ma = eltypedegree(sep, i)

            jMptr -= one(I)
            jMval -= ma * ma
            jNval -= ma
        end

        if ispositive(na)
            jMptr += one(I)
            jMval += na * na
            jNval += na

            nMptr = max(nMptr, jMptr)
            nMval = max(nMval, jMval)
            nNval = max(nNval, jNval)
        end

        nFval = max(nFval, nj)
        Dp += nn * nn
        Lp += nn * na
    end

    Dptr[nv(res) + one(I)] = Dp + one(I)
    Lptr[nv(res) + one(I)] = Lp + one(I)

    return ChordalSymbolic(res, sep, rel, chd, pnt, idx, Dptr, Lptr, nMptr, nMval, nNval, nFval)
end

function ChordalSymbolic(res::BipartiteGraph{I, I}, sep::BipartiteGraph{I, I}) where {I}
    pnt = FVector{I}(undef, nv(res))
    idx = FVector{I}(undef, nov(res))
    pstop = ne(sep) + one(I)

    for i in reverse(vertices(res))
        pstrt = pointers(sep)[i]

        if pstrt < pstop
            w = targets(sep)[pstrt]
            j = idx[w]
        else
            j = zero(I)
        end

        pnt[i] = j

        for v in neighbors(res, i)
            idx[v] = i
        end

        pstop = pstrt
    end

    return ChordalSymbolic(res, sep, Tree(nv(res), pnt))
end

function ChordalSymbolic(res::BipartiteGraph{I, I}, sep::BipartiteGraph{I, I}, tree::Tree{I}) where {I}
    chd = tree.graph
    pnt = tree.tree.prnt

    reltgt = FVector{I}(undef, ne(sep))
    rel = BipartiteGraph(nov(sep), nv(sep), ne(sep), pointers(sep), reltgt)

    nMptr = jMptr = one(I)
    nMval = jMval = zero(I)
    nNval = jNval = zero(I)
    nFval = zero(I)
    Dp = zero(I)
    Lp = zero(I)

    idx = FVector{I}(undef, nov(res))
    Dptr = FVector{I}(undef, nv(res) + one(I))
    Lptr = FVector{I}(undef, nv(res) + one(I))

    for j in vertices(res)
        Dptr[j] = Dp + one(I)
        Lptr[j] = Lp + one(I)

        nn = eltypedegree(res, j)
        na = eltypedegree(sep, j)
        nj = nn + na

        jres = neighbors(res, j)
        jsep = neighbors(sep, j)

        for w in jres
            idx[w] = j
        end

        for i in neighbors(chd, j)
            q = one(I); w = jres[q]

            for p in incident(sep, i)
                v = targets(sep)[p]

                while w < v && q < nn
                    q += one(I); w = jres[q]
                end

                while w < v
                    q += one(I); w = jsep[q - nn]
                end

                targets(rel)[p] = q
            end

            ma = eltypedegree(sep, i)

            jMptr -= one(I)
            jMval -= ma * ma
            jNval -= ma
        end

        if ispositive(na)
            jMptr += one(I)
            jMval += na * na
            jNval += na

            nMptr = max(nMptr, jMptr)
            nMval = max(nMval, jMval)
            nNval = max(nNval, jNval)
        end

        nFval = max(nFval, nj)
        Dp += nn * nn
        Lp += nn * na
    end

    Dptr[nv(res) + one(I)] = Dp + one(I)
    Lptr[nv(res) + one(I)] = Lp + one(I)

    return ChordalSymbolic(res, sep, rel, chd, pnt, idx, Dptr, Lptr, nMptr, nMval, nNval, nFval)
end

function Base.getproperty(S::ChordalSymbolic, d::Symbol)
    if d === :L
        return SymbolicChordalTriangular{:L}(S)
    elseif d === :U
        return SymbolicChordalTriangular{:U}(S)
    else
        return getfield(S, d)
    end
end

function Base.copy(S::ChordalSymbolic)
    return ChordalSymbolic(
        copy(S.res), copy(S.sep), copy(S.rel), copy(S.chd),
        copy(S.pnt), copy(S.idx), copy(S.Dptr), copy(S.Lptr),
        S.nMptr, S.nMval, S.nNval, S.nFval,
    )
end

function Base.copyto!(dst::ChordalSymbolic, src::ChordalSymbolic)
    copyto!(dst.res, src.res)
    copyto!(dst.sep, src.sep)
    copyto!(dst.rel, src.rel)
    copyto!(dst.chd, src.chd)
    copyto!(dst.pnt, src.pnt)
    copyto!(dst.idx, src.idx)
    copyto!(dst.Dptr, src.Dptr)
    copyto!(dst.Lptr, src.Lptr)
    return dst
end

function Base.show(io::IO, S::T) where {T <: ChordalSymbolic}
    n = ncl(S)
    print(io, "$n×$n $T with $(nnz(S)) stored entries")
    return
end

function Base.show(io::IO, ::MIME"text/plain", S::T) where {T <: ChordalSymbolic}
    n = ncl(S)
    println(io, "$n×$n $T with $(nnz(S)) stored entries:")

    if n < 16
        print_matrix(io, S.L)
    else
        showsymbolic(io, S, Val(:L))
    end

    return
end

# ===== Braille Patterns =====

const brailleblocks = UInt16['⠁', '⠂', '⠄', '⡀', '⠈', '⠐', '⠠', '⢀']

function showsymbolic(io::IO, S::ChordalSymbolic, uplo::Val{Q}) where {Q}
    n = ncl(S)

    maxheight, maxwidth = displaysize(io)
    maxheight -= 4
    maxwidth ÷= 2

    if get(io, :limit, true)
        scaleheight = max(8, min(n, 2maxwidth, 4maxheight))
        scalewidth = max(4, min(n, 2maxwidth, 4maxheight))
    else
        scaleheight = max(8, n)
        scalewidth = max(4, n)
    end

    rowscale = max(1, scaleheight - 1) / max(1, n - 1)
    colscale = max(1, scalewidth - 1) / max(1, n - 1)

    braillegrid = Matrix{UInt16}(undef, (scalewidth - 1) ÷ 2 + 4, (scaleheight - 1) ÷ 4 + 1)
    braillegrid               .= '⠀'
    braillegrid[1,       :]   .= '⎢'
    braillegrid[end - 1, :]   .= '⎥'
    braillegrid[1,       1]    = '⎡'
    braillegrid[1,     end]    = '⎣'
    braillegrid[end - 1, 1]    = '⎤'
    braillegrid[end - 1, end]  = '⎦'
    braillegrid[end,     :]   .= '\n'

    for j in vertices(S.res)
        res = neighbors(S.res, j)
        sep = neighbors(S.sep, j)

        nn = eltypedegree(S.res, j)
        na = eltypedegree(S.sep, j)

        for w in oneto(nn)
            rw = res[w]

            if Q == :L
                rng = w:nn
            else
                rng = oneto(w)
            end

            for v in rng
                rv = res[v]
                setbraille!(braillegrid, rv, rw, rowscale, colscale)
            end

            for v in oneto(na)
                sv = sep[v]

                if Q == :L
                    setbraille!(braillegrid, sv, rw, rowscale, colscale)
                else
                    setbraille!(braillegrid, rw, sv, rowscale, colscale)
                end
            end
        end
    end

    for c in @view braillegrid[1:end - 1]
        print(io, Char(c))
    end
end

function setbraille!(braillegrid, row, col, rowscale, colscale)
    si = round(Int, (row - 1) * rowscale + 1)
    sj = round(Int, (col - 1) * colscale + 1)

    i =  (sj - 1) ÷ 2  + 2
    j =  (si - 1) ÷ 4  + 1
    b = ((sj - 1) % 2) * 4 + ((si - 1) % 4 + 1)

    braillegrid[i, j] |= brailleblocks[b]
end

# ===== Abstract Matrix Interface =====

function SparseArrays.nnz(S::ChordalSymbolic)
    return ndz(S) + nlz(S)
end

function ndz(S::ChordalSymbolic)
    n = nfr(S)
    return convert(Int, S.Dptr[n + 1]) - 1
end

function nlz(S::ChordalSymbolic)
    n = nfr(S)
    return convert(Int, S.Lptr[n + 1]) - 1
end

function ncl(S::ChordalSymbolic)
    return convert(Int, nov(S.res))
end

function nfr(S::ChordalSymbolic)
    return convert(Int, nv(S.res))
end

function fronts(S::ChordalSymbolic)
    return oneto(nfr(S))
end

function Base.size(S::ChordalSymbolic)
    n = ncl(S)
    return (n, n)
end

function Base.size(S::ChordalSymbolic, i::Integer)
    return ncl(S)
end

function Base.isstored(S::ChordalSymbolic, v::Integer, w::Integer, uplo::Val{UPLO}) where {UPLO}
    return !iszero(flatindex(S, v, w, uplo))
end

function flatindex(S::ChordalSymbolic{I}, v::Integer, w::Integer, uplo::Val) where {I <: Integer}
    return flatindex(S, convert(I, v), convert(I, w), uplo)
end

function flatindex(S::ChordalSymbolic{I}, v::I, w::I, ::Val{:L}) where {I <: Integer}
    poff = convert(I, ndz(S))

    if v ≥ w
        j = S.idx[w]

        nn = eltypedegree(S.res, j)
        na = eltypedegree(S.sep, j)

        res = neighbors(S.res, j)
        sep = neighbors(S.sep, j)

        w = w - first(res)

        if v in res
            v = v - first(res)
            return S.Dptr[j] + v + w * nn
        else
            i = searchsortedfirst(sep, v)

            if i ≤ na && sep[i] == v
                v = convert(I, i) - one(I)
                return S.Lptr[j] + poff + v + w * na
            end
        end
    end

    return zero(I)
end

function flatindex(S::ChordalSymbolic{I}, v::I, w::I, ::Val{:U}) where {I <: Integer}
    poff = convert(I, ndz(S))

    if v ≤ w
        j = S.idx[v]

        nn = eltypedegree(S.res, j)
        na = eltypedegree(S.sep, j)

        res = neighbors(S.res, j)
        sep = neighbors(S.sep, j)

        v = v - first(res)

        if w in res
            w = w - first(res)
            return S.Dptr[j] + v + w * nn
        else
            i = searchsortedfirst(sep, w)

            if i ≤ na && sep[i] == w
                w = convert(I, i) - one(I)
                return S.Lptr[j] + poff + v + w * nn
            end
        end
    end

    return zero(I)
end

function flatindices(S::ChordalSymbolic{I}, B::SparseMatrixCSC, ::Val{:L}) where {I}
    P = zeros(I, nnz(B)); poff = convert(I, ndz(S))
    res = S.res
    sep = S.sep

    rhi = one(I)

    @inbounds for j in vertices(res)
        pj = S.Dptr[j] - one(I)

        rlo = rhi
        rhi = pointers(res)[j + one(I)]

        for col in rlo:rhi - one(I)
            row = rlo

            for p in nzrange(B, col)
                wa = rowvals(B)[p]
                wa < rlo && continue
                wa >= rhi && break

                P[p] = pj += wa - row + one(I)
                row = wa + one(I)
            end

            pj += rhi - row
        end
    end

    shi = one(I)

    @inbounds for j in vertices(res)
        pj = S.Lptr[j] + poff - one(I)

        slo = shi
        shi = pointers(sep)[j + one(I)]
        slo >= shi && continue

        swr = targets(sep)[slo]
        nwr = targets(sep)[shi - one(I)] + one(I)

        for col in neighbors(res, j)
            k = slo

            for p in nzrange(B, col)
                row = targets(sep)[k]
                wa = rowvals(B)[p]
                wa < swr && continue
                wa >= nwr && break

                while row < wa
                    pj += one(I)
                    k += one(I)
                    row = targets(sep)[k]
                end

                P[p] = pj += one(I)
                k += one(I)
            end

            pj += shi - k
        end
    end

    return P
end

function flatindices(S::ChordalSymbolic{I}, B::SparseMatrixCSC, ::Val{:U}) where {I}
    P = zeros(I, nnz(B)); poff = convert(I, ndz(S))
    res = S.res
    sep = S.sep

    rhi = one(I)

    @inbounds for j in vertices(res)
        pj = S.Dptr[j] - one(I)

        rlo = rhi
        rhi = pointers(res)[j + one(I)]

        for col in rlo:rhi - one(I)
            row = rlo

            for p in nzrange(B, col)
                wa = rowvals(B)[p]
                wa < rlo && continue
                wa >= rhi && break

                P[p] = pj += wa - row + one(I)
                row = wa + one(I)
            end

            pj += rhi - row
        end

        pj = S.Lptr[j] + poff - one(I)

        for col in neighbors(sep, j)
            row = rlo

            for p in nzrange(B, col)
                wa = rowvals(B)[p]
                wa < rlo && continue
                wa >= rhi && break

                P[p] = pj += wa - row + one(I)
                row = wa + one(I)
            end

            pj += rhi - row
        end
    end

    return P
end

function flatindices(P::Permutation, S::ChordalSymbolic, A::SparseMatrixCSC, uplo::Val; check::Bool=true)
    return flatindices(P.invp, S, A, uplo; check)
end

function flatindices(invp::AbstractVector, S::ChordalSymbolic, A::SparseMatrixCSC, uplo::Val{UPLO}; check::Bool=true) where {UPLO}
    if !check || ishermitian(A)
        return flatindices(invp, S, Hermitian(A, UPLO), uplo)
    elseif istril(A)
        return flatindices(invp, S, Hermitian(A, :L), uplo)
    elseif istriu(A)
        return flatindices(invp, S, Hermitian(A, :U), uplo)
    end

    error()
end

function flatindices(P::Permutation, S::ChordalSymbolic, A::HermOrSym, uplo::Val)
    return flatindices(P.invp, S, A, uplo)
end

function flatindices(invp::AbstractVector{I}, S::ChordalSymbolic{I}, A::HermOrSym, uplo::Val{UPLO}) where {I, UPLO}
    m = convert(I, nnz(parent(A)))
    colptr = parent(A).colptr
    rowval = parent(A).rowval
    nzval = collect(oneto(m))
    B = SparseMatrixCSC(size(A)..., colptr, rowval, nzval)

    if UPLO === :L
        C = sympermute(B, invp, A.uplo, 'L')
    else
        C = sympermute(B, invp, A.uplo, 'U')
    end

    P = flatindices(S, C, uplo)
    fill!(nzval, zero(I))

    for (i, j) in zip(nonzeros(C), P)
        nzval[i] = j
    end

    return nzval
end

#**********************************************************************
#**********************************************************************
#*****   COMPRESS  ..... COMPRESS INITIAL GRAPH   *********************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       THIS ROUTINE COMPRESSES A GRAPH BY REPRESENTING EACH SET OF
#       INDISTINGUISHABLE NODES AS A SINGLE NODE.  THE UNCOMPRESSED
#       INPUT GRAPH IS WRITTEN OVER BY THE NEW COMPRESSED GRAPH.
#
#     INPUT PARAMETERS:
#       NEQNS       - NUMBER OF EQUATIONS.
#       MAXINT      - MAXIMUM INTEGER IN MARKING ARRAYS; USED HERE 
#                     TO SIGNIFY ABSORPTION.  (USING MARKER(*))
#       ADJLEN      - LENGTH OF ADJNCY(*).
#
#     MODIFIED PARAMETERS:
#       XADJ(*)     - ARRAY OF LENGTH NEQNS+1, CONTAINING INITIAL
#                     POINTERS TO THE ADJACENCY STRUCTURE.  ON 
#                     OUTPUT, CONTAINS POINTERS FOR THE COMPRESSED
#                     ADJACENCY STRUCTURE.
#       ADJNCY(*)   - ARRAY OF LENGTH ADJLEN, CONTAINING INITIAL
#                     ADJACENCY STRUCTURE.  ON OUTPUT, CONTAINS THE
#                     COMPRESSED ADJACENCY STRUCTURE.
#
#     OUTPUT PARAMETERS:
#       DEGREE(*)   - ARRAY OF LENGTH NEQNS, NUMBER OF NODES IN
#                     THE UNCOMPRESSED GRAPH ADJACENT TO THE NODE,
#                     PLUS ONE.  (I.E., |N(V) \CUP {V}|)
#       MARKER(*)   - ARRAY OF LENGTH NEQNS,
#                       0      -  REPRESENTATIVE NODE IN COMPRESSED
#                                 GRAPH.
#                       MAXINT -  ABSORBED NODE IN COMPRESSED GRAPH.
#       WORK(*)     - ARRAY OF LENGTH NEQNS,
#                       0      -  REPRESENTATIVE NODE IN COMPRESSED
#                                 GRAPH.
#                       <0     -  -JNODE, WHERE THE NODE IS ABSORBED
#                                 INTO REPRESENTATIVE NODE JNODE.
#       QSIZE(*)    - ARRAY OF LENGTH NEQNS,
#                       0      -  ABSORBED NODE IN COMPRESSED GRAPH.
#                       >0     -  NUMBER OF NODES IN THE SUPERNODE 
#                                 REPRESENTED BY THE NODE.
#
#     WORKING PARAMETERS:
#       HASH(*)     - ARRAY OF LENGTH NEQNS, USED TO CONTAIN HASH
#                     VALUES TO GROUP THE NODES TOGETHER.  THIS
#                     IS A LONG-INTEGER (I.E., INTEGER*8) ARRAY
#                     BECAUSE THE SUMS STORED IN THE HASH ARRAY
#                     MAY BE VERY LARGE.
#       UMARK(*)    - ARRAY OF LENGTH NEQNS, USED TO MARK
#                     NEIGHBORS OF NODES.
#       XADJ2(*)    - ARRAY OF LENGTH NEQNS, USED TO COMPUTE
#                     POINTERS TO NEW COMPRESSED ADJACENCY STRUCTURE.
#
#**********************************************************************
#
function compress(
        neqns::V,
        adjlen::E,
        vwght::AbstractVector{W},
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
        degree::AbstractVector{W},
        marker::AbstractVector{I},
        work::AbstractVector{V},
        qsize::AbstractVector{W},
        qnmbr::AbstractVector{V},
        hash::AbstractVector{I},
        umark::AbstractVector{I},
        xadj2::AbstractVector{E}
    ) where {V, E, I, W}
    
    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    
    #       -----------------------------------------------------------
    #       INITIALIZE VARIOUS VECTORS.
    #       NOTE THAT DEGREE COUNTS THE VERTEX AS A NEIGHBOR OF ITSELF.
    #       -----------------------------------------------------------
    tag = zero(I)

    for jnode in oneto(neqns)
        qsize[jnode] = vwght[jnode]
        qnmbr[jnode] = one(V)
        marker[jnode] = zero(V)
        work[jnode] = zero(V)
        umark[jnode] = zero(V)
        hash[jnode] = convert(I, jnode)

        kstart = xadj[jnode]
        kstop = xadj[jnode + one(V)] - one(E)
        dj = vwght[jnode]

        for k in kstart:kstop
            knode = adjncy[k]
            dj += vwght[knode]
        end

        degree[jnode] = dj
    end

    #       ----------------------------------
    #       COMPUTE HASH SCORES FOR EACH NODE.
    #       ----------------------------------
    kstart = xadj[1]

    for jnode in oneto(neqns)
        kstop = xadj[jnode + one(V)] - one(E)

        for k in kstart:kstop
            knode = adjncy[k]
            hash[jnode] += convert(I, knode)
        end

        kstart = kstop + one(E)
    end
    
    #       -----------------------
    #       FOR EACH NODE JNODE ...
    #       -----------------------
    for jnode in oneto(neqns)
        
        #           -------------------------------------------------------
        #           IF JNODE IS NOT ALREADY ABSORBED IN A PREVIOUS NODE ...
        #           -------------------------------------------------------
        if !iszero(qsize[jnode])
            
            #               ----------------------------------------------
            #               MARK JNODE AND ITS NEIGHBORS WITH THE NEW TAG.
            #               ----------------------------------------------
            tag += one(I)
            umark[jnode] = tag
            kstart = xadj[jnode]
            kstop = xadj[jnode + one(V)] - one(E)

            for k in kstart:kstop
                knode = adjncy[k]
                umark[knode] = tag
            end

            #               ------------------------------------
            #               FOR EACH NEIGHBOR KNODE OF JNODE ...
            #               ------------------------------------
            kstart = xadj[jnode]
            kstop = xadj[jnode + one(V)] - one(E)

            for k in kstart:kstop
                knode = adjncy[k]
                #                   ----------------------------------------------
                #                   IF KNODE HAS THE SAME DEGREE AND HASH VALUE AS
                #                   JNODE AND KNODE IS GREATER THAN JNODE
                #                   ----------------------------------------------
                if degree[knode] == degree[jnode] && hash[knode] == hash[jnode] && knode > jnode

                    #                       ----------------------------------------------
                    #                       CHECK IF KNODE AND JNODE ARE INDISINGUISHABLE.
                    #                       ----------------------------------------------
                    indist = true
                    istart = xadj[knode]
                    istop = xadj[knode + one(V)] - one(E)

                    for i in istart:istop
                        inode = adjncy[i]

                        if umark[inode] < tag
                            indist = false
                        end
                    end
                    #                       -----------------------------------------
                    #                       IF JNODE AND KNODE ARE INDISTINGUISHABLE,
                    #                       THEN
                    #                       -----------------------------------------
                    if indist
                        #                           ---------------------------
                        #                           KNODE IS MERGED INTO JNODE.
                        #                           ---------------------------
                        work[knode] = -jnode
                        qsize[jnode] += qsize[knode]
                        qnmbr[jnode] += qnmbr[knode]
                        marker[knode] = maxint(I)
                        qsize[knode] = zero(W)
                        qnmbr[knode] = zero(V)
                    end
                end
                #                   ----------------------------
                #                   NEXT NEIGHBOR KNODE OF JNODE
                #                   ----------------------------
            end
            
        end
        #           ----------------
        #           NEXT NODE JNODE.
        #           ----------------
    end
    
    #       ---------------------------------
    #       COMPRESS THE ADJACENCY STRUCTURE.
    #       ---------------------------------
    nxtloc = one(E)
    #       -----------------------
    #       FOR EACH NODE JNODE ...
    #       -----------------------
    for jnode in oneto(neqns)
        #           ----------------------------------------
        #           IF JNODE IS ABSORBED BY ANOTHER NODE ...
        #           ----------------------------------------
        if iszero(qsize[jnode])
            #               -------------------------------------------
            #               JNODE WILL HAVE AN EMPTY LIST OF NEIGHBORS.
            #               -------------------------------------------
            xadj2[jnode] = nxtloc
        else
            #               -------------------------------
            #               JNODE IS A REPRESENTATIVE NODE.
            #               COMPRESS JNODE'S NEIGHBOR LIST.
            #               -------------------------------
            kstart = xadj[jnode]
            kstop = xadj[jnode + one(V)] - one(E)

            for k in kstart:kstop
                knode = adjncy[k]

                if !iszero(qsize[knode])
                    adjncy[nxtloc] = knode
                    nxtloc += one(E)
                end
            end

            xadj2[jnode] = nxtloc
        end
    end

    #       ------------------
    #       COPY NEW POINTERS.
    #       ------------------
    xadj[1] = one(E)

    for k in oneto(neqns)
        xadj[k + one(V)] = xadj2[k]
    end
    
    return
end

const MultiplicationWorkspace = DivisionWorkspace
const AbstractMultiplicationWorkspace = AbstractDivisionWorkspace

# ================================== dot ==================================

function LinearAlgebra.dot(A::AbstractVecOrMat, F::NaturalFactorization{DIAG}, B::AbstractVecOrMat) where {DIAG}
    @assert size(F, 1) == size(A, 1) == size(B, 1)
    @assert size(A) == size(B)
    C = F.U * A
    E = F.U * B

    if DIAG === :U
        lmul!(F.D, E)
    end

    return dot(C, E)
end

function LinearAlgebra.dot(A::AbstractVecOrMat, F::AbstractFactorization, B::AbstractVecOrMat)
    @assert size(F, 1) == size(A, 1) == size(B, 1)
    @assert size(A) == size(B)
    return dot(F.P * A, NaturalFactorization(F), F.P * B)
end

# ================================= cong =================================

function cong(A, B)
    return B' * A * B
end

function cong(A::SparseMatrixCSC, B::Permutation)
    return permute(A, B.invp, B.invp)
end

function cong(A::Hermitian, B::Permutation)
    return Hermitian(sympermute(parent(A), B.perm, A.uplo, A.uplo), Symbol(A.uplo))
end

function cong(A::Symmetric{T}, B::Permutation) where {T <: Real}
    return Symmetric(sympermute(parent(A), B.perm, A.uplo, A.uplo), Symbol(A.uplo))
end

function cong(A::Diagonal, B::Permutation)
    return Diagonal(B \ A.diag)
end

# ================================== * ==================================

# --- Permutation ---

function Base.:*(A::Permutation{I}, B::Permutation{I}) where {I}
    @assert size(A, 1) == size(B, 1)
    C = Permutation{I}(size(A, 1))
    return mul!(C, A, B)
end

function Base.:*(A::Permutation, B::SparseMatrixCSC)
    return rowpermute(B, A.perm)
end

function Base.:*(A::SparseMatrixCSC, B::Permutation)
    return colpermute(A, B.invp)
end

function Base.:*(A::Permutation, B::Diagonal)
    C = Diagonal(similar(B.diag, promote_eltype(A, B)))
    return mul!(C, A, B)
end

# --- AbstractFactorization ---

function Base.:*(F::AbstractFactorization, B::AbstractVecOrMat)
    T = promote_eltype(F, B)
    return lmul!(F, copyto!(similar(B, T), B))
end

function Base.:*(B::AbstractMatrix, F::AbstractFactorization)
    T = promote_eltype(F, B)
    return rmul!(copyto!(similar(B, T), B), F)
end

# --- ChordalTriangular ---

function Base.:*(A::ChordalTriangular, α::Number)
    B = similar(A, promote_eltype(A, α))
    copyto!(B, A)
    rmul!(B, α)
    return B
end

function Base.:*(α::Number, A::MaybeHermOrSymTri)
    return A * α
end

function Base.:*(α::Real, A::HermTri{UPLO}) where {UPLO}
    return A * α
end

function Base.:*(A::HermTri{UPLO}, α::Number) where {UPLO}
    return Hermitian(parent(A) * α, UPLO)
end

function Base.:*(A::HermTri{UPLO}, α::Real) where {UPLO}
    return Hermitian(parent(A) * α, UPLO)
end

function Base.:*(A::HermTri{UPLO}, α::Complex) where {UPLO}
    @assert iszero(imag(α))
    return Hermitian(parent(A) * real(α), UPLO)
end

function Base.:*(A::SymTri{UPLO}, α::Number) where {UPLO}
    return Symmetric(parent(A) * α, UPLO)
end

function Base.:*(α::Number, A::AdjTri)
    return adjoint(conj(α) * parent(A))
end

function Base.:*(A::AdjTri, α::Number)
    return adjoint(parent(A) * conj(α))
end

function Base.:*(α::Number, A::TransTri)
    return transpose(α * parent(A))
end

function Base.:*(A::TransTri, α::Number)
    return transpose(parent(A) * α)
end

# ================================ lmul! ================================

# --- AbstractFactorization ---

function LinearAlgebra.lmul!(α::Number, F::AbstractFactorization{DIAG}) where {DIAG}
    if DIAG === :N
        lmul!(sqrt(α), triangular(F))
    else
        lmul!(α, F.D)
    end

    return F
end

function LinearAlgebra.lmul!(F::NaturalFactorization{DIAG}, B::AbstractVecOrMat) where {DIAG}
    @assert size(F, 1) == size(B, 1)

    if DIAG === :N
        return lmul!(F.L, lmul!(F.U, B))
    else
        return lmul!(F.L, lmul!(F.D, lmul!(F.U, B)))
    end
end

function LinearAlgebra.lmul!(F::AbstractFactorization, B::AbstractVecOrMat)
    @assert size(F, 1) == size(B, 1)
    T = promote_eltype(F, B)
    C = FArray{T}(undef, size(B))
    return mul!!(C, F, B)
end

# --- ChordalTriangular ---

function LinearAlgebra.lmul!(α::Number, C::ChordalTriangular)
    lmul!(α, C.Dval)
    lmul!(α, C.Lval)
    return C
end

function LinearAlgebra.lmul!(α::Number, A::HermTri)
    lmul!(α, parent(A))
    return A
end

function LinearAlgebra.lmul!(α::Number, A::SymTri)
    lmul!(α, parent(A))
    return A
end

function LinearAlgebra.lmul!(α::Number, A::AdjTri)
    lmul!(conj(α), parent(A))
    return A
end

function LinearAlgebra.lmul!(α::Number, A::TransTri)
    lmul!(α, parent(A))
    return A
end

function LinearAlgebra.lmul!(A::MaybeAdjOrTransTri, B::AbstractVecOrMat{R}) where {R}
    W = AbstractMultiplicationWorkspace{R}(A, size(B, 2))
    return lmul!(W, A, B)
end

function LinearAlgebra.lmul!(W::MultiplicationWorkspace, A::MaybeAdjOrTransTri, B::AbstractVecOrMat)
    @assert size(A, 1) == size(B, 1)
    A, tA = unwrap(A)
    B, tB = unwrap(B)
    return mul_impl!(B, W, A, tA, tB, Val(:L))
end

# ================================ rmul! ================================

# --- AbstractFactorization ---

function LinearAlgebra.rmul!(F::AbstractFactorization{DIAG}, α::Number) where {DIAG}
    if DIAG === :N
        rmul!(triangular(F), sqrt(α))
    else
        rmul!(F.D, α)
    end

    return F
end

function LinearAlgebra.rmul!(B::AbstractMatrix, F::NaturalFactorization{DIAG}) where {DIAG}
    @assert size(F, 1) == size(B, 2)

    if DIAG === :N
        return rmul!(rmul!(B, F.L), F.U)
    else
        return rmul!(rmul!(rmul!(B, F.L), F.D), F.U)
    end
end

function LinearAlgebra.rmul!(B::AbstractMatrix, F::AbstractFactorization)
    @assert size(F, 1) == size(B, 2)
    T = promote_eltype(F, B)
    C = FMatrix{T}(undef, size(B))
    return mul!!(C, B, F)
end

# --- ChordalTriangular ---

function LinearAlgebra.rmul!(C::ChordalTriangular, α::Number)
    rmul!(C.Dval, α)
    rmul!(C.Lval, α)
    return C
end

function LinearAlgebra.rmul!(A::HermTri, α::Number)
    rmul!(parent(A), α)
    return A
end

function LinearAlgebra.rmul!(A::SymTri, α::Number)
    rmul!(parent(A), α)
    return A
end

function LinearAlgebra.rmul!(A::AdjTri, α::Number)
    rmul!(parent(A), conj(α))
    return A
end

function LinearAlgebra.rmul!(A::TransTri, α::Number)
    rmul!(parent(A), α)
    return A
end

function LinearAlgebra.rmul!(B::AbstractMatrix{R}, A::MaybeAdjOrTransTri) where {R}
    W = AbstractMultiplicationWorkspace{R}(A, size(B, 1))
    return rmul!(W, B, A)
end

function LinearAlgebra.rmul!(W::MultiplicationWorkspace, B::AbstractMatrix, A::MaybeAdjOrTransTri)
    @assert size(A, 1) == size(B, 2)
    A, tA = unwrap(A)
    B, tB = unwrap(B)
    return mul_impl!(B, W, A, tA, tB, Val(:R))
end

# ================================= mul! ================================

# --- AbstractFactorization ---

function LinearAlgebra.mul!(C::AbstractVecOrMat, F::AbstractFactorization, B::AbstractVecOrMat)
    lmul!(F, copyrec!(C, B))
end

# --- ChordalTriangular ---

function LinearAlgebra.mul!(C::AbstractVecOrMat, A::MaybeAdjOrTransTri, B::AbstractVecOrMat)
    lmul!(A, copyrec!(C, B))
end

# --- Permutation ---

function LinearAlgebra.mul!(C::AbstractVecOrMat, A::Permutation, B::AbstractVecOrMat)
    @boundscheck size(C, 1) == size(B, 1) == size(A, 1) || throw(DimensionMismatch())
    return copyscatterrec!(C, B, A.invp, Val(:L))
end

function LinearAlgebra.mul!(C::AbstractMatrix, A::AbstractMatrix, B::Permutation)
    @boundscheck size(C, 2) == size(A, 2) == size(B, 1) || throw(DimensionMismatch())
    return copyscatterrec!(C, A, B.perm, Val(:R))
end

function LinearAlgebra.mul!(C::Diagonal, A::Permutation, B::Diagonal)
    @boundscheck length(C.diag) == length(B.diag) == size(A, 1) || throw(DimensionMismatch())
    copyscatterrec!(C.diag, B.diag, A.invp)
    return C
end

# ambiguity
function LinearAlgebra.mul!(::AbstractMatrix, ::MaybeAdjOrTransTri, ::Permutation)
    error()
end

# ambiguity
function LinearAlgebra.mul!(::AbstractMatrix, ::HermOrSymTri, ::Permutation)
    error()
end

# ambiguity
function LinearAlgebra.mul!(::AbstractMatrix, ::Permutation, ::HermOrSymTri)
    error()
end

# ambiguity
function LinearAlgebra.mul!(::AbstractMatrix, ::MaybeAdjOrTransTri, ::HermOrSymTri)
    error()
end

# ambiguity
function LinearAlgebra.mul!(::AbstractMatrix, ::HermOrSymTri, ::HermOrSymTri)
    error()
end

function LinearAlgebra.mul!(C::Permutation, A::Permutation, B::Permutation)
    @boundscheck size(C, 2) == size(A, 2) == size(B, 1) || throw(DimensionMismatch())

    @inbounds for i in axes(C, 1)
        j = C.perm[i] = B.perm[A.perm[i]]
        C.invp[j] = i
    end

    return C
end

function LinearAlgebra.mul!(C::AbstractMatrix{T}, A::Permutation, B::Permutation) where {T}
    @boundscheck size(C, 1) == size(C, 2) == size(A, 1) == size(B, 1) || throw(DimensionMismatch())
    fill!(C, zero(T))

    @inbounds for i in axes(C, 1)
        C[i, B.perm[A.perm[i]]] = one(T)
    end

    return C
end
# ============================== mul_impl! ==============================
#
# The multiply is a blocked right-looking triangular product, the dual of the
# division solve. Applying the factor scatters L₂₁ C₁ onto the separator and is
# traversed root → leaves (so a separator slot is written only after it has been
# consumed); applying its adjoint gathers from the separator and is traversed
# leaves → root. As in the solve, `piv` restricts each front to its full-rank
# part and projects the null residual to zero.
#

function mul_impl!(
        B::AbstractVecOrMat{R},
        W::MultiplicationWorkspace{R},
        L::ChordalTriangular{DIAG, UPLO, T, I},
        tA::Val{TA},
        tB::Val{TB},
        side::Val{SIDE},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, DIAG, UPLO, TA, TB, SIDE, PIV}
    return mul_impl!(B, W.Mval, L, tA, tB, side, piv)
end

function mul_impl!(
        B::AbstractVecOrMat{R},
        Mval::AbstractVector{R},
        L::ChordalTriangular{DIAG, UPLO, T, I},
        tA::Val{TA},
        tB::Val{TB},
        side::Val{SIDE},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, DIAG, UPLO, TA, TB, SIDE, PIV}
    return mul_impl!(
        B, Mval,
        L.S.Dptr, L.Dval,
        L.S.Lptr, L.Lval,
        L.S.res, L.S.sep,
        tA, tB, L.uplo, side, L.diag, piv)
end

function mul_impl!(
        B::AbstractVecOrMat{R},
        Mval::AbstractVector{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}

    if B isa AbstractVector
        nrhs = one(I)
    elseif SIDE === :L
        nrhs = convert(I, size(B, 2))
    else
        nrhs = convert(I, size(B, 1))
    end

    if isforward(UPLO, TA, SIDE)
        for j in Iterators.reverse(vertices(res))
            mul_fwd_loop!(B, Mval, Dptr, Dval, Lptr, Lval, res, sep, nrhs, j, tA, tB, uplo, side, diag, piv)
        end
    else
        for j in vertices(res)
            mul_bwd_loop!(B, Mval, Dptr, Dval, Lptr, Lval, res, sep, nrhs, j, tA, tB, uplo, side, diag, piv)
        end
    end

    return B
end

function mul_fwd_loop!(
        C::AbstractVecOrMat{R},
        Mval::AbstractVector{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        nrhs::I,
        j::I,
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}

    nn = eltypedegree(res, j)

    if T <: Real && isone(nn)
        return mul_fwd_loop_nod!(
            C, Dptr, Dval,
            Lptr, Lval,
            res, sep, nrhs, j, tA, tB, uplo, side, diag, piv
        )
    else
        return mul_fwd_loop_snd!(
            C, Mval, Dptr, Dval,
            Lptr, Lval,
            res, sep, nrhs, nn, j, tA, tB, uplo, side, diag, piv
        )
    end
end

function mul_fwd_loop_snd!(
        C::AbstractVecOrMat{R},
        Mval::AbstractVector{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        nrhs::I,
        nn::I,
        j::I,
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(sep, j)
    Dp = Dptr[j]
    Lp = Lptr[j]
    #
    # L is part of the factor
    #
    #          res(j)
    #     L = [ D₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # determine the rank of D₁₁
    #
    if PIV
        rank = one(I)

        @inbounds while rank ≤ nn && ispositive(D₁₁[rank, rank])
            rank += one(I)
        end

        rank -= one(I)
    else
        rank = nn
    end
    #
    # extract the full-rank submatrix of D₁₁:
    #
    #   D₁₁ = [ rD₁₁   ]
    #         [      0 ]
    #
    rD₁₁ = view(D₁₁, oneto(rank), oneto(rank))
    #
    # extract the full-rank submatrix of L₂₁:
    #
    #   L₂₁ = [ rL₂₁ 0 ]
    #
    if UPLO === :L
        rL₂₁ = view(L₂₁, oneto(na), oneto(rank))
    else
        rL₂₁ = view(L₂₁, oneto(rank), oneto(na))
    end
    #
    # C₁ is part of the right-hand side
    #
    #   C = [ C₁  ] res(j)
    #       [ C₂  ] sep(j)
    #
    #     = [ rC₁ ]
    #       [ nC₁ ]
    #       [  C₂ ]
    #
    if C isa AbstractVector
        C₁ = view(C, neighbors(res, j))
        rC₁ = view(C₁,      oneto(rank))
        nC₁ = view(C₁, rank + one(I):nn)
    elseif SIDE === :L
        C₁ = view(C, neighbors(res, j), oneto(nrhs))
        rC₁ = view(C₁, oneto(rank),      oneto(nrhs))
        nC₁ = view(C₁, rank + one(I):nn, oneto(nrhs))
    else
        C₁ = view(C, oneto(nrhs), neighbors(res, j))
        rC₁ = view(C₁, oneto(nrhs),      oneto(rank))
        nC₁ = view(C₁, oneto(nrhs), rank + one(I):nn)
    end

    if ispositive(na) && ispositive(rank)
        #
        # M₂ is the update to the separator part of the right-hand side
        #
        if C isa AbstractVector
            M₂ = view(Mval, oneto(na))
        elseif SIDE === :L
            M₂ = reshape(view(Mval, oneto(na * nrhs)), na, nrhs)
        else
            M₂ = reshape(view(Mval, oneto(na * nrhs)), nrhs, na)
        end
        #
        #     M₂ ← rL₂₁ rC₁
        #
        if C isa AbstractVector
            if UPLO === :L
                gemv!(Val(:N), one(R), rL₂₁, rC₁, zero(R), M₂)
            else
                gemv!(tA, one(R), rL₂₁, rC₁, zero(R), M₂)
            end
        elseif SIDE === :L
            if UPLO === :L
                gemm!(Val(:N), tB, one(R), rL₂₁, rC₁, zero(R), M₂)
            else
                gemm!(tA, tB, one(R), rL₂₁, rC₁, zero(R), M₂)
            end
        else
            if UPLO === :L
                gemm!(tB, tA, one(R), rC₁, rL₂₁, zero(R), M₂)
            else
                gemm!(tB, Val(:N), one(R), rC₁, rL₂₁, zero(R), M₂)
            end
        end
        #
        #     C₂ ← C₂ + M₂
        #
        if C isa AbstractVector
            addscatterrec!(C, M₂, neighbors(sep, j))
        else
            addscatterrec!(C, M₂, neighbors(sep, j), side)
        end
    end
    #
    #     rC₁ ← rD₁₁ rC₁
    #
    if ispositive(rank)
        if C isa AbstractVector
            trmv!(uplo,       tA, diag,         rD₁₁, rC₁)
        else
            trmm!(side, uplo, tA, diag, one(R), rD₁₁, rC₁)
        end
    end
    #
    #     nC₁ ← 0
    #
    PIV && zerorec!(nC₁)

    return
end

# Fast path for nn = 1 (residual size is 1)
# In this case, diagonal blocks are scalars and off-diagonal blocks are vectors
function mul_fwd_loop_nod!(
        C::AbstractVecOrMat{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        nrhs::I,
        j::I,
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(sep, j)
    #
    # L is part of the factor (d₁₁ is scalar, l₂₁ is vector)
    #
    #          res(j)
    #     L = [ d₁₁  ] res(j)
    #         [ l₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    Rp = pointers(res)[j]
    Sp = pointers(sep)[j]
    d₁₁ = Dval[Dp]
    #
    #     c₂ ← c₂    + l₂₁ c₁
    #     c₁ ←      d₁₁    c₁   (c₁ ← 0 if d₁₁ is not positive)
    #
    if PIV && !ispositive(d₁₁)
        if C isa AbstractVector
            C[Rp] = zero(R)
        elseif SIDE === :L
            @inbounds for k in oneto(nrhs)
                C[Rp, k] = zero(R)
            end
        else
            @inbounds for k in oneto(nrhs)
                C[k, Rp] = zero(R)
            end
        end

        return
    end

    if C isa AbstractVector
        c₁ = C[Rp]

        @inbounds for i in oneto(na)
            l =         Lval[Lp + i - one(I)]
            s = targets(sep)[Sp + i - one(I)]

            C[s] += l * c₁
        end

        DIAG === :N && (C[Rp] = d₁₁ * c₁)
    elseif SIDE === :L
        @inbounds for i in oneto(na)
            l =         Lval[Lp + i - one(I)]
            s = targets(sep)[Sp + i - one(I)]

            for k in oneto(nrhs)
                C[s, k] += l * C[Rp, k]
            end
        end

        if DIAG === :N
            @inbounds for k in oneto(nrhs)
                C[Rp, k] *= d₁₁
            end
        end
    else
        @inbounds for i in oneto(na)
            l =         Lval[Lp + i - one(I)]
            s = targets(sep)[Sp + i - one(I)]

            @simd for k in oneto(nrhs)
                C[k, s] += l * C[k, Rp]
            end
        end

        if DIAG === :N
            @inbounds for k in oneto(nrhs)
                C[k, Rp] *= d₁₁
            end
        end
    end

    return
end

function mul_bwd_loop!(
        C::AbstractVecOrMat{R},
        Mval::AbstractVector{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        nrhs::I,
        j::I,
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}

    nn = eltypedegree(res, j)

    if T <: Real && isone(nn)
        return mul_bwd_loop_nod!(
            C, Dptr, Dval,
            Lptr, Lval,
            res, sep, nrhs, j, tA, tB, uplo, side, diag, piv
        )
    else
        return mul_bwd_loop_snd!(
            C, Mval, Dptr, Dval,
            Lptr, Lval,
            res, sep, nrhs, nn, j, tA, tB, uplo, side, diag, piv
        )
    end
end

function mul_bwd_loop_snd!(
        C::AbstractVecOrMat{R},
        Mval::AbstractVector{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        nrhs::I,
        nn::I,
        j::I,
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(sep, j)
    Dp = Dptr[j]
    Lp = Lptr[j]
    #
    # L is part of the factor
    #
    #          res(j)
    #     L = [ D₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # determine the rank of D₁₁
    #
    if PIV
        rank = one(I)

        @inbounds while rank ≤ nn && ispositive(D₁₁[rank, rank])
            rank += one(I)
        end

        rank -= one(I)
    else
        rank = nn
    end
    #
    # extract the full-rank submatrix of D₁₁:
    #
    #   D₁₁ = [ rD₁₁   ]
    #         [      0 ]
    #
    rD₁₁ = view(D₁₁, oneto(rank), oneto(rank))
    #
    # extract the full-rank submatrix of L₂₁:
    #
    #   L₂₁ = [ rL₂₁ 0 ]
    #
    if UPLO === :L
        rL₂₁ = view(L₂₁, oneto(na), oneto(rank))
    else
        rL₂₁ = view(L₂₁, oneto(rank), oneto(na))
    end
    #
    # C₁ is part of the right-hand side
    #
    #   C = [ C₁  ] res(j)
    #       [ C₂  ] sep(j)
    #
    #     = [ rC₁ ]
    #       [ nC₁ ]
    #       [  C₂ ]
    #
    if C isa AbstractVector
        C₁ = view(C, neighbors(res, j))
        rC₁ = view(C₁,      oneto(rank))
        nC₁ = view(C₁, rank + one(I):nn)
    elseif SIDE === :L
        C₁ = view(C, neighbors(res, j), oneto(nrhs))
        rC₁ = view(C₁, oneto(rank),      oneto(nrhs))
        nC₁ = view(C₁, rank + one(I):nn, oneto(nrhs))
    else
        C₁ = view(C, oneto(nrhs), neighbors(res, j))
        rC₁ = view(C₁, oneto(nrhs),      oneto(rank))
        nC₁ = view(C₁, oneto(nrhs), rank + one(I):nn)
    end
    #
    #     rC₁ ← rD₁₁ᴴ rC₁
    #
    if ispositive(rank)
        if C isa AbstractVector
            trmv!(uplo,       tA, diag,         rD₁₁, rC₁)
        else
            trmm!(side, uplo, tA, diag, one(R), rD₁₁, rC₁)
        end
    end
    #
    #     nC₁ ← 0
    #
    PIV && zerorec!(nC₁)

    if ispositive(na) && ispositive(rank)
        #
        # M₂ is the separator part of the right-hand side
        #
        if C isa AbstractVector
            M₂ = view(Mval, oneto(na))
        elseif SIDE === :L
            M₂ = reshape(view(Mval, oneto(na * nrhs)), na, nrhs)
        else
            M₂ = reshape(view(Mval, oneto(na * nrhs)), nrhs, na)
        end
        #
        #     M₂ ← C₂
        #
        if C isa AbstractVector
            copygatherrec!(M₂, C, neighbors(sep, j))
        else
            copygatherrec!(M₂, C, neighbors(sep, j), side)
        end
        #
        #     rC₁ ← rC₁ + rL₂₁ᴴ M₂
        #
        if C isa AbstractVector
            if UPLO === :L
                gemv!(tA, one(R), rL₂₁, M₂, one(R), rC₁)
            else
                gemv!(Val(:N), one(R), rL₂₁, M₂, one(R), rC₁)
            end
        elseif SIDE === :L
            if UPLO === :L
                gemm!(tA, Val(:N), one(R), rL₂₁, M₂, one(R), rC₁)
            else
                gemm!(Val(:N), Val(:N), one(R), rL₂₁, M₂, one(R), rC₁)
            end
        else
            if UPLO === :L
                gemm!(Val(:N), Val(:N), one(R), M₂, rL₂₁, one(R), rC₁)
            else
                gemm!(Val(:N), tA, one(R), M₂, rL₂₁, one(R), rC₁)
            end
        end
    end

    return
end

function mul_bwd_loop_nod!(
        C::AbstractVecOrMat{R},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        nrhs::I,
        j::I,
        tA::Val{TA},
        tB::Val{TB},
        uplo::Val{UPLO},
        side::Val{SIDE},
        diag::Val{DIAG},
        piv::Val{PIV} = Val(false),
    ) where {T, R, I <: Integer, TA, TB, UPLO, SIDE, DIAG, PIV}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(sep, j)
    #
    # L is part of the factor (d₁₁ is scalar, l₂₁ is vector)
    #
    #          res(j)
    #     L = [ d₁₁  ] res(j)
    #         [ l₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    Rp = pointers(res)[j]
    Sp = pointers(sep)[j]
    d₁₁ = Dval[Dp]
    #
    #     c₁ ←      d₁₁ᴴ  c₁   (c₁ ← 0 if d₁₁ is not positive)
    #     c₁ ← c₁    + l₂₁ᴴ c₂
    #
    if PIV && !ispositive(d₁₁)
        if C isa AbstractVector
            C[Rp] = zero(R)
        elseif SIDE === :L
            @inbounds for k in oneto(nrhs)
                C[Rp, k] = zero(R)
            end
        else
            @inbounds for k in oneto(nrhs)
                C[k, Rp] = zero(R)
            end
        end

        return
    end

    if C isa AbstractVector
        DIAG === :N && (C[Rp] *= d₁₁)

        Δ = zero(R)

        @inbounds for i in oneto(na)
            l =         Lval[Lp + i - one(I)]
            s = targets(sep)[Sp + i - one(I)]

            Δ += l * C[s]
        end

        C[Rp] += Δ
    elseif SIDE === :L
        if DIAG === :N
            @inbounds for k in oneto(nrhs)
                C[Rp, k] *= d₁₁
            end
        end

        @inbounds for i in oneto(na)
            l =         Lval[Lp + i - one(I)]
            s = targets(sep)[Sp + i - one(I)]

            for k in oneto(nrhs)
                C[Rp, k] += l * C[s, k]
            end
        end
    else
        if DIAG === :N
            @inbounds for k in oneto(nrhs)
                C[k, Rp] *= d₁₁
            end
        end

        @inbounds for i in oneto(na)
            l =         Lval[Lp + i - one(I)]
            s = targets(sep)[Sp + i - one(I)]

            @simd for k in oneto(nrhs)
                C[k, Rp] += l * C[k, s]
            end
        end
    end

    return
end

# ================================ mul!! =================================

# C is a workspace. Returns B.
function mul!!(C::AbstractVecOrMat, F::AbstractFactorization, B::AbstractVecOrMat)
    ldiv!(B, F.P, lmul!(NaturalFactorization(F), mul!(C, F.P, B)))
end

# C is a workspace. Returns B.
function mul!!(C::AbstractVecOrMat, B::AbstractVecOrMat, F::AbstractFactorization)
    mul!(B, rmul!(rdiv!(C, B, F.P), NaturalFactorization(F)), F.P)
end

#**********************************************************************
#**********************************************************************
#*****   MFINIT_DEF ... W-H INITIAL DEFICIENCIES   ********************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       THIS SUBROUTINE COMPUTES INITIAL DEFICIENCIES.  IT INITIALIZES
#       AN EMPTY GRAPH, AND THEN IT ADDS THE EDGES OF THE COMPRESSED
#       GRAPH TO THE GROWING GRAPH, PERFORMING WING-HUANG UPDATES AS
#       IT GOES.
#
#     INPUT PARAMETERS:
#       NEQNS       - NUMBER OF EQUATIONS.
#       ADJLEN      - LENGTH OF ADJNCY(*).
#       ADJLEN2     - LENGTH OF ADJ2(*).
#       XADJ(*)     - ARRAY OF LENGTH NEQNS+1, CONTAINING POINTERS
#                     TO THE ADJACENCY STRUCTURE OF THE COMPRESSED
#                     GRAPH.
#       ADJNCY(*)   - ARRAY OF LENGTH ADJLEN, CONTAINING THE
#                     ADACENCY STRUCTURE OF THE COMPRESSED GRAPH.
#       DEGREE(*)   - ARRAY OF LENGTH NEQNS, CONTAINING THE DEGREE
#                     OF EACH REPRESENTATIVE NODE IN THE ORIGINAL 
#                     GRAPH, PLUS ONE.
#       QSIZE(*)    - SUPERNODE SIZE:
#                        0 -  ABSORBED VERTEX
#                       >0 -  SUPERNODE SIZE OF A REPRESENTATIVE
#                             VERTEX
#
#     OUTPUT PARAMETERS:
#       DEFNCY(*)   - ARRAY OF LENGTH NEQNS, CONTAINING THE EXACT 
#                     DEFICIENCY OF EACH REPRESENTATIVE NODE IN THE
#                     INITIAL COMPRESSED GRAPH.  SINCE A DEFICIENCY 
#                     VALUE CAN BE VERY LARGE, THIS ARRAY IS OF
#                     TYPE LONG INTEGER (INTEGER*8).
#       
#     WORKING PARAMETERS:
#       MARKER(*)   - ARRAY OF LENGTH NEQNS, USED FOR A MARKING
#                     PROCESS IN THIS ROUTINE.
#       DHEAD(*)    - ARRAY OF LENGTH NEQNS, HEADS OF THE DEGREE 
#                     LISTS.
#       DFORW(*)    - ARRAY OF LENGTH NEQNS, FORWARD LINKS FOR THE 
#                     SINGLY-LINKED DEGREE LISTS.
#       DEGTMP(*)   - ARRAY OF LENGTH NEQNS, MAINTAINS THE DEGREE
#                     IN THE DYNAMICALLY GROWING GRAPH WHERE EDGES
#                     ARE ADDED FOR THE REQUIRED WH UPDATES.
#       XADJ2(*)    - ARRAY OF LENGTH NEQNS, CONTAINS THE POINTERS
#                     TO THE TO GROWING ADJACENCY LISTS.
#       LEN2(*)     - ARRAY OF LENGTH NEQNS, CONTAINS THE LENGTHS
#                     OF THE GROWING ADJACENCY LISTS.
#       ADJ2(*)     - ARRAY OF LENGTH ADJLEN2, CONTAINS THE GROWING
#                     ADJACENCY LISTS.
#
#**********************************************************************
#
function mfinit_def(
        neqns::V,
        adjlen::E,
        adjlen2::E,
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
        degree::AbstractVector{W},
        qsize::AbstractVector{W},
        defncy::AbstractVector{W},
        marker::AbstractVector{I},
        dhead::AbstractVector{V},
        dforw::AbstractVector{V},
        degtmp::AbstractVector{W},
        xadj2::AbstractVector{E},
        len2::AbstractVector{V},
        adj2::AbstractVector{V}
    ) where {V, E, I, W}
    
    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    
    #       -----------------------------------------
    #       INITIALIZE MARKER VECTOR AND EMPTY LISTS.
    #       -----------------------------------------
    for jnode in oneto(neqns)
        dhead[jnode] = zero(V)

        if !iszero(qsize[jnode])
            marker[jnode] = zero(I)
        end
    end

    #       --------------------------------------------------
    #       INITIALIZE ZERO DEFICIENCY SCORES AND EMPTY GRAPH.
    #       --------------------------------------------------
    tag = zero(I)

    for jnode in oneto(neqns)
        if !iszero(qsize[jnode])
            xadj2[jnode] = xadj[jnode]
            len2[jnode] = zero(V)
            defncy[jnode] = zero(W)
            degtmp[jnode] = zero(W)
        end
    end

    #       -------------------------
    #       FOR EACH VERTEX JNODE ...
    #       -------------------------
    maxdeg = zero(V)

    for jnode = oneto(neqns)
        #           ---------------------------------------
        #           IF JNODE IS A REPRESENTATIVE VERTEX ...
        #           ---------------------------------------
        if !iszero(qsize[jnode])
            #               ---------------------------------------------
            #               COMPUTE JNODE'S NUMBER OF NEIGHBORS IN THE
            #               COMPRESSED GRAPH AND PLACE IT IN DEGREE LIST.
            #               ---------------------------------------------
            degre = convert(V, xadj[jnode + one(V)] - xadj[jnode])
            maxdeg = max(maxdeg, degre)
            degp1 = degre + one(V)
            nxtnod = dhead[degp1]
            dforw[jnode] = nxtnod
            dhead[degp1] = jnode
        end
    end

    #       *********************************************************
    #       BUILD THE GRAPH FROM SCRATCH WHILE COMPUTING DEFICIENCIES
    #       USING WING-HUANG UPDATING.
    #       *********************************************************

    #       -------------------------------------------------------
    #       DO WHILE THERE ARE VERTICES WHOSE EDGES ARE YET TO BE
    #       ADDED TO THE ADJACENCY STRUCTURE UNDER CONSTRUCTION ...
    #       -------------------------------------------------------
    while ispositive(maxdeg)

        #           ----------------------------------------------
        #           GET VERTEX UNODE OF MAXIMUM DEGREE WHOSE EDGES
        #           HAVE NOT YET BEEN ADDED TO THE NEW GRAPH.
        #           ----------------------------------------------
        degp1 = maxdeg + one(V)
        unode = dhead[degp1]

        if iszero(unode)
            maxdeg -= one(V)
        else
            
            #               ----------------------------------
            #               REMOVE UNODE FROM ITS DEGREE LIST.
            #               ----------------------------------
            nxtnod = dforw[unode]
            dhead[degp1] = nxtnod
            
            #               ------------------------------------------
            #               MARK THE NEIGHBORS OF UNODE IN THE CURRENT
            #               TRANSIENT GRAPH.
            #               ------------------------------------------
            tag += one(I)

            for w in xadj2[unode]:xadj2[unode] + convert(E, len2[unode]) - one(E)
                wnode = adj2[w]
                marker[wnode] = tag
            end

            #               ----------------------------------------------------
            #               FOR EACH NEIGHBOR OF UNODE TO BE ADDED AS A NEIGHBOR
            #               IN THE NEW GRAPH ...
            #               ----------------------------------------------------
            for w in xadj[unode]:xadj[unode + one(V)] - one(E)
                wnode = adjncy[w]

                if marker[wnode] < tag

                    #                       ----------------------------------------
                    #                       INITIALIZE COUNTS USED FOR W-H UPDATING.
                    #                       ----------------------------------------
                    ucount = degtmp[unode]
                    cntu = ucount
                    cntw = zero(W)
                    uwfill = qsize[unode] * qsize[wnode]

                    #                       --------------------------------------------
                    #                       PERFORM WING-HUANG UPDATES FOR THE NEW EDGE.
                    #                       --------------------------------------------
                    for x in xadj2[wnode]:xadj2[wnode] + convert(E, len2[wnode]) - one(E)
                        xnode = adj2[x]

                        if marker[xnode] == tag
                            defncy[xnode] -= uwfill
                            cntu -= qsize[xnode]
                        else
                            cntw += qsize[xnode]
                        end
                    end

                    defncy[unode] += cntu * qsize[wnode]
                    defncy[wnode] += cntw * qsize[unode]

                    #                       ---------------------------------------
                    #                       ADD THE EDGE JOINING UNODE AND WNODE TO
                    #                       THE GRAPH (AND UPDATE DEGREES IN THE
                    #                       TRANSIENT GRAPH).
                    #                       ---------------------------------------
                    adj2[xadj2[unode] + convert(E, len2[unode])] = wnode
                    len2[unode] += one(V)

                    adj2[xadj2[wnode] + convert(E, len2[wnode])] = unode
                    len2[wnode] += one(V)
                    
                    degtmp[wnode] += qsize[unode]
                    degtmp[unode] += qsize[wnode]
                    
                    #                       --------------------------------------------
                    #                       MARK WNODE AS A NEW NEIGHBOR OF UNODE IN G'.
                    #                       --------------------------------------------
                    marker[wnode] = tag
                    
                end
                #                   -----------
                #                   NEXT WNODE.
                #                   -----------
            end
        end
        #           -----------
        #           NEXT UNODE.
        #           -----------
    end
    
    return
end

module TreeWidthSolverExt

using CliqueTrees
using Graphs
using TreeWidthSolver: TreeWidthSolver

function CliqueTrees.permutation(graph, alg::BT)
    return permutation(BipartiteGraph(graph), alg)
end

function CliqueTrees.permutation(graph::AbstractGraph{V}, alg::BT) where {V}
    graph = Graph{Int}(graph)

    for v in vertices(graph)
        rem_edge!(graph, v, v)
    end

    order::Vector{V} = reverse!(reduce(vcat, TreeWidthSolver.elimination_order(graph); init = Int[]))
    return order, invperm(order)
end

function CliqueTrees.permutation(weights::AbstractVector, graph, alg::BT)
    return permutation(weights, BipartiteGraph(graph), alg)
end

function CliqueTrees.permutation(weights::AbstractVector, graph::AbstractGraph{V}, alg::BT) where {V}
    return permutation(collect(weights), graph, alg)
end

function CliqueTrees.permutation(weights::Vector, graph::AbstractGraph{V}, alg::BT) where {V}
    graph = Graph{Int}(graph)

    for v in vertices(graph)
        rem_edge!(graph, v, v)
    end

    order::Vector{V} = reverse!(reduce(vcat, TreeWidthSolver.elimination_order(graph; weights); init = Int[]))
    return order, invperm(order)
end

end

"""
    LDLTWork{T, I}

A workspace for the function [`ldlt!`](@ref).
"""
struct LDLTWork{T, I}
    updptr::FVector{I}
    nzval1::FVector{T}
    nzval2::FVector{T}
    updval::FVector{T}
    frtval::FVector{T}
    wrkval::FVector{T}
    pattern1::BipartiteGraph{I, I, FVector{I}, FVector{I}}
    pattern2::BipartiteGraph{I, I, FVector{I}, FVector{I}} 
end

"""
    ldltinit([T::Type, ]matrix::AbstractMatrix, symbfact::SymbFact)

Initialize an LDLt factor and a factorization workspace.

```julia-repl
julia> import CliqueTrees

julia> matrix = [
           3 1 0 0 0 0 0 0
           1 3 1 0 0 2 0 0
           0 1 3 1 0 1 2 1
           0 0 1 3 0 0 0 0
           0 0 0 0 3 1 1 0
           0 2 1 0 1 3 0 0
           0 0 2 0 1 0 3 1
           0 0 1 0 0 0 1 3
       ];

julia> symbfact = CliqueTrees.symbolic(matrix)
SymbFact{Int64}:
    nnz: 19

julia> ldltfact, ldltwork = CliqueTrees.ldltinit(matrix, symbfact);
```

### Parameters

  - `T`: element type (optional)
  - `matrix`: sparse quasi definite matrix
  - `symbfact`: symbolic factorization
"""
function ldltinit(matrix::AbstractMatrix{T}, symbfact::SymbFact) where {T}
    return ldltinit(T, matrix, symbfact)
end

function ldltinit(matrix::AbstractMatrix{T}, symbfact::SymbFact) where {T <: Integer}
    return ldltinit(float(T), matrix, symbfact)
end

function ldltinit(::Type{T}, matrix::AbstractMatrix, symbfact::SymbFact) where {T}
    return ldltinit(T, sparse(matrix), symbfact)
end

function ldltinit(::Type{T}, matrix::SparseMatrixCSC{<:Any, I}, symbfact::SymbFact{I}) where {T, I}
    @assert size(matrix, 1) == size(matrix, 2)
    @assert size(matrix, 1) == nov(separators(symbfact.tree))

    tree = symbfact.tree
    separator = separators(tree)

    adjln = symbfact.adjln
    blkln = symbfact.blkln
    njmax = symbfact.njmax
    nsmax = symbfact.nsmax
    upmax = symbfact.upmax

    neqns = nov(separator)
    treln = nv(separator)
    relln = ne(separator)
    frtln = njmax * njmax

    colptr1 = FVector{I}(undef, neqns + one(I))
    colptr2 = FVector{I}(undef, neqns + one(I))
    blkptr  = FVector{I}(undef, treln + one(I))
    updptr  = FVector{I}(undef, nsmax + one(I))
    relptr = pointers(separator)

    rowval1 = FVector{I}(undef, adjln)
    rowval2 = FVector{I}(undef, adjln)
    relidx  = FVector{I}(undef, relln)

    nzval1 = FVector{T}(undef, adjln)
    nzval2 = FVector{T}(undef, adjln)
    blkval = FVector{T}(undef, blkln)
    diaval = FVector{T}(undef, neqns)
    updval = FVector{T}(undef, upmax)
    frtval = FVector{T}(undef, frtln)
    wrkval = FVector{T}(undef, frtln)

    status = FScalar{Bool}(undef)

    mapping = BipartiteGraph(njmax, treln, relln, relptr, relidx)
    pattern1 = BipartiteGraph(neqns, neqns, adjln, colptr1, rowval1)
    pattern2 = BipartiteGraph(neqns, neqns, adjln, colptr2, rowval2)

    ldltfact = LDLTFact{T, I}(symbfact, blkptr, blkval, diaval, status, mapping) 
    ldltwork = LDLTWork{T, I}(updptr, nzval1, nzval2, updval, frtval, wrkval, pattern1, pattern2)
    return ldltfact, ldltwork
end

function Base.show(io::IO, ::MIME"text/plain", ldltwork::LDLTWork{T, I}) where {T, I}
    print(io, "LDTWork{$T, $I}:")
end

"""
    SE99{T} <: AbstractRegularization

The Schnabel-Eskow 1999 modified Cholesky algorithm.

### Example

```julia-repl
julia> using CliqueTrees.Multifrontal, LinearAlgebra

julia> A = [
           1 1 2
           1 1 3
           2 3 1
       ];

julia> isposdef(A)
false

julia> F = cholesky!(ChordalCholesky(A); reg=SE99());

julia> B = Matrix(F)
3×3 Matrix{Float64}:
 3.0  1.0  2.0
 1.0  3.0  3.0
 2.0  3.0  3.375

julia> isposdef(B)
true
```

### Fields

- `gammapos`: maximum diagonal element for positive pivots
- `gammaneg`: maximum diagonal element for negative pivots
- `epsilon`: pivot tolerance
- `mu`: lookahead parameter
"""
struct SE99{T} <: AbstractRegularization
    gammapos::T
    gammaneg::T
    epsilon::T
    mu::T
end

function SE99{T}(; gammapos=-one(T), gammaneg=-one(T), epsilon=-one(T), mu=-one(T)) where {T}
    return SE99{T}(gammapos, gammaneg, epsilon, mu)
end

function SE99(; kw...)
    return SE99{Float64}(; kw...)
end

function initialize(A::AbstractMatrix{T}, S::AbstractVector, R::SE99) where {T}
    if isnegative(R.gammapos)
        gammapos = se99_gamma(A, S, 1)
    else
        gammapos = convert(real(T), R.gammapos)
    end

    if isnegative(R.gammaneg)
        gammaneg = se99_gamma(A, S, -1)
    else
        gammaneg = convert(real(T), R.gammaneg)
    end

    if isnegative(R.epsilon)
        epsilon = se99_epsilon(real(T))
    else
        epsilon = convert(real(T), R.epsilon)
    end

    if isnegative(R.mu)
        mu = se99_mu(real(T))
    else
        mu = convert(real(T), R.mu)
    end

    return SE99{real(T)}(gammapos, gammaneg, epsilon, mu)
end

function se99_gamma(A::ChordalTriangular{DIAG, UPLO, T}, S::AbstractVector, s::Real) where {DIAG, UPLO, T}
    out = eps(real(T))

    @inbounds for j in fronts(A)
        D, res = diagblock(A, j)
        out = max(out, se99_gamma(D, view(S, res), s))
    end

    return out
end

function se99_gamma(A::AbstractMatrix{T}, S::AbstractVector, s::Real) where {T}
    out = eps(real(T))

    @inbounds for (r, i) in zip(S, diagind(A))
        if real(r) == s
            out = max(out, abs(parent(A)[i]))
        end
    end

    return out
end

function se99_gamma(R::SE99, s::Real)
    if isone(s)
        return R.gammapos
    elseif isone(-s)
        return R.gammaneg
    else
        error()
    end
end

function se99_epsilon(::Type{T}) where {T}
    return cbrt(eps(real(T)))^2
end

function se99_mu(::Type{T}) where {T}
    return convert(real(T), 0.1)
end

function checkdiag(
        R::SE99,
        S₁::AbstractVector{T},
        S₂::AbstractVector{T},
        d₁::AbstractVector{T},
        d₂::AbstractVector{T},
        Djj::Real,
        j::Integer,
    ) where {T}
    gamma = se99_gamma(R, real(S₁[j]))

    if Djj < R.epsilon * gamma
        return false
    end

    minval = Djj

    for i in j:length(d₁)
        minval = min(minval, real(S₁[i]) * real(d₁[i]))
    end

    for i in eachindex(d₂)
        minval = min(minval, real(S₂[i]) * real(d₂[i]))
    end

    return minval >= -R.mu * Djj
end

function lookahead(
        R::SE99,
        S₁::AbstractVector{T},
        S₂::AbstractVector{T},
        L₁::AbstractMatrix{T},
        L₂::AbstractMatrix{T},
        d₁::AbstractVector{T},
        d₂::AbstractVector{T},
        j::Integer,
        ::Val{UPLO},
    ) where {T, UPLO}

    Djj = real(d₁[j])

    for i in j + 1:length(d₁)
        Sii = real(S₁[i])
        gamma = se99_gamma(R, Sii)

        if UPLO === :L
            ζii = real(d₁[i]) - abs2(L₁[i, j]) / Djj
        else
            ζii = real(d₁[i]) - abs2(L₁[j, i]) / Djj
        end

        if Sii * ζii < -R.mu * gamma
            return false
        end
    end

    for i in eachindex(d₂)
        Sii = real(S₂[i])
        gamma = se99_gamma(R, Sii)

        if UPLO === :L
            ζii = real(d₂[i]) - abs2(L₂[i, j]) / Djj
        else
            ζii = real(d₂[i]) - abs2(L₂[j, i]) / Djj
        end

        if Sii * ζii < -R.mu * gamma
            return false
        end
    end

    return true
end

function regularize(
        R::SE99,
        S::AbstractVector,
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        Djj::Real,
        j::Integer,
        deltapos::Real,
        deltaneg::Real,
        ::Val{UPLO},
    ) where {T, UPLO}
    bound = zero(real(T))
    gamma = se99_gamma(R, real(S[j]))

    if UPLO === :L
        for i in j + 1:size(D, 1)
            bound += abs(D[i, j])
        end

        for i in axes(L, 1)
            bound += abs(L[i, j])
        end
    else
        for i in j + 1:size(D, 1)
            bound += abs(D[j, i])
        end

        for i in axes(L, 2)
            bound += abs(L[j, i])
        end
    end

    # Select delta based on sign class
    if real(S[j]) > 0
        delta = deltapos
    else
        delta = deltaneg
    end

    δj = max(zero(real(T)), -real(S[j]) * Djj + max(bound, R.epsilon * gamma), delta)

    if ispositive(δj)
        Djj = Djj + real(S[j]) * δj
    end

    # Update only the relevant delta
    if real(S[j]) > 0
        return Djj, δj, deltaneg
    else
        return Djj, deltapos, δj
    end
end

# Safe separator detection and recombination.
# All vertex indices are 1-based.

# ==================== Apply Safe Separator ====================

"""
    apply_externally_found_safe_separator!(weights, graph, S, min_k, already_calc_component)

Separate the graph at a separator found externally (e.g. during HasTreeWidth).
Returns `(subgraphs, already_calculated_C_index, min_k)`.
"""
function apply_externally_found_safe_separator!(
    weights::Vector{Int}, graph::Graph{PSet}, S::PSet,
    min_k::Int, already_calc_component::PSet
) where {PSet}
    make_into_clique!(graph, S)

    # Separate, finding which subgraph contains the already-calculated component
    subgraphs = Graph{PSet}[]
    already_calc_idx = -1

    for (idx, (C, _)) in enumerate(components(graph, S))
        V = C ∪ S

        # Create subgraph with filtered neighborhoods
        subgraph = Graph(V)

        for v in V
            subgraph.neighbors[v] = neighbors(graph, v) ∩ V
        end
        make_into_clique!(subgraph, S)

        push!(subgraphs, subgraph)

        # Check if this component contains the already-calculated component
        if !isempty(already_calc_component) && !isdisjoint(C, already_calc_component)
            already_calc_idx = idx
        end
    end

    min_k = max(min_k, wt(weights, S))

    return (subgraphs, already_calc_idx, min_k)
end

# ==================== RecombineTreeDecompositions ====================

"""
    recombine_tree_decompositions(pool, S, roots)

Recombine tree decompositions from separated subgraphs into a single PTD.
`roots` is a vector/view of PTD root indices.
"""
function recombine_tree_decompositions(pool::PTDPool{PSet}, S::PSet, roots::AbstractVector{Int}) where {PSet}
    first_root = roots[1]
    rest = @view roots[2:end]

    # Find node whose bag contains the separator
    root = 0
    stack = Int[first_root]

    while !isempty(stack)
        current = pop!(stack)

        if bag(pool[current]) ⊇ S
            root = current
            empty!(stack)
            break
        end

        for p in incident(pool, current)
            push!(stack, target(pool, p))
        end
    end

    @assert root != 0 "No node found with bag ⊇ S"

    # Reroot the other tree decompositions and attach them at root
    for y_root in rest
        y_root = reroot!(pool, y_root, S)
        add_edge!(pool, root, y_root)
    end

    return first_root
end

# ==================== Articulation Points ====================

"""
    articulation_points(graph, V)

List all articulation points of the graph restricted to `V`.
Uses an iterative version of Tarjan's algorithm, faithfully transpiled from C#.

This method can also be used to test for separators of size n by passing a set
of n-1 vertices as ignored (removed from V), and combining the
result with the ignored vertices.
"""
function articulation_points(graph::Graph{PSet}, V::PSet=vertices(graph)) where {PSet}
    A = PSet()

    stack = Tuple{Int, Int, Int}[]
    count = Vector{Int}(undef, domain(V))
    reach = Vector{Int}(undef, domain(V))
    queue = Vector{PSet}(undef, domain(V))

    for v in V
        count[v] = typemax(Int)
    end

    u = first(V); count[u] = n = 0

    for v in neighbors(graph, u) ∩ V
        if count[v] == typemax(Int)
            push!(stack, (v, 1, u))        

            while !isempty(stack)
                (x, timer, w) = last(stack)

                if count[x] == typemax(Int)
                    count[x] = timer
                    reach[x] = timer
                    queue[x] = setdiff(neighbors(graph, x) ∩ V, w)
                elseif !isempty(queue[x])
                    y, queue[x] = popfirst_nonempty(queue[x])

                    if count[y] < typemax(Int)
                        reach[x] = min(reach[x], count[y])
                    else
                        push!(stack, (y, timer + 1, x))
                    end
                else
                    if x != v
                        reach[w] = min(reach[w], reach[x])

                        if reach[x] ≥ count[w]
                            A = A ∪ w
                        end
                    end

                    pop!(stack)
                end
            end

            n += 1
        end
    end

    if n > 1
        A = A ∪ u
    end

    return A
end

# ==================== Heuristic Safe Separator Test ====================

const MAX_MISSINGS = 100
const MAX_STEPS = 1000000

# ---------- Is Safe Separator (Heuristic) ----------

"""
    is_safe_separator_heuristic(graph, weights, S)

Test heuristically if a candidate separator is a safe separator.
If this method returns true, the separator is guaranteed safe.
False negatives are possible.
"""
function is_safe_separator_heuristic(weights::Vector{Int}, graph::Graph{PSet}, S::PSet) where {PSet}

    # count missing edges
    n = 0

    for v in S
        n += length(setdiff(S, neighbors(graph, v))) - 1
    end

    n > 2MAX_MISSINGS && return false

    isfirst = true

    for (C, N) in components(graph, S)
        isfirst && S ∪ C == vertices(graph) && return false
        isfirst = false
        find_clique_minor(weights, graph, N, setdiff(vertices(graph), N ∪ C)) || return false
    end

    return true
end

# ---------- Find Clique Minor ----------

# Try to determine if S is a labelled clique minor of the graph G[V].
# The following definition is taken from Bodlaender and Koster, "Safe
# Separators for Treewidth".
#
# Definition 9: A graph H is a *labelled minor* of G if H can be obtained
# from G by a sequence of zero or more of the following operations:
#
#   - deletion of edges
#   - deletion of vertices (and all adjacent edges)
#   - edge contraction that keeps the label of one endpoint: when contracting
#     the edge {v, w}, the resulting vertex will be labelled either v or w
#
# The function works by constructing a mapping D → S, where D ⊆ V, indicating
# which edges need to be contracted in order to make S into a clique. If such
# a mapping is found, the function returns `true`; otherwise, `false`.
function find_clique_minor(weights::Vector{Int}, graph::Graph{PSet}, S::PSet, V::PSet) where {PSet}
    # The vector `edges` contains all ordered nonadjacent vertices in S.
    # Each of these "missing edges" needs to be covered by the contraction
    # mapping D → S.
    edges = Tuple{Int, Int, Bool}[]

    # The vector `nodes` contains the contraction mapping D → S. Each element
    # is a triple (Dᵢ, Nᵢ, vᵢ), where vᵢ ∈ S is a vertex in the image of the
    # mapping, Dᵢ ⊆ D is its pre-image, and Nᵢ := N(Dᵢ) is the open neighborhood
    # of Dᵢ.
    nodes = Tuple{PSet, PSet, Int}[]

    # Find every ordered pair v < w of nonadjacent vertices in S and append
    # it to `edges`.
    R = S; E = PSet()

    while !isempty(R)
        v, R = popfirst_nonempty(R)

        for w in setdiff(R, neighbors(graph, v))
            push!(edges, (v, w, false))
            E = E ∪ v
            E = E ∪ w
        end
    end

    # Find every vertex v ∈ V with
    #
    #  - two or more neighbors, and
    #  - one or more neighbors which is an endpoint of a missing edge
    #
    # and append it to `nodes`.
    for w in E
        for v in neighbors(graph, w) ∩ V
            N = neighbors(graph, v)

            if length(N) > 1 && weights[v] >= weights[w]
                push!(nodes, (packedset(PSet, v), N, 0))
                V = setdiff(V, v)
            end
        end
    end

    # Halt early if `steps` exceeds `MAX_STEPS`.
    steps = 0

    # -- PHASE 1 ------------------------------------------------------
    #
    # A missing edge {w₁, w₂} is "zero-covered" if
    #
    #     {w₁, w₂} ⊈ N(D)
    #
    # for all vertex subsets D in `nodes`. For all such edges we search
    # for a pair of vertex subsets D₁ and D₂ in `nodes` such that
    #
    #   - w₁ ∈ N(D₁) and w₂ ∈ N(D₂),
    #   - w₂ ∉ N(D₁) and w₁ ∉ N(D₂), and
    #   - there exists a path P from D₁ to D₂ outside S and D.
    #
    # When such a pair is found, we remove D₁ and D₂ from `nodes`
    # and replace them with the union D₁ ∪ D₂ ∪ P. Note that D
    # also changes to D ∪ P. This new set now "covers" the missing
    # edge: if the set is contracted into either endpoint, the
    # missing edge will be introduced.
    i = find_zero_covered_edge(edges, nodes, weights)

    while !iszero(i)
        steps += 1
        steps < MAX_STEPS || return false

        edge = edges[i]
        pair = find_covering_pair(edge, nodes, V, weights, graph)

        if !isnothing(pair)
            V = merge_nodes!(pair..., edge, nodes, V, weights, graph)
        else
            return false
        end

        i = find_zero_covered_edge(edges, nodes, weights)
    end

    # -- PHASE 2 ------------------------------------------------------
    #
    # At this point, every missing edge is "covered" by a vertex subset
    # in `nodes`. However, the number of these subsets may be very
    # large, impacting the performance of PHASE 3.
    i = find_least_covered_edge(edges, nodes, weights)

    while 2length(nodes) > length(S) && !iszero(i)
        steps += 1
        steps < MAX_STEPS || return false

        edge = edges[i]
        pair = find_covering_pair(edge, nodes, V, weights, graph)

        if !isnothing(pair)
            V = merge_nodes!(pair..., edge, nodes, V, weights, graph)
        else
            w₁, w₂, _ = edge; edges[i] = (w₁, w₂, true)
            break
        end

        i = find_least_covered_edge(edges, nodes, weights)
    end

    # Remove ...
    i = 1

    while i ≤ length(nodes)
        _, N, _ = nodes[i]

        iscovered = false

        for (w₁, w₂, _) in edges
            iscovered && break
            iscovered = (w₁ ∈ N) & (w₂ ∈ N)
        end

        if iscovered
            i += 1
        elseif i < length(nodes)
            nodes[i] = pop!(nodes)
        else
            pop!(nodes)
        end
    end

    # -- PHASE 3 ------------------------------------------------------
    while !isempty(edges)
        vmax = 0
        imax = 0
        nmax = 0
        cmax = 0

        for v in S
            for (i, (D, N, w)) in enumerate(nodes)
                # Can only assign if: unassigned, adjacent, and weight constraint satisfied
                if iszero(w) && v ∈ N && weights[first(D)] >= weights[v]
                    steps += 1
                    steps < MAX_STEPS || return false

                    nodes[i] = (D, N, v)
                    n, c = min_cover(edges, nodes, weights)
                    nodes[i] = (D, N, 0)

                    if (n, c) > (nmax, cmax)
                        vmax = v
                        imax = i
                        nmax = n
                        cmax = c
                    end
                end
            end
        end

        iszero(nmax) && return false
        D, N, _ = nodes[imax]; nodes[imax] = (D, N, vmax)

        # Remove...
        i = 1

        while i ≤ length(edges)
            w₁, w₂, _ = edges[i]

            iscovered = false

            for (_, N, v) in nodes
                iscovered && break
                iscovered = ((v == w₁) & (w₂ in N)) | ((v == w₂) & (w₁ in N))
            end

            if !iscovered
                i += 1
            elseif i < length(edges)
                edges[i] = pop!(edges)
            else
                pop!(edges)
            end
        end
    end

    return true
end

# ---------- Clique Minor Helper Functions ----------

# Get the index of a missing edge {w, x} in `edges` such that,
# for all unassigned vertex subsets D in `nodes`,
#
#    {w, x} ⊈ N(D)  or  wmineight(D) < min(weight(w), weight(x))
#
# If no such edge exists, return 0.
function find_zero_covered_edge(edges::Vector{Tuple{Int,Int,Bool}}, nodes::Vector{Tuple{PSet,PSet,Int}}, weights::Vector{Int}) where {PSet}
    for (i, (w, x, _)) in enumerate(edges)
        iscovered = false
        wmin = min(weights[w], weights[x])

        for (D, N, v) in nodes
            iscovered && break
            iscovered = iszero(v) & (w in N) & (x in N) & (weights[first(D)] >= wmin)
        end

        iscovered || return i
    end

    return 0
end

"""
    find_least_covered_edge(edges, nodes, weights)

Find the augmentable missing edge potentially covered by the fewest right nodes.
Returns the index into `edges`, or `0` if no augmentable edge exists.
"""
function find_least_covered_edge(edges::Vector{Tuple{Int,Int,Bool}}, nodes::Vector{Tuple{PSet,PSet,Int}}, weights::Vector{Int}) where {PSet}
    nmin = imin = 0

    for (i, (w, x, flag)) in enumerate(edges)
        flag && continue

        n = 0
        wmin = min(weights[w], weights[x])

        for (D, N, v) in nodes
            if iszero(v) & (w in N) & (x in N) & (weights[first(D)] >= wmin)
                n += 1
            end
        end

        if iszero(imin) || n < nmin
            nmin = n
            imin = i
        end
    end

    return imin
end

# Given a missing edge {w₁, w₂}, find a pair (V₁, V₂) of
# vertex subsets in `nodes` such that
#
#   - w₁ ∈ N(V₁) and w₂ ∉ N(V₁)
#   - w₂ ∈ N(V₂) and w₁ ∉ N(V₂)
#   - wmineight(V₁) >= min(weight(w₁), weight(w₂))
#   - wmineight(V₂) >= min(weight(w₁), weight(w₂))
#
# and there is a path from V₁ to V₂ in V using only vertices with
# weight >= min(weight(w₁), weight(w₂)).
function find_covering_pair((w₁, w₂, _)::Tuple{Int, Int, Bool}, nodes::Vector{Tuple{PSet, PSet, Int}}, V::PSet, weights::Vector{Int}, graph::Graph{PSet}) where {PSet}
    wmin = min(weights[w₁], weights[w₂])
    k = searchsortedfirst(weights, wmin)
    V = V ∩ upset(PSet, k)

    for (i₁, (D₁, N₁, _)) in enumerate(nodes)
        (w₁ ∈ N₁ && w₂ ∉ N₁ && weights[first(D₁)] >= wmin) || continue

        for (i₂, (D₂, N₂, _)) in enumerate(nodes)
            (w₁ ∉ N₂ && w₂ ∈ N₂ && weights[first(D₂)] >= wmin) || continue

            U = D₁ # visited
            M = N₁ # frontier

            while isdisjoint(M, D₂) && !isdisjoint(M, V)
                U = U ∪ (M ∩ V)
                M = setdiff(neighbors(graph, M ∩ V), U)
            end

            !isdisjoint(M, D₂) && return (i₁, i₂)
        end
    end

    return
end

function merge_nodes!(i₁::Int, i₂::Int, (w₁, w₂, _)::Tuple{Int,Int,Bool}, nodes::Vector{Tuple{PSet,PSet,Int}}, V::PSet, weights::Vector{Int}, graph::Graph{PSet}) where {PSet}
    D₁, N₁, _ = nodes[i₁]
    D₂, N₂, _ = nodes[i₂]

    # Restrict path search to vertices with weight >= min(w₁, w₂)
    wmin = min(weights[w₁], weights[w₂])
    k = searchsortedfirst(weights, wmin)
    U, M = merge_nodes(graph, V ∩ upset(PSet, k), D₁, D₂, N₁, N₂)

    nodes[i₁] = (U, M, 0)

    if i₂ != length(nodes)
        nodes[i₂] = nodes[end]
    end

    pop!(nodes)

    return setdiff(V, U)
end

# We are given disjoint vertex sets V, D₁, and D₂, as
# well as the neighborhoods
#
#   N₁ := N(D₁)
#   N₂ := N(D₂).
#
# This function finds a path P from D₁ to D₂ through V.
# It returns the union
#
#    U := D₁ ∪ D₂ ∪ P
#
# as well as its neighborhood N(U).
function merge_nodes(graph::Graph{PSet}, V::PSet, D₁::PSet, D₂::PSet, N₁::PSet, N₂::PSet) where {PSet}
    layers = PSet[]

    U = D₁ # visited
    M = N₁ # frontier

    while isdisjoint(M, D₂)
        push!(layers, M ∩ V)
        U = U ∪ (M ∩ V)
        M = setdiff(neighbors(graph, M ∩ V), U)
    end

    U = D₁ ∪ D₂
    M = N₁ ∪ N₂
    B = N₂

    for L in Iterators.reverse(layers)
        v = first(L ∩ B)
        B = neighbors(graph, v)

        U = U ∪ v
        M = M ∪ B
    end

    return (U, setdiff(M, U))
end

"""
    min_cover(edges, nodes, weights)

Determine the minimum number of right nodes that potentially cover
any non-finally-covered missing edge.
"""
function min_cover(edges::Vector{Tuple{Int,Int,Bool}}, nodes::Vector{Tuple{PSet,PSet,Int}}, weights::Vector{Int}) where {PSet}
    nmin = typemax(Int); c = 0

    for (w₁, w₂, _) in edges
        n = 0
        wmin = min(weights[w₁], weights[w₂])

        for (D, N, v) in nodes
            b₁ = w₁ ∈ N
            b₂ = w₂ ∈ N

            if iszero(v) & b₁ & b₂ & (weights[first(D)] >= wmin)
                n += 1
            elseif ((v == w₁) & b₂) | ((v == w₂) & b₁)
                n = typemax(Int)
                c += 1
                break
            end
        end

        nmin = min(nmin, n)
    end

    return (nmin, c)
end

# Sieve: a modified trie for storing and querying PTDURs by vertex sets.
# Flat struct-of-arrays with left-child right-sibling tree representation.
# Each node stores a stop value and a bitset (the edge label from parent).
# Leaves have stop < 0 (encoding -ptdur_root); inner nodes have stop ≥ 1.
# The start of an inner node's interval is parent.stop + 1 (or 1 for the root).
# Children of each node form a doubly linked list (head/prev/next).

# ==================== Type ====================

const MAX_CHILDREN_PER_NODE = 32

struct Sieve{PSet <: AbstractPackedSet}
    stop::Vector{Int}       # ≥ 1 for inner nodes (interval stop); negative for leaves (-ptdur_root)
    set::Vector{PSet}
    parent::Vector{Int}
    head::Vector{Int}       # first child; doubles as free-list next
    prev::Vector{Int}       # previous sibling
    next::Vector{Int}       # next sibling
    outdegree::Vector{Int}

    free::Scalar{Int}
    leaf::Dict{Int, Int}   # ptdur root index -> trie leaf node
end

# ==================== Constructor ====================

function Sieve{PSet}() where {PSet <: AbstractPackedSet}
    sieve = Sieve{PSet}(
        Int[], PSet[], Int[], Int[], Int[], Int[], Int[],
        zeros(Int), Dict{Int, Int}())

    add_vertex!(sieve, domain(PSet), PSet())
    return sieve
end

# ==================== Helpers ====================

function children(sieve::Sieve, v::Int)
    return DoublyLinkedList(view(sieve.head, v), sieve.prev, sieve.next)
end

function is_leaf(sieve::Sieve, v::Int)
    return sieve.stop[v] < 0
end

function outdegree(sieve::Sieve, v::Int)
    return sieve.outdegree[v]
end

function add_vertex!(sieve::Sieve{PSet}, stop::Int, V::PSet) where {PSet}
    list = SinglyLinkedList(sieve.free, sieve.head)

    if isempty(list)
        push!(sieve.stop, stop)
        push!(sieve.set, V)
        push!(sieve.parent, 0)
        push!(sieve.head, 0)
        push!(sieve.prev, 0)
        push!(sieve.next, 0)
        push!(sieve.outdegree, 0)
        v = length(sieve.stop)
    else
        v = popfirst!(list)
        sieve.stop[v] = stop
        sieve.set[v] = V
        sieve.parent[v] = 0
        sieve.head[v] = 0
        sieve.prev[v] = 0
        sieve.next[v] = 0
        sieve.outdegree[v] = 0
    end

    return v
end

# ==================== setindex! ====================

function Base.setindex!(sieve::Sieve{PSet}, V::PSet, i::Int) where {PSet}
    v = start = 1; isdone = false

    while !isdone
        I = packedset(PSet, start:sieve.stop[v])

        isfound = false

        for w in children(sieve, v)
            W = sieve.set[w]

            if V ∩ I == W ∩ I
                isfound = true

                if is_leaf(sieve, w)
                    isdone = true
                    delete!(sieve.leaf, -sieve.stop[w])
                    sieve.stop[w] = -i
                    sieve.leaf[i] = w
                else
                    start = sieve.stop[v] + 1
                    v = w
                end

                break
            end
        end

        if !isfound
            isdone = true

            if sieve.stop[v] < domain(PSet)
                w = add_vertex!(sieve, domain(PSet), V)
                add_edge_split!(sieve, v, w, start)
                start = sieve.stop[v] + 1
                v = w
            end

            w = sieve.leaf[i] = add_vertex!(sieve, -i, V)
            add_edge_split!(sieve, v, w, start)
        end
    end

    return sieve
end

# ==================== Query ====================

# Find all key-value pairs i => V such that
#
#   - V ∩ R = ∅
#   - w(S - V) ≤ margin
#

function init!(stack::Vector{Tuple{Int, Int, Int}})
    push!(empty!(stack), (1, 1, 0))
    return stack
end

function next!(sieve::Sieve{PSet}, stack::Vector{Tuple{Int, Int, Int}}, R::PSet, S::PSet, margin::Int, weights::Vector{Int}) where {PSet}
    result = 0

    while !isempty(stack)
        v, start, i = pop!(stack)

        if is_leaf(sieve, v)
            result = -sieve.stop[v]
            break
        else
            V = packedset(PSet, start:sieve.stop[v])

            for w in children(sieve, v)
                W = sieve.set[w]

                if isempty(R ∩ W ∩ V)
                    j = i + wt(weights, setdiff(S ∩ V, W))
                    j > margin || push!(stack, (w, sieve.stop[v] + 1, j))
                end
            end
        end
    end

    return result
end

# ==================== replace_key! ====================

function replace_key!(sieve::Sieve, old_root::Int, new_root::Int)
    node = sieve.leaf[old_root]
    delete!(sieve.leaf, old_root)
    sieve.stop[node] = -new_root
    sieve.leaf[new_root] = node
    return sieve
end

# ==================== delete! ====================

function Base.delete!(sieve::Sieve, i::Int)
    list = SinglyLinkedList(sieve.free, sieve.head)

    v = pop!(sieve.leaf, i)

    while !isone(v) && iszero(outdegree(sieve, v))
        u = sieve.parent[v]
        rem_edge!(sieve, u, v)
        pushfirst!(list, v)
        v = u
    end

    return sieve
end

# ==================== Internal: add_edge! ====================

function add_edge!(sieve::Sieve, u::Int, v::Int)
    sieve.parent[v] = u
    pushfirst!(children(sieve, u), v)
    sieve.outdegree[u] += 1
    return
end

function rem_edge!(sieve::Sieve, u::Int, v::Int)
    sieve.parent[v] = 0
    delete!(children(sieve, u), v)
    sieve.outdegree[u] -= 1
    return
end

function add_edge_split!(sieve::Sieve{PSet}, u::Int, v::Int, start::Int) where {PSet}
    add_edge!(sieve, u, v)
    outdegree(sieve, u) > MAX_CHILDREN_PER_NODE && split_vertex!(sieve, u, start)
    return
end

# ==================== Internal: split_vertex! ====================

function split_vertex!(sieve::Sieve{PSet}, v::Int, start::Int) where {PSet}
    oldstop = sieve.stop[v]
    newstop = sieve.stop[v] = split_index(start, oldstop)

    V = packedset(PSet, start:newstop)

    dict = Dict{PSet, Int}()

    for x in children(sieve, v)
        rem_edge!(sieve, v, x)

        X = sieve.set[x]

        w = get!(dict, X ∩ V) do
            w = add_vertex!(sieve, oldstop, X)
            add_edge!(sieve, v, w)
            return w
        end

        add_edge!(sieve, w, x)
    end

    return
end

# ==================== Internal: _get_split_vertex ====================

function split_index(start::Int, stop::Int)
    return start + (1 << floor(Int, log(stop - start))) - 1
end

function selinv(A::SparseMatrixCSC, F::ChordalCholesky)
    return selinv(Hermitian(A), F)
end

function selinv(A::HermOrSymSparse, F::ChordalCholesky)
    Y = copy(F)
    return project(A, selinv!(Y))
end

# ===== frule =====

function selinv_frule_impl(A::HermOrSymSparse, F::ChordalCholesky, dA::HermOrSymSparse)
     cB = selinv!(copy(F))
      B = project(A, cB)
    cdA = copyto!(similar(F), dA)
     dB = project(A, fisher!(cdA, F, cB; inv=false))
    rmul!(parent(dB), -1)
    return B, dB
end

# ===== rrule =====

function selinv_rrule_impl!(ΣA::HermOrSymSparse, A::HermOrSymSparse, F::ChordalCholesky, B::HermOrSymSparse, ΔB::HermOrSymSparse)
     cB = selinv!(copy(F))
    cΔB = copyto!(similar(F), ΔB)
     dA = scldia!(project(A, fisher!(scldia!(cΔB, 2), F, cB; inv=false)), 1 / 2)
    selaxpy!(-1, dA, ΣA)
    return ΣA
end

# ===== logdet(A, F) =====

@is_primitive MinimalCtx Tuple{typeof(logdet), HermOrSymSparse, ChordalCholesky}

function Mooncake.rrule!!(
        ::CoDual{typeof(logdet)},
        cdA::CoDual{<:HermOrSymSparse},
        cdF::CoDual{<:ChordalCholesky},
    )
    A, dA = primaltangent(cdA)
    y = logdet(A, primal(cdF))

    function pullback!!(Δy)
        logdet_rrule_impl!(dA, A, primal(cdF), y, Δy)
        return NoRData(), NoRData(), NoRData()
    end

    return CoDual(y, NoFData()), pullback!!
end

function Mooncake.frule!!(
        ::Dual{typeof(logdet)},
        cdA::Dual{<:HermOrSymSparse},
        cdF::Dual{<:ChordalCholesky},
    )
    A, dA = primaltangent(cdA)
    y, dy = logdet_frule_impl(A, primal(cdF), dA)
    return Dual(y, dy)
end

# ===== logdet_rrule_impl!(ΣA, A, F, y, Δy) =====

@is_primitive MinimalCtx Tuple{typeof(logdet_rrule_impl!), HermSparse, HermSparse, ChordalCholesky, Number, Number}
@is_primitive MinimalCtx Tuple{typeof(logdet_rrule_impl!), SymSparse, SymSparse, ChordalCholesky, Number, Number}

function Mooncake.frule!!(
        ::Dual{typeof(logdet_rrule_impl!)},
        cdΣA::Dual{<:HermOrSymSparse},
        cdA::Dual{<:HermOrSymSparse},
        cdF::Dual{<:ChordalCholesky},
        cdy::Dual{<:Number},
        cdΔy::Dual{<:Number},
    )
    ΣA, dΣA = primaltangent(cdΣA)
     A,  dA = primaltangent(cdA)
    Δy, dΔy = primaltangent(cdΔy)

    logdet_rrule_frule_impl!(ΣA, dΣA, A, dA, primal(cdF), Δy, dΔy)

    return cdΣA
end

struct DoublyLinkedList{I, Head <: AbstractScalar{I}, Prev <: AbstractVector{I}, Next <: AbstractVector{I}} <: AbstractLinkedList{I}
    head::Head
    prev::Prev
    next::Next
end

function DoublyLinkedList{I}(n::Integer) where {I}
    head = fill(zero(I))
    prev = Vector{I}(undef, n)
    next = Vector{I}(undef, n)

    return DoublyLinkedList(head, prev, next)
end

@propagate_inbounds function Base.pushfirst!(list::DoublyLinkedList, i::Integer)
    @boundscheck checkbounds(list.prev, i)
    @inbounds n = list.next[i] = list.head[]
    @inbounds list.head[] = i

    if ispositive(n)
        @inbounds list.prev[n] = i
    end

    return list
end

@propagate_inbounds function Base.delete!(list::DoublyLinkedList, i::Integer)
    @boundscheck checkbounds(list.prev, i)
    @inbounds h = list.head[]
    @inbounds n = list.next[i]

    if i == h
        @inbounds list.head[] = n
    else
        @inbounds p = list.prev[i]
        @inbounds list.next[p] = n

        if ispositive(n)
            @inbounds list.prev[n] = p
        end
    end

    return list
end

@propagate_inbounds function Base.prepend!(list::DoublyLinkedList, v::AbstractVector)
    if !isempty(v)
        @inbounds i = v[begin]
        @inbounds h = list.head[]
        @inbounds list.head[] = i
        @boundscheck checkbounds(list.prev, i)

        for j in @view v[begin + 1:end]
            @boundscheck checkbounds(list.prev, j)
            @inbounds list.prev[j] = i
            @inbounds list.next[i] = j
            i = j
        end

        @inbounds list.next[i] = h
    end

    return list
end

# ===== FactorizationWorkspace =====

abstract type AbstractFactorizationWorkspace end

struct FactorizationWorkspace{T, I <: Integer} <: AbstractFactorizationWorkspace
    Mptr::FVector{I}
    Mval::FVector{T}
    Fval::FVector{T}
    Eval::FVector{T}
    piv::FVector{BlasInt}
    mval::FVector{I}
    fval::FVector{I}
end

function FactorizationWorkspace{T}(S::ChordalSymbolic{I}) where {T, I <: Integer}
    Mptr = FVector{I}(undef, S.nMptr)
    Mval = FVector{T}(undef, S.nMval)
    Fval = FVector{T}(undef, max(S.nFval * S.nFval, two(I)))
    Eval = FVector{T}(undef, S.nFval)
    piv  = FVector{BlasInt}(undef, S.nFval)
    mval = FVector{I}(undef, S.nNval)
    fval = FVector{I}(undef, S.nFval)
    return FactorizationWorkspace{T, I}(Mptr, Mval, Fval, Eval, piv, mval, fval)
end

function FactorizationWorkspace(L::ChordalTriangular{DIAG, UPLO, T}) where {DIAG, UPLO, T}
    return FactorizationWorkspace{T}(L.S)
end

function FactorizationWorkspace(F::AbstractFactorization)
    return FactorizationWorkspace(triangular(F))
end

# TODO: workspace for dense factorization
struct DenseFactorizationWorkspace <: AbstractFactorizationWorkspace end

function FactorizationWorkspace(::AbstractTriangular)
    return DenseFactorizationWorkspace()
end

"""
    cholesky!(F[, pivot::PivotingStrategy]; check=true, reg=NoRegularization())

Perform a Cholesky factorization of a positive definite matrix.

### Example

Use [`ChordalCholesky`](@ref) to construct a factorization object,
and use [`cholesky!`](@ref) to perform the factorization.

```julia-repl
julia> using CliqueTrees.Multifrontal, LinearAlgebra

julia> A = [
           4  2  0  0  2
           2  5  0  0  3
           0  0  4  2  0
           0  0  2  5  2
           2  3  0  2  7
       ];

julia> F = cholesky!(ChordalCholesky(A))
5×5 FChordalCholesky{:L, Float64, Int64} with 10 stored entries:
 2.0   ⋅    ⋅    ⋅    ⋅
 0.0  2.0   ⋅    ⋅    ⋅
 0.0  1.0  2.0   ⋅    ⋅
 1.0  0.0  0.0  2.0   ⋅
 0.0  1.0  1.0  1.0  2.0
```

### Parameters

  - `F`: positive definite matrix
  - `pivot`: pivoting strategy
  - `check`: if `check = true`, then the function errors if `F`
    is not positive definite
  - `reg`: dynamic regularization strategy

"""
function LinearAlgebra.cholesky!(
        F::AbstractCholesky{UPLO, T},
        pivot::PivotingStrategy=NoPivot();
        check::Bool=true,
        reg::AbstractRegularization=NoRegularization(),
        tol::Real=-one(real(T)),
    ) where {UPLO, T}
    W = FactorizationWorkspace(F)
    return cholesky!(W, F, pivot; check, reg, tol)
end

function LinearAlgebra.cholesky!(
        W::AbstractFactorizationWorkspace,
        F::AbstractCholesky{UPLO, T},
        pivot::PivotingStrategy=NoPivot();
        check::Bool=true,
        reg::AbstractRegularization=NoRegularization(),
        tol::Real=-one(real(T)),
    ) where {UPLO, T}
    signs = Ones{T}(size(F, 1))
    return factorize!(W, F, pivot; signs, reg, check, tol)
end

function LinearAlgebra.cholesky!(
        L::ChordalTriangular{:N, UPLO, T},
        pivot::NoPivot=NoPivot();
        check::Bool=true,
        reg::AbstractRegularization=NoRegularization(),
        tol::Real=-one(real(T)),
    ) where {UPLO, T}
    W = FactorizationWorkspace(L)
    return cholesky!(W, L, pivot; check, reg, tol)
end

function LinearAlgebra.cholesky!(
        L::ChordalTriangular{:N, UPLO, T},
        pivot::RowMaximum;
        check::Bool=true,
        reg::AbstractRegularization=NoRegularization(),
        tol::Real=-one(real(T)),
    ) where {UPLO, T}
    W = FactorizationWorkspace(L)
    return cholesky!(W, L, pivot; check, reg, tol)
end

function LinearAlgebra.cholesky!(
        W::FactorizationWorkspace,
        L::ChordalTriangular{:N, UPLO, T},
        pivot::PivotingStrategy=NoPivot();
        check::Bool=true,
        reg::AbstractRegularization=NoRegularization(),
        tol::Real=-one(real(T)),
    ) where {UPLO, T}
    signs = Ones{T}(size(L, 1))
    d = Ones{T}(size(L, 1))
    return factorize!(W, L, d, pivot; signs, reg, check, tol)
end

"""
    ldlt!(F[, pivot::PivotingStrategy]; check=true, signs=Zeros(size(F, 1)), reg=NoRegularization())

Perform an LDLᵀ factorization of a quasi-definite matrix.

### Example

```julia-repl
julia> using CliqueTrees.Multifrontal, LinearAlgebra

julia> A = [
           4  2  0  0  2
           2  5  0  0  3
           0  0  4  2  0
           0  0  2  5  2
           2  3  0  2  7
       ];

julia> F = ldlt!(ChordalLDLt(A))
5×5 FChordalLDLt{:L, Float64, Int64} with 10 stored entries:
 1.0   ⋅    ⋅    ⋅    ⋅
 0.0  1.0   ⋅    ⋅    ⋅
 0.0  0.5  1.0   ⋅    ⋅
 0.5  0.0  0.0  1.0   ⋅
 0.0  0.5  0.5  0.5  1.0

 4.0   ⋅    ⋅    ⋅    ⋅
  ⋅   4.0   ⋅    ⋅    ⋅
  ⋅    ⋅   4.0   ⋅    ⋅
  ⋅    ⋅    ⋅   4.0   ⋅
  ⋅    ⋅    ⋅    ⋅   4.0
```

### Parameters

   - `F`: quasi-definite matrix
   - `pivot`: pivoting strategy
   - `check`: if `check = true`, then the function errors
     if the matrix is singular
   - `signs`: pivot signs
   - `reg`: dynamic regularization strategy

"""
function LinearAlgebra.ldlt!(
        F::AbstractLDLt{UPLO, T},
        pivot::PivotingStrategy=NoPivot();
        signs::AbstractVector=Zeros{T}(size(F, 1)),
        reg::AbstractRegularization=NoRegularization(),
        check::Bool=true,
        tol::Real=-one(real(T)),
    ) where {UPLO, T}
    W = FactorizationWorkspace(F)
    return ldlt!(W, F, pivot; signs, reg, check, tol)
end

function LinearAlgebra.ldlt!(
        W::AbstractFactorizationWorkspace,
        F::AbstractLDLt{UPLO, T},
        pivot::PivotingStrategy=NoPivot();
        signs::AbstractVector=Zeros{T}(size(F, 1)),
        reg::AbstractRegularization=NoRegularization(),
        check::Bool=true,
        tol::Real=-one(real(T)),
    ) where {UPLO, T}
    return factorize!(W, F, pivot; signs, reg, check, tol)
end

function LinearAlgebra.ldlt!(
        L::ChordalTriangular{:U, UPLO, T},
        d::AbstractVector{T},
        pivot::PivotingStrategy=NoPivot();
        signs::AbstractVector=Zeros{T}(size(L, 1)),
        reg::AbstractRegularization=NoRegularization(),
        check::Bool=true,
        tol::Real=-one(real(T)),
    ) where {UPLO, T}
    W = FactorizationWorkspace(L)
    return ldlt!(W, L, d, pivot; signs, reg, check, tol)
end

function LinearAlgebra.ldlt!(
        W::FactorizationWorkspace,
        L::ChordalTriangular{:U, UPLO, T},
        d::AbstractVector{T},
        pivot::PivotingStrategy=NoPivot();
        signs::AbstractVector=Zeros{T}(size(L, 1)),
        reg::AbstractRegularization=NoRegularization(),
        check::Bool=true,
        tol::Real=-one(real(T)),
    ) where {UPLO, T}
    return factorize!(W, L, d, pivot; signs, reg, check, tol)
end

# ===== factorize! Level 1: AbstractFactorization =====

function factorize!(
        W::AbstractFactorizationWorkspace,
        F::AbstractFactorization{DIAG, UPLO, T},
        pivot::PivotingStrategy;
        signs::AbstractVector,
        reg::AbstractRegularization,
        check::Bool,
        tol::Real,
    ) where {DIAG, UPLO, T}
    S = permuteto(T, signs, F.perm)

    if pivot isa NoPivot
        info = factorize!(W, triangular(F), F.d, pivot; signs=S, reg, check, tol)
    else
        info = factorize!(W, triangular(F), F.d, pivot, F.perm, F.invp; signs=S, reg, check, tol)
    end

    if iszero(info)
        F.info[] = info
    else
        F.info[] = F.perm[info]
    end

    return F
end

# ===== factorize! Level 2: ChordalTriangular with kwargs =====

function factorize!(
        W::FactorizationWorkspace,
        L::ChordalTriangular{DIAG, UPLO, T, I},
        d::AbstractVector,
        pivot::NoPivot;
        signs::AbstractVector,
        reg::AbstractRegularization,
        check::Bool,
        tol::Real,
    ) where {DIAG, UPLO, T, I <: Integer}
    @assert checksigns(signs, reg)

    info = factorize!(W, L, d, pivot, signs, reg, tol)
    check && checkinfo(info, L.diag)

    return info
end

function factorize!(
        W::FactorizationWorkspace,
        L::ChordalTriangular{DIAG, UPLO, T, I},
        d::AbstractVector,
        pivot::RowMaximum,
        perm::AbstractVector,
        invp::AbstractVector;
        signs::AbstractVector,
        reg::AbstractRegularization,
        check::Bool,
        tol::Real,
    ) where {DIAG, UPLO, T, I <: Integer}
    @assert checksigns(signs, reg)

    info = factorize!(W, L, d, pivot, perm, invp, signs, reg, tol)

    if check && ispositive(info)
        # throw(RankDeficientException(info))
    end

    return info
end

# ===== factorize! Level 3: all positional (core computation) =====

function factorize!(
        W::FactorizationWorkspace,
        L::ChordalTriangular{DIAG, UPLO, T, I},
        d::AbstractVector{T},
        ::NoPivot,
        signs::AbstractVector{T},
        reg::AbstractRegularization,
        tol::Real,
    ) where {DIAG, UPLO, T, I <: Integer}
    R = initialize(L, signs, reg)
    return chol_impl!(W, L, d, signs, R)
end

function chol_impl!(
        W::FactorizationWorkspace,
        L::ChordalTriangular{DIAG, UPLO, T, I},
        d::AbstractVector{T},
        signs::AbstractVector{T},
        R::AbstractRegularization,
    ) where {DIAG, UPLO, T, I <: Integer}
    return chol_impl!(W.Mptr, W.Mval, W.Fval, L, d, signs, R)
end

function chol_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Fval::AbstractVector{T},
        L::ChordalTriangular{:N, UPLO, T, I},
        R::AbstractRegularization=NoRegularization(),
    ) where {UPLO, T, I <: Integer}
    n = ncl(L)
    d = Ones{T}(n)
    S = Ones{T}(n)
    info = chol_impl!(Mptr, Mval, Fval, L, d, S, R)
    return info
end

function chol_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Fval::AbstractVector{T},
        L::ChordalTriangular{DIAG, UPLO, T, I},
        d::AbstractVector{T},
        S::AbstractVector{T},
        R::AbstractRegularization=NoRegularization(),
    ) where {DIAG, UPLO, T, I <: Integer}
    info = chol_impl!(
        Mptr, Mval,
        L.S.Dptr, L.Dval,
        L.S.Lptr, L.Lval,
        d, Fval,
        L.S.res, L.S.rel, L.S.chd,
        L.uplo, S, R, L.diag)

    return info
end

function chol_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        uplo::Val{UPLO},
        S::AbstractVector{T},
        R::AbstractRegularization,
        diag::Val{DIAG},
    ) where {T, I <: Integer, UPLO, DIAG}

    ns = zero(I); Mptr[one(I)] = one(I)

    for j in vertices(res)
        ns, info = chol_loop!(Mptr, Mval, Dptr, Dval, Lptr, Lval, d, Fval, res, rel, chd, ns, j, uplo, S, R, diag)

        if isnegative(info)
            return info
        elseif ispositive(info)
            return info + pointers(res)[j] - one(I)
        end
    end

    return zero(I)
end

function chol_loop!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        S::AbstractVector{T},
        R::AbstractRegularization,
        diag::Val{DIAG},
    ) where {T, I <: Integer, UPLO, DIAG}
    nn = eltypedegree(res, j)

    if isone(nn)
        return chol_loop_nod!(
            Mptr, Mval,
            Dptr, Dval,
            Lptr, Lval,
            d, Fval,
            res, rel, chd, ns, j, uplo, S, R, diag
        )
    else
        return chol_loop_snd!(
            Mptr, Mval,
            Dptr, Dval,
            Lptr, Lval,
            d, Fval,
            res, rel, chd, ns, nn, j, uplo, S, R, diag
        )
    end
end

function chol_loop_snd!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        nn::I,
        j::I,
        uplo::Val{UPLO},
        S::AbstractVector{T},
        R::AbstractRegularization,
        diag::Val{DIAG},
    ) where {T, I <: Integer, UPLO, DIAG}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁₁     ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₁₁ = view(F, oneto(nn),      oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
    end
    #
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ D₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    d₁₁ = view(d, neighbors(res, j))
    S₁₁ = view(S, neighbors(res, j))
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    #     F ← 0
    #
    zerotri!(F, uplo)

    for i in Iterators.reverse(neighbors(chd, j))
        #
        # add the update matrix for child i to F
        #
        #   F ← F + Rᵢ Sᵢ Rᵢᵀ
        #
        chol_send!(F, Mptr, Mval, rel, ns, i, uplo)
        ns -= one(I)
    end
    #
    # add F to L
    #
    #     L ← L + F
    #
    addtri!(D₁₁, F₁₁, uplo)
    addrec!(L₂₁, F₂₁)
    #
    # factorize D₁₁ and solve for L₂₁
    #
    #     D₁₁ ← cholesky(D₁₁)
    #     L₂₁ ← L₂₁ D₁₁⁻ᴴ
    #
    info = chol_factor!(D₁₁, L₂₁, Fval, d₁₁, S₁₁, R, uplo, diag)
    !iszero(info) && return ns, convert(I, info)

    if ispositive(na)
        #
        # M₂₂ is the update matrix for node j
        #
        ns += one(I)
        strt = Mptr[ns]
        stop = Mptr[ns + one(I)] = strt + na * na
        M₂₂ = reshape(view(Mval, strt:stop - one(I)), na, na)
        #
        #     M₂₂ ← F₂₂
        #
        copytri!(M₂₂, F₂₂, uplo)

        if UPLO === :L
            trans = Val(:N)
        else
            trans = Val(:C)
        end
        #
        #     M₂₂ ← M₂₂ - L₂₁ L₂₁ᴴ
        #
        syrk!(uplo, trans, -one(real(T)), Fval, L₂₁, d₁₁, one(real(T)), M₂₂, diag)
    end

    return ns, zero(I)
end

# Fast path for nn = 1 (residual size is 1)
# In this case, diagonal blocks are scalars and off-diagonal blocks are vectors
function chol_loop_nod!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        S::AbstractVector{T},
        R::AbstractRegularization,
        diag::Val{DIAG},
    ) where {T, I <: Integer, UPLO, DIAG}
    #
    # nn = 1 (the size of the residual at node j)
    #
    nn = one(I)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) | = 1 + na
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           1   na
    #     F = [ f₁₁     ] 1
    #         [ f₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        f₂₁ = view(F, nn + one(I):nj, one(I))
    else
        f₂₁ = view(F, one(I), nn + one(I):nj)
    end
    #
    # L is part of the Cholesky factor (d₁₁ is scalar, l₂₁ is vector)
    #
    #          res(j)
    #     L = [ d₁₁  ] res(j)
    #         [ l₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    Rp = pointers(res)[j]
    s₁ = S[Rp]
    l₂₁ = view(Lval, Lp:Lp + na - one(I))
    #
    #     F ← 0
    #
    zerotri!(F, uplo)

    for i in Iterators.reverse(neighbors(chd, j))
        #
        # add the update matrix for child i to F
        #
        #   F ← F + Rᵢ Sᵢ Rᵢᵀ
        #
        chol_send!(F, Mptr, Mval, rel, ns, i, uplo)
        ns -= one(I)
    end
    #
    # add F to L (scalar and vector additions)
    #
    #     d₁₁ ← d₁₁ + f₁₁
    #     l₂₁ ← l₂₁ + f₂₁
    #
    d₁₁ = Dval[Dp] + F[one(I)]
    addrec!(l₂₁, f₂₁)
    #
    # regularize d₁₁
    #
    d₁₁ = regularize(R, s₁, real(d₁₁), l₂₁)

    if iszero(d₁₁)
        return ns, one(I)
    end

    if DIAG === :N
        d₁₁ = sqrt(d₁₁)
        Dval[Dp] = d₁₁
    else
        d[Rp] = d₁₁
    end

    if ispositive(na)
        #
        # M₂₂ is the update matrix for node j
        #
        ns += one(I)
        strt = Mptr[ns]
        stop = Mptr[ns + one(I)] = strt + na * na
        M₂₂ = reshape(view(Mval, strt:stop - one(I)), na, na)
        #
        #     M₂₂ ← F₂₂
        #
        copytri!(M₂₂, F₂₂, uplo)
        #
        #     l₂₁ ← l₂₁ / d₁₁
        #
        rdiv!(l₂₁, d₁₁)

        if DIAG === :U
            #
            #     M₂₂ ← M₂₂ - d₁₁ l₂₁ l₂₁ᴴ
            #
            syr!(uplo, -d₁₁, l₂₁, M₂₂)
        else
            #
            #     M₂₂ ← M₂₂ - l₂₁ l₂₁ᴴ
            #
            syr!(uplo, -one(real(T)), l₂₁, M₂₂)
        end
    end

    return ns, zero(I)
end

@inline function chol_factor!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        W::AbstractVector{T},
        d::AbstractVector{T},
        S::AbstractVector{T},
        R::AbstractRegularization,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, UPLO, DIAG}
    @assert size(D, 1) == size(D, 2)

    if DIAG === :U
        @assert length(d) == size(D, 1)
        @assert length(D) <= length(W)

        if UPLO === :L
            @assert size(L, 2) == size(D, 1)
        else
            @assert size(L, 1) == size(D, 1)
        end
    end
    #
    # factorize D
    #
    #     D ← cholesky(D)
    #
    info = potrf!(uplo, W, D, d, S, R, diag)

    if iszero(info) && !isempty(L)
        if UPLO === :L
            side = Val(:R)
        else
            side = Val(:L)
        end
        #
        #     L ← L D⁻ᴴ
        #
        trsm!(side, uplo, Val(:C), diag, one(T), D, L)
        cdiv!(side, diag, L, d)
    end

    return info
end

# ===== GMW81 Specialization =====
#
# GMW81 requires blocked factorization with access to both D and L
#

function chol_factor!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        W::AbstractVector{T},
        d::AbstractVector{T},
        S::AbstractVector{T},
        R::GMW81,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, UPLO, DIAG}
    if UPLO === :L
        @assert size(D, 1) == size(D, 2) == size(L, 2)
    else
        @assert size(D, 1) == size(D, 2) == size(L, 1)
    end

    if DIAG === :U
        @assert length(d) == size(D, 1)
    end

    n = size(D, 1)

    @inbounds for bstrt in 1:THRESHOLD:n
        bstop = min(bstrt + THRESHOLD - 1, n)

        if UPLO === :L
            Dbb = view(D, bstrt:n, bstrt:bstop)
            Lnb = view(L, :, bstrt:bstop)
        else
            Dbb = view(D, bstrt:bstop, bstrt:n)
            Lnb = view(L, bstrt:bstop, :)
        end

        dbb = view(d, bstrt:bstop)
        Sbb = view(S, bstrt:bstop)

        info = chol_factor_block!(Dbb, Lnb, dbb, Sbb, R, uplo, diag)
        !iszero(info) && return bstrt + info - 1

        if bstop < n
            Drr = view(D, bstop + 1:n, bstop + 1:n)

            if UPLO === :L
                Drb = view(D, bstop + 1:n, bstrt:bstop)
                tA = Val(:N)
                tB = Val(:C)
            else
                Drb = view(D, bstrt:bstop, bstop + 1:n)
                tA = Val(:C)
                tB = Val(:N)
            end

            syrk!(uplo, tA, -one(real(T)), W, Drb, dbb, one(real(T)), Drr, diag)

            if !isempty(L)
                if UPLO === :L
                    Lnr = view(L, :, bstop + 1:n)
                    A = Lnb
                    B = Drb
                else
                    Lnr = view(L, bstop + 1:n, :)
                    A = Drb
                    B = Lnb
                end

                gemm!(tA, tB, -one(T), W, A, B, dbb, one(T), Lnr, diag)
            end
        end
    end

    return 0
end

function chol_factor_block!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        d::AbstractVector{T},
        S::AbstractVector{T},
        R::GMW81,
        uplo::Val{:L},
        diag::Val{DIAG},
    ) where {T, DIAG}
    @assert size(D, 2) == size(L, 2)

    if DIAG === :U
        @assert length(d) == size(D, 2)
    end

    @inbounds for j in axes(D, 2)
        Djj = regularize(R, S, D, L, real(D[j, j]), j, uplo)

        if DIAG === :U
            d[j] = Djj
        else
            D[j, j] = Djj = sqrt(Djj)
        end

        iDjj = inv(Djj)

        for i in j + 1:size(D, 1)
            D[i, j] *= iDjj
        end

        for i in axes(L, 1)
            L[i, j] *= iDjj
        end

        for k in j + 1:size(D, 2)
            Dkj = D[k, j]
            cDkj = conj(Dkj)

            if DIAG === :N
                D[k, k] -= abs2(Dkj)
            else
                D[k, k] -= Djj * abs2(Dkj)
            end

            for i in k + 1:size(D, 1)
                if DIAG === :N
                    D[i, k] -= D[i, j] * cDkj
                else
                    D[i, k] -= D[i, j] * Djj * cDkj
                end
            end

            for i in axes(L, 1)
                if DIAG === :N
                    L[i, k] -= L[i, j] * cDkj
                else
                    L[i, k] -= L[i, j] * Djj * cDkj
                end
            end
        end
    end

    return 0
end

function chol_factor_block!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        d::AbstractVector{T},
        S::AbstractVector{T},
        R::GMW81,
        uplo::Val{:U},
        diag::Val{DIAG},
    ) where {T, DIAG}
    @assert size(D, 1) == size(L, 1)

    if DIAG === :U
        @assert length(d) == size(D, 1)
    end

    @inbounds for j in axes(D, 1)
        for i in j + 1:size(D, 2)
            for k in 1:j - 1
                if DIAG === :U
                    D[j, i] -= D[k, i] * d[k] * conj(D[k, j])
                else
                    D[j, i] -= D[k, i] * conj(D[k, j])
                end
            end
        end

        for i in axes(L, 2)
            for k in 1:j - 1
                if DIAG === :U
                    L[j, i] -= L[k, i] * d[k] * conj(D[k, j])
                else
                    L[j, i] -= L[k, i] * conj(D[k, j])
                end
            end
        end

        Djj = real(D[j, j])

        for k in 1:j - 1
            if DIAG === :U
                Djj -= d[k] * abs2(D[k, j])
            else
                Djj -= abs2(D[k, j])
            end
        end

        Djj = regularize(R, S, D, L, Djj, j, uplo)

        if DIAG === :U
            d[j] = Djj
        else
            D[j, j] = Djj = sqrt(Djj)
        end

        iDjj = inv(Djj)

        for i in j + 1:size(D, 2)
            D[j, i] *= iDjj
        end

        for i in axes(L, 2)
            L[j, i] *= iDjj
        end
    end

    return 0
end

function chol_send!(
        F::AbstractMatrix{T},
        ptr::AbstractVector{I},
        val::AbstractVector{T},
        rel::AbstractGraph{I},
        ns::I,
        i::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    #
    # na is the size of the separator at node i
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, i)
    #
    # inj is the subset inclusion
    #
    #     inj: sep(i) → bag(parent(i))
    #
    inj = neighbors(rel, i)
    #
    # M is the update matrix from child i
    #
    strt = ptr[ns]
    M = reshape(view(val, strt:strt + na * na - one(I)), na, na)
    #
    # add M to F
    #
    #     F ← F + inj M injᵀ
    #
    addscattertri!(F, M, inj, uplo)
    return
end

"""
    ldlt!(F::ChordalLDLt; check=true, reg=nothing)

Perform an LDLᵀ factorization of a sparse quasi-definite
matrix.

### Basic Usage

Use [`ChordalLDLt`](@ref) to construct a factorization object.
Use [`ldlt!`](@ref) to perform the factorization.

```julia-repl
julia> using CliqueTrees.Multifrontal, LinearAlgebra

julia> A = [
           4  2  0  0  2
           2  5  0  0  3
           0  0  4  2  0
           0  0  2  5  2
           2  3  0  2  7
       ];

julia> F = ldlt!(ChordalLDLt(A))
5×5 FChordalLDLt{:L, Float64, Int64} with 10 stored entries:
 1.0   ⋅    ⋅    ⋅    ⋅ 
 0.0  1.0   ⋅    ⋅    ⋅ 
 0.0  0.5  1.0   ⋅    ⋅ 
 0.5  0.0  0.0  1.0   ⋅ 
 0.0  0.5  0.5  0.5  1.0

 4.0   ⋅    ⋅    ⋅    ⋅ 
  ⋅   4.0   ⋅    ⋅    ⋅ 
  ⋅    ⋅   4.0   ⋅    ⋅ 
  ⋅    ⋅    ⋅   4.0   ⋅ 
  ⋅    ⋅    ⋅    ⋅   4.0
```

### Parameters

   - `F`: quasi-definite matrix
   - `check`: if `check = true`, then the function errors
     if the matrix is singular
   - `reg`: triggers dynamic regularization

"""
function LinearAlgebra.ldlt!(F::ChordalLDLt{UPLO, T, I}; check::Bool=true, reg::Union{DynReg, Nothing}=nothing) where {UPLO, T, I <: Integer}
    Mptr = FVector{I}(undef, F.S.nMptr)
    Mval = FVector{T}(undef, F.S.nMval)
    Fval = FVector{T}(undef, F.S.nFval * F.S.nFval)

    if !isnothing(reg)
        prg = DynReg{T, I}(nov(F.S.res), reg.delta, reg.epsilon)

        for i in outvertices(F.S.res)
            prg.signs[i] = reg.signs[F.perm[i]]
        end
    else
        prg = nothing
    end

    info = ldlt_impl!(Mptr, Mval, F.S.Dptr, F.Dval, F.S.Lptr, F.Lval, F.d, Fval, F.S.res, F.S.rel, F.S.chd, Val{UPLO}(), prg)

    if isnegative(info)
        throw(ArgumentError(info))
    elseif ispositive(info) && check
        throw(SingularException(F.perm[info]))
    elseif ispositive(info) && !check
        F.info[] = F.perm[info]
    else
        F.info[] = zero(I)
    end

    return F
end

function ldlt_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        uplo::Val{UPLO},
        reg::Union{DynReg, Nothing},
    ) where {T, I <: Integer, UPLO}

    ns = zero(I); Mptr[one(I)] = one(I)

    for j in vertices(res)
        ns, localinfo = ldlt_loop!(Mptr, Mval, Dptr, Dval, Lptr, Lval, d, Fval, res, rel, chd, ns, j, uplo, reg)

        if isnegative(localinfo)
            return localinfo
        elseif ispositive(localinfo)
            return localinfo + pointers(res)[j] - one(I)
        end
    end

    return zero(I)
end

function ldlt_loop!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        reg::Union{DynReg, Nothing},
    ) where {T, I <: Integer, UPLO}
    #
    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    nn = eltypedegree(res, j)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁₁     ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₁₁ = view(F, oneto(nn),      oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
    end
    #
    # L is part of the LDLᵀ factor
    #
    #          res(j)
    #     L = [ D₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # d₁₁ is the diagonal for the vertices in res(j)
    #
    d₁₁ = view(d, neighbors(res, j))
    #
    #     F ← 0
    #
    zerotri!(F, uplo)

    for i in Iterators.reverse(neighbors(chd, j))
        #
        # add the update matrix for child i to F
        #
        #   F ← F + Rᵢ Sᵢ Rᵢᵀ
        #
        chol_send!(F, Mptr, Mval, rel, ns, i, uplo)
        ns -= one(I)
    end
    #
    # add F to L
    #
    #     L ← L + F
    #
    addtri!(D₁₁, F₁₁, uplo)
    addrec!(L₂₁, F₂₁)
    #
    # M₂₂ is the update matrix for node j
    #
    if ispositive(na)
        ns += one(I)
        strt = Mptr[ns]
        stop = Mptr[ns + one(I)] = strt + na * na
        M₂₂ = reshape(view(Mval, strt:stop - one(I)), na, na)
        #
        #     M₂₂ ← F₂₂
        #
        copytri!(M₂₂, F₂₂, uplo)
    else
        M₂₂ = reshape(view(Mval, oneto(zero(I))), zero(I), zero(I))
    end
    if !isnothing(reg)
        regview = view(reg, neighbors(res, j))
    else
        regview = nothing
    end

    if nn <= THRESHOLD
        info = convert(I, ldlt_kernel!(D₁₁, L₂₁, M₂₂, d₁₁, uplo, Val(:N), regview))
    else
        info = convert(I, ldlt_kernel!(D₁₁, L₂₁, M₂₂, Fval, d₁₁, uplo, Val(:S), regview))
    end

    if ispositive(na) && ispositive(info)
        ns -= one(I)
    end

    return ns, info
end

function ldlt_kernel!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        S::AbstractMatrix{T},
        Wval::AbstractVector{T},
        d::AbstractVector{T},
        uplo::Val{UPLO},
        node::Val{:S},
        reg::Union{DynReg, Nothing},
    ) where {T, UPLO}
    @assert size(D, 1) == size(D, 2)
    @assert size(S, 1) == size(S, 2)

    if UPLO === :L
        @assert size(L) == (size(S, 1), size(D, 1))
    else
        @assert size(L) == (size(D, 1), size(S, 1))
    end
    #
    # factorize D
    #
    #     D, d ← ldlt(D)
    #
    W₁₁ = reshape(view(Wval, eachindex(D)), size(D))
    info = qdtrf!(uplo, W₁₁, D, d, reg)

    if iszero(info) && !isempty(S)
        #
        #     L ← L D⁻ᴴ
        #
        if UPLO === :L
            trsm!(Val(:R), Val(:L), Val(:C), Val(:U), one(T), D, L)
        else
            trsm!(Val(:L), Val(:U), Val(:C), Val(:U), one(T), D, L)
        end
        #
        #     W ← L
        #
        W₂₁ = reshape(view(Wval, eachindex(L)), size(L))
        copyrec!(W₂₁, L)
        #
        #     L ← L d⁻¹
        #
        if UPLO === :L
            @inbounds for k in axes(L, 2)
                idk = inv(d[k])

                for i in axes(L, 1)
                    L[i, k] *= idk
                end
            end
        else
            @inbounds for i in axes(L, 2)
                for k in axes(L, 1)
                    L[k, i] *= inv(d[k])
                end
            end
        end
        #
        #     S ← S - W Lᴴ
        #
        if UPLO === :L
            trrk!(uplo, Val(:N), W₂₁, L, S)
        else
            trrk!(uplo, Val(:C), W₂₁, L, S)
        end
    end

    return info
end

function ldlt_kernel!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        S::AbstractMatrix{T},
        d::AbstractVector{T},
        uplo::Val{:L},
        node::Val{:N},
        reg::Union{DynReg, Nothing},
    ) where {T}
    @assert size(D, 1) == size(D, 2)
    @assert size(S, 1) == size(S, 2)
    @assert size(L, 1) == size(S, 1)
    @assert size(L, 2) == size(D, 1)

    @inbounds for j in axes(D, 1)
        Djj = real(D[j, j])

        if !isnothing(reg)
            if reg.signs[j] * Djj < reg.epsilon
                Djj = reg.delta * reg.signs[j]
            end
        end

        d[j] = Djj
        iszero(Djj) && return j

        iDjj = inv(Djj)

        for i in j + 1:size(D, 1)
            D[i, j] *= iDjj
        end

        for k in j + 1:size(D, 1)
            Dkj = D[k, j]
            cDkj = Djj * conj(Dkj)

            D[k, k] -= Djj * abs2(Dkj)

            for i in k + 1:size(D, 1)
                D[i, k] -= D[i, j] * cDkj
            end
        end

        syr!(uplo, -iDjj, view(L, :, j), S)

        for i in axes(S, 1)
            L[i, j] *= iDjj
        end

        ger!(-Djj, view(L, :, j), view(D, j + 1:size(D, 1), j), view(L, :, j + 1:size(D, 1)))
    end

    return 0
end

function ldlt_kernel!(
        D::AbstractMatrix{T},
        U::AbstractMatrix{T},
        S::AbstractMatrix{T},
        d::AbstractVector{T},
        uplo::Val{:U},
        node::Val{:N},
        reg::Union{DynReg, Nothing},
    ) where {T}
    @assert size(D, 1) == size(D, 2)
    @assert size(S, 1) == size(S, 2)
    @assert size(U, 1) == size(D, 1)
    @assert size(U, 2) == size(S, 1)

    @inbounds for j in axes(D, 1)
        Djj = real(D[j, j])

        for k in 1:j - 1
            Djj -= abs2(D[k, j]) * d[k]
        end

        if !isnothing(reg)
            if reg.signs[j] * Djj < reg.epsilon
                Djj = reg.delta * reg.signs[j]
            end
        end

        d[j] = Djj
        iszero(Djj) && return j

        iDjj = inv(Djj)

        for i in j + 1:size(D, 1)
            Dji = D[j, i]

            for k in 1:j - 1
                Dji -= conj(D[k, j]) * d[k] * D[k, i]
            end

            D[j, i] = Dji * iDjj
        end

        for i in axes(S, 1)
            Uji = U[j, i]

            for k in 1:j - 1
                Uji -= conj(D[k, j]) * d[k] * U[k, i]
            end

            U[j, i] = Uji
        end

        for k in axes(S, 1)
            Ujk = U[j, k]
            S[k, k] -= iDjj * abs2(Ujk)

            for i in 1:k - 1
                S[i, k] -= iDjj * conj(U[j, i]) * Ujk
            end
        end

        for i in axes(S, 1)
            U[j, i] *= iDjj
        end
    end

    return 0
end

"""
    SupernodeTree{V} <: AbstractVector{UnitRange{V}}

A rooted forest T = (V, E) and a function snd: U → V.
This type implements the [indexed tree interface](https://juliacollections.github.io/AbstractTrees.jl/stable/#The-Indexed-Tree-Interface).
"""
struct SupernodeTree{V} <: AbstractVector{UnitRange{V}}
    """
    The rooted forest T.
    """
    tree::Tree{V, FVector{V}, FVector{V}, FVector{V}}

    """
    A directed bipartite graph G = (U, V, E') with an arc

        (snd(u), u) ∈ E'

    for all vertices u ∈ U.
    """
    graph::BipartiteGraph{V, V, FVector{V}, OneTo{V}}

    function SupernodeTree{V}(tree::Tree, graph::BipartiteGraph) where {V}
        @assert last(tree) == nv(graph)
        @assert ne(graph) == nov(graph)
        return new{V}(tree, graph)
    end
end

function SupernodeTree(tree::Tree{V}, graph::BipartiteGraph{V}) where {V}
    return SupernodeTree{V}(tree, graph)
end

function Tree(tree::SupernodeTree)
    return Tree(tree.tree)
end

"""
    supernodetree(graph;
        alg::PermutationOrAlgorithm=DEFAULT_ELIMINATION_ALGORITHM,
        snd::SupernodeType=DEFAULT_SUPERNODE_TYPE)

Construct a supernodal elimination tree.
"""
function supernodetree(
        graph;
        alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM,
        snd::SupernodeType = DEFAULT_SUPERNODE_TYPE,
    )
    order, tree = supernodetree(graph, alg, snd)
    return order, tree
end

function supernodetree(
        weights::AbstractVector,
        graph;
        alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM,
        snd::SupernodeType = DEFAULT_SUPERNODE_TYPE,
    )
    order, tree = supernodetree(weights, graph, alg, snd)
    return order, tree
end

function supernodetree(graph, alg::PermutationOrAlgorithm, snd::SupernodeType)
    return supernodetree(BipartiteGraph(graph), alg, snd)
end

function supernodetree(graph::AbstractGraph{V}, alg::PermutationOrAlgorithm, snd::SupernodeType) where {V}
    n = nv(graph); weights = Ones{V}(n)
    return supernodetree(weights, graph, alg, snd)
end

function supernodetree(weights::AbstractVector, graph, alg::PermutationOrAlgorithm, snd::SupernodeType)
    return supernodetree(weights, BipartiteGraph(graph), alg, snd)
end

function supernodetree(weights::AbstractVector, graph::AbstractGraph{V}, alg::PermutationOrAlgorithm, snd::SupernodeType) where {V}
    E = etype(graph); n = nv(graph); m = half(de(graph))
    nn = n + one(V); nnn = nn + one(V)

    target1 = FVector{V}(undef, max(m, nn))
    target2 = FVector{V}(undef, m)
    target3 = FVector{V}(undef, n)

    pointer1 = FVector{E}(undef, nn)
    pointer2 = FVector{E}(undef, nn)
    pointer3 = FVector{V}(undef, nnn)

    colcount = FVector{V}(undef, n)
    elmorder = FVector{V}(undef, n)
    elmindex = FVector{V}(undef, n)
    sndptr = FVector{V}(undef, nn)
    sepptr = FVector{E}(undef, nn)
    new = FVector{V}(undef, n)
    parent = FVector{V}(undef, n)
    elmtree = Parent{V}(n)

    order, index = permutation(weights, graph, alg)

    sndtree, upper, lower = supernodetree_impl!(target1, target2,
        target3, pointer1, pointer2, pointer3, colcount,
        elmorder, elmindex, sndptr, sepptr, new, parent, elmtree, graph,
        order, index, snd)

    return order, sndtree        
end

function supernodetree_impl!(
        target1::AbstractVector{V},
        target2::AbstractVector{V},
        target3::AbstractVector{V},
        pointer1::AbstractVector{E},
        pointer2::AbstractVector{E},
        pointer3::AbstractVector{V},
        colcount::AbstractVector{V},
        elmorder::AbstractVector{V},
        elmindex::AbstractVector{V},
        sndptr::AbstractVector{V},
        sepptr::AbstractVector{E},
        new::AbstractVector{V},
        parent::AbstractVector{V},
        elmtree::Parent{V},
        graph::AbstractGraph{V},
        order::AbstractVector{V},
        index::AbstractVector{V},
        snd::SupernodeType,
    ) where {V, E}

    n = nv(graph)

    upper = eliminationtree_impl!(elmorder,
        pointer1, target1, elmtree, graph, index)

    lower = reverse!_impl!(pointer2, target2, upper)

    supcnt_impl!(colcount, new, parent, index, elmorder,
        elmindex, sndptr, UnionFind(n, target1, pointer3, target3),
        Ones{V}(n), lower, elmtree)

    ancestor = index

    tree = stree_impl!(new, parent, ancestor, elmorder,
        tree_impl!(pointer3, target3, elmtree),
        colcount, snd)

    postorder!_impl!(target1, sndptr, elmindex, elmorder, tree)

    for i in tree
        elmorder[elmindex[i]] = i
    end

    sndptr[begin] = one(V)
    sepptr[begin] = one(E)

    for i in tree
        ii = i + one(V); j = elmorder[i]
        u = new[j]
        p = elmindex[u] = sndptr[i]

        for v in ancestorindices(elmtree, u)
            v == ancestor[j] && break
            elmindex[v] = p += one(V)
        end

        sepptr[ii] = sepptr[i] + convert(E, sndptr[i] + colcount[u] - p) - one(E)
        sndptr[ii] = p + one(V)
    end

    for v in oneto(n)
        elmorder[v] = order[v]
    end

    for v in oneto(n)
        order[elmindex[v]] = elmorder[v]
    end

    h = last(tree)
    residual = BipartiteGraph(n, h, n, sndptr, oneto(n))
    sndtree = SupernodeTree(tree_impl!(pointer3, target3, tree), residual)
    return sndtree, upper, lower
end

"""
    residuals(tree::SupernodeTree)

Get the residuals of a supernodal elimination tree.
"""
function residuals(tree::SupernodeTree)
    return tree.graph
end

function Base.copy(tree::SupernodeTree)
    return SupernodeTree(copy(tree.tree), copy(tree.graph))
end

function Base.copy!(dst::SupernodeTree, src::SupernodeTree)
    copy!(dst.tree, src.tree)
    copy!(dst.graph, src.graph)
    return dst
end

function Base.:(==)(left::SupernodeTree, right::SupernodeTree)
    return left.tree == right.tree && left.graph == right.graph
end

##########################
# Indexed Tree Interface #
##########################

function AbstractTrees.rootindex(tree::SupernodeTree)
    return rootindex(tree.tree)
end

function AbstractTrees.parentindex(tree::SupernodeTree, i::Integer)
    return parentindex(tree.tree, i)
end

function rootindices(tree::SupernodeTree)
    return rootindices(tree.tree)
end

function AbstractTrees.childindices(tree::SupernodeTree, i::Integer)
    return childindices(tree.tree, i)
end

function ancestorindices(tree::SupernodeTree, i::Integer)
    return ancestorindices(tree.tree, i)
end

#############################
# Abstract Vector Interface #
#############################

function Base.getindex(tree::SupernodeTree{V}, i::Integer) where {V}
    return neighbors(tree.graph, i)
end

function Base.IndexStyle(::Type{<:SupernodeTree})
    return IndexLinear()
end

function Base.size(tree::SupernodeTree)
    return size(tree.tree)
end

function LinearAlgebra.logdet(A::SparseMatrixCSC, F::ChordalCholesky)
    return logdet(Hermitian(A), F)
end

function LinearAlgebra.logdet(A::HermOrSymSparse, F::ChordalCholesky)
    return logdet(F)
end

# ===== frule =====

function logdet_frule_impl(A::HermOrSymSparse, F::ChordalCholesky, dA::HermOrSymSparse)
     y = logdet(A, F)
    dy = symdot(selinv(A, F), dA)
    return y, dy
end

function logdet_rrule_frule_impl!(ΣA::HermOrSymSparse, dΣA::HermOrSymSparse, A::HermOrSymSparse, dA::HermOrSymSparse, F::ChordalCholesky, Δy::Number, dΔy::Number)
    if !iszero(Δy)
        B, dB = selinv_frule_impl(A, F, dA)
        scldia!( B, 1 / 2)
        scldia!(dB, 1 / 2)
        selaxpy!( 2Δy,  B,  ΣA)
        selaxpy!(2dΔy,  B, dΣA)
        selaxpy!( 2Δy, dB, dΣA)
    elseif !iszero(dΔy)
        B = selinv(A, F)
        scldia!(B, 1 / 2)
        selaxpy!(2dΔy, B, dΣA)
    end

    return ΣA, dΣA
end

# ===== rrule =====

Base.@noinline function logdet_rrule_impl!(ΣA::HermOrSymSparse, A::HermOrSymSparse, F::ChordalCholesky, y::Number, Δy::Number)
    if !iszero(Δy)
        B = selinv(A, F)
        scldia!(B, 1/2)
        selaxpy!(2Δy, B, ΣA)
    end

    return ΣA
end

struct FilledEdgeIter{V, E} <: AbstractEdgeIter
    graph::FilledGraph{V, E}
end

function Base.show(io::IO, iter::FilledEdgeIter)
    printiterator(io, iter)
    return
end

############################
# Abstract Graph Interface #
############################

function Graphs.edgetype(::FilledGraph{V}) where {V}
    return SimpleEdge{V}
end

function Graphs.edges(graph::FilledGraph)
    return FilledEdgeIter(graph)
end

#######################
# Iteration Interface #
#######################

function Base.iterate(iter::FilledEdgeIter{V}, (i, p)::Tuple{V, V} = (one(V), one(V))) where {V}
    graph = iter.graph; ii = i + one(V); pp = p + one(V)
    result = nothing

    if i <= nv(graph)
        @inbounds clique = neighbors(graph, i)
        @inbounds degree = eltypedegree(graph, i)

        if p <= degree
            @inbounds j = clique[p]
            edge = SimpleEdge(i, j)

            if p < degree
                state = (i, pp)
            else
                state = (ii, one(V))
            end

            result = (edge, state)
        else
            state = (ii, one(V))
            result = iterate(iter, state)
        end
    end

    return result
end

function Base.length(iter::FilledEdgeIter)
    m::Int = ne(iter.graph)
    return m
end

function Base.eltype(::Type{<:FilledEdgeIter{V}}) where {V}
    return SimpleEdge{V}
end

function Base.in(edge, iter::FilledEdgeIter)
    return has_edge(iter.graph, edge)
end

function Base.hasfastin(::Type{<:FilledEdgeIter})
    return true
end

module KaHyParExt

using Base: oneto
using Base.Order
using CliqueTrees
using CliqueTrees: EliminationAlgorithm, Parent, UnionFind, bestfill_impl!, bestwidth_impl!, compositerotations_impl!, hpartition!, sympermute!_impl!, nov, outvertices, simplegraph, qcc
using CliqueTrees.Utilities
using Graphs

import KaHyPar

const WINT1 = KaHyPar.kahypar_hypernode_weight_t
const WINT2 = KaHyPar.kahypar_hyperedge_weight_t
const VINT1 = KaHyPar.kahypar_hypernode_id_t
const VINT2 = KaHyPar.kahypar_hyperedge_id_t
const EINT = KaHyPar.Csize_t
const PINT = KaHyPar.kahypar_partition_id_t

function CliqueTrees.permutation(weights::AbstractVector, graph::AbstractGraph, alg::ND{<:Any, <:EliminationAlgorithm, <:KaHyParND})
    order = dissect(weights, graph, alg)
    return order, invperm(order)
end

function separator!(sepsize::AbstractScalar{WINT2}, part::AbstractVector{PINT}, vwght::AbstractVector{WINT1}, ewght::AbstractVector{WINT2}, graph::BipartiteGraph{VINT2, EINT}, imbalance::PINT, alg::KaHyParND)
    @assert nov(graph) <= length(part)
    @assert nov(graph) <= length(vwght)
    @assert nv(graph) <= length(ewght)

    m = ne(graph); n = nv(graph); nn = n + one(VINT2)

    @inbounds for v in oneto(nn)
        pointers(graph)[v] -= one(EINT)
    end

    @inbounds for p in oneto(m)
        targets(graph)[p] -= one(VINT2)
    end

    imbalance -= convert(PINT, 100)

    context = KaHyPar.kahypar_context_new()
    KaHyPar.kahypar_configure_context_from_file(context, joinpath(@__DIR__, "config/cut_kKaHyPar_sea20.ini"))

    KaHyPar.kahypar_partition(
        convert(VINT1, nov(graph)),
        nv(graph),
        convert(Cdouble, imbalance) / convert(Cdouble, 1000),
        two(PINT),
        vwght,
        ewght,
        pointers(graph),
        targets(graph),
        sepsize,
        context,
        part,
    )

    @inbounds for v in oneto(nn)
        pointers(graph)[v] += one(EINT)
    end

    @inbounds for p in oneto(m)
        targets(graph)[p] += one(VINT2)
    end

    return
end

function dissect(weights::AbstractVector{W}, graph::AbstractGraph, alg::ND) where {W}
    n = nv(graph)
    scale = convert(W, alg.scale)
    intweights = FVector{PINT}(undef, n)

    @inbounds for v in oneto(n)
        w = weights[v]

        if W <: AbstractFloat
            w *= scale
        end

        intweights[v] = trunc(PINT, w)
    end

    return dissect(intweights, graph, alg)
end

function dissect(weights::FVector{WINT2}, graph::AbstractGraph{V}, alg::ND) where {V}
    simple = simplegraph(PINT, PINT, graph)
    cover = qcc(VINT2, EINT, simple, alg.dis.beta, alg.dis.order)
    order = convert(Vector{V}, dissectsimple(weights, reverse(cover), simple, alg))
    return order
end

function dissectsimple(weights::AbstractVector{WINT2}, hgraph::BipartiteGraph{VINT2, EINT}, graph::BipartiteGraph{PINT, PINT}, alg::ND{S}) where {S}
    h = nov(hgraph); n = nv(graph); m = ne(graph); nn = n + one(PINT)
    maxlevel = convert(PINT, alg.level)
    minwidth = convert(WINT2, alg.width)
    imbalance = convert(PINT, alg.imbalance)

    work00 = FScalar{WINT2}(undef)
    work01 = Vector{PINT}(undef, m)
    work02 = Vector{PINT}(undef, m)
    work03 = FVector{PINT}(undef, max(h, n))
    work04 = FVector{PINT}(undef, n)
    work05 = FVector{PINT}(undef, max(h, n))
    work06 = FVector{PINT}(undef, max(h, n))
    work07 = FVector{WINT2}(undef, n)
    work08 = FVector{WINT2}(undef, n)
    work09 = FVector{PINT}(undef, nn)
    work10 = FVector{PINT}(undef, nn)
    work11 = FVector{PINT}(undef, n)
    work12 = FVector{PINT}(undef, n)
    work13 = FVector{PINT}(undef, n)
    work14 = FVector{PINT}(undef, n)
    work15 = FVector{PINT}(undef, n)
    work16 = FVector{PINT}(undef, n)
    hwght = FVector{WINT1}(undef, h)

    @inbounds for v in oneto(h)
        hwght[v] = one(WINT1)
    end

    parts = FVector{PINT}[]
    orders = FVector{PINT}[]

    nodes = Tuple{
        BipartiteGraph{VINT2, EINT, FVector{EINT}, FVector{VINT2}}, # hgraph
        BipartiteGraph{PINT, PINT, FVector{PINT}, FVector{PINT}},   # graph
        FVector{PINT},                                              # weights
        BipartiteGraph{PINT, PINT, FVector{PINT}, FVector{PINT}},   # label
        FVector{PINT},                                              # clique
        PINT,                                                       # level
    }[]

    label = BipartiteGraph{PINT, PINT}(n, n, n)
    clique = FVector{PINT}(undef, zero(PINT))
    level = zero(PINT)

    @inbounds for v in oneto(n)
        pointers(label)[v] = v
        targets(label)[v] = v
    end

    pointers(label)[nn] = nn
    push!(nodes, (hgraph, graph, weights, label, clique, level))

    @inbounds while !isempty(nodes)
        hgraph, graph, weights, label, clique, level = pop!(nodes)
        n = nv(graph); m = ne(graph); l = ne(label); k = convert(PINT, length(clique))

        if !isnegative(level) # unprocessed
            isleaf = n <= minwidth || level >= maxlevel || m == n * (n - one(PINT))

            if isleaf # leaf
                push!(nodes, (hgraph, graph, weights, label, clique, -one(PINT)))
            else      # branch
                if m > length(work01)
                    resize!(work01, half(m))
                    resize!(work02, half(m))
                end

                part = FVector{PINT}(undef, n)
                separator!(work00, work03, hwght, weights, hgraph, imbalance, alg.dis)

                child0, child1, order2 = hpartition!(work00, work14, work04, work07, work08,
                     work11, work12, work13, work09, work10, work01, work02, work15, work16,
                     work05, work06, work03, part, weights, hgraph, graph)

                push!(
                    nodes,
                    (hgraph, graph, weights, label, clique, -two(PINT)),
                    (child0..., level + one(PINT)),
                    (child1..., level + one(PINT)),
                )

                push!(parts, part)
                push!(orders, order2)
            end
        else                  # processed
            isleaf = isone(-level)
            iscomplete = m == n * (n - one(PINT))

            if iscomplete # complete graph
                for v in oneto(n)
                    work03[v] = v
                end
            else
                tree = Parent(n, work06)
                upper = BipartiteGraph(n, n, half(m), work09, work01)
                lower = BipartiteGraph(n, n, half(m), work10, work02)

                if isleaf # leaf
                    order, index = permutation(weights, graph, alg.alg)
                else      # branch
                    part = pop!(parts)
                    ndsorder = Vector{PINT}(undef, n)
                    ndsindex = Vector{PINT}(undef, n)
                    i = zero(PINT)

                    for v in pop!(orders)
                        if !istwo(part[v])
                            ndsindex[v] = i += one(PINT)
                            ndsorder[i] = v
                        end
                    end

                    for v in pop!(orders)
                        if !istwo(part[v])
                            ndsindex[v] = i += one(PINT)
                            ndsorder[i] = v
                        end
                    end

                    for v in pop!(orders)
                        ndsindex[v] = i += one(PINT)
                        ndsorder[i] = v
                    end

                    if isone(S) || istwo(S)
                        sets = UnionFind(n, work03, work04, work05)
                        grdorder, grdindex = permutation(weights, graph, alg.alg)

                        if isone(S)
                            best = bestwidth_impl!(lower, upper, tree, sets, work07,
                                work08, work11, work12, work13, work14, work15,
                                work16, weights, graph, (ndsindex, grdindex))
                        else
                            best = bestfill_impl!(lower, upper, tree, sets, work07,
                                work08, work11, work12, work13, work14, work15,
                                work16, weights, graph, (ndsindex, grdindex))
                        end

                        order = (ndsorder, grdorder)[best]
                        index = (ndsindex, grdindex)[best]
                    else
                        order, index = ndsorder, ndsindex
                    end
                end

                sympermute!_impl!(upper, graph, index, Forward)

                for i in oneto(k)
                    clique[i] = index[clique[i]]
                end

                compositerotations_impl!(index, work03, work04,
                    work05, lower, tree, upper, clique)

                for v in oneto(n)
                    i = index[v]; work03[i] = order[v]
                end
            end

            j = zero(PINT); outorder = FVector{PINT}(undef, l)

            for i in oneto(n)
                v = work03[i]

                for w in neighbors(label, v)
                    j += one(PINT); outorder[j] = w
                end
            end

            push!(orders, outorder)
        end
    end

    return only(orders)
end

end

# Treewidth.jl — faithful transpilation of Tamaki_Tree_Decomp/Treewidth.cs
# Contains the core DP algorithm for computing exact treewidth.
# Uses the blocksieve path (C# #define blocksieve).
# Graph reduction is SKIPPED (input is assumed pre-reduced).
# All vertex indices are 1-based.

const COMPLETE_HEURISTICALLY = true
const HEURISTIC_COMPLETION_FREQUENCY = 1
const TEST_OUTLET_IS_CLIQUE_MINOR = true
const MORE_THAN_2_COMPONENTS_OPTIMIZATION = true
const HEURISTIC_INLET_MIN = 0.0f0
const HEURISTIC_INLET_MAX = 1.0f0
const MAX_TESTS_PER_GRAPH_AND_K = typemax(Int)

@enum State Continue Divide Halt

# ---------------------------------------------------------------------------
# Main entry point  (C# TreeWidth, lines 27-51)
# ---------------------------------------------------------------------------

"""
    treewidth(graph::Graph{PSet}, weights::Vector{Int}; min_k::Int=0) where {PSet}

Compute the exact treewidth of `graph` and return `(treewidth, ptd)` where
`ptd` is a `(pool, root_index)` tuple.

`min_k` is a lower bound on the treewidth. The DP search begins at this value,
so supplying a tight lower bound (e.g. from MMD+) avoids wasted iterations.
"""
function treewidth(weights::Vector{Int}, graph::Graph{PSet}; min_k::Int=0) where {PSet}
    # Edge cases
    if nv(graph) == 0
        pool = PTDPool{PSet}()
        root = make_ptd(pool, PSet())
        return (0, (pool, root))
    elseif nv(graph) == 1
        pool = PTDPool{PSet}()
        v = first(vertices(graph))
        only_bag = packedset(PSet, v)
        root = add_vertex!(pool, PTD{PSet}(only_bag, only_bag, PSet()))
        return (weights[v] - 1, (pool, root))
    end

    return treewidth_computation(weights, graph, min_k)
end

# ---------------------------------------------------------------------------
# Achievable subset sums of vertex weights
# ---------------------------------------------------------------------------

function achievable_sums(weights::Vector{Int}, graph::Graph{PSet}) where {PSet}
    W = wt(weights, vertices(graph))
    achievable = falses(W + 1)
    achievable[1] = true  # 0 is achievable (1-indexed: index 1 = sum 0)

    for v in vertices(graph)
        w = weights[v]

        for j in W:-1:w
            achievable[j + 1] |= achievable[j + 1 - w]
        end
    end

    sums = Int[]

    for j in 0:W
        if achievable[j + 1]
            push!(sums, j - 1)
        end
    end

    return sums
end

# ---------------------------------------------------------------------------
# Orchestrator  (C# TreeWidth_Computation, lines 63-297)
# ---------------------------------------------------------------------------

function treewidth_computation(weights::Vector{Int}, graph::Graph{PSet}, lower_bound::Int) where {PSet}
    outlets_already_checked = Set{PSet}()

    min_k = lower_bound

    pool = PTDPool{PSet}()
    sums = achievable_sums(weights, graph)

    sub_graphs = Graph{PSet}[graph]
    separators = PSet[]                          # index j -> separator
    separator_subgraph_indices = Int[]           # index j -> subgraph index i
    child_stop = Int[1]                      # children for sep j = child_stop[j]+1 : child_stop[j+1]
    ptd_roots = Int[]                            # index i -> root index (0 = pending)

    for (i, graph_i) in enumerate(sub_graphs)
        # Loop over possible treewidths for the current subgraph (C# line 141)
        first_k = true

        while min_k < wt(weights, vertices(graph_i)) - 1
            # Break early if no vertices remain (C# lines 152-161)
            if nv(graph_i) == 0
                push!(ptd_roots, make_ptd(pool, PSet()))
                break
            end

            if first_k
                empty!(outlets_already_checked)
            end

            immutable_graph = CachedGraph(graph_i)

            state, tree_decomp_root, outlet_safe_sep = has_treewidth(
                pool, weights, immutable_graph, min_k, graph_i, outlets_already_checked)

            if state == Halt
                push!(ptd_roots, tree_decomp_root)
                break
            elseif state == Divide
                tree_decomp_data = pool[tree_decomp_root]
                separated_graphs, already_calc_idx, min_k = apply_externally_found_safe_separator!(
                    weights, graph_i, outlet_safe_sep, min_k, inlet(tree_decomp_data))

                append!(sub_graphs, separated_graphs)

                push!(separators, outlet_safe_sep)
                push!(separator_subgraph_indices, i)
                push!(child_stop, length(sub_graphs))
                push!(ptd_roots, 0)

                # Continue with the next graph
                break
            end

            j = searchsortedfirst(sums, min_k + 1)
            min_k = sums[j]
            first_k = false
        end

        # If graph is smaller than min bound (all vertices form a single bag) (C# lines 268-271)
        if length(ptd_roots) < i
            push!(ptd_roots, make_ptd(pool, vertices(graph_i)))
        end

    end

    # Recombine subgraphs that have been safe separated (C# lines 277-293)
    for j in length(separators):-1:1
        parent_idx = separator_subgraph_indices[j]
        children = child_stop[j] + 1 : child_stop[j + 1]
        ptd_roots[parent_idx] = recombine_tree_decompositions(pool, separators[j], view(ptd_roots, children))
    end

    return (min_k, (pool, ptd_roots[1]))
end

# ---------------------------------------------------------------------------
# Core DP algorithm  (C# HasTreeWidth, lines 317-736)
#
# Uses the blocksieve path.
# Returns (found::Bool, root_or_nothing::Union{Int, Nothing}, outlet_safe_sep::Union{PSet, Nothing}).
# ---------------------------------------------------------------------------

function has_treewidth(pool::PTDPool{PSet}, weights::Vector{Int}, graph::CachedGraph{PSet}, k::Int, mutable_graph::Graph{PSet},
                       outlets_already_checked::Set{PSet}) where {PSet}
    if nv(graph) == 0
        return (Halt, make_ptd(pool, PSet()), PSet())
    end

    ptd_roots = Int[]              # Stack of root indices (push!/pop!)
    ptd_inlets = Set{PSet}()

    sieve = LayeredSieve{PSet}(k, weights)
    ptdur_inlets = Dict{PSet, Int}()    # inlet -> ptdur root index

    is_small_pmc = Vector{Bool}(undef, domain(PSet))
    work = Vector{PSet}(undef, domain(PSet))

    # moreThan2ComponentsOptimization data structures (C# lines 345-346)
    if MORE_THAN_2_COMPONENTS_OPTIMIZATION
        cmp_to_ptd_roots = Dict{PSet, Vector{Int}}()
        ptd_root_to_cmps = Dict{Int, Int}()
    else
        cmp_to_ptd_roots = nothing
        ptd_root_to_cmps = nothing
    end

    heuristic_completion_in = 1
    current_tests_per_gk = 0

    # --------- lines 2 to 6: Initialize PTDs from vertex neighborhoods ----------
    # (C# lines 357-380)

    for v in vertices(graph)
        N = neighbors(graph, v) ∪ v
        is_small_pmc[v] = flag = wt(weights, N) <= k + 1 && is_pmc!(work, graph, N)

        if flag
            ptd_root = make_ptd(pool, N, neighbors(graph, setdiff(vertices(graph), N)))
            ptd_data = pool[ptd_root]
            S = outlet(ptd_data)
            R = inlet(ptd_data)

            if R ∉ ptd_inlets && !is_incoming(pool, ptd_root, graph)
                is_min_sep, cmps = is_minimal_separator(graph, S)
                is_min_sep && _add_to_p!(pool, ptd_root, cmps, graph, ptd_roots, ptd_inlets, cmp_to_ptd_roots, ptd_root_to_cmps)
            end
        end
    end

    # --------- lines 7 to 32: Main DP loop ----------
    # (C# lines 384-721)

    while !isempty(ptd_roots)
        ptd_root = pop!(ptd_roots)

        # --------- line 9 ----------
        ptdur_root_1 = create_ptdur_from_ptd(pool, ptd_root)

        # --------- line 10: add PTDUR to U ----------
        # (C# lines 400-421, blocksieve path)
        ptdur_data_1 = pool[ptdur_root_1]
        V_1 = vertices(ptdur_data_1)
        B_1 = bag(ptdur_data_1)
        R_1 = inlet(ptdur_data_1)

        if haskey(ptdur_inlets, R_1)
            ptdur_root_0 = ptdur_inlets[R_1]
            ptdur_data_0 = pool[ptdur_root_0]
            B_0 = bag(ptdur_data_0)

            if wt(weights, B_1) < wt(weights, B_0)
                replace_subset!(sieve, ptdur_root_0, B_0, ptdur_root_1, B_1, V_1)
                ptdur_inlets[R_1] = ptdur_root_1
                rem_vertex!(pool, ptdur_root_0)
            else
                rem_vertex!(pool, ptdur_root_1)
                continue
            end
        else
            ptdur_inlets[R_1] = ptdur_root_1
            sieve[ptdur_root_1] = (B_1, V_1)
            flush!(sieve)
        end

        # --------- lines 11-32: iterate over eligible PTDURs ----------
        # (C# lines 448-718)
        ptd_data = pool[ptd_root]
        R = inlet(ptd_data)
        S = outlet(ptd_data)

        for ptdur_root_2 in query(sieve, R, S, ptdur_root_1)
            ptdur_data_2 = pool[ptdur_root_2]
            R_2 = inlet(ptdur_data_2)

            # --------- lines 12-15 ----------
            # (C# lines 460-520)
            if R_1 != R_2
                success, new_root = add_ptd_to_ptdur_check(work, pool, ptdur_root_2, ptd_root, weights, graph, k, mutable_graph)
                success || continue
   
                ptdur_root_3 = new_root

                # Add to U (blocksieve path, C# lines 470-492)
                ptdur_data_3 = pool[ptdur_root_3]
                V_3 = vertices(ptdur_data_3)
                B_3 = bag(ptdur_data_3)
                R_3 = inlet(ptdur_data_3)

                if haskey(ptdur_inlets, R_3)
                    ptdur_root_0 = ptdur_inlets[R_3]
                    ptdur_data_0 = pool[ptdur_root_0]
                    B_0 = bag(ptdur_data_0)

                    if wt(weights, B_3) < wt(weights, B_0)
                        replace_subset!(sieve, ptdur_root_0, B_0, ptdur_root_3, B_3, V_3)
                        ptdur_inlets[R_3] = ptdur_root_3
                        rem_vertex!(pool, ptdur_root_0)
                    else
                        rem_vertex!(pool, ptdur_root_3)
                        continue
                    end
                else
                    sieve[ptdur_root_3] = (B_3, V_3)
                    ptdur_inlets[R_3] = ptdur_root_3
                end
            else
                ptdur_root_3 = ptdur_root_1
            end

            ptdur_data_3 = pool[ptdur_root_3]
            B_3 = bag(ptdur_data_3)
            ptdur_size = wt(weights, B_3)

            # --------- lines 16-20: Rule 1 - Check if completion ----------
            if ptdur_size == k + 1 || is_pmc!(work, graph, B_3)
                state, root, sep, heuristic_completion_in, current_tests_per_gk =
                    _rule1!(pool, ptdur_root_3, ptd_root, weights, graph, k, mutable_graph,
                            ptd_roots, ptd_inlets, cmp_to_ptd_roots, ptd_root_to_cmps, outlets_already_checked,
                            heuristic_completion_in, current_tests_per_gk)

                state == Continue || return (state, root, sep)
            else
                # --------- lines 21-26: Rule 2 ----------
                state, root, sep, heuristic_completion_in, current_tests_per_gk =
                    _rule2!(pool, ptdur_root_3, ptdur_data_3, ptd_root, weights, graph, k, mutable_graph,
                            is_small_pmc, ptd_roots, ptd_inlets, cmp_to_ptd_roots, ptd_root_to_cmps, outlets_already_checked,
                            heuristic_completion_in, current_tests_per_gk)

                state == Continue || return (state, root, sep)

                # --------- lines 27-32: Rule 3 ----------
                state, root, sep, heuristic_completion_in, current_tests_per_gk =
                    _rule3!(work, pool, ptdur_root_3, ptdur_data_3, ptd_root, weights, graph, k, mutable_graph,
                            ptd_roots, ptd_inlets, cmp_to_ptd_roots, ptd_root_to_cmps, outlets_already_checked,
                            heuristic_completion_in, current_tests_per_gk)

                state == Continue || return (state, root, sep)
            end
        end

        # Flush deferred additions (C# lines 719-721, blocksieve path)
        flush!(sieve)
    end

    return (Continue, 0, PSet())
end

# ---------------------------------------------------------------------------
# Rule 1: Check if completion (C# lines 530-580)
# ---------------------------------------------------------------------------

function _rule1!(pool::PTDPool{PSet}, ptdur_root::Int, ptd_root::Int,
                 weights::Vector{Int}, graph::CachedGraph{PSet}, k::Int, mutable_graph::Graph{PSet},
                 ptd_roots::Vector{Int}, ptd_inlets::Set{PSet}, cmp_to_ptd_roots, ptd_root_to_cmps,
                 outlets_already_checked::Set{PSet},
                 heuristic_completion_in::Int, current_tests_per_gk::Int) where {PSet}
    new_ptd_root = copy_ptd(pool, ptdur_root)
    consumed = false
    new_ptd_data = pool[new_ptd_root]
    V_new = vertices(new_ptd_data)
    R_new = inlet(new_ptd_data)
    S_new = outlet(new_ptd_data)

    if V_new == vertices(graph)
        return (Halt, new_ptd_root, PSet(), heuristic_completion_in, current_tests_per_gk)
    end

    if !(R_new in ptd_inlets)
        is_ms, cmps = is_minimal_separator(graph, S_new)

        if is_ms && !is_incoming(pool, new_ptd_root, graph) && is_normalized(pool, new_ptd_root)
            heuristic_completion_in -= 1

            if COMPLETE_HEURISTICALLY && heuristic_completion_in == 0
                success, current_tests_per_gk =
                    _try_heuristic_completion!(pool, weights, graph, new_ptd_root, k, mutable_graph,
                        current_tests_per_gk)

                if success
                    return (Halt, new_ptd_root, PSet(), heuristic_completion_in, current_tests_per_gk)
                end
            end
            if heuristic_completion_in < 0
                heuristic_completion_in = HEURISTIC_COMPLETION_FREQUENCY
            end

            if _outlet_is_safe_separator(pool, new_ptd_root, weights, graph, mutable_graph, outlets_already_checked)
                return (Divide, new_ptd_root, outlet(pool[ptd_root]), heuristic_completion_in, current_tests_per_gk)
            end

            _add_to_p!(pool, new_ptd_root, cmps, graph, ptd_roots, ptd_inlets, cmp_to_ptd_roots, ptd_root_to_cmps)
            consumed = true
        end
    end

    consumed || rem_vertex!(pool, new_ptd_root)

    return (Continue, 0, PSet(), heuristic_completion_in, current_tests_per_gk)
end

# ---------------------------------------------------------------------------
# Rule 2: Extend via vertex neighborhood (C# lines 582-648)
# ---------------------------------------------------------------------------

function _rule2!(pool::PTDPool{PSet}, ptdur_root::Int, ptdur_data::PTD{PSet}, ptd_root::Int,
                 weights::Vector{Int}, graph::CachedGraph{PSet}, k::Int, mutable_graph::Graph{PSet},
                 is_small_pmc::Vector{Bool},
                 ptd_roots::Vector{Int}, ptd_inlets::Set{PSet}, cmp_to_ptd_roots, ptd_root_to_cmps,
                 outlets_already_checked::Set{PSet},
                 heuristic_completion_in::Int, current_tests_per_gk::Int) where {PSet}
    V = vertices(ptdur_data)
    B = bag(ptdur_data)
    S = outlet(ptdur_data)

    # Compute candidates: common neighbors of all outlet vertices, minus vertices already covered
    candidates = vertices(graph)
    first_outlet = true
    remaining = S

    while !isempty(remaining)
        v, remaining = popfirst_nonempty(remaining)
        if first_outlet
            candidates = neighbors(graph, v)
            first_outlet = false
        else
            candidates = candidates ∩ neighbors(graph, v)
        end
    end
    if first_outlet
        candidates = PSet()  # empty outlet => no candidates
    end

    candidates = setdiff(candidates, V)

    # Process each candidate
    remaining = candidates

    while !isempty(remaining)
        v, remaining = popfirst_nonempty(remaining)

        N = neighbors(graph, v) ∪ v

        if is_small_pmc[v] && N ⊇ B
            new_ptd_root = extend_to_pmc_rule2(pool, ptdur_root, N, graph)
            consumed = false
            new_ptd_data = pool[new_ptd_root]
            V_new = vertices(new_ptd_data)
            R_new = inlet(new_ptd_data)
            S_new = outlet(new_ptd_data)

            if V_new == vertices(graph)
                return (Halt, new_ptd_root, PSet(), heuristic_completion_in, current_tests_per_gk)
            end

            heuristic_completion_in -= 1

            if !(R_new in ptd_inlets)
                is_ms, cmps = is_minimal_separator(graph, S_new)

                if is_ms && !is_incoming(pool, new_ptd_root, graph) && is_normalized(pool, new_ptd_root)
                    if COMPLETE_HEURISTICALLY && heuristic_completion_in == 0
                        success, current_tests_per_gk =
                            _try_heuristic_completion!(pool, weights, graph, new_ptd_root, k, mutable_graph,
                                current_tests_per_gk)

                        if success
                            return (Halt, new_ptd_root, PSet(), heuristic_completion_in, current_tests_per_gk)
                        end
                    end
                    if heuristic_completion_in < 0
                        heuristic_completion_in = HEURISTIC_COMPLETION_FREQUENCY
                    end

                    if _outlet_is_safe_separator(pool, new_ptd_root, weights, graph, mutable_graph, outlets_already_checked)
                        return (Divide, new_ptd_root, outlet(pool[ptd_root]), heuristic_completion_in, current_tests_per_gk)
                    end

                    _add_to_p!(pool, new_ptd_root, cmps, graph, ptd_roots, ptd_inlets, cmp_to_ptd_roots, ptd_root_to_cmps)
                    consumed = true
                end
            end

            consumed || rem_vertex!(pool, new_ptd_root)
        end
    end

    return (Continue, 0, PSet(), heuristic_completion_in, current_tests_per_gk)
end

# ---------------------------------------------------------------------------
# Rule 3: Extend by adding neighbors (C# lines 650-713)
# ---------------------------------------------------------------------------

function _rule3!(work::Vector{PSet}, pool::PTDPool{PSet}, ptdur_root::Int, ptdur_data::PTD{PSet}, ptd_root::Int,
                 weights::Vector{Int}, graph::CachedGraph{PSet}, k::Int, mutable_graph::Graph{PSet},
                 ptd_roots::Vector{Int}, ptd_inlets::Set{PSet}, cmp_to_ptd_roots, ptd_root_to_cmps,
                 outlets_already_checked::Set{PSet},
                 heuristic_completion_in::Int, current_tests_per_gk::Int) where {PSet}
    B = bag(ptdur_data)
    R = inlet(ptdur_data)

    for v in B
        pot_new_bag = setdiff(neighbors(graph, v), R) ∪ B

        if wt(weights, pot_new_bag) <= k + 1 && is_pmc!(work, graph, pot_new_bag)
            new_ptd_root = extend_to_pmc_rule3(pool, ptdur_root, pot_new_bag, graph)
            consumed = false
            new_ptd_data = pool[new_ptd_root]
            V_new = vertices(new_ptd_data)
            R_new = inlet(new_ptd_data)
            S_new = outlet(new_ptd_data)

            if V_new == vertices(graph)
                return (Halt, new_ptd_root, PSet(), heuristic_completion_in, current_tests_per_gk)
            end

            if !(R_new in ptd_inlets)
                is_ms, cmps = is_minimal_separator(graph, S_new)

                if is_ms && !is_incoming(pool, new_ptd_root, graph) && is_normalized(pool, new_ptd_root)
                    heuristic_completion_in -= 1

                    if COMPLETE_HEURISTICALLY && heuristic_completion_in == 0
                        success, current_tests_per_gk =
                            _try_heuristic_completion!(pool, weights, graph, new_ptd_root, k, mutable_graph,
                                current_tests_per_gk)

                        if success
                            return (Halt, new_ptd_root, PSet(), heuristic_completion_in, current_tests_per_gk)
                        end
                    end
                    if heuristic_completion_in < 0
                        heuristic_completion_in = HEURISTIC_COMPLETION_FREQUENCY
                    end

                    if _outlet_is_safe_separator(pool, new_ptd_root, weights, graph, mutable_graph, outlets_already_checked)
                        return (Divide, new_ptd_root, outlet(pool[ptd_root]), heuristic_completion_in, current_tests_per_gk)
                    end

                    _add_to_p!(pool, new_ptd_root, cmps, graph, ptd_roots, ptd_inlets, cmp_to_ptd_roots, ptd_root_to_cmps)
                    consumed = true
                end
            end

            consumed || rem_vertex!(pool, new_ptd_root)
        end
    end

    return (Continue, 0, PSet(), heuristic_completion_in, current_tests_per_gk)
end

# ---------------------------------------------------------------------------
# AddToP  (C# AddToP, lines 896-963)
# ---------------------------------------------------------------------------

function _add_to_p!(pool::PTDPool{PSet}, ptd_root::Int, cmps, graph::CachedGraph{PSet}, ptd_roots::Vector{Int},
                    ptd_inlets::Set{PSet}, cmp_to_ptd_roots, ptd_root_to_cmps;
                    is_confirmed_no_missing::Bool=false) where {PSet}
    ptd_data = pool[ptd_root]
    ptd_inlet = inlet(ptd_data)
    # Mark this PTD as accounted for (C# line 899)
    push!(ptd_inlets, ptd_inlet)

    if MORE_THAN_2_COMPONENTS_OPTIMIZATION
        # (C# lines 904-933)
        if !is_confirmed_no_missing && cmps !== nothing && length(cmps) > 2
            # Determine missing cmps
            missing_cmps = PSet[]

            for ci in 2:length(cmps)   # start from index 2 (1 is always the incoming cmp)
                cmp = cmps[ci]
                if isdisjoint(cmp, ptd_inlet)
                    if !(cmp in ptd_inlets)
                        push!(missing_cmps, cmp)
                        if haskey(cmp_to_ptd_roots, cmp)
                            push!(cmp_to_ptd_roots[cmp], ptd_root)
                        else
                            cmp_to_ptd_roots[cmp] = Int[ptd_root]
                        end
                    end
                end
            end

            # If cmps are missing, store and return (C# lines 928-932)
            if !isempty(missing_cmps)
                ptd_root_to_cmps[ptd_root] = length(missing_cmps)
                return
            end
        end

        # No cmps missing: add to P (C# line 936)
        push!(ptd_roots, ptd_root)

        # Update dependent PTDs (C# lines 940-956)
        if haskey(cmp_to_ptd_roots, ptd_inlet)
            dependents = cmp_to_ptd_roots[ptd_inlet]

            for dep_root in dependents
                ptd_root_to_cmps[dep_root] -= 1
                if ptd_root_to_cmps[dep_root] == 0
                    delete!(ptd_root_to_cmps, dep_root)
                    _add_to_p!(pool, dep_root, nothing, graph, ptd_roots, ptd_inlets, cmp_to_ptd_roots, ptd_root_to_cmps;
                               is_confirmed_no_missing=true)
                end
            end
            delete!(cmp_to_ptd_roots, ptd_inlet)
        end
    else
        # (C# lines 958-962)
        push!(ptd_roots, ptd_root)
    end
end

# ---------------------------------------------------------------------------
# OutletIsSafeSeparator  (C# OutletIsSafeSeparator, lines 971-983)
# ---------------------------------------------------------------------------

function _outlet_is_safe_separator(pool::PTDPool{PSet}, ptd_root::Int, weights::Vector{Int}, graph::CachedGraph{PSet}, mutable_graph::Graph{PSet}, outlets_checked::Set{PSet}) where {PSet}
    ptd_data = pool[ptd_root]

    if TEST_OUTLET_IS_CLIQUE_MINOR && !(outlet(ptd_data) in outlets_checked)
        push!(outlets_checked, outlet(ptd_data))
        return is_safe_separator_heuristic(weights, mutable_graph, outlet(ptd_data))
    end
    return false
end

# ---------------------------------------------------------------------------
# TryHeuristicCompletion  (C# TryHeuristicCompletion, lines 1007-1129)
# ---------------------------------------------------------------------------

function _try_heuristic_completion!(pool::PTDPool{PSet}, weights::Vector{Int}, immutable_graph::CachedGraph{PSet}, ptd_root::Int, k::Int,
                                    mutable_graph_template::Graph{PSet},
                                    tests_per_gk::Int) where {PSet}
    ptd_data = pool[ptd_root]
    ptd_inlet = inlet(ptd_data)
    # Inlet ratio check (C# lines 1022-1026)
    inlet_ratio = Float32(wt(weights, ptd_inlet)) / wt(weights, vertices(immutable_graph))

    if inlet_ratio < HEURISTIC_INLET_MIN || inlet_ratio > HEURISTIC_INLET_MAX
        return (false, tests_per_gk)
    end

    tests_per_gk += 1

    if tests_per_gk > MAX_TESTS_PER_GRAPH_AND_K
        return (false, tests_per_gk)
    end

    # Build subgraph: remove inlet vertices, make outlet a clique (C# lines 1038-1061)
    not_removed = setdiff(vertices(immutable_graph), ptd_inlet)
    graph = Graph(not_removed)

    for u in vertices(immutable_graph)
        if u in ptd_inlet
            graph.neighbors[u] = PSet()
        else
            graph.neighbors[u] = setdiff(neighbors(immutable_graph, u), ptd_inlet)
        end
    end
    make_into_clique!(graph, outlet(ptd_data))

    # Calculate bags using heuristic (C# lines 1064-1077)
    bags_and_parents_stack = Tuple{PSet, PSet}[]
    heuristic_pairs, remaining_clique = heuristic_bags_and_neighbors(weights, graph)

    for (bag, parent) in heuristic_pairs
        if wt(weights, bag) > k + 1
            return (false, tests_per_gk)
        end
        push!(bags_and_parents_stack, (bag, parent))
    end

    # Return also if the remaining clique is too large (C# lines 1074-1077)
    if wt(weights, remaining_clique) > k + 1
        return (false, tests_per_gk)
    end

    # Build the PTD from those bags (C# lines 1080-1108)
    other_root = make_ptd(pool, remaining_clique)
    subtree_list = Int[other_root]

    for idx in length(bags_and_parents_stack):-1:1
        current_bag, current_parent = bags_and_parents_stack[idx]
        current_root = make_ptd(pool, current_bag)

        # Iterate from most recent to least recent (C# lines 1092-1103)
        for i in length(subtree_list):-1:1
            if bag(pool[subtree_list[i]]) ⊇ current_parent
                add_edge!(pool, subtree_list[i], current_root)
                break
            end
        end
        push!(subtree_list, current_root)
    end

    # Reroot and attach (C# lines 1110-1112)
    other_root = reroot!(pool, other_root, outlet(ptd_data))
    add_edge!(pool, ptd_root, other_root)

    return (true, tests_per_gk)
end

"""
    DissectionAlgorithm

A vertex separator algorithm.
"""
abstract type DissectionAlgorithm end

"""
    METISND <: DissectionAlgorithm

    METISND(; nseps=-1, seed=-1)

Compute a vertex separator using the graph partitioning library METIS.

### Parameters

  - `nseps`: number of different separators computed at each level of nested dissection
  - `seed`: random seed

### References

  - Karypis, George, and Vipin Kumar. "A fast and high quality multilevel scheme for partitioning irregular graphs." *SIAM Journal on Scientific Computing* 20.1 (1998): 359-392.
"""
@kwdef struct METISND <: DissectionAlgorithm
    nseps::Int = -1
    seed::Int = -1
end

"""
    KaHyParND{O} <: DissectionAlgorithm

    KaHyParND(order; beta=1.0)

Compute a vertex separator using the hypergraph partitioning library KaHyPar. A β-quasi-clique cover is constructed
using a greedy algorithm controlled by the parameters `order` and `beta`.

### Parameters

  - `order`: tie breaking strategy (`Forward` or `Reverse`).
  - `beta`: quasi-clique parameter

### References

  - Çatalyürek, Ümit V., Cevdet Aykanat, and Enver Kayaaslan. "Hypergraph partitioning-based fill-reducing ordering for symmetric matrices." *SIAM Journal on Scientific Computing* 33.4 (2011): 1996-2023.
  - Kaya, Oguz, et al. "Fill-in reduction in sparse matrix factorizations using hypergraphs".
"""
struct KaHyParND{O <: Ordering} <: DissectionAlgorithm
    order::O
    beta::Float64
end

function KaHyParND(order::Ordering = Forward; beta::Number = 1.0)
    return KaHyParND(order, beta)
end

function partition!(
        work0::AbstractScalar{V},
        work1::AbstractVector{V},
        work2::AbstractVector{V},
        work3::AbstractVector{V},
        work4::AbstractVector{V},
        work5::AbstractVector{V},
        label0::AbstractVector{V},
        label1::AbstractVector{V},
        pointer0::AbstractVector{E},
        pointer1::AbstractVector{E},
        target0::AbstractVector{V},
        target1::AbstractVector{V},
        project0::AbstractVector{V},
        project1::AbstractVector{V},
        part::AbstractVector{V},
        weights::AbstractVector{W},
        graph::AbstractGraph{V},
    ) where {W, V, E}
    @assert nv(graph) <= length(label0)
    @assert nv(graph) <= length(label1)
    @assert nv(graph) < length(pointer0)
    @assert nv(graph) < length(pointer1)
    @assert de(graph) <= length(target0)
    @assert de(graph) <= length(target1)
    @assert nv(graph) <= length(part)
    @assert nv(graph) <= length(project0)
    @assert nv(graph) <= length(project1)
    @assert nv(graph) <= length(weights)

    n = nv(graph)

    # V = W ∪ B
    n0 = zero(V); m0 = zero(E)
    n1 = zero(V); m1 = zero(E)
    n2 = zero(V)

    @inbounds for v in vertices(graph)
        vv = part[v]

        if iszero(vv)    # v ∈ W - B
            n0 += one(V); m0 += convert(E, outdegree(graph, v))
        elseif isone(vv) # v ∈ B - W
            n1 += one(V); m1 += convert(E, outdegree(graph, v))
        else             # v ∈ W ∩ B
            n0 += one(V); m0 += convert(E, twice(n2))
            n1 += one(V); m1 += convert(E, twice(n2))
            n2 += one(V)

            for w in outneighbors(graph, v)
                ww = part[w]

                if iszero(ww)    # w ∈ W - B
                    m0 += one(E)
                elseif isone(ww) # w ∈ B - W
                    m1 += one(E)
                end
            end
        end
    end

    t0 = zero(V)
    t1 = zero(V)
    t2 = zero(V); label2 = FVector{V}(undef, n2)

    @inbounds for v in vertices(graph)
        vv = part[v]

        if iszero(vv)    # v ∈ W - B
            project0[v] = t0 += one(V); label0[t0] = v
        elseif isone(vv) # v ∈ B - W
            project1[v] = t1 += one(V); label1[t1] = v
        else             # v ∈ W ∩ B
            t2 += one(V); label2[t2] = v
            project0[v] = t0 += one(V); label0[t0] = v
            project1[v] = t1 += one(V); label1[t1] = v
        end
    end

    if max(m0, m1) > length(target0)
        resize!(target0, max(m0, m1))
        resize!(target1, max(m0, m1))
    end

    graph0 = BipartiteGraph{V, E}(n0, n0, m0, pointer0, target0)
    graph1 = BipartiteGraph{V, E}(n1, n1, m1, pointer1, target1)
    t0 = one(V); pointers(graph0)[t0] = p0 = one(E)
    t1 = one(V); pointers(graph1)[t1] = p1 = one(E)

    @inbounds for v in vertices(graph)
        vv = part[v]

        if iszero(vv)    # v ∈ W - B
            for w in neighbors(graph, v)                     # w ∈ W
                targets(graph0)[p0] = project0[w]; p0 += one(E)
            end

            t0 += one(V); pointers(graph0)[t0] = p0
        elseif isone(vv) # v ∈ B - W
            for w in neighbors(graph, v)                     # w ∈ B
                targets(graph1)[p1] = project1[w]; p1 += one(E)
            end

            t1 += one(V); pointers(graph1)[t1] = p1
        else             # v ∈ W ∩ B
            for w in neighbors(graph, v)
                ww = part[w]

                if iszero(ww)                                # w ∈ W - B
                    targets(graph0)[p0] = project0[w]; p0 += one(E)
                elseif isone(ww)                             # w ∈ B - W
                    targets(graph1)[p1] = project1[w]; p1 += one(E)
                end
            end

            for w in label2                                  # w ∈ W ∩ B
                v == w && continue
                targets(graph0)[p0] = project0[w]; p0 += one(E)
                targets(graph1)[p1] = project1[w]; p1 += one(E)
            end

            t0 += one(V); pointers(graph0)[t0] = p0
            t1 += one(V); pointers(graph1)[t1] = p1
        end
    end

    child0 = compresspart(work0, work1, work2, work3,
        work4, work5, part, weights, n, graph0, label0)

    child1 = compresspart(work0, work1, work2, work3,
        work4, work5, part, weights, n, graph1, label1)

    return child0, child1, label2
end

function hpartition!(
        work00::AbstractScalar{V},
        work01::AbstractVector{V},
        work02::AbstractVector{V},
        work03::AbstractVector{V},
        work04::AbstractVector{V},
        work05::AbstractVector{V},
        work06::AbstractVector{V},
        work07::AbstractVector{V},
        work08::AbstractVector{E},
        work09::AbstractVector{E},
        work10::AbstractVector{V},
        work11::AbstractVector{V},
        work12::AbstractVector{V},
        work13::AbstractVector{V},
        hproject0::AbstractVector{V},
        hproject1::AbstractVector{V},
        hpart::AbstractVector{V},
        part::AbstractVector{V},
        weights::AbstractVector{W},
        hgraph::AbstractGraph{HV},
        graph::AbstractGraph{V},
    ) where {W, V, E, HV}
    @assert nov(hgraph) <= length(hproject0)
    @assert nov(hgraph) <= length(hproject1)
    @assert nv(hgraph) <= length(part)
    @assert nv(hgraph) == nv(graph)

    h0 = one(V)
    h1 = one(V)

    for hv in outvertices(hgraph)
        hvv = hpart[hv]

        if iszero(hvv)
            hproject0[hv] = h0 += one(V)
            hproject1[hv] = zero(V)
        else
            hproject1[hv] = h1 += one(V)
            hproject0[hv] = zero(V)
        end
    end

    # V = W ∪ B
    for v in vertices(graph)
        vv = three(V)

        for hv in neighbors(hgraph, v)
            hvv = hpart[hv]

            if iszero(hvv) # v ∈ W
                if isthree(vv)
                    vv = zero(V)
                elseif isone(vv)  # v ∈ W ∩ B
                    vv = two(V)
                end
            else          # v ∈ B
                if isthree(vv)
                    vv = one(V)
                elseif iszero(vv) # v ∈ W ∩ B
                    vv = two(V)
                end
            end
        end

        if isthree(vv)
            vv = zero(V)
        end

        part[v] = vv
    end

    child0, child1, label2 = partition!(work00, work01, work02, work03, work04,
        work05, work06, work07, work08, work09, work10, work11, work12, work13,
        part, weights, graph) 

    graph0, weights0, label0, clique0 = child0
    graph1, weights1, label1, clique1 = child1

    tag = one(V)

    hgraph0, tag = hcompresspart(h0, tag, hgraph, hproject0, hpart, label0, clique0)
    hgraph1, tag = hcompresspart(h1, tag, hgraph, hproject1, hpart, label1, clique1)

    hchild0 = (hgraph0, graph0, weights0, label0, clique0)
    hchild1 = (hgraph1, graph1, weights1, label1, clique1)

    return hchild0, hchild1, label2
end

function compresspart(
        work0::AbstractScalar{V},
        work1::AbstractVector{V},
        work2::AbstractVector{V},
        work3::AbstractVector{V},
        work4::AbstractVector{V},
        work5::AbstractVector{V},
        part::AbstractVector{V},
        supweights::AbstractVector{W},
        nsup::V,
        subgraph::AbstractGraph{V},
        sublabel::AbstractVector{V},
    ) where {W, V}
    @assert nv(subgraph) <= nsup <= length(supweights)
    @assert nv(subgraph) <= length(sublabel)

    E = etype(subgraph); nsub = nv(subgraph); msub = de(subgraph); nnsub = nsub + one(V)

    prjptr = FVector{V}(undef, nnsub)
    cmpptr = FVector{E}(undef, nnsub)
    prjtgt = FVector{V}(undef, nsub)
    cmptgt = FVector{V}(undef, msub)

    cmpgraph, project = compress_impl!(work0, prjptr, work1, prjtgt,
        work2, work3, work4, work5, cmpptr, cmptgt, subgraph, Val(true))

    @inbounds for v in vertices(subgraph)
        w = sublabel[prjtgt[v]]
        prjtgt[v] = w
    end

    kcmp = zero(V)
    ncmp = nv(cmpgraph)

    cmpweights = FVector{W}(undef, ncmp)
    cmplabel = BipartiteGraph(nsup, ncmp, nsub, prjptr, prjtgt) 

    @inbounds for u in vertices(cmpgraph)
        wgt = zero(W); flg = false
        
        for w in neighbors(cmplabel, u)
            wgt += supweights[w]

            if !flg && istwo(part[w])
                flg = true
                kcmp += one(V); sublabel[kcmp] = u
            end
        end

        cmpweights[u] = wgt
    end

    cmpclique = FVector{V}(undef, kcmp)

    @inbounds for k in oneto(kcmp)
        cmpclique[k] = sublabel[k]
    end

    return (cmpgraph, cmpweights, cmplabel, cmpclique)
end

function hcompresspart(
        hh::V,
        tag::V,
        hgraph::AbstractGraph{HV},
        hproject::AbstractVector{V},
        mark::AbstractVector{V},
        label::AbstractGraph{V},
        clique::AbstractVector{V},
    ) where {HV, V}
    @assert nov(hgraph) <= length(mark)
    @assert nv(hgraph) == nov(label)

    HE = etype(hgraph); hn = convert(HV, nv(label)); hm = convert(HE, length(clique))

    for v in vertices(label)
        tag += one(V)

        for w in neighbors(label, v), hw in neighbors(hgraph, w)
            hx = hproject[hw]

            if ispositive(hx) && mark[hw] < tag
                mark[hw] = tag
                hm += one(HE)
            end
        end
    end

    hchild = BipartiteGraph{HV, HE}(hh, hn, hm)
    pointers(hchild)[begin] = p = one(HE)

    for v in vertices(label)
        tag += one(V); flag = false

        for w in neighbors(label, v), hw in neighbors(hgraph, w)
            hx = hproject[hw]

            if ispositive(hx) && mark[hw] < tag
                mark[hw] = tag
                targets(hchild)[p] = hx; p += one(HE)
            end

            flag = flag || iszero(hx)
        end

        if flag
            targets(hchild)[p] = one(HV); p += one(HE)
        end

        pointers(hchild)[v + one(V)] = p
    end

    return hchild, tag
end

function qcc(::Type{V}, ::Type{E}, graph, beta::Number, order::Ordering) where {V, E}
    simple = simplegraph(V, E, graph)
    return qcc!(simple, beta, order)
end

# Fill-in reduction in sparse matrix factorizations using hypergraphs
# Kaya, Kayaaslan, Ucar, and Duff
# Algorithm 1: QCC(G, β)
#
# Construct a β-quasi-clique cover.
# The complexity is O( ∑ |N(v)|² ) ≤ O( Δ|E| ).
function qcc!(graph::BipartiteGraph{V, E}, beta::W, order::Ordering) where {W, V, E}
    @assert zero(W) < beta <= one(W)
    n = nv(graph); m = ne(graph); mm = m + one(E)
    marker = zeros(V, n)

    #### bucket queue (degree) ########################
    degree = FVector{V}(undef, n)
    deghead = FVector{V}(undef, n)
    degprev = FVector{V}(undef, n)
    degnext = FVector{V}(undef, n)

    @inbounds for deg in oneto(n)
        deghead[deg] = zero(V)
    end

    function degset(deg::V)
        @inbounds head = view(deghead, deg + one(V))
        return DoublyLinkedList(head, degprev, degnext)
    end
    ###################################################

    #### bucket queue (score) #########################
    score = FVector{E}(undef, n)
    scrhead = FVector{V}(undef, mm)
    scrprev = FVector{V}(undef, n)
    scrnext = FVector{V}(undef, n)

    @inbounds for scr in oneto(mm)
        scrhead[scr] = zero(V)
    end

    function scrset(scr::E)
        @inbounds head = view(scrhead, scr + one(E))
        return DoublyLinkedList(head, scrprev, scrnext)
    end
    ###################################################

    #### clique cover #################################
    #          cliques
    #          [ x x ]
    # vertices [   x ]
    #          [ x   ]
    ptrC = FVector{E}(undef, mm)
    tgtC = FVector{V}(undef, twice(m))
    vC = one(V); ptrC[vC] = pC = one(E)
    ###################################################

    degmax = zero(V)

    @inbounds for v in vertices(graph)
        deg = eltypedegree(graph, v)
        scr = zero(E)

        degree[v] = deg; pushfirst!(degset(deg), v)
        score[v] = scr; pushfirst!(scrset(scr), v)

        degmax = max(degmax, deg)
    end

    @inbounds while ispositive(m)
        ppC = pC; mC = scrmax = zero(E)

        while isempty(degset(degmax))
            degmax -= one(V)
        end

        v = first(degset(degmax))

        while true
            marker[v] = vC; tgtC[ppC] = v; ppC += one(E)

            for w in neighbors(graph, v)
                if ispositive(w)
                    if marker[w] < vC # w ∈ B
                        scr = score[w]
                        delete!(scrset(scr), w)
                        score[w] = scr += one(E)

                        if !isempty(scrset(scr))
                            ww = first(scrset(scr))

                            if lt(order, degree[ww], degree[w])
                                delete!(scrset(scr), ww)
                                pushfirst!(scrset(scr), w)
                                w = ww
                            end
                        end

                        pushfirst!(scrset(scr), w)
                    else
                        mC += one(E)  # w ∈ C
                    end
                end
            end

            scrmax += one(E)

            while isempty(scrset(scrmax))
                scrmax -= one(E)
            end

            # |E(C)| + score(v)
            left = convert(W, mC + scrmax)

            # |C| (|C| + 1)
            # -------------
            #       2
            right = convert(W, half((ppC - pC) * (ppC - pC + one(E))))

            #   |E(C)| + score(v)
            # 2 ----------------- < β
            #     |C| (|C| + 1)
            left < beta * right && break
            v = popfirst!(scrset(scrmax))
            score[v] = scr = zero(E); pushfirst!(scrset(scr), v)
        end

        while pC < ppC
            v = tgtC[pC]
            deg = degree[v]; delete!(degset(deg), v)
            pstart = pointers(graph)[v]
            pstop = pointers(graph)[v + one(V)] - one(E)

            for p in pstart:pstop
                w = targets(graph)[p]

                if ispositive(w)
                    if marker[w] < vC  # w ∈ B
                        scr = score[w]
                        delete!(scrset(scr), w)
                        score[w] = scr = zero(E)
                        pushfirst!(scrset(scr), w)
                    else               # w ∈ C
                        targets(graph)[p] = zero(V)
                        deg -= one(V); m -= one(E)
                    end
                end
            end

            degree[v] = deg; pushfirst!(degset(deg), v)
            pC += one(E)
        end

        vC += one(V); ptrC[vC] = pC
    end

    nC = vC - one(V)
    mC = pC - one(E)
    return BipartiteGraph(n, nC, mC, ptrC, tgtC)
end

function Base.show(io::IO, ::MIME"text/plain", alg::METISND)
    indent = get(io, :indent, 0)
    println(io, " "^indent * "METISND:")
    println(io, " "^indent * "    nseps: $(alg.nseps)")
    println(io, " "^indent * "    seed: $(alg.seed)")
    return
end

function Base.show(io::IO, ::MIME"text/plain", alg::KaHyParND{O}) where {O}
    indent = get(io, :indent, 0)
    println(io, " "^indent * "KaHyParND{$O}:")
    println(io, " "^indent * "    order: $(alg.order)")
    println(io, " "^indent * "    beta: $(alg.beta)")
    return
end

"""
    DEFAULT_DISSECTION_ALGORITHM = METISND()

The default dissection algorithm.
"""
const DEFAULT_DISSECTION_ALGORITHM = METISND()

module Utilities

using Base: @propagate_inbounds
using Base.Iterators
using Base.Order
using FixedSizeArrays
using Graphs

# arrays
export AbstractScalar, Scalar, FScalar, FVector, FMatrix, FArray

# arithmetic
export tolerance, twice, half, two, three, four, five, six, eight, ispositive, isnegative, istwo, isthree, isfour

# graphs
export eltypedegree, de

# printing
export MAX_ITEMS_PRINTED, printiterator

const AbstractScalar{T} = AbstractArray{T, 0}
const Scalar{T} = Array{T, 0}

const FArray{T} = FixedSizeArrayDefault{T}
const FMatrix{T} = FArray{T, 2}
const FVector{T} = FArray{T, 1}
const FScalar{T} = FArray{T, 0}

const MAX_ITEMS_PRINTED = 5

# `tol = tolerance(W)` should satisfy
#     v < w iff v ≤ w - tol
#     v ≤ w iif v < w + tol
# for all weights v and w.
function tolerance(::Type{W}) where {W <: AbstractFloat}
    return convert(W, 1.0e-5)
end

function tolerance(::Type{W}) where {W <: Integer}
    return one(W)
end

function twice(i::I) where {I}
    return i + i
end

function half(i::I) where {I <: Integer}
    return i ÷ two(I)
end

function half(i::W) where {W <: AbstractFloat}
    return i / two(W)
end

function eight(::Type{I}) where {I}
    return twice(four(I))
end

function eight(::I) where {I}
    return eight(I)
end

function six(::Type{I}) where {I}
    return twice(three(I))
end

function six(::I) where {I}
    return six(I)
end

function five(::Type{I}) where {I}
    return one(I) + four(I)
end

function five(::I) where {I}
    return five(I)
end

function four(::Type{I}) where {I}
    return one(I) + three(I)
end

function four(::I) where {I}
    return four(I)
end

function three(::Type{I}) where {I}
    return one(I) + two(I)
end

function three(::I) where {I}
    return three(I)
end

function two(::Type{I}) where {I}
    return one(I) + one(I)
end

function two(::I) where {I}
    return two(I)
end

@static if isdefined(Base, :ispositive)
    import Base.ispositive
else
    function ispositive(i::I) where {I}
        return i > zero(I)
    end
end

@static if isdefined(Base, :isnegative)
    import Base.isnegative
else
    function isnegative(i::I) where {I}
        return i < zero(I)
    end
end

function isfour(i::I) where {I}
    return i == four(I)
end

function isthree(i::I) where {I}
    return i == three(I)
end

function istwo(i::I) where {I}
    return i == two(I)
end

function eltypedegree(graph::AbstractGraph{V}, i::Integer) where {V}
    n::V = outdegree(graph, i)
    return n
end

function de(graph::AbstractGraph)
    m = ne(graph)

    if !is_directed(graph)
        m = twice(m)
    end

    return m
end

function printiterator(io::IO, iterator::T) where {T}
    return printiterator(io, iterator, Base.IteratorSize(T))
end

function printiterator(io::IO, iterator::T, ::Any) where {T}
    print(io, "$T:")
    printelements(io, iterator)
    return
end

function printiterator(io::IO, iterator::T, ::Base.HasLength) where {T}
    n = length(iterator)
    print(io, "$n-element $T:")
    printelements(io, iterator)
    return
end

function printelements(io::IO, iterator)
    count = 0

    for v in iterator
        count += 1

        if count <= MAX_ITEMS_PRINTED
            print(io, "\n $v")
        else
            print(io, "\n ⋮")
            break
        end
    end

    return
end

end

function ldiv_rrule_impl!(Y::AbstractVecOrMat, F::ChordalCholesky, X::AbstractVecOrMat, dX::AbstractVecOrMat)
    ldiv!(F, dX)
    copyto!(X, Y)
    return dX
end

function ldiv_frule_impl!(F::ChordalCholesky, X::AbstractVecOrMat, dX::AbstractVecOrMat)
    ldiv!(F,  X)
    ldiv!(F, dX)
    return X, dX
end

function rdiv_rrule_impl!(Y::AbstractMatrix, F::ChordalCholesky, X::AbstractMatrix, dX::AbstractMatrix)
    rdiv!(dX, F)
    copyto!(X, Y)
    return dX
end

function rdiv_frule_impl!(F::ChordalCholesky, X::AbstractMatrix, dX::AbstractMatrix)
    rdiv!( X, F)
    rdiv!(dX, F)
    return X, dX
end

struct DAG{T}
    label::Vector{T}
    head::Vector{Int}
    indegree::Vector{Int}
    prev::Vector{Int}
    next::Vector{Int}
    target::Vector{Int}
    vhead::Scalar{Int}
    ehead::Scalar{Int}
    stack::Vector{Int}
end

function DAG{T}() where {T}
    return DAG{T}(T[], Int[], Int[], Int[], Int[], Int[], zeros(Int), zeros(Int), Int[])
end

function incident(dag::DAG, v::Int)
    return DoublyLinkedList(view(dag.head, v), dag.prev, dag.next)
end

function target(dag::DAG, p::Int)
    return dag.target[p]
end

function Base.getindex(dag::DAG, v::Int)
    return dag.label[v]
end

function indegree(dag::DAG, v::Int)
    return dag.indegree[v]
end

function add_vertex!(dag::DAG{T}, lbl::T) where {T}
    free = SinglyLinkedList(dag.vhead, dag.head)

    if isempty(free)
        push!(dag.label, lbl)
        push!(dag.head, 0)
        push!(dag.indegree, 0)
        v = length(dag.label)
    else
        v = popfirst!(free)
        dag.label[v] = lbl
        dag.head[v] = 0
        dag.indegree[v] = 0
    end

    return v
end

function add_edge!(dag::DAG, u::Int, v::Int)
    free = SinglyLinkedList(dag.ehead, dag.next)

    if isempty(free)
        push!(dag.target, v)
        push!(dag.prev, 0)
        push!(dag.next, 0)
        p = length(dag.target)
    else
        p = popfirst!(free)
        dag.target[p] = v
    end

    pushfirst!(incident(dag, u), p)
    dag.indegree[v] += 1
    return p
end

function rem_vertex!(dag::DAG, u::Int, ::Val{true} = Val(true))
    @assert iszero(indegree(dag, u))
    vfree = SinglyLinkedList(dag.vhead, dag.head)
    efree = SinglyLinkedList(dag.ehead, dag.next)
    stack = dag.stack

    push!(stack, u)

    while !isempty(stack)
        u = pop!(stack)

        for p in incident(dag, u)
            v = target(dag, p)
            n = dag.indegree[v] -= 1
            iszero(n) && push!(stack, v)
            pushfirst!(efree, p)
        end

        pushfirst!(vfree, u)
    end

    return dag
end

function rem_vertex!(dag::DAG, u::Int, ::Val{false})
    @assert iszero(indegree(dag, u))
    vfree = SinglyLinkedList(dag.vhead, dag.head)
    efree = SinglyLinkedList(dag.ehead, dag.next)

    for p in incident(dag, u)
        v = target(dag, p)
        dag.indegree[v] -= 1
        pushfirst!(efree, p)
    end

    pushfirst!(vfree, u)
    return dag
end

function rem_edge!(dag::DAG, u::Int, p::Int)
    free = SinglyLinkedList(dag.ehead, dag.next)
    v = target(dag, p)
    dag.indegree[v] -= 1
    delete!(incident(dag, u), p)
    pushfirst!(free, p)
    return dag
end

# ===== symv! =====

function symv!(uplo::Val, α, A::AbstractMatrix{T}, x::AbstractVector{T}, β, y::AbstractVector{T}) where {T <: BlasFloat}
    if T <: Complex
        BLAS.hemv!(char(uplo), convert(T, α), A, x, convert(T, β), y)
    else
        BLAS.symv!(char(uplo), convert(T, α), A, x, convert(T, β), y)
    end

    return
end

function symv!(uplo::Val{UPLO}, α, A::AbstractMatrix, x::AbstractVector, β, y::AbstractVector) where {UPLO}
    n = length(y)

    if n <= THRESHOLD
        symv2!(uplo, α, A, x, β, y)
    else
        m = prevpow(2, n) >> 1

        A₁₁ = view(A,     1:m,     1:m)
        A₂₂ = view(A, m + 1:n, m + 1:n)

        if UPLO === :L
            A₂₁ = view(A, m + 1:n, 1:m)
        else
            A₂₁ = view(A, 1:m, m + 1:n)
        end

        x₁ = view(x,     1:m)
        x₂ = view(x, m + 1:n)
        y₁ = view(y,     1:m)
        y₂ = view(y, m + 1:n)

        symv!(uplo, α, A₁₁, x₁, β, y₁)
        symv!(uplo, α, A₂₂, x₂, β, y₂)

        if UPLO === :L
            gemv!(Val(:N), α, A₂₁, x₁, 1, y₂)
            gemv!(Val(:C), α, A₂₁, x₂, 1, y₁)
        else
            gemv!(Val(:N), α, A₂₁, x₂, 1, y₁)
            gemv!(Val(:C), α, A₂₁, x₁, 1, y₂)
        end
    end

    return
end

# ===== symv2! =====

function symv2!(::Val{:L}, α, A::AbstractMatrix, x::AbstractVector, β, y::AbstractVector)
    n = length(y)

    if iszero(β)
        @inbounds @fastmath for i in 1:n
            y[i] = β
        end
    else
        @inbounds @fastmath for i in 1:n
            y[i] *= β
        end
    end

    @inbounds @fastmath for j in 1:n
        αxj = α * x[j]
        y[j] += A[j, j] * αxj

        for i in j + 1:n
            y[i] += A[i, j] * αxj
            y[j] += conj(A[i, j]) * α * x[i]
        end
    end
    return
end

function symv2!(::Val{:U}, α, A::AbstractMatrix, x::AbstractVector, β, y::AbstractVector)
    n = length(y)

    if iszero(β)
        @inbounds @fastmath for i in 1:n
            y[i] = β
        end
    else
        @inbounds @fastmath for i in 1:n
            y[i] *= β
        end
    end

    @inbounds @fastmath for j in 1:n
        αxj = α * x[j]
        y[j] += A[j, j] * αxj

        for i in 1:j - 1
            y[i] += A[i, j] * αxj
            y[j] += conj(A[i, j]) * α * x[i]
        end
    end
    return
end

# ===== symm! =====

function symm!(side::Val, uplo::Val, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T <: BlasFloat}
    if T <: Complex
        BLAS.hemm!(char(side), char(uplo), convert(T, α), A, B, convert(T, β), C)
    else
        BLAS.symm!(char(side), char(uplo), convert(T, α), A, B, convert(T, β), C)
    end

    return
end

function symm!(side::Val{SIDE}, uplo::Val{UPLO}, α, A::AbstractMatrix, B::AbstractMatrix, β, C::AbstractMatrix) where {SIDE, UPLO}
    m, n = size(C)
    p = size(A, 1)

    maxdim = max(m, n, p)

    if maxdim <= THRESHOLD
        symm2!(side, uplo, α, A, B, β, C)
        return
    end

    l = prevpow(2, maxdim) >> 1

    if p == maxdim
        A₁₁ = view(A,     1:l,     1:l)
        A₂₂ = view(A, l + 1:p, l + 1:p)

        if UPLO === :L
            A₂₁ = view(A, l + 1:p, 1:l)
        else
            A₂₁ = view(A, 1:l, l + 1:p)
        end

        if SIDE === :L
            B₁ = view(B,     1:l, :)
            B₂ = view(B, l + 1:p, :)
            C₁ = view(C,     1:l, :)
            C₂ = view(C, l + 1:p, :)
        else
            B₁ = view(B, :,     1:l)
            B₂ = view(B, :, l + 1:p)
            C₁ = view(C, :,     1:l)
            C₂ = view(C, :, l + 1:p)
        end

        symm!(side, uplo, α, A₁₁, B₁, β, C₁)
        symm!(side, uplo, α, A₂₂, B₂, β, C₂)

        if SIDE === :L
            if UPLO === :L
                gemm!(Val(:N), Val(:N), α, A₂₁, B₁, 1, C₂)
                gemm!(Val(:C), Val(:N), α, A₂₁, B₂, 1, C₁)
            else
                gemm!(Val(:N), Val(:N), α, A₂₁, B₂, 1, C₁)
                gemm!(Val(:C), Val(:N), α, A₂₁, B₁, 1, C₂)
            end
        else
            if UPLO === :L
                gemm!(Val(:N), Val(:N), α, B₂, A₂₁, 1, C₁)
                gemm!(Val(:N), Val(:C), α, B₁, A₂₁, 1, C₂)
            else
                gemm!(Val(:N), Val(:C), α, B₂, A₂₁, 1, C₁)
                gemm!(Val(:N), Val(:N), α, B₁, A₂₁, 1, C₂)
            end
        end
    else
        if SIDE === :L
            B₁ = view(B, :,     1:l)
            B₂ = view(B, :, l + 1:n)
            C₁ = view(C, :,     1:l)
            C₂ = view(C, :, l + 1:n)
        else
            B₁ = view(B,     1:l, :)
            B₂ = view(B, l + 1:m, :)
            C₁ = view(C,     1:l, :)
            C₂ = view(C, l + 1:m, :)
        end

        symm!(side, uplo, α, A, B₁, β, C₁)
        symm!(side, uplo, α, A, B₂, β, C₂)
    end

    return
end

# ===== symm2! =====

function symm2!(::Val{:L}, ::Val{:L}, α, A::AbstractMatrix, B::AbstractMatrix, β, C::AbstractMatrix)
    m, n = size(C)

    @inbounds @fastmath for j in 1:n
        for i in 1:m
            Δ = α * A[i, i] * B[i, j]

            for k in i + 1:m
                Δ += α * conj(A[k, i]) * B[k, j]
            end

            for k in 1:i - 1
                Δ += α * A[i, k] * B[k, j]
            end

            if iszero(β)
                C[i, j] = Δ
            else
                C[i, j] = Δ + β * C[i, j]
            end
        end
    end

    return
end

function symm2!(::Val{:L}, ::Val{:U}, α, A::AbstractMatrix, B::AbstractMatrix, β, C::AbstractMatrix)
    m, n = size(C)

    @inbounds @fastmath for j in 1:n
        for i in 1:m
            Δ = α * A[i, i] * B[i, j]

            for k in 1:i - 1
                Δ += α * conj(A[k, i]) * B[k, j]
            end

            for k in i + 1:m
                Δ += α * A[i, k] * B[k, j]
            end

            if iszero(β)
                C[i, j] = Δ
            else
                C[i, j] = Δ + β * C[i, j]
            end
        end
    end
    return
end

function symm2!(::Val{:R}, ::Val{:L}, α, A::AbstractMatrix, B::AbstractMatrix, β, C::AbstractMatrix)
    m, n = size(C)

    @inbounds @fastmath for j in 1:n
        for i in 1:m
            Δ = α * B[i, j] * A[j, j]

            for k in j + 1:n
                Δ += α * B[i, k] * conj(A[k, j])
            end

            for k in 1:j - 1
                Δ += α * B[i, k] * A[j, k]
            end

            if iszero(β)
                C[i, j] = Δ
            else
                C[i, j] = Δ + β * C[i, j]
            end
        end
    end

    return
end

function symm2!(::Val{:R}, ::Val{:U}, α, A::AbstractMatrix, B::AbstractMatrix, β, C::AbstractMatrix)
    m, n = size(C)

    @inbounds @fastmath for j in 1:n
        for i in 1:m
            Δ = α * B[i, j] * A[j, j]

            for k in 1:j - 1
                Δ += α * B[i, k] * conj(A[k, j])
            end

            for k in j + 1:n
                Δ += α * B[i, k] * A[j, k]
            end

            if iszero(β)
                C[i, j] = Δ
            else
                C[i, j] = Δ + β * C[i, j]
            end
        end
    end

    return
end

# Graph: a mutable graph with bitset-backed neighborhoods.
# Faithful transpilation of the C# Graph.cs class, using 1-based vertex indexing
# and immutable AbstractPackedSet values in place of the C# BitSet.

"""
    wt(weights, set)

Sum of vertex weights for all vertices in `set`.
"""
function wt(weights::Vector{Int}, set::PSet) where {PSet <: AbstractPackedSet}
    s = 0

    for v in set
        s += weights[v]
    end
    return s
end

# ==================== Graph ====================

"""
    Graph{PSet}

A mutable graph with logically removable vertices.  `vertices(g)` returns the
packed set of vertices still present; `nv(g)` returns its size.

Type parameter `PSet <: AbstractPackedSet` is the bitset representation used for
neighborhoods and vertex sets.
"""
struct Graph{PSet <: AbstractPackedSet}
    neighbors::Vector{PSet}   # N(v) as bitset
    V::PSet                   # bitset of vertices still present
end

vertices(g::Graph) = g.V
nv(g::Graph) = length(vertices(g))
neighbors(g::Graph, v::Int) = g.neighbors[v]

# ==================== Constructors ====================

"""
    Graph(V::PSet)

Construct a Graph with vertex set V and uninitialized domain-sized neighborhood array.
"""
function Graph(V::PSet) where {PSet <: AbstractPackedSet}
    d = domain(PSet)
    neighbors = Vector{PSet}(undef, d)
    return Graph{PSet}(neighbors, V)
end

"""
    Graph{PSet}(n::Int)

Construct a Graph with vertices 1:n and uninitialized domain-sized neighborhood array.
"""
function Graph{PSet}(n::Int) where {PSet <: AbstractPackedSet}
    return Graph(packedset(PSet, oneto(n)))
end

# ==================== Mutation: add_edge!, make_into_clique! ====================

"""
    add_edge!(g, u, v)

Add an edge between vertices `u` and `v`.  Does nothing if the edge already exists.
"""
function add_edge!(g::Graph{PSet}, u::Int, v::Int) where {PSet}
    if v in neighbors(g, u)
        return nothing
    end
    g.neighbors[u] = neighbors(g, u) ∪ v
    g.neighbors[v] = neighbors(g, v) ∪ u
    return nothing
end


"""
    make_into_clique!(g, vertices)

Add all missing edges among the given `vertices`, making them a clique.
"""
function make_into_clique!(g::Graph{PSet}, V::PSet) where {PSet}
    remaining = V

    while !isempty(remaining)
        u, remaining = popfirst_nonempty(remaining)
        rest = remaining

        while !isempty(rest)
            v, rest = popfirst_nonempty(rest)
            add_edge!(g, u, v)
        end
    end
    return nothing
end

# ==================== Queries ====================

"""
    neighbors(g, vertex_set)

Return N(vertex_set) \\ vertex_set: the union of open neighborhoods of all elements
of `vertex_set`, with the set itself removed.
"""
function neighbors(g::Graph{PSet}, vertex_set::PSet) where {PSet}
    result = PSet()

    for v in vertex_set
        result = result ∪ neighbors(g, v)
    end
    return setdiff(result, vertex_set)
end

"""
    ComponentsIterator{PSet}

Lazy BFS iterator over connected components in G \\ S.
Each iteration yields `(component, separator_neighbors)`.
"""
struct ComponentsIterator{PSet <: AbstractPackedSet}
    graph::Graph{PSet}
    S::PSet
end

function Base.eltype(::Type{ComponentsIterator{PSet}}) where {PSet}
    return Tuple{PSet, PSet}
end

function Base.IteratorSize(::Type{C}) where {C <: ComponentsIterator}
    return Base.SizeUnknown()
end

function Base.iterate(iter::ComponentsIterator{PSet}, V::PSet=setdiff(vertices(iter.graph), iter.S)) where {PSet}
    isempty(V) && return nothing

    v = first_nonempty(V)
    C = F = packedset(PSet, v)

    while !isempty(F)
        N = neighbors(iter.graph, F)
        F = setdiff(N, C ∪ iter.S)
        C = C ∪ N
    end

    return ((setdiff(C, iter.S), C ∩ iter.S), setdiff(V, C))
end

"""
    components(g, S)

Find connected components in G \\ S via BFS.
Returns a lazy iterator of `(component, neighbors_in_separator)` tuples.
"""
function components(g::Graph{PSet}, S::PSet) where {PSet}
    return ComponentsIterator(g, S)
end

#**********************************************************************
#**********************************************************************
#*****   MFINIT_HEAP ... INITIALIZE VECTORS AND HEAP     **************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       THIS SUBROUTINE INITIALIZES KEY VECTORS IN THE DATA STRUCTURE
#       AND INSERTS THE ACTIVE VERTICES IN THE HEAP STRUCTURE AND
#       MAKES THE HEAP.
#
#     INPUT PARAMETERS:
#       NEQNS       - NUMBER OF EQUATIONS.
#       XADJ(*)     - ARRAY OF LENGTH NEQNS+1, CONTAINING POINTERS
#                     TO THE ADJACENCY STRUCTURE OF THE COMPRESSED
#                     GRAPH.
#       DEGREE(*)   - ARRAY OF LENGTH NEQNS, CONTAINING THE DEGREE
#                     OF EACH REPRESENTATIVE NODE IN THE ORIGINAL 
#                     GRAPH, PLUS ONE.
#       QSIZE(*)    - SUPERNODE SIZE:
#                       0  -  ABSORBED VERTEX
#                       >0 -  SUPERNODE SIZE OF A REPRESENTATIVE
#                             VERTEX
#       DEFNCY(*)   - ARRAY OF LENGTH NEQNS, CONTAINING THE EXACT 
#                     DEFICIENCY OF EACH REPRESENTATIVE NODE IN
#                     THE INITIAL COMPRESSED GRAPH (IF COMPRESSION
#                     WAS DONE).
#
#     OUTPUT PARAMETERS:
#       HEAP(*)     - ARRAY OF LENGTH 2*NEQNS, CONTAINING THE 
#                     PRIORITY HEAP OF VERTICES BASED ON
#                     DEFICIENCY-DEPENDENT SCORES.
#       HEAPSIZE    - NUMBER OF VERTICES IN THE HEAP.
#       HEAPINV(*)  - ARRAY OF LENGTH NEQNS, CONTAINING POINTERS
#                     FROM THE VERTICES TO THEIR LOCATIONS IN THE
#                     HEAP.
#       MARKER(*)   - ARRAY OF LENGTH NEQNS, INITIALIZED TO ZERO
#                     FOR MARKING PROCESSES IN SUBSEQUENT
#                     PROCESSING AFTER THIS ROUTINE.
#       NVTXS(*)    - ARRAY OF LENGTH NEQNS, NUMBER OF VERTEX
#                     NEIGHBORS IN INITIAL QUOTIENT GRAPH.
#                       >= 0  FOR EACH REPRESENTATIVE NODE.
#                       -1    FOR EACH ABSORBED VERTEX.
#       WORK(*)     - ARRAY OF LENGTH NEQNS, NUMBER OF CLIQUE
#                     NEIGHBORS IN INITIAL QUOTIENT GRAPH.
#                       0     FOR EACH REPRESENTATIVE NODE.
#       ECFORW(*)   - ARRAY OF LENGTH NEQNS, INITIALLY EVERY NODE
#                     IS NOT IN THE ELIMINATION CLIQUE LIST (THEY
#                     ARE NOT ELIMINATION CLIQUES).
#                       -1    FOR EACH REPRESENTATIVE NODE.
#       CHANGED(*)  - ARRAY OF LENGTH NEQNS, INITIALLY EVERY NODE
#                     IS RECORDED AS NOT HAVING ITS DEFICIENCY
#                     CURRENTLY CHANGED.
#                       -1    FOR EACH REPRESENTATIVE NODE.
#       UMARK(*)    - ARRAY OF LENGTH NEQNS, ARRAY FOR LATER
#                     WING-HUANG MARKING PROCESSES; IT IS
#                     INITIALIZED TO ZERO HERE.
#                       0     FOR EACH REPRESENTATIVE NODE.
#       INVP(*)     - ARRAY OF LENGTH NEQNS, INITIALLY ZERO FOR
#                     EVERY REPRESENTATIVE VERTEX TO INDICATE THAT
#                     IT HAS NOT BEEN ELIMINATED.
#
#**********************************************************************
#
function mfinit_heap(
        neqns::V,
        xadj::AbstractVector{E},
        degree::AbstractVector{W},
        qsize::AbstractVector{W},
        defncy::AbstractVector{W},
        heap::AbstractVector{W},
        heapinv::AbstractVector{V},
        marker::AbstractVector{I},
        nvtxs::AbstractVector{V},
        work::AbstractVector{V},
        ecforw::AbstractVector{V},
        changed::AbstractVector{Bool},
        umark::AbstractVector{I},
        invp::AbstractVector{V},
    ) where {V, E, I, W}
    
    #       ---------------------------------------------------------
    #       MORE INITIALIZATIONS AND ALSO PLACE EACH NODE AND ITS
    #       DEFICIENCY-BASED SCORE IN THE HEAP STRUCTURE IN ARBITRARY
    #       ORDER.
    #       ---------------------------------------------------------
    
    heapcnt = zero(V)

    #       -------------------------
    #       FOR EACH VERTEX JNODE ...
    #       -------------------------
    for jnode in oneto(neqns)

        #           ----------------------------------------------
        #           NVTXS(JNODE) WILL BE -1 FOR ABSORBED VERTICES.
        #           ----------------------------------------------
        nvtxs[jnode] = -one(V)

        #           -------------------------------------
        #           IF JNODE IS A REPRESENTATIVE NODE ...
        #           -------------------------------------
        if !iszero(qsize[jnode])

            #               ---------------------------
            #               INITIALIZE VARIOUS VECTORS.
            #               ---------------------------
            ecforw[jnode] = -one(V)
            changed[jnode] = false
            umark[jnode] = zero(I)
            work[jnode] = zero(V)
            invp[jnode] = zero(V)
            marker[jnode] = zero(I)
            nvtxs[jnode] = convert(V, xadj[jnode + one(V)] - xadj[jnode])
            
            #               ------------------------------------------
            #               DJ WILL BE THE DEGREE OF JNODE (PLUS ONE).
            #               ------------------------------------------
            def = defncy[jnode]
            
            #               -------------------------------
            #               COMPUTE DEFICIENCY-BASED SCORE.
            #               -------------------------------
            
            #               ---------------------------------------------
            #               INSERT JNODE AND ITS DEFICIENCY-BASED SCORE
            #               INTO THE HEAP IN THE NEXT AVAILABLE LOCATION.
            #               ---------------------------------------------
            heapcnt += one(V)
            heapinv[jnode] = heapcnt
            heap[twice(heapcnt) - one(V)] = def
            heap[twice(heapcnt)] = convert(W, jnode)
            
        end
        
    end
    
    #       ------------------------------
    #       IMPOSE HEAP ORDER ON THE HEAP.
    #       ------------------------------
    heapsize = build_heap(heap, heapinv, heapcnt)
    
    return heapsize
end

# ================================= selaxpby! =================================

function selaxpy!(α::Number, A::AbstractMatrix, B::AbstractMatrix)
    return selaxpby!(α, A, true, B)
end

function selaxpby!(α::Number, A::HermOrSym, β::Number, B::HermOrSym)
    @assert A.uplo == B.uplo
    selaxpby!(α, parent(A), β, parent(B), A.uplo)
    return A
end

function selaxpby!(β::Number, B::SparseMatrixCSC{TB, IB}, α::Number, A::SparseMatrixCSC{TA, IA}, uplo::Char) where {TA, IA, TB, IB}
    if iszero(α)
        fill!(nonzeros(A), α)
    elseif !isone(α)
        rmul!(nonzeros(A), α)
    end

    @inbounds for j in axes(A, 2)
        pa, pastop = A.colptr[j], A.colptr[j + 1] - one(IA)
        pb, pbstop = B.colptr[j], B.colptr[j + 1] - one(IB)

        while pa <= pastop && pb <= pbstop
            ia = rowvals(A)[pa]
            ib = rowvals(B)[pb]

            if ia == ib
                if (uplo == 'L' && ia >= j) || (uplo == 'U' && ia <= j)
                    nonzeros(A)[pa] += β * nonzeros(B)[pb]
                end

                pa += one(IA)
                pb += one(IB)
            elseif ia < ib
                pa += one(IA)
            else
                pb += one(IB)
            end
        end
    end

    return A
end

function selaxpby!(β::Number, B::ChordalTriangular, α::Number, A::SparseMatrixCSC, uplo::Char)
    @assert char(B.uplo) == uplo
    return selaxpby!(β, B, α, A)
end

function selaxpby!(β::Number, B::ChordalTriangular{DIAG, :L, T, I}, α::Number, A::SparseMatrixCSC) where {DIAG, T, I}
    if iszero(α)
        fill!(nonzeros(A), α)
    elseif !isone(α)
        rmul!(nonzeros(A), α)
    end

    @inbounds for f in fronts(B)
        D, res = diagblock(B, f)
        L, sep = offdblock(B, f)

        rlo = first(res)
        rhi = last(res)

        if !isempty(sep)
            slo = first(sep)
            shi = last(sep)
        end

        for j in eachindex(res)
            i = one(I)

            for p in nzrange(A, res[j])
                row = rowvals(A)[p]

                if row <= rhi
                    row < rlo && continue
                    nonzeros(A)[p] += β * parent(D)[row - rlo + one(I), j]
                elseif !isempty(sep)
                    row < slo && continue
                    row > shi && break

                    while sep[i] < row
                        i += one(I)
                    end

                    nonzeros(A)[p] += β * L[i, j]
                    i += one(I)
                end
            end
        end
    end

    return A
end

function selaxpby!(β::Number, B::ChordalTriangular{DIAG, :U, T, I}, α::Number, A::SparseMatrixCSC) where {DIAG, T, I}
    if iszero(α)
        fill!(nonzeros(A), α)
    elseif !isone(α)
        rmul!(nonzeros(A), α)
    end

    @inbounds for i in fronts(B)
        D, res = diagblock(B, i)
        L, sep = offdblock(B, i)

        rlo = first(res)
        rhi = last(res)

        for j in eachindex(res)
            for p in nzrange(A, res[j])
                row = rowvals(A)[p]
                row < rlo && continue
                row > rhi && break
                nonzeros(A)[p] += β * parent(D)[row - rlo + one(I), j]
            end
        end

        for j in eachindex(sep)
            for p in nzrange(A, sep[j])
                row = rowvals(A)[p]
                row < rlo && continue
                row > rhi && break
                nonzeros(A)[p] += β * L[row - rlo + one(I), j]
            end
        end
    end

    return A
end

# ================================= axpby! =================================

function LinearAlgebra.axpby!(α::Number, X::ChordalTriangular{DIAG, UPLO}, β::Number, Y::ChordalTriangular{DIAG, UPLO}) where {DIAG, UPLO}
    @assert checksymbolic(X, Y)
    axpby!(α, X.Dval, β, Y.Dval)
    axpby!(α, X.Lval, β, Y.Lval)
    return Y
end

function LinearAlgebra.axpby!(α::Number, X::AdjTri{DIAG, UPLO}, β::Number, Y::AdjTri{DIAG, UPLO}) where {DIAG, UPLO}
    axpby!(α, parent(X), β, parent(Y))
    return Y
end

function LinearAlgebra.axpby!(α::Number, X::TransTri{DIAG, UPLO}, β::Number, Y::TransTri{DIAG, UPLO}) where {DIAG, UPLO}
    axpby!(α, parent(X), β, parent(Y))
    return Y
end

function LinearAlgebra.axpby!(α::Number, X::HermTri{UPLO, T}, β::Number, Y::HermTri{UPLO, T}) where {UPLO, T}
    @assert checksymtri(X) && checksymtri(Y)
    axpby!(α, parent(X), β, parent(Y))
    return Y
end

function LinearAlgebra.axpby!(α::Number, X::SymTri{UPLO, T}, β::Number, Y::SymTri{UPLO, T}) where {UPLO, T}
    @assert checksymtri(X) && checksymtri(Y)
    axpby!(α, parent(X), β, parent(Y))
    return Y
end

function LinearAlgebra.axpby!(α::Number, J::UniformScaling, β::Number, A::ChordalTriangular{:N})
    if iszero(β)
        fill!(A, β)
    elseif !isone(β)
        rmul!(A, β)
    end

    @inbounds for f in fronts(A)
        D, _ = diagblock(A, f)

        for i in diagind(D)
            D[i] += α * J.λ
        end
    end

    return A
end

function LinearAlgebra.axpby!(α::Number, J::Diagonal, β::Number, A::ChordalTriangular{:N})
    if iszero(β)
        fill!(A, β)
    elseif !isone(β)
        rmul!(A, β)
    end

    @inbounds for f in fronts(A)
        D, res = diagblock(A, f)

        for (i, j) in zip(diagind(D), res)
            D[i] += α * J.diag[j]
        end
    end

    return A
end

function LinearAlgebra.axpby!(α::Number, J::UniformScaling, β::Number, A::HermOrSymTri)
    axpby!(α, J, β, parent(A))
    return A
end

function LinearAlgebra.axpby!(α::Number, J::UniformScaling, β::Number, A::AdjOrTransTri{:N})
    axpby!(α, J, β, parent(A))
    return A
end

function LinearAlgebra.axpby!(α::Number, J::Diagonal, β::Number, A::HermOrSymTri)
    axpby!(α, J, β, parent(A))
    return A
end

function LinearAlgebra.axpby!(α::Number, J::Diagonal, β::Number, A::AdjOrTransTri{:N})
    axpby!(α, J, β, parent(A))
    return A
end

function LinearAlgebra.axpby!(α::Number, X::SparseMatrixCSC, β::Number, Y::ChordalTriangular{:N, :L, T, I}) where {T, I}
    if iszero(β)
        fill!(Y, β)
    elseif !isone(β)
        rmul!(Y, β)
    end

    @inbounds for f in fronts(Y)
        D, res = diagblock(Y, f)
        L, sep = offdblock(Y, f)

        rlo = first(res)
        rhi = last(res)

        if !isempty(sep)
            slo = first(sep)
            shi = last(sep)
        end

        for jloc in eachindex(res)
            j = res[jloc]
            k = one(I)

            for p in nzrange(X, j)
                i = rowvals(X)[p]

                if i <= rhi
                    i < rlo && continue
                    D[i - rlo + one(I), jloc] += α * nonzeros(X)[p]
                elseif !isempty(sep)
                    i < slo && continue
                    i > shi && break

                    while sep[k] < i
                        k += one(I)
                    end

                    L[k, jloc] += α * nonzeros(X)[p]
                    k += one(I)
                end
            end
        end
    end

    return Y
end

function LinearAlgebra.axpby!(α::Number, X::SparseMatrixCSC, β::Number, Y::ChordalTriangular{:N, :U, T, I}) where {T, I}
    if !isone(β)
        if iszero(β)
            fill!(Y, zero(T))
        else
            rmul!(Y, β)
        end
    end

    @inbounds for f in fronts(Y)
        D, res = diagblock(Y, f)
        L, sep = offdblock(Y, f)

        rlo = first(res)
        rhi = last(res)

        for jloc in eachindex(res)
            j = res[jloc]

            for p in nzrange(X, j)
                i = rowvals(X)[p]
                i < rlo && continue
                i > rhi && break

                D[i - rlo + one(I), jloc] += α * nonzeros(X)[p]
            end
        end

        for jloc in eachindex(sep)
            j = sep[jloc]

            for p in nzrange(X, j)
                i = rowvals(X)[p]
                i < rlo && continue
                i > rhi && break

                L[i - rlo + one(I), jloc] += α * nonzeros(X)[p]
            end
        end
    end

    return Y
end

function LinearAlgebra.axpby!(α::Number, X::HermOrSymSparse, β::Number, Y::HermOrSymTri)
    axpby!(α, parent(X), β, parent(Y))
    return Y
end


# ================================= axpy! =================================

function LinearAlgebra.axpy!(α::Number, X::ChordalTriangular{DIAG, UPLO}, Y::ChordalTriangular{DIAG, UPLO}) where {DIAG, UPLO}
    return axpby!(α, X, true, Y)
end

function LinearAlgebra.axpy!(α::Number, X::AdjTri{DIAG, UPLO}, Y::AdjTri{DIAG, UPLO}) where {DIAG, UPLO}
    return axpby!(α, X, true, Y)
end

function LinearAlgebra.axpy!(α::Number, X::TransTri{DIAG, UPLO}, Y::TransTri{DIAG, UPLO}) where {DIAG, UPLO}
    return axpby!(α, X, true, Y)
end

function LinearAlgebra.axpy!(α::Number, X::HermTri{UPLO, T}, Y::HermTri{UPLO, T}) where {UPLO, T}
    return axpby!(α, X, true, Y)
end

function LinearAlgebra.axpy!(α::Number, X::SymTri{UPLO, T}, Y::SymTri{UPLO, T}) where {UPLO, T}
    return axpby!(α, X, true, Y)
end

function LinearAlgebra.axpy!(α, J::UniformScaling, A::ChordalTriangular{:N})
    return axpby!(α, J, true, A)
end

function LinearAlgebra.axpy!(α, J::Diagonal, A::ChordalTriangular{:N})
    return axpby!(α, J, true, A)
end

function LinearAlgebra.axpy!(α, J::UniformScaling, A::HermOrSymTri)
    return axpby!(α, J, true, A)
end

function LinearAlgebra.axpy!(α, J::UniformScaling, A::AdjOrTransTri{:N})
    return axpby!(α, J, true, A)
end

function LinearAlgebra.axpy!(α, J::Diagonal, A::HermOrSymTri)
    return axpby!(α, J, true, A)
end

function LinearAlgebra.axpy!(α, J::Diagonal, A::AdjOrTransTri{:N})
    return axpby!(α, J, true, A)
end

function LinearAlgebra.axpy!(α::Number, X::SparseMatrixCSC, Y::ChordalTriangular{:N})
    return axpby!(α, X, true, Y)
end

function LinearAlgebra.axpy!(α::Number, X::HermOrSymSparse, Y::HermOrSymTri)
    return axpby!(α, X, true, Y)
end

# =================================== + ===================================

function Base.:+(A::ChordalTriangular{:N, UPLO, T}, B::ChordalTriangular{:N, UPLO, T}) where {UPLO, T}
    return axpy!(one(T), A, copy(B))
end

function Base.:+(A::HermTri{UPLO}, B::HermTri{UPLO}) where {UPLO}
    return Hermitian(parent(A) + parent(B), UPLO)
end

function Base.:+(A::SymTri{UPLO}, B::SymTri{UPLO}) where {UPLO}
    return Symmetric(parent(A) + parent(B), UPLO)
end

function Base.:+(A::AdjTri{:N, UPLO}, B::AdjTri{:N, UPLO}) where UPLO
    return adjoint(parent(A) + parent(B))
end

function Base.:+(A::TransTri{:N, UPLO}, B::TransTri{:N, UPLO}) where UPLO
    return transpose(parent(A) + parent(B))
end

function Base.:+(A::ChordalTriangular{:N}, J::UniformScaling)
    B = similar(A, promote_eltype(A, J))
    copyto!(B, A)
    axpy!(true, J, B)
    return B
end

function Base.:+(J::UniformScaling, A::ChordalTriangular{:N})
    return A + J
end

function Base.:+(A::HermTri{UPLO}, J::UniformScaling) where {UPLO}
    return Hermitian(parent(A) + J, UPLO)
end

function Base.:+(A::HermTri{UPLO}, J::UniformScaling{<:Complex}) where {UPLO}
    @assert iszero(imag(J.λ))
    return Hermitian(parent(A) + real(J.λ) * I, UPLO)
end

function Base.:+(J::UniformScaling, A::HermTri)
    return A + J
end

function Base.:+(J::UniformScaling{<:Complex}, A::HermTri)
    return A + J
end

function Base.:+(A::SymTri{UPLO}, J::UniformScaling) where {UPLO}
    return Symmetric(parent(A) + J, UPLO)
end

function Base.:+(J::UniformScaling, A::SymTri)
    return A + J
end

function Base.:+(A::ChordalTriangular{:N}, J::Diagonal)
    B = similar(A, promote_eltype(A, J))
    copyto!(B, A)
    axpy!(true, J, B)
    return B
end

function Base.:+(J::Diagonal, A::ChordalTriangular{:N})
    return A + J
end

function Base.:+(A::HermTri{UPLO}, D::Diagonal) where {UPLO}
    return Hermitian(parent(A) + D, UPLO)
end

function Base.:+(A::HermTri{UPLO}, D::Diagonal{<:Real}) where {UPLO}
    return Hermitian(parent(A) + D, UPLO)
end

function Base.:+(D::Diagonal, A::HermTri)
    return A + D
end

function Base.:+(D::Diagonal{<:Real}, A::HermTri)
    return A + D
end

function Base.:+(A::SymTri{UPLO}, D::Diagonal) where {UPLO}
    return Symmetric(parent(A) + D, UPLO)
end

function Base.:+(A::SymTri{UPLO}, D::Diagonal{<:Number}) where {UPLO}
    return Symmetric(parent(A) + D, UPLO)
end

function Base.:+(D::Diagonal, A::SymTri)
    return A + D
end

function Base.:+(D::Diagonal{<:Number}, A::SymTri)
    return A + D
end

# =================================== - ===================================

function Base.:-(X::ChordalTriangular{:N})
    return -1 * X
end

function Base.:-(X::HermOrSymTri)
    return -1 * X
end

function Base.:-(X::AdjTri{:N})
    return -1 * X
end

function Base.:-(X::TransTri{:N})
    return -1 * X
end

function Base.:-(A::ChordalTriangular{:N, UPLO, T}, B::ChordalTriangular{:N, UPLO, T}) where {UPLO, T}
    return axpy!(-one(T), B, copy(A))
end

function Base.:-(A::HermTri{UPLO}, B::HermTri{UPLO}) where {UPLO}
    return Hermitian(parent(A) - parent(B), UPLO)
end

function Base.:-(A::SymTri{UPLO}, B::SymTri{UPLO}) where {UPLO}
    return Symmetric(parent(A) - parent(B), UPLO)
end

function Base.:-(A::AdjTri{:N, UPLO}, B::AdjTri{:N, UPLO}) where UPLO
    return adjoint(parent(A) - parent(B))
end

function Base.:-(A::TransTri{:N, UPLO}, B::TransTri{:N, UPLO}) where UPLO
    return transpose(parent(A) - parent(B))
end

function Base.:-(A::ChordalTriangular{:N}, J::UniformScaling)
    return A + (-J)
end

function Base.:-(A::HermTri, J::UniformScaling)
    return A + (-J)
end

function Base.:-(A::SymTri, J::UniformScaling)
    return A + (-J)
end

function Base.:-(A::ChordalTriangular{:N}, D::Diagonal)
    return A + (-D)
end

function Base.:-(A::HermTri, D::Diagonal)
    return A + (-D)
end

function Base.:-(A::HermTri, D::Diagonal{<:Real})
    return A + (-D)
end

function Base.:-(A::SymTri, D::Diagonal)
    return A + (-D)
end

function Base.:-(A::SymTri, D::Diagonal{<:Number})
    return A + (-D)
end

function Base.:-(J::UniformScaling, A::ChordalTriangular{:N})
    return J + (-A)
end

function Base.:-(J::UniformScaling, A::HermTri)
    return J + (-A)
end

function Base.:-(J::UniformScaling{<:Complex}, A::HermTri)
    return J + (-A)
end

function Base.:-(J::UniformScaling, A::SymTri)
    return J + (-A)
end

function Base.:-(D::Diagonal, A::ChordalTriangular{:N})
    return D + (-A)
end

function Base.:-(D::Diagonal, A::HermTri)
    return D + (-A)
end

function Base.:-(D::Diagonal{<:Real}, A::HermTri)
    return D + (-A)
end

function Base.:-(D::Diagonal, A::SymTri)
    return D + (-A)
end

function Base.:-(D::Diagonal{<:Number}, A::SymTri)
    return D + (-A)
end

# ================================== zero ==================================

function Base.zero(A::ChordalTriangular{:N})
    return fill!(similar(A), 0)
end

function Base.zero(A::HermTri{UPLO}) where {UPLO}
    return Hermitian(zero(parent(A)), UPLO)
end

function Base.zero(A::SymTri{UPLO}) where {UPLO}
    return Symmetric(zero(parent(A)), UPLO)
end

function Base.zero(A::AdjTri{:N})
    return adjoint(zero(parent(A)))
end

function Base.zero(A::TransTri{:N})
    return transpose(zero(parent(A)))
end

using Test

@static if VERSION >= v"1.12"
    @testset "Code Quality (Aqua.jl)" begin
        include("aqua.jl")
    end
end

#=
@testset "Code Quality (JET.jl)" begin
    include("jet.jl")
end
=#

@testset "Core" begin
    include("core.jl")
end

function acsd_find!(
        head::AbstractVector{V},
        next::AbstractVector{V},
        mark::AbstractVector{V},
        weights::AbstractVector{W},
        graph::AbstractGraph{V},
        order::AbstractVector{V},
        tree::CliqueTree{V, E},
    ) where {W, V, E}
    @assert nv(graph) <= length(head)
    @assert nv(graph) <= length(next)
    @assert nv(graph) <= length(mark)
    @assert nv(graph) <= length(weights)
    @assert nv(graph) <= length(order)
    
    function set(v::V)
        h = view(head, v)
        return SinglyLinkedList(h, next)
    end

    minwgt = typemax(W)
    tol = tolerance(W)
    node = zero(V)
    totcnt = zero(E)

    for v in vertices(graph)
        head[v] = zero(V)
        mark[v] = zero(V)
        minwgt = min(minwgt, weights[v])
    end

    for bag in tree
        node += one(V); maxcnt = poscnt = negcnt = vert = zero(V)

        for i in separator(bag)
            v = order[i]
            mark[v] = node; maxcnt += one(V)
        end

        for i in separator(bag)
            v = order[i]; cnt = maxcnt - one(V)
            
            if weights[v] < minwgt + tol
                flag = true
            else
                flag = false
            end
            
            for w in neighbors(graph, v)
                if w != v && mark[w] == node
                    cnt -= one(V)
                end
            end

            if isone(cnt)
                negcnt += cnt
            elseif ispositive(cnt)
                if flag && !ispositive(vert) && cnt >= negcnt
                    poscnt = cnt; vert = v
                else
                    poscnt = -one(V)
                    break
                end
            end
        end

        if poscnt == negcnt && ispositive(vert)
            totcnt += convert(E, poscnt)
            pushfirst!(set(vert), node)
        end
    end

    return de(graph) + twice(totcnt)
end

function acsd_complete!(
        pointer::AbstractVector{E},
        target::AbstractVector{V},
        head::AbstractVector{V},
        next::AbstractVector{V},
        mark::AbstractVector{V},
        graph::AbstractGraph{V},
        order::AbstractVector{V},
        tree::CliqueTree{V, E},
    ) where {V, E}   
    @assert nv(graph) < length(pointer)
    @assert de(graph) <= length(target)
    @assert nv(graph) <= length(head)
    @assert nv(graph) <= length(next)
    @assert nv(graph) <= length(mark)
    @assert nv(graph) <= length(order)

    n = nv(graph)
    
    function set(v::V)
        h = view(head, v)
        return SinglyLinkedList(h, next)
    end

    for v in vertices(graph)
        mark[v] = zero(V)
        pointer[v + one(V)] = zero(V)
    end

    for v in oneto(n - one(V))
        nodes = set(v); ndeg = pointer[v + two(V)] + eltypedegree(graph, v)
        
        if !isempty(nodes)         
            for w in neighbors(graph, v)
                mark[w] = v
            end

            for node in nodes, i in separator(tree, node)
                w = order[i]

                if v != w && mark[w] < v
                    mark[w] = v; ndeg += one(V)

                    if w < n
                        pointer[w + two(V)] += one(V)
                    end
                end
            end
        end

        pointer[v + two(V)] = ndeg
    end

    nodes = set(n)

    if !isempty(nodes)
        for w in neighbors(graph, n)
            mark[w] = n
        end

        for node in nodes, i in separator(tree, node)
            w = order[i]

            if n != w && mark[w] < n
                mark[w] = n

                if w < n
                    pointer[w + two(V)] += one(V)
                end
            end
        end
    end

    pointer[one(V)] = p = one(E) 
    
   for v in vertices(graph)
        mark[v] = zero(V)
        pointer[v + one(V)] = p += pointer[v + one(V)]
    end
    
    for v in vertices(graph)
        nodes = set(v); p = pointer[v + one(V)]
        
        if !isempty(nodes)            
            for w in neighbors(graph, v)
                target[p] = w; p += one(E)
                mark[w] = v
            end

            for node in nodes, i in separator(tree, node)
                w = order[i]

                if v != w && mark[w] < v
                    mark[w] = v
                    q = pointer[w + one(V)]
                    target[p] = w; p += one(E)
                    target[q] = v; q += one(E)
                    pointer[w + one(V)] = q
                end
            end
        else
            for w in neighbors(graph, v)
                target[p] = w; p += one(E)
            end
        end

        pointer[v + one(V)] = p
    end

    p = qstop = one(E)
    
    for v in vertices(graph)
        qstrt = qstop
        qstop = pointer[v + one(V)]

        for q in qstrt:qstop - one(E)
            w = target[q]

            if mark[w] < v + n
                mark[w] = v + n
                target[p] = w; p += one(V)
            end
        end

        pointer[v + one(V)] = p  
    end

    m = p - one(E)
    return BipartiteGraph(n, n, m, pointer, target)
end

function acsd(weights::AbstractVector, graph::AbstractGraph{V}, alg::MinimalAlgorithm) where {V}
    E = etype(graph); n = nv(graph)
    
    head = FVector{V}(undef, n)
    next = FVector{V}(undef, n)
    mark = FVector{V}(undef, n)
    pointer = FVector{E}(undef, n + one(V))

    order, tree = cliquetree(weights, graph, alg)
   
    m = acsd_find!(head, next, mark,
        weights, graph, order, tree)

    target = FVector{V}(undef, m)
    return acsd_complete!(pointer, target, head, next, mark, graph, order, tree)
end

function safeseparators(weights::AbstractVector, graph::AbstractGraph{V}, alg::EliminationAlgorithm, min::MinimalAlgorithm) where {V}
    n = nv(graph)

    if n < two(V)
        order = collect(oneto(n))
        index = collect(oneto(n))
    else
        cmpgraph = acsd(weights, graph, min)
        order, tree = atomtree(cmpgraph, min); index = invperm(order)

        if length(tree) < 2
            order, index = permutation(weights, cmpgraph, alg)
        else
            pmtweights = weights[order]
            pmtgraph = permute(cmpgraph, order, index)
            pmtindex = safeseparators(pmtweights, pmtgraph, tree, alg, min)

            for v in vertices(graph)
                i = index[v] = pmtindex[index[v]]
                order[i] = v
            end
        end
    end

    return order, index
end

function safeseparators(weights::AbstractVector{W}, graph::AbstractGraph{V}, tree::CliqueTree{V, E}, alg::EliminationAlgorithm, min::MinimalAlgorithm) where {W, V, E}
    n = nv(graph); m = de(graph)
    
    index = FVector{V}(undef, n)
    work1 = FVector{V}(undef, n)
    work2 = FVector{V}(undef, n)
    work3 = FVector{V}(undef, n)
    
    subwgt = FVector{W}(undef, n)
    submsk = FVector{V}(undef, n)
    subinv = FVector{V}(undef, n)
    
    subptr = FVector{E}(undef, n + 1)
    uppptr = FVector{E}(undef, n + 1)
    
    subtgt = FVector{V}(undef, m)
    upptgt = FVector{V}(undef, m)

    for i in vertices(graph)
        submsk[i] = zero(V)
    end

    for bag in tree
        res = residual(bag)
        sep = separator(bag)

        strt = first(res)
        stop = last(res)
        ii = stop - strt + one(V)
        
        for i in sep
            submsk[i] = strt
            subinv[i] = ii += one(V)
        end

        ii = zero(V); subptr[ii + one(V)] = pp = one(E)

        for i in bag
            ii += one(V); subwgt[ii] = weights[i]
            
            for j in neighbors(graph, i)
                jj = zero(V)
                
                if strt <= j
                    if j <= stop
                        jj = j - strt + one(V)
                    elseif submsk[j] == strt
                        jj = subinv[j]
                    end
                end

                if ispositive(jj)
                    subtgt[pp] = jj; pp += one(E)
                end
            end

            subptr[ii + one(V)] = pp
        end

        nn = ii; mm = pp - one(E)
        subgraph = BipartiteGraph(nn, nn, mm, subptr, subtgt)
        suborder, subindex = permutation(subwgt, subgraph, Compression(SafeSeparators(alg, min)))
        subupper = sympermute!_impl!(uppptr, upptgt, subgraph, subindex, Forward)
        sublower = BipartiteGraph(nn, nn, de(subupper), subptr, subtgt)
        subclique = view(subindex, stop - strt + two(V):nn)
        subtree = Parent(nn, suborder)
        
        compositerotations_impl!(work1, work2, work3,
            subinv, sublower, subtree, subupper, subclique)

        for i in strt:stop
            ii = i - strt + one(V)
            index[i] = work1[subindex[ii]] + strt - one(V)
        end
    end

    return index
end

"""
    Clique{V, E} <: AbstractVector{V}

A clique of a clique tree.
"""
struct Clique{V, E} <: AbstractVector{V}
    residual::UnitRange{V}
    separator::SubArray{V, 1, FVector{V}, Tuple{UnitRange{E}}, true}
end

"""
    residual(clique::Clique)

Get the residual of a clique.
"""
function residual(clique::Clique)
    return clique.residual
end

"""
    separator(clique::Clique)

Get the separator of a clique.
"""
function separator(clique::Clique)
    return clique.separator
end

#############################
# Abstract Vector Interface #
#############################

function Base.getindex(clique::Clique, i::Integer)
    if i in eachindex(residual(clique))
        return residual(clique)[i]
    else
        return separator(clique)[i - length(residual(clique))]
    end
end

function Base.IndexStyle(::Type{<:Clique})
    return IndexLinear()
end

function Base.size(clique::Clique)
    return (length(residual(clique)) + length(separator(clique)),)
end

function Base.in(v, clique::Clique)
    return v in residual(clique) || insorted(v, separator(clique))
end

function Base.hasfastin(::Type{<:Clique})
    return true
end

#**********************************************************************
#**********************************************************************
#*****   MFINIT_VANILLA --- INITIAL DEFICIENCIES   ********************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       THIS SUBROUTINE COMPUTES THE INITIAL DEFICIENCIES USING A
#       STRAIGHFORWARD APPROACH.  THE DEFICIENCIES ARE USED BY THE
#       CODE TO CHECK THE WING-HUANG INITIAL DEFICIENCES WHENEVER THE
#       CODE IS CHECKING FOR CORRECTNESS.  
#
#     INPUT PARAMETERS:
#       NEQNS       - NUMBER OF EQUATIONS.
#       ADJLEN      - LENGTH OF THE ADJNCY(*) ARRAY.
#       XADJ(*)     - ARRAY OF LENGTH NEQNS+1, CONTAINING THE    
#                     POINTERS TO THE ADJACENCY STRUCTURE OF THE
#                     COMPRESSED GRAPH.
#       ADJNCY(*)   - ARRAY OF LENGTH ADJLEN, CONTAINING THE 
#                     ADJACENCY STRUCTURE OF THE COMPRESSED GRAPH.
#       DEGREE(*)   - ARRAY OF LENGTH NEQNS, CONTAINING THE DEGREE
#                     OF EACH NODE BACK IN THE UNCOMPRESSED GRAPH
#                     PLUS ONE.
#       QSIZE(*)    - ARRAY OF LENGTH NEQNS,
#                        0 -  NODE IS ABSORBED IN THE COMPRESSED
#                             GRAPH.
#                       >0 -  NUMBER OF NODES ABSORBED BY THE NODE
#                             IN THE COMPRESSED GRAPH PLUS ONE.
#
#     OUTPUT PARAMETER:
#       DEFCY2(*)   - ARRAY OF LENGTH NEQNS, CONTAINING THE
#                     DEFICIENCY OF EACH REPRESENTATIVE NODE IN
#                     THE COMPRESSED GRAPH.
#
#     WORKING PARAMETER:
#       UMARK(*)    - ARRAY OF LENGTH NEQNS, USED TO MARK (AND
#                     UNMARK) THE NEIGHBORS OF A NODE (UNODE).
#
#**********************************************************************
#
function mfinit_vanilla(
        neqns::V,
        adjlen::E,
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
        degree::AbstractVector{W},
        qsize::AbstractVector{W},
        defcy2::AbstractVector{W},
        umark::AbstractVector{I},
    ) where {V, E, I, W}
    
    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    
    #       ----------------
    #       INITIALIZATIONS.
    #       ----------------
    for unode in oneto(neqns)
        if !iszero(qsize[unode])
            umark[unode] = zero(I)
        end
    end
    
    #       -----------------------
    #       FOR EACH NODE UNODE ...
    #       -----------------------
    for unode in oneto(neqns)
        #           PRINT *, 'UNODE:', UNODE
        
        #           ----------------------------------------------
        #           IF UNODE IS A REPRESENTATIVE NODE (UNABSORBED)
        #           IN THE COMPRESSED GRAPH ...
        #           ----------------------------------------------
        if !iszero(qsize[unode])
            
            #               ---------------------------------------
            #               INITIALIZE UNODE'S DEFICIENCY COUNT AND
            #               ITS ACTIVE NEIGHBORHOOD SIZE.
            #               ---------------------------------------
            def = zero(W)
            ucount = degree[unode] - qsize[unode]
            #               ----------------------------
            #               MARK THE NEIGHBORS OF UNODE.
            #               ----------------------------
            for w in xadj[unode]:xadj[unode + one(V)] - one(E)
                wnode = adjncy[w]
                umark[wnode] = one(I)
            end
            #               ------------------------------------
            #               FOR EACH NEIGHBOR WNODE OF UNODE ...
            #               ------------------------------------
            for w = xadj[unode]:xadj[unode + one(V)] - one(E)
                wnode = adjncy[w]
                qw = qsize[wnode]
                ucount -= qw
                cnt = ucount
                #                   PRINT *,'   WNODE,CNT:',WNODE,CNT
                #                   -------------------------------
                #                   COMPUTE WNODE'S CONTRIBUTION TO
                #                   UNODE'S DEFICIENCY.
                #                   -------------------------------
                for x in xadj[wnode]:xadj[wnode + one(V)] - one(E)
                    xnode = adjncy[x]

                    if isone(umark[xnode])
                        cnt -= qsize[xnode]
                        #                           PRINT *,'      XNODE,CNT:',XNODE,CNT
                    end
                end
                #                   ------------------------------------
                #                   ACCUMULATE WNODE'S CONTRIBUTION TO
                #                   UNODE'S DEFICIENCY AND UNMARK WNODE.
                #                   ------------------------------------
                def += cnt * qw
                #                   PRINT *,'   WNODE,CNT:',WNODE,CNT
                umark[wnode] = zero(I)
            end
            #               -------------------------------------
            #               RECORD THE DEFICIENCY SCORE OF UNODE.
            #               -------------------------------------
            defcy2[unode] = def
            
        end
        
    end
    
    return
end

# ===== trrk! =====
# Triangular rank-k update: C = α * op(A) * op(B)' + β * C, writing only to the triangle.
# Assumes A * B' is symmetric, so uses syr2k with α/2 for BLAS types.

function trrk!(uplo::Val, trans::Val, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T <: BlasFloat}
    syr2k!(uplo, trans, α / 2, A, B, β, C)
    return
end

function trrk!(uplo::Val, trans::Val{TRANS}, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T, TRANS}
    if TRANS === :N
        gemmt!(uplo, trans, Val(:C), α, A, B, β, C)
    else
        gemmt!(uplo, trans, Val(:N), α, A, B, β, C)
    end
    return
end

#**********************************************************************
#**********************************************************************
#*****   BUILD_HEAP ... BUILD A HEAP   ********************************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       BUILD_HEAP CREATES A BINARY HEAP OUT OF A SET OF N ELEMENTS.
#
#       EACH ELEMENT HAS TWO FIELDS: (WEIGHT,VERTEX).  THE VERTEX
#       FIELD REFERS TO A VERTEX AND THE WEIGHT FIELD REFERS TO A
#       WEIGHT ASSOCIATED WITH THE VERETEX.  THE VERTICES ARE ASSUMED
#       TO BE UNIQUE INTEGERS FROM 1 TO N.  THE HEAP IS CONSTRUCTED
#       USING THE WEIGHTS.
#     
#     INPUT PARAMETER:
#       N           - IT IS THE NUMBER OF INPUT ELEMENTS.
#
#     MODIFIED PARAMETERS:
#       HEAP(*)     - IT IS AN ARRAY OF SIZE 2*N.  ON INPUT,
#                     IT CONTAINS A SET OF NODES (IN ARBITRARY
#                     ORDER).  HEAP(2*K-1) CONTAINS THE WEIGHT
#                     OF NODE K AND HEAP(2*K) CONTAINS THE
#                     CORRESPONDING VERTEX.  ON OUTPUT, THE
#                     NODES ARE REARRANGED TO FORM A HEAP.
#       V2HEAP(*)   - V2HEAP IS A MAPPING OF THE VERTICES TO
#                     THE NODES IN THE HEAP.
#
#     OUTPUT PARAMETER:
#       HEAPSIZE    - IT IS THE NUMBER OF ELEMENTS IN HEAP.
#
#**********************************************************************
#
function build_heap(heap::AbstractVector{W}, v2heap::AbstractVector{V}, n::V) where {V, W}

    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------

    heapsize = n

    for node in reverse(oneto(half(n)))
        move_down(heap, heapsize, node, v2heap)
    end

    return heapsize
end

#**********************************************************************
#**********************************************************************
#*****   MOVE_UP ... MOVE A NODE UP A HEAP   **************************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       MOVE_UP MOVES A GIVEN ELEMENT UP A BINARY TREE TO MAKE SURE
#       THE BINARY TREE IS A HEAP.
#
#       EACH ELEMENT HAS TWO FIELDS: (WEIGHT,VERTEX).  THE VERTEX
#       FIELD REFERS TO A VERTEX AND THE WEIGHT FIELD REFERS TO A
#       WEIGHT ASSOCIATED WITH THE VERETEX.  THE VERTICES ARE ASSUMED
#       TO BE UNIQUE INTEGERS FROM 1 TO N.  THE HEAP IS CONSTRUCTED
#       USING THE WEIGHTS.
#
#     INPUT PARAMETERS:
#       HEAPSIZE    - IT IS THE NUMBER OF ELEMENTS IN HEAP.
#       VTX_PTR     - THE LOCATION OF THE ELEMENT TO BE MOVED UP.
#
#     MODIFIED PARAMETERS:
#       HEAP(*)     - IT IS AN ARRAY OF SIZE 2*HEAPSIZE.  ON INPUT,
#                     IT CONTAINS A SET OF NODES THAT ARE IN A HEAP,
#                     WITH HEAP(2*K-1) CONTAINING THE WEIGHT OF NODE
#                     K AND HEAP(2*K) CONTAINING THE CORRESPONDING
#                     VERTEX.  ON OUTPUT, THE NODES ARE REARRANGED
#                     TO FORM A HEAP.
#       V2HEAP(*)   - V2HEAP IS A MAPPING OF THE VERTICES TO
#                     THE NODES IN HEAP.
#
#**********************************************************************
#
function move_up(heap::AbstractVector{W}, heapsize::V, vtx_ptr::V, v2heap::AbstractVector{V}) where {V, W}
    
    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    
    #       ------------------------------------------------------
    #       MOVE THE GIVEN NODE IN LOCATION VTX_PTR UP IN HEAP AND
    #       ENSURE THAT HEAP IS A HEAP.
    #       ------------------------------------------------------
    v = vtx_ptr
    #       PRINT *, 'FLD_INDEX = ', VTX_PTR
    
    while ispositive(v - one(V))
        #           PRINT *, 'NODE = ', V
        
        #           ------------------------------------------------
        #           DO THE FOLLOWING, AS LONG AS THE ELEMENT HAS NOT
        #           REACHED THE ROOT OF THE BINARY TREE.
        #           ------------------------------------------------
        
        #           ----------------
        #           P IS THE PARENT.
        #           ----------------
        p = half(v)
        
        #           -----------------------------------------------
        #           V_PTR AND P_PTR POINT TO WHERE V AND ITS PARENT
        #           ARE LOCATED IN HEAP.
        #           -----------------------------------------------
        v_ptr = twice(v)
        p_ptr = twice(p)
        
        #           --------------------------------------------
        #           V_WT AND P_WT ARE THE WEIGHT FIELDS OF V AND
        #           ITS PARENT.
        #           --------------------------------------------
        v_wt = heap[v_ptr - one(V)]
        p_wt = heap[p_ptr - one(V)]
        
        #           PRINT *, 'VAL, VAL1 = ', V_WT, P_WT
        if v_wt >= p_wt
            
            #               ----------------------------------------------
            #               WE ARE DONE MOVING ELEMENT UP THE BINARY TREE.
            #               ----------------------------------------------
            v = zero(V)
            
        else

            #               ----------------------------------------------
            #               HERE V_WT < P_WT, SO THE WEIGHT FIELD OF THE
            #               THE NODE IS LESS THAN THAT OF THE PARENT.  THE
            #               TWO SHOULD BE SWAPPED.
            #               ----------------------------------------------

            c_vtx = convert(V, heap[v_ptr])
            v2heap[c_vtx] = p

            p_vtx = convert(V, heap[p_ptr])
            v2heap[p_vtx] = v
            #               PRINT *, 'VTX, FLD_NEXT, IPOINT, FLD_NOW = ',
            #    &                    C_VTX, P, P_VTX, V

            heap[v_ptr] = heap[p_ptr]
            heap[p_ptr] = convert(W, c_vtx)
            
            heap[v_ptr - one(V)] = p_wt
            heap[p_ptr - one(V)] = v_wt
            
            v = p
            
        end
        
    end
    
    return
end

using SparseArrays.CHOLMOD: Factor
using SparseArrays.LibSuiteSparse: cholmod_factor_struct

function ChordalCholesky(F::Factor)
    return ChordalCholesky{:L}(F)
end

function ChordalCholesky{:L}(F::Factor{T, I}) where {T, I}
    fstruct = unsafe_load(F.ptr)
    ncol = convert(I, fstruct.n)
    perm0 = unsafe_wrap(Array, Ptr{I}(fstruct.Perm), ncol)

    if iszero(fstruct.is_super)
        xsize = convert(I, fstruct.nzmax)
        blkptr0 = unsafe_wrap(Array, Ptr{I}(fstruct.p), ncol + one(I))
        bagtgt0 = unsafe_wrap(Array, Ptr{I}(fstruct.i), xsize)
        blkval0 = unsafe_wrap(Array, Ptr{T}(fstruct.x), xsize)

        P, S = cholmod_symb_node(ncol, perm0, blkptr0, bagtgt0)
    else
        nfrt = convert(I, fstruct.nsuper)
        ssize = convert(I, fstruct.ssize)
        xsize = convert(I, fstruct.xsize)

        resptr0 = unsafe_wrap(Array, Ptr{I}(fstruct.super), nfrt + one(I))
        bagptr0 = unsafe_wrap(Array, Ptr{I}(fstruct.pi), nfrt + one(I))
        bagtgt0 = unsafe_wrap(Array, Ptr{I}(fstruct.s), ssize)
        blkptr0 = unsafe_wrap(Array, Ptr{I}(fstruct.px), nfrt + one(I))
        blkval0 = unsafe_wrap(Array, Ptr{T}(fstruct.x), xsize)

        P, S = cholmod_symb_supn(ncol, nfrt, perm0, resptr0, bagptr0, bagtgt0)
    end

    CF = ChordalCholesky{:L, T}(P, S)

    return cholmod_copy!(CF, blkptr0, blkval0)
end

function cholmod_symb_supn(
    ncol::I,
    nfrt::I,
    perm0::AbstractVector{I},
    resptr0::AbstractVector{I},
    bagptr0::AbstractVector{I},
    bagtgt0::AbstractVector{I},
) where {I}

    nsep = zero(I)

    for j in oneto(nfrt)
        nn = resptr0[j + one(I)] - resptr0[j]
        nj = bagptr0[j + one(I)] - bagptr0[j]
        nsep += nj - nn
    end

    res = BipartiteGraph{I, I, FVector{I},   OneTo{I}}(ncol, nfrt, ncol)
    sep = BipartiteGraph{I, I, FVector{I}, FVector{I}}(ncol, nfrt, nsep)
    perm = FVector{I}(undef, ncol)

    pointers(res)[one(I)] = one(I)
    pointers(sep)[one(I)] = one(I)
    q = one(I)

    for j in oneto(nfrt)
        vstrt = resptr0[j] + one(I)
        vstop = resptr0[j + one(I)]
        nn = vstop - vstrt + one(I)

        pstrt = bagptr0[j] + nn + one(I)
        pstop = bagptr0[j + one(I)]

        pointers(res)[j + one(I)] = pointers(res)[j] + nn

        for p in pstrt:pstop
            targets(sep)[q] = bagtgt0[p] + one(I)
            q += one(I)
        end

        pointers(sep)[j + one(I)] = q
    end

    S = ChordalSymbolic(res, sep)

    for j in oneto(ncol)
        perm[j] = perm0[j] + one(I)
    end

    return Permutation(perm), S
end

function cholmod_symb_node(
        ncol::I,
        perm0::AbstractVector{I},
        bagptr0::AbstractVector{I},
        bagtgt0::AbstractVector{I},
    ) where {I}

    nsep = zero(I)

    for j in oneto(ncol)
        pstrt = bagptr0[j] + one(I)
        pstop = bagptr0[j + one(I)]

        for p in pstrt:pstop
            v = bagtgt0[p] + one(I)

            if v > j
                nsep += pstop - p + one(I)
                break
            end
        end
    end

    res = BipartiteGraph{I, I, FVector{I},   OneTo{I}}(ncol, ncol, ncol)
    sep = BipartiteGraph{I, I, FVector{I}, FVector{I}}(ncol, ncol, nsep)
    perm = FVector{I}(undef, ncol)

    for j in oneto(ncol + one(I))
        pointers(res)[j] = j
    end

    pointers(sep)[one(I)] = one(I)
    q = one(I)

    for j in oneto(ncol)
        pstrt = bagptr0[j] + one(I)
        pstop = bagptr0[j + one(I)]

        for p in pstrt:pstop
            v = bagtgt0[p] + one(I)

            if v > j
                targets(sep)[q] = v
                q += one(I)
            end
        end

        pointers(sep)[j + one(I)] = q
    end

    S = ChordalSymbolic(res, sep)

    for j in oneto(ncol)
        perm[j] = perm0[j] + one(I)
    end

    return Permutation(perm), S
end

function cholmod_copy!(
        CF::ChordalCholesky{:L, T, I},
        blkptr0::AbstractVector{I},
        blkval0::AbstractVector{T},
    ) where {T, I}
    nfrt = nfr(CF)

    for j in oneto(nfrt)
        nn = eltypedegree(CF.S.res, j)
        na = eltypedegree(CF.S.sep, j)

        bp = blkptr0[j] + one(I)
        Dp = CF.S.Dptr[j]
        Lp = CF.S.Lptr[j]

        for c in oneto(nn)
            for r in oneto(nn)
                CF.Dval[Dp] = blkval0[bp]
                Dp += one(I)
                bp += one(I)
            end

            for r in oneto(na)
                CF.Lval[Lp] = blkval0[bp]
                Lp += one(I)
                bp += one(I)
            end
        end
    end

    return CF
end

#**********************************************************************
#**********************************************************************
#*****   ELMTRA ..... QUOTIENT GRAPH TRANSFORMATION   *****************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       SEPTEMBER 22, 2025
#
#**********************************************************************
#
#     PURPOSE:
#       THIS SUBROUTINE PERFORMS THE QUOTIENT GRAPH TRANSFORMATION
#       CAUSED BY THE ELIMINATION OF ENODE.  ENODE'S ELIMINATION
#       CLIQUE WAS COMPUTED EARLIER BY ROUTINE ELMCLQ IN ARRAY
#       ECLIQ(*).
#
#       NOTES:
#         IT USES HASHING TO DETECT SUPERNODES.
#
#     INPUT PARAMETERS:
#       ENODE       - NODE TO BE ELIMINATED.
#       NEQNS       - NUMBER OF EQUATIONS.
#       ADJLEN      - LENGTH OF THE ADJACENCY STRUCTURE (ADJNCY(*)).
#                     IDEALLY AT LEAST NEQNS GREATER THAN INITIAL
#                     XADJ(NEQNS+1)-1.
#       MAXINT      - MAXIMUM INTEGER VALUE WITH WHICH VERTICES CAN
#                     BE MARKED (SEE MARKER(*)).
#       NNODES      - NUMBER OF NODES IN ENODE'S ELIMINATION CLIQUE.
#       ECLIQ(*)    - ARRAY OF LENGTH NEQNS, CONTAINS ENODE'S  
#                     ELIMINATION CLIQUE.
#       INVP(*)     - ARRAY OF LENGTH NEQNS.
#                       ELIMINATED: -NUM, WHERE NUM IS THE NUMBER
#                                   ASSIGNED BY THE ELIMINATION
#                                   ORDER.
#
#     MODIFIED PARAMETERS:
#       TAG         - VALUE USED TO MARK VERTICES, GENERALLY TO
#                     REGULATE AGAINST PROCESSING THE SAME VERTEX
#                     TWICE.
#       XADJ(*)     - ARRAY OF LENGTH NEQNS+1, CONTAINING POINTERS
#                     INTO THE QUOTIENT GRAPH.
#       ADJNCY(*)   - ARRAY OF LENGTH ADJLEN, CONTAINING A CHANGING
#                     QUOTIENT GRAPH.
#       NVTXS(*)    - ARRAY OF LENGTH NEQNS.
#                       ACTIVE ELIMINATED:  NUMBER OF VERTICES IN
#                                           THE ELIMINATION CLIQUE.
#                       MERGED ELIMINATED:  -1.
#                       UNELIMINATED:       NUMBER OF UNELIMINATED
#                                           VERTEX NEIGHBORS IN
#                                           CURRENT QUOTIENT GRAPH.
#                       ABSORBED:           -1.
#       WORK(*)     - ARRAY OF LENGTH NEQNS.
#                       ACTIVE ELIMINATED:  NOT USED IN THIS CASE.
#                       UNELIMINATED:       NUMBER OF ELIMINATION
#                                           CLIQUES VERTEX IS
#                                           ADJACENT TO IN THE
#                                           QUOTIENT GRAPH.
#                       ABSORBED:           MAPS ABSORBED VERTEX
#                                           TO MINUS THE ABSORBING
#                                           VERTEX
#                                           (I.E., -ABSORBEE).
#       QSIZE(*)    - ARRAY OF SIZE NEQNS.
#                       ELIMINATED:   NOT USED AT THIS TIME.
#                       UNELIMINATED AND NOT IN ENODE'S ELIMINATION
#                         CLIQUE:     SUPERNODE SIZE.
#                       UNELIMINATED AND IN ENODE'S ELIMINATION
#                         CLIQUE:     NEGATIVE OF SUPERNODE SIZE.
#                                     CHANGED BACK TO POSITIVE AT
#                                     END OF ROUTINE.
#                         ABSORBED:   0.
#       MARKER(*)   - ARRAY OF LENGTH NEQNS, USED TO MARK PREVIOUS
#                     VISITS TO VERTICES.
#                       NOT ABSORBED: <MAXINT.
#                       ABSORBED:     MAXINT.
#       ECHEAD      - HEAD OF ELIMINATION CLIQUE LIST.
#       ECTAIL      - TAIL OF ELIMINATION CLIQUE LIST.
#       ECFORW(*)   - ARRAY OF SIZE NEQNS.
#                       FORWARD LINKS OF A LIST OF THE ELIMINATION 
#                         CLIQUES ORDERED BY THE ELIMINATION.
#                       OTHERWISE: -1.
#       NXTLOC      - POINTS TO FIRST LOCATION IN VACANT STORAGE
#                     REMAINING AT END OF ADJACENCY STRUCTURE
#                     (ADJNCY(*)).
#       GBGCNT      - NUMBER OF GARBAGE COLLECTIONS PERFORMED ON
#                     THE QUOTIENT GRAPH DATA STRUCTURE.
#       CLQSIZ      - ACTUAL SIZE OF THE CLIQUE GENERATED BY
#                     ENODE'S ELIMINATION.  IT IS CORRECT ON
#                     INPUT, AND IS MODIFIED BY ANY MASS
#                     ELIMINATION.
#       UMARK(*)    - ARRAY OF LENGTH NEQNS, USED FOR MARKING
#                     DURING WING-HUANG MARKING PROCESSES.
#                       NOT ABSORBED: <MAXINT.
#                       ABSORBED:     MAXINT.
#
#     WORKING PARAMETERS:
#       HHEADS      - ARRAY OF SIZE NEQNS.  HEADS OF THE LISTS
#                     USED FOR HASHING.
#       HLINK(*)    - ARRAY OF LENGTH NEQNS.  FORWARD LINK IN
#                     HASH LISTS (>=0).
#
#**********************************************************************
#
function elmtra(
        enode::V,
        neqns::V,
        adjlen::E,
        nnodes::V,
        ecliq::AbstractVector{V},
        invp::AbstractVector{V},
        tag::I,
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
        nvtxs::AbstractVector{V},
        work::AbstractVector{V},
        qsize::AbstractVector{W},
        qnmbr::AbstractVector{V},
        marker::AbstractVector{I},
        echead::V,
        ectail::V,
        ecforw::AbstractVector{V},
        nxtloc::E,
        gbgcnt::I,
        clqsiz::W,
        umark::AbstractVector{I},
        hheads::AbstractVector{V},
        hlink::AbstractVector{V},
    ) where {V, E, I, W}
    
    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    
    #       ---------------------
    #       BUMP TAG.
    #       NOTE: TAG <= MAXINT-1
    #       ---------------------
    if tag <= maxint(I) - two(I)
        tag += one(I)
    else
        tag = one(I)

        for i in oneto(neqns)
            if marker[i] < maxint(I)
                marker[i] = zero(I)
            end
        end
    end

    #       -----------------------------------------------------------
    #       MARK THE CLIQUES MERGED TO FORM ENODE'S ELIMINATION CLIQUE.
    #       THIS SERVES TO REMOVE THEM FROM THE QUOTIENT GRAPH.
    #       -----------------------------------------------------------
    cstart = xadj[enode] + convert(E, nvtxs[enode])
    cstop = cstart + convert(E, work[enode]) - one(E)

    for c in cstart:cstop
        cnode = adjncy[c]
        nvtxs[cnode] = -one(V)
        marker[cnode] = tag
    end

    #       -------------------------------------------------
    #       IF ENODE'S ELIMINATION CLIQUE WILL NOT FIT IN THE
    #       REMAINING STORAGE ...
    #       -------------------------------------------------
    remain = adjlen - nxtloc + one(E)

    if convert(E, nnodes) > remain
        #           ---------------------------------------------------------------
        #           ... PERFORM GARBAGE COLLECTION ON
        #               THE QUOTIENT GRAPH STRUCTURE.
        #
        #           INPUT:    NEQNS, ADJLEN, ECHEAD, ECFORW, NVTXS,
        #                     WORK, INVP
        #           MODIFIED: XADJ, ADJNCY
        #           OUTPUT:   NXTLOC
        #           ---------------------------------------------------------------
        nxtloc = garbg2(
            neqns, adjlen, echead, ecforw, nvtxs,
            work, invp, xadj, adjncy, nxtloc
        )

        gbgcnt += one(I)
    end
    
    #       ------------------------------------
    #       COPY ENODE'S ELIMINATION CLIQUE INTO
    #       THE QUOTIENT GRAPH STRUCTURE.
    #       ------------------------------------
    fstloc = nxtloc

    for i in oneto(nnodes)
        adjncy[nxtloc] = ecliq[i]
        nxtloc += one(E)
    end
    #       ------------------------------------
    #       RECORD POINTER AND LENGTH FOR ENODE.
    #       ------------------------------------
    xadj[enode] = fstloc
    nvtxs[enode] = nnodes
    #       -----------------------------------------------
    #       APPEND ENODE TO END OF ELIMINATION CLIQUE LIST.
    #       -----------------------------------------------
    if iszero(ectail)
        echead = enode
    else
        ecforw[ectail] = enode
    end

    ectail = enode
    ecforw[enode] = zero(V)

    #       **************************************************************
    #       FOR EVERY VERTEX JNODE IN ENODE'S ELIMINATION CLIQUE,
    #           (1) UPDATE (I.E. REDUCE) ITS SET OF VERTEX NEIGHBORS.
    #           (2) UPDATE (GENERALLY REDUCE) ITS SET OF CLIQUE NEIGHBORS.
    #
    #       ANCILLARY FUNCTION OF THE LOOP:
    #           (1) MASS ELIMINATION
    #       **************************************************************
    #       --------------------------------------------------------
    #       FOR EVERY VERTEX JNODE IN ENODE'S ELIMINATION CLIQUE ...
    #       --------------------------------------------------------
    jstart = xadj[enode]
    jstop = jstart + convert(E, nvtxs[enode]) - one(E)

    for j in jstart:jstop
        jnode = adjncy[j]
        #           ********************************************************
        #           UPDATE (I.E., REDUCE) VERTEX NEIGHBORS (INODE) OF JNODE.
        #           ********************************************************
        #           --------------------------------------------
        #           FOR EVERY VERTEX NEIGHBOR INODE OF JNODE ...
        #           --------------------------------------------
        istart = xadj[jnode]
        istop = xadj[jnode] + convert(E, nvtxs[jnode]) - one(E)
        nxtlc2 = istart

        for i in istart:istop
            inode = adjncy[i]
            #               -----------------------------------------
            #               IF INODE IS NOT IN ENODE'S ELIMINATION
            #               CLIQUE AND HAS NOT BEEN ABSORBED THEN ...
            #               -----------------------------------------
            if ispositive(qsize[inode])
                #                   ------------------------------------
                #                   RETAIN INODE IN JNODE'S VERTEX LIST.
                #                   ------------------------------------
                adjncy[nxtlc2] = inode
                nxtlc2 += one(E)
            end
        end
        cst = nxtlc2
        #           ****************************************************
        #           UPDATE (GENERALLY REDUCE) CLIQUE NEIGHBORS OF JNODE.
        #           ****************************************************
        #           ----------------------------------------------
        #           FOR EACH ELIMINATION CLIQUE NEIGHBOR CNODE ...
        #           ----------------------------------------------
        cstart = istop + one(E)
        cstop = istop + convert(E, work[jnode])

        for c in cstart:cstop
            cnode = adjncy[c]
            #               ---------------------------------------
            #               IF CNODE WAS NOT MERGED TO FORM ENODE'S
            #               ELIMINATION CLIQUE ...
            #               ---------------------------------------
            if marker[cnode] < tag
                #                   --------------------------
                #                   ADD CNODE TO JNODE'S LIST.
                #                   --------------------------
                adjncy[nxtlc2] = cnode
                nxtlc2 += one(E)
            end
        end
        #           ----------------------------------------------------
        #           INCLUDE ENODE AS AN ELIMINATION CLIQUE NBR OF JNODE.
        #           ----------------------------------------------------
        adjncy[nxtlc2] = enode
        #           ---------------------------------------------------
        #           COMPUTE THE NUMBER OF VERTEX AND ELIMINATION CLIQUE
        #           NEIGHBORS OF JNODE.
        #           ---------------------------------------------------
        nvtxs[jnode] = convert(V, cst - istart)
        work[jnode] = convert(V, nxtlc2 - cst) + one(V)
        #           ------------------------------------------------
        #           IF ENODE IS THE ONLY NEIGHBOR OF JNODE, THEN ...
        #           ------------------------------------------------
        if isone(work[jnode]) && iszero(nvtxs[jnode])
            #               -------------------------------------------
            #               ... PERFORM MASS ELIMINATION OF JNODE ALONG
            #               WITH ENODE.
            #               NOTE: QSIZE'S ARE NEGATIVE.
            #               -------------------------------------------
            work[jnode] = -enode
            qsize[enode] += qsize[jnode]
            qnmbr[enode] += qnmbr[jnode]
            nvtxs[jnode] = -one(V)
            marker[jnode] = maxint(I)
            umark[jnode] = maxint(I)
            clqsiz += qsize[jnode]
            qsize[jnode] = zero(W)
            qnmbr[jnode] = zero(V)
        end
    end

    #       *********************************
    #       SUPERNODE ABSORPTION VIA HASHING.
    #       *********************************
    #       -------------------------------------
    #       INITIALIZE EMPTY HASH LISTS.
    #       HHEADS(I) IS THE HEAD OF HASH LIST I.
    #       -------------------------------------
    for i in oneto(nnodes)
        hheads[i] = zero(V)
    end
    #       --------------------------------------------------------
    #       FOR EVERY VERTEX INODE IN ENODE'S ELIMINATION CLIQUE ...
    #       --------------------------------------------------------
    istart = xadj[enode]
    istop = istart + convert(E, nvtxs[enode]) - one(E)

    for i in istart:istop
        inode = adjncy[i]
        #           ------------------------------------
        #           IF INODE HAS BEEN ABSORBED, SKIP IT.
        #           ------------------------------------
        if !iszero(qsize[inode])
            #               ---------
            #               BUMP TAG.
            #               ---------
            if tag <= maxint(I) - two(I)
                tag += one(I)
            else
                tag = one(I)

                for k in oneto(neqns)
                    if marker[k] < maxint(I)
                        marker[k] = zero(I)
                    end
                end
            end
            #               -------------------------------------
            #               MARK THE QUOTIENT NEIGHBORS OF INODE.
            #               (AND COMPUTE ITS HASH VALUE.)
            #               -------------------------------------
            hash = zero(I)
            nvtxi = nvtxs[inode]
            nclqi = work[inode]
            kstart = xadj[inode]
            kstop = kstart + convert(E, nvtxi + nclqi) - two(E)

            for k in kstart:kstop
                knode = adjncy[k]
                hash += convert(I, knode)
                marker[knode] = tag
            end

            hash2 = convert(V, mod(hash, convert(I, nnodes))) + one(V)
            #               ------------------------------------------------
            #               SCAN THE NODES JNODE ALREADY IN INODE'S HASH BIN
            #               FOR IDENTICAL QUOTIENT ADJACENCY SETS.
            #               ------------------------------------------------
            #               -------------------------------------------
            #               FOR EACH NODE JNODE IN INODE'S HASH BIN ...
            #               -------------------------------------------
            done = false
            jnode = hheads[hash2]

            while ispositive(jnode) && !done
                #                   --------------------------------------------
                #                   IF LIST LENGTHS OF INODE AND JNODE MATCH ...
                #                   --------------------------------------------
                match = false

                if nvtxs[jnode] == nvtxi && work[jnode] == nclqi
                    #                       ------------------
                    #                       CHECK FOR A MATCH.
                    #                       ------------------
                    match = true
                    kstart = xadj[jnode]
                    kstop = kstart + convert(E, nvtxs[jnode] + work[jnode]) - two(E)

                    for k in kstart:kstop
                        knode = adjncy[k]

                        if marker[knode] != tag
                            match = false
                        end
                    end
                end
                #                   ----------------------------
                #                   IF INODE AND JNODE MATCH ...
                #                   ----------------------------
                if match
                    #                       ----------------------------------
                    #                       INODE WILL BE ABSORBED INTO JNODE.
                    #                       NOTE: QSIZE'S ARE NEGATIVE.
                    #                       ----------------------------------
                    work[inode] = -jnode
                    qsize[jnode] += qsize[inode]
                    qnmbr[jnode] += qnmbr[inode]
                    nvtxs[inode] = -one(V)
                    marker[inode] = maxint(I)
                    umark[inode] = maxint(I)
                    qsize[inode] = zero(W)
                    qnmbr[inode] = zero(V)
                    #                       -------------------
                    #                       INODE IS ABSORBED.
                    #                       SKIP TO NEXT INODE.
                    #                       -------------------
                    done = true
                end

                if !done
                    #                       --------------------------------
                    #                       TRY NEXT JNODE IN HASH BIN.
                    #                       HLINK(*)(JNODE) IS FORWARD LINK.
                    #                       --------------------------------
                    jnode = hlink[jnode]
                end
            end

            if !done
                #                   ------------------------------------
                #                   INODE WILL BE A REPRESENTATIVE NODE.
                #                   INSERT IT INTO ITS HASH LIST.
                #                   HLINK(INODE) IS FORWARD LINK.
                #                   ------------------------------------
                hlink[inode] = hheads[hash2]
                hheads[hash2] = inode
            end
        end
        # 200       continue
    end
    
    #       ------------------------------------------------------
    #       REMOVE ABSORBED NODES FROM ENODE'S ELIMINATION CLIQUE.
    #       REVERSE SIGNS ON QSIZE'S.
    #       ------------------------------------------------------
    istart = xadj[enode]
    istop = istart + convert(E, nvtxs[enode]) - one(E)
    nxtlc2 = istart

    for i in istart:istop
        inode = adjncy[i]
        #           ----------------------------------------------
        #           UNMARKING WHEN OUTMATCHING IS BEING EXPLOITED.
        #           ----------------------------------------------
        if !iszero(qsize[inode])
            qsize[inode] = -qsize[inode]
            adjncy[nxtlc2] = inode
            nxtlc2 += one(E)
        end
    end
    #       ----------------------------------------------------------
    #       RECORD INFO ABOUT ENODE AND RECORD NEXT AVAILABLE LOCATION
    #       IN QUOTIENT GRAPH.
    #       ----------------------------------------------------------
    nvtxs[enode] = convert(V, nxtlc2 - istart)
    qsize[enode] = -qsize[enode]
    nxtloc = nxtlc2
    
    return tag, echead, ectail, nxtloc, gbgcnt, clqsiz
end

#**********************************************************************
#**********************************************************************
#*****   GARBG2 ..... GARBAGE COLLECTION   ****************************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       THIS SUBROUTINE COMPRESSES THE ADJACENCY STRUCTURE USED BY
#       THE MINIMUM DEFICIENCY ROUTINES.  UPON COMPLETION, ALL
#       "ACTIVE" DATA IS STORED CONTIGUOUSLY IN THE FIRST PART OF
#       ADJNCY(*), WHILE UNUSED SPACE OCCURS AS A SINGLE BLOCK THAT
#       TRAILS THE ACTIVE PORTION OF THE DATA STRUCTURE.
#
#     INPUT PARAMETERS:
#       NEQNS       - NUMBER OF EQUATIONS.
#       ADJLEN      - LENGTH OF ADJNCY(*).
#       ECHEAD      - HEAD OF ELIMINATION CLIQUE LIST.
#       ECFORW(*)   - ARRAY OF SIZE NEQNS.
#                       ELIMINATED NOT IN PLACE: FORWARD LINKS OF
#                         A LIST OF THE ELIMINATION CLIQUES ORDERED
#                         BY THE ELIMINATION.
#                       OTHERWISE: -1.
#       NVTXS(*)    - ARRAY OF LENGTH NEQNS+1.
#                       ACTIVE ELIMINATED: NUMBER OF VERTICES IN THE
#                         ELIMINATION CLIQUE.
#                       MERGED ELIMINATED: -1.
#                       UNELIMINATED: NUMBER OF UNELIMINATED VERTEX
#                         NEIGHBORS IN CURRENT QUOTIENT GRAPH.
#                       ABSORBED: -1.
#       WORK(*)     - ARRAY OF LENGTH NEQNS.
#                       ACTIVE ELIMINATED: >=0; NOT USED.
#                       UNELIMINATED: NUMBER OF ELIMINATION
#                         CLIQUES VERTEX IS ADJACENT TO IN THE
#                         QUOTIENT GRAPH.
#                       ABSORBED: MAPS ABSORBED VERTEX TO MINUS
#                         THE ABSORBING VERTEX (I.E., -ABSORBEE).
#       INVP(*)     - ARRAY OF LENGTH NEQNS.
#                       ELIMINATED: -NUM, WHERE NUM IS THE NUMBER
#                         ASSIGNED BY THE ELIMINATION ORDER.
#
#     MODIFIED PARAMETERS:
#       XADJ(*)     - ARRAY OF LENGTH NEQNS+1.
#                     XADJ(JNODE) POINTS TO THE BEGINNING OF JNODE'S 
#                     NEIGHBORS IN ADJNCY(*).
#                     NOTE: XADJ(JNODE+1) DOES **NOT** GENERALLY
#                     POINT ONE LOCATION BEYOND THE END OF JNODE.
#                     TERMINATION SEES THE SAME FUNCTIONALITY, BUT
#                     NOW ALL UNUSED SPACE IN ADJNCY(*) HAS BEEN
#                     MOVED TO THE END.
#       ADJNCY(*)   - ARRAY OF LENGTH ADJLEN.
#                     ADJACENCY LISTS.  THE VERTEX NEIGHBORS OF 
#                     VERTEX JNODE ARE LOCATED IN ADJLEN(XADJ(JNODE)),
#                     ADJLEN(XADJ(JNODE)+1), ... ,
#                     ADJLEN(XADJ(JNODE)+NVTXS(JNODE)-1).
#
#     OUTPUT PARAMETER:
#       NXTLOC      - POINTS TO THE FIRST AVAILABLE LOCATION IN THE
#                     UNOCCUPIED BLOCK TO THE RIGHT OF THE ACTIVE 
#                     DATA STRUCTURE IN ADJNCY(*).  UPON TERMINATION, 
#                     ALL UNUSED SPACE IN ADJNCY(*) NOW OCCURS IN A 
#                     SINGLE BLOCK TO THE RIGHT OF THE ACTIVE DATA 
#                     STRUCTURE.
#
#**********************************************************************
#
function garbg2(
        neqns::V,
        adjlen::E,
        echead::V,
        ecforw::AbstractVector{V},
        nvtxs::AbstractVector{V},
        work::AbstractVector{V},
        invp::AbstractVector{V},
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
        nxtloc::E
    ) where {V, E}
    
    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    
    #       ---------------
    #       INITIALIZATION.
    #       ---------------
    #       PRINT *,' '
    #       PRINT *,'ENTER GARBAGE COLLECTION'
    fstloc = one(E)
    nxtlc2 = fstloc

    #       -----------------------------------------
    #       FOR THE NEXT VERTEX NXTNOD (IN ORDER) ...
    #       -----------------------------------------
    for nxtnod in oneto(neqns)
        #           -------------------------------------
        #           ... IF NXTNOD IS AN ACTIVE VERTEX ...
        #               I.E. UNMERGED AND UNABSORBED
        #           -------------------------------------
        if !isnegative(nvtxs[nxtnod])
            #               ---------------------------------
            #               ... IF NXTNOD IS UNELIMINATED ...
            #               ---------------------------------
            if !isnegative(invp[nxtnod])
                #                   --------------------------------
                #                   ... THEN COPY NXTNOD'S LIST INTO
                #                       ITS NEW LOCATION.
                #                   --------------------------------
                #                   PRINT *,'NXTNOD,NVTXS,WORK:',NXTNOD,NVTXS(NXTNOD),
                #    &                      WORK(NXTNOD)
                jstart = xadj[nxtnod]
                jstop = jstart + convert(E, nvtxs[nxtnod] + work[nxtnod]) - one(E)
                nxtlc2 = fstloc

                for j in jstart:jstop
                    #                       PRINT *,'JNODE, NXTLC2, J:',ADJNCY(NXTLC2),
                    #    &                          NXTLC2, J
                    adjncy[nxtlc2] = adjncy[j]
                    nxtlc2 += one(E)
                end
                #                   ----------------------------
                #                   ... AND RECORD NEW LOCATION.
                #                   ----------------------------
                xadj[nxtnod] = fstloc
                fstloc = nxtlc2
            end
        end
    end
    
    #       --------------------------------------------------------
    #       FOR THE NEXT VERTEX (NXTNOD) ELIMINATED NOT IN PLACE ...
    #       (IN ORDER BY ELIMINATION)
    #       --------------------------------------------------------
    nxtnod = echead

    while !iszero(nxtnod)
        #           PRINT *,'ELIMINATION CLIQUES'
        #           PRINT *,'NXTNOD,NVTXS     :',NXTNOD,NVTXS(NXTNOD)
        #           --------------------------------------
        #           IF NXTNOD REMAINS AN ACTIVE (UNMERGED)
        #           ELIMINATION CLIQUE ...
        #           --------------------------------------
        if !isnegative(nvtxs[nxtnod])
            #               --------------------------------------------------
            #               ... THEN COPY NXTNOD'S LIST INTO ITS NEW LOCATION.
            #               --------------------------------------------------
            jstart = xadj[nxtnod]
            jstop = jstart + convert(E, nvtxs[nxtnod]) - one(E)
            nxtlc2 = fstloc

            for j in jstart:jstop
                #                   PRINT *,'JNODE, NXTLC2, J:',ADJNCY(NXTLC2),NXTLC2, J
                adjncy[nxtlc2] = adjncy[j]
                nxtlc2 += one(E)
            end
            #               ----------------------------
            #               ... AND RECORD NEW LOCATION.
            #               ----------------------------
            xadj[nxtnod] = fstloc
            fstloc = nxtlc2
        end
        #           ----------------
        #           GET NEXT CLIQUE.
        #           ----------------
        nxtnod = ecforw[nxtnod]
    end
    
    #       ---------------------------------------
    #       ... AND RECORD NEXT AVAILABLE POSITION.
    #       ---------------------------------------
    nxtloc = nxtlc2
    
    return nxtloc
end

"""
    GMW81{T} <: AbstractRegularization

The Gill-Murray-Wright 1981 modified Cholesky algorithm.

### Example

```julia-repl
julia> using CliqueTrees.Multifrontal, LinearAlgebra

julia> A = [
           1 1 2
           1 1 3
           2 3 1
       ];

julia> isposdef(A)
false

julia> F = cholesky!(ChordalCholesky(A); reg=GMW81());

julia> B = Matrix(F)
3×3 Matrix{Float64}:
 3.77124  1.0      2.0
 1.0      6.01561  3.0
 2.0      3.0      3.24264

julia> isposdef(B)
true
```

### Fields

- `beta`: scaling parameter
- `delta`: minimum pivot
"""
struct GMW81{T} <: AbstractRegularization
    beta::T
    delta::T
end

function GMW81{T}(; beta=-one(T), delta=-one(T)) where {T}
    return GMW81{T}(beta, delta)
end

function GMW81(; kw...)
    return GMW81{Float64}(; kw...)
end

function initialize(A::AbstractMatrix{T}, S::AbstractVector, R::GMW81) where {T}
    if isnegative(R.beta)
        beta = gmw81_beta(A)
    else
        beta = convert(real(T), R.beta)
    end

    if isnegative(R.delta)
        delta = gmw81_delta(real(T))
    else
        delta = convert(real(T), R.delta)
    end

    return GMW81{real(T)}(beta, delta)
end

function gmw81_gamma_xi(A::AbstractMatrix{T}) where {T}
    gamma = zero(real(T))
    xi = zero(real(T))

    @inbounds for j in axes(A, 2)
        for i in axes(A, 1)
            if i == j
                gamma = max(gamma, abs(parent(A)[i, j]))
            else
                xi = max(xi, abs(A[i, j]))
            end
        end
    end

    return gamma, xi
end

function gmw81_beta(A::ChordalTriangular{DIAG, UPLO, T, I}) where {DIAG, UPLO, T, I}
    n = size(A, 1)
    gamma = zero(real(T))
    xi = zero(real(T))

    @inbounds for j in fronts(A)
        D, _ = diagblock(A, j)
        L, _ = offdblock(A, j)

        gamma, xi = max.((gamma, xi), gmw81_gamma_xi(D))
        xi = max(xi, maximum(abs, L; init=zero(real(T))))
    end

    return max(gamma, xi / sqrt(n^2 - 1), eps(real(T)))
end

function gmw81_beta(A::AbstractMatrix{T}) where {T}
    n = size(A, 1)
    gamma, xi = gmw81_gamma_xi(A)
    return max(gamma, xi / sqrt(n^2 - 1), eps(real(T)))
end

function gmw81_delta(::Type{T}) where {T}
    return cbrt(eps(real(T)))
end

function regularize(
        R::GMW81,
        S::AbstractVector,
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        Djj::T,
        j::Integer,
        uplo::Val{UPLO},
    ) where {T, UPLO}
    Aimax = zero(real(T))

    if UPLO === :L
        for i in j + 1:size(D, 1)
            Aimax = max(Aimax, abs(D[i, j]))
        end

        for i in axes(L, 1)
            Aimax = max(Aimax, abs(L[i, j]))
        end
    else
        for i in j + 1:size(D, 2)
            Aimax = max(Aimax, abs(D[j, i]))
        end

        for i in axes(L, 2)
            Aimax = max(Aimax, abs(L[j, i]))
        end
    end

    return real(S[j]) * max(abs(Djj), Aimax^2 / R.beta, R.delta)
end

# Fast path for nn = 1: D is scalar, L is vector
function regularize(
        R::GMW81,
        s,
        Djj::T,
        l::AbstractVector{T},
    ) where {T}
    Aimax = zero(real(T))

    for i in eachindex(l)
        Aimax = max(Aimax, abs(l[i]))
    end

    return real(s) * max(abs(Djj), Aimax^2 / R.beta, R.delta)
end

function LinearAlgebra.lowrankupdate!(F::ChordalLDLt{UPLO, T, I}, v::AbstractVector{T}) where {UPLO, T, I}
    return _lowrankupdate!(F, v, Val{:P}())
end

function LinearAlgebra.lowrankupdate!(F::ChordalCholesky{UPLO, T, I}, v::AbstractVector{T}) where {UPLO, T, I}
    return _lowrankupdate!(F, v, Val{:P}())
end

function LinearAlgebra.lowrankdowndate!(F::ChordalLDLt{UPLO, T, I}, v::AbstractVector{T}) where {UPLO, T, I}
    return _lowrankupdate!(F, v, Val{:N}())
end

function LinearAlgebra.lowrankdowndate!(F::ChordalCholesky{UPLO, T, I}, v::AbstractVector{T}) where {UPLO, T, I}
    return _lowrankupdate!(F, v, Val{:N}())
end

function _lowrankupdate!(F::ChordalLDLt{UPLO, T, I}, v::AbstractVector{T}, sign::Val{SIGN}) where {UPLO, T, I, SIGN}
    @assert length(v) == nov(F.S.res)

    Pval = FVector{I}(undef, nv(F.S.rel))
    Cval = FVector{T}(undef, nov(F.S.res))
    Kval = FVector{T}(undef, ne(F.S.rel))
    Fval = FVector{T}(undef, F.S.nFval + F.S.nNval)
    Mval = FVector{T}(undef, F.S.nNval)

    for i in outvertices(F.S.res)
        Cval[i] = v[F.perm[i]]
    end

    j = findbag(F.S, Cval); n = zero(I)

    while !iszero(j)
        n += one(I); Pval[n] = j; j = F.S.pnt[j]
    end

    path = view(Pval, oneto(n))

    lowrank_copy!(Kval, path, Cval, F.S.res, F.S.rel)
    ldlt_lowrank_impl!(Kval, Fval, Mval, path, Cval, F.d, F.S.Dptr, F.Dval, F.S.Lptr, F.Lval, F.S.res, F.S.rel, sign, Val{UPLO}())

    return F
end

function _lowrankupdate!(F::ChordalCholesky{UPLO, T, I}, v::AbstractVector{T}, sign::Val{SIGN}) where {UPLO, T, I, SIGN}
    @assert length(v) == nov(F.S.res)

    Pval = FVector{I}(undef, nv(F.S.rel))
    Cval = FVector{T}(undef, nov(F.S.res))
    Kval = FVector{T}(undef, ne(F.S.rel))
    Fval = FVector{T}(undef, F.S.nFval + F.S.nNval)
    Mval = FVector{T}(undef, F.S.nNval)

    for i in outvertices(F.S.res)
        Cval[i] = v[F.perm[i]]
    end

    j = findbag(F.S, Cval); n = zero(I)

    while !iszero(j)
        n += one(I); Pval[n] = j; j = F.S.pnt[j]
    end

    path = view(Pval, oneto(n))

    lowrank_copy!(Kval, path, Cval, F.S.res, F.S.rel)
    chol_lowrank_impl!(Kval, Fval, Mval, path, Cval, F.S.Dptr, F.Dval, F.S.Lptr, F.Lval, F.S.res, F.S.rel, sign, Val{UPLO}())

    return F
end

function lowrank_copy!(
        Kval::AbstractVector{T},
        path::AbstractVector{I},
        Cval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
    ) where {T, I <: Integer}

    j = zero(I)

    for i in Iterators.reverse(path)
        if !iszero(j)
            na = eltypedegree(rel, i)
            nn = eltypedegree(res, j)

            inj = neighbors(rel, i)
            cj = view(Cval, neighbors(res, j))
            ki = view(Kval, incident(rel, i))
            kj = view(Kval, incident(rel, j))

            for s in oneto(na)
                is = inj[s]

                if is <= nn
                    ki[s] = cj[is]
                else
                    ki[s] = kj[is - nn]
                end
            end
        end

        j = i
    end

    return
end

function ldlt_lowrank_impl!(
        Kval::AbstractVector{T},
        Fval::AbstractVector{T},
        Mval::AbstractVector{T},
        path::AbstractVector{I},
        Cval::AbstractVector{T},
        d::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        sign::Val{SIGN},
        uplo::Val{UPLO},
    ) where {T, I <: Integer, SIGN, UPLO}

    path_len = length(path)
    α = one(T)

    for k in oneto(I(path_len))
        α = ldlt_lowrank_loop!(Kval, Fval, Mval, path, k, Cval, d, Dptr, Dval, Lptr, Lval, res, rel, α, sign, uplo)
    end

    return
end

function chol_lowrank_impl!(
        Kval::AbstractVector{T},
        Fval::AbstractVector{T},
        Mval::AbstractVector{T},
        path::AbstractVector{I},
        Cval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        sign::Val{SIGN},
        uplo::Val{UPLO},
    ) where {T, I <: Integer, SIGN, UPLO}

    path_len = length(path)

    for k in oneto(I(path_len))
        chol_lowrank_loop!(Kval, Fval, Mval, path, k, Cval, Dptr, Dval, Lptr, Lval, res, rel, sign, uplo)
    end

    return
end

function ldlt_lowrank_loop!(
        Kval::AbstractVector{T},
        Fval::AbstractVector{T},
        Mval::AbstractVector{T},
        path::AbstractVector{I},
        k::I,
        Cval::AbstractVector{T},
        d::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        α::T,
        sign::Val{SIGN},
        uplo::Val{UPLO},
    ) where {T, I <: Integer, SIGN, UPLO}

    j = path[k]
    #
    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    nn = eltypedegree(res, j)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # c is part of the rank-1 vector
    #
    #     c := [ c₁ ] res(j)
    #          [ k₂ ] sep(j)
    #
    c₁ = view(Cval, neighbors(res, j))
    k₂ = view(Kval, incident(rel, j))
    #
    # d₁ is the diagonal for res(j)
    #
    d₁ = view(d, neighbors(res, j))
    #
    # D₁₁ and L₂₁ are the diagonal and off-diagonal blocks
    #
    #     L := [ D₁₁ ] res(j)
    #          [ L₂₁ ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + na * nn - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # f is the frontal vector at node j
    #
    #     f := [ f₁ ] nn
    #          [ f₂ ] na
    #
    p = zero(I)
    f  = view(Fval, p + one(I):p + nn + na)
    f₁ = view(Fval, p + one(I):p + nn); p += nn
    f₂ = view(Fval, p + one(I):p + na); p += na
    #
    #     f₁ ← c₁
    #
    copyrec!(f₁, c₁)
    #
    #     f₂ ← 0
    #
    zerorec!(f₂)

    if !isone(k)
        #
        # i is the child preceding j on the path
        #
        i = path[k - one(I)]
        #
        # m is the update vector from child i
        #
        m = view(Mval, oneto(eltypedegree(rel, i)))
        #
        # add m into f
        #
        #     f ← f + Rᵢ m
        #
        addrec!(f, m, neighbors(rel, i))
    end
    #
    # m₂ is the update vector from j
    #
    m₂ = view(Mval, oneto(na))
    #
    #
    #     c₁ ← f₁
    #
    copyrec!(c₁, f₁)
    #
    #     m₂ ← f₂
    #
    copyrec!(m₂, f₂)
    #
    # update D₁₁, L₂₁, d₁, and m₂
    #
    return ldlt_lowrank_kernel!(D₁₁, L₂₁, d₁, c₁, k₂, m₂, α, sign, uplo)
end

function chol_lowrank_loop!(
        Kval::AbstractVector{T},
        Fval::AbstractVector{T},
        Mval::AbstractVector{T},
        path::AbstractVector{I},
        k::I,
        Cval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        sign::Val{SIGN},
        uplo::Val{UPLO},
    ) where {T, I <: Integer, SIGN, UPLO}

    j = path[k]
    nn = eltypedegree(res, j)
    na = eltypedegree(rel, j)

    c₁ = view(Cval, neighbors(res, j))
    k₂ = view(Kval, incident(rel, j))

    Dp = Dptr[j]
    Lp = Lptr[j]
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + na * nn - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end

    p = zero(I)
    f  = view(Fval, p + one(I):p + nn + na)
    f₁ = view(Fval, p + one(I):p + nn); p += nn
    f₂ = view(Fval, p + one(I):p + na); p += na

    copyrec!(f₁, c₁)
    zerorec!(f₂)

    if !isone(k)
        i = path[k - one(I)]
        m = view(Mval, oneto(eltypedegree(rel, i)))
        addrec!(f, m, neighbors(rel, i))
    end

    m₂ = view(Mval, oneto(na))

    copyrec!(c₁, f₁)
    copyrec!(m₂, f₂)

    return chol_lowrank_kernel!(D₁₁, L₂₁, c₁, k₂, m₂, sign, uplo)
end

function lowrank_rotate(a::T, b::T, ::Val{:P}) where {T}
    return givensAlgorithm(a, b)
end

function lowrank_rotate(a::T, b::T, ::Val{:N}) where {T}
    s = b / a
    s² = s * s

    if s² < one(T)
        c = sqrt(one(T) - s²)
        r = c * a
        cosθ = one(T) / c
        sinθ = s / c
        return cosθ, sinθ, r
    else
        error()
    end
end

#
# Given a unit-lower-triangular matrix D, a matrix L, and
# vectors d, c, k, and m, compute E, F, and e such that
#
#     [ D ] diag(d) [ Dᵀ Lᵀ ] ± [  c  ] [ cᵀ kᵀ+mᵀ ] = [ E ] diag(e) [ Eᵀ Fᵀ ]
#     [ L ]                     [ k+m ]                [ F ]
#
# over-writing D with E, L with F, and d with e. Additionally, the
# vector m is over-written with the difference m ← m - L D⁻¹ c.
function ldlt_lowrank_kernel!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        d::AbstractVector{T},
        c::AbstractVector{T},
        k::AbstractVector{T},
        m::AbstractVector{T},
        α::T,
        sign::Val{SIGN},
        uplo::Val{:L},
    ) where {T, SIGN}
    @assert size(D, 1) == size(D, 2) == size(L, 2) == length(d) == length(c)
    @assert size(L, 1) == length(k) == length(m)

    @inbounds for j in axes(L, 2)
        cj = c[j]
        dj = d[j]

        if SIGN === :P
            β = α * dj + cj^2
        else
            β = α * dj - cj^2
        end

        if ispositive(β)
            d[j] = β / α

            α = β / dj

            if SIGN === :P
                δ = cj / β
            else
                δ = -cj / β
            end

            for i in j + 1:size(L, 2)
                ci = c[i] -= cj * D[i, j]
                D[i, j] += δ * ci
            end

            for i in axes(L, 1)
                mi = m[i] -= cj * L[i, j]
                L[i, j] += δ * (k[i] + mi)
            end
        else
            error()
        end
    end

    return α
end

# TODO: bad memory access pattern
function ldlt_lowrank_kernel!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        d::AbstractVector{T},
        c::AbstractVector{T},
        k::AbstractVector{T},
        m::AbstractVector{T},
        α::T,
        sign::Val{SIGN},
        uplo::Val{:U},
    ) where {T, SIGN}
    @assert size(D, 1) == size(D, 2) == size(L, 1) == length(d) == length(c)
    @assert size(L, 2) == length(k) == length(m)

    @inbounds for j in axes(L, 1)
        cj = c[j]
        dj = d[j]

        if SIGN === :P
            β = α * dj + cj^2
        else
            β = α * dj - cj^2
        end

        if ispositive(β)
            d[j] = β / α

            α = β / dj

            if SIGN === :P
                δ = cj / β
            else
                δ = -cj / β
            end

            for i in j + 1:size(L, 1)
                ci = c[i] -= cj * D[j, i]
                D[j, i] += δ * ci
            end

            for i in axes(L, 2)
                mi = m[i] -= cj * L[j, i]
                L[j, i] += δ * (k[i] + mi)
            end
        else
            error()
        end
    end

    return α
end

function chol_lowrank_kernel!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        c::AbstractVector{T},
        k::AbstractVector{T},
        m::AbstractVector{T},
        sign::Val{SIGN},
        uplo::Val{:L},
    ) where {T, SIGN}
    @assert size(D, 1) == size(D, 2) == size(L, 2) == length(c)
    @assert size(L, 1) == length(k) == length(m)

    @inbounds for j in axes(L, 2)
        Djj = D[j, j]
        cj = c[j]
        cosθ, sinθ, r = lowrank_rotate(Djj, cj, sign)

        D[j, j] = r

        for i in j + 1:size(L, 2)
            Dij = D[i, j]
            ci = c[i]

            if SIGN === :P
                D[i, j] = cosθ * Dij + sinθ * ci
            else
                D[i, j] = cosθ * Dij - sinθ * ci
            end

            c[i] = cosθ * ci - sinθ * Dij
        end

        for i in axes(L, 1)
            Lij = L[i, j]
            ki = k[i]
            mi = m[i]

            if SIGN === :P
                L[i, j] = cosθ * Lij + sinθ * (ki + mi)
            else
                L[i, j] = cosθ * Lij - sinθ * (ki + mi)
            end

            m[i] = (cosθ - one(T)) * ki + cosθ * mi - sinθ * Lij
        end
    end

    return
end

# TODO: bad memory access pattern
function chol_lowrank_kernel!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        c::AbstractVector{T},
        k::AbstractVector{T},
        m::AbstractVector{T},
        sign::Val{SIGN},
        uplo::Val{:U},
    ) where {T, SIGN}
    @assert size(D, 1) == size(D, 2) == size(L, 1) == length(c)
    @assert size(L, 2) == length(k) == length(m)

    @inbounds for j in axes(L, 1)
        Djj = D[j, j]
        cj = c[j]
        cosθ, sinθ, r = lowrank_rotate(Djj, cj, sign)

        D[j, j] = r

        for i in j + 1:size(L, 1)
            Dji = D[j, i]
            ci = c[i]

            if SIGN === :P
                D[j, i] = cosθ * Dji + sinθ * ci
            else
                D[j, i] = cosθ * Dji - sinθ * ci
            end

            c[i] = cosθ * ci - sinθ * Dji
        end

        for i in axes(L, 2)
            Lji = L[j, i]
            ki = k[i]
            mi = m[i]

            if SIGN === :P
                L[j, i] = cosθ * Lji + sinθ * (ki + mi)
            else
                L[j, i] = cosθ * Lji - sinθ * (ki + mi)
            end

            m[i] = (cosθ - one(T)) * ki + cosθ * mi - sinθ * Lji
        end
    end

    return
end

function findbag(S::ChordalSymbolic{I}, w::AbstractVector{T}) where {T, I}
    for j in vertices(S.res)
        for i in neighbors(S.res, j)
            if !iszero(w[i])
                res = neighbors(S.res, j)
                sep = neighbors(S.sep, j)

                for k in i + one(I):nov(S.res)
                    @assert iszero(w[k]) || k in res || insorted(k, sep)
                end

                return j
            end
        end
    end

    return zero(I)
end

module MLFLib

using Base: oneto
using FillArrays
using ..Utilities

export mlf!

function maxint(::Type{I}) where {I}
    return typemax(I) - convert(I, 100000)
end

include("mlfwh.jl")
include("genmf_wh.jl")
include("compress.jl")
include("mfinit_def.jl")
include("mfinit_vanilla.jl")
include("mfinit_heap.jl")
include("build_heap.jl")
include("del_heap.jl")
include("mod_heap.jl")
include("move_up.jl")
include("move_down.jl")
include("elmclq.jl")
include("elmtra.jl")
include("garbg2.jl")
include("mfupd_def.jl")
include("mfnumn.jl")

end

function writegr(io::IO, graph::AbstractGraph)
    m = 0

    for v in vertices(graph), w in neighbors(graph, v)
        if v != w && (!is_directed(graph) || v < w)
            m += 1
        end
    end

    n = nv(graph)
    println(io, "p tw $n $m")

    for v in vertices(graph), w in neighbors(graph, v)
        if v != w && (!is_directed(graph) || v < w)
            println(io, "$v $w")
        end
    end

    return
end

function readgr(io::IO)
    lines = readlines(io)

    # remove comments
    filter!(lines) do line
        !startswith(line, "c")
    end

    # parse statistics
    words = split(popfirst!(lines))
    nv = parse(Int, words[3])
    ne = parse(Int, words[4])

    # parse graph
    p = 0
    I = Vector{Int}(undef, 2ne)
    J = Vector{Int}(undef, 2ne)
    
    while !isempty(lines)
        words = split(popfirst!(lines))
        
        i = parse(Int, words[1])
        j = parse(Int, words[2])
        
        p += 1; I[p] = i; J[p] = j
        p += 1; I[p] = j; J[p] = i
    end
    
    V = ones(Int, 2ne)
    return BipartiteGraph(sparse(I, J, V))
end


function readtd(io::IO)
    lines = readlines(io)

    # remove comments
    filter!(lines) do line
        !startswith(line, "c")
    end

    isempty(lines) && error("Empty File")

    # parse statistics
    words = split(lines[1])
    nb = parse(Int, words[3])
    tw = parse(Int, words[4])
    nv = parse(Int, words[5])

    # parse hypergraph
    index = Vector{Int}(undef, nb)
    pointer = Vector{Int}(undef, nb + 1)
    target = Vector{Int}(undef, 0)
    pointer[begin] = p = 1

    for i in oneto(nb)
        words = split(lines[i + 1])

        j = parse(Int, words[2])
        index[j] = i

        for word in words[3:end]
            p += 1
            push!(target, parse(Int, word))
        end

        pointer[i + 1] = p
    end

    hypergraph = BipartiteGraph(nv, nb, p - 1, pointer, target)

    # parse tree
    I = sizehint!(Int[], nb)
    J = sizehint!(Int[], nb)

    for line in lines[(nb + 2):end]
        words = split(line)
        i = parse(Int, words[1])
        j = parse(Int, words[2])
        push!(I, index[i], index[j])
        push!(J, index[j], index[i])
    end

    root = 1
    parent = dfs_parents(BipartiteGraph(sparse(I, J, J, nb, nb)), root)
    parent[root] = 0

    tree = Parent(nb, parent)
    return hypergraph, tree
end

function readeo(io::IO, ::Type{V}) where {V}
    hypergraph, tree = readtd(io)

    treeindex = postorder(tree)
    treeorder = invperm(treeindex)

    n = nov(hypergraph)
    index = zeros(V, n)
    i = n + 1

    for b in Iterators.reverse(treeorder), v in neighbors(hypergraph, b)
        if iszero(index[v])
            index[v] = i -= 1
        end
    end

    return index
end

#**********************************************************************
#**********************************************************************
#*****   GENMF_WH ..... MINIMUM DEFICIENCY ORDERING   *****************
#*****                  (WITH WING-HUANG UPDATING)    *****************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       THIS SUBROUTINE COMPUTES ORDERINGS BASED ON MINIMUM LOCAL
#       FILL.  IT USES WING-HUANG UPDATING TO UPDATE DEFICIENCY
#       COUNTS AFTER EACH ELIMINATION STEP.
#
#     ACKNOWLEDGEMENTS:
#       THIS CODE OWES MUCH TO PAST MINIMUM DEGREE CODES.  THE
#       DATA STRUCTURES, MODULARITY, AND VARIABLE NAMING
#       CONVENTIONS OWE MUCH TO THE MULTIPLE MINIMUM DEGREE CODE
#       OF LIU (GENMMD.F).  THE AGGRESSIVE 'HASHING' TECHNIQUE
#       FOR DETECTING INDISTINGUISHABLE VERTICES OWES MUCH TO THE
#       APPROXIMATE MINIMUM DEGREE CODE OF AMESTOY, DAVIS, AND DUFF.
#
#       REFERENCES:
#
#         P. AMESTOY, T.A. DAVIS, AND I.S. DUFF, "AN APPROXIMATE
#           MINIMUM DEGREE ALGORITHM," SIAM J. MATRIX ANAL. APPL.,
#           17 (1995), PP. 1404-1411.
#
#         J.W.H. LIU, "MODIFICATION OF THE MINIMUM DEGREE
#           ALGORITHM BY MULTIPLE ELIMINATION," ACM TRANS. MATH.
#           SOFTWARE, 11 (1985), PP. 141-153.
#
#     NOTES:
#       (1) QUOTIENT GRAPHS ARE USED TO REPRESENT THE ELIMINATION
#           GRAPHS.
#       (2) THE INPUT GRAPH IS DESTROYED DURING THE ELIMINATION
#           PROCESS.
#       (3) THE ADJACENCY STRUCTURE SHOULD BE PADDED WITH VACANT
#           ENTRIES AT THE END OF ADJNCY(*).  IT IS ADVISABLE
#           THAT THERE BE AT LEAST NEQNS SUCH VACANT ENTRIES.
#       (4) ALL ARRAYS AND VARIABLES ARE INTEGERS.
#       (5) VERTICES FALL INTO ONE OF FOUR CATEGORIES DURING THE 
#           ELIMINATION PROCESS.
#             (A) AN ACTIVE UNELIMINATED VERTEX OF THE QUOTIENT
#                 GRAPH.
#             (B) AN ACTIVE ELIMINATION CLIQUE REPRESENTATIVE
#                 IN THE QUOTIENT GRAPH.
#             (C) A MERGED ELIMINATION CLIQUE REPRESENTATIVE.
#             (D) A VERTEX ABSORBED INTO ANOTHER VERTEX'S
#                 SUPERNODE.
#           WORKING STORAGE VECTORS ARE USED IN DIFFERENT WAYS
#           FOR DIFFERENT CATEGORIES OF VERTICES.
#
#     INPUT PARAMETERS:
#       NEQNS       - NUMBER OF EQUATIONS.
#       MAXINT      - MAXIMUM INTEGER VALUE WITH WHICH VERTICES CAN
#                     BE MARKED (SEE MARKER(*) AND UMARK(*)).
#       ADJLEN      - LENGTH OF THE ADJACENCY STRUCTURE (ADJNCY(*)).
#                     IDEALLY AT LEAST NEQNS GREATER THAN INITIAL
#                     XADJ(NEQNS+1)-1 (SEE IFLAG).
#       ADJLEN2     - LENGTH OF THE WORK VECTOR (ADJ2(*)) INTO
#                     WHICH THE ADJACENCY STRUCTURE IS COPIED WHEN
#                     W-H UPDATING IS USED TO COMPUTE THE INITIAL
#                     DEFICIENCIES.
#       XADJ(*)     - ARRAY OF LENGTH NEQNS+1, CONTAINING POINTERS
#                     TO THE ADJACENCY STRUCTURE.
#       ADJNCY(*)   - ARRAY OF LENGTH ADJLEN, CONTAINING THE
#                     ADJACENCY STRUCTURE.
#       DEFFLAG     - DEFICIENCY FLAG.
#                          0 -  USING A STRAIGTFORWARD WAY TO COMPUTE
#                               THE INITIAL DEFICIENCIES.
#                       /= 0 -  COMPUTE THE DEFICIENCIES BY ADDING
#                               THE EDGES OF THE GIVEN GRAPH TO AN
#                               INITIALLY EMPTY GRAPH AND PERFORMING
#                               WING-HUANG UPDATING FOR EACH NEW EDGE.
#
#     OUTPUT PARAMETERS:
#       XADJ(*)     - DESTROYED ON OUTPUT.
#       ADJNCY(*)   - DESTROYED ON OUTPUT.
#       GBGCNT      - NUMBER OF GARBAGE COLLECTIONS USED TO
#                     RECOMPRESS THE QUOTIENT GRAPH WHEN A NEW
#                     ELIMINATION CLIQUE "RUNS OFF THE END" OF
#                     ADJNCY(*).
#       PERM(*)     - ENDS UP WITH THE PERMUTATION VECTOR, WHICH
#                     MAPS NEW NUMBERS TO OLD.
#       INVP(*)     - ENDS UP WITH THE INVERSE PERMUTATION VECTOR,
#                     WHICH MAPS OLD NUMBERS TO NEW.
#       NOFNZ       - NUMBER OF OFF-DIAGONAL NONZEROS IN THE FACTOR
#                     MATRIX PRODUCED BY THE ORDERING.
#       IFLAG       - ERROR FLAG
#                        0 -  NO ERROR OR WARNING, ADJLEN IS NO LESS
#                             THAN INITIAL XADJ(NEQNS+1)+NEQNS-1.
#                        1 -  WARNING, ADJLEN IS SMALL; IT IS
#                             BETWEEN INITIAL XADJ(NEQNS+1)-1 AND
#                             INITIAL XADJ(NEQNS+1)+NEQNS-1,
#                             INCLUSIVE.  MAY CAUSE EXCESSIVE
#                             GARBAGE COLLECTION.
#                       -1 -  ERROR, ADJLEN IS SMALLER THAN INITIAL
#                             XADJ(NEQNS+1)-1.  INSUFFICIENT ROOM
#                             IN ADJNCY(*) FOR THE ADJACENCY
#                             STRUCTURE, OR INCORRECT ADJLEN HAS
#                             BEEN INPUT.
#
#     WORK PARAMETERS:
#       INVP(*)     - ARRAY OF LENGTH NEQNS.
#                       ELIMINATED: -NUM, WHERE NUM IS THE NUMBER
#                                   ASSIGNED BY THE ELIMINATION
#                                   ORDER.
#                       OTHERWISE:  >=0
#       MARKER(*)   - ARRAY OF LENGTH NEQNS, USED TO MARK PREVIOUS
#                     VISITS TO VERTICES.
#                       NOT ABSORBED: < MAXINT.
#                       ABSORBED:     MAXINT.
#       NVTXS(*)    - ARRAY OF LENGTH NEQNS.
#                       ACTIVE ELIMINATED:  NUMBER OF VERTICES IN
#                                           THE ELIMINATION CLIQUE.
#                       MERGED ELIMINATED:  -1.
#                       UNELIMINATED:       NUMBER OF UNELIMINATED
#                                           VERTEX NEIGHBORS IN
#                                           CURRENT QUOTIENT GRAPH.
#                       ABSORBED:           -1.
#       WORK(*)     - ARRAY OF LENGTH NEQNS.
#                       ACTIVE ELIMINATED:  NOT USED AT THIS TIME.
#                       UNELIMINATED:       NUMBER OF ELIMINATION
#                                           CLIQUES VERTEX IS
#                                           ADJACENT TO IN THE
#                                           QUOTIENT GRAPH.
#                       ABSORBED:           MAPS ABSORBED VERTEX TO
#                                           MINUS THE ABSORBING
#                                           VERTEX (I.E.,
#                                           -ABSORBEE).
#       QSIZE(*)    - ARRAY OF SIZE NEQNS.
#                       UNELIMINATED: SUPERNODE SIZE.
#                       ABSORBED:     0.
#       ECFORW(*)   - ARRAY OF SIZE NEQNS.
#                       ELIMINATED: FORWARD LINKS OF A LIST OF THE 
#                                   ELIMINATION CLIQUES ORDERED BY
#                                   THE ELIMINATION.
#                       OTHERWISE:  -1.
#       DEFNCY(*)   - ARRAY OF SIZE NEQNS, CONTAINING THE
#                     DEFICIENCIES OF THE UNELIMINATED NODES
#                     COMPUTED WITH WING-HUANG UPDATING.
#       ADJ2(*)     - ARRAY OF LENGTH ADJLEN2, CONTAINS THE GROWING
#                     ADJACENCY LISTS USED TO PERFORM WING-HUANG 
#                     UPDATING DURING COMPUTATION OF INITIAL 
#                     DEFICIENCIES BY ROUTINES MFINIT_DEF.
#       CHANGED(*)  - ARRAY OF LENGTH NEQNS, USED TO MARK THE
#                     VERTICES WHOSE DEFICIENCIES ARE CHANGED BY
#                     THE CURRENT STEP OF THE ALGORITHM.
#                       -1 -  DEFICIENCY IS UNCHANGED
#                        1 -  DEFICIENCY IS POTENTIALLY CHANGED
#       DEGREE(*)   - ARRAY OF LENGTH NEQNS, USED TO STORE DEGREE
#                     INFORMATION.  DEGREE(UNODE) IS THE DEGREE
#                     OF UNODE IN THE CURRENT ELIMINATION GRAPH
#                     PLUS ONE.  THAT IS, IT IS THE SIZE OF THE
#                     CLOSED NEIGHBORHOOD.
#       UMARK(*)    - ARRAY OF LENGTH NEQNS, USED TO MARK NEIGHBORS
#                     OF UNODE DURING THE W-H UPDATE PROCESS.
#                       NOT ABSORBED: < MAXINT.
#                       ABSORBED:     MAXINT.
#       HEAP(*)     - ARRAY OF SIZE 2*NEQNS, THE HEAP OF ACTIVE
#                     NODES BASED ON SOME DEFICIENCY-BASED SCORE. 
#       HEAPINV(*)  - ARRAY OF LENGTH NEQNS, GIVES LOCATION IN THE
#                     HEAP FOR EACH NODE IN THE HEAP.
#       ECLIQ(*)    - ARRAY OF LENGTH NEQNS, CONTAINS ENODE'S  
#                     ELIMINATION CLIQUE.  IT IS ALSO USED TO
#                     COLLECT OTHER NODES WHO NEED THEIR
#                     DEFICIENCY SCORES UPDATED.
#       XADJ2(*)    - ARRAY OF LENGTH NEQNS, USED TO STORE POINTERS
#                     TO THE DYNAMIC GROWING ADJACENCY LISTS NEEDED
#                     FOR COMPUTATION OF INITIAL DEFICIENCIES.
#                     USED IN OTHER CAPACITIES AS A WORK VECTOR.
#       LEN2(*)     - ARRAY OF LENGTH NEQNS, USED TO STORE THE
#                     LENGTHS OF THE DYNAMIC GROWING ADJACENCY
#                     LISTS NEEDED FOR COMPUTATION OF INITIAL
#                     DEFICIENCIES.
#                     USED IN OTHER CAPACITIES AS A WORK VECTOR.
#       WORK1(*)    - ARRAY OF LENGTH NEQNS, A WORK VECTOR.
#
#**********************************************************************
#
function genmf_wh(
        neqns::V,
        adjlen::E,
        adjlen2::E,
        vwght::AbstractVector{W},
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
        defflag::Bool,
        perm::AbstractVector{V},
        invp::AbstractVector{V},
        marker::AbstractVector{I},
        nvtxs::AbstractVector{V},
        work::AbstractVector{V},
        qsize::AbstractVector{W},
        qnmbr::AbstractVector{V},
        ecforw::AbstractVector{V},
        defncy::AbstractVector{W},
        adj2::AbstractVector{V},
        changed::AbstractVector{Bool},
        degree::AbstractVector{W},
        umark::AbstractVector{I},
        heap::AbstractVector{W},
        heapinv::AbstractVector{V},
        ecliq::AbstractVector{V},
        xadj2::AbstractVector{E},
        len2::AbstractVector{V},
        work1::AbstractVector{I},
        work2::AbstractVector{W},
    ) where {V, E, I, W}
    
    #       ****************
    #       INITIALIZATIONS.
    #       ****************
    
    #       -------------------------------------
    #       COMPRESS THE GRAPH.
    #         INPUT:    NEQNS, MAXINT, ADJLEN
    #         MODIFIED: XADJ, ADJNCY
    #         OUTPUT:   DEGREE, MARKER, WORK, QSIZE
    #         WORK:     DEFNCY, UMARK, XADJ2
    #       -------------------------------------
    compress(
        neqns, adjlen, vwght, xadj, adjncy,
        degree, marker, work, qsize, qnmbr, work1,
        umark, xadj2
    )
    
    if !defflag
        
        #           -----------------------------------------------------
        #           COMPUTE INITIAL DEFICIENCIES BY THE STRAIGHTFORWARD
        #           APPROACH.
        #             INPUT:  NEQNS , ADJLEN, XADJ, ADJNCY, DEGREE, QSIZE
        #             OUTPUT: DEFNCY
        #             WORK:   UMARK
        #           -----------------------------------------------------
        mfinit_vanilla(
            neqns, adjlen, xadj, adjncy, degree,
            qsize, defncy, umark
        )
        
    else
        
        #           --------------------------------------------------------
        #           IF DEFICIENCY FLAG IS ON ...
        #           COMPUTE INITIAL DEFICIENCIES BY ADDING THE EDGES ONE
        #           AT A TIME TO AN INITIALLY EMPTY GRAPH AND PERFORMING
        #           WING-HUANG UPDATING FOR EACH NEW EDGE.
        #             INPUT:  NEQNS , ADJLEN, ADJLEN2, XADJ, ADJNCY, DEGREE,
        #               QSIZE
        #             OUTPUT: DEFNCY
        #             WORK:   MARKER, PERM, INVP, UMARK, XADJ2, LEN2  , ADJ2
        #           --------------------------------------------------------
        mfinit_def(
            neqns, adjlen, adjlen2, xadj, adjncy,
            degree, qsize, defncy, marker, perm,
            invp, work2, xadj2, len2, adj2
        )
        
    end
    
    #       ----------------------------------------------------------
    #       INITIALIZE VARIOUS VECTORS AND MAKE THE INITIAL HEAP BASED
    #       ON INITIAL DEFICIENCY-BASED SCORES.
    #         INPUT:  NEQNS, XADJ, DEGREE, QSIZE, DEFNCY
    #         OUTPUT: HEAP, HEAPSIZE, HEAPINV, MARKER, NVTXS, WORK,
    #                 ECFORW, CHANGED, UMARK, INVP
    #       ----------------------------------------------------------
    heapsize = mfinit_heap(
        neqns, xadj, degree, qsize, defncy,
        heap, heapinv, marker, nvtxs,
        work, ecforw, changed, umark, invp
    )
    
    #       ------------------------------------------------------
    #       NOFNZ:  NUMBER OF NONZEROS IN FACTOR IS INITIALLY ZERO.
    #       ECHEAD, ECTAIL: EMPTY ELIMINATION CLIQUE LIST.
    #       GBGCNT: GARBAGE COLLECTION COUNT INITIALLY ZERO.
    #       TAG:    INITIAL MARKER VALUE IS ZERO.
    #       UTAG:   INITIAL W-H MARKER VALUE IS ZERO.
    #       NXTLOC: POINTS TO FIRST LOCATION IN VACANT STORAGE
    #               REMAINING AT END OF ADJNCY(*).
    #       REMAIN: AMOUNT OF VACANT STORAGE REMAINING AT END OF
    #               ADJNCY(*).
    #       IFLAG:  TEST FOR SUFFICIENT WORK STORAGE IN ADJNCY(*).
    #       ------------------------------------------------------
    nofnz  = zero(W)
    echead = zero(V)
    ectail = zero(V)
    gbgcnt = zero(I)
    tag    = zero(I)
    utag   = zero(I)
    nxtloc = xadj[neqns + one(V)]
    remain = adjlen - nxtloc + one(E)

    if remain >= convert(E, neqns)
        #           --------------------------------
        #           SUFFICIENT STORAGE (NO WARNING).
        #           --------------------------------
        iflag = zero(I)
    elseif !isnegative(remain) && remain <= convert(E, neqns) - one(E)
        #           ------------------------------------------------------
        #           SUFFICIENT STORAGE, BUT COULD BE TIGHT ENOUGH TO CAUSE
        #           MANY GARBAGE COLLECTIONS. (WARNING)
        #           ------------------------------------------------------
        iflag = one(I)
    else
        #           -----------------------------
        #           INSUFFICIENT STORAGE (ERROR).
        #           -----------------------------
        iflag = -one(I)
        return nofnz, gbgcnt, iflag
    end
    
    #       ------------------------------------------------
    #       MAIN LOOP:
    #       WHILE THERE REMAIN ANY NODES TO ELIMINATE ...
    #
    #       NUM: NEXT NUMBER TO BE ASSIGNED BY THE ORDERING.
    #       ------------------------------------------------
    num = one(V)

    while num <= neqns

        #           --------------------------------------------
        #           DELETE THE MINIMUM-SCORE NODE FROM THE HEAP.
        #             ENODE:  MINIMUM-SCORE NODE
        #           --------------------------------------------
        enode = convert(V, heap[two(V)])
        heapsize = del_heap(heap, heapsize, heapinv, enode)
        
        #           --------------------------------------------------------
        #           COMPUTE THE NEW ELIMINATION CLIQUE FORMED BY ELIMINATING
        #           ENODE.
        #             INPUT:    ENODE, NEQNS, ADJLEN, XADJ, ADJNCY, NVTXS,
        #                       WORK
        #             MODIFIED: QSIZE, CHANGED
        #             OUTPUT:   CLQSIZ, FNODE, NNODES, ECLIQ, CLIQUE
        #           --------------------------------------------------------
        clqsiz, fnode, nnodes = elmclq(
            enode, neqns, adjlen, xadj, adjncy,
            nvtxs, work, qsize, changed, ecliq
        )
        
        #           ----------------------------------------------------------
        #           INITIALLY NO NNODES EXTERNAL TO ENODE'S ELIMINATION CLIQUE
        #           HAVE HAD THEIR DEFICIENCIES REDUCED. (NNODES2 = 0)
        #           ----------------------------------------------------------
        
        #           ---------------------------------------------------------
        #           PERFORM THE WING-HUANG UPDATES TO THE DEFICIENCIES DUE TO
        #           EDGES ADDED BY THE ELIMINATION OF ENODE.
        #             INPUT:    CONFLAG, CONDONE, ENODE, NEQNS, MAXINT, 
        #                       ADJLEN, XADJ, ADJNCY, NVTXS, WORK,
        #                       QSIZE, NNODES, FNODE
        #             MODIFIED: NNODES2, ECLIQ, DEGREE, DEFNCY, TAG, MARKER,
        #                       UTAG, UMARK, CHANGED
        #             WORK:     XADJ2, LEN2
        #           ---------------------------------------------------------
        tag, utag, nnodes2 = mfupd_def(
            enode, neqns, adjlen, xadj,
            adjncy, nvtxs, work, qsize, nnodes,
            fnode, ecliq, degree, defncy,
            tag, marker, utag, umark, changed,
            len2, work2
        )
        
        #           -------------------------------------------------------
        #           PERFORM THE ELIMINATION GRAPH TRANSFORMATION DUE TO THE
        #           ELIMINATION OF ENODE ...
        #             INPUT:    ENODE, NEQNS, ADJLEN, MAXINT, NNODES,
        #                       ECLIQ, INVP
        #             MODIFIED: TAG, XADJ, ADJNCY, NVTXS, WORK,
        #                       QSIZE, MARKER, ECHEAD, ECTAIL, ECFORW,
        #                       NXTLOC, GBGCNT, CLQSIZ, UMARK
        #             WORK:     WORK1, XADJ2
        #           -------------------------------------------------------
        tag, echead, ectail, nxtloc, gbgcnt, clqsiz = elmtra(
            enode, neqns, adjlen, nnodes,
            ecliq, invp, tag, xadj, adjncy,
            nvtxs, work, qsize, qnmbr, marker, echead,
            ectail, ecforw, nxtloc, gbgcnt, clqsiz,
            umark, perm, len2
        )
        
        #           -------------------------------------------------------
        #           PERFORM FINAL WING-HUANG UPDATE TO THE DEFICIENCIES FOR
        #           EACH NODE UNODE IN ENODE'S ELIMINATION CLIQUE, DUE TO
        #           THE REMOVAL OF ENODE FROM THE GRAPH (NOT DUE TO THE NEW
        #           FILL EDGES).
        #           -------------------------------------------------------
        qe = qsize[enode]
        de = degree[enode]
        jstart = xadj[enode]
        jstop = jstart + convert(E, nvtxs[enode]) - one(E)

        for j in jstart:jstop
            unode = adjncy[j]
            du = degree[unode]
            defncy[unode] = defncy[unode] - (du - de) * qe
        end

        #           -----------------------------------------------
        #           UPDATE THE DEGREE OF EACH NODE UNODE IN ENODE'S
        #           ELIMINATION CLIQUE TO REFLECT THE REMOVAL OF
        #           ENODE.
        #           -----------------------------------------------
        jstart = xadj[enode]
        jstop = jstart + convert(E, nvtxs[enode]) - one(E)

        for j in jstart:jstop
            unode = adjncy[j]
            degree[unode] = degree[unode] - qsize[enode]
        end
        
        #           ---------------------------------------------------------
        #           ... RECORD INFO FOR ENODE.
        #
        #           NOFNZ:  ACCUMULATES THE NUMBER OF NONZEROS IN THE FACTOR.
        #                   THIS IS RETURNED SO THAT IT CAN BE COMPARED WITH
        #                   THE RESULTS OF A SYMBOLIC FACTORIZATION.
        #           NUM:    ENODE'S NUMBER IN THE ELIMINATION ORDERING.
        #           CLQSIZ: ENODE'S ELIMINATION CLIQUE SIZE.
        #           ---------------------------------------------------------
        qe = qsize[enode]
        nofnz += qe * (qe + clqsiz) - half((qe - one(W)) * qe)
        invp[enode] = -num
        num += qnmbr[enode]
        
        #           ---------------------------------------------------------
        #           FOR EACH NODE JNODE WHOSE DEFICIENCY HAS BEEN CHANGED ...
        #           ---------------------------------------------------------
        for j in oneto(nnodes + nnodes2)
            
            jnode = ecliq[j]
            
            if iszero(qsize[jnode])
                #                   -------------------------------------
                #                   DELETE ABSORBED VERTEX FROM THE HEAP.
                #                   -------------------------------------
                heapsize = del_heap(heap, heapsize, heapinv, jnode)
            else
                #                   ------------------------------------
                #                   DJ WILL BE THE DEGREE OF JNODE.
                #                   (PLUS ONE).
                #                   QJ IS THE SIZE OF JNODE'S SUPERNODE.
                #                   ------------------------------------
                def = defncy[jnode]
                #                   -------------------------------
                #                   COMPUTE DEFICIENCY-BASED SCORE.
                #                   -------------------------------
                
                #                   -------------------
                #                   RESTORE HEAP ORDER.
                #                   -------------------
                if j <= nnodes
                    #                       ------------------------------------------
                    #                       JNODE IS IN THE ELIMINATION CLIQUE,
                    #                       SO DSCORE MAY HAVE INCREASED OR DECREASED.
                    #                       ------------------------------------------
                    mod_heap(heap, heapsize, heapinv, jnode, def)
                else
                    #                       ------------------------------------------
                    #                       JNODE IS NOT IN THE ELIMINATION CLIQUE,
                    #                       SO DSCORE HAS DECREASED.
                    #                       ------------------------------------------
                    hindex = heapinv[jnode]
                    heap[twice(hindex) - one(V)] = def
                    move_up(heap, heapsize, hindex, heapinv)
                end
            end
            #               ------------------------
            #               MARK JNODE AS UNCHANGED.
            #               ------------------------
            changed[jnode] = false
            #               ----------------------
            #               NEXT NODE IN THE LIST.
            #               ----------------------
        end
        
        #           -----------------------------------------------
        #           END OF MAIN LOOP:
        #           GET NEXT NODE OF MINIMUM SCORE TO ELIMINATE ...
        #           -----------------------------------------------
    end
    
    #       ------------------------------------------------------
    #       NUMBER THE VERTICES ACCORDING THE THE ORDER GENERATED.
    #         INPUT:    NEQNS, WORK
    #         MODIFIED: INVP
    #         OUTPUT:   PERM 
    #       ------------------------------------------------------
    mfnumn(neqns, work, invp, perm)
    
    return nofnz, gbgcnt, iflag
end

# PTD (Partial Tree Decomposition) — pool-based DAG implementation.
# A PTD is represented as (pool, root_index) where pool is a DAG{PTD{PSet}}.
# All vertex indices are 1-based.

# ---------------------------------------------------------------------------
const TEST_IF_ADDING_ONE_VERTEX_TO_BAG_FORMS_PMC = true
const NEIGHBORS_FIRST = true

# ---------------------------------------------------------------------------
# PTD: value type for node data (stored in DAG pool)
# ---------------------------------------------------------------------------

struct PTD{PSet <: AbstractPackedSet}
    bag::PSet
    vertices::PSet
    outlet::PSet
end

@inline bag(data::PTD) = data.bag
@inline vertices(data::PTD) = data.vertices
@inline outlet(data::PTD) = data.outlet
@inline inlet(data::PTD) = setdiff(data.vertices, data.outlet)

# ---------------------------------------------------------------------------
# Type aliases
# ---------------------------------------------------------------------------

const PTDPool{PSet} = DAG{PTD{PSet}}

# ---------------------------------------------------------------------------
# Constructors (return root index into pool)
# ---------------------------------------------------------------------------

# Bag-only constructor (for import/heuristic)
function make_ptd(pool::PTDPool{PSet}, B::PSet) where {PSet <: AbstractPackedSet}
    return add_vertex!(pool, PTD{PSet}(B, PSet(), PSet()))
end

# Bag+outlet constructor
function make_ptd(pool::PTDPool{PSet}, B::PSet, outlet::PSet) where {PSet <: AbstractPackedSet}
    return add_vertex!(pool, PTD{PSet}(B, B, outlet))
end

# Copy: new node with same data and same children edges
function copy_ptd(pool::PTDPool{PSet}, root::Int) where {PSet}
    data = pool[root]
    new_root = add_vertex!(pool, data)
    for p in incident(pool, root)
        add_edge!(pool, new_root, target(pool, p))
    end
    return new_root
end

# ---------------------------------------------------------------------------
# Combination Rules
# ---------------------------------------------------------------------------

# C# CreatePTDURFromPTD: new bag = old outlet, old PTD becomes only child.
function create_ptdur_from_ptd(pool::PTDPool{PSet}, tau_root::Int) where {PSet}
    tau_data = pool[tau_root]
    data = PTD{PSet}(outlet(tau_data), vertices(tau_data), outlet(tau_data))
    root = add_vertex!(pool, data)
    add_edge!(pool, root, tau_root)
    return root
end

# C# AddPTDToPTDUR_CheckBagSize_CheckPossiblyUsable_CheckCliquish
# Returns (success::Bool, result_root::Int) where result_root=0 on failure.
function add_ptd_to_ptdur_check(work::Vector{PSet}, pool::PTDPool{PSet}, tp_root::Int, tau_root::Int,
                                 weights::Vector{Int}, graph::CachedGraph{PSet}, k::Int, mutable_graph::Graph{PSet}) where {PSet}
    tp_data = pool[tp_root]
    tau_data = pool[tau_root]

    # Check bag size (weighted)
    future_bag_size = wt(weights, bag(tp_data) ∪ outlet(tau_data))
    if future_bag_size > k + 1
        return (false, 0)
    end

    B = bag(tp_data) ∪ outlet(tau_data)

    # Check possibly usable: only need to check new child against existing ones
    if !is_possibly_usable(pool, tp_root, tau_root, graph)
        return (false, 0)
    end

    # If bag is at max size and not PMC, reject
    if future_bag_size == k + 1 && !is_pmc!(work, graph, B)
        return (false, 0)
    end

    # Check cliquish
    if !is_csh!(work, graph, B)
        return (false, 0)
    end

    # One-vertex-to-PMC test
    if TEST_IF_ADDING_ONE_VERTEX_TO_BAG_FORMS_PMC && future_bag_size == k
        if !is_pmc!(work, graph, B)
            useless = true

            for (component, nbrs) in components(graph, B)
                if nbrs == B && isdisjoint(component, vertices(tp_data)) && isdisjoint(component, vertices(tau_data))
                    if NEIGHBORS_FIRST
                        for v in B
                            v_nbrs = neighbors(graph, v) ∩ component

                            if length(v_nbrs) == 1
                                candidate = first(v_nbrs)
                                test_bag = B ∪ candidate

                                if is_csh!(work, graph, test_bag)
                                    useless = false
                                    break
                                end
                            end
                        end
                        if !useless
                            break
                        end
                    end

                    for ap in articulation_points(mutable_graph, component)
                        test_bag = B ∪ ap

                        if is_pmc!(work, graph, test_bag)
                            useless = false
                            break
                        end
                    end
                    if !useless
                        break
                    end

                    if !NEIGHBORS_FIRST
                        for v in B
                            v_nbrs = neighbors(graph, v) ∩ component

                            if length(v_nbrs) == 1
                                candidate = first(v_nbrs)
                                test_bag = B ∪ candidate

                                if is_csh!(work, graph, test_bag)
                                    useless = false
                                    break
                                end
                            end
                        end
                        if !useless
                            break
                        end
                    end
                end
            end

            if useless
                return (false, 0)
            end
        end
    end

    # Build result
    V = vertices(tp_data) ∪ vertices(tau_data)
    S = outlet(graph, B, V)

    new_root = add_vertex!(pool, PTD{PSet}(B, V, S))

    # Copy existing children from tp
    for p in incident(pool, tp_root)
        add_edge!(pool, new_root, target(pool, p))
    end
    # Add tau as new child
    add_edge!(pool, new_root, tau_root)

    return (true, new_root)
end

# C# IsPossiblyUsable: Check only new child against existing children (O(n)).
function is_possibly_usable(pool::PTDPool{PSet}, parent_root::Int, tau_root::Int, graph::CachedGraph{PSet}) where {PSet}
    tau_data = pool[tau_root]

    for p in incident(pool, parent_root)
        child_data = pool[target(pool, p)]

        if !isdisjoint(inlet(child_data), inlet(tau_data))
            return false
        end
        vi = vertices(child_data) ∩ vertices(tau_data)

        if !(outlet(child_data) ⊇ vi) || !(outlet(tau_data) ⊇ vi)
            return false
        end
    end
    return true
end


# ---------------------------------------------------------------------------
# Extend-to-PMC rules
# ---------------------------------------------------------------------------

# C# ExtendToPMC_Rule2
function extend_to_pmc_rule2(pool::PTDPool{PSet}, tw_root::Int, v_neighbors::PSet, graph::CachedGraph{PSet}) where {PSet}
    tw_data = pool[tw_root]
    B = v_neighbors
    V = vertices(tw_data) ∪ v_neighbors
    S = outlet(graph, B, V)
    new_root = add_vertex!(pool, PTD{PSet}(B, V, S))

    for p in incident(pool, tw_root)
        add_edge!(pool, new_root, target(pool, p))
    end
    return new_root
end

# C# ExtendToPMC_Rule3
function extend_to_pmc_rule3(pool::PTDPool{PSet}, tw_root::Int, new_root_bag::PSet, graph::CachedGraph{PSet}) where {PSet}
    tw_data = pool[tw_root]
    @assert new_root_bag ⊇ bag(tw_data)
    B = new_root_bag
    V = vertices(tw_data) ∪ new_root_bag
    S = outlet(graph, B, V)
    new_root = add_vertex!(pool, PTD{PSet}(B, V, S))

    for p in incident(pool, tw_root)
        add_edge!(pool, new_root, target(pool, p))
    end
    return new_root
end

# ---------------------------------------------------------------------------
# Queries
# ---------------------------------------------------------------------------

# C# IsIncoming: inlet.First() < complement(vertices).First()
function is_incoming(pool::PTDPool{PSet}, root::Int, graph::CachedGraph{PSet}) where {PSet}
    data = pool[root]
    rest = setdiff(vertices(graph), vertices(data))

    if isempty(rest)
        return true  # all vertices covered
    end
    return first(inlet(data)) < first(rest)
end

# C# IsNormalized
function is_normalized(pool::PTDPool{PSet}, root::Int) where {PSet}
    data = pool[root]

    for p in incident(pool, root)
        child_data = pool[target(pool, p)]

        if outlet(data) ⊇ outlet(child_data)
            return false
        end
    end
    return true
end

# ---------------------------------------------------------------------------
# Tree restructuring
# ---------------------------------------------------------------------------

# C# Reroot: restructure the tree so a node whose bag ⊇ root_set becomes root.
# Returns the new root index.
function reroot!(pool::PTDPool{PSet}, root::Int, S::PSet) where {PSet}
    path = Vector{Int}(undef, domain(PSet))
    stack = Tuple{Int, Int}[]

    n = 0
    node = root
    data = pool[node]

    while S ⊈ bag(data)
        for p in incident(pool, node)
            push!(stack, (n + 1, p))
        end

        n, p = pop!(stack)
        node = target(pool, p)
        data = pool[node]
        path[n] = p
    end

    for p in view(path, oneto(n))
        node = target(pool, p)
        rem_edge!(pool, root, p)
        add_edge!(pool, node, root)
        root = node
    end

    return node
end

struct ChordalFactorization{
        DIAG,
        UPLO,
        T,
        I,
        Dia <: AbstractVector{T},
        Dvl <: AbstractVector{T},
        Lvl <: AbstractVector{T},
        Prm <: AbstractVector{I},
        Ivp <: AbstractVector{I},
        Ifo,
    } <: AbstractFactorization{DIAG, UPLO, T, I, Prm, Ivp}
    S::ChordalSymbolic{I}
    d::Dia
    Dval::Dvl
    Lval::Lvl
    perm::Prm
    invp::Ivp
    info::Ifo
end

"""
    ChordalCholesky{UPLO, T, I, Val} <: Factorization{T}

A Cholesky decomposition of a sparse positive-definite matrix ``A``:

```math
    P A P^\\mathsf{T} = L L^\\mathsf{T}.
```

where ``P`` is a permutation matrix and ``L`` is lower triangular.
The type parameter `UPLO` specifies which triangular factor is
stored.

   - `UPLO`: `:L` or `:U` (lower / upper triangular)

### Fields

   - `F.P`: permutation matrix
   - `F.L`: lower triangular factor
   - `F.U`: upper triangular factor
   - `F.S`: symbolic factorization

"""
const ChordalCholesky = ChordalFactorization{:N}

const FChordalCholesky{UPLO, T, I} = ChordalCholesky{
    UPLO,
    T,
    I,
    IOnes{T},
    FVector{T},
    FVector{T},
    FVector{I},
    FVector{I},
    FScalar{I},
}

const DChordalCholesky{UPLO, T, I} = ChordalCholesky{
    UPLO,
    T,
    I,
    IOnes{T},
    Vector{T},
    Vector{T},
    Vector{I},
    Vector{I},
    Scalar{I},
}

"""
    ChordalLDLt{UPLO, T, I, Val} <: Factorization{T}

An LDLᵀ decomposition of a sparse symmetric matrix ``A``:

```math
    P A P^\\mathsf{T} = L D L^\\mathsf{T}.
```

where ``P`` is a permutation matrix, ``L`` is unit lower triangular, and ``D`` is diagonal.
The type parameter `UPLO` specifies which triangular factor is
stored.

   - `UPLO`: `:L` or `:U` (lower / upper triangular)

### Fields

   - `F.P`: permutation matrix
   - `F.L`: unit lower triangular factor
   - `F.U`: unit upper triangular factor
   - `F.D`: diagonal factor
   - `F.S`: symbolic factorization

"""
const ChordalLDLt = ChordalFactorization{:U}

const FChordalLDLt{UPLO, T, I} = ChordalLDLt{
    UPLO,
    T,
    I,
    FVector{T},
    FVector{T},
    FVector{T},
    FVector{I},
    FVector{I},
    FScalar{I},
}

const DChordalLDLt{UPLO, T, I} = ChordalLDLt{
    UPLO,
    T,
    I,
    Vector{T},
    Vector{T},
    Vector{T},
    Vector{I},
    Vector{I},
    Scalar{I},
}

# ===== Constructors =====

function ChordalFactorization{DIAG, UPLO}(
        S::ChordalSymbolic{I},
        d::Dia,
        Dval::Dvl,
        Lval::Lvl,
        perm::Prm,
        invp::Ivp,
        info::Ifo,
    ) where {
        DIAG,
        UPLO,
        I <: Integer,
        T,
        Dia <: AbstractVector{T},
        Dvl <: AbstractVector{T},
        Lvl <: AbstractVector{T},
        Prm <: AbstractVector{I},
        Ivp <: AbstractVector{I},
        Ifo,
    }
    return ChordalFactorization{DIAG, UPLO, T, I, Dia, Dvl, Lvl, Prm, Ivp, Ifo}(S, d, Dval, Lval, perm, invp, info)
end

function ChordalFactorization{DIAG, UPLO, T, I, Dia, Dvl, Lvl, Prm, Ivp, Ifo}(
        P::Permutation{I},
        S::ChordalSymbolic{I},
    ) where {
        DIAG,
        UPLO,
        T,
        I <: Integer,
        Dia <: AbstractVector{T},
        Dvl <: AbstractVector{T},
        Lvl <: AbstractVector{T},
        Prm <: AbstractVector{I},
        Ivp <: AbstractVector{I},
        Ifo,
    }
    d = allocate(Dia, ncl(S))
    Dval = allocate(Dvl, ndz(S))
    Lval = allocate(Lvl, nlz(S))
    info = allocate(Ifo)

    return ChordalFactorization{DIAG, UPLO, T, I, Dia, Dvl, Lvl, Prm, Ivp, Ifo}(S, d, Dval, Lval, P.perm, P.invp, info)
end

for Fac in (:FChordalCholesky, :DChordalCholesky, :FChordalLDLt, :DChordalLDLt)
    @eval function $Fac{UPLO, T}(
            P::Permutation{I},
            S::ChordalSymbolic{I},
        ) where {
            UPLO,
            T,
            I <: Integer,
        }
        return $Fac{UPLO, T, I}(P, S)
    end
end

function ChordalFactorization{DIAG, UPLO, T}(P::Permutation{I, Prm, Ivp}, S::ChordalSymbolic{I}) where {DIAG, UPLO, T, I <: Integer, Prm <: AbstractVector{I}, Ivp <: AbstractVector{I}}
    if DIAG === :N
        Dia = IOnes{T}
    else
        Dia = FVector{T}
    end

    return ChordalFactorization{DIAG, UPLO, T, I, Dia, FVector{T}, FVector{T}, Prm, Ivp, FScalar{I}}(P, S)
end

function ChordalFactorization{DIAG, UPLO, T}(S::ChordalSymbolic{I}) where {DIAG, UPLO, T, I <: Integer}
    P = NaturalPermutation{I}(ncl(S))
    return ChordalFactorization{DIAG, UPLO, T}(P, S)
end

function (::Type{Fac})(A::AbstractMatrix; kw...) where {DIAG, Fac <: ChordalFactorization{DIAG}}
    return Fac{DEFAULT_UPLO}(A; kw...)
end

function (::Type{Fac})(A::AbstractMatrix; kw...) where {DIAG, UPLO, Fac <: ChordalFactorization{DIAG, UPLO}}
    return Fac(sparse(A); kw...)
end

function (::Type{Fac})(A::SparseMatrixCSC; check::Bool=true, kw...) where {DIAG, UPLO, Fac <: ChordalFactorization{DIAG, UPLO}}
    if !check || ishermitian(A)
        return Fac(Hermitian(A, UPLO), symbolic(A; check=false, kw...)...)
    elseif istril(A)
        return Fac(Hermitian(A, :L); kw...)
    elseif istriu(A)
        return Fac(Hermitian(A, :U); kw...)
    end

    error()
end

function (::Type{Fac})(A::HermOrSym; kw...) where {DIAG, UPLO, Fac <: ChordalFactorization{DIAG, UPLO}}
    return Fac(A, symbolic(A; kw...)...)
end

function (::Type{Fac})(A::AbstractMatrix, P::Permutation, S::ChordalSymbolic; check::Bool=true) where {DIAG, Fac <: ChordalFactorization{DIAG}}
    return Fac{DEFAULT_UPLO}(A, P, S; check)
end

function (::Type{Fac})(A::AbstractMatrix{T}, P::Permutation, S::ChordalSymbolic; check::Bool=true) where {DIAG, UPLO, T, Fac <: ChordalFactorization{DIAG, UPLO}}
    return Fac{T}(A, P, S; check)
end

function (::Type{Fac})(A::AbstractMatrix{T}, P::Permutation, S::ChordalSymbolic; check::Bool=true) where {DIAG, UPLO, T <: Integer, Fac <: ChordalFactorization{DIAG, UPLO}}
    return Fac{float(T)}(A, P, S; check)
end

function (::Type{Fac})(A::AbstractMatrix{T}, P::Permutation, S::ChordalSymbolic; check::Bool=true) where {DIAG, UPLO, T <: Integer, R, Fac <: ChordalFactorization{DIAG, UPLO, R}}
    return copyto!(Fac(P, S), A; check)
end

function (::Type{Fac})(A::AbstractMatrix, P::Permutation, S::ChordalSymbolic; check::Bool=true) where {DIAG, UPLO, T, Fac <: ChordalFactorization{DIAG, UPLO, T}}
    return copyto!(Fac(P, S), A; check)
end

function (::Type{Fac})(A::AbstractMatrix, S::ChordalSymbolic{I}; check::Bool=true) where {DIAG, I, Fac <: ChordalFactorization{DIAG}}
    P = NaturalPermutation{I}(ncl(S))
    return Fac(A, P, S; check)
end

function NaturalFactorization(F::ChordalFactorization{DIAG, UPLO, T, I}) where {DIAG, UPLO, T, I}
    perm = invp = OneTo{I}(ncl(F))
    return ChordalFactorization{DIAG, UPLO}(F.S, F.d, F.Dval, F.Lval, perm, invp, F.info)
end

function triangular(F::ChordalFactorization, ::Val{DIAG}=F.diag) where {DIAG}
    return ChordalTriangular{DIAG}(F)
end

function project(A::Hermitian, F::ChordalCholesky{UPLO}) where {UPLO}
    return project(A, Hermitian(triangular(F), UPLO), F.P)
end

function project(A::Symmetric, F::ChordalCholesky{UPLO}) where {UPLO}
    return project(A, Symmetric(triangular(F), UPLO), F.P)
end

# ===== Base methods =====

for Fac in (:FChordalCholesky, :FChordalLDLt)
    @eval function Base.show(io::IO, ::Type{$Fac{UPLO, T, I}}) where {UPLO, T, I}
        if !isdefined(get(io, :module, Main), $(QuoteNode(Fac)))
            print(io, "Multifrontal.")
        end

        print(io, $("$Fac{"), repr(UPLO), ", ", T, ", ", I, "}")
    end
end

for Fac in (:DChordalCholesky, :DChordalLDLt)
    @eval function Base.show(io::IO, ::Type{$Fac{UPLO, T, I}}) where {UPLO, T, I}
        print(io, $("$Fac{"), repr(UPLO), ", ", T, ", ", I, "}")
    end
end

function Base.show(io::IO, F::T) where {T <: ChordalFactorization}
    n = ncl(F)
    print(io, "$n×$n $T with $(nnz(F)) stored entries")
    return
end

function Base.show(io::IO, ::MIME"text/plain", F::T) where {DIAG, UPLO, T <: ChordalFactorization{DIAG, UPLO}}
    n = ncl(F)
    println(io, "$n×$n $T with $(nnz(F)) stored entries:")

    if n < 16
        print_matrix(io, ChordalTriangular(F))

        if DIAG === :U
            println(io)
            println(io)
            print_matrix(io, F.D)
        end
    else
        showsymbolic(io, F.S, F.uplo)
    end

    return
end

function Base.propertynames(::ChordalFactorization)
    return (:L, :U, :D, :P, :S, :d, :Dval, :Lval, :perm, :invp, :info)
end

function Base.similar(F::ChordalFactorization{DIAG, UPLO}, ::Type{T}=eltype(F)) where {DIAG, UPLO, T}
    if DIAG === :N
        d = F.d
    else
        d = similar(F.d, T)
    end

    return ChordalFactorization{DIAG, UPLO}(F.S, d, similar(F.Dval, T), similar(F.Lval, T), F.perm, F.invp, similar(F.info))
end

# ===== flatindices =====

function flatindices(F::ChordalFactorization{DIAG, UPLO}, A::SparseMatrixCSC; check::Bool=true) where {DIAG, UPLO}
    return flatindices(F.P, F.S, A, Val(UPLO); check)
end

function flatindices(F::ChordalFactorization{DIAG, UPLO}, A::HermOrSym) where {DIAG, UPLO}
    return flatindices(F.P, F.S, A, Val(UPLO))
end

function getflatindex(F::ChordalFactorization, p::Integer)
    return getflatindex(ChordalTriangular(F), p)
end

function setflatindex!(F::ChordalFactorization, x, p::Integer)
    setflatindex!(ChordalTriangular(F), x, p)
    return F
end

# ===== Abstract Matrix Interface =====

function SparseArrays.nnz(F::ChordalFactorization)
    return nnz(ChordalTriangular(F))
end

function ndz(F::ChordalFactorization)
    return ndz(ChordalTriangular(F))
end

function nlz(F::ChordalFactorization)
    return nlz(ChordalTriangular(F))
end

function nfr(F::ChordalFactorization)
    return nfr(F.S)
end

function fronts(F::ChordalFactorization)
    return fronts(F.S)
end

function diagblock(F::ChordalFactorization, j::Integer)
    return diagblock(ChordalTriangular(F), j)
end

function offdblock(F::ChordalFactorization, j::Integer)
    return offdblock(ChordalTriangular(F), j)
end

function symbolic(F::ChordalFactorization)
    return symbolic(triangular(F))
end

struct UnionFind{I <: Integer, Rank <: AbstractVector{I}, Parent <: AbstractVector{I}, Stack <: AbstractVector{I}} <: AbstractVector{I}
    n::I
    rank::Rank
    parent::Parent
    stack::Stack
end

function UnionFind{I}(n::Integer) where {I <: Integer}
    rank = FVector{I}(undef, n)
    parent = FVector{I}(undef, n)
    stack = FVector{I}(undef, n)
    return UnionFind(convert(I, n), rank, parent, stack)
end

@propagate_inbounds function Base.union!(uf::UnionFind{I}, i::I, j::I) where {I <: Integer}
    @boundscheck checkbounds(uf.parent, i)
    @boundscheck checkbounds(uf.parent, j)
    @inbounds ii = uf.rank[i]
    @inbounds jj = uf.rank[j]

    if ii < jj
        i, j = j, i
    elseif ii == jj
        @inbounds uf.rank[i] += one(I)
    end

    @inbounds uf.parent[j] = i
    return i
end

############################
# Abstract Array Interface #
############################

function Base.IndexStyle(::Type{<:UnionFind})
    return IndexLinear()
end

function Base.size(uf::UnionFind)
    return (uf.n,)
end

@propagate_inbounds function Base.getindex(uf::UnionFind{I}, i::I) where {I <: Integer}
    @boundscheck checkbounds(oneto(uf.n), i)
    @inbounds ii = uf.parent[i]
    n = zero(I)

    @inbounds while ispositive(ii)
        n += one(I); uf.stack[n] = i
        i = ii; ii = uf.parent[i]
    end

    ii = i; nn = n

    @inbounds for n in oneto(nn)
        i = uf.stack[n]
        uf.parent[i] = ii
    end

    return ii
end

"""
    CholFact{T, I} <: Factorization{T}

A Cholesky factorization object.
"""
struct CholFact{T, I} <: Factorization{T}
    symbfact::SymbFact{I}
    blkptr::FVector{I}
    blkval::FVector{T}
    status::FScalar{Bool}
    mapping::BipartiteGraph{I, I, FVector{I}, FVector{I}}
end

"""
    SymbFact(cholfact::CholFact)

Get the underlying symbolic factorization of a Cholesky
factorization.
"""
function SymbFact(cholfact::CholFact)
    return cholfact.symbfact
end

"""
    cholesky(matrix::AbstractMatrix;
        alg::EliminationAlgorithm=DEFAULT_ELIMINATION_ALGORITHM,
        snd::SupernodeType=DEFAULT_SUPERNODE_TYPE,
    )

Compute the Cholesky factorization of a sparse positive definite matrix.
The factorization occurs in two phases: symbolic and numeric. During the
symbolic phase, a *tree decomposition* is constructed which will control
the numeric phase. The speed of the numeric phase is dependant on the
quality of this tree decomposition.

The symbolic phase is controlled by the parameters `alg` and `snd`.
See the function [`cliquetree`](@ref) for more information.

```julia-repl
julia> import CliqueTrees

julia> matrix = [
           3 1 0 0 0 0 0 0
           1 3 1 0 0 2 0 0
           0 1 3 1 0 1 2 1
           0 0 1 3 0 0 0 0
           0 0 0 0 3 1 1 0
           0 2 1 0 1 3 0 0
           0 0 2 0 1 0 3 1
           0 0 1 0 0 0 1 3
       ];

julia> cholfact = CliqueTrees.cholesky(matrix)
CholFact{Float64, Int64}:
    nnz: 19
    success: true
```

### Parameters

  - `matrix`: sparse positive-definite matrix
  - `alg`: elimination algorithm
  - `snd`: supernode type

"""
function cholesky(matrix::AbstractMatrix; alg::PermutationOrAlgorithm=DEFAULT_ELIMINATION_ALGORITHM, snd::SupernodeType=DEFAULT_SUPERNODE_TYPE)
    cholfact = cholesky(matrix, alg, snd)
    return cholfact
end

function cholesky(matrix::AbstractMatrix, alg::PermutationOrAlgorithm, snd::SupernodeType)
    cholfact = cholesky(matrix, symbolic(matrix, alg, snd))
    return cholfact
end

function cholesky(matrix::AbstractMatrix, symbfact::SymbFact)
    cholfact = cholesky(sparse(matrix), symbfact)
    return cholfact
end

function cholesky(matrix::SparseMatrixCSC{<:Any, I}, symbfact::SymbFact{I}) where {I}
    @assert size(matrix, 1) == size(matrix, 2)
    @assert size(matrix, 1) == nov(separators(symbfact.tree))
    return cholesky!(cholinit(matrix, symbfact)..., matrix) 
end

"""
    cholesky!(cholfact::CholFact, cholwork::CholWork, matrix::AbstractMatrix)

Compute the Cholesky factorization of a sparse positive definite matrix
using a pre-allocated workspace. See [`cholesky`](@ref).

```julia-repl
julia> import CliqueTrees

julia> matrix = [
           3 1 0 0 0 0 0 0
           1 3 1 0 0 2 0 0
           0 1 3 1 0 1 2 1
           0 0 1 3 0 0 0 0
           0 0 0 0 3 1 1 0
           0 2 1 0 1 3 0 0
           0 0 2 0 1 0 3 1
           0 0 1 0 0 0 1 3
       ];

julia> symbfact = CliqueTrees.symbolic(matrix)
SymbFact{Int64}:
    nnz: 19

julia> cholfact, cholwork = CliqueTrees.cholinit(matrix, symbfact);

julia> CliqueTrees.cholesky!(cholfact, cholwork, matrix, symbfact)
CholFact{Float64, Int64}:
    nnz: 19
    success: true
```

### Parameters

  - `cholfact`: Cholesky factor
  - `cholwork`: workspace
  - `matrix`: sparse positive-definite matrix
"""
function cholesky!(cholfact::CholFact{T, I}, cholwork::CholWork{T, I}, matrix::AbstractMatrix) where {T, I}
    return cholesky!(cholfact, cholwork, sparse(matrix))
end

function cholesky!(cholfact::CholFact{T, I}, cholwork::CholWork{T, I}, matrix::SparseMatrixCSC{<:Any, I}) where {T, I}
    symbfact = cholfact.symbfact

    tree = symbfact.tree
    invp = symbfact.invp

    mapping = cholfact.mapping

    blkptr = cholfact.blkptr
    blkval = cholfact.blkval

    updptr = cholwork.updptr
    updval = cholwork.updval
    frtval = cholwork.frtval

    pattern0 = BipartiteGraph(matrix)
    pattern1 = cholwork.pattern1
    pattern2 = cholwork.pattern2

    nzval0 = matrix.nzval
    nzval1 = cholwork.nzval1
    nzval2 = cholwork.nzval2

    cholesky_permute!(pattern0, pattern1, nzval0, nzval1, invp)
    cholesky_reverse!(pattern1, pattern2, nzval1, nzval2)

    cholfact.status[] = cholesky_impl!(mapping, blkptr, updptr, blkval, updval, frtval, tree, pattern2, nzval2) 

    return cholfact    
end

function cholesky_permute!(
        pattern1::BipartiteGraph{I, I},
        pattern2::BipartiteGraph{I, I},
        nzval1::AbstractVector,
        nzval2::AbstractVector,
        invp::AbstractVector{I},
    ) where {I}
    neqns = nv(pattern1)

    @inbounds for i2 in vertices(pattern1)
        pointers(pattern2)[i2 + one(I)] = zero(I)
    end

    @inbounds for j1 in vertices(pattern1)
        j2 = invp[j1]
        j2 == neqns && continue

        for i1 in neighbors(pattern1, j1)
            i1 > j1 && continue

            i2 = invp[i1]
            i2 == neqns && continue

            k2 = max(i2, j2)
            pointers(pattern2)[k2 + two(I)] += one(I)
        end
    end

    @inbounds pointers(pattern2)[begin] = p2 = one(I)

    @inbounds for i2 in vertices(pattern1)
        pointers(pattern2)[i2 + one(I)] = p2 += pointers(pattern2)[i2 + one(I)]
    end

    @inbounds for j1 in vertices(pattern1)
        j2 = invp[j1]

        for p1 in incident(pattern1, j1)
            i1 = targets(pattern1)[p1]
            i1 > j1 && continue

            x1 = nzval1[p1]
            i2 = invp[i1]
            k2 = j2

            if k2 < i2
                i2, k2 = k2, i2
                x1 = conj(x1)
            end

            p2 = pointers(pattern2)[k2 + one(I)]
            pointers(pattern2)[k2 + one(I)] = p2 + one(I)
            targets(pattern2)[p2] = i2
            nzval2[p2] = x1
        end
    end

    return
end

function cholesky_reverse!(
        pattern1::BipartiteGraph{I, I},
        pattern2::BipartiteGraph{I, I},
        nzval1::AbstractVector,
        nzval2::AbstractVector,
    ) where {I}
    @inbounds for i2 in vertices(pattern1)
        pointers(pattern2)[i2 + one(I)] = zero(I)
    end

    @inbounds for j1 in vertices(pattern1), i1 in neighbors(pattern1, j1)
        i1 == nv(pattern1) && continue
        pointers(pattern2)[i1 + two(I)] += one(I)
    end

    @inbounds pointers(pattern2)[begin] = p2 = one(I)

    @inbounds for i2 in vertices(pattern1)
        pointers(pattern2)[i2 + one(I)] = p2 += pointers(pattern2)[i2 + one(I)]
    end

    @inbounds for j1 in vertices(pattern1), p1 in incident(pattern1, j1)
        i1 = targets(pattern1)[p1]
        x1 = nzval1[p1]
        p2 = pointers(pattern2)[i1 + one(I)]

        pointers(pattern2)[i1 + one(I)] = p2 + one(I)
        targets(pattern2)[p2] = j1
        nzval2[p2] = conj(x1)
    end

    return
end

function cholesky_impl!(
        mapping::BipartiteGraph{I, I},        
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I},
        pattern::BipartiteGraph{I, I},
        nzval::AbstractVector,
    ) where {T, I}
    separator = separators(tree)
    relidx = targets(mapping)
    status = true; ns = zero(I)

    cholesky_init!(relidx, blkptr, updptr,
        blkval, tree, pattern, nzval)

    @inbounds for j in vertices(separator)
        iterstatus, ns = cholesky_loop!(mapping, blkptr,
            updptr, blkval, updval, frtval, tree, ns, j)

        status = status && iterstatus
    end

    return status
end

function cholesky_init!(
        relidx::AbstractVector{I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        tree::CliqueTree{I, I},
        pattern::BipartiteGraph{I, I},
        nzval::AbstractVector,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)
    treln = nv(separator)

    @inbounds updptr[one(I)] = p = q = one(I)

    @inbounds for j in vertices(separator)
        blkptr[j] = p

        res = neighbors(residual, j)
        sep = neighbors(separator, j)
        bag = Clique(res, sep)

        nn = eltypedegree(residual, j)
        na = eltypedegree(separator, j)
        nj = nn + na

        for v in res
            k = one(I)

            for q in incident(pattern, v)
                w = targets(pattern)[q]

                while bag[k] < w
                    blkval[p] = zero(T)
                    k += one(I)
                    p += one(I)
                end

                blkval[p] = nzval[q]
                k += one(I)
                p += one(I) 
            end

            while k <= nj
                blkval[p] = zero(T)
                k += one(I)
                p += one(I)
            end
        end

        pj = parentindex(tree, j)

        if !isnothing(pj)
            pbag = tree[pj]    

            k = one(I)

            for w in sep
                while pbag[k] < w
                    k += one(I)
                end

                relidx[q] = k
                q += one(I)
                k += one(I)
            end
        end
    end

    @inbounds blkptr[treln + one(I)] = p
    return
end

function cholesky_loop!(
        mapping::BipartiteGraph{I, I},        
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    if isone(nn)
        status, ns = cholesky_loop_nod!(mapping, blkptr,
            updptr, blkval, updval, frtval, tree, ns, j)
    else
        status, ns = cholesky_loop_snd!(mapping, blkptr,
            updptr, blkval, updval, frtval, tree, ns, j)
    end

    return status, ns
end


function cholesky_loop_snd!(
        mapping::BipartiteGraph{I, I},        
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁  F₂  ] nj
    #
    #       = [ F₁₁ F₁₂ ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    # only the lower triangular part is used
    @inbounds F = reshape(view(frtval, oneto(nj * nj)), nj, nj)
    @inbounds F₁ =  view(F, oneto(nj),      oneto(nn))
    @inbounds F₁₁ = view(F, oneto(nn),      oneto(nn))
    @inbounds F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    @inbounds F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    # B is part of the Cholesky factor
    #
    #          res(j)
    #     B = [ B₁₁  ] res(j)
    #         [ B₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds B = reshape(view(blkval, pstrt:pstop - one(I)), nj, nn)

    # copy B into F₁
    #
    #     F₁₁ ← B₁₁
    #     F₂₁ ← B₂₁
    #
    lacpy!(F, B); fill!(F₂₂, zero(T))

    @inbounds for i in Iterators.reverse(childindices(tree, j))
        cholesky_add_update!(F, ns, i, mapping, updptr, updval)
        ns -= one(I)
    end

    # factorize F₁₁ as
    #
    #     F₁₁ = L₁₁ L₁₁ᴴ
    #
    # and store F₁₁ ← L₁₁
    status = potrf!(F₁₁)

    if ispositive(na)
        ns += one(I)

        # U₂₂ is the update matrix for node j
        @inbounds pstrt = updptr[ns]
        @inbounds pstop = updptr[ns + one(I)] = pstrt + na * na
        @inbounds U₂₂ = reshape(view(updval, pstrt:pstop - one(I)), na, na)
        lacpy!(U₂₂, F₂₂)

        # solve for L₂₁ in
        #
        #     L₂₁ L₁₁ᴴ = F₂₁
        #
        # and store F₂₁ ← L₂₁
        rdiv!(F₂₁, LowerTriangular(F₁₁) |> adjoint)
    
        # compute the difference
        #
        #    L₂₂ = U₂₂ - L₂₁ L₂₁ᴴ
        #
        # and store U₂₂ ← L₂₂
        syrk!(F₂₁, U₂₂)
    end
 
    # copy F₁ into B
    #
    #     B₁₁ ← F₁₁
    #     B₂₁ ← F₂₁
    #
    lacpy!(B, F₁)
    return status, ns
end

function cholesky_loop_nod!(
        mapping::BipartiteGraph{I, I},        
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    nn = one(I)

    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁  F₂  ] nj
    #
    #       = [ F₁₁ F₁₂ ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    # only the lower triangular part is used
    @inbounds F = reshape(view(frtval, oneto(nj * nj)), nj, nj)
    @inbounds F₁ =  view(F, oneto(nj),      nn)
    @inbounds F₁₁ = view(F, nn,             nn)
    @inbounds F₂₁ = view(F, nn + one(I):nj, nn)
    @inbounds F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    # B is part of the Cholesky factor
    #
    #          res(j)
    #     B = [ B₁₁  ] res(j)
    #         [ B₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds B = view(blkval, pstrt:pstop - one(I))
    @inbounds B₁ = view(B, nn)
    @inbounds B₂ = view(B, nn + one(I):nj)

    # copy B into F₁
    #
    #     F₁₁ ← B₁₁
    #     F₂₁ ← B₂₁
    #
    F₁₁[] = B₁[]; copyto!(F₂₁, B₂); fill!(F₂₂, zero(T))

    @inbounds for i in Iterators.reverse(childindices(tree, j))
        cholesky_add_update!(F, ns, i, mapping, updptr, updval)
        ns -= one(I)
    end

    # factorize F₁₁ as
    #
    #     F₁₁ = L₁₁ L₁₁ᴴ
    #
    # and store F₁₁ ← L₁₁
    f₁₁ = F₁₁[]

    if ispositive(real(f₁₁))
        f₁₁ = sqrt(f₁₁); status = true
    else
        f₁₁ = one(T);    status = false
    end

    if ispositive(na)
        ns += one(I)

        # U₂₂ is the update matrix for node j
        @inbounds pstrt = updptr[ns]
        @inbounds pstop = updptr[ns + one(I)] = pstrt + na * na
        @inbounds U₂₂ = reshape(view(updval, pstrt:pstop - one(I)), na, na)
        lacpy!(U₂₂, F₂₂)

        # solve for L₂₁ in
        #
        #     L₂₁ L₁₁ᴴ = F₂₁
        #
        # and store F₂₁ ← L₂₁
        F₂₁ ./= conj(f₁₁)
    
        # compute the difference
        #
        #    L₂₂ = U₂₂ - L₂₁ L₂₁ᴴ
        #
        # and store U₂₂ ← L₂₂
        syr!(F₂₁, U₂₂)
    end

    # copy F₁ into B
    #
    #     B₁₁ ← F₁₁
    #     B₂₁ ← F₂₁
    #
    B₁[] = f₁₁; copyto!(B₂, F₂₁)
    return status, ns
end

function cholesky_add_update!(
        F::AbstractMatrix{T},
        ns::I,
        i::I,
        mapping::BipartiteGraph{I, I},
        updptr::AbstractVector{I},
        updval::AbstractVector{T},
    ) where {T, I}
    # na is the size of the separator at node i.
    #
    #     na = | sep(i) |
    #
    na = eltypedegree(mapping, i)

    # ind is the subset inclusion
    #
    #     ind: sep(i) → sep(parent(i))
    #
    ind = neighbors(mapping, i)

    # U is the na × na update matrix for node i.
    pstrt = updptr[ns]
    pstop = pstrt + na * na
    U = reshape(view(updval, pstrt:pstop - one(I)), na, na)

    # for all uj in sep(i) ...
    @inbounds for uj in oneto(na)
        # let fj = ind(uj)
        fj = ind[uj]

        # for all ui ≥ uj in sep(i) ...
        for ui in uj:na
            # let fi = ind(ui)
            fi = ind[ui]

            # compute the sum
            #
            #     F[fi, fj] + U[ui, uj]
            #
            # and assign it to F[fi, fj]
            F[fi, fj] += U[ui, uj]
        end
    end

    return
end

function rdiv!_fwd_add_update!(
        F::AbstractVector{T},
        ns::I,
        i::I,
        mapping::BipartiteGraph{I, I},
        updptr::AbstractVector{I},
        updval::AbstractVector{T},
    ) where {T, I}
    # na is the size of the separator at node i.
    #
    #     na = | sep(i) |
    #
    @inbounds na = eltypedegree(mapping, i)

    # ind is the subset inclusion
    #
    #     ind: sep(i) → sep(parent(i))
    #
    @inbounds ind = neighbors(mapping, i)

    # U is the update vector for node i.
    @inbounds pstrt = updptr[ns]
    pstop = pstrt + na
    @inbounds U = view(updval, pstrt:pstop - one(I))

    # for all u in sep(i) ...
    @inbounds for u in oneto(na)
        # let f = ind(u)
        f = ind[u]

        # compute the sum
        #
        #     F[f] + U[u]
        #
        # and assign it to F[f]
        F[f] += U[u]
    end

    return
end

function rdiv!_fwd_add_update!(
        F::AbstractMatrix{T},
        ns::I,
        i::I,
        mapping::BipartiteGraph{I, I},
        updptr::AbstractVector{I},
        updval::AbstractVector{T},
    ) where {T, I}
    nrhs = convert(I, size(F, 1))

    # na is the size of the separator at node i.
    #
    #     na = | sep(i) |
    #
    @inbounds na = eltypedegree(mapping, i)

    # ind is the subset inclusion
    #
    #     ind: sep(i) → sep(parent(i))
    #
    @inbounds ind = neighbors(mapping, i)

    # U is the update vector for node i.
    @inbounds pstrt = updptr[ns]
    pstop = pstrt + na * nrhs
    @inbounds U = reshape(view(updval, pstrt:pstop - one(I)), nrhs, na)

    # for all u in sep(i) ...
    @inbounds for u in oneto(na)
        # let f = ind(u)
        f = ind[u]

        # for all rows c ...
        for c in oneto(nrhs)
            # compute the sum
            #
            #     F[c, f] + U[c, u]
            #
            # and assign it to F[c, f]
            F[c, f] += U[c, u]
        end
    end

    return
end

function rdiv!_bwd_add_update!(
        F::AbstractVector{T},
        ns::I,
        i::I,
        mapping::BipartiteGraph{I, I},
        updptr::AbstractVector{I},
        updval::AbstractVector{T},
    ) where {T, I}
    # na is the size of the separator at node i.
    #
    #     na = | sep(i) |
    #
    @inbounds na = eltypedegree(mapping, i)

    # ind is the subset inclusion
    #
    #     ind: sep(i) → sep(parent(i))
    #
    @inbounds ind = neighbors(mapping, i)

    # U is the update vector for node i.
    @inbounds pstrt = updptr[ns]
    @inbounds pstop = updptr[ns + one(I)] = pstrt + na
    @inbounds U = view(updval, pstrt:pstop - one(I))

    # for all u in sep(i) ...
    @inbounds for u in oneto(na)
        # let f = ind(u)
        f = ind[u]

        # assign U[u] ← F[f]
        U[u] = F[f]
    end

    return
end

function rdiv!_bwd_add_update!(
        F::AbstractMatrix{T},
        ns::I,
        i::I,
        mapping::BipartiteGraph{I, I},
        updptr::AbstractVector{I},
        updval::AbstractVector{T},
    ) where {T, I}
    nrhs = convert(I, size(F, 1))

    # na is the size of the separator at node i.
    #
    #     na = | sep(i) |
    #
    @inbounds na = eltypedegree(mapping, i)

    # ind is the subset inclusion
    #
    #     ind: sep(i) → sep(parent(i))
    #
    @inbounds ind = neighbors(mapping, i)

    # U is the update vector for node i.
    @inbounds pstrt = updptr[ns]
    @inbounds pstop = updptr[ns + one(I)] = pstrt + na * nrhs
    @inbounds U = reshape(view(updval, pstrt:pstop - one(I)), nrhs, na)

    # for all u in sep(i) ...
    @inbounds for u in oneto(na)
        # let f = ind(u)
        f = ind[u]

        # for all rows c...
        for c in oneto(nrhs)
            # assign U[c, u] ← F[c, f]
            U[c, u] = F[c, f]
        end
    end

    return
end

function rdiv!_loop_fwd!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractArray{T},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    if isone(nn)
        ns = rdiv!_loop_fwd_nod!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, B, ns, j)
    else
        ns = rdiv!_loop_fwd_snd!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, B, ns, j)
    end

    return ns
end

function rdiv!_loop_fwd_snd!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractVector{T},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = neighbors(residual, j)
    
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = reshape(view(blkval, pstrt:pstop - one(I)), nj, :)
    @inbounds L₁₁ = view(L, oneto(nn),      :)
    @inbounds L₂₁ = view(L, nn + one(I):nj, :)

    # F is part of B
    #
    #     F = [ F₁ ] res(j)
    #         [ F₂ ] sep(j)
    #
    @inbounds F = view(frtval, oneto(nj))
    @inbounds F₁ = view(F, oneto(nn))
    @inbounds F₂ = view(F, nn + one(I):nj)

    @inbounds F₁ .= view(B, res)
    F₂ .= zero(T)

    @inbounds for i in Iterators.reverse(childindices(tree, j))
        rdiv!_fwd_add_update!(F, ns, i, mapping, updptr, updval)
        ns -= one(I)
    end

    # solve for Y₁ in
    #
    #     L₁₁ Y₁ = F₁
    #
    # and store F₁ ← Y₁
    ldiv!(LowerTriangular(L₁₁), F₁)
 
    if ispositive(na)
        # U₂ is the update matrix for node j
        ns += one(I)
        @inbounds pstrt = updptr[ns]
        @inbounds pstop = updptr[ns + one(I)] = pstrt + na
        @inbounds U₂ = view(updval, pstrt:pstop - one(I))
        U₂ .= F₂

        # compute the difference
        #
        #     Y₂ = U₂ - L₂₁ F₁
        #
        # and store U₂ ← Y₂ 
        mul!(U₂, L₂₁, F₁, -one(T), one(T))
    end
   
    # copy B ← F₁
    @inbounds B[res] .= F₁
    return ns
end

function rdiv!_loop_fwd_snd!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractMatrix{T},
        ns::I,
        j::I,
    ) where {T, I}
    nrhs = convert(I, size(B, 1))

    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = neighbors(residual, j)
    
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = reshape(view(blkval, pstrt:pstop - one(I)), nj, :)
    @inbounds L₁₁ = view(L, oneto(nn),      :)
    @inbounds L₂₁ = view(L, nn + one(I):nj, :)

    # F is part of B
    #
    #         res(j) sep(j)
    #     F = [ F₁    F₂ ]
    #
    @inbounds F = reshape(view(frtval, oneto(nj * nrhs)), :, nj)
    @inbounds F₁ = view(F, :, oneto(nn))
    @inbounds F₂ = view(F, :, nn + one(I):nj)

    @inbounds F₁ .= view(B, :, res)
    F₂ .= zero(T)

    @inbounds for i in Iterators.reverse(childindices(tree, j))
        rdiv!_fwd_add_update!(F, ns, i, mapping, updptr, updval)
        ns -= one(I)
    end

    # solve for Y₁ in
    #
    #     Y₁ L₁₁ᴴ = F₁
    #
    # and store F₁ ← Y₁
    rdiv!(F₁, LowerTriangular(L₁₁) |> adjoint)
 
    if ispositive(na)
        # U₂ is the update matrix for node j
        ns += one(I)
        @inbounds pstrt = updptr[ns]
        @inbounds pstop = updptr[ns + one(I)] = pstrt + na * nrhs
        @inbounds U₂ = reshape(view(updval, pstrt:pstop - one(I)), nrhs, na)
        U₂ .= F₂

        # compute the difference
        #
        #     Y₂ = U₂ - Y₁ L₂₁ᴴ
        #
        # and store U₂ ← Y₂ 
        mul!(U₂, F₁, L₂₁ |> adjoint, -one(T), one(T))
    end
   
    # copy B ← F₁
    @inbounds B[:, res] .= F₁
    return ns
end

function rdiv!_loop_fwd_nod!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractVector{T},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = one(I)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = only(neighbors(residual, j))
    
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = view(blkval, pstrt:pstop - one(I))
    @inbounds L₁₁ = view(L, nn)
    @inbounds L₂₁ = view(L, nn + one(I):nj)

    # F is part of B
    #
    #     F = [ F₁ ] res(j)
    #         [ F₂ ] sep(j)
    #
    @inbounds F = view(frtval, oneto(nj))
    @inbounds F₁ = view(F, nn)
    @inbounds F₂ = view(F, nn + one(I):nj)

    @inbounds F₁[] = B[res]
    F₂ .= zero(T)

    @inbounds for i in Iterators.reverse(childindices(tree, j))
        rdiv!_fwd_add_update!(F, ns, i, mapping, updptr, updval)
        ns -= one(I)
    end

    # solve for Y₁ in
    #
    #     L₁₁ Y₁ = F₁
    #
    # and store F₁ ← Y₁
    f₁ = F₁[] / L₁₁[]
 
    if ispositive(na)
        # U₂ is the update matrix for node j
        ns += one(I)
        @inbounds pstrt = updptr[ns]
        @inbounds pstop = updptr[ns + one(I)] = pstrt + na
        @inbounds U₂ = view(updval, pstrt:pstop - one(I))
        U₂ .= F₂

        # compute the difference
        #
        #     Y₂ = U₂ - L₂₁ F₁
        #
        # and store U₂ ← Y₂
        mul!(U₂, L₂₁, f₁, -one(T), one(T))
    end
   
    # copy B ← F₁
    @inbounds B[res] = f₁

    return ns
end

function rdiv!_loop_fwd_nod!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractMatrix{T},
        ns::I,
        j::I,
    ) where {T, I}
    nrhs = convert(I, size(B, 1))

    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = one(I)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the residual at node j
    @inbounds res = only(neighbors(residual, j))
    
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = view(blkval, pstrt:pstop - one(I))
    @inbounds L₁₁ = view(L, nn)
    @inbounds L₂₁ = view(L, nn + one(I):nj)

    # F is part of B
    #
    #         res(j) sep(j)
    #     F = [ F₁    F₂ ]
    #
    @inbounds F = reshape(view(frtval, oneto(nj * nrhs)), :, nj)
    @inbounds F₁ = view(F, :, nn)
    @inbounds F₂ = view(F, :, nn + one(I):nj)

    @inbounds F₁ .= view(B, :, res)

    F₂ .= zero(T)

    @inbounds for i in Iterators.reverse(childindices(tree, j))
        rdiv!_fwd_add_update!(F, ns, i, mapping, updptr, updval)
        ns -= one(I)
    end

    # solve for Y₁ in
    #
    #     Y₁ L₁₁ᴴ = F₁
    #
    # and store F₁ ← Y₁
    F₁ ./= conj(L₁₁[])
 
    if ispositive(na)
        # U₂ is the update matrix for node j
        ns += one(I)
        @inbounds pstrt = updptr[ns]
        @inbounds pstop = updptr[ns + one(I)] = pstrt + na * nrhs
        @inbounds U₂ = reshape(view(updval, pstrt:pstop - one(I)), :, na)
        U₂ .= F₂

        # compute the difference
        #
        #     Y₂ = U₂ - Y₁ L₂₁ᴴ
        #
        # and store U₂ ← Y₂ 
        mul!(U₂, F₁, L₂₁ |> adjoint, -one(T), one(T))
    end
   
    # copy B ← F₁
    @inbounds B[:, res] .= F₁
    return ns
end

function rdiv!_loop_bwd!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractArray{T},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    if isone(nn)
        ns = rdiv!_loop_bwd_nod!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, B, ns, j)
    else
        ns = rdiv!_loop_bwd_snd!(mapping, blkptr, updptr,
            blkval, updval, frtval, tree, B, ns, j)
    end

    return ns
end

function rdiv!_loop_bwd_snd!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractVector{T},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the res at node j
    @inbounds res = neighbors(residual, j)
 
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = reshape(view(blkval, pstrt:pstop - one(I)), nj, :)
    @inbounds L₁₁ = view(L, oneto(nn),      :)
    @inbounds L₂₁ = view(L, nn + one(I):nj, :)

    # F is part of B
    #
    #     F = [ F₁ ] res(j)
    #         [ F₂ ] sep(j)
    #
    @inbounds F = view(frtval, oneto(nj))
    @inbounds F₁ = view(F, oneto(nn))
    @inbounds F₂ = view(F, nn + one(I):nj)

    @inbounds F₁ .= view(B, res)
    
    if ispositive(na)
        # U₂ is the update matrix for node j
        @inbounds pstrt = updptr[ns]
        pstop = pstrt + na
        @inbounds U₂ = view(updval, pstrt:pstop - one(I))
        ns -= one(I)

        # compute the difference
        #
        #     Y₁ = F₁ - L₂₁ᴴ U₂
        #
        # and store F₁ ← Y₁ 
        mul!(F₁, L₂₁ |> adjoint, U₂, -one(T), one(T))

        # copy F₂ ← U₂
        F₂ .= U₂
    end

    # solve for Z₁ in
    #
    #     L₁₁ᴴ Z₁ = Y₁
    #
    # and store F₁ ← Z₁
    ldiv!(LowerTriangular(L₁₁) |> adjoint, F₁)

    @inbounds for i in childindices(tree, j)
        ns += one(I)
        rdiv!_bwd_add_update!(F, ns, i, mapping, updptr, updval)
    end

    # copy B ← F₁
    @inbounds B[res] .= F₁
    return ns
end

function rdiv!_loop_bwd_snd!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractMatrix{T},
        ns::I,
        j::I,
    ) where {T, I}
    nrhs = convert(I, size(B, 1))

    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = eltypedegree(residual, j)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the res at node j
    @inbounds res = neighbors(residual, j)
 
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = reshape(view(blkval, pstrt:pstop - one(I)), nj, :)
    @inbounds L₁₁ = view(L, oneto(nn),      :)
    @inbounds L₂₁ = view(L, nn + one(I):nj, :)

    # F is part of B
    #
    #         res(j) sep(j)
    #     F = [ F₁    F₂ ]
    #
    @inbounds F = reshape(view(frtval, oneto(nj * nrhs)), :, nj)
    @inbounds F₁ = view(F, :, oneto(nn))
    @inbounds F₂ = view(F, :, nn + one(I):nj)

    @inbounds F₁ .= view(B, :, res)

    if ispositive(na)
        # U₂ is the update matrix for node j
        @inbounds pstrt = updptr[ns]
        pstop = pstrt + na * nrhs
        @inbounds U₂ = reshape(view(updval, pstrt:pstop - one(I)), :, na)
        ns -= one(I)

        # compute the difference
        #
        #     Y₁ = F₁ - U₂ L₂₁
        #
        # and store F₁ ← Y₁ 
        mul!(F₁, U₂, L₂₁, -one(T), one(T))

        # copy F₂ ← U₂
        F₂ .= U₂
    end

    # solve for Z₁ in
    #
    #     Z₁ L₁₁ = Y₁
    #
    # and store F₁ ← Z₁
    rdiv!(F₁, LowerTriangular(L₁₁))

    @inbounds for i in childindices(tree, j)
        ns += one(I)
        rdiv!_bwd_add_update!(F, ns, i, mapping, updptr, updval)
    end

    # copy B ← F₁
    @inbounds B[:, res] .= F₁
    return ns
end

function rdiv!_loop_bwd_nod!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractVector{T},
        ns::I,
        j::I,
    ) where {T, I}
    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = one(I)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the res at node j
    @inbounds res = only(neighbors(residual, j))
 
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = view(blkval, pstrt:pstop - one(I))
    @inbounds L₁₁ = view(L, nn)
    @inbounds L₂₁ = view(L, nn + one(I):nj)

    # F is part of B
    #
    #     F = [ F₁ ] res(j)
    #         [ F₂ ] sep(j)
    #
    @inbounds F = view(frtval, oneto(nj))
    @inbounds F₁ = view(F, nn)
    @inbounds F₂ = view(F, nn + one(I):nj)

    @inbounds f₁ = F₁[] = B[res]
    
    if ispositive(na)
        # U₂ is the update matrix for node j
        @inbounds pstrt = updptr[ns]
        pstop = pstrt + na
        @inbounds U₂ = view(updval, pstrt:pstop - one(I))
        ns -= one(I)

        # compute the difference
        #
        #     Y₁ = F₁ - L₂₁ᴴ U₂
        #
        # and store F₁ ← Y₁ 
        f₁ -= dot(L₂₁, U₂)

        # copy F₂ ← U₂
        F₂ .= U₂
    end

    # solve for Z₁ in
    #
    #     L₁₁ᴴ Z₁ = Y₁
    #
    # and store F₁ ← Z₁
    F₁[] = f₁ / conj(L₁₁[])

    @inbounds for i in childindices(tree, j)
        ns += one(I)
        rdiv!_bwd_add_update!(F, ns, i, mapping, updptr, updval)
    end

    # copy B ← F₁
    @inbounds B[res] = F₁[]
    return ns
end

function rdiv!_loop_bwd_nod!(
        mapping::BipartiteGraph{I, I},
        blkptr::AbstractVector{I},
        updptr::AbstractVector{I},
        blkval::AbstractVector{T},
        updval::AbstractVector{T},
        frtval::AbstractVector{T},
        tree::CliqueTree{I, I}, 
        B::AbstractMatrix{T},
        ns::I,
        j::I,
    ) where {T, I}
    nrhs = convert(I, size(B, 1))

    residual = residuals(tree)
    separator = separators(tree)

    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    @inbounds nn = one(I)

    # na is the size of the separator at node j.
    #
    #     na = | sep(j) |
    #
    @inbounds na = eltypedegree(separator, j)

    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na

    # res is the res at node j
    @inbounds res = only(neighbors(residual, j))
 
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    @inbounds pstrt = blkptr[j]
    @inbounds pstop = blkptr[j + one(I)]
    @inbounds L = view(blkval, pstrt:pstop - one(I))
    @inbounds L₁₁ = view(L, nn)
    @inbounds L₂₁ = view(L, nn + one(I):nj)

    # F is part of B
    #
    #         res(j) sep(j)
    #     F = [ F₁    F₂ ]
    #
    @inbounds F = reshape(view(frtval, oneto(nj * nrhs)), :, nj)
    @inbounds F₁ = view(F, :, nn)
    @inbounds F₂ = view(F, :, nn + one(I):nj)

    F₁ .= view(B, :, res)
    
    if ispositive(na)
        # U₂ is the update matrix for node j
        @inbounds pstrt = updptr[ns]
        pstop = pstrt + na * nrhs
        @inbounds U₂ = reshape(view(updval, pstrt:pstop - one(I)), :, na)
        ns -= one(I)

        # compute the difference
        #
        #     Y₁ = F₁ - U₂ L₂₁
        #
        # and store F₁ ← Y₁
        mul!(F₁, U₂, L₂₁, -one(T), one(T))
 
        # copy F₂ ← U₂
        F₂ .= U₂
    end

    # solve for Z₁ in
    #
    #     Z₁ L₁₁ = Y₁
    #
    # and store F₁ ← Z₁
    F₁ ./= L₁₁[]

    @inbounds for i in childindices(tree, j)
        ns += one(I)
        rdiv!_bwd_add_update!(F, ns, i, mapping, updptr, updval)
    end

    # copy B ← F₁
    @inbounds B[:, res] .= F₁
    return ns
end

function Base.size(cholfact::CholFact)
    tree = cholfact.symbfact.tree
    separator = separators(tree)
    neqns = convert(Int, nov(separator))
    return (neqns, neqns)
end

function SparseArrays.nnz(cholfact::CholFact)
    return nnz(cholfact.symbfact)
end

function Base.show(io::IO, ::MIME"text/plain", cholfact::CholFact{T, I}) where {T, I}
    println(io, "CholFact{$T, $I}:")
    println(io, "    nnz: $(nnz(cholfact))")
    print(io,   "    success: $(issuccess(cholfact))")
end

###########################
# Factorization Interface #
###########################

function LinearAlgebra.ldiv!(cholfact::CholFact, B::AbstractArray)
    return linsolve!(B, cholfact, Val(false))
end

function LinearAlgebra.rdiv!(B::AbstractArray, cholfact::CholFact)
    return linsolve!(B, cholfact, Val(true))
end

function LinearAlgebra.issuccess(cholfact::CholFact)
    return cholfact.status[]
end

function LinearAlgebra.isposdef(cholfact::CholFact)
    return issuccess(cholfact)
end

function LinearAlgebra.det(cholfact::CholFact{T, I}) where {T, I}
    tree = cholfact.symbfact.tree
    blkptr = cholfact.blkptr
    blkval = cholfact.blkval

    residual = residuals(tree)
    separator = separators(tree)

    det = one(real(T))

    @inbounds for j in vertices(separator)
        # nn is the size of the residual at node j
        #
        #     nn = | res(j) |
        #
        nn = eltypedegree(residual, j)

        # na is the size of the separator at node j
        #
        #     na = | sep(j) |
        #
        na = eltypedegree(separator, j)

        # nj is the size of the bag at node j
        #
        #     nj = | bag(j) |
        #
        nj = nn + na

        # L is part of the Cholesky factor
        #
        #          res(j)
        #     L = [ L₁₁  ] res(j)
        #         [ L₂₁  ] sep(j)
        #
        pstrt = blkptr[j]
        pstop = blkptr[j + one(I)]
        L = reshape(view(blkval, pstrt:pstop - one(I)), nj, nn)
 
        for k in oneto(nn)
            Lkk = real(L[k, k])
            det *= Lkk * Lkk
        end
    end

    return det
end

function LinearAlgebra.logdet(cholfact::CholFact{T, I}) where {T, I}
    tree = cholfact.symbfact.tree
    blkptr = cholfact.blkptr
    blkval = cholfact.blkval

    residual = residuals(tree)
    separator = separators(tree)

    logdet = zero(real(T))

    @inbounds for j in vertices(separator)
        # nn is the size of the residual at node j
        #
        #     nn = | res(j) |
        #
        nn = eltypedegree(residual, j)

        # na is the size of the separator at node j
        #
        #     na = | sep(j) |
        #
        na = eltypedegree(separator, j)

        # nj is the size of the bag at node j
        #
        #     nj = | bag(j) |
        #
        nj = nn + na

        # L is part of the Cholesky factor
        #
        #          res(j)
        #     L = [ L₁₁  ] res(j)
        #         [ L₂₁  ] sep(j)
        #
        pstrt = blkptr[j]
        pstop = blkptr[j + one(I)]
        L = reshape(view(blkval, pstrt:pstop - one(I)), nj, nn)
 
        for k in oneto(nn)
            Lkk = log(real(L[k, k]))
            logdet += Lkk + Lkk
        end
    end

    return logdet
end

##################################
# Dense Numerical Linear Algebra #
##################################

# copy the lower triangular part of B to A
function lacpy!(A::AbstractMatrix{T}, B::AbstractMatrix{T}) where {T}
    m = size(B, 1)

    @inbounds for j in axes(B, 2)
        for i in j:m
            A[i, j] = B[i, j]
        end
    end

    return
end

@static if VERSION >= v"1.11"

function lacpy!(A::AbstractMatrix{T}, B::AbstractMatrix{T}) where {T <: BLAS.BlasFloat}
    LAPACK.lacpy!(A, B, 'L')
    return
end

end

# factorize A as
#
#     A = L Lᴴ
#
# and store A ← L
function potrf!(A::AbstractMatrix)
    fact = LinearAlgebra.cholesky!(Hermitian(A, :L), NoPivot(); check = false)
    status = iszero(fact.info)
    return status
end

# compute the lower triangular part of the difference
#
#     C = L - A * Aᴴ
#
# and store L ← C
function syrk!(A::AbstractMatrix{T}, L::AbstractMatrix{T}) where {T}
    m = size(A, 1)

    @inbounds for k in axes(A, 2), j in axes(A, 1)
        Ajk = conj(A[j, k])

        for i in j:m
            L[i, j] -= A[i, k] * Ajk
        end
    end

    return
end

function syrk!(A::AbstractMatrix{T}, L::AbstractMatrix{T}) where {T <: BLAS.BlasReal}
    BLAS.syrk!('L', 'N', -one(T), A, one(T), L)
    return
end

function syrk!(A::AbstractMatrix{T}, L::AbstractMatrix{T}) where {T <: BLAS.BlasComplex}
    BLAS.herk!('L', 'N', -one(real(T)), A, one(real(T)), L)
    return
end

# compute the lower triangular part of the difference
#
#     C = L - a * aᴴ
#
# and store L ← C
function syr!(a::AbstractVector{T}, L::AbstractMatrix{T}) where {T}
    m = length(a)

    @inbounds for j in eachindex(a)
        aj = conj(a[j])

        for i in j:m
            L[i, j] -= a[i] * aj
        end
    end

    return
end

function syr!(a::AbstractVector{T}, L::AbstractMatrix{T}) where {T <: BLAS.BlasReal}
    BLAS.syr!('L', -one(T), a, L)
    return
end

function syr!(a::AbstractVector{T}, L::AbstractMatrix{T}) where {T <: BLAS.BlasComplex}
    BLAS.her!('L', -one(real(T)), a, L)
    return
end

# ===== potrf2! =====

function potrf2!(::Val{:L}, A::AbstractMatrix{T}, d::AbstractVector{T}, S::AbstractVector{T}, R::AbstractRegularization, ::Val{DIAG}) where {T, DIAG}
    @inbounds @fastmath for j in axes(A, 1)
        Ajj = regularize(R, S, real(A[j, j]), j)

        iszero(Ajj) && return j

        if DIAG === :N
            A[j, j] = Ajj = sqrt(Ajj)
        else
            d[j] = Ajj
        end

        iDjj = inv(Ajj)

        for i in j + 1:size(A, 1)
            A[i, j] *= iDjj
        end

        for k in j + 1:size(A, 1)
            Akj = A[k, j]; cAkj = conj(Akj)

            if DIAG === :N
                A[k, k] -= abs2(Akj)
            else
                A[k, k] -= Ajj * abs2(Akj)
            end

            for i in k + 1:size(A, 1)
                if DIAG === :N
                    A[i, k] -= A[i, j] * cAkj
                else
                    A[i, k] -= A[i, j] * Ajj * cAkj
                end
            end
        end
    end

    return 0
end

function potrf2!(::Val{:U}, A::AbstractMatrix{T}, d::AbstractVector{T}, S::AbstractVector{T}, R::AbstractRegularization, ::Val{DIAG}) where {T, DIAG}
    @inbounds @fastmath for j in axes(A, 1)
        Ajj = real(A[j, j])

        for k in 1:j - 1
            if DIAG === :N
                Ajj -= abs2(A[k, j])
            else
                Ajj -= abs2(A[k, j]) * real(d[k])
            end
        end

        Ajj = regularize(R, S, Ajj, j)

        iszero(Ajj) && return j

        if DIAG === :N
            A[j, j] = Ajj = sqrt(Ajj)
        else
            d[j] = Ajj
        end

        iDjj = inv(Ajj)

        for i in j + 1:size(A, 1)
            for k in 1:j - 1
                cAkj = conj(A[k, j])

                if DIAG === :N
                    A[j, i] -= A[k, i] * cAkj
                else
                    A[j, i] -= A[k, i] * d[k] * cAkj
                end
            end

            A[j, i] *= iDjj
        end
    end

    return 0
end

# ===== potrf! =====

function potrf!(uplo::Val{UPLO}, A::AbstractMatrix{T}) where {T <: BlasFloat, UPLO}
    _, info = LAPACK.potrf!(char(uplo), A)
    return info
end

function potrf!(uplo::Val{UPLO}, A::AbstractMatrix{T}, R::AbstractRegularization=NoRegularization()) where {T, UPLO}
    n = size(A, 1)
    W = Ones{T}(n * n)
    d = Ones{T}(n)
    S = Ones{T}(n)
    diag = Val(:N)
    return potrf!(uplo, W, A, d, S, R, diag)
end

function potrf!(uplo::Val{UPLO}, ::AbstractVector{T}, A::AbstractMatrix{T}, ::AbstractVector{T}, ::AbstractVector{T}, ::NoRegularization, ::Val{:N}) where {T <: BlasFloat, UPLO}
    return potrf!(uplo, A)
end

function potrf!(uplo::Val{UPLO}, W::AbstractVector{T}, D::AbstractMatrix{T}, d::AbstractVector{T}, S::AbstractVector{T}, R::GMW81, diag::Val{DIAG}) where {T, UPLO, DIAG}
    n = size(D, 1)

    if UPLO === :L
        L = Ones{T}(0, n)
    else
        L = Ones{T}(n, 0)
    end

    return chol_factor!(D, L, W, d, S, R, uplo, diag)
end

function potrf!(uplo::Val{UPLO}, W::AbstractVector{T}, L₁::AbstractMatrix{T}, d₁::AbstractVector{T}, S₁::AbstractVector{T}, R::SE99, diag::Val{DIAG}) where {T, UPLO, DIAG}
    n = size(L₁, 1)

    if UPLO === :L
        L₂ = Ones{T}(0, n)
    else
        L₂ = Ones{T}(n, 0)
    end

    M = Ones{T}(0, 0)
    d₂ = Ones{T}(0)
    S₂ = Ones{T}(0)

    chol_se99_kernel!(L₁, L₂, M, W, d₁, d₂, S₁, S₂, R, true, zero(real(T)), zero(real(T)), uplo, diag)

    return 0
end

function potrf!(uplo::Val{UPLO}, W::AbstractVector{T}, A::AbstractMatrix{T}, d::AbstractVector{T}, S::AbstractVector{T}, R::AbstractRegularization, diag::Val{DIAG}) where {T, UPLO, DIAG}
    n = size(A, 1)
    n <= THRESHOLD && return potrf2!(uplo, A, d, S, R, diag)

    n₁  = 2^floor(Int, log2(n)) ÷ 2
    A₁₁ = view(A, 1:n₁, 1:n₁)
    A₂₂ = view(A, n₁+1:n, n₁+1:n)

    d₁₁ = view(d, 1:n₁)
    d₂₂ = view(d, n₁+1:n)
    S₁₁ = view(S, 1:n₁)
    S₂₂ = view(S, n₁+1:n)
    #
    # factorize A₁₁
    #
    info = potrf!(uplo, W, A₁₁, d₁₁, S₁₁, R, diag)
    !iszero(info) && return info

    if UPLO === :L
        B = view(A, n₁+1:n, 1:n₁)
        side = Val(:R)
        trans = Val(:N)
    else
        B = view(A, 1:n₁, n₁+1:n)
        side = Val(:L)
        trans = Val(:C)
    end
    #
    # B ← B A₁₁⁻ᴴ D₁₁⁻¹
    #
    trsm!(side, uplo, Val(:C), diag, one(T), A₁₁, B)
    cdiv!(side, diag, B, d₁₁)
    #
    # A₂₂ ← A₂₂ - B Bᴴ       (Cholesky)
    # A₂₂ ← A₂₂ - B D₁₁ Bᴴ   (LDLt)
    #
    syrk!(uplo, trans, -one(real(T)), W, B, d₁₁, one(real(T)), A₂₂, diag)
    #
    # factorize A₂₂
    #
    info = potrf!(uplo, W, A₂₂, d₂₂, S₂₂, R, diag)
    !iszero(info) && return n₁ + info
    return 0
end

"""
    DynamicRegularization
"""
struct DynamicRegularization{T, I, Sgn <: AbstractVector{I}}
    signs::Sgn
    delta::T
    epsilon::T
end

const DynReg = DynamicRegularization

function DynReg{T, I}(n::Integer, delta::Number, epsilon::Number) where {T, I}
    signs = FVector{I}(undef, n)
    return DynReg{T, I, FVector{I}}(signs, delta, epsilon)
end

function DynReg(signs::Sgn; delta::T=1e-6, epsilon::T=1e-12) where {T, I, Sgn <: AbstractVector{I}}
    return DynReg{T, I, Sgn}(signs, delta, epsilon)
end

function Base.view(reg::DynReg, inds)
    return DynReg(view(reg.signs, inds), reg.delta, reg.epsilon)
end

struct DenseFactorization{
        DIAG,
        UPLO,
        T,
        Mat <: AbstractMatrix{T},
        Dia <: AbstractVector{T},
        Prm <: AbstractVector{Int},
        Ivp <: AbstractVector{Int},
        Ifo <: AbstractScalar{Int},
    } <: AbstractFactorization{DIAG, UPLO, T, Int, Prm, Ivp}
    M::Mat
    d::Dia
    perm::Prm
    invp::Ivp
    info::Ifo
end

const NaturalDenseFactorization{DIAG, UPLO, T, Mat, Dia, Ifo} = DenseFactorization{DIAG, UPLO, T, Mat, Dia, OneTo{Int}, OneTo{Int}, Ifo}
const DenseCholeskyPivoted = DenseFactorization{:N}
const DenseLDLtPivoted = DenseFactorization{:U}
const DenseCholesky = NaturalDenseFactorization{:N}
const DenseLDLt = NaturalDenseFactorization{:U}

const FDenseCholesky{UPLO, T} = DenseCholesky{
    UPLO,
    T,
    FMatrix{T},
    IOnes{T},
    FScalar{Int},
}

const FDenseLDLt{UPLO, T} = DenseLDLt{
    UPLO,
    T,
    FMatrix{T},
    FVector{T},
    FScalar{Int},
}

const FDenseCholeskyPivoted{UPLO, T} = DenseCholeskyPivoted{
    UPLO,
    T,
    FMatrix{T},
    IOnes{T},
    FVector{Int},
    FVector{Int},
    FScalar{Int},
}

const FDenseLDLtPivoted{UPLO, T} = DenseLDLtPivoted{
    UPLO,
    T,
    FMatrix{T},
    FVector{T},
    FVector{Int},
    FVector{Int},
    FScalar{Int},
}

const DDenseCholesky{UPLO, T} = DenseCholesky{
    UPLO,
    T,
    Matrix{T},
    IOnes{T},
    Scalar{Int},
}

const DDenseLDLt{UPLO, T} = DenseLDLt{
    UPLO,
    T,
    Matrix{T},
    Vector{T},
    Scalar{Int},
}

const DDenseCholeskyPivoted{UPLO, T} = DenseCholeskyPivoted{
    UPLO,
    T,
    Matrix{T},
    IOnes{T},
    Vector{Int},
    Vector{Int},
    Scalar{Int},
}

const DDenseLDLtPivoted{UPLO, T} = DenseLDLtPivoted{
    UPLO,
    T,
    Matrix{T},
    Vector{T},
    Vector{Int},
    Vector{Int},
    Scalar{Int},
}

# ===== NaturalFactorization =====

function DenseFactorization{DIAG, UPLO, T, Mat, Dia, Prm, Ivp, Ifo}(A::AbstractMatrix) where {
        DIAG,
        UPLO,
        T,
        Mat <: AbstractMatrix{T},
        Dia <: AbstractVector{T},
        Prm <: AbstractVector{Int},
        Ivp <: AbstractVector{Int},
        Ifo <: AbstractScalar{Int},
    }

    if A isa HermOrSym
        B = parent(A)
    else
        B = A
    end

    n = size(A, 1)
    d = allocate(Dia, n)
    perm = allocate(Prm, n)
    invp = allocate(Ivp, n)
    info = allocate(Ifo)

    if !(Prm <: AbstractRange)
        perm .= 1:n
    end

    if !(Ivp <: AbstractRange)
        invp .= 1:n
    end

    return DenseFactorization{DIAG, UPLO, T, Mat, Dia, Prm, Ivp, Ifo}(B, d, perm, invp, info)
end

function DenseFactorization{DIAG, UPLO}(
        M::Mat,
        d::Dia,
        perm::Prm,
        invp::Ivp,
        info::Ifo,
    ) where {
        DIAG,
        UPLO,
        T,
        Mat <: AbstractMatrix{T},
        Dia <: AbstractVector{T},
        Prm <: AbstractVector{Int},
        Ivp <: AbstractVector{Int},
        Ifo <: AbstractScalar{Int},
    }
    return DenseFactorization{DIAG, UPLO, T, Mat, Dia, Prm, Ivp, Ifo}(M, d, perm, invp, info)
end

function (::Type{Fac})(n::Integer) where {DIAG, UPLO, T, Fac <: Union{DenseFactorization{DIAG, UPLO, T}, NaturalDenseFactorization{DIAG, UPLO, T}}}
    M = FMatrix{T}(undef, n, n)
    return Fac(M)
end

function (::Type{Fac})(n::Integer) where {DIAG, UPLO, T, Mat <: AbstractMatrix{T}, Fac <: Union{DenseFactorization{DIAG, UPLO, T, Mat}, NaturalDenseFactorization{DIAG, UPLO, T, Mat}}}
    M = allocate(Mat, n, n)
    return Fac(M)
end

function DenseFactorization{DIAG}(A::AbstractMatrix) where {DIAG}
    return DenseFactorization{DIAG, DEFAULT_UPLO}(A)
end

function NaturalDenseFactorization{DIAG}(A::AbstractMatrix) where {DIAG}
    return NaturalDenseFactorization{DIAG, DEFAULT_UPLO}(A)
end

function DenseFactorization{DIAG, UPLO}(A::AbstractMatrix{T}) where {DIAG, UPLO, T}
    return DenseFactorization{DIAG, UPLO, T}(A)
end

function NaturalDenseFactorization{DIAG, UPLO}(A::AbstractMatrix{T}) where {DIAG, UPLO, T}
    return NaturalDenseFactorization{DIAG, UPLO, T}(A)
end

function DenseFactorization{DIAG, UPLO, T}(A::Mat) where {DIAG, UPLO, T, Mat <: AbstractMatrix{T}}
    if DIAG === :N
        Dia = IOnes{T}
    else
        Dia = FVector{T}
    end

    if A isa HermOrSym
        Pnt = typeof(parent(A))
    else
        Pnt = Mat
    end

    Prm = FVector{Int}
    Ivp = FVector{Int}
    Ifo = FScalar{Int}
    return DenseFactorization{DIAG, UPLO, T, Pnt, Dia, Prm, Ivp, Ifo}(A)
end 

function NaturalDenseFactorization{DIAG, UPLO, T}(A::Mat) where {DIAG, UPLO, T, Mat <: AbstractMatrix{T}}
    if DIAG === :N
        Dia = IOnes{T}
    else
        Dia = FVector{T}
    end 
 
    if A isa HermOrSym
        Pnt = typeof(parent(A))
    else
        Pnt = Mat
    end
   
    Ifo = FScalar{Int}
    return NaturalDenseFactorization{DIAG, UPLO, T, Pnt, Dia, Ifo}(A)
end 

function NaturalFactorization(F::DenseFactorization{DIAG, UPLO}) where {DIAG, UPLO}
    perm = invp = OneTo{Int}(size(F, 1))
    return DenseFactorization{DIAG, UPLO}(F.M, F.d, perm, invp, F.info)
end

# ===== Base methods =====

function Base.propertynames(::DenseFactorization)
    return (:L, :U, :D, :P, :d, :perm, :invp, :info)
end

function Base.similar(F::DenseFactorization{DIAG, UPLO}, ::Type{T}=eltype(F)) where {DIAG, UPLO, T}
    if DIAG === :N
        d = F.d
    else
        d = similar(F.d, T)
    end

    return DenseFactorization{DIAG, UPLO}(similar(F.M, T), d, F.perm, F.invp, similar(F.info))
end

function triangular(F::DenseFactorization, diag::Val=F.diag)
    return tri(F.uplo, diag, getfield(F, :M))
end

# ===== show =====

for Fac in (
    :FDenseCholesky,
    :FDenseLDLt,
    :FDenseCholeskyPivoted,
    :FDenseLDLtPivoted,
    :DDenseCholesky,
    :DDenseLDLt,
    :DDenseCholeskyPivoted,
    :DDenseLDLtPivoted,
)
    @eval function Base.show(io::IO, ::Type{$Fac{UPLO, T}}) where {UPLO, T}
        print(io, $("$Fac{"), repr(UPLO), ", ", T, "}")
    end
end

function Base.show(io::IO, F::Fac) where {Fac <: DenseFactorization}
    n = size(F, 1)
    print(io, "$n×$n $Fac")
end

function Base.show(io::IO, ::MIME"text/plain", F::Fac) where {DIAG, Fac <: DenseFactorization{DIAG}}
    n = size(F, 1)
    println(io, "$n×$n $Fac:")
    print_matrix(io, triangular(F))

    if DIAG === :U
        println(io)
        println(io)
        print_matrix(io, F.D)
    end
end

# ===== syrk! =====

function syrk!(uplo::Val, trans::Val, α, A::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T}
    n = size(C, 1)
    W = Ones{T}(n * n)
    D = Ones{T}(n)
    syrk!(uplo, trans, α, W, A, D, β, C, Val(:N))
    return
end

# ===== syrk2! =====

function syrk2!(::Val{UPLO}, ::Val{:N}, α, A::AbstractMatrix{T}, D::AbstractVector{T}, β, C::AbstractMatrix{T}, ::Val{DIAG}) where {T, UPLO, DIAG}
    m = size(C, 1)
    n = size(A, 2)

    @inbounds @fastmath for j in 1:m
        if UPLO === :L
            rng = j:m
        else
            rng = 1:j
        end

        if iszero(β)
            for i in rng
                C[i, j] = β
            end
        else
            for i in rng
                C[i, j] *= β
            end
        end
    end

    @inbounds @fastmath for k in 1:n
        for j in 1:m
            if UPLO === :L
                rng = j:m
            else
                rng = 1:j
            end

            if DIAG === :N
                Ajk = α * conj(A[j, k])
            else
                Ajk = α * D[k] * conj(A[j, k])
            end

            for i in rng
                C[i, j] += A[i, k] * Ajk
            end
        end
    end

    return
end

function syrk2!(::Val{UPLO}, ::Val, α, A::AbstractMatrix{T}, D::AbstractVector{T}, β, C::AbstractMatrix{T}, ::Val{DIAG}) where {T, UPLO, DIAG}
    m = size(C, 1)
    n = size(A, 1)

    @inbounds @fastmath for j in 1:m
        if UPLO === :L
            rng = j:m
        else
            rng = 1:j
        end

        for i in rng
            Δij = zero(T)

            for k in 1:n
                if DIAG === :N
                    Δij += α * conj(A[k, i]) * A[k, j]
                else
                    Δij += α * D[k] * conj(A[k, i]) * A[k, j]
                end
            end

            if iszero(β)
                C[i, j] = Δij
            else
                C[i, j] = Δij + β * C[i, j]
            end
        end
    end

    return
end

# ===== 9-arg syrk! recursive fallback =====

function syrk!(uplo::Val{UPLO}, trans::Val{TRANS}, α, W::AbstractVector{T}, A::AbstractMatrix{T}, D::AbstractVector{T}, β, C::AbstractMatrix{T}, diag::Val{DIAG}) where {T, TRANS, UPLO, DIAG}
    n = size(C, 1)

    if n <= THRESHOLD
        syrk2!(uplo, trans, α, A, D, β, C, diag)
    else
        m = prevpow(2, n) >> 1

        if TRANS === :N
            A₁ = view(A,     1:m, :)
            A₂ = view(A, m + 1:n, :)
        else
            A₁ = view(A, :,     1:m)
            A₂ = view(A, :, m + 1:n)
        end

        C₁₁ = view(C,     1:m,     1:m)
        C₂₂ = view(C, m + 1:n, m + 1:n)

        if UPLO === :L
            C₂₁ = view(C, m + 1:n, 1:m)

            if TRANS === :N
                gemm!(Val(:N), Val(:T), α, W, A₂, A₁, D, β, C₂₁, diag)
            else
                gemm!(Val(:T), Val(:N), α, W, A₂, A₁, D, β, C₂₁, diag)
            end
        else
            C₁₂ = view(C, 1:m, m + 1:n)

            if TRANS === :N
                gemm!(Val(:N), Val(:T), α, W, A₁, A₂, D, β, C₁₂, diag)
            else
                gemm!(Val(:T), Val(:N), α, W, A₁, A₂, D, β, C₁₂, diag)
            end
        end

        syrk!(uplo, trans, α, W, A₁, D, β, C₁₁, diag)
        syrk!(uplo, trans, α, W, A₂, D, β, C₂₂, diag)
    end

    return
end

function syrk!(uplo::Val, trans::Val{TRANS}, α, ::AbstractVector{T}, A::AbstractMatrix{T}, ::AbstractVector{T}, β, C::AbstractMatrix{T}, ::Val{:N}) where {T <: BlasFloat, TRANS}
    if T <: Complex
        BLAS.herk!(char(uplo), char(trans), convert(real(T), α), A, convert(real(T), β), C)
    else
        BLAS.syrk!(char(uplo), char(trans), convert(T, α), A, convert(T, β), C)
    end

    return
end

function syrk!(uplo::Val, trans::Val{TRANS}, α, W::AbstractVector{T}, A::AbstractMatrix{T}, D::AbstractVector{T}, β, C::AbstractMatrix{T}, ::Val{:U}) where {T <: BlasFloat, TRANS}
    B = reshape(view(W, 1:length(A)), size(A))
    copyrec!(B, A)

    if TRANS === :N
        cmul!(Val(:R), Val(:U), B, D)
    else
        cmul!(Val(:L), Val(:U), B, D)
    end

    trrk!(uplo, trans, α, B, A, β, C)
    return
end

"""
    Permutation{I} <: AbstractMatrix{Bool}

A permutation matrix.

### Fields

  - `P.perm`: permutation vector
  - `P.invp`: inverse permutation vector

"""
struct Permutation{I, Prm <: AbstractVector{I}, Ivp <: AbstractVector{I}} <: AbstractMatrix{Bool}
    perm::Prm
    invp::Ivp

    function Permutation{I, Prm, Ivp}(perm, invp) where {I, Prm <: AbstractVector{I}, Ivp <: AbstractVector{I}}
        @assert length(perm) == length(invp)

        if Prm <: FVector && !(perm isa Prm)
            perm = Prm(perm)
        end

        if Ivp <: FVector && !(invp isa Ivp)
            invp = Ivp(invp)
        end

        return new{I, Prm, Ivp}(perm, invp)
    end
end

const FPermutation{I} = Permutation{I, FVector{I}, FVector{I}}
const DPermutation{I} = Permutation{I, Vector{I}, Vector{I}}
const NaturalPermutation{I} = Permutation{I, OneTo{I}, OneTo{I}}

function Permutation(perm::AbstractVector{I}, invp::AbstractVector{I}) where {I}
    return Permutation{I}(perm, invp)
end

function Permutation{I}(perm::Prm, invp::Ivp) where {I, Prm <: AbstractVector{I}, Ivp <: AbstractVector{I}}
    return Permutation{I, Prm, Ivp}(perm, invp)
end

function Permutation{I, Prm, Ivp}(n::Integer) where {I, Prm <: AbstractVector{I}, Ivp <: AbstractVector{I}}
    perm = allocate(Prm, n)
    invp = allocate(Ivp, n)
    return Permutation{I, Prm, Ivp}(perm, invp)
end

function Permutation{I}(n::Integer) where {I}
    return FPermutation{I}(n)
end

function (::Type{Prm})(perm::AbstractVector{I}) where {I, Prm <: Permutation}
    return Prm{I}(perm)
end

function (::Type{Prm})(perm::AbstractVector) where {I, Prm <: Permutation{I}}
    return Prm(perm, invperm(perm))
end

function Base.:(==)(P::Permutation, Q::Permutation)
    return P.perm == Q.perm && P.invp == Q.invp
end

# ===== show =====

for Prm in (:FPermutation, :DPermutation, :NaturalPermutation)
    @eval function Base.show(io::IO, ::Type{$Prm{I}}) where {I}
        print(io, $("$Prm{"), I, "}")
    end
end

# ===== Adjoint, Transpose, Inverse =====

function Base.inv(P::Permutation)
    return Permutation(P.invp, P.perm)
end

function Base.adjoint(P::Permutation)
    return inv(P)
end

function Base.transpose(P::Permutation)
    return inv(P)
end

# ===== Abstract Matrix Interface =====

function Base.size(P::Permutation)
    n = length(P.perm)
    return (n, n)
end

function Base.getindex(P::Permutation, i::Integer, j::Integer)
    @boundscheck checkbounds(P, i, j)
    return P.perm[i] == j
end

"""
    FilledGraph{V, E} <: AbstractGraph{V}

A filled graph.
"""
struct FilledGraph{V, E} <: AbstractGraph{V}
    tree::CliqueTree{V, E}
    index::Vector{V}
    ne::E
end

function FilledGraph{V, E}(tree::CliqueTree) where {V, E}
    n = ne(residuals(tree)); m = zero(E); i = zero(V)
    index = Vector{V}(undef, n)

    @inbounds for bag in tree
        res = residual(bag)
        sep = separator(bag)
        nres = convert(E, length(res))
        nsep = convert(E, length(sep))

        index[res] .= i += one(V)
        m += nsep * nres + half(nres * (nres - one(E)))
    end

    return FilledGraph{V, E}(tree, index, m)
end

function FilledGraph{V}(tree::CliqueTree{<:Any, E}) where {V, E}
    return FilledGraph{V, E}(tree)
end

function FilledGraph(tree::CliqueTree{V}) where {V}
    return FilledGraph{V}(tree)
end

function BipartiteGraph{V, E}(graph::FilledGraph) where {V, E}
    n = nv(graph); m = ne(graph)
    result = BipartiteGraph{V, E}(n, n, m)
    j = one(V); pointers(result)[j] = p = one(E)

    @inbounds for bag in graph.tree
        res = residual(bag)
        sep = separator(bag)
        nres = convert(V, length(res))
        nsep = convert(V, length(sep))

        for i in oneto(nres)
            src = i + one(V); num = nres - i
            copyto!(targets(result), p, res, src, num)

            p += convert(E, num); src = one(V); num = nsep
            copyto!(targets(result), p, sep, src, num)

            j += one(V); pointers(result)[j] = p += convert(E, num)
        end
    end

    return result
end

function Graphs.Graph{V}(graph::FilledGraph) where {V}
    n = nv(graph)
    count = Vector{V}(undef, n)
    fadjlist = Vector{Vector{V}}(undef, n)

    @inbounds for v in reverse(vertices(graph))
        count[v] = zero(V)

        for w in neighbors(graph, v)
            count[w] += one(V)
        end
    end

    @inbounds for v in vertices(graph)
        fadjlist[v] = Vector{V}(undef, count[v] + outdegree(graph, v))
        count[v] = zero(V)
    end

    @inbounds for v in vertices(graph)
        i = count[v]

        for w in neighbors(graph, v)
            count[w] += one(V)
            fadjlist[w][count[w]] = v

            i += one(V)
            fadjlist[v][i] = w
        end
    end

    m = Int(ne(graph))
    return Graph{V}(m, fadjlist)
end

function Graphs.DiGraph{V}(graph::FilledGraph) where {V}
    n = nv(graph)
    count = Vector{V}(undef, n)
    fadjlist = Vector{Vector{V}}(undef, n)
    badjlist = Vector{Vector{V}}(undef, n)

    @inbounds for v in reverse(vertices(graph))
        count[v] = zero(V)

        for w in neighbors(graph, v)
            count[w] += one(V)
        end
    end

    @inbounds for v in vertices(graph)
        fadjlist[v] = Vector{V}(undef, outdegree(graph, v))
        badjlist[v] = Vector{V}(undef, count[v])
        count[v] = zero(V)
    end

    @inbounds for v in vertices(graph)
        i = zero(V)

        for w in neighbors(graph, v)
            count[w] += one(V)
            badjlist[w][count[w]] = v

            i += one(V)
            fadjlist[v][i] = w
        end
    end

    m = Int(ne(graph))
    return DiGraph{V}(m, fadjlist, badjlist)
end

function Base.Matrix{T}(graph::FilledGraph) where {T}
    return Matrix(sparse(T, graph))
end

function Base.Matrix(graph::FilledGraph)
    return Matrix(sparse(graph))
end

# Construct a sparse symmetric matrix with a given sparsity graph.
function SparseArrays.SparseMatrixCSC{T, I}(graph::FilledGraph) where {T, I}
    return SparseMatrixCSC{T}(BipartiteGraph{I, I}(graph))
end

# See above.
function SparseArrays.SparseMatrixCSC{T}(graph::FilledGraph{V, E}) where {T, V, E}
    I = promote_type(V, E)
    return SparseMatrixCSC{T, I}(graph)
end

# See above.
function SparseArrays.SparseMatrixCSC(graph::FilledGraph)
    return SparseMatrixCSC{Bool}(graph)
end

# Construct the adjacency matrix of a graph.
function SparseArrays.sparse(::Type{T}, ::Type{I}, graph::FilledGraph) where {T, I}
    matrix = SparseMatrixCSC{T, I}(graph)
    fill!(nonzeros(matrix), one(T))
    return matrix
end

# See above.
function SparseArrays.sparse(::Type{T}, graph::FilledGraph{V, E}) where {T, V, E}
    I = promote_type(V, E)
    return sparse(T, I, graph)
end

# See above.
function SparseArrays.sparse(graph::FilledGraph)
    return sparse(Bool, graph)
end

function Base.show(io::IO, ::MIME"text/plain", graph::G) where {G <: FilledGraph}
    m = ne(graph)
    n = nv(graph)
    return println(io, "{$n, $m} $G")
end

############################
# Abstract Graph Interface #
############################

function Graphs.is_directed(::Type{<:FilledGraph})
    return true
end

function Graphs.nv(graph::FilledGraph{V}) where {V}
    return ne(residuals(graph.tree))
end

function Graphs.ne(graph::FilledGraph)
    return graph.ne
end

@propagate_inbounds function Graphs.has_edge(graph::FilledGraph, i::Integer, j::Integer)
    @boundscheck checkbounds(graph.index, i)
    @inbounds bag = graph.tree[graph.index[i]]
    return i < j && j in bag
end

function Graphs.vertices(graph::FilledGraph{V}) where {V}
    return oneto(nv(graph))
end

@propagate_inbounds function Graphs.outneighbors(graph::FilledGraph{V, E}, i::Integer) where {V, E}
    ii = convert(V, i) + one(V)
    @boundscheck checkbounds(graph.index, i)
    @inbounds bag = graph.tree[graph.index[i]]
    res = residual(bag)
    sep = separator(bag)
    return Clique{V, E}(ii:last(res), sep)
end

@propagate_inbounds function Graphs.outdegree(graph::FilledGraph{V}, i::Integer) where {V}
    @boundscheck checkbounds(graph.index, i)
    @inbounds bag = graph.tree[graph.index[i]]
    res = residual(bag)
    sep = separator(bag)
    return convert(Int, last(res)) + length(sep) - convert(Int, i)
end

#**********************************************************************
#**********************************************************************
#*****   MFNUMN .....  VERTEX NUMBER STEP - NATURAL   *****************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       THIS SUBROUTINE NUMBERS THE VERTICES OF THE ORIGINAL GRAPH 
#       PASSED INTO THE MINIMUM LOCAL FILL ORDERING ROUTINES.
#       WITHIN EACH SUPERNODE, THE REPRESENTATIVE VERTEX IS NUMBERED
#       FIRST, AND THE REMAINING VERTICES ARE NUMBERED IN THE NATURAL
#       ORDERING IN THE ORIGINAL ORDERING.
#
#     INPUT PARAMETERS:
#       NEQNS       - NUMBER OF COLUMN VERTICES.
#       WORK(*)     - ARRAY OF LENGTH NEQNS.
#                       ELIMINATED REPRESENTATIVE: >=0
#                       ABSORBED: MAPS ABSORBED VERTEX TO MINUS THE
#                         ABSORBING VERTEX (I.E., -ABSORBEE).
#       INVP(*)     - ARRAY OF LENGTH NEQNS.
#                       ELIMINATED REPRESENTATIVE: -NUM, WHERE NUM
#                         IS THE NUMBER ASSIGNED BY THE ELIMINATION
#                         ORDER.
#                       ABSORBED: USELESS DATA.
#
#     MODIFIED PARAMETERS:
#       WORK(*)     - SHORTENED SUPERNODE FOREST.
#       INVP(*)     - ENDS UP WITH THE INVERSE PERMUTATION VECTOR, 
#                     WHICH MAPS OLD NUMBERS TO NEW.
#
#     OUTPUT PARAMETER:
#       PERM(*)     - ARRAY OF LENGTH NEQNS.
#                     ENDS UP WITH THE PERMUTATION VECTOR, WHICH 
#                     MAPS NEW NUMBERS TO OLD.
#
#**********************************************************************
#
function mfnumn(neqns::V, work::AbstractVector{V}, invp::AbstractVector{V}, perm::AbstractVector{V}) where {V}
    
    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    
    #       -------------------------------------------------------
    #       INITIALIZATION AND TAKE CARE OF REPRESENTATIVE COLUMNS.
    #       -------------------------------------------------------
    for jcol in oneto(neqns)
        perm[jcol] = zero(V)
    end

    for jcol in oneto(neqns)
        if !isnegative(work[jcol])
            perm[-invp[jcol]] = jcol
        end
    end
    
    #       -----------------------------------------------------
    #       MAIN LOOP -- TAKE CARE OF NON-REPRESENTATIVE COLUMNS.
    #       FOR EACH COLUMN JCOL ...
    #       -----------------------------------------------------
    for jcol in oneto(neqns)
        
        #           ---------------------------
        #           SKIP REPRESENTATIVE COLUMN.
        #           ---------------------------
        if isnegative(work[jcol])
            
            #               ----------------------------
            #               FIND ROOT OF SUPERNODE TREE.
            #               ----------------------------
            parent = jcol

            while isnegative(work[parent])
                parent = -work[parent]
            end
            
            #               -----------------------
            #               NUMBER JCOL AFTER ROOT.
            #               -----------------------
            root = parent
            invp[root] -= one(V)
            perm[-invp[root]] = jcol
            
            #               --------------------
            #               SHORTEN MERGED TREE.
            #               --------------------
            parent = jcol
            nextp = -work[parent]

            while ispositive(nextp)
                work[parent] = -root
                parent = nextp
                nextp = -work[parent]
            end
            
        end
        
    end
    
    #       --------------------------------
    #       COMPUTE INVERSE PERMUTATION TOO.
    #       --------------------------------
    for jcol in oneto(neqns)
        invp[perm[jcol]] = jcol
    end
    
    return
end

module FlowCutterPACE17_jllExt

using CliqueTrees
using CliqueTrees: postorder, nov, readeo, writegr
using FlowCutterPACE17_jll
using Graphs

function CliqueTrees.permutation(weights::AbstractVector, graph::AbstractGraph, alg::FlowCutter)
    index = flowcutter(graph, alg.time, alg.seed)
    return invperm(index), index
end

function flowcutter(graph::AbstractGraph{V}, time::Int, seed::Int) where {V}
    @assert time >= 0
    @assert seed >= 0

    index = mktempdir() do tmp
        input = tmp * "/input.gr"
        output = tmp * "/output.td"

        open(input; write = true) do io
            writegr(io, graph)
        end

        execute = flow_cutter_pace17()
        command = `$execute -s $seed`
        process = run(pipeline(command; stdin = input, stdout = output); wait = false)

        while !process_running(process)
            sleep(1)
        end

        sleep(time)
        kill(process)
        return open(io -> readeo(io, V), output)
    end

    return index
end

end

"""
    AbstractTree{V} = Union{Tree{V}, SupernodeTree{V}, CliqueTree{V}}

A rooted forest. This type implements the [indexed tree interface](https://juliacollections.github.io/AbstractTrees.jl/stable/#The-Indexed-Tree-Interface).
"""
const AbstractTree{V} = Union{Tree{V}, SupernodeTree{V}, CliqueTree{V}}

function Base.show(io::IO, ::MIME"text/plain", tree::T) where {T <: AbstractTree}
    n = length(tree)
    println(io, "$n-element $T:")

    for (i, root) in enumerate(take(rootindices(tree), MAX_ITEMS_PRINTED + 1))
        if i <= MAX_ITEMS_PRINTED
            node = IndexNode(tree, root)

            for line in eachsplit(strip(repr_tree(node)), "\n")
                println(io, " $line")
            end
        else
            println(io, " ⋮")
        end
    end
    return
end

##########################
# Indexed Tree Interface #
##########################

"""
    rootindices(tree::AbstractTree)

Get the roots of a rooted forest.
"""
rootindices(tree::AbstractTree)

"""
    firstchildindex(tree::AbstractTree, i::Integer)

Get the first child of node `i`. Returns `nothing` if `i` is a leaf.
"""
firstchildindex(tree::AbstractTree, i::Integer)

"""
    ancestorindices(tree::AbstractTree, i::Integer)

Get the proper ancestors of node `i`.
"""
ancestorindices(tree::AbstractTree, i::Integer)

function AbstractTrees.ParentLinks(::Type{IndexNode{T, V}}) where {V, T <: AbstractTree{V}}
    return StoredParents()
end

function AbstractTrees.SiblingLinks(::Type{IndexNode{T, V}}) where {V, T <: AbstractTree{V}}
    return StoredSiblings()
end

function AbstractTrees.NodeType(::Type{IndexNode{T, V}}) where {V, T <: AbstractTree{V}}
    return HasNodeType()
end

function AbstractTrees.nodetype(::Type{IndexNode{T, V}}) where {V, T <: AbstractTree{V}}
    return IndexNode{T, V}
end

"""
    CliqueTree{V, E} <: AbstractVector{Clique{V, E}}

A rooted forest T = (V, E) and functions

       clique: V → 2ᵁ
    separator: V → 2ᵁ

This type implements the [indexed tree interface](https://juliacollections.github.io/AbstractTrees.jl/stable/#The-Indexed-Tree-Interface).
"""
struct CliqueTree{V, E} <: AbstractVector{Clique{V, E}}
    """
    The rooted forest T = (V, E).
    """
    tree::SupernodeTree{V}

    """
    A directed bipartite graph G = (U, V, E') with an arc

        (v, u) ∈ E'

    for all vertices v ∈ V and u ∈ separator(v).
    """
    graph::BipartiteGraph{V, E, FVector{E}, FVector{V}}

    function CliqueTree{V, E}(tree::SupernodeTree{V}, graph::BipartiteGraph{V, E}) where {V, E}
        @assert nv(residuals(tree)) == nv(graph)
        @assert nov(residuals(tree)) == nov(graph)
        return new{V, E}(tree, graph)
    end
end

function CliqueTree(tree::SupernodeTree{V}, graph::BipartiteGraph{V, E}) where {V, E}
    return CliqueTree{V, E}(tree, graph)
end

function Tree(tree::CliqueTree)
    return Tree(tree.tree)
end

"""
    cliquetree([weights, ]graph;
        alg::PermutationOrAlgorithm=DEFAULT_ELIMINATION_ALGORITHM,
        snd::SupernodeType=DEFAULT_SUPERNODE_TYPE)

Construct a tree decomposition of a simple graph.
The vertices of the graph are first ordered by a fill-reducing permutation computed by the algorithm `alg`.
The size of the resulting decomposition is determined by the supernode partition `snd`.

```julia-repl
julia> using CliqueTrees

julia> graph = [
           0 1 0 0 0 0 0 0
           1 0 1 0 0 1 0 0
           0 1 0 1 0 1 1 1
           0 0 1 0 0 0 0 0
           0 0 0 0 0 1 1 0
           0 1 1 0 1 0 0 0
           0 0 1 0 1 0 0 1
           0 0 1 0 0 0 1 0
       ];

julia> label, tree = cliquetree(graph);

julia> tree
6-element CliqueTree{Int64, Int64}:
 [6, 7, 8]
 └─ [5, 7, 8]
    ├─ [1, 5]
    ├─ [3, 5, 7]
    │  └─ [2, 3]
    └─ [4, 5, 8]
```
"""
function cliquetree(
        graph;
        alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM,
        snd::SupernodeType = DEFAULT_SUPERNODE_TYPE,
    )
    return cliquetree(graph, alg, snd)
end

function cliquetree(
        weights::AbstractVector,
        graph;
        alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM,
        snd::SupernodeType = DEFAULT_SUPERNODE_TYPE,
    )
    return cliquetree(weights, graph, alg, snd)
end

function cliquetree(graph, alg::PermutationOrAlgorithm, snd::SupernodeType)
    return cliquetree(BipartiteGraph(graph), alg, snd)
end

function cliquetree(graph::AbstractGraph{V}, alg::PermutationOrAlgorithm, snd::SupernodeType = Maximal()) where {V}
    n = nv(graph); weights = Ones{V}(n)
    return cliquetree(weights, graph, alg, snd)
end

function cliquetree(weights::AbstractVector, graph, alg::PermutationOrAlgorithm, snd::SupernodeType = Maximal())
    return cliquetree(weights, BipartiteGraph(graph), alg, snd)
end

function cliquetree(weights::AbstractVector, graph::AbstractGraph{V}, alg::PermutationOrAlgorithm, snd::SupernodeType = Maximal()) where {V}
    E = etype(graph); n = nv(graph); m = half(de(graph))
    nn = n + one(V); nnn = nn + one(V)
    
    target1 = FVector{V}(undef, max(m, nn))
    target2 = FVector{V}(undef, m)
    target3 = FVector{V}(undef, n)

    pointer1 = FVector{E}(undef, nn)
    pointer2 = FVector{E}(undef, nn)
    pointer3 = FVector{V}(undef, nnn)

    colcount = FVector{V}(undef, n)
    elmorder = FVector{V}(undef, n)
    elmindex = FVector{V}(undef, n)
    sndptr = FVector{V}(undef, nn)
    sepptr = FVector{E}(undef, nn)
    new = FVector{V}(undef, n)
    parent = FVector{V}(undef, n)
    elmtree = Parent{V}(n)

    order, index = permutation(weights, graph, alg)

    sndtree, upper, lower = supernodetree_impl!(target1, target2,
        target3, pointer1, pointer2, pointer3, colcount,
        elmorder, elmindex, sndptr, sepptr, new, parent, elmtree, graph,
        order, index, snd)

    h = last(sndtree.tree)
    k = sepptr[h + one(V)] - one(E)

    septgt = FVector{V}(undef, k)
    separator = BipartiteGraph(n, h, k, sepptr, septgt)

    clqtree = cliquetree_impl!(elmindex,
        upper, lower, separator, sndtree)

    return order, clqtree
end

function cliquetree_impl!(
        index::AbstractVector{V},
        target::BipartiteGraph{V, E},
        source::BipartiteGraph{V, E},
        separator::BipartiteGraph{V, E},
        sndtree::SupernodeTree{V},
    ) where {V, E}
    n = last(sndtree.tree)
    lower = sympermute!_impl!(target, source, index, Reverse)
    residual = residuals(sndtree); cache = index

    for j in oneto(n)
        pstrt = pointers(separator)[j]
        pstop = pointers(separator)[j + one(V)] 

        qstrt = pointers(residual)[j]
        qstop = pointers(residual)[j + one(V)]

        rstrt = pointers(lower)[qstrt]
        rstop = pointers(lower)[qstrt + one(V)]

        p = pstrt; r = rstrt
    
        while r < rstop && targets(lower)[r] < qstop
            r += one(E)
        end
    
        while r < rstop
            targets(separator)[p] = targets(lower)[r]; p += one(E)
            r += one(E)
        end 

        p1 = p 
 
        for i in childindices(sndtree, j)
            pstop1 = p1
            pstrt1 = pstrt

            pstop2 = pointers(separator)[i + one(V)]
            pstrt2 = pointers(separator)[i]
        
            p1 = pstrt1; p2 = pstrt2; t = one(V)

            while p2 < pstop2 && targets(separator)[p2] < qstop
                p2 += one(E)
            end

            while p1 < pstop1 && p2 < pstop2
                v1 = targets(separator)[p1]
                v2 = targets(separator)[p2]

                if v1 == v2
                    cache[t] = v1
                    p1 += one(E)
                    p2 += one(E)
                elseif v1 < v2
                    cache[t] = v1
                    p1 += one(E)
                else
                    cache[t] = v2
                    p2 += one(E)
                end

                t += one(V)
            end

            while p1 < pstop1
                cache[t] = targets(separator)[p1]
                p1 += one(E)
                t += one(V)
            end

            while p2 < pstop2
                cache[t] = targets(separator)[p2]
                p2 += one(E)
                t += one(V)
            end

            p1 = pstrt; tstop = t

            for t in oneto(tstop - one(V))
                targets(separator)[p1] = cache[t]
                p1 += one(E)
            end
        end
    end        

    return CliqueTree(sndtree, separator)
end

function cliquetree(tree::CliqueTree{V, E}, root::Integer) where {V, E}
    sep = separators(tree); h = nov(sep); n = nv(sep); m = ne(sep)
    perm = FVector{V}(undef, h)
    invp = FVector{V}(undef, h)

    newsep = BipartiteGraph{V, E, FVector{E}, FVector{V}}(h, n, m)
    p = m + one(E); pointers(newsep)[n + one(V)] = p

    newres = BipartiteGraph{V, E, FVector{E}, OneTo{V}}(h, n, h)
    q = h + one(V); pointers(newres)[n + one(V)] = q

    sndtree = copy(tree.tree.tree.tree)
    sndinvp = postorder!(setrootindex!(sndtree, root), root)
    sndperm = invperm(sndinvp)

    for v in oneto(h)
        invp[v] = zero(V)
    end

    for i in reverse(sndtree)
        ii = sndperm[i]; bag = tree[ii]

        for vv in Iterators.reverse(bag)
            v = invp[vv]

            if ispositive(v)
                p -= one(E); targets(newsep)[p] = v
            else
                q -= one(V); perm[q] = vv; invp[vv] = q
            end
        end

        pointers(newsep)[i] = p
        pointers(newres)[i] = q
    end

    revsep = BipartiteGraph{V, E, FVector{E}, FVector{V}}(n, h, m)
    reverse!(revsep, newsep)
    reverse!(newsep, revsep)

    newtree = CliqueTree(SupernodeTree(Tree(sndtree), newres), newsep)
    return collect(perm), newtree
end

function cliquetree(tree::CliqueTree{V, E}, clique::AbstractVector{V}) where {V, E}
    sep = separators(tree)
    res = residuals(tree)

    h = nov(sep)
    n = nv(sep)
    m = ne(sep)

    perm = FVector{V}(undef, h)
    invp = FVector{V}(undef, h)

    newsep = BipartiteGraph{V, E, FVector{E}, FVector{V}}(h, n, m)
    p = m + one(E); pointers(newsep)[n + one(V)] = p

    newres = BipartiteGraph{V, E, FVector{E}, OneTo{V}}(h, n, h)
    q = h + one(V); pointers(newres)[n + one(V)] = q

    for v in outvertices(sep)
        invp[v] = zero(V)
    end

    for v in Iterators.reverse(clique)
        q -= one(V); perm[q] = v; invp[v] = q
    end

    root = n

    for i in vertices(res)
        root < n && break

        for v in neighbors(res, i)
            root < n && break

            if ispositive(invp[v])
                root = i
            end
        end
    end

    sndtree = copy(tree.tree.tree.tree)
    sndinvp = postorder!(setrootindex!(sndtree, root), root)
    sndperm = invperm(sndinvp)

    rootbag = tree[sndperm[n]]

    for vv in Iterators.reverse(rootbag)
        if !ispositive(invp[vv])
            q -= one(V); perm[q] = vv; invp[vv] = q
        end
    end

    pointers(newsep)[n] = p
    pointers(newres)[n] = q

    for i in reverse(oneto(n - one(V)))
        ii = sndperm[i]; bag = tree[ii]

        for vv in Iterators.reverse(bag)
            v = invp[vv]

            if ispositive(v)
                p -= one(E); targets(newsep)[p] = v
            else
                q -= one(V); perm[q] = vv; invp[vv] = q
            end
        end

        pointers(newsep)[i] = p
        pointers(newres)[i] = q
    end

    revsep = BipartiteGraph{V, E, FVector{E}, FVector{V}}(n, h, m)
    reverse!(revsep, newsep)
    reverse!(newsep, revsep)

    newtree = CliqueTree(SupernodeTree(Tree(sndtree), newres), newsep)
    return collect(perm), newtree
end

function cliquetree!(tree::CliqueTree, root::Integer)
    perm, newtree = cliquetree(tree, root)
    copy!(tree, newtree)
    return perm
end

function cliquetree!(tree::CliqueTree, clique::AbstractVector)
    perm, newtree = cliquetree(tree, clique)
    copy!(tree, newtree)
    return perm
end

function atomtree(graph::AbstractGraph; alg::MinimalAlgorithm=DEFAULT_MINIMAL_ALGORITHM)
    return atomtree(graph, alg)
end

function atomtree(graph::AbstractGraph, alg::MinimalAlgorithm)
    return atomtree!(cliquetree(graph, alg)..., graph)
end

function atomtree!(order::AbstractVector{V}, tree::CliqueTree{V, E}, graph::AbstractGraph{V}) where {V, E}
    res = residuals(tree)
    sep = separators(tree)
    
    h = nov(sep); m = ne(sep); n = nv(sep)

    work1 = FVector{V}(undef, h)
    work2 = FVector{V}(undef, n)
    work3 = FVector{V}(undef, n)

    mark = FVector{V}(undef, h)
    prnt = FVector{V}(undef, n)
    proj = FVector{V}(undef, n)

    resptr = FVector{V}(undef, n + one(V))
    sepptr = FVector{E}(undef, n + one(V))
    septgt = FVector{V}(undef, m)

    for v in vertices(graph)
        mark[v] = n + one(V)
    end

    qode = zero(V)
    
    for node in reverse(oneto(n))
        flag = true; maxcnt = zero(V)
        
        for i in neighbors(sep, node)
            v = order[i]
            mark[v] = node; maxcnt += one(V)
        end

        for i in neighbors(sep, node)
            v = order[i]; cnt = maxcnt - one(V)

            for w in neighbors(graph, v)
                if w != v && mark[w] == node
                    cnt -= one(V)
                end
            end

            if ispositive(cnt)
                flag = false
                break
            end
        end

        npnt = parentindex(tree, node)

        if isnothing(npnt)
            spnt = zero(V)
        else
            spnt = abs(proj[npnt])
        end

        if flag
            proj[node] = qode += one(V)
            prnt[qode] = spnt
        else
            proj[node] = -spnt
        end
    end

    q = qode; qree = Parent(q, prnt)
    postorder!_impl!(work1, work2, mark, work3, qree)

    for node in oneto(n)
        qode = proj[node]

        if ispositive(qode)
            qode = mark[qode]
        else
            qode = -mark[-qode]
        end
            
        proj[node] = qode
    end

    for qode in oneto(q + one(V))
        resptr[qode] = zero(V)
    end

    sepptr[q + one(V)] = zero(E)

    for node in oneto(n)
        qode = proj[node]
        
        if ispositive(qode)
            sepptr[qode] = eltypedegree(sep, node)
        else
            qode = -qode
        end
        
        resptr[qode] += eltypedegree(res, node)
    end
    
    r = one(V)
    s = one(E)

    for qode in oneto(q + one(V))
        resptr[qode] = r += resptr[qode]
        sepptr[qode] = s += sepptr[qode]
    end

    for node in reverse(oneto(n))
        qode = proj[node]

        if ispositive(qode)
            s = sepptr[qode]

            for i in Iterators.reverse(neighbors(sep, node))
                s -= one(E); septgt[s] = mark[i]
            end

            sepptr[qode] = s
        else
            qode = -qode
        end

        r = resptr[qode]

        for i in reverse(neighbors(res, node))
            mark[i] = r -= one(E)
        end

        resptr[qode] = r
    end

    for i in oneto(h)
        work1[mark[i]] = order[i]
    end

    for i in oneto(h)
        order[i] = work1[i]
    end

    m = sepptr[q + one(V)] - one(E)
    qres = BipartiteGraph(h, q, h, resptr, oneto(h))
    qsep = BipartiteGraph(h, q, m, sepptr, septgt)
    atomtree = CliqueTree(SupernodeTree(Tree(qree), qres), qsep)
    return order, atomtree
end

"""
    treewidth([weights, ]tree::CliqueTree)

Compute the [width](https://en.wikipedia.org/wiki/Treewidth) of a clique tree.

```julia-repl
julia> using CliqueTrees

julia> graph = [
           0 1 0 0 0 0 0 0
           1 0 1 0 0 1 0 0
           0 1 0 1 0 1 1 1
           0 0 1 0 0 0 0 0
           0 0 0 0 0 1 1 0
           0 1 1 0 1 0 0 0
           0 0 1 0 1 0 0 1
           0 0 1 0 0 0 1 0
       ];

julia> label, tree = cliquetree(graph);

julia> treewidth(tree)
2
```

"""
function treewidth(tree::CliqueTree{V}) where {V}
    n = nov(residuals(tree)); weights = Ones{V}(n)
    width = treewidth(weights, tree)
    return width - one(V)
end

function treewidth(weights::AbstractVector{W}, tree::CliqueTree{V}) where {W, V}
    maxwidth = zero(W)

    for clique in tree
        width = zero(W)

        for v in clique
            width += weights[v]
        end

        maxwidth = max(maxwidth, width)
    end

    return maxwidth
end

function treewidth(weights::Ones{W}, tree::CliqueTree) where {W}
    residual = residuals(tree)
    separator = separators(tree)
    width = zero(W)

    @inbounds for i in vertices(residual)
        nn = convert(W, outdegree(residual, i))
        na = convert(W, outdegree(separator, i))
        width = max(width, nn + na)
    end

    return width
end

"""
    treewidth([weights, ]graph;
        alg::PermutationOrAlgorithm=DEFAULT_ELIMINATION_ALGORITHM)

Compute the [width](https://en.wikipedia.org/wiki/Treewidth) induced by an elimination
algorithm.

```julia-repl
julia> using CliqueTrees, TreeWidthSolver

julia> graph = [
           0 1 0 0 0 0 0 0
           1 0 1 0 0 1 0 0
           0 1 0 1 0 1 1 1
           0 0 1 0 0 0 0 0
           0 0 0 0 0 1 1 0
           0 1 1 0 1 0 0 0
           0 0 1 0 1 0 0 1
           0 0 1 0 0 0 1 0
       ];

julia> treewidth(graph; alg=MCS())
3

julia> treewidth(graph; alg=BT()) # exact treewidth
2
```
"""
function treewidth(graph; alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM)
    return treewidth(graph, alg)
end

function treewidth(graph, alg::PermutationOrAlgorithm)
    return treewidth(BipartiteGraph(graph), alg)
end

function treewidth(graph::AbstractGraph{V}, alg::PermutationOrAlgorithm) where {V}
    n = nv(graph); weights = Ones{V}(n)
    width = treewidth(weights, graph, alg)
    return width - one(V)
end

function treewidth(weights::AbstractVector, graph; alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM)
    return treewidth(weights, graph, alg)
end

function treewidth(weights::AbstractVector, graph, alg::PermutationOrAlgorithm)
    return treewidth(weights, BipartiteGraph(graph), alg)
end

function treewidth(weights::AbstractVector{W}, graph::AbstractGraph{V}, alg::PermutationOrAlgorithm) where {W, V}
    E = etype(graph); m = half(de(graph)); n = nv(graph)
    order, index = permutation(weights, graph, alg)

    lower = BipartiteGraph{V, E}(n, n, m)
    upper = BipartiteGraph{V, E}(n, n, m)
    tree = Parent{V}(n)
    sets = UnionFind{V}(n)
    
    wwork0 = FVector{W}(undef, n)
    wwork1 = FVector{W}(undef, n)
    vwork0 = FVector{V}(undef, n)
    vwork1 = FVector{V}(undef, n)
    vwork2 = FVector{V}(undef, n)
    vwork3 = FVector{V}(undef, n)
    vwork4 = FVector{V}(undef, n)
    vwork5 = FVector{V}(undef, n)
    
    width = treewidth_impl!(lower, upper, tree, sets, wwork0, wwork1, vwork0,
        vwork1, vwork2, vwork3, vwork4, vwork5, weights, graph, index)

    return width
end

function treewidth_impl!(
        lower::BipartiteGraph{V, E},
        upper::BipartiteGraph{V, E},
        tree::Parent{V},
        sets::UnionFind{V},
        wwork0::AbstractVector{W},
        wwork1::AbstractVector{W},
        vwork0::AbstractVector{V},
        vwork1::AbstractVector{V},
        vwork2::AbstractVector{V},
        vwork3::AbstractVector{V},
        vwork4::AbstractVector{V},
        vwork5::AbstractVector{V},
        weights::AbstractVector{W},
        graph::AbstractGraph{V},
        index::AbstractVector{V},
    ) where {W, V, E}
    @assert nv(graph) <= length(weights)
    @assert nv(graph) <= length(wwork1)
    
    @inbounds for v in vertices(graph)
        wwork1[index[v]] = weights[v]
    end
    
    sympermute!_impl!(upper, graph, index, Forward)
    reverse!_impl!(lower, upper)
    etree_impl!(tree, vwork0, upper)
    
    supcnt_impl!(wwork0, vwork0, vwork1, vwork2, vwork3,
        vwork4, vwork5, sets, wwork1, lower, tree)

    width = zero(W)

    @inbounds for v in vertices(lower)
        width = max(width, wwork0[v])
    end

    return width
end

function bestwidth(weights::AbstractVector{W}, graph::AbstractGraph{V}, algs::NTuple{<:Any, PermutationOrAlgorithm}) where {W, V}
    E = etype(graph); m = de(graph); n = nv(graph)
    
    pairs = map(algs) do alg
        return permutation(weights, graph, alg)
    end

    indices = map(pairs) do (order, index)
        return index
    end

    lower = BipartiteGraph{V, E}(n, n, m)
    upper = BipartiteGraph{V, E}(n, n, m)
    tree = Parent{V}(n)
    sets = UnionFind{V}(n)

    wwork0 = FVector{W}(undef, n)
    wwork1 = FVector{W}(undef, n)
    vwork0 = FVector{V}(undef, n)
    vwork1 = FVector{V}(undef, n)
    vwork2 = FVector{V}(undef, n)
    vwork3 = FVector{V}(undef, n)
    vwork4 = FVector{V}(undef, n)
    vwork5 = FVector{V}(undef, n)

    index = bestwidth_impl!(lower, upper, tree, sets, wwork0, wwork1, vwork0,
        vwork1, vwork2, vwork3, vwork4, vwork5, weights, graph, indices)

    return pairs[index]
end

function bestwidth_impl!(
        lower::BipartiteGraph{V, E},
        upper::BipartiteGraph{V, E},
        tree::Parent{V},
        sets::UnionFind{V},
        wwork0::AbstractVector{W},
        wwork1::AbstractVector{W},
        vwork0::AbstractVector{V},
        vwork1::AbstractVector{V},
        vwork2::AbstractVector{V},
        vwork3::AbstractVector{V},
        vwork4::AbstractVector{V},
        vwork5::AbstractVector{V},
        weights::AbstractVector{W},
        graph::AbstractGraph{V},
        indices::NTuple{N, AbstractVector{V}},
    ) where {W, V, E, N}

    minindex = zero(N); minwidth = typemax(W)

    for index in oneto(N)
        width = treewidth_impl!(lower, upper, tree, sets, wwork0, wwork1, vwork0,
            vwork1, vwork2, vwork3, vwork4, vwork5, weights, graph, indices[index])

        if width < minwidth
            minindex, minwidth = index, width
        end
    end

    return minindex
end

function treefill(tree::CliqueTree{<:Any, E}) where {E}
    n = nov(residuals(tree)); weights = Ones{E}(n)
    fill = treefill(weights, tree)
    return fill - convert(E, n)
end

function treefill(weights::AbstractVector{W}, tree::CliqueTree) where {W}
    fill = zero(W)

    @inbounds for bag in tree
        res = residual(bag)

        for vv in bag
            ww = weights[vv]

            for v in res
                v > vv && break
                w = weights[v]
                fill += ww * w
            end
        end
    end

    return fill
end

function treefill(weights::Ones{W}, tree::CliqueTree) where {W}
    residual = residuals(tree)
    separator = separators(tree)
    fill = zero(W)

    @inbounds for i in vertices(residual)
        nn = convert(W, outdegree(residual, i))
        na = convert(W, outdegree(separator, i))
        fill += half(nn * (nn + one(I))) + nn * na
    end

    return fill
end

function treefill(graph; alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM)
    return treefill(graph, alg)
end

function treefill(graph, alg::PermutationOrAlgorithm)
    return treefill(BipartiteGraph(graph), alg)
end

function treefill(graph::AbstractGraph, alg::PermutationOrAlgorithm)
    E = etype(graph); n = nv(graph); weights = Ones{E}(n)
    fill = treefill(weights, graph, alg)
    return fill - convert(E, n)
end

function treefill(weights::AbstractVector, graph; alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM)
    return treefill(weights, graph, alg)
end

function treefill(weights::AbstractVector, graph, alg::PermutationOrAlgorithm)
    return treefill(weights, BipartiteGraph(graph), alg)
end

function treefill(weights::AbstractVector{W}, graph::AbstractGraph{V}, alg::PermutationOrAlgorithm) where {W, V}
    E = etype(graph); m = de(graph); n = nv(graph)
    order, index = permutation(weights, graph, alg)
    
    lower = BipartiteGraph{V, E}(n, n, m)
    upper = BipartiteGraph{V, E}(n, n, m)
    tree = Parent{V}(n)
    sets = UnionFind{V}(n)
    
    wwork0 = FVector{W}(undef, n)
    wwork1 = FVector{W}(undef, n)
    vwork0 = FVector{V}(undef, n)
    vwork1 = FVector{V}(undef, n)
    vwork2 = FVector{V}(undef, n)
    vwork3 = FVector{V}(undef, n)
    vwork4 = FVector{V}(undef, n)
    vwork5 = FVector{V}(undef, n)
    
    fill = treefill_impl!(lower, upper, tree, sets, wwork0, wwork1, vwork0,
        vwork1, vwork2, vwork3, vwork4, vwork5, weights, graph, index)

    return fill
end

function treefill_impl!(
        lower::BipartiteGraph{V, E},
        upper::BipartiteGraph{V, E},
        tree::Parent{V},
        sets::UnionFind{V},
        wwork0::AbstractVector{W},
        wwork1::AbstractVector{W},
        vwork0::AbstractVector{V},
        vwork1::AbstractVector{V},
        vwork2::AbstractVector{V},
        vwork3::AbstractVector{V},
        vwork4::AbstractVector{V},
        vwork5::AbstractVector{V},
        weights::AbstractVector{W},
        graph::AbstractGraph{V},
        index::AbstractVector{V},
    ) where {W, V, E}
    @assert nv(graph) <= length(weights)
    @assert nv(graph) <= length(wwork1)
    
    @inbounds for v in vertices(graph)
        wwork1[index[v]] = weights[v]
    end
    
    sympermute!_impl!(upper, graph, index, Forward)
    reverse!_impl!(lower, upper)
    etree_impl!(tree, vwork0, upper)
    
    supcnt_impl!(wwork0, vwork0, vwork1, vwork2, vwork3,
        vwork4, vwork5, sets, wwork1, lower, tree)
    
    fill = zero(W)

    @inbounds for v in vertices(lower)
        fill += wwork1[v] * wwork0[v]
    end

    return fill
end

function bestfill(weights::AbstractVector{W}, graph::AbstractGraph{V}, algs::NTuple{<:Any, PermutationOrAlgorithm}) where {W, V}
    E = etype(graph); m = de(graph); n = nv(graph)
    
    pairs = map(algs) do alg
        return permutation(weights, graph, alg)
    end

    indices = map(pairs) do (order, index)
        return index
    end

    lower = BipartiteGraph{V, E}(n, n, m)
    upper = BipartiteGraph{V, E}(n, n, m)
    tree = Parent{V}(n)
    sets = UnionFind{V}(n)

    wwork0 = FVector{W}(undef, n)
    wwork1 = FVector{W}(undef, n)
    vwork0 = FVector{V}(undef, n)
    vwork1 = FVector{V}(undef, n)
    vwork2 = FVector{V}(undef, n)
    vwork3 = FVector{V}(undef, n)
    vwork4 = FVector{V}(undef, n)
    vwork5 = FVector{V}(undef, n)

    index = bestfill_impl!(lower, upper, tree, sets, wwork0, wwork1, vwork0,
        vwork1, vwork2, vwork3, vwork4, vwork5, weights, graph, indices)

    return pairs[index]
end

function bestfill_impl!(
        lower::BipartiteGraph{V, E},
        upper::BipartiteGraph{V, E},
        tree::Parent{V},
        sets::UnionFind{V},
        wwork0::AbstractVector{W},
        wwork1::AbstractVector{W},
        vwork0::AbstractVector{V},
        vwork1::AbstractVector{V},
        vwork2::AbstractVector{V},
        vwork3::AbstractVector{V},
        vwork4::AbstractVector{V},
        vwork5::AbstractVector{V},
        weights::AbstractVector{W},
        graph::AbstractGraph{V},
        indices::NTuple{N, AbstractVector{V}},
    ) where {W, V, E, N}

    minindex = zero(N); minfill = typemax(W)

    for index in oneto(N)
        fill = treefill_impl!(lower, upper, tree, sets, wwork0, wwork1, vwork0,
            vwork1, vwork2, vwork3, vwork4, vwork5, weights, graph, indices[index])

        if fill < minfill
            minindex, minfill = index, fill
        end
    end

    return minindex
end

function separatorwidth(tree::CliqueTree{V}) where {V}
    n = nov(residuals(tree)); weights = Ones{V}(n)
    return separatorwidth(weights, tree)
end

function separatorwidth(weights::AbstractVector{W}, tree::CliqueTree) where {W}
    maxwidth = zero(W)

    @inbounds for bag in tree
        width = zero(W)

        for v in separator(bag)
            width += weights[v]
        end

        maxwidth = max(maxwidth, width)
    end

    return maxwidth
end

function separatorwidth(weights::Ones{W}, tree::CliqueTree) where {W}
    maxwidth = zero(W)

    @inbounds for bag in tree
        width = convert(W, length(separator(bag)))
        maxwidth = max(maxwidth, width)
    end

    return maxwidth
end

function separatorwidth(graph; alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM, snd::SupernodeType = DEFAULT_SUPERNODE_TYPE)
    return separatorwidth(graph, alg, snd)
end

function separatorwidth(graph, alg::PermutationOrAlgorithm, snd::SupernodeType)
    perm, tree = cliquetree(graph, alg, snd)
    return separatorwidth(tree)
end

function separatorwidth(weights::AbstractVector, graph; alg::PermutationOrAlgorithm = DEFAULT_ELIMINATION_ALGORITHM, snd::SupernodeType = DEFAULT_SUPERNODE_TYPE)
    return separatorwidth(weights, graph, alg, snd)
end

function separatorwidth(weights::AbstractVector, graph, alg::PermutationOrAlgorithm, snd::SupernodeType)
    perm, tree = cliquetree(graph, alg, snd)
    return separatorwidth(weights[perm], tree)
end

"""
    residual(tree::CliqueTree, i::Integer)

Get the residual at node `i`.
"""
function residual(tree::CliqueTree, i::Integer)
    return tree.tree[i]
end

"""
    separator(tree::CliqueTree, i::Integer)

Get the separator at node `i`.
"""
function separator(tree::CliqueTree, i::Integer)
    return neighbors(separators(tree), i)
end

"""
    residuals(tree::CliqueTree)

Get the residuals of a clique tree.
"""
function residuals(tree::CliqueTree)
    return residuals(tree.tree)
end

"""
    separators(tree::CliqueTree)

Get the separators of a clique tree.
"""
function separators(tree::CliqueTree)
    return tree.graph
end

function Base.copy(tree::CliqueTree)
    return CliqueTree(copy(tree.tree), copy(tree.graph))
end

function Base.copy!(dst::CliqueTree, src::CliqueTree)
    copy!(dst.tree, src.tree)
    copy!(dst.graph, src.graph)
    return dst
end

function Base.:(==)(left::CliqueTree, right::CliqueTree)
    return left.tree == right.tree && left.graph == right.graph
end

##########################
# Indexed Tree Interface #
##########################

function AbstractTrees.rootindex(tree::CliqueTree)
    return rootindex(tree.tree)
end

function AbstractTrees.parentindex(tree::CliqueTree, i::Integer)
    return parentindex(tree.tree, i)
end

function rootindices(tree::CliqueTree)
    return rootindices(tree.tree)
end

function AbstractTrees.childindices(tree::CliqueTree, i::Integer)
    return childindices(tree.tree, i)
end

function ancestorindices(tree::CliqueTree, i::Integer)
    return ancestorindices(tree.tree, i)
end

#############################
# Abstract Vector Interface #
#############################

function Base.getindex(tree::CliqueTree, i::Integer)
    return Clique(residual(tree, i), separator(tree, i))
end

function Base.IndexStyle(::Type{<:CliqueTree})
    return IndexLinear()
end

function Base.size(tree::CliqueTree)
    return size(tree.tree)
end

struct SinglyLinkedList{I, Head <: AbstractScalar{I}, Next <: AbstractVector{I}} <: AbstractLinkedList{I}
    head::Head
    next::Next
end

function SinglyLinkedList{I}(n::Integer) where {I}
    head = FScalar{I}(undef)
    next = FVector{I}(undef, n)
    
    head[] = zero(I)
    return SinglyLinkedList(head, next)
end

@propagate_inbounds function Base.pushfirst!(list::SinglyLinkedList, i::Integer)
    @boundscheck checkbounds(list.next, i)
    @inbounds list.next[i] = list.head[]
    @inbounds list.head[] = i
    return list
end

@propagate_inbounds function Base.prepend!(list::SinglyLinkedList{I}, v::AbstractVector) where {I}
    if !isempty(v)
        @inbounds i = v[begin]
        @inbounds h = list.head[]
        @inbounds list.head[] = i

        for j in @view v[begin + 1:end]
            @boundscheck checkbounds(list.next, j)
            @inbounds list.next[i] = j
            i = j
        end

        @inbounds list.next[i] = h
    end

    return list
end

# Stubs for Krylov extension
function cg!(args...)
    error("`import Krylov` to use function `complete`.")
end

function cgworkspace(args...)
    error("`import Krylov` to use function `complete`.")
end

function cgsolution(args...)
    error("`import Krylov` to use function `complete`.")
end

"""
    ChordalCholesky{UPLO, T, I, Val} <: Factorization{T}

A Cholesky decomposition of a sparse positive-definite matrix ``A``:

```math
    P A P^\\mathsf{T} = L L^\\mathsf{T}.
```

where ``P`` is a permutation matrix and ``L`` is lower triangular.
The type parameter `UPLO` specifies which triangular factor is
stored.

   - `UPLO`: `:L` or `:U` (lower / upper triangular)

### Fields

   - `F.P`: permutation matrix
   - `F.L`: lower triangular factor
   - `F.U`: upper triangular factor
   - `F.S`: symbolic factorization

"""
struct ChordalCholesky{UPLO, T, I, Val <: AbstractVector{T}, Prm <: AbstractVector{I}} <: Factorization{T}
    S::ChordalSymbolic{I}
    Dval::Val
    Lval::Val
    perm::Prm
    invp::Prm
    info::FScalar{I}
end

const FChordalCholesky{UPLO, T, I} = ChordalCholesky{UPLO, T, I, FVector{T}, FVector{I}}

function ChordalCholesky{UPLO}(S::ChordalSymbolic{I}, Dval::Val, Lval::Val, perm::Prm, invp::Prm, info::FScalar{I}) where {UPLO, I <: Integer, T, Val <: AbstractVector{T}, Prm <: AbstractVector{I}}
    return ChordalCholesky{UPLO, T, I, Val, Prm}(S, Dval, Lval, perm, invp, info)
end

function ChordalCholesky{UPLO, T}(perm::Prm, S::ChordalSymbolic{I}) where {UPLO, T, I <: Integer, Prm <: AbstractVector{I}}
    n = nv(S.res)
    Dval = FVector{T}(undef, S.Dptr[n + one(I)] - one(I))
    Lval = FVector{T}(undef, S.Lptr[n + one(I)] - one(I))
    info = FScalar{I}(undef); info[] = zero(I)
    invp = similar(perm)

    @inbounds for i in eachindex(perm)
        invp[perm[i]] = i
    end

    return ChordalCholesky{UPLO}(S, Dval, Lval, perm, invp, info)
end

"""
    ChordalCholesky(A::AbstractMatrix; check=true)

Construct a Cholesky factorization object from a positive-definite matrix `A`.
Perform the factorization using the function [`cholesky!`](@ref).

### Arguments

- `check`: check if `A` is symmetric

"""
function ChordalCholesky(A::AbstractMatrix; kw...)
    return ChordalCholesky{:L}(A; kw...)
end

function ChordalCholesky(A::AbstractMatrix, perm::AbstractVector, S::ChordalSymbolic)
    return ChordalCholesky{:L}(A, perm, S)
end

function ChordalCholesky{UPLO}(A::AbstractMatrix; kw...) where {UPLO}
    return ChordalCholesky{UPLO}(sparse(A); kw...)
end

function ChordalCholesky{UPLO}(A::AbstractMatrix, perm::AbstractVector, S::ChordalSymbolic) where {UPLO}
    return ChordalCholesky{UPLO}(sparse(A), perm, S)
end

function ChordalCholesky{UPLO}(A::SparseMatrixCSC; check::Bool=true, kw...) where {UPLO}
    if !check || ishermitian(A)
        perm, S = symbolic(A; check=false, kw...)
        return ChordalCholesky{UPLO}(Hermitian(A, UPLO), perm, S)
    elseif istril(A)
        return ChordalCholesky{UPLO}(Hermitian(A, :L); kw...)
    elseif istriu(A)
        return ChordalCholesky{UPLO}(Hermitian(A, :U); kw...)
    end

    error()
end

function ChordalCholesky{UPLO}(A::HermOrSym; kw...) where {UPLO}
    perm, S = symbolic(A; kw...)
    return ChordalCholesky{UPLO}(A, perm, S)
end

"""
    ChordalCholesky(A::AbstractMatrix, perm::AbstractVector, S::ChordalSymbolic)

Construct a Cholesky factorization object from a positive-definite matrix `A`.
Perform the factorization using the function [`cholesky!`](@ref).
"""
function ChordalCholesky{UPLO}(A::AbstractMatrix{T}, perm::Prm, S::ChordalSymbolic{I}) where {UPLO, T, I <: Integer, Prm <: AbstractVector{I}}
    return copy!(ChordalCholesky{UPLO, T}(perm, S), A)
end

function ChordalCholesky{UPLO}(A::AbstractMatrix{T}, perm::Prm, S::ChordalSymbolic{I}) where {UPLO, T <: Integer, I <: Integer, Prm <: AbstractVector{I}}
    R = float(T)
    return ChordalCholesky{UPLO}(convert(AbstractMatrix{R}, A), perm, S)
end

function Base.propertynames(::ChordalCholesky)
    return (:L, :U, :P, :S, :Dval, :Lval, :perm, :invp, :info)
end

function Base.getproperty(F::ChordalCholesky{UPLO}, d::Symbol) where {UPLO}
    if d === :P
        return Permutation(getfield(F, :perm))
    elseif d === :L || d === :U
        A = ChordalTriangular(F)

        if d === UPLO
            return A
        else
            return A'
        end
    else
        return getfield(F, d)
    end
end

function Base.show(io::IO, F::T) where {T <: ChordalCholesky}
    n = size(F, 1)
    print(io, "$n×$n $T with $(nnz(F)) stored entries")
    return
end

function Base.show(io::IO, ::MIME"text/plain", F::T) where {UPLO, T <: ChordalCholesky{UPLO}}
    n = size(F, 1)
    println(io, "$n×$n $T with $(nnz(F)) stored entries:")

    if n < 16
        print_matrix(io, ChordalTriangular(F))
    else
        showsymbolic(io, F.S, Val(UPLO))
    end

    return
end

function Base.copy(F::ChordalCholesky{UPLO, T, I, Val, Prm}) where {UPLO, T, I, Val, Prm}
    return ChordalCholesky{UPLO, T, I, Val, Prm}(F.S, copy(F.Dval), copy(F.Lval), copy(F.perm), copy(F.invp), copy(F.info))
end

function Base.copy!(F::ChordalCholesky{UPLO}, A::SparseMatrixCSC; check::Bool=true) where {UPLO}
    if !check || ishermitian(A)
        return copy!(F, Hermitian(A, UPLO))
    elseif istril(A)
        return copy!(F, Hermitian(A, :L))
    elseif istriu(A)
        return copy!(F, Hermitian(A, :U))
    end

    error()
end

function Base.copy!(F::ChordalCholesky{UPLO}, A::HermOrSym; check::Bool=true) where {UPLO}
    if UPLO === :L
        B = sympermute(parent(A), F.invp, A.uplo, 'U')
    else
        B = sympermute(parent(A), F.invp, A.uplo, 'L')
    end

    copy!(ChordalTriangular(F), copy(adjoint(B)))
    return F
end

function Base.fill!(F::ChordalCholesky, x)
    fill!(ChordalTriangular(F), x)
    return F
end

function flatindices(F::ChordalCholesky{UPLO}, A::SparseMatrixCSC; check::Bool=true) where {UPLO}
    if !check || ishermitian(A)
        return flatindices(F, Hermitian(A, UPLO))
    elseif istril(A)
        return flatindices(F, Hermitian(A, :L))
    elseif istriu(A)
        return flatindices(F, Hermitian(A, :U))
    end

    error()
end

function flatindices(F::ChordalCholesky{UPLO, T, I}, A::HermOrSym; check::Bool=true) where {UPLO, T, I}
    m = convert(I, nnz(parent(A)))
    colptr = parent(A).colptr
    rowval = parent(A).rowval
    nzval = collect(oneto(m))
    B = SparseMatrixCSC(size(A)..., colptr, rowval, nzval)

    if UPLO === :L
        B = sympermute(B, F.invp, A.uplo, 'U')
    else
        B = sympermute(B, F.invp, A.uplo, 'L')
    end

    C = copy(adjoint(B)); P = flatindices(ChordalTriangular(F), C)
    fill!(nzval, zero(I))

    for (i, j) in zip(nonzeros(C), P)
        nzval[i] = j
    end

    return nzval
end

function getflatindex(F::ChordalCholesky, p::Integer)
    return getflatindex(ChordalTriangular(F), p)
end

function setflatindex!(F::ChordalCholesky, x, p::Integer)
    setflatindex!(ChordalTriangular(F), x, p)
    return F
end

# ===== Abstract Matrix Interface =====

function SparseArrays.nnz(F::ChordalCholesky)
    return nnz(F.S)
end

function Base.size(F::ChordalCholesky)
    return size(F.S)
end

function Base.size(F::ChordalCholesky, args...)
    return size(F.S, args...)
end

function Base.axes(F::ChordalCholesky, args...)
    return axes(F.S, args...)
end

function LinearAlgebra.isposdef(F::ChordalCholesky)
    return iszero(F.info[])
end

function LinearAlgebra.issuccess(F::ChordalCholesky)
    return iszero(F.info[])
end

function LinearAlgebra.rank(F::ChordalCholesky; kw...)
    return rank(F.L; kw...)
end

function Base.adjoint(F::ChordalCholesky)
    return F
end

function LinearAlgebra.det(F::ChordalCholesky)
    return det(F.L)^2
end

function LinearAlgebra.logdet(F::ChordalCholesky)
    return 2logdet(F.L)
end

function LinearAlgebra.logabsdet(F::ChordalCholesky{UPLO, T}) where {UPLO, T}
    return (2logdet(F.L), one(T))
end

#**********************************************************************
#**********************************************************************
#*****   ELMCLQ ..... NEW ELIMINATION CLIQUE   ************************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       THIS SUBROUTINE COMPUTES THE NEW ELIMINATION CLIQUE THAT WILL 
#       BE CREATED BY THE ELIMINATION OF ENODE.
#
#       NOTES:
#         THIS ROUTINE ONLY COMPUTES ENODE'S NEW ELIMINATION CLIQUE
#         (IN A WORK VECTOR ECLIQ(*)).  IT DOES NOT PERFORM THE 
#         QUOTIENT GRAPH TRANSFORMATION DUE TO ENODE'S ELIMINATION.
#         THAT TRANSFORMATION IS PERFORMED LATER BY ROUTINE ELMTRA.F.
#
#     INPUT PARAMETERS:
#       ENODE       - NODE TO BE ELIMINATED.
#       NEQNS       - NUMBER OF EQUATIONS.
#       ADJLEN      - LENGTH OF THE ADJACENCY STRUCTURE (ADJNCY(*)).
#                     IDEALLY SHOULD BE AT LEAST NEQNS GREATER THAN
#                     THE INITIAL VALUE STORED IN XADJ(NEQNS+1)-1.
#       XADJ(*)     - ARRAY OF LENGTH NEQNS+1, CONTAINING POINTERS
#                     FOR THE QUOTIENT GRAPH.
#       ADJNCY(*)   - ARRAY OF LENGTH ADJLEN, CONTAINING THE
#                     QUOTIENT GRAPH.
#       NVTXS(*)    - ARRAY OF LENGTH NEQNS.
#                       ACTIVE ELIMINATED:  NUMBER OF VERTICES IN
#                                           THE ELIMINATION CLIQUE.
#                       MERGED ELIMINATED:  -1.
#                       UNELIMINATED:       NUMBER OF UNELIMINATED
#                                           VERTEX NEIGHBORS IN
#                                           CURRENT QUOTIENT GRAPH.
#                       ABSORBED:           -1.
#       WORK(*)     - ARRAY OF LENGTH NEQNS.
#                       ACTIVE ELIMINATED:  >=0, NOT USED AT THIS
#                                           POINT FOR THESE NODES.
#                       UNELIMINATED:       NUMBER OF ELIMINATION
#                                           CLIQUES VERTEX IS
#                                           ADJACENT TO IN THE
#                                           QUOTIENT GRAPH.
#                       ABSORBED:           MAPS ABSORBED VERTEX
#                                           TO MINUS THE ABSORBING
#                                           VERTEX
#                                           (I.E., -ABSORBEE).
#
#     MODIFIED PARAMETERS:
#       QSIZE(*)    - ARRAY OF SIZE NEQNS.
#                       ELIMINATED:   NOT USED AT THIS POINT.
#                       UNELIMINATED AND NOT IN ENODE'S ELIMINATION
#                         CLIQUE:     SUPERNODE SIZE.
#                       UNELIMINATED AND IN ENODE'S ELIMINATION
#                         CLIQUE:     NEGATIVE OF SUPERNODE SIZE.
#                                     CHANGED BACK AT END OF THE
#                                     QUOTIENT GRAPH TRANSFORMATION
#                                     (ELMTRA).
#                       ABSORBED:     0.
#       CHANGED(*)  - ARRAY OF SIZE NEQNS.
#                     ON INPUT, VALUE IS -1 FOR EVERY ACTIVE VERTEX
#                     IN THE QUOTIENT GRAPH.
#                     ASSIGNED THE VALUE 1 IN THIS ROUTINE FOR EVERY
#                     VERTEX IN THE ELIMINATION CLIQUE BECAUSE ITS
#                     DEFICIENCY VALUE POTENTIALLY CHANGES.
#
#     OUTPUT PARAMETERS:
#       CLQSIZ      - ACTUAL SIZE OF THE CLIQUE GENERATED BY
#                     ENODE'S ELIMINATION.
#       FNODE       - POINTER TO FIRST SUPERNODE IN ENODE'S
#                     ELIMINATION CLIQUE MERGED INTO THE CLIQUE
#                     AFTER THE NODES OF QUOTIENT GRAPH NEIGHBOR
#                     C = CSTOP.
#       NNODES      - NUMBER OF SUPERNODES IN ENODE'S ELIMINATION 
#                     CLIQUE.
#       ECLIQ(*)    - ARRAY OF LENGTH NEQNS, CONTAINS ENODE'S  
#                     ELIMINATION CLIQUE.
#
#**********************************************************************
#
function elmclq(
        enode::V,
        neqns::V,
        adjlen::E,
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
        nvtxs::AbstractVector{V},
        work::AbstractVector{V},
        qsize::AbstractVector{W},
        changed::AbstractVector{Bool},
        ecliq::AbstractVector{V},
    ) where {V, E, W}
    
    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    
    #       -----------------------------------------------------------
    #       MARK ENODE SO IT WILL NOT APPEAR IN QUOTIENT GRAPH LISTS
    #       WHEN THE ELIMINATION GRAPH TRANSFORMATION IS COMPUTED LATER
    #       IN THE ELMTRA ROUTINE.
    #       -----------------------------------------------------------
    qsize[enode] = -qsize[enode]
    
    #       ****************************************
    #       FORM NEW ELIMINATION CLIQUE IN ECLIQ(*).
    #       ****************************************
    
    clqsiz = zero(W)
    
    #       ***********************************************
    #       MERGE ELIMINATION CLIQUES CONTAINING ENODE INTO 
    #       ENODE'S ELIMINATION CLIQUE.
    #       ***********************************************
    #       ------------------------------------------------------------
    #       FOR EACH ELIMINATION CLIQUE CNODE TO WHICH ENODE BELONGS ...
    #       ------------------------------------------------------------
    
    cstart = xadj[enode] + convert(E, nvtxs[enode])
    cstop = cstart + convert(E, work[enode]) - one(E)
    ipnt = zero(V)
    fnode = one(V)

    for c in reverse(cstart:cstop)
        cnode = adjncy[c]
        jstart = xadj[cnode]
        jstop = jstart + convert(E, nvtxs[cnode]) - one(E)
        #           ---------------------------------------------
        #           ... FOR EACH VERTEX JNODE IN CLIQUE CNODE ...
        #           ---------------------------------------------
        for j in jstart:jstop
            jnode = adjncy[j]
            #               ------------------------------------------------
            #               ... IF JNODE HAS NOT YET BEEN ADDED TO ENODE'S
            #               ELIMINATION CLIQUE AND HAS NOT BEEN ABSORBED ...
            #               ------------------------------------------------
            if ispositive(qsize[jnode])
                #                   ----------------------------------------
                #                   ADD JNODE TO ENODE'S ELIMINATION CLIQUE.
                #                   ----------------------------------------
                ipnt += one(V)
                ecliq[ipnt] = jnode
                clqsiz += qsize[jnode]
                qsize[jnode] = -qsize[jnode]
                #                   -----------------------------------
                #                   MARK JNODE'S DEFICIENCY AS CHANGED.
                #                   -----------------------------------
                changed[jnode] = true
            end
        end
        #           --------------------------------------------------
        #           RECORD THE LOCATION OF THE FIRST NODE THAT WILL BE
        #           INSERTED INTO ENODE'S ELIMINATION CLIQUE AFTER THE
        #           NODES OF CLIQUE CSTOP HAVE BEEN INTRODUCED.
        #           --------------------------------------------------
        if c == cstop
            fnode = max(fnode, ipnt + one(V))
        end
    end

    #       ******************************************************
    #       PUT VERTEX NEIGHBORS OF ENODE INTO ENODE'S ELIMINATION
    #       CLIQUE.
    #       ******************************************************
    #       ----------------------------------------------
    #       COPY ENODE'S VERTICES INTO ENODE'S NEW CLIQUE.
    #       ----------------------------------------------
    jstart = xadj[enode]
    jstop = jstart + convert(E, nvtxs[enode]) - one(E)
    #       ------------------------------------------------
    #       ... FOR EACH VERTEX JNODE IN THE VERTEX LIST ...
    #       ------------------------------------------------
    for j in jstart:jstop
        jnode = adjncy[j]
        #           --------------------------------------
        #           ... IF JNODE HAS NOT BEEN ABSORBED ...
        #           --------------------------------------
        if !iszero(qsize[jnode])
            #               ----------------------------------------
            #               ADD JNODE TO ENODE'S ELIMINATION CLIQUE.
            #               ----------------------------------------
            ipnt += one(V)
            ecliq[ipnt] = jnode
            clqsiz += qsize[jnode]
            qsize[jnode] = -qsize[jnode]
            #               -----------------------------------
            #               MARK JNODE'S DEFICIENCY AS CHANGED.
            #               -----------------------------------
            changed[jnode] = true
        end
    end
    
    #       ----------------------------------------------------------------
    #       RECORD THE NUMBER OF (SUPER)NODES IN ENODE'S ELIMINATION CLIQUE.
    #       ----------------------------------------------------------------
    nnodes = ipnt
    
    return clqsiz, fnode, nnodes
end

module KrylovExt

using CliqueTrees
using CliqueTrees.Multifrontal
using Krylov
using LinearAlgebra

function CliqueTrees.Multifrontal.cgworkspace(::Type{T}, n::Integer) where {T}
    return Krylov.CgWorkspace(n, n, CliqueTrees.FVector{T})
end

function CliqueTrees.Multifrontal.cgsolution(workspace::Krylov.CgWorkspace)
    return workspace.x
end

function CliqueTrees.Multifrontal.cg!(
        workspace::Krylov.CgWorkspace{T},
        H,
        b::AbstractVector{T},
        prec::AbstractVector{T},
        rtol::Real,
        itmax::Int,
    ) where {T}
    M = Diagonal(prec)
    Krylov.cg!(workspace, H, b; M, rtol, itmax, ldiv=true)
    return workspace
end

end

#= A collection of routines to find an MMD (multiple minimum degree) ordering.
   Written by Erik Demaine, eddemaine@uwaterloo.ca
   Based on a Fortran 77 code written by Joseph Liu.
   For information on the minimum degree algorithm see the articles:
   The evolution of the minimum degree algorithm by Alan George and
   Joseph Liu, SIAM Rev. 31 pp. 1 - 19, 1989.0
   Modification of the minimum degree algorithm by multiple
   elimination, ACM Trans. Math. Soft. 2 pp.141 - 152, 1985
=#

module MMDLib

using Base: oneto
using FillArrays
using ..Utilities

export mmd

function mmd(neqns::V, xadj::AbstractVector, adjncy::AbstractVector{V}; kwargs...) where {V}
    vwght = Ones{V}(neqns)
    return mmd(neqns, vwght, xadj, adjncy; kwargs...)
end

function mmd(neqns::V, vwght::AbstractVector, xadj::AbstractVector, adjncy::AbstractVector{V}; kwargs...) where {V}
    @assert neqns <= length(vwght)
    newvwght = FVector{V}(undef, neqns)

    @inbounds for node in oneto(neqns)
        newvwght[node] = trunc(V, vwght[node])
    end

    return mmd(neqns, newvwght, xadj, adjncy; kwargs...)
end

function mmd(neqns::V, vwght::AbstractVector{V}, xadj::AbstractVector{E}, adjncy::AbstractVector{V}; delta::Integer = 0) where {V, E}
    @assert neqns <= length(vwght)
    @assert neqns < length(xadj)
    @inbounds nnz = xadj[neqns + one(V)] - one(E)
    total = zero(V)

    @inbounds for node in oneto(neqns)
        total += vwght[node]
    end

    marker = FVector{Int}(undef, neqns)
    needsupdate = FVector{V}(undef, neqns)
    supersize = FVector{V}(undef, neqns)
    superwght = FVector{V}(undef, neqns)
    elimnext = FVector{V}(undef, neqns)
    deghead = FVector{V}(undef, total)
    degnext = FVector{V}(undef, neqns)
    degprev = FVector{V}(undef, neqns)
    newadjncy = FVector{V}(undef, nnz)

    mmd_impl!(marker, needsupdate, supersize,
        superwght, elimnext, deghead, degnext, degprev, newadjncy,
        total, neqns, convert(V, delta), vwght, xadj, adjncy)

    return convert(Vector{V}, degnext)
end

function mmd_impl!(
        marker::AbstractVector{I},
        needsupdate::AbstractVector{V},
        supersize::AbstractVector{V},
        superwght::AbstractVector{V},
        elimnext::AbstractVector{V},
        deghead::AbstractVector{V},
        degnext::AbstractVector{V},
        degprev::AbstractVector{V},
        newadjncy::AbstractVector{V},
        total::V,
        neqns::V,
        delta::V,
        vwght::AbstractVector{V},
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
    ) where {I, V, E}
    @assert neqns < length(xadj)
    @inbounds nnz = xadj[neqns + one(V)] - one(E)

    @inbounds for i in oneto(nnz)
        newadjncy[i] = adjncy[i]
    end

    mmd!_impl!(
        marker, needsupdate, supersize,
        superwght, elimnext, deghead, degnext, degprev, total,
        neqns, convert(V, delta), vwght, xadj, newadjncy)

    return degnext
end

"""
    mmd!(neqns, xadj, adjncy, delta)

This routine implements the minimum degree algorithm. It makes use of the
implicit representation of elimination graphs by quotient graphs, and the
notion of indistinguishable nodes. It also implements the modifications by
multiple elimination and minimum external degree.

input parameters:

  - `neqns`: number of equations
  - `(xadj, adjncy)`: adjacency structure
  - `delta`: tolerance value for multiple elimination

output parameters:

  - `degnext`: the minimum degree ordering (repurposed from degree list links)

working arrays:

  - `deghead`: points to first node with degree deg, or 0 if there
    are no such nodes
  - `degnext`: during algorithm, points to the next node in the degree list
    or stores negative values for eliminated/merged nodes.
    After algorithm, stores the final ordering.
  - `degprev`: points to the previous node in a degree list
    associated with node, or the negative of the degree of
    node (if node was the last in the degree list), or 0
    if the node is not in the degree lists
  - `supersize`: the size of the supernodes (0 means merged into another)
  - `elimhead`: points to the first node eliminated in the current pass
  - `elimnext`: points to the next node in a eliminated supernode
    or 0 if there are no more after node
  - `marker`: a temporary marker vector
  - `needsupdate`: positive iff node needs a degree update (0 otherwise)
"""
function mmd!_impl!(
        marker::AbstractVector{I},
        needsupdate::AbstractVector{V},
        supersize::AbstractVector{V},
        superwght::AbstractVector{V},
        elimnext::AbstractVector{V},
        deghead::AbstractVector{V},
        degnext::AbstractVector{V},
        degprev::AbstractVector{V},
        total::V,
        neqns::V,
        delta::V,
        vwght::AbstractVector{V},
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
    ) where {I, V, E}
    @assert neqns <= length(marker)
    @assert neqns <= length(needsupdate)
    @assert neqns <= length(supersize)
    @assert neqns <= length(superwght)
    @assert neqns <= length(elimnext)
    @assert total <= length(deghead)
    @assert neqns <= length(degnext)
    @assert neqns <= length(degprev)
    @assert neqns <= length(vwght)
    @assert neqns < length(xadj)

    # initialization for the minimum degree algorithm.
    @inbounds for node in oneto(neqns)
        degnext[node] = zero(V)
        marker[node] = zero(I)
        needsupdate[node] = zero(V)
        supersize[node] = one(V)
        superwght[node] = vwght[node]
        elimnext[node] = zero(V)
    end

    @inbounds for node in oneto(total)
        deghead[node] = zero(V)
    end

    # - `mindeg` is the current minimum degree
    # - `num` counts the number of ordered nodes plus 1
    # - `tag` is used to facilitate marking nodes
    mindeg = total; num = one(V); tag = one(I)

    @inbounds for node in oneto(neqns)
        istart = xadj[node]; istop = xadj[node + one(V)] - one(E)

        if istart <= istop
            ndeg = one(V)

            for i in istart:istop
                ndeg += vwght[adjncy[i]]
            end

            fnode = deghead[ndeg]
            deghead[ndeg] = node
            degnext[node] = fnode

            if ispositive(fnode)
                degprev[fnode] = node
            end

            degprev[node] = -ndeg
            mindeg = min(mindeg, ndeg)
        else
            # eliminate isolated node
            marker[node] = maxint(I)
            degnext[node] = -num; num += one(V)
        end
    end

    @inbounds while num <= neqns
        while !ispositive(deghead[mindeg])
            mindeg += one(V)
        end

        # use value of `delta` to set up `mindeglimit`, which governs
        # when a degree update is to be performed.
        mindeglimit = max(mindeg, mindeg + delta)
        elimhead = zero(V)

        while true
            mdnode = deghead[mindeg]

            while !ispositive(mdnode)
                mindeg += one(V)

                if mindeg > mindeglimit
                    @goto pass
                end

                mdnode = deghead[mindeg]
            end

            # remove `mdnode` from the degree structure.
            mdnextnode = degnext[mdnode]
            deghead[mindeg] = mdnextnode

            if ispositive(mdnextnode)
                degprev[mdnextnode] = -mindeg
            end

            degnext[mdnode] = -num

            if num + supersize[mdnode] > neqns
                @goto main
            end

            # eliminate `mdnode` and perform quotient graph
            # transformation (reset `tag` value if necessary)
            tag += one(I)

            if tag >= maxint(I)
                tag = one(I)

                for node in oneto(neqns)
                    if marker[node] < maxint(I)
                        marker[node] = zero(I)
                    end
                end
            end

            mmdelim!(mdnode, xadj, adjncy, deghead, degnext, degprev,
                supersize, superwght, elimnext, marker, tag,
                needsupdate)

            num += supersize[mdnode]
            elimnext[mdnode] = elimhead
            elimhead = mdnode
        end

        @label pass

        # update degrees of the nodes involved in the
        # minimum degree node's elimination
        if num > neqns
            @goto main
        end

        mindeg, tag = mmdupdate!(neqns, elimhead, vwght, xadj, adjncy,
            delta, mindeg, deghead, degnext, degprev, supersize, superwght,
            elimnext, marker, tag, needsupdate)
    end

    @label main

    mmdnumber!(neqns, supersize, degnext)

    return degnext
end

"""
    mmdelim!(mdnode, xadj, adjncy, deghead, degnext, degprev, supersize, elimnext, marker, tag, needsupdate)

This routine eliminates the node mdnode of
minimum degree from the adjacency structure, which
is stored in the quotient Graph format. It also
transforms the quotient Graph representation of the
elimination graph.

input parameters:

  - `mdnode`: node of minimum degree
  - `tag`: tag value

updated parameters:

  - `(xadj, adjncy)`: updated adjacency structure
  - `deghead`: points to first node with degree deg, or 0 if there
    are no such nodes
  - `degnext`: points to the next node in the degree list
    associated with node, or negative if eliminated/merged
  - `degprev`: points to the previous node in a degree list
    associated with node, or the negative of the degree of
    node (if node was the last in the degree list), or 0
    if the node is not in the degree lists
  - `supersize`: the size of the supernodes (0 means merged)
  - `elimnext`: points to the next node in a eliminated supernode
    or 0 if there are no more after node
  - `marker`: a temporary marker vector
  - `needsupdate`: positive iff the node needs a degree update (0 otherwise)
"""
function mmdelim!(
        mdnode::V,
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
        deghead::AbstractVector{V},
        degnext::AbstractVector{V},
        degprev::AbstractVector{V},
        supersize::AbstractVector{V},
        superwght::AbstractVector{V},
        elimnext::AbstractVector{V},
        marker::AbstractVector{I},
        tag::I,
        needsupdate::AbstractVector{V},
    ) where {I, V, E}
    # find reachable set and place in data structure
    @inbounds marker[mdnode] = tag

    # - `elmnt` points to the beginning of the list of eliminated
    #   neighbors of `mdnode`
    # - `rloc` gives the storage location
    #   for the next reachable node.
    elmnt = zero(V)
    @inbounds rloc = xadj[mdnode]; rlmt = xadj[mdnode + one(V)] - one(E)

    @inbounds for i in rloc:rlmt
        neighbor = adjncy[i]

        if iszero(neighbor)
            break
        end

        if marker[neighbor] < tag
            marker[neighbor] = tag

            if !isnegative(degnext[neighbor])
                adjncy[rloc] = neighbor
                rloc += one(E)
            else
                elimnext[neighbor] = elmnt
                elmnt = neighbor
            end
        end
    end

    # merge with reachable nodes from generalized elements
    @inbounds while ispositive(elmnt)
        adjncy[rlmt] = -elmnt
        j = xadj[elmnt]; jstop = xadj[elmnt + one(V)]
        node = adjncy[j]

        while !iszero(node)
            if node < zero(V)
                j = xadj[-node]; jstop = xadj[one(V) - node]
            else
                if marker[node] < tag && !isnegative(degnext[node])
                    marker[node] = tag

                    # use storage from eliminated nodes
                    # if necessary.
                    while rloc >= rlmt
                        link = -adjncy[rlmt]
                        rloc = xadj[link]; rlmt = xadj[link + one(V)] - one(E)
                    end

                    adjncy[rloc] = node; rloc += one(E)
                end

                j += one(E)
            end

            if j >= jstop
                break
            end

            node = adjncy[j]
        end

        elmnt = elimnext[elmnt]
    end

    if rloc <= rlmt
        @inbounds adjncy[rloc] = zero(V)
    end

    # for each node in the reachable set, do the following...
    @inbounds i = xadj[mdnode]; istop = xadj[mdnode + one(V)]
    @inbounds rnode = adjncy[i]

    @inbounds while !iszero(rnode)
        if isnegative(rnode)
            i = xadj[-rnode]; istop = xadj[one(V) - rnode]
        else
            # if `rnode` is in the degree list structure...
            pvnode = degprev[rnode]

            if !iszero(pvnode)
                # then remove `rnode` from the structure
                nxnode = degnext[rnode]

                if ispositive(nxnode)
                    degprev[nxnode] = pvnode
                end

                if ispositive(pvnode)
                    degnext[pvnode] = nxnode
                else
                    deghead[-pvnode] = nxnode
                end
            end

            # purge inactive quotient neighbors of `rnode`
            xqnbr = xadj[rnode]

            for j in xadj[rnode]:(xadj[rnode + one(V)] - one(E))
                neighbor = adjncy[j]

                if iszero(neighbor)
                    break
                end

                if marker[neighbor] < tag
                    adjncy[xqnbr] = neighbor; xqnbr += one(E)
                end
            end

            # if no active neighbor after the purging...
            nqnbrs = convert(V, xqnbr - xadj[rnode])

            if !ispositive(nqnbrs)
                # then merge `rnode` with `mdnode`
                supersize[mdnode] += supersize[rnode]; supersize[rnode] = zero(V)
                superwght[mdnode] += superwght[rnode]; superwght[rnode] = zero(V)
                degnext[rnode] = -mdnode
                marker[rnode] = maxint(I)
            else
                # else flag `rnode` for degree update, and
                # add `mdnode` as a neighbor of `rnode`
                needsupdate[rnode] = nqnbrs + one(V)
                adjncy[xqnbr] = mdnode; xqnbr += one(E)

                if xqnbr < xadj[rnode + one(V)]
                    adjncy[xqnbr] = zero(V)
                end
            end

            degprev[rnode] = zero(V)
            i += one(E)
        end

        if i >= istop
            break
        end

        rnode = adjncy[i]
    end

    return
end

"""
    mmdupdate!(neqns, elimhead, vwght, xadj, adjncy, delta, mindeg, deghead, degnext, degprev, supersize, elimnext, marker, tag, needsupdate)

This routine updates the degrees of nodes
after a multiple elimination step.

input parameters:

  - `elimhead`: the beginning of the list of eliminated
    nodes (i.e. newly formed elements)
  - `neqns`: number of equations
  - `(xadj, adjncy)`: adjacency structure
  - `delta`: tolerance value for multiple elimination

updated parameters:

  - `mindeg`: new minimum degree after degree update
  - `deghead`: points to first node with degree deg, or 0 if there
    are no such nodes
  - `degnext`: points to the next node in the degree list
    associated with node, or negative if eliminated/merged
  - `degprev`: points to the previous node in a degree list
    associated with node, or the negative of the degree of
    node (if node was the last in the degree list), or 0
    if the node is not in the degree lists
  - `supersize`: the size of the supernodes (0 means merged)
  - `elimnext`: points to the next node in a eliminated supernode
    or 0 if there are no more after node
  - `marker`: marker vector for degree update
  - `tag`: tag value
  - `needsupdate`: positive iff node needs update (0 otherwise)
"""
function mmdupdate!(
        neqns::V,
        elimhead::V,
        vwght::AbstractVector{V},
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
        delta::V,
        mindeg::V,
        deghead::AbstractVector{V},
        degnext::AbstractVector{V},
        degprev::AbstractVector{V},
        supersize::AbstractVector{V},
        superwght::AbstractVector{V},
        elimnext::AbstractVector{V},
        marker::AbstractVector{I},
        tag::I,
        needsupdate::AbstractVector{V},
    ) where {I, V, E}
    mindeglimit = mindeg + delta
    elimnode = elimhead

    # for each of the newly formed element, do the following
    # (reset `tag` value if necessary)
    @inbounds while ispositive(elimnode)
        mtag = tag + convert(I, mindeglimit)

        if mtag >= maxint(I)
            tag = one(I)
            mtag = tag + convert(I, mindeglimit)

            for node in oneto(neqns)
                if marker[node] < maxint(I)
                    marker[node] = zero(I)
                end
            end
        end

        # create two linked lists from nodes associated
        # with `elmnt`: one with two neighbors (`q2head`) in
        # adjacency structure, and the other with more
        # than two neighbors (`qxhead`)
        #
        # also compute `elimwght`, weight of the nodes in this element
        q2head = qxhead = zero(V); elimwght = zero(V)
        i = xadj[elimnode]; istop = xadj[elimnode + one(V)]
        enode = adjncy[i]

        while !iszero(enode)
            if isnegative(enode)
                i = xadj[-enode]; istop = xadj[one(V) - enode]
            else
                if !iszero(supersize[enode])
                    elimwght += superwght[enode]
                    marker[enode] = mtag

                    # if `enode` requires a degree update,
                    # then do the following
                    if ispositive(needsupdate[enode])
                        # place either in `qxhead` or `q2head` lists
                        if !istwo(needsupdate[enode])
                            elimnext[enode] = qxhead; qxhead = enode
                        else
                            elimnext[enode] = q2head; q2head = enode
                        end
                    end
                end

                i += one(E)
            end

            if i >= istop
                break
            end

            enode = adjncy[i]
        end

        # For each enode in q2 list, do the following.
        enode = q2head

        while ispositive(enode)
            if ispositive(needsupdate[enode])
                tag += one(I)
                deg = elimwght + one(V)

                # identify the other adjacent element neighbor
                istart = xadj[enode]
                neighbor = adjncy[istart]

                if neighbor == elimnode
                    neighbor = adjncy[istart + one(E)]
                end

                # if neighbor is uneliminated, increase degree count
                if !isnegative(degnext[neighbor])
                    deg += superwght[neighbor]
                else
                    # otherwise, for each node in the 2nd element,
                    # do the following.
                    i = xadj[neighbor]
                    istop = xadj[neighbor + one(V)]
                    node = adjncy[i]

                    while !iszero(node)
                        if isnegative(node)
                            i = xadj[-node]
                            istop = xadj[one(V) - node]
                        else
                            if node != enode && !iszero(supersize[node])
                                if marker[node] < tag
                                    # case when `node` is not yet considered
                                    marker[node] = tag
                                    deg += superwght[node]
                                elseif ispositive(needsupdate[node])
                                    # case when `node` is indistinguishable from
                                    # `enode`
                                    #
                                    # merge them into a new supernode
                                    if istwo(needsupdate[node])
                                        supersize[enode] += supersize[node]; supersize[node] = zero(V)
                                        superwght[enode] += superwght[node]; superwght[node] = zero(V)
                                        marker[node] = maxint(I)
                                        degnext[node] = -enode
                                    end

                                    needsupdate[node] = zero(V)
                                    degprev[node] = zero(V)
                                end
                            end

                            i += one(E)
                        end

                        if i >= istop
                            break
                        end

                        node = adjncy[i]
                    end
                end

                deg, mindeg = updateexternaldegree!(deg, mindeg, enode,
                    superwght, deghead, degnext, degprev, needsupdate)
            end

            enode = elimnext[enode]
        end

        # for each `enode` in the qx list, do the following.
        enode = qxhead

        while ispositive(enode)
            if ispositive(needsupdate[enode])
                tag += one(I)
                deg = elimwght + one(V)

                # for each unmarked neighbor of `enode`,
                # do the following.
                for i in xadj[enode]:(xadj[enode + one(V)] - one(E))
                    neighbor = adjncy[i]

                    if iszero(neighbor)
                        break
                    end

                    if marker[neighbor] < tag
                        marker[neighbor] = tag

                        # if uneliminated, include it in
                        # degree count
                        if !isnegative(degnext[neighbor])
                            deg += superwght[neighbor]
                        else
                            # if eliminated, include unmarked
                            # nodes in this element into the
                            # degree count
                            j = xadj[neighbor]; jstop = xadj[neighbor + one(V)]
                            node = adjncy[j]

                            while !iszero(node)
                                if isnegative(node)
                                    j = xadj[-node]; jstop = xadj[one(V) - node]
                                else
                                    if marker[node] < tag
                                        marker[node] = tag
                                        deg += superwght[node]
                                    end

                                    j += one(E)
                                end

                                if j >= jstop
                                    break
                                end

                                node = adjncy[j]
                            end
                        end
                    end
                end

                # update external degree of `enode` in degree
                # structure, and `mindeg` if necessary
                deg, mindeg = updateexternaldegree!(deg, mindeg, enode,
                    superwght, deghead, degnext, degprev, needsupdate)
            end

            # get next `enode` in current element.
            enode = elimnext[enode]
        end

        # get next element in the list.
        tag = mtag
        elimnode = elimnext[elimnode]
    end

    return mindeg, tag
end

function updateexternaldegree!(
        deg::V,
        mindeg::V,
        enode::V,
        superwght::AbstractVector{V},
        deghead::AbstractVector{V},
        degnext::AbstractVector{V},
        degprev::AbstractVector{V},
        needsupdate::AbstractVector{V},
    ) where {V}
    @inbounds deg -= superwght[enode]
    @inbounds firstnode = deghead[deg]
    @inbounds deghead[deg] = enode
    @inbounds degnext[enode] = firstnode
    @inbounds degprev[enode] = -deg
    @inbounds needsupdate[enode] = zero(V)

    if ispositive(firstnode)
        @inbounds degprev[firstnode] = enode
    end

    return deg, min(deg, mindeg)
end

"""
    mmdnumber!(neqns, supersize, degnext)

This routine performs the final step in
producing the permutation and inverse permutation
vectors in the multiple elimination version of the
minimum degree ordering algorithm.

input parameters:

  - `neqns`: number of equations
  - `supersize`: size of supernodes (>0 for principals, 0 for merged)

updated parameters:

  - `degnext`: on input, stores -ordering for principals, -parent for merged.
    on output, stores the final positive ordering for all nodes.
"""
function mmdnumber!(neqns::V, supersize::AbstractVector{V}, degnext::AbstractVector{V}) where {V}
    # first pass: convert principals to positive ordering
    # and do path compression for merged nodes.
    # we repurpose `supersize` as `mergelastnum` for principals.
    @inbounds for node in oneto(neqns)
        if ispositive(supersize[node])
            # principal: negate to get positive ordering
            # and use `supersize` as `mergelastnum`
            supersize[node] = degnext[node] = -degnext[node]
        else
            # merged node: trace to `root` and compress path
            root = -degnext[node]

            while iszero(supersize[root])
                root = -degnext[root]
            end

            # path compression: point all nodes on path to `root`
            while node != root
                next = -degnext[node]
                degnext[node] = -root
                node = next
            end
        end
    end

    # second pass: assign orderings
    # all merged nodes now point directly to `root`
    @inbounds for node in oneto(neqns)
        if iszero(supersize[node])
            root = -degnext[node]
            degnext[node] = supersize[root] += one(V)
        end
    end

    return
end

function maxint(::Type{I}) where {I}
    return typemax(I) - convert(I, 100000)
end

end

#**********************************************************************
#**********************************************************************
#*****   MOD_HEAP ... REBUILD A HEAP AFTER A NODE HAS BEEN   **********
#*****                MODIFIED                               **********
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       MOD_HEAP MODIFIES AN ELEMENT IN A HEAP AND REBUILDS THE HEAP.
#
#       EACH ELEMENT HAS TWO FIELDS: (WEIGHT,VERTEX).  THE VERTEX
#       FIELD REFERS TO A VERTEX AND THE WEIGHT FIELD REFERS TO A
#       WEIGHT ASSOCIATED WITH THE VERETEX.  THE VERTICES ARE ASSUMED
#       TO BE UNIQUE INTEGERS FROM 1 TO N.  THE HEAP IS CONSTRUCTED
#       USING THE WEIGHTS.  THE WEIGHT OF A GIVEN VERTEX IS TO BE
#       MODIFIED.
#     
#     INPUT PARAMETERS:
#       HEAPSIZE    - IT IS THE NUMBER OF ELEMENTS IN HEAP.
#       VTX         - THE ELEMENT WITH VERTEX = VTX IS TO BE
#                     MODIFED. 
#       WT          - THE NEW WEIGHT OF THE ELEMENT WITH
#                     VERTEX = VTX.
#
#     MODIFIED PARAMETERS:
#       HEAP(*)     - IT IS AN ARRAY OF SIZE 2*HEAPSIZE.  ON INPUT,
#                     IT CONTAINS A SET OF NODES THAT ARE IN A HEAP,
#                     WITH HEAP(2*K-1) CONTAINING THE WEIGHT OF NODE
#                     K AND HEAP(2*K) CONTAINING THE CORRESPONDING
#                     VERTEX.  ON OUTPUT, THE NODES ARE REARRANGED
#                     TO FORM A HEAP.
#       V2HEAP(*)   - V2HEAP IS A MAPPING OF THE VERTICES TO
#                     THE NODES IN HEAP.
#
#**********************************************************************
#
function mod_heap(heap::AbstractVector{W}, heapsize::V, v2heap::AbstractVector{V}, vtx::V, wt::W) where {V, W}
    
    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    
    #       ---------------------------------------------------
    #       GET THE LOCATION OF THE NODE CONTAINING VERTEX VTX.
    #       ---------------------------------------------------
    i = v2heap[vtx]
    
    #       -----------------------------------------------------
    #       MODIFY THE WEIGHT FIELD OF ELEMENT WITH VERTEX = VTX.
    #       -----------------------------------------------------
    heap[twice(i) - one(V)] = wt
    
    #       ------------------------------------------------------
    #       HEAP MAY NO LONGER BE A HEAP AFTER THE WEIGHT FIELD OF
    #       AN ELEMENT IS MODIFIED.  IT HAS TO BE REBUILT INTO A
    #       HEAP.
    #       ------------------------------------------------------
    
    if ispositive(i - one(V))
        #           ----------------------------------------------------
        #           THE MODIFIED ELEMENT IS NOT AT THE TOP OF THE BIANRY
        #           TREE, SO IT HAS A PARENT, GIVEN BY I/2.
        #           ----------------------------------------------------
        p = half(i)

        if heap[twice(p) - one(V)] > wt
            #               ------------------------------------------------
            #               THE WEIGHT FIELD OF THE PARENT IS LARGER THAN THE
            #               WEIGHT OF THE MODIFIED ELEMENT, SO THE MODIFIED
            #               ELEMENT HAS TO BE MOVED UP THE BINARY TREE TO
            #               REBUILD THE HEAP.
            #               ------------------------------------------------
            move_up(heap, heapsize, i, v2heap)
            return
        end
    end
    
    #       -------------------------------------------------------
    #       EITHER THE MODIFIED ELEMENT IS AT THE TOP OF THE BINARY
    #       TREE (WITH I = 1), OR ITS WEIGHT FIELD IS LESS THAN OR
    #       EQUAL TO THE WEIGHT FIELD OF THE PARENT IN THE BINARY
    #       TREE.
    #
    #       THE BINARY TREE ROOTED AT THE MODIFIED ELEMENT MAY NOT
    #       BE A HEAP ANYMORE.  IT MAY BE NECESSARY TO REBUILD THE
    #       HEAP BY TRAVERSING DOWN THE BINARY TREE, STARTING FROM
    #       THE MODIFIED ELEMENT.
    #       -------------------------------------------------------
    move_down(heap, heapsize, i, v2heap)
    
    return
end

module Multifrontal

using AbstractTrees
using Base: oneto, OneTo, print_matrix, replace_with_centered_mark, isstored, promote_eltype
using Base.Threads: @threads, maxthreadid, nthreads, threadid
using FillArrays: Ones, Zeros, AbstractFill, AbstractZeros, AbstractZerosVector, AbstractZerosMatrix
using Graphs
using LinearAlgebra
using LinearAlgebra: Adjoint, Transpose, AdjOrTrans, HermOrSym, BlasFloat, BlasComplex, Factorization, LAPACK, BLAS, PivotingStrategy, RowMaximum, BlasInt, checksquare, chkstride1, require_one_based_indexing, givensAlgorithm, AbstractTriangular, axpby!
using Random
using Random: rand!
using SparseArrays
using SparseArrays: getcolptr

import ..BipartiteGraph, ..CliqueTree, ..FArray, ..FMatrix, ..FScalar, ..FVector, ..Scalar, ..Tree,
    ..incident, ..nov, ..ne, ..nv, ..outvertices, ..vertices, ..neighbors, ..pointers, ..targets,
    ..eltypedegree, ..etype, ..residual, ..half, ..ispositive, ..isnegative, ..two, ..twice,
    ..cliquetree, ..residuals, ..separators, ..childindices, ..AbstractScalar, ..DEFAULT_ELIMINATION_ALGORITHM

export ChordalSymbolic
export ChordalCholesky, FChordalCholesky
export ChordalLDLt, FChordalLDLt
export ChordalTriangular, FChordalTriangular
export DenseCholesky, DenseLDLt
export DenseCholeskyPivoted, DenseLDLtPivoted
export DynamicRegularization, GMW81, SE99
export Permutation, FPermutation
export symbolic
export selinv!
export amari!

const THRESHOLD = 64
const DEFAULT_UPLO = :L
const TransVec = Transpose{<:Any, <:AbstractVector}
const AdjVec = Adjoint{<:Any, <:AbstractVector}
const IOnes{T} = Ones{T, 1, Tuple{OneTo{Int}}}

const HermSparse{T, I} = Hermitian{T, SparseMatrixCSC{T, I}}
const SymSparse{T, I} = Symmetric{T, SparseMatrixCSC{T, I}}
const HermOrSymSparse{T, I} = Union{HermSparse{T, I}, SymSparse{T, I}}
const MaybeHermOrSymSparse{T, I} = Union{SparseMatrixCSC{T, I}, HermOrSymSparse{T, I}}

include("permutation.jl")
include("chordal_symbolic.jl")
include("abstract_factorization.jl")
include("chordal_factorization.jl")
include("chordal_triangular.jl")
include("regularization.jl")
include("cholesky.jl")
include("cholesky_pivoted.jl")
include("cholesky_se99.jl")
include("cholesky_pivoted_se99.jl")
include("utils.jl")
include("operator.jl")
include("blas.jl")
include("divide.jl")
include("multiply.jl")
include("add.jl")
include("selinv.jl")
include("complete.jl")
include("complete_dense.jl")
include("uncholesky.jl")
include("dense/dense.jl")
include("fisherroot.jl")
include("fisher.jl")
include("amari.jl")
include("lowrank.jl")
include("krylov.jl")
include("complete_generic.jl")
include("nullspace.jl")
if Base.USE_GPL_LIBS
    include("cholmod.jl")
end

include("Differential.jl/src/Differential.jl")

using .Differential

end # module Multifrontal

function pidbt(weights::AbstractVector{Int}, g::Graphs.AbstractGraph, min_k::Int=0)
    n = convert(Int, Graphs.nv(g))
    S = settype(n)
    return _pidbt(S, weights, g, min_k)
end

function _pidbt(::Type{PSet}, weights::AbstractVector{Int}, g::Graphs.AbstractGraph{V}, min_k::Int) where {V, PSet <: AbstractPackedSet}
    @assert all(weights .> 0)
    n = convert(Int, Graphs.nv(g))

    # Sort vertices by weight (increasing order)
    # perm[new_index] = old_index
    perm = sortperm(weights)
    old_to_new = invperm(perm)

    # Build graph and sorted weights
    mg = Graph{PSet}(n)
    sorted_weights = Vector{Int}(undef, domain(PSet))

    for new_v in 1:n
        old_v = perm[new_v]
        sorted_weights[new_v] = weights[old_v]

        s = PSet()
        for old_u in Graphs.neighbors(g, old_v)
            old_u == old_v && continue
            s = s ∪ old_to_new[old_u]
        end
        mg.neighbors[new_v] = s
    end

    (tw, (pool, root)) = treewidth(sorted_weights, mg; min_k = max(0, min_k - 1))

    # Map elimination ordering back to original indices
    sorted_ordering = _elimination_ordering(pool, root)
    return convert(Vector{V}, perm[sorted_ordering])
end

function _elimination_ordering(pool::PTDPool{PSet}, root::Int) where {PSet}
    ordering = Int[]
    _postorder!(ordering, pool, root, PSet())
    return ordering
end

function _postorder!(ordering::Vector{Int}, pool::PTDPool{PSet}, node::Int, parent_bag::PSet) where {PSet}
    B = bag(pool[node])
    for p in incident(pool, node)
        _postorder!(ordering, pool, target(pool, p), B)
    end
    for v in setdiff(B, parent_bag)
        push!(ordering, v)
    end
end

#-----------------------#
# dissection algorithms #
#-----------------------#

package(::Type{<:METISND}) = "Metis"
package(::Type{<:KaHyParND}) = "KaHyPar"

#------------------------#
# elimination algorithms #
#------------------------#

package(::Type{<:METIS}) = "Metis"
package(::Type{<:AMD}) = "AMD"
package(::Type{<:SymAMD}) = "AMD"
package(::Type{<:Spectral}) = "Laplacians"
package(::Type{<:FlowCutter}) = "FlowCutterPACE17_jll"
package(::Type{<:BT}) = "TreeWidthSolver"

function package(::Type{<:ND{<:Any, <:Any, D}}) where D
    return package(D)
end

module Differential

using LinearAlgebra
using LinearAlgebra: lmul!, axpy!, ldiv!, rdiv!, Hermitian, HermOrSym
using SparseArrays: SparseMatrixCSC, rowvals, nonzeros
using Base: AbstractVecOrMat

using ...Multifrontal
using ...Multifrontal: HermOrSymTri, HermOrSymSparse, HermSparse, SymSparse, ChordalCholesky, ChordalTriangular, Permutation
using ...Multifrontal: fisher!, selinv!, triangular, project, diagblock, fronts, selaxpy!

export selinv, symdot

include("utils.jl")
include("selinv.jl")
include("logdet.jl")
include("divide.jl")

end

# ===== pstrf_pivot! =====

function pstrf_pivot!(uplo::Val, A::AbstractMatrix{T}, D::AbstractVector, P::AbstractVector, S::AbstractVector, R::AbstractRegularization, tol::Real, j::Int) where {T}
    n = size(A, 1)

    if R isa NoRegularization && iszero(S[j])
        maxval = abs(D[j])
    else
        maxval = real(S[j]) * D[j]
    end

    maxind = j

    for i in j + 1:n
        if R isa NoRegularization && iszero(S[i])
            sAii = abs(D[i])
        else
            sAii = real(S[i]) * D[i]
        end

        if sAii > maxval
            maxval = sAii
            maxind = i
        end
    end

    if R isa NoRegularization && maxval < tol
        for i in j:n
            D[i] = zero(real(T))
        end

        return false
    end

    if maxind != j
        swaptri!(A, j, maxind, uplo)
        swaprec!(P, j, maxind)
        swaprec!(D, j, maxind)
        swaprec!(S, j, maxind)
    end

    return true
end

# ===== pstrf2! =====

function pstrf2!(uplo::Val{:L}, A::AbstractMatrix{T}, D::AbstractVector, P::AbstractVector, bstrt::Int, bstop::Int, S::AbstractVector, R::AbstractRegularization, tol::Real, ::Val{DIAG}) where {T, DIAG}
    n = size(A, 1)

    @inbounds for j in bstrt:bstop
        pstrf_pivot!(uplo, A, D, P, S, R, tol, j) || return j, j - 1

        for k in bstrt:j - 1
            cLjk = conj(A[j, k])

            for i in j + 1:n
                if DIAG === :N
                    A[i, j] -= A[i, k] * cLjk
                else
                    A[i, j] -= A[i, k] * real(D[k]) * cLjk
                end
            end
        end

        Djj = regularize(R, S, real(D[j]), j)

        iszero(Djj) && return j, j - 1

        if DIAG === :N
            A[j, j] = Djj = sqrt(Djj)
        else
            D[j] = Djj
        end

        iDjj = inv(Djj)

        for i in j + 1:n
            A[i, j] *= iDjj
        end

        for i in j + 1:n
            if DIAG === :N
                D[i] -= abs2(A[i, j])
            else
                D[i] -= Djj * abs2(A[i, j])
            end
        end
    end

    return 0, bstop
end

function pstrf2!(uplo::Val{:U}, A::AbstractMatrix{T}, D::AbstractVector, P::AbstractVector, bstrt::Int, bstop::Int, S::AbstractVector, R::AbstractRegularization, tol::Real, ::Val{DIAG}) where {T, DIAG}
    n = size(A, 1)

    @inbounds for j in bstrt:bstop
        pstrf_pivot!(uplo, A, D, P, S, R, tol, j) || return j, j - 1

        Djj = regularize(R, S, real(D[j]), j)

        iszero(Djj) && return j, j - 1

        if DIAG === :N
            A[j, j] = Djj = sqrt(Djj)
        else
            D[j] = Djj
        end

        iDjj = inv(Djj)

        for i in j + 1:n
            for k in bstrt:j - 1
                cAkj = conj(A[k, j])

                if DIAG === :N
                    A[j, i] -= A[k, i] * cAkj
                else
                    A[j, i] -= A[k, i] * real(D[k]) * cAkj
                end
            end

            A[j, i] *= iDjj

            if DIAG === :N
                D[i] -= abs2(A[j, i])
            else
                D[i] -= Djj * abs2(A[j, i])
            end
        end
    end

    return 0, bstop
end

# ===== pstrf! =====

for (pstrf, T, R) in
    ((:dpstrf_, :Float64,    :Float64),
     (:spstrf_, :Float32,    :Float32),
     (:zpstrf_, :ComplexF64, :Float64),
     (:cpstrf_, :ComplexF32, :Float32))
    @eval begin
        function pstrf!(uplo::AbstractChar, A::AbstractMatrix{$T}, piv::AbstractVector{BlasInt}, work::AbstractVector{$R}, tol::Real)
            n = checksquare(A)
            @assert length(piv) >= n
            @assert length(work) >= 2n
            require_one_based_indexing(A, piv, work)
            LAPACK.chkuplo(uplo)
            chkstride1(A)

            lda = max(1, stride(A, 2))
            rank = Ref{BlasInt}()
            info = Ref{BlasInt}()

            ccall((BLAS.@blasfunc($pstrf), BLAS.libblastrampoline), Cvoid,
                  (Ref{UInt8}, Ref{BlasInt}, Ptr{$T}, Ref{BlasInt}, Ptr{BlasInt},
                   Ptr{BlasInt}, Ref{$R}, Ptr{$R}, Ref{BlasInt}, Clong),
                  uplo, n, A, lda, piv, rank, tol, work, info, 1)

            LAPACK.chkargsok(info[])
            return info[], rank[]
        end
    end
end

function pstrf!(uplo::Val, W::AbstractVector{T}, A::AbstractMatrix{T}, P::AbstractVector{BlasInt}, tol::Real=-one(real(T))) where {T <: BlasFloat}
    return pstrf!(char(uplo), A, P, reinterpret(real(T), W), tol)
end

function pstrf!(uplo::Val, W::AbstractVector{T}, A::AbstractMatrix{T}, P::AbstractVector, R_or_tol::Union{Real, AbstractRegularization}=-one(real(T))) where {T}
    n = size(A, 1)
    S = Ones{T}(n)
    M = Ones{T}(n * n)
    diag = Val(:N)

    if R_or_tol isa AbstractRegularization
        R = R_or_tol
        tol = -one(real(T))
    else
        R = NoRegularization()
        tol = R_or_tol
    end

    return pstrf!(uplo, M, A, W, P, S, R, tol, diag)
end

function pstrf!(uplo::Val, W::AbstractVector{T}, A::AbstractMatrix{T}, D::AbstractVector{T}, P::AbstractVector{BlasInt}, ::AbstractVector{T}, ::NoRegularization, tol::Real, ::Val{:N}) where {T <: BlasFloat}
    return pstrf!(uplo, W, A, P, tol)
end

function pstrf!(uplo::Val{UPLO}, W::AbstractVector{T}, A::AbstractMatrix{T}, D::AbstractVector{T}, P::AbstractVector, S::AbstractVector{T}, R::GMW81, tol::Real, diag::Val{DIAG}) where {T, UPLO, DIAG}
    n = size(A, 1)

    if UPLO === :L
        L = Ones{T}(0, n)
    else
        L = Ones{T}(n, 0)
    end

    return chol_piv_factor!(A, L, W, D, P, S, R, uplo, diag)
end

function pstrf!(uplo::Val{UPLO}, W::AbstractVector{T}, L₁::AbstractMatrix{T}, d₁::AbstractVector{T}, P::AbstractVector, S₁::AbstractVector{T}, R::SE99, tol::Real, diag::Val{DIAG}) where {T, UPLO, DIAG}
    n = size(L₁, 1)

    if UPLO === :L
        L₂ = Ones{T}(0, n)
    else
        L₂ = Ones{T}(n, 0)
    end

    M = Ones{T}(0, 0)
    d₂ = Ones{T}(0)
    g = FVector{T}(undef, n)
    S₂ = Ones{T}(0)

    chol_se99_piv_kernel!(L₁, L₂, M, W, d₁, d₂, g, P, S₁, S₂, R, true, zero(real(T)), zero(real(T)), uplo, diag)

    return 0, n
end

function pstrf!(uplo::Val{UPLO}, W::AbstractVector{T}, A::AbstractMatrix{T}, D::AbstractVector{T}, P::AbstractVector, S::AbstractVector{T}, R::AbstractRegularization, tol::Real, diag::Val{DIAG}) where {T, UPLO, DIAG}
    n = size(A, 1)

    if isnegative(tol)
        maxdiag = zero(real(T))

        @inbounds for i in axes(A, 1)
            maxdiag = max(maxdiag, abs(real(A[i, i])))
        end

        tol = n * eps(real(T)) * maxdiag
    end

    @inbounds for j in axes(A, 1)
        P[j] = j
        D[j] = real(A[j, j])
    end

    rank = n

    @inbounds for bstrt in 1:THRESHOLD:n
        bstop = min(bstrt + THRESHOLD - 1, n)

        info, rank = pstrf2!(uplo, A, D, P, bstrt, bstop, S, R, tol, diag)

        if rank < bstop
            return info, rank
        elseif bstop < n
            Arr = view(A, bstop + 1:n, bstop + 1:n)
            Dbb = view(D, bstrt:bstop)

            if UPLO === :L
                Arb = view(A, bstop + 1:n, bstrt:bstop)
                trans = Val(:N)
            else
                Arb = view(A, bstrt:bstop, bstop + 1:n)
                trans = Val(:C)
            end

            syrk!(uplo, trans, -one(real(T)), W, Arb, Dbb, one(real(T)), Arr, diag)
        end
    end

    return 0, rank
end

#**********************************************************************
#**********************************************************************
#*****   MFUPD_DEF ... DEFICIENCY UPDATING   **************************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       THIS SUBROUTINE USES WING-HUANG UPDATING TO UPDATE THE
#       DEFICIENCIES OF ALL VERTICES WHOSE DEFICIENCIES ARE INFLUENCED
#       BY THE ELIMINATION OF ENODE.
#
#     INPUT PARAMETERS:
#       ENODE       - ELIMINATION NODE.
#       NEQNS       - NUMBER OF EQUATIONS.
#       MAXINT      - MAXIMUM INTEGER USED IN MARKER(*).
#       ADJLEN      - LENGTH OF ADJNCY(*).
#       XADJ(*)     - ARRAY OF LENGTH NEQNS+1, CONTAINING THE
#                     POINTERS FOR THE CURRENT QUOTIENT GRAPH.
#       ADJNCY(*)   - ARRAY OF LENGTH ADJLEN, CONTAINING THE CURRENT
#                     QUOTIENT GRAPH.
#       NVTXS(*)    - ARRAY OF LENGTH NEQNS, CONTAINING THE NUMBER
#                     VERTEX NEIGHBORS FOR AN UNELIMINATED NODE, AND
#                     THE NUMBER OF NODES IN THE CLIQUE FOR AN
#                     ELIMINATED NODE.
#       WORK(*)     - ARRAY OF LENGTH NEQNS, CONTAINING THE NUMBER
#                     OF ELIMINATION CLIQUES TO WHICH AN UNELIMINATED
#                     NODE BELONGS.
#       QSIZE(*)    - ARRAY OF LENGTH NEQNS,
#                       <0 - NEGATIVE OF SUPERNODE SIZE FOR EACH NODE
#                            IN ENODE'S ELIMINATION CLIQUE.
#                       >0 - SUPERNODE SIZE FOR EACH UNELIMINATED 
#                            NODE NOT IN ENODE'S ELIMINATION 
#                            CLIQUE.
#                       =0 - ABSORBED.
#       NNODES      - NUMBER OF (SUPER)NODES IN ENODE'S ELIMINATION
#                     CLIQUE.
#       FNODE       - POINTER TO FIRST (SUPER)NODE IN ENODE'S
#                     ELIMINATION CLIQUE MERGED INTO THE CLIQUE
#                     AFTER THE (SUPER)NODES OF QUOTIENT GRAPH
#                     NEIGHBOR CLIQUE "LAST CLIQUE".
#
#     MODIFIED PARAMETERS:
#       NNODES2     - INITIALLY ZERO.  ON OUTPUT, IT IS THE NUMBER
#                     OF EXTERNAL NODES WHOSE DEFICIENCIES HAVE BEEN
#                     CHANGED BY THIS ROUTINE.
#       ECLIQ(*)    - ARRAY OF LENGTH NEQNS.
#                     ON INPUT CONTAINS ENODE'S ELIMINATION CLIQUE
#                     AND MAY OR MAY NOT CONTAIN THE EXTERNAL NODES
#                     WHOSE DEFICIENCIES WILL CHANGE.
#                     ON OUTPUT, CONTAINS ENODE'S ELIMINATION CLIQUE
#                     AND THE EXTERNAL NODES WHOSE DEFICIENCIES HAVE
#                     CHANGED.
#       DEGREE(*)   - ARRAY OF LENGTH NEQNS, RECORDS THE DEGREE
#                     OF EACH NODE UNODE IN THE CURRENT ELIMINATION
#                     GRAPH PLUS ONE.
#       DEFNCY(*)   - ARRAY OF LENGTH NEQNS, CONTAINING THE 
#                     DEFICIENCIES OF THE UNELIMINATED NODES.
#                     SINCE DEFICIENCIES CAN BE VERY LARGE, THIS
#                     ARRAY IS STORED AS LONG INTEGER (INTEGER*8).
#       TAG         - TAG FOR MARKING PROCESSES IN MARKER(*).
#       MARKER(*)   - ARRAY OF LENGTH NEQNS, USED FOR MARKING TO 
#                     PREVENT PROCESSING SAME NODE MORE THAN ONCE
#                     OR PROCESSING AN ABSORBED NODE.
#       UTAG        - USED TO TAG THE NEIGHBORS OF UNODE FOR
#                     THE WING-HUANG UPDATING PROCESS.
#       UMARK(*)    - ARRAY OF LENGTH NEQNS, USED TO MARK THE
#                     NEIGHBORS OF UNODE FOR THE W-H UPDATING
#                     PROCESS.
#       CHANGED(*)  - ARRAY OF LENGTH NEQNS,
#                       -1 - DEFICIENCY IS UNCHANGED
#                        1 - DEFICIENCY IS POTENTIALLY CHANGED
#
#   WORKING PARAMETERS:
#       DSET(*)     - ARRAY OF LENGTH NEQNS, USED TO STORE THE 
#                     BACK-EDGES OF THE DEFICIENCY OF ENODE,
#                     INCIDENT, IN TURN, UPON EACH MEMBER UNODE
#                     OF ENODE'S ELIMINATION CLIQUE.
#       DEGINC(*)   - ARRAY OF LENGTH NEQNS, USED TO ACCUMULATE
#                     THE CHANGE IN DEGREES OF THE NODES IN THE
#                     ELIMINATION CLIQUE.
#
#**********************************************************************
#
function mfupd_def(
        enode::V,
        neqns::V,
        adjlen::E,
        xadj::AbstractVector{E},
        adjncy::AbstractVector{V},
        nvtxs::AbstractVector{V},
        work::AbstractVector{V},
        qsize::AbstractVector{W},
        nnodes::V,
        fnode::V,
        ecliq::AbstractVector{V},
        degree::AbstractVector{W},
        defncy::AbstractVector{W},
        tag::I,
        marker::AbstractVector{I},
        utag::I,
        umark::AbstractVector{I},
        changed::AbstractVector{Bool},
        dset::AbstractVector{V},
        deginc::AbstractVector{W},
    ) where {V, E, I, W}
    
    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    
    #       ------------------------------------------------------------
    #       INITIALIZE THE CHANGES IN THE DEGREES TO ZERO.
    #       K: LAST OCCUPIED LOCATION IN THE ELIMINATION CLIQUE (ECLIQ).
    #       ------------------------------------------------------------
    for j in oneto(nnodes)
        unode = ecliq[j]
        deginc[unode] = zero(W)
    end
    
    k = nnodes
    
    #       -----------------------------------------------------
    #       FOR EACH NODE UNODE IN ENODE'S ELIMINATION CLIQUE ...
    #       (STARTING FIRST WITH NODE FNODE)
    #       -----------------------------------------------------
    for j in fnode:nnodes
        
        #           ----------
        #           GET UNODE.
        #           ----------
        unode = ecliq[j]
        qu = abs(qsize[unode])
        
        #           ---------
        #           BUMP TAG.
        #           ---------
        if tag <= maxint(I) - convert(I, j) - one(I)
            tag0 = tag
            tag += convert(I, j)
        else
            tag0 = zero(I)
            tag = convert(I, j)

            for i in oneto(neqns)
                if marker[i] < maxint(I)
                    marker[i] = zero(I)
                end
            end
        end

        #           ----------
        #           BUMP UTAG.
        #           ----------
        if utag <= maxint(I) - two(I)
            utag += one(I)
        else
            utag = one(I)

            for i in oneto(neqns)
                if marker[i] < maxint(I)
                    umark[i] = zero(I)
                end
            end
        end

        #           ------------------------------------------------
        #           INITIALIZE NUMBER OF EXTERNAL NEIGHBORS OF UNODE
        #           TO ZERO.
        #           ------------------------------------------------
        ucount = zero(W)
        #           ------------------------------------------
        #           FOR EVERY UNABSORBED VERTEX NEIGHBOR WNODE
        #           OF UNODE ...
        #           ------------------------------------------
        istart = xadj[unode]
        istop = istart + convert(E, nvtxs[unode]) - one(E)

        for i in istart:istop
            wnode = adjncy[i]
            #               --------------------------------------------
            #               IF WNODE IS A FIRST-TIME UNABSORBED NEIGHBOR
            #               OF UNODE ...
            #               --------------------------------------------
            if umark[wnode] < utag
                #                   --------------------------------------
                #                   IF WNODE IS NOT IN ENODE'S ELIMINATION
                #                   CLIQUE ...
                #                   --------------------------------------
                if ispositive(qsize[wnode])
                    #                       ------------------------------------
                    #                       COUNT WNODE AS AN EXTERNAL NEIGHBOR.
                    #                       ------------------------------------
                    ucount += qsize[wnode]
                end
                #                   --------------------
                #                   ... THEN MARK WNODE.
                #                   --------------------
                umark[wnode] = utag
            end
        end
        #           --------------------------------------------
        #           FOR EVERY CLIQUE NEIGHBOR CNODE OF UNODE ...
        #           --------------------------------------------
        cstart = xadj[unode] + convert(E, nvtxs[unode])
        cstop = cstart + convert(E, work[unode]) - one(E)

        for c in cstart:cstop
            cnode = adjncy[c]
            #               ----------------------------------------
            #               FOR EVERY NODE WNODE IN CLIQUE CNODE ...
            #               ----------------------------------------
            istart = xadj[cnode]
            istop = istart + convert(E, nvtxs[cnode]) - one(E)

            for i in istart:istop
                wnode = adjncy[i]
                #                   -----------------------------------
                #                   IF WNODE IS A FIRST-TIME UNABSORBED
                #                   NEIGHBOR OF UNODE ...
                #                   -----------------------------------
                if umark[wnode] < utag
                    #                       --------------------------
                    #                       IF WNODE IS NOT IN ENODE'S
                    #                       ELIMINATION CLIQUE ...
                    #                       --------------------------
                    if ispositive(qsize[wnode])
                        #                           ------------------------------------
                        #                           COUNT WNODE AS AN EXTERNAL NEIGHBOR.
                        #                           ------------------------------------
                        ucount += qsize[wnode]
                    end
                    #                       --------------------
                    #                       ... THEN MARK WNODE.
                    #                       --------------------
                    umark[wnode] = utag
                end
            end
        end
        
        #           ----------------------------------
        #           FOR EVERY EARLIER WNODE IN ENODE'S
        #           ELIMINATION CLIQUE ...
        #           (NOTE THAT UNODE = ECLIQ(J))
        #           ----------------------------------
        dvtxs = zero(V)

        for i in oneto(j - one(V))
            wnode = ecliq[i]
            #               ---------------------------------------
            #               IF WNODE IS NOT A NEIGHBOR OF UNODE ...
            #               ---------------------------------------
            if umark[wnode] < utag
                #                   ---------------------------------------------
                #                   ... THEN THERE IS A NEW FILL EDGE JOINING
                #                   UNODE AND WNODE.
                #                   ACCUMULATE THE CONTRIBUTION OF THE FILL
                #                   EDGE TO UNODE'S AND WNODE'S DEGREE INCREMENT.
                #                   ---------------------------------------------
                deginc[unode] -= qsize[wnode]
                deginc[wnode] += qu
                dvtxs += one(V)
                dset[dvtxs] = wnode
            end
        end

        #           ---------------------------------------------
        #           FOR EACH NEW FILL NEIGHBOR WNODE OF UNODE ...
        #           ---------------------------------------------
        for w in oneto(dvtxs)

            #               --------------------------------------
            #               INITIALIZE COUNTS FOR UNODE AND WNODE.
            #               --------------------------------------
            wnode = dset[w]
            cntu = ucount
            cntw = zero(W)
            tag0 += one(I)
            uwfill = qsize[unode] * qsize[wnode]

            #               -------------------------------------------------------
            #               FOR EVERY UNABSORBED VERTEX NEIGHBOR XNODE OF WNODE ...
            #               -------------------------------------------------------
            istart = xadj[wnode]
            istop = istart + convert(E, nvtxs[wnode]) - one(E)

            for i in istart:istop
                xnode = adjncy[i]

                if marker[xnode] < tag0
                    #                       ------------------------------------
                    #                       FIRST TIME VISIT TO UNABSORBED XNODE
                    #                       AS A NEIGHBOR OF WNODE.
                    #                       ------------------------------------
                    if ispositive(qsize[xnode])
                        #                           --------------------------------
                        #                           XNODE IS NOT A MEMBER OF ENODE'S
                        #                           ELIMINATION CLIQUE.
                        #                           --------------------------------
                        if umark[xnode] == utag
                            #                               ----------------------------------
                            #                               XNODE IS ALSO A NEIGHBOR OF UNODE.
                            #                               ----------------------------------
                            
                            #                               ---------------------------
                            #                               DECREMENT UNODE'S COUNT AND
                            #                               DEFICIENCY OF XNODE.
                            #                               ---------------------------
                            cntu -= qsize[xnode]
                            defncy[xnode] -= uwfill
                            #                               ---------------------------------
                            #                               IF XNODE'S DEFICIENCY IS CHANGED
                            #                               FOR THE FIRST TIME, THEN STORE IT
                            #                               AND MARK IT AS CHANGED.
                            #                               ---------------------------------
                            if !changed[xnode]
                                k += one(V)
                                ecliq[k] = xnode
                                changed[xnode] = true
                            end
                        else
                            #                               ------------------------------------
                            #                               XNODE IS NOT A NEIGHBOR OF UNODE ...
                            #                               SO IT WILL INCREASE THE DEFICIENCY
                            #                               OF WNODE.
                            #                               ------------------------------------
                            cntw += qsize[xnode]
                        end
                    else
                        #                           ----------------------------
                        #                           XNODE IS A MEMBER OF ENODE'S
                        #                           ELIMINATION CLIQUE.
                        #                           ----------------------------
                        if umark[xnode] == utag
                            #                               ---------------------------------
                            #                               ... AND IT IS ADJACENT TO UNODE.
                            #                               SO DECREMENT DEFICIENCY OF XNODE.
                            #                               ---------------------------------
                            defncy[xnode] -= uwfill
                        end
                    end
                    #                       ---------------------------------------------
                    #                       MARK XNODE AS VISITED AS A NEIGHBOR OF WNODE.
                    #                       ---------------------------------------------
                    marker[xnode] = tag0
                end
            end

            #               --------------------------------------------
            #               FOR EVERY CLIQUE NEIGHBOR CNODE OF WNODE ...
            #               --------------------------------------------
            cstart = xadj[wnode] + convert(E, nvtxs[wnode])
            cstop = cstart + convert(E, work[wnode]) - one(E)

            for c in cstart:cstop
                cnode = adjncy[c]
                #                   ----------------------------------
                #                   FOR EVERY UNABSORBED NODE XNODE IN
                #                   CLIQUE CNODE ...
                #                   ----------------------------------
                istart = xadj[cnode]
                istop = istart + convert(E, nvtxs[cnode]) - one(E)

                for i in istart:istop
                    xnode = adjncy[i]

                    if marker[xnode] < tag0
                        #                           ------------------------------------
                        #                           FIRST TIME VISIT TO UNABSORBED XNODE
                        #                           AS A NEIGHBOR OF WNODE.
                        #                           ------------------------------------
                        if ispositive(qsize[xnode])
                            #                               --------------------------------
                            #                               XNODE IS NOT A MEMBER OF ENODE'S
                            #                               ELIMINATION CLIQUE.
                            #                               --------------------------------
                            if umark[xnode] == utag
                                #                                   ------------------------
                                #                                   XNODE IS ALSO A NEIGHBOR
                                #                                   OF UNODE.
                                #                                   ------------------------
                                #                                   ---------------------------
                                #                                   DECREMENT UNODE'S COUNT AND
                                #                                   DEFICIENCY OF XNODE.
                                #                                   ---------------------------
                                cntu -= qsize[xnode]
                                defncy[xnode] -= uwfill
                                #                                   ---------------------------------
                                #                                   IF XNODE'S DEFICIENCY IS CHANGED
                                #                                   FOR THE FIRST TIME, ADD IT TO THE
                                #                                   LIST OF NODES WITH CHANGED
                                #                                   DEFICIENCIES.
                                #                                   ---------------------------------
                                if !changed[xnode]
                                    k += one(V)
                                    ecliq[k] = xnode
                                    changed[xnode] = true
                                end
                            else
                                #                                   -----------------------
                                #                                   XNODE IS NOT A NEIGHBOR
                                #                                   OF UNODE ...
                                #                                   SO IT WILL INCREASE THE
                                #                                   DEFICIENCY OF WNODE.
                                #                                   -----------------------
                                cntw += qsize[xnode]
                            end
                        else
                            #                               ----------------------------
                            #                               XNODE IS A MEMBER OF ENODE'S
                            #                               ELIMINATION CLIQUE.
                            #                               ----------------------------
                            if umark[xnode] == utag
                                #                                   ---------------------------------
                                #                                   ... AND IT IS ADJACENT TO UNODE.
                                #                                   SO DECREMENT DEFICIENCY OF XNODE.
                                #                                   ---------------------------------
                                defncy[xnode] -= uwfill
                            end
                        end
                        #                           -----------------------------------
                        #                           MARK XNODE AS VISITED AS A NEIGHBOR
                        #                           OF WNODE.
                        #                           -----------------------------------
                        marker[xnode] = tag0
                    end
                end
            end
            
            #               ---------------------------------------------
            #               WING-HUANG UPDATES FOR UNODE AND WNODE DUE TO
            #               FILL JOINING UNODE AND WNODE.
            #               NOTE: QSIZE IS NEGATIVE.
            #               ---------------------------------------------
            defncy[unode] -= cntu * qsize[wnode]
            defncy[wnode] -= cntw * qsize[unode]
            
            #               -----------
            #               NEXT WNODE.
            #               -----------
        end
        #           -----------
        #           NEXT UNODE.
        #           -----------
    end
    
    #       -------------------------------------------
    #       APPLY THE DEGREE INCREMENTS TO THE DEGREES.
    #       -------------------------------------------
    for j in oneto(nnodes)
        unode = ecliq[j]
        degree[unode] += deginc[unode]
    end
    
    #       --------------------------------------------
    #       RECORD THE NUMBER OF EXTERNAL VERTICES WHOSE
    #       DEFICIENCIES HAVE BEEN UPDATED.
    #       --------------------------------------------
    nnodes2 = k - nnodes
    
    #       ------------------------------------------------------
    #       CHECK IF THE DEFICIENCY OF THE ELIMINATED NODE ENODE
    #       IS ZERO.  STOP IF IT IS NOT. 
    #       ------------------------------------------------------
    if abs(defncy[enode]) > 1e-5
        error("ELIMINATED NODE HAS NONZERO DEFICIENCY: $enode => $(defncy[enode])")
    end
    
    return tag, utag, nnodes2
end

struct LayeredSieve{PSet <: AbstractPackedSet}
    sieves::Vector{Sieve{PSet}}
    margins::Vector{Int}
    k::Int
    weights::Vector{Int}
    stack::Vector{Tuple{Int, Int, Int}}
    buffer::Vector{Tuple{Int, PSet, PSet}}   # (root, bag, vertices) tuples
    index::Dict{Int, Int} # root index -> index in buffer
end

function LayeredSieve{PSet}(k::Int, weights::Vector{Int}) where {PSet <: AbstractPackedSet}
    n = margin_index(k)
    sieves = Vector{Sieve{PSet}}(undef, n)
    margins = Vector{Int}(undef, n)

    for s in 1:n
        sieves[s] = Sieve{PSet}()
        margins[s] = 1 << (s - 2)
    end

    return LayeredSieve{PSet}(sieves, margins, k, weights, Tuple{Int, Int, Int}[], Tuple{Int, PSet, PSet}[], Dict{Int, Int}())
end

# Compute the smallest positive integer i such that
#
#    2ⁱ⁻² ≥ m.
#
function margin_index(m::Int)
    return 8sizeof(Int) - leading_zeros(max(2m - 1, 0)) + 1
end

function sieve_index(sieve::LayeredSieve{PSet}, B::PSet) where {PSet}
    return margin_index(sieve.k + 1 - wt(sieve.weights, B))
end

function Base.setindex!(sieve::LayeredSieve{PSet}, (B, V)::Tuple{PSet, PSet}, i::Int) where {PSet}
    push!(sieve.buffer, (i, B, V))
    sieve.index[i] = length(sieve.buffer)
    return sieve
end

function flush!(sieve::LayeredSieve{PSet}) where {PSet}
    n = length(sieve.sieves)

    for (i, B, V) in sieve.buffer
        if haskey(sieve.index, i)
            s = min(sieve_index(sieve, B), n)
            sieve.sieves[s][i] = V
            delete!(sieve.index, i)
        end
    end

    empty!(sieve.buffer)
end

function replace_subset!(sieve::LayeredSieve{PSet}, i::Int, B::PSet, j::Int, C::PSet, V::PSet) where {PSet}
    n = length(sieve.sieves)

    if haskey(sieve.index, i)
        s = sieve.index[j] = pop!(sieve.index, i)
        sieve.buffer[s] = (j, C, V)
    else
        s = min(sieve_index(sieve, B), n)
        t = min(sieve_index(sieve, C), n)

        if s == t
            replace_key!(sieve.sieves[s], i, j)
        else
            delete!(sieve.sieves[s], i)
            sieve.sieves[t][j] = V
        end        
    end

    return sieve
end

struct LayeredSieveQuery{PSet <: AbstractPackedSet}
    sieve::LayeredSieve{PSet}
    stack::Vector{Tuple{Int, Int, Int}}
    R::PSet
    S::PSet
    i::Int
end

function Base.eltype(::Type{<:LayeredSieveQuery})
    return Int
end

function Base.IteratorSize(::Type{<:LayeredSieveQuery})
    return Base.SizeUnknown()
end

function Base.iterate(iter::LayeredSieveQuery)
    init!(iter.stack)
    return (iter.i, 1)
end

function Base.iterate(iter::LayeredSieveQuery{PSet}, s::Int) where {PSet}
    sieve = iter.sieve
    stack = iter.stack
    R = iter.R
    S = iter.S

    i = 0; n = length(sieve.sieves)

    if s <= n
        i = next!(sieve.sieves[s], stack, R, S, sieve.margins[s], sieve.weights)
    end

    while iszero(i) && s < n
        s += 1
        i = next!(sieve.sieves[s], init!(stack), R, S, sieve.margins[s], sieve.weights)
    end

    iszero(i) || return (i, s)
    return
end

function query(sieve::LayeredSieve{PSet}, R::PSet, S::PSet, i::Int) where {PSet}
    return LayeredSieveQuery{PSet}(sieve, sieve.stack, R, S, i)
end

function scldia!(A::ChordalTriangular, α)
    @inbounds for j in fronts(A)
        D, _ = diagblock(A, j)

        for i in diagind(D)
            D[i] *= α
        end
    end

    return A
end

function scldia!(A::SparseMatrixCSC, α)
    for i in diagind(A)
        A[i] *= α
    end

    return A
end

function scldia!(A::HermOrSym, α)
    scldia!(parent(A), α)
    return A
end

function scldia!(F::ChordalCholesky, α)
    scldia!(triangular(F), α)
    return F
end

function symdot(A::HermSparse, B::HermSparse)
    @assert A.uplo == B.uplo
    return symdot_impl(parent(A), parent(B), Val(:C), A.uplo)
end

function symdot(A::SymSparse, B::SymSparse)
    @assert A.uplo == B.uplo
    return symdot_impl(parent(A), parent(B), Val(:N), A.uplo)
end

function symdot_impl(A::SparseMatrixCSC{TA, IA}, B::SparseMatrixCSC{TB, IB}, tA::Val{T}, uplo::Char) where {TA, IA, TB, IB, T}
    if T === :C
        out = real(zero(TA) * zero(TB))
    else
        out = zero(TA) * zero(TB)
    end

    @inbounds for j in axes(A, 2)
        pa, pastop = A.colptr[j], A.colptr[j + 1] - one(IA)
        pb, pbstop = B.colptr[j], B.colptr[j + 1] - one(IB)

        while pa <= pastop && pb <= pbstop
            ia, ib = rowvals(A)[pa], rowvals(B)[pb]
            Aij = nonzeros(A)[pa]
            Bij = nonzeros(B)[pb]

            if ia == ib
                if (uplo == 'L' && ia >= j) || (uplo == 'U' && ia <= j)
                    if ia == j
                        if T === :C
                            out += real(Aij) * real(Bij)
                        else
                            out += Aij * Bij
                        end
                    else
                        if T === :C
                            out += 2 * real(conj(Aij) * Bij)
                        else
                            out += 2 * Aij * Bij
                        end
                    end
                end

                pa += one(IA)
                pb += one(IB)
            elseif ia < ib
                pa += one(IA)
            else
                pb += one(IB)
            end
        end
    end

    return out
end

function pr3(weights::AbstractVector{W}, graph::AbstractGraph, width::Number) where {W <: Number}
    return pr3(weights, graph, convert(W, width))
end

function pr3(weights::AbstractVector{W}, graph::AbstractGraph{V}, width::W) where {W <: Number, V}
    @assert nv(graph) <= length(weights)

    E = etype(graph); n = nv(graph); m = de(graph); nn = n + one(V)

    # `totdeg` is the total weight of the
    # vertices in the graph
    totdeg = zero(W)

    @inbounds for v in oneto(n)
        totdeg += weights[v]
    end

    marker = FVector{V}(undef, n)    
    stack0 = FVector{V}(undef, n)
    stack1 = FVector{V}(undef, n)
    stack2 = FVector{V}(undef, n)
    stack3 = FVector{V}(undef, n)
    stack4 = FVector{V}(undef, n)
    stack5 = FVector{V}(undef, n)
    index0 = FVector{V}(undef, n)
    index1 = FVector{V}(undef, n)
    index2 = FVector{V}(undef, n)
    index3 = FVector{V}(undef, n)
    tmpptr = FVector{E}(undef, nn)

    degree = FVector{W}(undef, n)
    number = FVector{V}(undef, n)
    source = FVector{V}(undef, m)
    target = FVector{V}(undef, m)
    begptr = FVector{E}(undef, nn)
    endptr = FVector{E}(undef, n)
    invptr = FVector{E}(undef, m)

    kernel, stack, inject, width = pr3_impl!(marker, stack0, stack1, stack2, stack3, stack4, stack5, 
        index0, index1, index2, index3, tmpptr, degree, number, source,
        target, begptr, endptr, invptr, totdeg, weights, graph, width)

    return kernel, stack, inject, width
end

"""
    pr3_impl!(marker, stack0, stack1, stack2, stack3, stack4,
        stack5, index0, index1, index2, index3, tmpptr, degree,
        number, source, target, begptr, endptr, invptr, totdeg,
        weight, graph, width)

Pre-processing for Triangulation of Probabilistic Networks
Bodlaender, Koster, Eijkhof, and van der Gaag

Preprocessing Rules for Triangulation of Probabilistic Networks
Bodlaender, Koster, Eijkhof, and van der Gaag

Safe Reduction Rules for Weighted Treewidth
Eijkhof, Bodlaender, and Koster

Preprocess a graph by applying a set of *safe* reduction
rules.
  - islet
  - twig
  - series
  - triangle
  - buddy
  - cube
The algorithm runs in a loop, testing each degree 0, 1, 2,
and 3 vertex to see if it can be eliminated according to one
of the rules. The algorithm terminates when no more vertices
can be eliminated.

The output is a reduced graph R and a sequence (v₁, ..., vₙ) of
eliminated vertices. Any minimum-treewidth elimination ordering
(w₁, ..., wₘ) of R can be appended to the sequence to create
a minimum-treewidth elimination ordering of the input graph.
   (v₁, ..., vₙ, w₁, ..., wₘ).
If the input graph has treewidth at most three, then the
algorithm will eliminate every vertex, and the reduced graph
R will have no vertices.

The algorithm employs a data structure called a *quotient graph.*
It is a directed graph with two types of vertices: elements and
supernodes. The arcs in the graph obey the following invariant
  - every supernode w has at most one predecessor v, which must
    be an element
We say that an element w is *reachable* by another element v if
there exists a path (v, x₁, ..., xₙ, w) from v to w through
supernodes {x₁, ..., xₙ}. Reachability is a symmetric, irreflexive
relation on the set of elements.

input parameters:
  - `totdeg`: total vertex weight
  - `weight`: vertex weight
  - `graph`: input graph
  - `width`: treewidth lower bound

output parameters:
  - `kernel`: reduced graph
  - `stack4`: stack of eliminated vertices
  - `inject`: mapping from the vertices of `kernel` to the vertices
              of `graph`
  - `width`: treewidth lower bound

working arrays:
  - miscellaneous:
    - `marker`: marker array
    - `stack5`: vertex stack
    - `tmpptr`: temporary pointer array
  - vertex-degree bucket queue:
    - `stack0`: stack of degree 0 vertices
    - `stack1`: stack of degree 1 vertices
    - `stack2`: stack of degree 2 vertices
    - `stack3`: stack of degree 3 vertices
    - `index0`: the index of a vertex in `stack0`
    - `index1`: the index of a vertex in `stack1`
    - `index2`: the index of a vertex in `stack2`
    - `index3`: the index of a vertex in `stack3`
  - quotient graph:
    - `source`: the source vertex of an edge
    - `target`: the target vertex of an edge
      - positive vertices are elements
      - negative vertices are supernodes
    - `begptr`: the first edge incident to a vertex
    - `endptr`: the final edge incident to a vertex
    - `invptr`: the reverse of an edge
"""
function pr3_impl!(
        marker::AbstractVector{V},
        stack0::AbstractVector{V},
        stack1::AbstractVector{V},
        stack2::AbstractVector{V},
        stack3::AbstractVector{V},
        stack4::AbstractVector{V},
        stack5::AbstractVector{V},
        index0::AbstractVector{V},
        index1::AbstractVector{V},
        index2::AbstractVector{V},
        index3::AbstractVector{V},
        tmpptr::AbstractVector{E},
        degree::AbstractVector{W},
        number::AbstractVector{V},
        source::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        totdeg::W,
        weight::AbstractVector{W},
        graph::AbstractGraph{V},
        width::W,
    ) where {W, V, E}
    @assert nv(graph) <= length(marker)
    @assert nv(graph) <= length(stack0)
    @assert nv(graph) <= length(stack1)
    @assert nv(graph) <= length(stack2)
    @assert nv(graph) <= length(stack3)
    @assert nv(graph) <= length(stack4)
    @assert nv(graph) <= length(stack5)
    @assert nv(graph) <= length(index0)
    @assert nv(graph) <= length(index1)
    @assert nv(graph) <= length(index2)
    @assert nv(graph) <= length(index3)
    @assert nv(graph) < length(tmpptr)
    @assert nv(graph) <= length(degree)
    @assert nv(graph) <= length(number)
    @assert de(graph) <= length(source)
    @assert de(graph) <= length(target)
    @assert nv(graph) < length(begptr)
    @assert nv(graph) <= length(endptr)
    @assert de(graph) <= length(invptr)

    # `n` is the number of vertices in the input graph
    n = nv(graph)

    # initialize vertex-degree bucket queue and quotient graph
    hi0, hi1, hi2, hi3, mindeg = pr3_init!(marker, stack0, stack1, stack2,
        stack3, index0, index1, index2, index3, tmpptr, degree, number,
        source, target, begptr, endptr, invptr, totdeg, weight, graph)

    # the weighted treewidth of the input graph is no less
    # than its minimum weighted degree
    width = max(width, mindeg)

    # `tag` is used to mark vertices
    tag = one(V)

    # `lo4` is the previous number of eliminated vertices
    lo4 = -one(V)

    # `hi4` is the current number of eliminated vertices
    hi4 = zero(V)

    # if a vertex was eliminated during the previous loop... 
    @inbounds while lo4 < hi4
        # update `lo4`
        lo4 = hi4

        # test every degree 0 vertex
        width, hi4 = pr3_0!(stack0, stack4, degree, number, width, hi0, hi4)

        # every degree 0 vertex has been eliminated
        hi0 = zero(V)

        # test every degree 1 vertex
        width, hi0, hi2, hi3, hi4 = pr3_1!(stack0, stack1, stack2, stack3,
            stack4, stack5, index0, index1, index2, index3, degree, number, source,
            target, begptr, endptr, invptr, weight, width, hi0, hi1, hi2, hi3, hi4)

        # every degree 1 vertex has been eliminated
        hi1 = zero(V)

        # test every degree 2 vertex
        width, hi0, hi1, hi2, hi3, hi4 = pr3_2!(stack0, stack1,
            stack2, stack3, stack4, stack5, index0, index1, index2, index3,
            degree, number, source, target, begptr, endptr, invptr, weight,
            width, hi0, hi1, hi2, hi3, hi4)

        # test every degree 3 vertex
        width, tag, hi0, hi1, hi2, hi3, hi4 = pr3_3!(marker, stack0, stack1,
            stack2, stack3, stack4, stack5, index0, index1, index2, index3,
            degree, number, source, target, begptr, endptr, invptr, weight,
            width, tag, hi0, hi1, hi2, hi3, hi4)
    end

    # construct the reduced graph R = (V, E):
    #  - V is the set of elements in the quotient graph
    #  - E contains an arc (v, w) if w is reachable by v in the quotient graph
    m, n = pr3_make!(stack4, stack5, target, begptr, endptr,
        invptr, stack0, number, tmpptr, source, hi4, n)

    # `kernel` is the reduced graph
    kernel = BipartiteGraph(n, n, m, tmpptr, source)
    return kernel, stack4, stack0, width
end

function pr3_make!(
        stack4::AbstractVector{V},
        stack5::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        inj::AbstractVector{V},
        prj::AbstractVector{V},
        ptr::AbstractVector{E},
        tgt::AbstractVector{V},
        hi4::V,
        n::V,
    ) where {V, E}

    # mark eliminated vertices with -1
    @inbounds for i in oneto(hi4)
        w = stack4[i]; prj[w] = -one(V)
    end

    # `v` is a vertex in the reduced graph
    v = one(V)

    # for every vertex `w`...
    @inbounds for w in oneto(n)

        # if `w` was not eliminated
        if !isnegative(prj[w])
            # associate `v` and `w`
            prj[w] = v
            inj[v] = w

            # increment `v`
            v += one(V)
        end
    end

    # `v` is a vertex in the reduced graph
    v = one(V)

    # `p` is the first arc incident to `v`
    @inbounds ptr[v] = p = one(E)

    # for all vertices `v` in the reduced graph...
    @inbounds while v + hi4 <= n
        # `w` is the corresponding element in the
        # quotient graph
        w = inj[v]

        p =  pr3_reach!(p, stack5,
            target, begptr, endptr, invptr, w) do p, _, x

            # `x` is an element reachable by `w`
            @inbounds tgt[p] = prj[x]; p += one(E)
            return p
        end

        # update `v` and `p`
        v += one(V); ptr[v] = p
    end

    # `m` is the number of arcs in the reduced graph
    m = p - one(E)

    # `n` is the number of vertices in the reduced graph
    n = v - one(V)
    return m, n
end

function pr3_init!(
        marker::AbstractVector{V},
        stack0::AbstractVector{V},
        stack1::AbstractVector{V},
        stack2::AbstractVector{V},
        stack3::AbstractVector{V},
        index0::AbstractVector{V},
        index1::AbstractVector{V},
        index2::AbstractVector{V},
        index3::AbstractVector{V},
        tmpptr::AbstractVector{E},
        degree::AbstractVector{W},
        number::AbstractVector{V},
        source::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        totdeg::W,
        weight::AbstractVector{W},
        graph::AbstractGraph{V},
    ) where {W, V, E}
    
    # `n` is the number of vertices in the graph
    n = nv(graph); nn = n + one(V)

    # `hi0` is the top of the stack of degree 0 vertices
    # `hi1` is the top of the stack of degree 1 vertices
    # `hi2` is the top of the stack of degree 2 vertices
    # `hi3` is the top of the stack of degree 3 vertices    
    hi0 = hi1 = hi2 = hi3 = zero(V)
    
    # `mindeg` is the minimum weighted degree
    mindeg = totdeg
    
    # `p` is the current arc
    p = one(E)

    @inbounds for v in vertices(graph)
        marker[v] = zero(V)
        tmpptr[v] = begptr[v] = endptr[v] = p

        # `deg` is the weighted degree of `v`
        deg = weight[v]
        
        # `num` is the unweighted degree of `v`
        num = zero(V)

        # for all neighbors `w` of `v`...
        for w in neighbors(graph, v)
            # ignore self loops
            if v != w
                # `p` is the arc (`v`, `w`)
                source[p] = v; p += one(E)

                # increase the weighted degree of `v` by
                # the weight of `w`
                deg += weight[w]

                # increment the degree of `v`
                num += one(V)
            end
        end
        
        # if `v` has degree 0 ...
        if iszero(num)
            # ... add it to the stack of degree 0 vertices
            index0[v] = hi0 += one(V); stack0[hi0] = v

        # if `v` has degree 1 ...
        elseif isone(num)
            # ... add it to the stack of degree 1 vertices
            index1[v] = hi1 += one(V); stack1[hi1] = v

        # if `v` has degree 2 ...
        elseif istwo(num)
            # ... add it to the stack of degree 2 vertices
            index2[v] = hi2 += one(V); stack2[hi2] = v

        # if `v` has degree 3 ...
        elseif isthree(num)
            # ... add it to the stack of degree 3 vertices
            index3[v] = hi3 += one(V); stack3[hi3] = v
        end

        # update the minimum weighted degree
        mindeg = min(mindeg, deg)

        # store the weighted degree of `v`
        degree[v] = deg

        # store the degree of `v`
        number[v] = num
    end

    # for all arcs (`v`, `w`)...
    @inbounds for v in vertices(graph), w in neighbors(graph, v)
        # ignore self loops
        if v != w
            # `q` is the arc (`w`, `v`)
            q = endptr[w]; target[q] = v; endptr[w] = q + one(E)
        end
    end

    # for all vertices `v`...
    @inbounds for v in vertices(graph)
        # the arcs {`p`, ..., `pend` - 1} are incident
        # to `v`
        p = begptr[v]; pend = endptr[v]

        while p < pend
            # `p` is the arc (`v`, `w`)
            w = target[p]

            # `q` is the arc (`w`, `v`)
            q = tmpptr[w]; invptr[p] = q; tmpptr[w] = q + one(E)
            p += one(E)
        end
    end

    if ispositive(n)
        @inbounds begptr[nn] = endptr[n]
    end

    return hi0, hi1, hi2, hi3, mindeg
end

function pr3_0!(
        stack0::AbstractVector{V},
        stack4::AbstractVector{V},
        degree::AbstractVector{W},
        number::AbstractVector{V},
        width::W,
        hi0::V,
        hi4::V,
    ) where {W, V}

    # for all elements with degree 0...
    @inbounds while ispositive(hi0)
        # `v` is an element with degree 0
        hi0, v = pr3_stack_pop!(stack0, hi0)

        # add `v` to the stack of eliminated vertices
        hi4 = pr3_stack_add!(stack4, hi4, v)

        # `v` is simplicial: update the lower bound
        width = max(width, degree[v])
    end
    
    return width, hi4
end

function pr3_1!(
        stack0::AbstractVector{V},
        stack1::AbstractVector{V},
        stack2::AbstractVector{V},
        stack3::AbstractVector{V},
        stack4::AbstractVector{V},
        stack5::AbstractVector{V},
        index0::AbstractVector{V},
        index1::AbstractVector{V},
        index2::AbstractVector{V},
        index3::AbstractVector{V},
        degree::AbstractVector{W},
        number::AbstractVector{V},
        source::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        weight::AbstractVector{W},
        width::W,
        hi0::V,
        hi1::V,
        hi2::V,
        hi3::V,
        hi4::V,
    ) where {W, V, E}
    
    # for all elements with degree 1...
    @inbounds while ispositive(hi1)
        # `v` is an element with degree 1
        hi1, v = pr3_stack_pop!(stack1, hi1)

        # add `v` to the stack of eliminated vertices
        hi4 = pr3_stack_add!(stack4, hi4, v)

        # `v` is simplicial: update the lower bound
        width = max(width, degree[v])
        
        # `w` is the unique element reachable by `v`
        w = zero(V)
        p = zero(E)

        p, w = pr3_reach!((p, w), stack5,
            target, begptr, endptr, invptr, v) do _, p, w
            return (p, w)
        end
                
        if isone(number[w])
            # if `w` has degree 1, remove it from the stack
            # of degree 1 elements
            hi1 = pr3_stack_del!(stack1, index1, hi1, w)

            # add `w` to the stack of degree 0 elements
            hi0 = pr3_stack_add!(stack0, index0, hi0, w)
        elseif istwo(number[w])
            # if `w` has degree 2, remove it from the stack
            # of degree 2 elements
            hi2 = pr3_stack_del!(stack2, index2, hi2, w)

            # add `w` to the stack of degree 1 elements
            hi1 = pr3_stack_add!(stack1, index1, hi1, w)
        elseif isthree(number[w])
            # if `w` has degree 3, remove it from the stack
            # of degree 3 elements
            hi3 = pr3_stack_del!(stack3, index3, hi3, w)

            # add `w` to the stack of degree 2 elements
            hi2 = pr3_stack_add!(stack2, index2, hi2, w)
        elseif isfour(number[w])
            # if `w` has degree 4, add it to the stack
            # of degree 3 elements
            hi3 = pr3_stack_add!(stack3, index3, hi3, w)
        end

        # remove `v` from the reachable set of `w`
        pr3_reach_del!(source, target, endptr, invptr, invptr[p])

        # decrement the degree of `w`
        number[w] -= one(V)

        # decrease the weighted degree of `w` by the weight
        # of `v`
        degree[w] -= weight[v]
    end
    
    return width, hi0, hi2, hi3, hi4
end

function pr3_2!(
        stack0::AbstractVector{V},
        stack1::AbstractVector{V},
        stack2::AbstractVector{V},
        stack3::AbstractVector{V},
        stack4::AbstractVector{V},
        stack5::AbstractVector{V},
        index0::AbstractVector{V},
        index1::AbstractVector{V},
        index2::AbstractVector{V},
        index3::AbstractVector{V},
        degree::AbstractVector{W},
        number::AbstractVector{V},
        source::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        weight::AbstractVector{W},
        width::W,
        hi0::V,
        hi1::V,
        hi2::V,
        hi3::V,
        hi4::V,
    ) where {W, V, E}
    tol = tolerance(W)
    
    # `i` is an index into the stack of degree 2 elements
    i = one(V)

    # for all elements with degree 2    
    @inbounds while i <= hi2
        # `v` is an element with degree 2
        v = stack2[i]
       
        # `w` and `ww` are the elements reachable by `v` 
        w = ww = zero(V)
        p = pp = zero(E)
        
        p, w, pp, ww = pr3_reach!((p, w, pp, ww),
            stack5, target, begptr, endptr, invptr, v) do (p, w, pp, ww), ppp, www
            
            if iszero(w)
                p, w = ppp, www
            else
                pp, ww = ppp, www
            end
            
            return (p, w, pp, ww)    
        end

        # sort `w` and `ww` by degree        
        if number[ww] < number[w]
            p, w, pp, ww = pp, ww, p, w
        end

        # if `flag` is zero, then `ww` is reachable by `w`
        flag = pr3_reach!(ww, stack5,
            target, begptr, endptr, invptr, w) do ww, qq, xx
            
            if ww == xx
                ww = zero(V)
            end

            return ww
        end
        
        if iszero(flag)
            # w ─── ww
            # │  ╱
            # v

            # remove `v` from the stack of degree 2 elements
            hi2 = pr3_stack_del!(stack2, index2, hi2, v)

            # add `v` to the stack of eliminated vertices
            hi4 = pr3_stack_add!(stack4, hi4, v)

            # `v` is simplicial: update the lower bound
            width = max(width, degree[v])

            if istwo(number[w])
                # if `w` has degree 2, remove it from the stack
                # of degree 2 elements
                hi2 = pr3_stack_del!(stack2, index2, hi2, w)

                # add `w` to the stack of degree 1 elements
                hi1 = pr3_stack_add!(stack1, index1, hi1, w)
            elseif isthree(number[w])
                # if `w` has degree 3, remove it from the stack
                # of degree 3 elements
                hi3 = pr3_stack_del!(stack3, index3, hi3, w)

                # add `w` to the stack of degree 2 elements
                hi2 = pr3_stack_add!(stack2, index2, hi2, w)
            elseif isfour(number[w])
                # if `w` has degree 4, add it to the stack
                # of degree 3 elements
                hi3 = pr3_stack_add!(stack3, index3, hi3, w)
            end

            if istwo(number[ww])
                # if `ww` has degree 2, remove it from the stack
                # of degree 2 elements
                hi2 = pr3_stack_del!(stack2, index2, hi2, ww)

                # add `ww` to the stack of degree 1 elements
                hi1 = pr3_stack_add!(stack1, index1, hi1, ww)
            elseif isthree(number[ww])
                # if `ww` has degree 3, remove it from the stack
                # of degree 3 elements
                hi3 = pr3_stack_del!(stack3, index3, hi3, ww)

                # add `ww` to the stack of degree 2 elements
                hi2 = pr3_stack_add!(stack2, index2, hi2, ww)
            elseif isfour(number[ww])
                # if `ww` has degree 4, add it to the stack
                # of degree 3 elements
                hi3 = pr3_stack_add!(stack3, index3, hi3, ww)
            end

            # remove `v` from the reachable sets of `w` and `ww`
            pr3_reach_del!(source, target, endptr, invptr, invptr[p])
            pr3_reach_del!(source, target, endptr, invptr, invptr[pp])

            # decrement the degree of `w` and `ww`
            number[w] -= one(V)
            number[ww] -= one(V)

            # decrease the weighted degree of `w` and `ww` by the
            # weight of `v`
            degree[w] -= weight[v]
            degree[ww] -= weight[v]
        elseif degree[v] < width + tol && min(weight[w], weight[ww]) < weight[v] + tol
            # w     ww
            # │  ╱
            # v

            # add `v` to the stack of eliminated vertices
            hi4 = pr3_stack_add!(stack4, hi4, v)

            # remove `v` from the stack of degree 2 vertices
            hi2 = pr3_stack_del!(stack2, index2, hi2, v)

            pinv = invptr[p]
            ppinv = invptr[pp]
            
            # replace `v` with `ww` in the reachable set of `w`
            target[pinv] = ww; invptr[pinv] = ppinv

            # replace `v` with `w` in the reachable set of `ww`
            target[ppinv] = w; invptr[ppinv] = pinv

            # increase the weighted degree of `w` by the weight
            # of `ww` and decrease it by the weight of `v`          
            degree[w] -= (weight[v] - weight[ww])

            # increase the weighted degree of `ww` by the weight
            # of `w` and decrease it by the weight of `v`          
            degree[ww] -= (weight[v] - weight[w])
        else
            i += one(V)
        end
    end
    
    return width, hi0, hi1, hi2, hi3, hi4
end

function pr3_3!(
        marker::AbstractVector{V},
        stack0::AbstractVector{V},
        stack1::AbstractVector{V},
        stack2::AbstractVector{V},
        stack3::AbstractVector{V},
        stack4::AbstractVector{V},
        stack5::AbstractVector{V},
        index0::AbstractVector{V},
        index1::AbstractVector{V},
        index2::AbstractVector{V},
        index3::AbstractVector{V},
        degree::AbstractVector{W},
        number::AbstractVector{V},
        source::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        weight::AbstractVector{W},
        width::W,
        tag::V,
        hi0::V,
        hi1::V,
        hi2::V,
        hi3::V,
        hi4::V,
    ) where {W, V, E}
    tol = tolerance(W)

    # `i` is an index into the stack of degree 3 elements
    i = one(V)

    # for all elements with degree 3...    
    @inbounds while i <= hi3
        # `v` is an element with degree 3
        v = stack3[i]

        # `w`, `ww`, and `www` are the elements reachable by `v`
        p, w, pp, ww, ppp, www = pr3_3_reach!(stack5,
            target, begptr, endptr, invptr, v)

        # sort `w`, `ww`, and `www` by degree
        (p, w), (pp, ww), (ppp, www) = sortthree((p, w), (pp, ww), (ppp, www)) do (p, w)
            @inbounds wnum = number[w]
            return wnum
        end

        # mark the elements reachable by `w` and not `ww` with `tag`
        # mark the elements reachable by `w` and `ww` with `tag` + 1
        # mark the elements reachable by `ww` and not `w` with `tag` + 2
        pr3_3_mark!(marker, stack5, target,
            begptr, endptr, invptr, tag, w, ww)

        # `f` is true if `ww` is reachable by `w`
        f = marker[ww] == tag

        # `ff` is true if `w` is reachable by `www`
        ff = tag <= marker[www] <= tag + one(V)

        # `fff` is true if `www` is reachable by `ww`
        fff = tag + one(V) <= marker[www]

        # sort `f`, `ff`, and `fff` by true value
        if f
            pp, ppp = ppp, pp
            ww, www = www, ww
            f, ff = ff, f
        end
        
        if ff
            p, pp = pp, p
            w, ww = ww, w
            ff, fff = fff, ff
        end
        
        if f
            pp, ppp = ppp, pp
            ww, www = www, ww
            f, ff = ff, f
        end
        
        if f
            # w ─── ww
            # │  ╳  │
            # v ─── www

            # remove `v` from the stack of degree 3 elements
            hi3 = pr3_stack_del!(stack3, index3, hi3, v)

            # add `v` to the stack of eliminated vertices
            hi4 = pr3_stack_add!(stack4, hi4, v)

            # `v` is simplicial: update the lower bound
            width = max(width, degree[v])

            if isthree(number[w])
                # if `w` has degree 3, remove it from the stack
                # of degree 3 elements
                hi3 = pr3_stack_del!(stack3, index3, hi3, w)

                # add `w` to the stack of degree 2 elements
                hi2 = pr3_stack_add!(stack2, index2, hi2, w)
            elseif isfour(number[w])
                # if `w` has degree 4, add it to the stack of
                # degree 3 elements
                hi3 = pr3_stack_add!(stack3, index3, hi3, w)
            end

            if isthree(number[ww])
                # if `ww` has degree 3, remove it from the stack
                # of degree 3 elements
                hi3 = pr3_stack_del!(stack3, index3, hi3, ww)

                # add `ww` to the stack of degree 2 elements
                hi2 = pr3_stack_add!(stack2, index2, hi2, ww)
            elseif isfour(number[ww])
                # if `ww` has degree 4, add it to the stack of
                # degree 3 elements
                hi3 = pr3_stack_add!(stack3, index3, hi3, ww)
            end

            if isthree(number[www])
                # if `www` has degree 3, remove it from the stack
                # of degree 3 elements
                hi3 = pr3_stack_del!(stack3, index3, hi3, www)

                # add `www` to the stack of degree 2 elements
                hi2 = pr3_stack_add!(stack2, index2, hi2, www)
            elseif isfour(number[www])
                # if `www` has degree 4, add it to the stack of
                # degree 3 elements
                hi3 = pr3_stack_add!(stack3, index3, hi3, www)
            end

            # remove `v` from the reachable sets of `w`, `ww`, and `www`
            pr3_reach_del!(source, target, endptr, invptr, invptr[p])
            pr3_reach_del!(source, target, endptr, invptr, invptr[pp])
            pr3_reach_del!(source, target, endptr, invptr, invptr[ppp])

            # decrement the degrees of `w`, `ww`, and `www`
            number[w] -= one(V)
            number[ww] -= one(V)
            number[www] -= one(V)

            # decrease the weighted degrees of `w`, `ww`, and `www`
            # by the weight of `v`
            degree[w] -= weight[v]
            degree[ww] -= weight[v]
            degree[www] -= weight[v]
        elseif ff && degree[v] < width + tol && min(weight[w], weight[ww]) < weight[v] + tol
            # w     ww
            # │  ╳  │
            # v ─── www

            # remove `v` from the stack of degree 3 elements
            hi3 = pr3_stack_del!(stack3, index3, hi3, v)

            # add `v` to the stack of eliminated vertices
            hi4 = pr3_stack_add!(stack4, hi4, v)

            if isthree(number[www])
                # if `www` has degree 3, remove it from the stack
                # of degree 3 elements
                hi3 = pr3_stack_del!(stack3, index3, hi3, www)

                # add `www` to the stack of degree 2 elements
                hi2 = pr3_stack_add!(stack2, index2, hi2, www)
            elseif isfour(number[www])
                # if `www` has degree 4, add it to the stack of
                # degree 3 elements
                hi3 = pr3_stack_add!(stack3, index3, hi3, www)
            end

            # remove `v` from the reachable set of `www`
            pr3_reach_del!(source, target, endptr, invptr, invptr[ppp])

            # decrement the degree of `www`
            number[www] -= one(V)

            # decrease the weighted degree of `www` by the
            # weight of `v`
            degree[www] -= weight[v]
            
            pinv = invptr[p]
            ppinv = invptr[pp]
            
            # replace `v` with `ww` in the reachable set of `w`
            target[pinv] = ww; invptr[pinv] = ppinv

            # replace `v` with `w` in the reachable set of `ww`
            target[ppinv] = w; invptr[ppinv] = pinv

            # increase the weighted degree of `w` by the weight of
            # `ww` and decrease it by the weight of `v`        
            degree[w] -= (weight[v] - weight[ww])

            # increase the weighted degree of `ww` by the weight of
            # `w` and decrease it by the weight of `v`        
            degree[ww] -= (weight[v] - weight[w])
        elseif fff && degree[v] < width + tol && weight[w] < weight[v] + tol
            # w     ww
            # │  ╱  │
            # v ─── www

            # remove `v` from the stack of degree 3 elements
            hi3 = pr3_stack_del!(stack3, index3, hi3, v)

            # add `v` to the stack of eliminated vertices
            hi4 = pr3_stack_add!(stack4, hi4, v)

            if isone(number[w])
                # if `w` has degree 1, remove it from the stack
                # of degree 1 elements
                hi1 = pr3_stack_del!(stack1, index1, hi1, w)

                # add `w` to the stack of degree 2 elements
                hi2 = pr3_stack_add!(stack2, index2, hi2, w)
            elseif istwo(number[w])
                # if `w` has degree 2, remove it from the stack
                # of degree 2 elements
                hi2 = pr3_stack_del!(stack2, index2, hi2, w)

                # add `w` to the stack of degree 3 elements
                hi3 = pr3_stack_add!(stack3, index3, hi3, w)
            elseif isthree(number[w])
                # if `w` has degree 3, remove it from the stack
                # of degree 3 elements
                hi3 = pr3_stack_del!(stack3, index3, hi3, w)
            end
            
            # increment the degree of `w`
            number[w] += one(V)
            
            pinv = invptr[p]
            ppinv = invptr[pp]
            pppinv = invptr[ppp]
     
            # turn `v` into a supernode       
            target[pinv] = -v

            # replace `v` with `w` in the reachable sets of `ww` and `www`
            target[ppinv] = w
            target[pppinv] = w

            # increase the weighted degree of `w` by the weights of
            # `ww` and `www` and decrease it by the weight of `v`        
            degree[w] -= (weight[v] - weight[ww] - weight[www])

            # increase the weighted degree of `ww` by the weight
            # of `w` and decrease it by the weight of `v`
            degree[ww] -= (weight[v] - weight[w])

            # increase the weighted degree of `www` by the weight
            # of `w` and decrease it by the weight of `v`
            degree[www] -= (weight[v] - weight[w])

            # remove `w` from the reachable set of `v`
            pr3_reach_del!(source, target, endptr, invptr, p)
        else
            flag = false

            if !fff && degree[v] < width + tol
                # w     ww
                # │  ╱  
                # v ─── www

                # search for a buddy `vv`
                vv = pr3_buddy_reach!(marker, stack5, degree, number, target,
                    begptr, endptr, invptr, weight, width, tag, v, w, ww, www)

                # if a buddy was found ...
                if ispositive(vv)
                    # w ────────── vv
                    # │         ╱  │
                    # │     ww     │
                    # │  ╱         │
                    # v ────────── www

                    # remove `v` and `vv` from the stack of degree 3 elements
                    hi3 = pr3_stack_del!(stack3, index3, hi3, v)
                    hi3 = pr3_stack_del!(stack3, index3, hi3, vv)

                    # add `v` and `vv` to the stack of eliminated vertices
                    hi4 = pr3_stack_add!(stack4, hi4, v)
                    hi4 = pr3_stack_add!(stack4, hi4, vv)

                    # eliminate `v` and `vv`
                    pr3_buddy!(stack5, degree, source, target, begptr, endptr,
                        invptr, weight, v, vv, p, w, pp, ww, ppp, www)

                    flag = true
                end
            end

            if !fff && !flag && isthree(number[w]) && isthree(number[ww]) && isthree(number[www]) && max(degree[w], degree[ww], degree[www]) < width + tol
                # search for a cube `x`, `y`, and `z`
                q, qq, r, rr, s, ss, x, y, z = pr3_cube_reach!(stack5,
                    target, begptr, endptr, invptr, weight, v, w, ww, www)

                # if a cube was found...
                if ispositive(q)
                    #       x
                    #    ╱     ╲
                    # w           ww
                    # │  ╲     ╱  │
                    # │     v     │
                    # z     │     y
                    #    ╲  │  ╱
                    #      www

                    # `v` will be simplicial after eliminating `w`, `ww`, and `www`:
                    # update the lower bound
                    width = max(width, degree[v])

                    # remove `w`, `ww`, `www`, and `v` from the stack
                    # of degree 3 elements
                    hi3 = pr3_stack_del!(stack3, index3, hi3, w)
                    hi3 = pr3_stack_del!(stack3, index3, hi3, ww)
                    hi3 = pr3_stack_del!(stack3, index3, hi3, www)
                    hi3 = pr3_stack_del!(stack3, index3, hi3, v)

                    # add `w`, `ww`, `www`, and `v` to the stack of
                    # eliminated vertices
                    hi4 = pr3_stack_add!(stack4, hi4, w)
                    hi4 = pr3_stack_add!(stack4, hi4, ww)
                    hi4 = pr3_stack_add!(stack4, hi4, www)
                    hi4 = pr3_stack_add!(stack4, hi4, v)

                    # eliminate `w`, `ww`, `www`, and `v`
                    hi2, hi3 = pr3_cube!(marker, stack2, stack3, stack5, index2, index3, 
                        number, degree, source, target, begptr, endptr, invptr,
                        weight, tag, hi2, hi3, w, ww, www, q, qq, r, rr, s, ss, x, y, z)

                    flag = true
                end
            end

            if !flag
                i += one(V)
            end
        end

        tag += six(V)
    end

    return width, tag, hi0, hi1, hi2, hi3, hi4
end

function pr3_buddy!(
        stack5::AbstractVector{V},
        degree::AbstractVector{W},
        source::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        weight::AbstractVector{W},
        v::V,
        vv::V,
        p::E,
        w::V,
        pp::E,
        ww::V,
        ppp::E,
        www::V,
    ) where {W, V, E}
    # w ────────── vv
    # │         ╱  │
    # │     ww     │
    # │  ╱         │
    # v ────────── www
    q = qq = qqq = zero(E)

    q, qq, qqq = pr3_reach!((q, qq, qqq),
        stack5, target, begptr, endptr, invptr, vv) do (q, qq, qqq), qnxt, wnxt

        if w == wnxt
            q = qnxt
        elseif ww == wnxt
            qq = qnxt
        elseif www == wnxt
            qqq = qnxt
        end

        return (q, qq, qqq)
    end

    @inbounds pinv = invptr[p]
    @inbounds ppinv = invptr[pp]
    @inbounds pppinv = invptr[ppp]

    @inbounds qinv = invptr[q]
    @inbounds qqinv = invptr[qq]
    @inbounds qqqinv = invptr[qqq]

    # replace `v` with `ww` in the reachable set of `w`   
    @inbounds target[pinv] = ww
    @inbounds invptr[pinv] = qqinv

    # replace `v` with `www` in the reachable set of `ww`
    @inbounds target[ppinv] = www
    @inbounds invptr[ppinv] = qqqinv

    # replace `v` with `w` in the reachable set of `www`
    @inbounds target[pppinv] = w
    @inbounds invptr[pppinv] = qinv

    # replace `vv` with `www` in the reachable set of `w` 
    @inbounds target[qinv] = www
    @inbounds invptr[qinv] = pppinv

    # replace `vv` with `w` in the reachable set of `ww`
    @inbounds target[qqinv] = w
    @inbounds invptr[qqinv] = pinv

    # replace `vv` with `ww` in the reachable set of `www`
    @inbounds target[qqqinv] = ww
    @inbounds invptr[qqqinv] = ppinv

    # decrease the weighted degree of `w` by the weights of `v` 
    # and `vv`, and increase it by the weights of `ww` and `www`
    @inbounds degree[w] -= (weight[v] + weight[vv] - weight[ww] - weight[www])

    # decrease the weighted degree of `ww` by the weights of `v` 
    # and `vv`, and increase it by the weights of `w` and `www`
    @inbounds degree[ww] -= (weight[v] + weight[vv] - weight[w] - weight[www])

    # decrease the weighted degree of `www` by the weights of `v` 
    # and `vv`, and increase it by the weights of `w` and `ww`
    @inbounds degree[www] -= (weight[v] + weight[vv] - weight[w] - weight[ww])                
    return
end

function pr3_3_reach!(
        stack5::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        v::V,
    ) where {V, E}
    p = pp = ppp = zero(E)
    w = ww = www = zero(V)
    
    p, w, pp, ww, ppp, www = pr3_reach!((p, w, pp, ww, ppp, www),
        stack5, target, begptr, endptr, invptr, v) do (p, w, pp, ww, ppp, www), pnxt, wnxt
        
        if iszero(w)
            p, w = pnxt, wnxt
        elseif iszero(ww)
            pp, ww = pnxt, wnxt
        elseif iszero(www)
            ppp, www = pnxt, wnxt
        end
        
        return (p, w, pp, ww, ppp, www)    
    end

    return (p, w, pp, ww, ppp, www)
end

function pr3_3_mark!(
        marker::AbstractVector{V},
        stack5::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        tag::V,
        w::V,
        ww::V,
    ) where {V, E}
    # mark elements reachable by `w` with `tag`
    pr3_reach!(nothing, stack5,
        target, begptr, endptr, invptr, w) do _, _, x
        @inbounds marker[x] = tag
        return
    end

    # mark elements reachable by `ww` and `w` with `tag` + 1
    # mark elements reachable by `ww` and not `w` with `tag` + 2
    pr3_reach!(nothing, stack5,
        target, begptr, endptr, invptr, ww) do _, _, xx
        @inbounds xxtag = marker[xx]

        if xxtag == tag
            @inbounds marker[xx] = tag + one(V)
        else
            @inbounds marker[xx] = tag + two(V)
        end

        return
    end

    return
end

function pr3_buddy_reach!(
        marker::AbstractVector{V},
        stack5::AbstractVector{V},
        degree::AbstractVector{W},
        number::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        weight::AbstractVector{W},
        width::W,
        tag::V,
        v::V, 
        w::V,
        ww::V,
        www::V,
    ) where {V, E, W}
    tol = tolerance(W)

    # `vwgt` is the weight of `v`
    @inbounds vwgt = weight[v]

    # `wwgt` is the weight of `w`
    @inbounds wwgt = weight[w]

    # `wwwgt` is the weight of `ww`
    @inbounds wwwgt = weight[ww]

    # `wwwwgt` is the weight of `www`
    @inbounds wwwwgt = weight[www]

    # sort the weights of `w`, `ww`, and `www`
    minwgt, medwgt, maxwgt = sortthree(wwgt, wwwgt, wwwwgt)

    # `vv` is a buddy of `v`
    vv = zero(V)

    vv = pr3_reach!(vv, stack5,
        target, begptr, endptr, invptr, www) do vv, _, vnxt

        if iszero(vv) && v != vnxt
            @inbounds nxtdeg = degree[vnxt]

            if nxtdeg < width + tol
                @inbounds nxtnum = number[vnxt]

                if isthree(nxtnum)
                    @inbounds nxttag = marker[vnxt]

                    if nxttag == tag + one(V)
                        @inbounds nxtwgt = weight[vnxt]

                        if minwgt < min(vwgt, nxtwgt) + tol && medwgt < max(vwgt, nxtwgt) + tol
                            vv = vnxt
                        end
                    end
                end
            end
        end

        return vv
    end

    return vv
end

function pr3_cube_reach!(
        stack5::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        weight::AbstractVector{W},
        v::V, 
        w::V,
        ww::V,
        www::V,
    ) where {V, E, W}
    tol = tolerance(W)

    # `x`, `xx` and `xxx` are elements reachable by `w`
    q, x, qq, xx, qqq, xxx = pr3_3_reach!(stack5,
        target, begptr, endptr, invptr, w)        

    # `y`, `yy` and `yyy` are elements reachable by `ww`
    r, y, rr, yy, rrr, yyy = pr3_3_reach!(stack5,
        target, begptr, endptr, invptr, ww)        

    # `z`, `zz`, and `zzz` are elements reachable by `www`
    s, z, ss, zz, sss, zzz = pr3_3_reach!(stack5,
        target, begptr, endptr, invptr, www)        

    # ensure that `v` = `xxx`
    (q, x), (qq, xx), (qqq, xxx) = sortthree((q, x), (qq, xx), (qqq, xxx)) do (_, x)
        return x == v
    end

    # ensure that `v` = `yyy`
    (r, y), (rr, yy), (rrr, yyy) = sortthree((r, y), (rr, yy), (rrr, yyy)) do (_, y)
        return y == v
    end

    # ensure that `v` = `zzz`
    (s, z), (ss, zz), (sss, zzz) = sortthree((s, z), (ss, zz), (sss, zzz)) do (_, z)
        return z == v
    end

    # copy `z` to avoid boxing
    zc = z

    # ensure that `z` = `xx`
    (q, x), (qq, xx) = sorttwo((q, x), (qq, xx)) do (_, x)
        x == zc
    end

    # copy `x` to avoid boxing
    xc = x

    # ensure that `x` = `yy`
    (r, y), (rr, yy) = sorttwo((r, y), (rr, yy)) do (_, y)
        y == xc
    end

    # `wwgt` is the weight of `w`
    @inbounds wwgt = weight[w]

    # `wwwgt` is the weight of `ww`
    @inbounds wwwgt = weight[ww]

    # `wwwwgt` is the weight of `www`
    @inbounds wwwwgt = weight[www]

    # `xwgt` is the weight of `x`
    @inbounds xwgt = weight[x]

    # `ywgt` is the weight of `y`
    @inbounds ywgt = weight[y]

    # `zwgt` is the weight of `x`
    @inbounds zwgt = weight[z]

    if x != yy || y != zz || z != xx || (
            (wwgt + tol <= xwgt || wwwgt + tol <= ywgt || wwwwgt + tol <= zwgt) &&
            (wwgt + tol <= zwgt || wwwgt + tol <= xwgt || wwwwgt + tol <= ywgt)
        )

        q = qq = r = rr = s = ss = zero(E)
        x = y = z = zero(V)
    end

    return (q, qq, r, rr, s, ss, x, y, z)
end

function pr3_cube!(
        marker::AbstractVector{V},
        stack2::AbstractVector{V},
        stack3::AbstractVector{V},
        stack5::AbstractVector{V},
        index2::AbstractVector{V},
        index3::AbstractVector{V},
        number::AbstractVector{V},
        degree::AbstractVector{W},
        source::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        weight::AbstractVector{W},
        tag::V,
        hi2::V,
        hi3::V,
        w::V, ww::V, www::V,
        q::E, qq::E, r::E, rr::E,
        s::E, ss::E, x::V, y::V, z::V,
    ) where {W, V, E}
    #       x
    #    ╱     ╲
    # w           ww
    # │  ╲     ╱  │
    # │     v     │
    # z     │     y
    #    ╲  │  ╱
    #      www

    # mark elements reachable by `x` and not `y` with `tag` + 3
    # mark elements reachable by `y` and `x` with `tag` + 4
    # mark elements reachable by `y` and not `x` with `tag` + 5
    pr3_3_mark!(marker, stack5, target, begptr,
        endptr, invptr, tag + three(V), x, y)

    @inbounds xtag = marker[x]
    @inbounds ztag = marker[z]

    @inbounds xnum = number[x]
    @inbounds ynum = number[y]
    @inbounds znum = number[z]

    @inbounds xdeg = degree[x]
    @inbounds ydeg = degree[y]
    @inbounds zdeg = degree[z]

    @inbounds xwgt = weight[x]
    @inbounds ywgt = weight[y]
    @inbounds zwgt = weight[z]

    @inbounds wwgt = weight[w]
    @inbounds wwwgt = weight[ww]
    @inbounds wwwwgt = weight[www]

    @inbounds qinv = invptr[q]
    @inbounds qqinv = invptr[qq]
   
    if tag + three(V) <= ztag <= tag + four(V)  
        # w ─── x
        # │  ╱
        # z

        # remove `w` from the reachable sets of `x` and `z`
        pr3_reach_del!(source, target, endptr, invptr, qinv)
        pr3_reach_del!(source, target, endptr, invptr, qqinv)

        if isthree(xnum)
            # if `x` has degree 3, remove it from the stack
            # of degree 3 elements
            hi3 = pr3_stack_del!(stack3, index3, hi3, x)

            # add `x` to the stack of degree 2 elements
            hi2 = pr3_stack_add!(stack2, index2, hi2, x)
        elseif isfour(xnum)
            # if `x` has degree 4, add it to the stack
            # of degree 3 elements
            hi3 = pr3_stack_add!(stack3, index3, hi3, x)
        end

        if isthree(znum)
            # if `z` has degree 3, remove it from the stack
            # of degree 3 elements
            hi3 = pr3_stack_del!(stack3, index3, hi3, z)

            # add `x` to the stack of degree 2 elements
            hi2 = pr3_stack_add!(stack2, index2, hi2, z)
        elseif isfour(znum)
            # if `z` has degree 4, add it to the stack
            # of degree 3 elements
            hi3 = pr3_stack_add!(stack3, index3, hi3, z)
        end

        # decrement the degree of `x` and `z`
        xnum -= one(V)
        znum -= one(V)

        # decrease the weighted degree of `x` and `z` by the
        # weight of `w`
        xdeg -= wwgt
        zdeg -= wwgt
    else
        # w ─── x
        # │
        # z

        # replace `w` with `z` in the reachable set of `x`
        @inbounds target[qinv] = z; invptr[qinv] = qqinv

        # replace `w` with `x` in the reachable set of `z`
        @inbounds target[qqinv] = x; invptr[qqinv] = qinv

        # increase the weighted degree of of `x` by the weight
        # of `z` and decrease it by the weight of `w`
        xdeg -= (wwgt - zwgt)

        # increase the weighted degree of `z` by the weight
        # of `x` and decrease it by the weight of `w`
        zdeg -= (wwgt - xwgt)
    end

    @inbounds rinv = invptr[r]
    @inbounds rrinv = invptr[rr]
  
    if tag + four(V) <= xtag
        # ww ─── y
        #  │  ╱
        #  x

        # remove `ww` from the reachable sets of `y` and `x`
        pr3_reach_del!(source, target, endptr, invptr, rinv)
        pr3_reach_del!(source, target, endptr, invptr, rrinv)

        if isthree(ynum)
            # if `y` has degree 3, remove it from the stack
            # of degree 3 elements
            hi3 = pr3_stack_del!(stack3, index3, hi3, y)

            # add `y` to the stack of degree 2 elements
            hi2 = pr3_stack_add!(stack2, index2, hi2, y)
        elseif isfour(ynum)
            # if `y` has degree 4, add it to the stack
            # of degree 3 elements
            hi3 = pr3_stack_add!(stack3, index3, hi3, y)
        end

        if isthree(xnum)
            # if `x` has degree 3, remove it from the stack
            # of degree 3 elements
            hi3 = pr3_stack_del!(stack3, index3, hi3, x)

            # add `x` to the stack of degree 2 elements
            hi2 = pr3_stack_add!(stack2, index2, hi2, x)
        elseif isfour(xnum)
            # if `x` has degree 4, add it to the stack
            # of degree 3 elements
            hi3 = pr3_stack_add!(stack3, index3, hi3, x)
        end

        # decrement the degree of `y` and `x`
        ynum -= one(V)
        xnum -= one(V)

        # decrease the weighted degree of `y` and `x` by the
        # weight of `ww`
        ydeg -= wwwgt
        xdeg -= wwwgt
    else
        # ww ─── y
        #  │
        #  x

        # replace `ww` with `x` in the reachable set of `y`
        @inbounds target[rinv] = x; invptr[rinv] = rrinv

        # replace `ww` with `y` in the reachable set of `x`
        @inbounds target[rrinv] = y; invptr[rrinv] = rinv

        # increase the weighted degree of of `y` by the weight
        # of `x` and decrease it by the weight of `ww`
        ydeg -= (wwwgt - xwgt)

        # increase the weighted degree of `x` by the weight
        # of `y` and decrease it by the weight of `ww`
        xdeg -= (wwwgt - ywgt)
    end

    @inbounds sinv = invptr[s]
    @inbounds ssinv = invptr[ss]
   
    if tag + four(V) <= ztag
        # www ─── z
        #   │  ╱
        #   y

        # remove `www` from the reachable sets of `z` and `y`
        pr3_reach_del!(source, target, endptr, invptr, sinv)
        pr3_reach_del!(source, target, endptr, invptr, ssinv)

        if isthree(znum)
            # if `z` has degree 3, remove it from the stack
            # of degree 3 elements
            hi3 = pr3_stack_del!(stack3, index3, hi3, z)

            # add `x` to the stack of degree 2 elements
            hi2 = pr3_stack_add!(stack2, index2, hi2, z)
        elseif isfour(znum)
            # if `z` has degree 4, add it to the stack
            # of degree 3 elements
            hi3 = pr3_stack_add!(stack3, index3, hi3, z)
        end

        if isthree(ynum)
            # if `y` has degree 3, remove it from the stack
            # of degree 3 elements
            hi3 = pr3_stack_del!(stack3, index3, hi3, y)

            # add `y` to the stack of degree 2 elements
            hi2 = pr3_stack_add!(stack2, index2, hi2, y)
        elseif isfour(ynum)
            # if `y` has degree 4, add it to the stack
            # of degree 3 elements
            hi3 = pr3_stack_add!(stack3, index3, hi3, y)
        end

        # decrement the degree of `z` and `y`
        znum -= one(V)
        ynum -= one(V)

        # decrease the weighted degree of `z` and `y` by the
        # weight of `www`
        zdeg -= wwwwgt
        ydeg -= wwwwgt
    else
        # www ─── z
        #   │
        #   y

        # replace `www` with `y` in the reachable set of `z`
        @inbounds target[sinv] = y; invptr[sinv] = ssinv

        # replace `www` with `z` in the reachable set of `x`
        @inbounds target[ssinv] = z; invptr[ssinv] = sinv

        # increase the weighted degree of of `z` by the weight
        # of `y` and decrease it by the weight of `www`
        zdeg -= (wwwwgt - ywgt)

        # increase the weighted degree of `y` by the weight
        # of `z` and decrease it by the weight of `www`
        ydeg -= (wwwwgt - zwgt)
    end

    @inbounds number[x] = xnum
    @inbounds number[y] = ynum
    @inbounds number[z] = znum

    @inbounds degree[x] = xdeg
    @inbounds degree[y] = ydeg
    @inbounds degree[z] = zdeg

    return hi2, hi3
end

function pr3_stack_del!(stack::AbstractVector{V}, index::AbstractVector{V}, hi::V, v::V) where {V}
    @inbounds i = index[v]
    
    if i < hi
        @inbounds x = stack[i] = stack[hi]; index[x] = i
    end

    hi -= one(V)
    return hi
end

function pr3_stack_add!(stack::AbstractVector{V}, index::AbstractVector{V}, hi::V, v::V) where {V}
    @inbounds hi = index[v] = pr3_stack_add!(stack, hi, v)
    return hi
end

function pr3_stack_add!(stack::AbstractVector{V}, hi::V, v::V) where {V}
    @inbounds hi += one(V); stack[hi] = v
    return hi
end

function pr3_stack_pop!(stack::AbstractVector{V}, hi::V) where {V}
    @inbounds v = stack[hi]; hi -= one(V)
    return hi, v
end

function pr3_reach_del!(
        source::AbstractVector{V},
        target::AbstractVector{V},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        p::E
    ) where {V, E}
    @inbounds pend = endptr[source[p]] -= one(E)

    if p < pend
        @inbounds x = target[p] = target[pend]

        if ispositive(x)
            @inbounds pinv = invptr[p] = invptr[pend]
            @inbounds invptr[pinv] = p
        end
    end

    return
end

function sorttwo(x, y)
    return sorttwo(identity, x, y)
end

function sorttwo(f::Function, x, y)
    if f(y) < f(x)
        x, y = y, x
    end

    return x, y
end

function sortthree(x, y, z)
    return sortthree(identity, x, y, z)
end

function sortthree(f::Function, x, y, z)
    x, y = sorttwo(f, x, y)
    y, z = sorttwo(f, y, z)
    x, y = sorttwo(f, x, y)
    return (x, y, z)
end

function pr3_reach!(
        combine::Function,
        result,
        vstack::AbstractVector{V},
        target::AbstractVector{V},
        begptr::AbstractVector{E},
        endptr::AbstractVector{E},
        invptr::AbstractVector{E},
        v::V,
    ) where {V, E}
    # push `v` to the stack
    @inbounds num = one(V); vstack[num] = v

    @inbounds while ispositive(num)
        # `vv` is a supernode adjacent to `v`
        vv = vstack[num]; num -= one(V)

        # the arcs {`pp`, ..., `ppend` - 1} are incident
        # to `vv`
        pp = begptr[vv]; ppend = endptr[vv]

        while pp < ppend
            # `ww` is adjacent to `vv` and reachable by `v`
            ww = target[pp]

            # if `ww` is an element, fold it into `result`
            if ispositive(ww)
                result = combine(result, pp, ww)
                pp += one(E)

            # otherwise, `ww` is a supernode
            else
                # `ppnxt` is the largest possible value of `ppend`
                ppnxt = begptr[vv + one(V)]

                # the arcs {`qq`, ..., `qqend` - 1} are incident
                # to `ww`
                ww = -ww; qq = begptr[ww]; qqend = endptr[ww]

                # while there is space, move neighbors of `ww` 
                # into the neighborhood of `vv`
                while ppend < ppnxt && qq < qqend
                    qqend -= one(E)

                    # `xx` is adjacent to `ww` and reachable by `v`
                    xx = target[ppend] = target[qqend]

                    if ispositive(xx)
                        # `xx` is an element; `ppinv` is the arc
                        # (`xx`, `v`)
                        ppinv = invptr[ppend] = invptr[qqend]
                        invptr[ppinv] = ppend
                    end

                    ppend += one(E)
                end

                endptr[ww] = qqend

                # if `ww` has more than two neighbors, push
                # it to the stack
                if qq < qqend - one(E)
                    num += one(V); vstack[num] = ww
                    pp += one(E)

                # if `ww` has only one neighbor `xx`, replace
                # `ww` with `xx` in the neighborhood of `vv` 
                elseif qq == qqend - one(E)
                    xx = target[pp] = target[qq]

                    if ispositive(xx)
                        # `xx` is an element; `ppinv` is the arc
                        # (`xx`, `v`)
                        ppinv = invptr[pp] = invptr[qq]
                        invptr[ppinv] = pp
                    end

                # if `ww` has no neighbors, replace it with a vertex
                # `xx` in the neighborhood of `vv`
                else
                    ppend -= one(E)

                    if pp < ppend
                        # `xx` is adjacent to `vv` and reachable by `v`
                        xx = target[pp] = target[ppend]

                        if ispositive(xx)
                            # `xx` is an element; `ppinv` is the arc
                            # (`xx`, `v`)
                            ppinv = invptr[pp] = invptr[ppend]
                            invptr[ppinv] = pp
                        end
                    end
                end
            end
        end

        endptr[vv] = ppend
    end

    return result
end

#**********************************************************************
#**********************************************************************
#*****   DEL_HEAP ... DELETE A NODE FROM A HEAP   *********************
#**********************************************************************
#**********************************************************************
#
#     AUTHORS:
#       ESMOND G. NG, LAWRENCE BERKELEY NATIONAL LABORAOTY
#       BARRY W. PEYTON, DALTON STATE COLLEGE
#
#     LAST UPDATED:
#       2025-09-22
#
#**********************************************************************
#
#     PURPOSE:
#       DEL_HEAP DELETES AN ELEMENT FROM A HEAP AND REBUILDS THE HEAP.
#
#       EACH ELEMENT HAS TWO FIELDS: (WEIGHT,VERTEX).  THE VERTEX
#       FIELD REFERS TO A VERTEX AND THE WEIGHT FIELD REFERS TO A
#       WEIGHT ASSOCIATED WITH THE VERETEX.  THE VERTICES ARE ASSUMED
#       TO BE UNIQUE INTEGERS FROM 1 TO N.  THE HEAP IS CONSTRUCTED
#       USING THE WEIGHTS.
#     
#     INPUT PARAMETERS:
#       HEAPSIZE    - IT IS THE NUMBER OF ELEMENTS IN HEAP.
#       VTX         - THE ELEMENT WITH VERTEX = VTX IS TO BE REMOVED
#                     FROM THE HEAP.
#
#     MODIFIED PARAMETERS:
#       HEAP(*)     - IT IS AN ARRAY OF SIZE 2*HEAPSIZE.  ON INPUT,
#                     IT CONTAINS A SET OF NODES THAT ARE IN A HEAP,
#                     WITH HEAP(2*K-1) CONTAINING THE WEIGHT OF NODE
#                     K AND HEAP(2*K) CONTAINING THE CORRESPONDING
#                     VERTEX.  ON OUTPUT, THE NODES ARE REARRANGED
#                     TO FORM A HEAP.
#       V2HEAP(*)   - V2HEAP IS A MAPPING OF THE VERTICES TO
#                     THE NODES IN HEAP.
#
#**********************************************************************
#
function del_heap(heap::AbstractVector{W}, heapsize::V, v2heap::AbstractVector{V}, vtx::V) where {V, W}
    
    #       -------------------
    #       LOCAL VARIABLES ...
    #       -------------------
    
    #       --------------------------------
    #       VTX IS THE VERTEX TO BE REMOVED.
    #       --------------------------------
    v = vtx

    if iszero(heapsize)
        return heapsize
    end
    
    #       ---------------------------------------------------
    #       I GIVES THE LOCATION OF THE VERTEX VTX IN THE HEAP.
    #       ---------------------------------------------------
    i = v2heap[v]

    if i < heapsize
        
        #           -----------------------------------------
        #           INDICATE THAT THE ELEMENT WITH VERTEX = V
        #           IS NO LONGER IN THE HEAP.
        #           -----------------------------------------
        v2heap[v] = zero(V)

        #           ----------------------------------------------------
        #           THE ELEMENT BEING REMOVED OCCUPIES HEAP(2*I)-1 AND
        #           HEAP(2*I).  MOVE THE LAST ELEMENT IN THE HEAP TO THE
        #           POSITION OCCUPIED BY THE DELETED ELEMENT.
        #           ----------------------------------------------------
        lp = twice(heapsize)
        ip = twice(i)

        v = convert(V, heap[lp])
        heap[ip] = convert(W, v)
        v2heap[v] = i
        heapsize -= one(V)

        wt = heap[lp - one(V)]

        #           -------------------------------------------------
        #           CALLING MOD_HEAP TO PUT THE WEIGHT IN THE CORRECT
        #           PLACE AND REBUILD THE HEAP.
        #           -------------------------------------------------
        mod_heap(heap, heapsize, v2heap, v, wt)

    else

        #           ---------------------------------------------
        #           THE ELEMENT BEING REMOVED IS THE LAST ELEMENT
        #           IN THE HEAP, SO THERE IS NOT MUCH TO DO.
        #           ---------------------------------------------
        v2heap[v] = zero(V)
        heapsize -= one(V)
    end
    
    return heapsize
end

"""
    SupernodeType

A type of supernode partition. The options are

| type                  | name                            |
|:--------------------- |:------------------------------- |
| [`Nodal`](@ref)       | nodal supernode partition       |
| [`Maximal`](@ref)     | maximal supernode partition     |
| [`Fundamental`](@ref) | fundamental supernode partition |
"""
abstract type SupernodeType end

"""
    Nodal <: SupernodeType

A nodal  supernode partition.
"""
struct Nodal <: SupernodeType end

"""
    Maximal <: SupernodeType

A maximal supernode partition.
"""
struct Maximal <: SupernodeType end

"""
    Fundamental <: SupernodeType

A fundamental supernode partition.
"""
struct Fundamental <: SupernodeType end

# Compact Clique Tree Data Structures in Sparse Matrix Factorizations
# Pothen and Sun
# Figure 4: The Clique Tree Algorithm 2
#
# Compute the maximal supernode partition of the montone transitive extension of an ordered graph.
# The complexity is O(n), where n = |V|.
function stree_impl!(
        new::AbstractVector{V},
        parent::AbstractVector{V},
        ancestor::AbstractVector{V},
        new_in_clique::AbstractVector{V},
        tree::Tree{V},
        colcount::AbstractVector{V},
        snd::Maximal,
    ) where {V}
    @assert length(tree) <= length(new)
    @assert length(tree) <= length(parent)
    @assert length(tree) <= length(ancestor)
    @assert length(tree) <= length(new_in_clique)
    @assert length(tree) <= length(colcount)
    snd = zero(V); n = last(tree)

    for v in tree
        u = zero(V); children = childindices(tree, v)

        for s in children
            if colcount[s] == colcount[v] + one(V)
                u = s
                break
            end
        end

        if ispositive(u)
            new_in_clique[v] = new_in_clique[u]

            for s in children
                if s != u
                    parent[new_in_clique[s]] = new_in_clique[v]
                    ancestor[new_in_clique[s]] = v
                end
            end
        else
            new_in_clique[v] = snd += one(V); new[snd] = v
            parent[snd] = ancestor[snd] = zero(V)

            for s in children
                parent[new_in_clique[s]] = new_in_clique[v]
                ancestor[new_in_clique[s]] = v
            end
        end
    end

    return Parent(snd, parent)
end

# Compute the fundamental supernode partition of the montone transitive extension of an ordered graph.
# The complexity is O(n), where n = |V|.
function stree_impl!(
        new::AbstractVector{V},
        parent::AbstractVector{V},
        ancestor::AbstractVector{V},
        new_in_clique::AbstractVector{V},
        tree::Tree{V},
        colcount::AbstractVector{V},
        snd::Fundamental,
    ) where {V}
    @assert length(tree) <= length(new)
    @assert length(tree) <= length(parent)
    @assert length(tree) <= length(ancestor)
    @assert length(tree) <= length(new_in_clique)
    @assert length(tree) <= length(colcount)
    snd = zero(V); n = last(tree)

    for v in tree
        u = zero(V); children = childindices(tree, v)

        if isone(length(children))
            u = only(children)
        end

        if ispositive(u) && colcount[u] == colcount[v] + one(V)
            new_in_clique[v] = new_in_clique[u]
        else
            new_in_clique[v] = snd += one(V); new[snd] = v
            parent[snd] = ancestor[snd] = zero(V)

            for s in children
                parent[new_in_clique[s]] = new_in_clique[v]
                ancestor[new_in_clique[s]] = v
            end
        end
    end

    return Parent(snd, parent)
end

# Compute the nodal supernode partition of the montone transitive extension of an ordered graph.
# The complexity is O(n), where n = |V|.
function stree_impl!(
        new::AbstractVector{V},
        parent::AbstractVector{V},
        ancestor::AbstractVector{V},
        new_in_clique::AbstractVector{V},
        tree::Tree{V},
        colcount::AbstractVector{V},
        snd::Nodal,
    ) where {V}
    @assert length(tree) <= length(new)
    @assert length(tree) <= length(parent)
    @assert length(tree) <= length(ancestor)
    n = last(tree)

    for i in tree
        j = parentindex(tree, i)

        if isnothing(j)
           j = zero(V)
        end 

        new[i] = i
        parent[i] = j
        ancestor[i] = j
    end

    return Parent(n, parent)
end

"""
    DEFAULT_SUPERNODE_TYPE = Maximal()

The default supernode partition.
"""
const DEFAULT_SUPERNODE_TYPE = Maximal()

# ===== syr2k! =====
# Symmetric rank-2k update: C = α(AB' + BA') + βC, writing only to the triangle.

function syr2k!(uplo::Val, trans::Val{TRANS}, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T <: BlasFloat, TRANS}
    if T <: Complex
        BLAS.her2k!(char(uplo), char(trans), convert(T, α), A, B, convert(real(T), β), C)
    else
        BLAS.syr2k!(char(uplo), char(trans), convert(T, α), A, B, convert(T, β), C)
    end

    return
end

function syr2k!(uplo::Val{UPLO}, trans::Val{TRANS}, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T, TRANS, UPLO}
    if TRANS === :N
        tB = Val(:C)
    else
        tB = Val(:N)
    end

    gemmt!(uplo, trans, tB, α, A, B, β, C)
    gemmt!(uplo, trans, tB, α, B, A, one(T), C)
    return
end

# ---------- #
# lowerbound #
# ---------- #
lowerbound(weights::AbstractVector, ::WidthOrAlgorithm) = error()

# ----------- #
# permutation #
# ----------- #

permutation(weights::AbstractVector, alg::PermutationOrAlgorithm) = error()

# --------------- #
# eliminationtree #
# --------------- #

eliminationtree(weights::AbstractVector, alg::PermutationOrAlgorithm) = error()

# --------- #
# treewidth #
# --------- #

treewidth(weights::AbstractVector, alg::PermutationOrAlgorithm) = error()

# -------- #
# treefill #
# -------- #

treefill(weights::AbstractVector, alg::PermutationOrAlgorithm) = error()

"""
    ischordal(graph)

Determine whether a simple graph is [chordal](https://en.wikipedia.org/wiki/Chordal_graph).
"""
function ischordal(graph)
    return isperfect(graph, permutation(graph; alg = MCS()))
end

function isperfect(graph, pair::Tuple)
    return isperfect(graph, pair...)
end

"""
    isperfect(graph, order::AbstractVector[, index::AbstractVector])

Determine whether an fill-reducing permutation is perfect.
"""
function isperfect(graph, order::AbstractVector, index::AbstractVector = invperm(order))
    return isperfect(BipartiteGraph(graph), order, index)
end

# Simple Linear-Time Algorithms to Test Chordality of BipartiteGraphs, Test Acyclicity of Hypergraphs, and Selectively Reduce Acyclic Hypergraphs
# Tarjan and Yannakakis
# Test for Zero Fill-In.
#
# Determine whether a fill-reducing permutation is perfect.
# The complexity is O(m + n), where m = |E| and n = |V|.
function isperfect(graph::AbstractGraph{V}, order::AbstractVector{V}, index::AbstractVector{V}) where {V}
    @assert nv(graph) <= length(order)
    @assert nv(graph) <= length(index)

    n = nv(graph)
    f = FVector{V}(undef, n)
    findex = FVector{V}(undef, n)

    @inbounds for i in oneto(n)
        w = order[i]; f[w] = w; findex[w] = i

        for v in neighbors(graph, w)
            if index[v] < i
                findex[v] = i

                if f[v] == v
                    f[v] = w
                end
            end
        end

        for v in neighbors(graph, w)
            if index[v] < i && findex[f[v]] < i
                return false
            end
        end
    end

    return true
end

"""
    color(graph[, order::AbstractVector, index::AbstractVector])

Compute a minimal vertex coloring of a chordal graph.
"""
function color(graph, pair::Tuple = permutation(graph; alg = MCS()))
    return color(graph, pair...)
end

function color(graph, order::AbstractVector, index::AbstractVector = invperm(order))
    return color(BipartiteGraph(graph), order, index)
end

function color(graph::AbstractGraph{V}, order::AbstractVector, index::AbstractVector) where {V}
    k = zero(V)
    label = fill(nv(graph) + one(V), nv(graph))
    color = Vector{V}(undef, nv(graph))
    lower = sympermute(graph, index, Reverse)

    @inbounds for v in reverse(vertices(lower))
        if outdegree(lower, v) >= k
            color[order[v]] = k += one(V)
        else
            for w in outneighbors(lower, v)
                label[color[order[w]]] = v
            end

            for i in oneto(k)
                if label[i] > v
                    color[order[v]] = i
                    break
                end
            end
        end
    end

    return Coloring(k, color)
end

function color(tree::CliqueTree{V}) where {V}
    n = nov(residuals(tree))
    color = Vector{V}(undef, n)
    label = Vector{V}(undef, n)
    label .= n + one(V)

    for bag in Iterators.reverse(tree)
        for v in separator(bag)
            label[color[v]] = n
        end

        c = one(V)

        for v in residual(bag)
            while label[c] <= n
                c += one(V)
            end

            color[v] = c; c += one(V)
        end

        n -= one(V)
    end

    return Coloring(treewidth(tree) + one(V), color)
end

# ===== gemm! =====

function gemm!(tA::Val, tB::Val, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}, β, C::AbstractMatrix{T}) where {T <: BlasFloat}
    BLAS.gemm!(char(tA), char(tB), convert(T, α), A, B, convert(T, β), C)
    return
end

function gemm!(tA::Val, tB::Val, α, A::AbstractMatrix, B::AbstractMatrix, β, C::AbstractMatrix)
    gemx!(tA, tB, α, A, B, β, C)
    return
end

function gemm!(tA::Val, tB::Val, α, ::AbstractVector, A::AbstractMatrix, B::AbstractMatrix, ::AbstractVector, β, C::AbstractMatrix, ::Val{:N})
    return gemm!(tA, tB, α, A, B, β, C)
end

function gemm!(tA::Val{TA}, tB::Val{TB}, α, W::AbstractVector, A::AbstractMatrix, B::AbstractMatrix, d::AbstractVector, β, C::AbstractMatrix, ::Val{:U}) where {TA, TB}
    D = reshape(view(W, 1:length(A)), size(A))
    copyrec!(D, A)

    if TA === :N
        cmul!(Val(:R), Val(:U), D, d)
    else
        cmul!(Val(:L), Val(:U), D, d)
    end

    gemm!(tA, tB, α, D, B, β, C)
    return
end

# ===== gemv! =====

function gemv!(tA::Val, α, A::AbstractMatrix{T}, b::AbstractVector{T}, β, c::AbstractVector{T}) where {T <: BlasFloat}
    BLAS.gemv!(char(tA), convert(T, α), A, b, convert(T, β), c)
    return
end

function gemv!(tA::Val, α, A::AbstractMatrix, b::AbstractVector, β, c::AbstractVector)
    gemx!(tA, Val(:N), α, A, b, β, c)
    return
end

# ===== gemx! =====

function gemx!(tA::Val{TA}, tB::Val{TB}, α, A::AbstractMatrix, B::AbstractVector, β, C::AbstractVector) where {TA, TB}
    gemx2!(tA, tB, α, A, B, β, C)
    return
end

function gemx!(tA::Val{TA}, tB::Val{TB}, α, A::AbstractMatrix, B::AbstractMatrix, β, C::AbstractMatrix) where {TA, TB}
    m = size(C, 1)
    n = size(C, 2)

    if TA === :N
        k = size(A, 2)
    else
        k = size(A, 1)
    end

    maxdim = max(m, n, k)

    if maxdim <= THRESHOLD
        gemx2!(tA, tB, α, A, B, β, C)
    else
        l = prevpow(2, maxdim) >> 1

        if m == maxdim
            C₁ = view(C,     1:l, :)
            C₂ = view(C, l + 1:m,  :)

            if TA === :N
                A₁ = view(A,     1:l, :)
                A₂ = view(A, l + 1:m,  :)
            else
                A₁ = view(A, :,     1:l)
                A₂ = view(A, :, l + 1:m)
            end

            gemx!(tA, tB, α, A₁, B, β, C₁)
            gemx!(tA, tB, α, A₂, B, β, C₂)

        elseif n == maxdim
            C₁ = view(C, :,     1:l)
            C₂ = view(C, :, l + 1:n)

            if TB === :N
                B₁ = view(B, :,     1:l)
                B₂ = view(B, :, l + 1:n)
            else
                B₁ = view(B,     1:l, :)
                B₂ = view(B, l + 1:n,  :)
            end

            gemx!(tA, tB, α, A, B₁, β, C₁)
            gemx!(tA, tB, α, A, B₂, β, C₂)

        else
            if TA === :N
                A₁ = view(A, :,     1:l)
                A₂ = view(A, :, l + 1:k)
            else
                A₁ = view(A,     1:l, :)
                A₂ = view(A, l + 1:k,  :)
            end

            if TB === :N
                B₁ = view(B,     1:l, :)
                B₂ = view(B, l + 1:k,  :)
            else
                B₁ = view(B, :,     1:l)
                B₂ = view(B, :, l + 1:k)
            end

            gemx!(tA, tB, α, A₁, B₁, β, C)
            gemx!(tA, tB, α, A₂, B₂, 1, C)
        end
    end

    return
end

@generated function gemx_tile!(c::AbstractVector, A::AbstractMatrix, b::AbstractVector, α, istrt, ::Val{TILE}) where {TILE}
    accm = Vector{Symbol}(undef, TILE)
    init = Vector{Expr}(undef,   TILE)
    updt = Vector{Expr}(undef,   TILE)
    stor = Vector{Expr}(undef,   TILE)

    for t in 1:TILE
        accm[t] = Symbol(:a, t)
        init[t] = :($(accm[t]) = z)
        updt[t] = :($(accm[t]) = muladd(A[istrt + $(t - 1), k], bk, $(accm[t])))
        stor[t] = :(@inbounds c[istrt + $(t - 1)] = muladd(α, $(accm[t]), c[istrt + $(t - 1)]))
    end

    return quote
        $(Expr(:meta, :inline))
        z = zero(promote_eltype(A, b))

        $(init...)

        @inbounds @simd for k in axes(A, 2)
            bk = b[k]
            $(updt...)
        end

        $(stor...)

        return
    end
end

function gemx2!(::Val{:N}, ::Val{:N}, α, A::AbstractMatrix, b::AbstractVector, β, c::AbstractVector)
    m = size(A, 1)
    #
    #     c ← β c
    #
    if iszero(β)
        @inbounds for i in 1:m
            c[i] = β
        end
    elseif !isone(β)
        @inbounds for i in 1:m
            c[i] *= β
        end
    end
    #
    #     c ← c + α A b
    #
    i = 1

    @inbounds while i + 15 <= m; gemx_tile!(c, A, b, α, i, Val(16)); i += 16; end
    @inbounds while i +  7 <= m; gemx_tile!(c, A, b, α, i, Val( 8)); i +=  8; end
    @inbounds while i +  3 <= m; gemx_tile!(c, A, b, α, i, Val( 4)); i +=  4; end
    @inbounds while i +  1 <= m; gemx_tile!(c, A, b, α, i, Val( 2)); i +=  2; end
    @inbounds while i      <= m; gemx_tile!(c, A, b, α, i, Val( 1)); i +=  1; end

    return
end

function gemx2!(::Val{:N}, ::Val{:N}, α, A::AbstractMatrix, B::AbstractMatrix, β, C::AbstractMatrix)
    if iszero(β)
        @inbounds @fastmath for j in axes(C, 2)
            for i in axes(C, 1)
                C[i, j] = β
            end
        end
    else
        @inbounds @fastmath for j in axes(C, 2)
            for i in axes(C, 1)
                C[i, j] *= β
            end
        end
    end

    @inbounds @fastmath for k in axes(A, 2)
        for j in axes(C, 2)
            Bkj = α * B[k, j]

            for i in axes(C, 1)
                C[i, j] += A[i, k] * Bkj
            end
        end
    end

    return
end

function gemx2!(::Val{:N}, ::Val{TB}, α, A::AbstractMatrix, B::AbstractVecOrMat, β, C::AbstractVecOrMat) where {TB}
    if iszero(β)
        @inbounds @fastmath for j in axes(C, 2)
            for i in axes(C, 1)
                C[i, j] = β
            end
        end
    else
        @inbounds @fastmath for j in axes(C, 2)
            for i in axes(C, 1)
                C[i, j] *= β
            end
        end
    end

    @inbounds @fastmath for k in axes(A, 2)
        for j in axes(C, 2)
            if TB === :C
                Bjk = α * conj(B[j, k])
            else
                Bjk = α * B[j, k]
            end

            for i in axes(C, 1)
                C[i, j] += A[i, k] * Bjk
            end
        end
    end

    return
end

@generated function gemx_dot_tile!(c::AbstractVector, A::AbstractMatrix, b::AbstractVector, α, ::Val{TA}, jstrt, ::Val{JAM}) where {TA, JAM}
    accm = Vector{Symbol}(undef, JAM)
    init = Vector{Expr}(undef,   JAM)
    updt = Vector{Expr}(undef,   JAM)
    stor = Vector{Expr}(undef,   JAM)

    for t in 1:JAM
        accm[t] = Symbol(:a, t)
        init[t] = :($(accm[t]) = z)

        if TA === :C
            updt[t] = :($(accm[t]) = muladd(conj(A[k, jstrt + $(t - 1)]), bk, $(accm[t])))
        else
            updt[t] = :($(accm[t]) = muladd(     A[k, jstrt + $(t - 1)],  bk, $(accm[t])))
        end

        stor[t] = :(@inbounds c[jstrt + $(t - 1)] = muladd(α, $(accm[t]), c[jstrt + $(t - 1)]))
    end

    return quote
        $(Expr(:meta, :inline))
        z = zero(promote_eltype(A, b))

        $(init...)

        @inbounds @simd for k in axes(A, 1)
            bk = b[k]
            $(updt...)
        end

        $(stor...)

        return
    end
end

function gemx2!(tA::Val{TA}, ::Val{:N}, α, A::AbstractMatrix, b::AbstractVector, β, c::AbstractVector) where {TA}
    n = size(A, 2)
    #
    #     c ← β c
    #
    if iszero(β)
        @inbounds for j in 1:n
            c[j] = β
        end
    elseif !isone(β)
        @inbounds for j in 1:n
            c[j] *= β
        end
    end
    #
    #     c ← c + α op(A) b   (column-jammed dot; outputs cascade 8→4→2→1)
    #
    j = 1

    @inbounds while j + 7 <= n; gemx_dot_tile!(c, A, b, α, tA, j, Val(8)); j += 8; end
    @inbounds while j + 3 <= n; gemx_dot_tile!(c, A, b, α, tA, j, Val(4)); j += 4; end
    @inbounds while j + 1 <= n; gemx_dot_tile!(c, A, b, α, tA, j, Val(2)); j += 2; end
    @inbounds while j     <= n; gemx_dot_tile!(c, A, b, α, tA, j, Val(1)); j += 1; end

    return
end

function gemx2!(::Val{TA}, ::Val{:N}, α, A::AbstractMatrix, B::AbstractMatrix, β, C::AbstractMatrix) where {TA}
    @inbounds @fastmath for j in axes(C, 2)
        for i in axes(C, 1)
            Δ = zero(promote_eltype(A, B))

            for k in axes(A, 1)
                if TA === :C
                    Δ += conj(A[k, i]) * B[k, j]
                else
                    Δ += A[k, i] * B[k, j]
                end
            end

            if iszero(β)
                C[i, j] = α * Δ
            else
                C[i, j] = α * Δ + β * C[i, j]
            end
        end
    end

    return
end

function gemx2!(::Val{TA}, ::Val{TB}, α, A::AbstractMatrix, B::AbstractVecOrMat, β, C::AbstractVecOrMat) where {TA, TB}
    @inbounds @fastmath for j in axes(C, 2)
        for i in axes(C, 1)
            Δ = zero(promote_eltype(A, B))

            for k in axes(A, 1)
                if TA === :C
                    Aki = conj(A[k, i])
                else
                    Aki = A[k, i]
                end

                if TB === :C
                    Δ += Aki * conj(B[j, k])
                else
                    Δ += Aki * B[j, k]
                end
            end

            if iszero(β)
                C[i, j] = α * Δ
            else
                C[i, j] = α * Δ + β * C[i, j]
            end
        end
    end

    return
end

abstract type AbstractLinkedList{I <: Integer} end

function ispositive(i::Integer)
    return i > zero(i)
end

function Base.popfirst!(list::AbstractLinkedList)
    @inbounds i = list.head[]
    @inbounds list.head[] = list.next[i]
    return i
end

function Base.empty!(list::AbstractLinkedList{I}) where {I}
    list.head[] = zero(I)
    return list
end

function Base.isempty(list::AbstractLinkedList)
    return iszero(list.head[])
end

#######################
# Iteration Interface #
#######################

@propagate_inbounds function Base.iterate(list::AbstractLinkedList{I}, i::I = list.head[]) where {I}
    if ispositive(i)
        @boundscheck checkbounds(list.next, i)
        @inbounds return (i, list.next[i])
    end

    return
end

function Base.IteratorSize(::Type{<:AbstractLinkedList})
    return Base.SizeUnknown()
end

function Base.eltype(::Type{<:AbstractLinkedList{I}}) where {I}
    return I
end

include("singly_linked_lists.jl")
include("doubly_linked_lists.jl")

function opnorm1(A::ChordalTriangular{DIAG, :L, T}) where {DIAG, T}
    out = zero(real(T))

    @inbounds for j in fronts(A)
        D, res = diagblock(A, j)
        L, sep = offdblock(A, j)

        for w in axes(D, 2)
            colsum = zero(real(T))

            for v in w:size(D, 1)
                colsum += abs(D[v, w])
            end

            for v in axes(L, 1)
                colsum += abs(L[v, w])
            end

            out = max(out, colsum)
        end
    end

    return out
end

function opnorm1(A::ChordalTriangular{DIAG, :U, T}) where {DIAG, T}
    colsums = zeros(real(T), size(A, 1))

    @inbounds for j in fronts(A)
        D, res = diagblock(A, j)
        L, sep = offdblock(A, j)

        for w in eachindex(res)
            for v in w:length(res)
                col = res[v]
                colsums[col] += abs(D[w, v])
            end

            for v in eachindex(sep)
                col = sep[v]
                colsums[col] += abs(L[w, v])
            end
        end
    end

    return maximum(colsums)
end

function opnorminf(A::ChordalTriangular{DIAG, :L, T}) where {DIAG, T}
    rowsums = zeros(real(T), size(A, 1))

    @inbounds for j in fronts(A)
        D, res = diagblock(A, j)
        L, sep = offdblock(A, j)

        for w in eachindex(res)
            for v in w:length(res)
                row = res[v]
                rowsums[row] += abs(D[v, w])
            end

            for v in eachindex(sep)
                row = sep[v]
                rowsums[row] += abs(L[v, w])
            end
        end
    end

    return maximum(rowsums)
end

function opnorminf(A::ChordalTriangular{DIAG, :U, T}) where {DIAG, T}
    out = zero(real(T))

    @inbounds for j in fronts(A)
        D, res = diagblock(A, j)
        L, sep = offdblock(A, j)

        for w in axes(D, 1)
            rowsum = zero(real(T))

            for v in w:size(D, 2)
                rowsum += abs(D[w, v])
            end

            for v in axes(L, 2)
                rowsum += abs(L[w, v])
            end

            out = max(out, rowsum)
        end
    end

    return out
end

function opnorm1(A::AdjOrTransTri)
    opnorminf(parent(A))
end

function opnorminf(A::AdjOrTransTri)
    opnorm1(parent(A))
end

function isparallel!(c, A, b)
    mul!(c, adjoint(A), b)

    for v in c
        if abs(v) == length(b)
            return true
        end
    end

    return false
end

# A Block Algorithm for Matrix 1-Norm Estimation,
# with an Application to 1-Norm Psuedospectra
#
# Higham and Tisseur
#
# Algorithm 2.4: practical block 1-norm estimator
function opnormest1(F, inv::Bool=false; numcols::Int=min(2, size(F, 1)), maxiter::Int=5)
    @assert 0 < numcols <= size(F, 1)

    n = size(F, 1); T = eltype(F)

    # integer vector recording indices of used unit vectors ej
    hst = Vector{Int}(undef, maxiter * numcols)

    row = Vector{Int}(undef, n)
    sgncur = Matrix{T}(undef, n, numcols)
    sgnold = Matrix{T}(undef, n, numcols)
    sgnaux = Vector{T}(undef, numcols)
    B = Matrix{T}(undef, n, numcols)
    C = Matrix{T}(undef, n, numcols)
    h = Vector{real(T)}(undef, n)

    # choose starting matrix B with columns of unit 1-norm
    fill!(view(B, :, 1), one(T))
    fill!(sgncur, zero(T))

    for j in 2:numcols
        while true
            rand!(view(B, :, j), (-1, 1))

            if !isparallel!(view(sgnaux, 1:j - 1), view(B, :, 1:j - 1), view(B, :, j))
                break
            end
        end
    end

    rdiv!(B, n)

    estcur = zero(real(T))
    estold = zero(real(T))
    estcol = 0

    for k in 1:maxiter
        if inv
            ldiv!(C, F, B)
        else
            mul!(C, F, B)
        end

        estcur = zero(real(T))
        estcol = 0

        for i in 1:numcols
            y = norm(view(C, :, i), 1)

            if y > estcur
                estcur = y
                estcol = i
            end
        end

        if k >= 2
            if k == 2 || estcur > estold
                maxrow = hst[(k - 2) * numcols + estcol]
            end

            if estcur <= estold
                estcur = estold
                break
            end
        end

        estold  = estcur
        sgnold .= sgncur

        k == maxiter && break

        for j in 1:numcols
            for i in 1:n
                if iszero(C[i, j])
                    sgncur[i, j] = one(C[i, j])
                else
                    sgncur[i, j] = sign(C[i, j])
                end
            end
        end

        if T <: Real
            # if every column of sgncur is parallel to a column of sgnold, break. 
            allparallel = true

            for j in 1:numcols
                allparallel || break
                allparallel = isparallel!(sgnaux, sgnold, view(sgncur, :, j))
            end

            allparallel && break

            # ensure no column of sgncur is parallel to another column of sgncur or to sgnold
            for j in 1:numcols
                repeated = false

                if j > 1
                    repeated = isparallel!(view(sgnaux, 1:j - 1), view(sgncur, :, 1:j - 1), view(sgncur, :, j))
                end

                if !repeated
                    repeated = isparallel!(sgnaux, sgnold, view(sgncur, :, j))
                end

                while repeated
                    rand!(view(sgncur, :, j), (-1, 1))

                    if j > 1
                        repeated = isparallel!(view(sgnaux, 1:j - 1), view(sgncur, :, 1:j - 1), view(sgncur, :, j))
                    end

                    if !repeated
                        repeated = isparallel!(sgnaux, sgnold, view(sgncur, :, j))
                    end
                end
            end
        end

        if inv
            ldiv!(C, adjoint(F), sgncur)
        else
            mul!(C, adjoint(F), sgncur)
        end

        maxh = zero(real(T))

        for i in 1:n
            h[i] = norm(view(C, i, 1:numcols), Inf)
            maxh = max(maxh, h[i])
        end

        k >= 2 && h[maxrow] == maxh && break

        sortperm!(row, h; rev=true, initialized=false)

        if numcols > 1
            addctr = numcols
            elmctr = 0

            while addctr > 0 && elmctr < n
                elmctr += 1
                elmcur = row[elmctr]
                found = false

                for i in 1:numcols * (k - 1)
                    found && break
                    found = elmcur == hst[i]
                end

                if !found
                    addctr -= 1

                    for i in 1:elmcur - 1
                        B[i, numcols - addctr] = 0
                    end

                    B[elmcur, numcols - addctr] = 1

                    for i in elmcur + 1:n
                        B[i, numcols - addctr] = 0
                    end

                    hst[k * numcols - addctr] = elmcur
                else
                    if elmctr == numcols && addctr == numcols
                        break
                    end
                end
            end
        else
            hst[k] = row[1]
            fill!(B, zero(T))
            B[row[1], 1] = one(T)
        end
    end

    return estcur
end

# Finding Structure with Randomness:
# Probabilistic Algorithms for Constructing
# Approximate Matrix Decompositions
#
# Halko, Martinsson, and Tropp
#
# Algorithm 4.4: Randomized Subspace Iteration
function opnormest2(F, inv::Bool=false; numcols::Int=6, maxiter::Int=2)
    B = randn(eltype(F), size(F, 2), numcols)
    C = similar(B)

    if inv
        ldiv!(C, F, B)
    else
        mul!(C, F, B)
    end

    copyto!(B, qr!(C).Q)

    for _ in 1:maxiter
        if inv
            ldiv!(C, F', B)
        else
            mul!(C, F', B)
        end

        copyto!(B, qr!(C).Q)

        if inv
            ldiv!(C, F, B)
        else
            mul!(C, F, B)
        end

        copyto!(B, qr!(C).Q)
    end

    if inv
        ldiv!(C, F, B)
    else
        mul!(C, F, B)
    end

    return first(svdvals!(C))
end

function condest1(F; kw...)
    opnormest1(F; kw...) * opnormest1(F, true; kw...)
end

function condest1(F::MaybeAdjOrTransTri; kw...)
    opnorm1(F) * opnormest1(F, true; kw...)
end

function condest2(F; kw...)
    opnormest2(F; kw...) * opnormest2(F, true; kw...)
end

# ===== factorize! Level 3: ChordalTriangular all positional (pivoted) =====

function factorize!(
        W::FactorizationWorkspace,
        L::ChordalTriangular{DIAG, UPLO, T, I},
        d::AbstractVector,
        P::Permutation,
        pivot::RowMaximum,
        signs::AbstractVector,
        reg::AbstractRegularization,
        tol::Real,
    ) where {DIAG, UPLO, T, I <: Integer}
    if reg isa NoRegularization
        R = convert(real(T), tol)
    else
        R = initialize(L, signs, reg)
    end

    info = chol_piv_impl!(W, L, d, P.perm, P.invp, signs, R)

    return info
end

# ============================= chol_piv_impl! =============================

function chol_piv_impl!(
        W::FactorizationWorkspace,
        L::ChordalTriangular{DIAG, UPLO, T, I},
        d::AbstractVector,
        perm::AbstractVector,
        invp::AbstractVector,
        signs::AbstractVector,
        R::Union{AbstractRegularization, Real},
    ) where {DIAG, UPLO, T, I <: Integer}
    return chol_piv_impl!(W.Mptr, W.Mval, W.Fval, W.piv, W.mval, W.fval, L, d, perm, invp, signs, R)
end

function chol_piv_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Fval::AbstractVector{T},
        piv::AbstractVector{<:Integer},
        mval::AbstractVector{I},
        fval::AbstractVector{I},
        L::ChordalTriangular{:N, UPLO, T, I},
        perm::AbstractVector{I},
        invp::AbstractVector{I},
        R::Union{AbstractRegularization, Real}=-one(real(T)),
    ) where {UPLO, T, I <: Integer}
    n = ncl(L)
    d = Ones{T}(n)
    S = Ones{T}(n)
    return chol_piv_impl!(Mptr, Mval, Fval, piv, mval, fval, L, d, perm, invp, S, R)
end

function chol_piv_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Fval::AbstractVector{T},
        piv::AbstractVector{<:Integer},
        mval::AbstractVector{I},
        fval::AbstractVector{I},
        L::ChordalTriangular{DIAG, UPLO, T, I},
        d::AbstractVector{T},
        perm::AbstractVector{I},
        invp::AbstractVector{I},
        S::AbstractVector{T},
        R::Union{AbstractRegularization, Real},
    ) where {DIAG, UPLO, T, I <: Integer}
    return chol_piv_impl!(
        Mptr, Mval,
        L.S.Dptr, L.Dval,
        L.S.Lptr, L.Lval,
        d, Fval, piv, mval, fval,
        L.S.res, L.S.rel, L.S.sep, L.S.chd,
        perm, invp, S, R, L.uplo, L.diag
    )
end

function chol_piv_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        piv::AbstractVector{<:Integer},
        mval::AbstractVector{I},
        fval::AbstractVector{I},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        sep::AbstractGraph{I},
        chd::AbstractGraph{I},
        perm::AbstractVector{I},
        invp::AbstractVector{I},
        S::AbstractVector{T},
        R::Union{AbstractRegularization, Real},
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, I <: Integer, UPLO, DIAG}

    info = chol_piv_fwd!(
        Mptr, Mval, Dptr, Dval, Lptr, Lval, d, Fval,
        res, rel, chd, piv, perm, S, R, uplo, diag
    )

    chol_piv_bwd!(Mptr, mval, fval, Dptr, Lptr, Lval, res, rel, sep, chd, perm, Fval, uplo)
    chol_piv_rel!(res, sep, rel, chd)

    @inbounds for i in eachindex(invp)
        invp[i] = perm[invp[i]]
    end

    @inbounds for i in eachindex(invp)
        perm[invp[i]] = i
    end

    return info
end

# ============================= chol_piv_fwd! =============================

function chol_piv_fwd!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        piv::AbstractVector{<:Integer},
        invp::AbstractVector{I},
        S::AbstractVector{T},
        R::Union{AbstractRegularization, Real},
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, I <: Integer, UPLO, DIAG}

    ns = info = zero(I); Mptr[one(I)] = one(I)

    for j in vertices(res)
        ns, localinfo = chol_piv_fwd_loop!(
            Mptr, Mval, Dptr, Dval, Lptr, Lval, d, Fval,
            res, rel, chd, ns, j, piv, invp, S, R, uplo, diag
        )

        if ispositive(localinfo) && iszero(info)
            info = localinfo + pointers(res)[j] - one(I)
        end
    end

    return info
end

function chol_piv_fwd_loop!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        piv::AbstractVector{<:Integer},
        invp::AbstractVector{I},
        S::AbstractVector{T},
        R::Union{AbstractRegularization, Real},
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, I <: Integer, UPLO, DIAG}
    #
    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    nn = eltypedegree(res, j)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁₁     ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₁₁ = view(F, oneto(nn),      oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
    end
    #
    # L is part of the factor
    #
    #          res(j)
    #     L = [ D₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # S₁₁ is the signs for the vertices in res(j)
    #
    S₁₁ = view(S, neighbors(res, j))
    #
    # d₁₁ is the diagonal workspace
    #
    #     Cholesky: use Fval (workspace)
    #     LDLt:     use view of d (actual diagonal storage)
    #
    if DIAG === :N
        d₁₁ = Fval
    else
        d₁₁ = view(d, neighbors(res, j))
    end
    #
    #     F ← 0
    #
    zerotri!(F, uplo)

    for i in Iterators.reverse(neighbors(chd, j))
        #
        # add the update matrix for child i to F
        #
        #   F ← F + Rᵢ Sᵢ Rᵢᵀ
        #
        chol_send!(F, Mptr, Mval, rel, ns, i, uplo)
        ns -= one(I)
    end
    #
    # add F to L
    #
    #     L ← L + F
    #
    addtri!(D₁₁, F₁₁, uplo)
    addrec!(L₂₁, F₂₁)
    #
    # pivoted factorization
    #
    info, rank = chol_piv_factor!(D₁₁, L₂₁, Fval, d₁₁, piv, S₁₁, R, uplo, diag)
    #
    # M₂₂ is the update matrix for node j
    #
    if ispositive(na)
        ns += one(I)
        strt = Mptr[ns]
        stop = Mptr[ns + one(I)] = strt + na * na
        M₂₂ = reshape(view(Mval, strt:stop - one(I)), na, na)
        #
        #     M₂₂ ← F₂₂
        #
        copytri!(M₂₂, F₂₂, uplo)
        #
        # Schur complement update
        #
        if ispositive(rank)
            rd = view(d₁₁, 1:rank)

            if UPLO === :L
                rL = view(L₂₁, :, 1:rank)
                trans = Val(:N)
            else
                rL = view(L₂₁, 1:rank, :)
                trans = Val(:C)
            end

            syrk!(uplo, trans, -one(real(T)), Fval, rL, rd, one(real(T)), M₂₂, diag)
        end
    end
    #
    # update invp with local pivot permutation
    # invp maps P-indices to Q-indices
    # piv[k] = p means vertex (off + p) gets Q-index (off + k)
    #
    off = pointers(res)[j] - one(I)

    @inbounds for v in oneto(nn)
        invp[off + piv[v]] = off + v
    end

    return ns, info
end

# ============================= chol_piv_factor! =============================

function chol_piv_factor!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        W::AbstractVector{T},
        d::AbstractVector{T},
        P::AbstractVector,
        S::AbstractVector{T},
        tol::Real,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, UPLO, DIAG}
    @assert size(D, 1) == size(D, 2)

    if UPLO === :L
        @assert size(L, 2) == size(D, 1)
    else
        @assert size(L, 1) == size(D, 1)
    end
    #
    # factorize D with pivoting
    #
    #     Pᵀ D P = L Lᵀ
    #
    info, rank = pstrf!(uplo, W, D, d, P, S, NoRegularization(), tol, diag)
    #
    # zero out the rank-deficient part of D
    #
    zerotri!(D, rank + 1:size(D, 1), uplo)

    if !isempty(L)
        #
        # permute L by pivot
        #
        M = reshape(view(W, 1:length(L)), size(L))
        copyrec!(M, L)

        if UPLO === :L
            copygatherrec!(L, M, P, Val(:R))
        else
            copygatherrec!(L, M, P, Val(:L))
        end
        #
        # zero out the rank-deficient part of L (after permutation)
        #
        if UPLO === :L
            zerorec!(L, rank + 1:size(D, 1), Val(:R))
        else
            zerorec!(L, rank + 1:size(D, 1), Val(:L))
        end
        #
        # triangular solve
        #
        if ispositive(rank)
            #
            # Use only the first `rank` columns/rows for the solve
            #
            rD = view(D, 1:rank, 1:rank)
            rd = view(d, 1:rank)

            if UPLO === :L
                rL = view(L, :, 1:rank)
                side = Val(:R)
            else
                rL = view(L, 1:rank, :)
                side = Val(:L)
            end
            #
            #     rL ← rL rD⁻ᴴ       (Cholesky)
            #     rL ← rL rD⁻ᴴ rd⁻¹  (LDLt)
            #
            trsm!(side, uplo, Val(:C), diag, one(T), rD, rL)
            cdiv!(side, diag, rL, rd)
        end
    end

    return info, rank
end

# ============================= chol_piv_bwd! =============================

function chol_piv_bwd!(
        mptr::AbstractVector{I},
        mval::AbstractVector{I},
        fval::AbstractVector{I},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        sep::AbstractGraph{I},
        chd::AbstractGraph{I},
        invp::AbstractVector{I},
        Fval::AbstractVector{T},
        uplo::Val{UPLO},
    ) where {T, I <: Integer, UPLO}

    ns = zero(I); mptr[one(I)] = one(I)

    for j in reverse(vertices(res))
        ns = chol_piv_bwd_loop!(
            mptr, mval, fval, Dptr, Lptr, Lval,
            res, rel, sep, chd, ns, j, invp, Fval, uplo
        )
    end

    return
end

function chol_piv_bwd_loop!(
        mptr::AbstractVector{I},
        mval::AbstractVector{I},
        fval::AbstractVector{I},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        sep::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        invp::AbstractVector{I},
        Fval::AbstractVector{T},
        uplo::Val{UPLO},
    ) where {T, I <: Integer, UPLO}
    #
    # nn is the size of the residual at node j
    #
    #     nn = |res(j)|
    #
    nn = eltypedegree(res, j)
    #
    # na is the size of the separator at node j
    #
    #     na = |sep(j)|
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = |bag(j)|
    #
    nj = nn + na
    #
    # f is the frontal Q-index vector at node j
    #
    #   f = [ f₁ ] nn
    #       [ f₂ ] na
    #
    f  = view(fval, oneto(nj))
    f₁ = view(f,    oneto(nn))
    f₂ = view(f,    nn + one(I):nj)
    #
    #     f₁ ← invp[res(j)]
    #
    copygatherrec!(f₁, invp, neighbors(res, j), Val(:L))
    #
    # pull Q-indices from ancestor's update matrix
    #
    #     f₂ ← m₂
    #
    if ispositive(na)
        strt = mptr[ns]
        m₂ = view(mval, strt:strt + na - one(I))
        ns -= one(I)
        copyrec!(f₂, m₂)
    end

    for i in neighbors(chd, j)
        #
        # push f restricted to sep(i) to child i
        #
        #     mᵢ ← Rᵢᵀ f
        #
        ns += one(I)
        chol_piv_bwd_update!(f, mptr, mval, rel, ns, i)
    end
    #
    # s₂ is the sorting permutation for sep(j) by Q-index
    #
    s₂ = neighbors(sep, j)
    sortperm!(s₂, f₂; alg=QuickSort, initialized=false)
    #
    # L₂₁ is the off-diagonal block of the Cholesky factor
    #
    #        nn
    #   L = [ L₂₁ ] na
    #
    Lp = Lptr[j]

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
        F₂₁ = reshape(view(Fval, oneto(na * nn)),           na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
        F₂₁ = reshape(view(Fval, oneto(nn * na)),           nn, na)
    end
    #
    # permute rows/cols of L₂₁ by s₂
    #
    copyrec!(F₂₁, L₂₁)

    if UPLO === :L
        copygatherrec!(L₂₁, F₂₁, s₂, Val(:L))
    else
        copygatherrec!(L₂₁, F₂₁, s₂, Val(:R))
    end
    #
    # update sep(j) targets with sorted Q-indices
    #
    #     sep(j) ← f₂[s₂]
    #
    copygatherrec!(s₂, f₂, s₂, Val(:L))

    return ns
end

function chol_piv_bwd_update!(
        f::AbstractVector{I},
        ptr::AbstractVector{I},
        val::AbstractVector{I},
        rel::AbstractGraph{I},
        ns::I,
        i::I,
    ) where {I <: Integer}
    #
    # na is the size of the separator at node i
    #
    #     na = |sep(i)|
    #
    na = eltypedegree(rel, i)
    #
    # inj: sep(i) → bag(parent(i))
    #
    inj = neighbors(rel, i)
    #
    # mᵢ ← Rᵢᵀ f
    #
    strt = ptr[ns]
    stop = ptr[ns + one(I)] = strt + na
    m = view(val, strt:stop - one(I))

    copygatherrec!(m, f, inj, Val(:L))

    return
end

# ============================= chol_piv_rel! =============================

function chol_piv_rel!(
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
    ) where {I <: Integer}

    for j in vertices(res)
        chol_piv_rel_loop!(res, sep, rel, chd, j)
    end

    return
end

function chol_piv_rel_loop!(
        res::AbstractGraph{I},
        sep::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        j::I,
    ) where {I <: Integer}
    #
    # nn is the size of the residual at node j
    #
    #     nn = |res(j)|
    #
    nn = eltypedegree(res, j)
    #
    # na is the size of the separator at node j
    #
    #     na = |sep(j)|
    #
    na = eltypedegree(sep, j)
    #
    # bag(j) = res(j) ∪ sep(j), both sorted by Q-index
    #
    res_j = neighbors(res, j)
    sep_j = neighbors(sep, j)
    #
    # for each child i, recompute rel(i)
    #
    #     rel(i) : sep(i) → bag(j)
    #
    for i in neighbors(chd, j)
        #
        # sep(i) ⊆ bag(j), both sorted by Q-index
        # use merge-style traversal to find positions
        #
        q = one(I)

        for p in incident(sep, i)
            v = targets(sep)[p]
            #
            # find v in bag(j)
            # bag(j)[q] = res_j[q] if q ≤ nn, else sep_j[q - nn]
            #
            while true
                if q <= nn
                    w = res_j[q]
                else
                    w = sep_j[q - nn]
                end

                if w >= v
                    break
                end
                q += one(I)
            end

            targets(rel)[p] = q
        end
    end

    return
end

function chol_piv_factor!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        W::AbstractVector{T},
        d::AbstractVector{T},
        P::AbstractVector,
        S::AbstractVector{T},
        R::DynamicRegularization,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, UPLO, DIAG}
    @assert size(D, 1) == size(D, 2)
    @assert length(D) <= length(W)

    if DIAG === :U
        @assert length(d) == size(D, 1)
    end

    if UPLO === :L
        @assert size(L, 2) == size(D, 1)
    else
        @assert size(L, 1) == size(D, 1)
    end

    pstrf!(uplo, W, D, d, P, S, R, -one(real(T)), diag)

    if !isempty(L)
        M = reshape(view(W, 1:length(L)), size(L))
        copyrec!(M, L)

        if UPLO === :L
            copygatherrec!(L, M, P, Val(:R))
            side = Val(:R)
        else
            copygatherrec!(L, M, P, Val(:L))
            side = Val(:L)
        end

        trsm!(side, uplo, Val(:C), diag, one(T), D, L)
        cdiv!(side, diag, L, d)
    end

    return 0, size(D, 1)
end

function chol_piv_factor!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        W::AbstractVector{T},
        d::AbstractVector{T},
        P::AbstractVector,
        S::AbstractVector{T},
        R::GMW81,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, UPLO, DIAG}
    if UPLO === :L
        @assert size(D, 1) == size(D, 2) == size(L, 2)
    else
        @assert size(D, 1) == size(D, 2) == size(L, 1)
    end

    @inbounds for j in axes(D, 1)
        P[j] = j

        if UPLO === :L
            d[j] = zero(real(T))
        else
            d[j] = real(D[j, j])
        end
    end

    @inbounds for bstrt in 1:THRESHOLD:size(D, 1)
        bstop = min(bstrt + THRESHOLD - 1, size(D, 1))

        chol_piv_factor_block!(D, L, d, P, S, R, bstrt, bstop, uplo, diag)

        if bstop < size(D, 1)
            Drr = view(D, bstop + 1:size(D, 1), bstop + 1:size(D, 1))
            dbb = view(d, bstrt:bstop)

            if UPLO === :L
                Drb = view(D, bstop + 1:size(D, 1), bstrt:bstop)
                syrk!(uplo, Val(:N), -one(real(T)), W, Drb, dbb, one(real(T)), Drr, diag)

                if !isempty(L)
                    Lnb = view(L, :, bstrt:bstop)
                    Lnr = view(L, :, bstop + 1:size(D, 1))
                    gemm!(Val(:N), Val(:C), -one(T), W, Lnb, Drb, dbb, one(T), Lnr, diag)
                end

                @inbounds for j in bstop + 1:size(D, 1)
                    d[j] = zero(real(T))
                end
            else
                Drb = view(D, bstrt:bstop, bstop + 1:size(D, 1))
                syrk!(uplo, Val(:C), -one(real(T)), W, Drb, dbb, one(real(T)), Drr, diag)

                if !isempty(L)
                    Lnb = view(L, bstrt:bstop, :)
                    Lnr = view(L, bstop + 1:size(D, 1), :)
                    gemm!(Val(:C), Val(:N), -one(T), W, Drb, Lnb, dbb, one(T), Lnr, diag)
                end
            end
        end
    end

    return 0, size(D, 1)
end

function chol_piv_factor_block!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        d::AbstractVector{T},
        P::AbstractVector,
        S::AbstractVector{T},
        R::GMW81,
        bstrt::Int,
        bstop::Int,
        ::Val{:L},
        ::Val{DIAG},
    ) where {T, DIAG}

    @inbounds for j in bstrt:bstop
        maxval = abs(real(D[j, j]) - d[j])
        maxind = j

        for i in j + 1:size(D, 1)
            Aii = abs(real(D[i, i]) - d[i])

            if Aii > maxval
                maxval = Aii
                maxind = i
            end
        end

        if maxind != j
            swaptri!(D, j, maxind, Val(:L))
            swapcol!(L, j, maxind)
            swaprec!(P, j, maxind)
            swaprec!(d, j, maxind)
            swaprec!(S, j, maxind)
        end

        for k in bstrt:j - 1
            if DIAG === :U
                cDkj = d[k] * conj(D[j, k])
            else
                cDkj = conj(D[j, k])
            end

            for i in j + 1:size(D, 1)
                D[i, j] -= D[i, k] * cDkj
            end
        end

        for k in bstrt:j - 1
            if DIAG === :U
                cDkj = d[k] * conj(D[j, k])
            else
                cDkj = conj(D[j, k])
            end

            for i in axes(L, 1)
                L[i, j] -= L[i, k] * cDkj
            end
        end

        Djj = real(D[j, j]) - real(d[j])

        Djj = regularize(R, S, D, L, Djj, j, Val(:L))

        if DIAG === :U
            d[j] = Djj
        else
            D[j, j] = Djj = sqrt(Djj)
        end

        iDjj = inv(Djj)

        for i in j + 1:size(D, 1)
            D[i, j] *= iDjj
        end

        for i in axes(L, 1)
            L[i, j] *= iDjj
        end

        for i in j + 1:size(D, 1)
            if DIAG === :N
                d[i] += abs2(D[i, j])
            else
                d[i] += Djj * abs2(D[i, j])
            end
        end
    end

    return
end

function chol_piv_factor_block!(
        D::AbstractMatrix{T},
        L::AbstractMatrix{T},
        d::AbstractVector{T},
        P::AbstractVector,
        S::AbstractVector{T},
        R::GMW81,
        bstrt::Int,
        bstop::Int,
        ::Val{:U},
        ::Val{DIAG},
    ) where {T, DIAG}

    @inbounds for j in bstrt:bstop
        maxval = abs(d[j])
        maxind = j

        for i in j + 1:size(D, 1)
            Aii = abs(d[i])

            if Aii > maxval
                maxval = Aii
                maxind = i
            end
        end

        if maxind != j
            swaptri!(D, j, maxind, Val(:U))
            swaprow!(L, j, maxind)
            swaprec!(P, j, maxind)
            swaprec!(d, j, maxind)
            swaprec!(S, j, maxind)
        end

        for i in j + 1:size(D, 1)
            for k in bstrt:j - 1
                if DIAG === :U
                    D[j, i] -= D[k, i] * d[k] * conj(D[k, j])
                else
                    D[j, i] -= D[k, i] * conj(D[k, j])
                end
            end
        end

        for i in axes(L, 2)
            for k in bstrt:j - 1
                if DIAG === :U
                    L[j, i] -= L[k, i] * d[k] * conj(D[k, j])
                else
                    L[j, i] -= L[k, i] * conj(D[k, j])
                end
            end
        end

        Djj = real(d[j])

        Djj = regularize(R, S, D, L, Djj, j, Val(:U))

        if DIAG === :U
            d[j] = Djj
        else
            D[j, j] = Djj = sqrt(Djj)
        end

        iDjj = inv(Djj)

        for i in j + 1:size(D, 1)
            D[j, i] *= iDjj

            if DIAG === :N
                d[i] -= abs2(D[j, i])
            else
                d[i] -= Djj * abs2(D[j, i])
            end
        end

        for i in axes(L, 2)
            L[j, i] *= iDjj
        end
    end

    return
end

# ===== gert! =====
# Triangular rank-1 update: C += α * x * yᴴ, writing only to the triangle specified by uplo

# WARNING: OVER-WRITES OTHER TRIANGLE (matches gemmt! behavior for BlasFloat)
function gert!(uplo::Val, α, x::AbstractVector{T}, y::AbstractVector{T}, C::AbstractMatrix{T}) where {T <: BlasFloat}
    BLAS.ger!(convert(T, α), x, y, C)
    return
end

function gert!(uplo::Val{UPLO}, α, x::AbstractVector{T}, y::AbstractVector{T}, C::AbstractMatrix{T}) where {T, UPLO}
    n = size(C, 1)

    @inbounds @fastmath for j in 1:n
        if UPLO === :L
            rng = j:n
        else
            rng = 1:j
        end

        αyj = α * conj(y[j])

        for i in rng
            C[i, j] += x[i] * αyj
        end
    end

    return
end

abstract type AbstractFactorization{DIAG, UPLO, T, I, Prm <: AbstractVector{I}, Ivp <: AbstractVector{I}} <: Factorization{T} end

const AbstractCholesky = AbstractFactorization{:N}
const AbstractLDLt = AbstractFactorization{:U}
const NaturalFactorization{DIAG, UPLO, T, I} = AbstractFactorization{DIAG, UPLO, T, I, OneTo{I}, OneTo{I}}

# ===== Base methods =====

function Base.:(==)(F::AbstractFactorization, G::AbstractFactorization)
    return false
end

function Base.:(==)(F::AbstractFactorization{DIAG, UPLO}, G::AbstractFactorization{DIAG, UPLO}) where {DIAG, UPLO}
    out = F.P === G.P && triangular(F) == triangular(G)

    if DIAG === :U
        out = out && F.D == G.D
    end

    return out
end

function Base.getproperty(F::AbstractFactorization{DIAG, UPLO}, s::Symbol) where {DIAG, UPLO}
    if s === :P
        return Permutation(getfield(F, :perm), getfield(F, :invp))
    elseif s === :D
        return Diagonal(getfield(F, :d))
    elseif s === :L || s === :U
        if s === UPLO
            return triangular(F)
        else
            return triangular(F)'
        end
    elseif s === :uplo
        return Val(UPLO)
    elseif s === :diag
        return Val(DIAG)
    else
        return getfield(F, s)
    end
end

function Base.copyto!(F::AbstractFactorization{DIAG}, G::AbstractFactorization{DIAG}) where {DIAG}
    if DIAG === :U
        copyto!(F.d, G.d)
    end

    copyto!(triangular(F, Val(:N)), triangular(G, Val(:N)))
    return F
end

function Base.copy(F::AbstractFactorization)
    return copyto!(similar(F), F)
end

function Base.copyto!(F::AbstractFactorization{DIAG, UPLO}, A::AbstractMatrix; check::Bool=true) where {DIAG, UPLO}
    if !check || ishermitian(A)
        return copyto!(F, Hermitian(A, UPLO))
    elseif istril(A)
        return copyto!(F, Hermitian(A, :L))
    elseif istriu(A)
        return copyto!(F, Hermitian(A, :U))
    end

    error()
end

function Base.copyto!(F::AbstractFactorization, A::HermOrSym; check::Bool=true)
    sympermute!(triangular(F), parent(A), F.invp, A.uplo, char(F.uplo))
    return F
end

function Base.copy!(F::AbstractFactorization, A; kw...)
    return copyto!(F, A; kw...)
end

function Base.size(F::AbstractFactorization)
    return size(triangular(F))
end

function Base.size(F::AbstractFactorization, args...)
    return size(triangular(F), args...)
end

function Base.axes(F::AbstractFactorization, args...)
    return axes(triangular(F), args...)
end

function Base.fill!(F::AbstractFactorization, x)
    fill!(triangular(F), x)
    return F
end

function Base.adjoint(F::AbstractFactorization)
    return F
end

# ===== LinearAlgebra =====

function LinearAlgebra.issuccess(F::AbstractFactorization)
    return iszero(F.info[])
end

function LinearAlgebra.rank(F::AbstractFactorization{DIAG}; kw...) where {DIAG}
    if DIAG === :N
        return rank(F.L; kw...)
    else
        return rank(F.D; kw...)
    end
end

function LinearAlgebra.isposdef(F::AbstractFactorization{DIAG}) where {DIAG}
    if DIAG === :N
        return iszero(F.info[])
    else
        return isposdef(F.D)
    end
end

function inertiadiag(D::Diagonal{T}; atol::Real=zero(real(T)), rtol::Real=zero(real(T))) where {T}
    R = real(T)

    if R <: AbstractFloat && !ispositive(rtol) && !ispositive(atol)
        tol = size(D, 1) * eps(R)
    else
        tol = convert(R, max(atol, rtol * maximum(abs, D.diag)))
    end

    np = nn = nz = 0

    for i in axes(D, 1)
        Dii = D.diag[i]

        if real(Dii) > tol
            np += 1
        elseif real(Dii) < -tol
            nn += 1
        else
            nz += 1
        end
    end

    return (np, nn, nz)
end

@static if VERSION >= v"1.11"
    function LinearAlgebra.inertia(F::AbstractFactorization{DIAG}; kw...) where {DIAG}
        if DIAG === :N
            return (ncl(F), 0, 0)
        else
            return inertiadiag(F.D; kw...)
        end
    end
end

function LinearAlgebra.det(F::AbstractFactorization{DIAG}) where {DIAG}
    if DIAG === :N
        return det(F.L)^2
    else
        return det(F.L)^2 * det(F.D)
    end
end

function LinearAlgebra.logdet(F::AbstractFactorization{DIAG}) where {DIAG}
    if DIAG === :N
        return 2logdet(F.L)
    else
        d, s = logabsdet(F)
        return d + log(s)
    end
end

function LinearAlgebra.logabsdet(F::AbstractFactorization{DIAG, UPLO, T}) where {DIAG, UPLO, T}
    if DIAG === :N
        return (2logdet(F.L), one(T))
    else
        return logabsdet(F.D)
    end
end

function LinearAlgebra.diag(F::AbstractFactorization{DIAG}) where {DIAG}
    if DIAG === :N
        return F.P' * diag(F.L).^2
    else
        return F.P' * diag(F.D)
    end
end

function LinearAlgebra.cond(F::AbstractFactorization, p::Real=2)
    if p == 1 || p == Inf
        condest1(F)
    elseif p == 2
        condest2(F)
    else
        error()
    end
end

function LinearAlgebra.opnorm(F::AbstractFactorization, p::Real=2)
    if p == 1 || p == Inf
        opnormest1(F)
    elseif p == 2
        opnormest2(F)
    else
        error()
    end
end

function ncl(F::AbstractFactorization)
    return size(F, 1)
end

function Base.length(F::AbstractFactorization)
    return ncl(F)^2
end

function uncopy(F::NaturalFactorization{DIAG, UPLO}) where {DIAG, UPLO}
    return Hermitian(triangular(F, Val(:N)), UPLO)
end

function uncopy(F::AbstractFactorization{DIAG, UPLO}) where {DIAG, UPLO}
    return cong(uncopy(NaturalFactorization(F)), F.P)
end

function unfactorize(F::AbstractFactorization)
    G = unfactorize!(copy(F))
    return uncopy(G)
end

function (::Type{Mat})(F::AbstractFactorization) where {Mat <: Matrix}
    return Mat(unfactorize(F))
end

function SparseArrays.sparse(F::AbstractFactorization)
    return sparse(unfactorize(F))
end

function tangentdata(x::Tangent)
    return x.fields
end

function tangentdata(x::FData)
    return x.data
end

function toarray(X::AbstractArray, dX)
    return dX
end

function toarray(X::SparseMatrixCSC, dX)
    dnzval = tangentdata(dX).nzval
    return SparseMatrixCSC(X.m, X.n, X.colptr, X.rowval, dnzval)
end

function toarray(X::Hermitian, dX)
    dY = toarray(parent(X), tangentdata(dX).data)
    return Hermitian(dY, Symbol(X.uplo))
end

function toarray(X::Symmetric, dX)
    dY = toarray(parent(X), tangentdata(dX).data)
    return Symmetric(dY, Symbol(X.uplo))
end

function totangent(Y::Mat, dY) where {Mat <: SparseMatrixCSC}
    colptr = fill(NoTangent(), length(Y.colptr))
    rowval = fill(NoTangent(), length(Y.rowval))
    return build_tangent(Mat, NoTangent(), NoTangent(), colptr, rowval, dY.nzval)
end

function totangent(Y::Mat, dY) where {Mat <: HermOrSym}
    return build_tangent(Mat, totangent(parent(Y), parent(dY)), NoTangent())
end

function tofdata(Y, dY)
    return fdata(totangent(Y, dY))
end

function primaltangent(x::Union{CoDual, Dual})
    return (primal(x), tangent(x))
end

function primaltangent(x::Union{CoDual{<:AbstractArray}, Dual{<:AbstractArray}})
    X = primal(x)
    dX = toarray(X, tangent(x))
    return (X, dX)
end

using CliqueTrees.Multifrontal: flatindices, setflatindex!, triangular, selinv!, complete!, fisherroot!, fisher!, amari!

@testset "cholesky" begin
    matrices = ("685_bus", "Trefethen_500", "bcsstk26", "bcsstk13", "mhd1280b")

    for UPLO in (:L, :U), pivot in (NoPivot(), RowMaximum())
        for name in matrices
            M = readmatrix(name); n = size(M, 2)
            F0 = cholesky(M)

            b = rand(n)
            x = rand(n)
            B = rand(n, 4)
            X = rand(n, 4)
            C = rand(5, n)
            Y = rand(5, n)

            F = cholesky!(ChordalCholesky{UPLO}(M), pivot)
            @test isa(repr("text/plain", F), String)
            @test issuccess(F) == issuccess(F0)
            @test logdet(F) ≈ logdet(F0)
            @test det(F) ≈ det(F0)
            @test isapprox(b, M * (F \ b); rtol=1e-6, atol=1e-14)
            @test isapprox(B, M * (F \ B); rtol=1e-6, atol=1e-14)
            @test isapprox(C, (C / F) * M; rtol=1e-6, atol=1e-14)
            @test isapprox(M * x, F * x; rtol=1e-6, atol=1e-14)
            @test isapprox(M * X, F * X; rtol=1e-6, atol=1e-14)
            @test isapprox(Y * M, Y * F; rtol=1e-6, atol=1e-14)

            F = ldlt!(ChordalLDLt{UPLO}(M), pivot)
            @test isa(repr("text/plain", F), String)
            @test issuccess(F) == issuccess(F0)
            @test logdet(F) ≈ logdet(F0)
            @test det(F) ≈ det(F0)
            @test isapprox(b, M * (F \ b); rtol=1e-6, atol=1e-14)
            @test isapprox(B, M * (F \ B); rtol=1e-6, atol=1e-14)
            @test isapprox(C, (C / F) * M; rtol=1e-6, atol=1e-14)
            @test isapprox(M * x, F * x; rtol=1e-6, atol=1e-14)
            @test isapprox(M * X, F * X; rtol=1e-6, atol=1e-14)
            @test isapprox(Y * M, Y * F; rtol=1e-6, atol=1e-14)
        end

        M = SparseMatrixCSC{BigFloat}(readmatrix("nos4")); n = size(M, 2)

        b = rand(BigFloat, n)
        x = rand(BigFloat, n)
        B = rand(BigFloat, n, 4)
        X = rand(BigFloat, n, 4)
        C = rand(BigFloat, 5, n)
        Y = rand(BigFloat, 5, n)

        F = cholesky!(ChordalCholesky{UPLO}(M), pivot)
        @test isapprox(b, M * (F \ b); rtol=1e-6, atol=1e-14)
        @test isapprox(B, M * (F \ B); rtol=1e-6, atol=1e-14)
        @test isapprox(C, (C / F) * M; rtol=1e-6, atol=1e-14)
        @test isapprox(M * x, F * x; rtol=1e-6, atol=1e-14)
        @test isapprox(M * X, F * X; rtol=1e-6, atol=1e-14)
        @test isapprox(Y * M, Y * F; rtol=1e-6, atol=1e-14)

        F = ldlt!(ChordalLDLt{UPLO}(M), pivot)
        @test isapprox(b, M * (F \ b); rtol=1e-6, atol=1e-14)
        @test isapprox(B, M * (F \ B); rtol=1e-6, atol=1e-14)
        @test isapprox(C, (C / F) * M; rtol=1e-6, atol=1e-14)
        @test isapprox(M * x, F * x; rtol=1e-6, atol=1e-14)
        @test isapprox(M * X, F * X; rtol=1e-6, atol=1e-14)
        @test isapprox(Y * M, Y * F; rtol=1e-6, atol=1e-14)

        M = SparseMatrixCSC{Float64}(readmatrix("685_bus"))
        @inferred cholesky!(ChordalCholesky{UPLO}(M), pivot)
        @inferred ldlt!(ChordalLDLt{UPLO}(M), pivot)
        @test_call target_modules = (CliqueTrees,) cholesky!(ChordalCholesky{UPLO}(M), pivot)
        @test_call target_modules = (CliqueTrees,) ldlt!(ChordalLDLt{UPLO}(M), pivot)
        @test_opt target_modules = (CliqueTrees,) cholesky!(ChordalCholesky{UPLO}(M), pivot)
        @test_opt target_modules = (CliqueTrees,) ldlt!(ChordalLDLt{UPLO}(M), pivot)

        for name in ("685_bus", "bcsstk26")
            M = readmatrix(name); n = size(M, 2)
            b = rand(n)

            for A in (Symmetric(M, :L), M)
                F = cholesky!(ChordalCholesky{UPLO}(A), pivot)
                P = flatindices(F, A)

                fill!(F, 0)
                cholesky!(F; check=false)
                @test !issuccess(F)

                for (i, p) in enumerate(P)
                    iszero(p) && continue
                    setflatindex!(F, nonzeros(M)[i], p)
                end

                cholesky!(F)
                @test issuccess(F)
                @test isapprox(b, M * (F \ b); rtol=1e-6, atol=1e-14)

                F = ldlt!(ChordalLDLt{UPLO}(A), pivot)
                P = flatindices(F, A)

                fill!(F, 0)
                ldlt!(F; check=false)
                @test !issuccess(F)

                for (i, p) in enumerate(P)
                    iszero(p) && continue
                    setflatindex!(F, nonzeros(M)[i], p)
                end

                ldlt!(F)
                @test issuccess(F)
                @test isapprox(b, M * (F \ b); rtol=1e-6, atol=1e-14)
            end
        end
    end
end

@testset "cholesky (cholmod)" begin
    matrices = ("685_bus", "Trefethen_500", "bcsstk26", "bcsstk13", "mhd1280b")

    for name in matrices
        M = readmatrix(name); n = size(M, 2)
        F0 = cholesky(M)

        b = rand(n)
        B = rand(n, 4)

        F = ChordalCholesky(F0)
        @test isapprox(b, M * (F \ b); rtol=1e-6, atol=1e-14)
        @test isapprox(B, M * (F \ B); rtol=1e-6, atol=1e-14)
    end
end

@testset "cholesky (dense)" begin
    for UPLO in (:L, :U), pivot in (NoPivot(), RowMaximum())
        for n in (10, 50, 100)
            A = rand(n, n)
            M = A' * A + I
            F0 = cholesky(M)

            b = rand(n)
            B = rand(n, 4)

            F = cholesky!(DenseCholeskyPivoted{UPLO}(copy(M)), pivot)
            @test isa(repr("text/plain", F), String)
            @test issuccess(F) == issuccess(F0)
            @test logdet(F) ≈ logdet(F0)
            @test det(F) ≈ det(F0)
            @test isapprox(b, M * (F \ b); rtol=1e-6, atol=1e-14)
            @test isapprox(B, M * (F \ B); rtol=1e-6, atol=1e-14)

            F = ldlt!(DenseLDLtPivoted{UPLO}(copy(M)), pivot)
            @test isa(repr("text/plain", F), String)
            @test issuccess(F) == issuccess(F0)
            @test logdet(F) ≈ logdet(F0)
            @test det(F) ≈ det(F0)
            @test isapprox(b, M * (F \ b); rtol=1e-6, atol=1e-14)
            @test isapprox(B, M * (F \ B); rtol=1e-6, atol=1e-14)
        end
    end
end

@testset "regularization (dense)" begin
    A = rand(10, 10)
    A = A' * A
    A -= 1.0001 * minimum(eigvals(A)) * I
    signs = ones(size(A, 1))

    for UPLO in (:L, :U)
        for R in (GMW81, SE99)
            F = DenseCholesky{UPLO}(copy(A))
            cholesky!(F; reg=R())
            @test A ≈ Matrix(F) rtol=1e-3

            F = DenseCholeskyPivoted{UPLO}(copy(A))
            cholesky!(F, RowMaximum(); reg=R())
            @test A ≈ Matrix(F) rtol=1e-3

            F = DenseLDLt{UPLO}(copy(A))
            ldlt!(F; signs, reg=R())
            @test A ≈ Matrix(F) rtol=1e-3

            F = DenseLDLtPivoted{UPLO}(copy(A))
            ldlt!(F, RowMaximum(); signs, reg=R())
            @test A ≈ Matrix(F) rtol=1e-3
        end
    end

    A = Float64[
        1 1 2
        1 1 3
        2 3 1
    ]

    signs = [1, 1, 1]

    for UPLO in (:L, :U)
        F = DenseCholesky{UPLO}(copy(A))
        cholesky!(F; reg=GMW81())
        @test diag(F) ≈ [3.771, 5.750, 1.121] rtol=1e-3

        F = DenseLDLt{UPLO}(copy(A))
        ldlt!(F; signs, reg=GMW81())
        @test diag(F) ≈ [3.771, 5.750, 1.121] rtol=1e-3
    end
end

@testset "regularization (sparse)" begin
    A = readmatrix("msc01440")
    A -= 1.0001 * minimum(eigvals(Matrix(A))) * I
    signs = ones(size(A, 1))

    for UPLO in (:L, :U)
        for P in (NoPivot, RowMaximum)
            for R in (GMW81, SE99)
                F = ChordalCholesky{UPLO}(A)
                cholesky!(F, P(); reg=R())
                @test A ≈ Matrix(F) rtol=1e-3

                F = ChordalLDLt{UPLO}(A)
                ldlt!(F, P(); signs, reg=R())
                @test A ≈ Matrix(F) rtol=1e-3
            end
        end
    end

    C = readmatrix("662_bus")
    C -= 1.0001 * minimum(eigvals(Matrix(C))) * I
    B = sprand(size(A, 1), size(C, 1), .001)

    P = randperm(size(A, 1) + size(C, 1))
    A = [A B; B' -C][P, P]
    signs = [signs; -signs][P]

    for UPLO in (:L, :U)
        for P in (NoPivot, RowMaximum)
            for R in (GMW81, SE99)
                F = ChordalLDLt{UPLO}(A)
                ldlt!(F, P(); signs, reg=R())
                @test A ≈ Matrix(F) rtol=1e-3
            end
        end
    end

    A = [
        1 1 2
        1 1 3
        2 3 1
    ]

    signs = [1, 1, 1]

    for UPLO in (:L, :U)
        F = ChordalCholesky{UPLO}(A)
        cholesky!(F; reg=GMW81())
        @test diag(F) ≈ [3.771, 5.750, 1.121] rtol=1e-3

        F = ChordalLDLt{UPLO}(A)
        ldlt!(F; signs, reg=GMW81())
        @test diag(F) ≈ [3.771, 5.750, 1.121] rtol=1e-3
    end
end

@testset "semidefinite (pivoted)" begin
    # Sheaf Laplacian L = D'D where D is a coboundary operator (double integrator dynamics)
    # This matrix has a 6-dimensional null space, testing pivoted factorization on rank-deficient matrices
    h = 0.25
    ρ = [1 h h^2/2; 0 1 h]      # dynamics restriction map [A_d | B_d]
    σ = [-1 0 0; 0 -1 0]        # state projection map -[I | 0]
    D = spzeros(18, 24)
    D[1:2,   1:2]   = -I(2)                         # boundary edge
    D[3:4,   1:3]   = ρ;   D[3:4,   4:6]   = σ      # dynamics edges
    D[5:6,   4:6]   = ρ;   D[5:6,   7:9]   = σ
    D[7:8,   7:9]   = ρ;   D[7:8,   10:12] = σ
    D[9:10,  10:12] = ρ;   D[9:10,  13:15] = σ
    D[11:12, 13:15] = ρ;   D[11:12, 16:18] = σ
    D[13:14, 16:18] = ρ;   D[13:14, 19:21] = σ
    D[15:16, 19:21] = ρ;   D[15:16, 22:23] = σ[:, 1:2]
    D[17:18, 22:24] = ρ                              # last edge (no target projection)
    L = D' * D

    # Verify it's semidefinite with non-trivial null space
    eigs = eigvals(Matrix(L))
    @test minimum(eigs) ≈ 0 atol=1e-10
    @test count(e -> abs(e) < 1e-10, eigs) == 6  # 6-dimensional null space

    for UPLO in (:L, :U)
        # Pivoted Cholesky should handle semidefinite matrices
        F = ChordalCholesky{UPLO}(L)
        cholesky!(F, RowMaximum())
        @test L ≈ Matrix(F) rtol=1e-10

        # Pivoted LDLt should also work
        F = ChordalLDLt{UPLO}(L)
        ldlt!(F, RowMaximum())
        @test L ≈ Matrix(F) rtol=1e-10
    end
end

@testset "condition number" begin
    A = readmatrix("bcsstk26")
    F = cholesky!(ChordalCholesky(A))

    for p in (1, Inf)
        @test cond(F, p) ≈ cond(A, p) rtol=1
        @test cond(F.L, p) ≈ cond(sparse(F.L), p) rtol=1
        @test cond(F.U, p) ≈ cond(sparse(F.U), p) rtol=1
    end

    F = ldlt!(ChordalLDLt(A))

    for p in (1, Inf)
        @test cond(F, p) ≈ cond(A, p) rtol=1
        @test cond(F.L, p) ≈ cond(sparse(F.L), p) rtol=1
        @test cond(F.U, p) ≈ cond(sparse(F.U), p) rtol=1
    end
end

@testset "selinv" begin
    matrices = ("nos4", "mesh3e1", "494_bus", "mhdb416", "685_bus")

    for name in matrices
        M = readmatrix(name); n = size(M, 2)

        for UPLO in (:L, :U)
            F = cholesky!(ChordalCholesky{UPLO}(M))
            G = copy(F)
            N = F.P * inv(Matrix(M)) * F.P'

            L = triangular(F)
            selinv!(G)
            S = triangular(G)

            @test all(isapprox(N[i, j], v; rtol=1e-6, atol=1e-14) for (i, j, v) in zip(findnz(S)...))

            complete!(G)

            @test all(isapprox(L[i, j], v; rtol=1e-6, atol=1e-14) for (i, j, v) in zip(findnz(S)...))
        end
    end

    M = SparseMatrixCSC{BigFloat}(readmatrix("nos4")); n = size(M, 2)

    for UPLO in (:L, :U)
        F = cholesky!(ChordalCholesky{UPLO}(M))
        G = copy(F)
        N = F.P * inv(Matrix(M)) * F.P'

        L = triangular(F)
        selinv!(G)
        S = triangular(G)

        @test all(isapprox(N[i, j], v; rtol=1e-6, atol=1e-14) for (i, j, v) in zip(findnz(S)...))

        complete!(G)

        @test all(isapprox(L[i, j], v; rtol=1e-6, atol=1e-14) for (i, j, v) in zip(findnz(S)...))
    end

    M = SparseMatrixCSC{Float64}(readmatrix("nos4"))
    L = cholesky!(ChordalCholesky{:L}(M))
    U = cholesky!(ChordalCholesky{:U}(M))
    @inferred selinv!(L)
    @inferred selinv!(U)
    @test_call target_modules = (CliqueTrees,) selinv!(L)
    @test_call target_modules = (CliqueTrees,) selinv!(U)
    @test_opt target_modules = (CliqueTrees,) selinv!(L)
    @test_opt target_modules = (CliqueTrees,) selinv!(U)
end

@testset "complete" begin
    matrices = ("nos4", "mesh3e1", "494_bus", "mhdb416", "685_bus")

    for name in matrices
        M = readmatrix(name)

        for UPLO in (:L, :U)
            F = cholesky!(ChordalCholesky{UPLO}(M))
            G = copy(F)

            selinv!(G)
            complete!(G)

            @test triangular(F) ≈ triangular(G)

            selinv!(G)
            complete!(G)

            @test triangular(F) ≈ triangular(G)
        end
    end

    M = SparseMatrixCSC{BigFloat}(readmatrix("nos4"))

    for UPLO in (:L, :U)
        F = cholesky!(ChordalCholesky{UPLO}(M))
        G = copy(F)

        selinv!(G)
        complete!(G)

        @test triangular(F) ≈ triangular(G)

        selinv!(G)
        complete!(G)

        @test triangular(F) ≈ triangular(G)
    end

    M = SparseMatrixCSC{Float64}(readmatrix("nos4"))
    L = selinv!(cholesky!(ChordalCholesky{:L}(M)))
    U = selinv!(cholesky!(ChordalCholesky{:U}(M)))
    @inferred complete!(L)
    @inferred complete!(U)
    @test_call target_modules = (CliqueTrees,) complete!(L)
    @test_call target_modules = (CliqueTrees,) complete!(U)
    @test_opt target_modules = (CliqueTrees,) complete!(L)
    @test_opt target_modules = (CliqueTrees,) complete!(U)
end

@testset "fisherroot (inv=false)" begin
    matrices = ("nos4", "mesh3e1", "494_bus", "mhdb416", "685_bus")

    for name in matrices
        M = readmatrix(name)

        for UPLO in (:L, :U)
            F = cholesky!(ChordalCholesky{UPLO}(M))
            S = selinv!(copy(F))

            Y = similar(F)
            rand!(Y.Dval)
            rand!(Y.Lval)
            Z = copy(Y)

            fisherroot!(Y, F, S; adj=false, inv=false)
            fisherroot!(Y, F, S; adj=true, inv=false)

            fisher!(Z, F, S; inv=false)

            @test triangular(Y) ≈ triangular(Z)
        end
    end

    M = SparseMatrixCSC{BigFloat}(readmatrix("nos4"))

    for UPLO in (:L, :U)
        F = cholesky!(ChordalCholesky{UPLO}(M))
        S = selinv!(copy(F))

        Y = similar(F)
        rand!(Y.Dval)
        rand!(Y.Lval)
        Z = copy(Y)

        fisherroot!(Y, F, S; adj=false, inv=false)
        fisherroot!(Y, F, S; adj=true, inv=false)

        fisher!(Z, F, S; inv=false)

        @test triangular(Y) ≈ triangular(Z)
    end

    M = SparseMatrixCSC{Float64}(readmatrix("nos4"))
    F = cholesky!(ChordalCholesky(M))
    S = selinv!(copy(F))
    Y = copy(F)
    @inferred fisherroot!(Y, F, S; adj=false, inv=false)
    @inferred fisherroot!(Y, F, S; adj=true, inv=false)
    @test_call target_modules = (CliqueTrees,) fisherroot!(Y, F, S; adj=false, inv=false)
    @test_call target_modules = (CliqueTrees,) fisherroot!(Y, F, S; adj=true, inv=false)
    @test_opt target_modules = (CliqueTrees,) fisherroot!(Y, F, S; adj=false, inv=false)
    @test_opt target_modules = (CliqueTrees,) fisherroot!(Y, F, S; adj=true, inv=false)
end

@testset "fisherroot (inv=true)" begin
    matrices = ("nos4", "mesh3e1", "494_bus", "mhdb416", "685_bus")

    for name in matrices
        M = readmatrix(name)

        for UPLO in (:L, :U)
            F = cholesky!(ChordalCholesky{UPLO}(M))
            S = selinv!(copy(F))

            Y = similar(F)
            rand!(Y.Dval)
            rand!(Y.Lval)
            Z = copy(Y)

            fisherroot!(Y, F, S; adj=true, inv=true)
            fisherroot!(Y, F, S; adj=false, inv=true)

            fisher!(Z, F, S; inv=true)

            @test triangular(Y) ≈ triangular(Z)
        end
    end

    M = SparseMatrixCSC{BigFloat}(readmatrix("nos4"))

    for UPLO in (:L, :U)
        F = cholesky!(ChordalCholesky{UPLO}(M))
        S = selinv!(copy(F))

        Y = similar(F)
        rand!(Y.Dval)
        rand!(Y.Lval)
        Z = copy(Y)

        fisherroot!(Y, F, S; adj=true, inv=true)
        fisherroot!(Y, F, S; adj=false, inv=true)

        fisher!(Z, F, S; inv=true)

        @test triangular(Y) ≈ triangular(Z)
    end

    M = SparseMatrixCSC{Float64}(readmatrix("nos4"))
    F = cholesky!(ChordalCholesky(M))
    S = selinv!(copy(F))
    Y = copy(F)
    @inferred fisherroot!(Y, F, S; adj=true, inv=true)
    @inferred fisherroot!(Y, F, S; adj=false, inv=true)
    @test_call target_modules = (CliqueTrees,) fisherroot!(Y, F, S; adj=true, inv=true)
    @test_call target_modules = (CliqueTrees,) fisherroot!(Y, F, S; adj=false, inv=true)
    @test_opt target_modules = (CliqueTrees,) fisherroot!(Y, F, S; adj=true, inv=true)
    @test_opt target_modules = (CliqueTrees,) fisherroot!(Y, F, S; adj=false, inv=true)
end

@testset "fisher (inv=false)" begin
    matrices = ("nos4", "mesh3e1", "494_bus", "mhdb416", "685_bus")

    for name in matrices
        M = readmatrix(name)

        for UPLO in (:L, :U)
            F = cholesky!(ChordalCholesky{UPLO}(M))
            S = selinv!(copy(F))
            Sinv = F.P * inv(Matrix(M)) * F.P'

            Y = similar(F)
            rand!(Y.Dval)
            rand!(Y.Lval)
            Ym = Symmetric(Matrix(triangular(Y)), UPLO)
            fisher!(Y, F, S; inv=false)
            Yexact = Sinv * Ym * Sinv

            YT = triangular(Y)
            @test all(isapprox(Yexact[i, j], v; rtol=1e-6, atol=1e-14) for (i, j, v) in zip(findnz(YT)...))
        end
    end

    M = SparseMatrixCSC{BigFloat}(readmatrix("nos4"))

    for UPLO in (:L, :U)
        F = cholesky!(ChordalCholesky{UPLO}(M))
        S = selinv!(copy(F))
        Sinv = F.P * inv(Matrix(M)) * F.P'

        Y = similar(F)
        rand!(Y.Dval)
        rand!(Y.Lval)
        Ym = Symmetric(Matrix(triangular(Y)), UPLO)
        fisher!(Y, F, S; inv=false)
        Yexact = Sinv * Ym * Sinv

        YT = triangular(Y)
        @test all(isapprox(Yexact[i, j], v; rtol=1e-6, atol=1e-14) for (i, j, v) in zip(findnz(YT)...))
    end

    M = SparseMatrixCSC{Float64}(readmatrix("nos4"))
    F = cholesky!(ChordalCholesky(M))
    S = selinv!(copy(F))
    Y = similar(F)
    rand!(Y.Dval)
    rand!(Y.Lval)
    @inferred fisher!(Y, F, S; inv=false)
    @test_call target_modules = (CliqueTrees,) fisher!(Y, F, S; inv=false)
    @test_opt target_modules = (CliqueTrees,) fisher!(Y, F, S; inv=false)
end

@testset "fisher (inv=true)" begin
    matrices = ("nos4", "mesh3e1", "494_bus", "mhdb416", "685_bus")

    for name in matrices
        M = readmatrix(name)

        for UPLO in (:L, :U)
            F = cholesky!(ChordalCholesky{UPLO}(M))
            S = selinv!(copy(F))

            Y = similar(F)
            rand!(Y.Dval)
            rand!(Y.Lval)
            Z = copy(Y)

            fisher!(Y, F, S; inv=false)
            fisher!(Y, F, S; inv=true)

            @test triangular(Y) ≈ triangular(Z) rtol=1e-5 atol=1e-14
        end
    end

    M = SparseMatrixCSC{BigFloat}(readmatrix("nos4"))

    for UPLO in (:L, :U)
        F = cholesky!(ChordalCholesky{UPLO}(M))
        S = selinv!(copy(F))

        Y = similar(F)
        rand!(Y.Dval)
        rand!(Y.Lval)
        Z = copy(Y)

        fisher!(Y, F, S; inv=false)
        fisher!(Y, F, S; inv=true)

        @test triangular(Y) ≈ triangular(Z) rtol=1e-5 atol=1e-14
    end

    M = SparseMatrixCSC{Float64}(readmatrix("nos4"))
    F = cholesky!(ChordalCholesky(M))
    S = selinv!(copy(F))
    Y = copy(F)
    @inferred fisher!(Y, F, S; inv=true)
    @test_call target_modules = (CliqueTrees,) fisher!(Y, F, S; inv=true)
    @test_opt target_modules = (CliqueTrees,) fisher!(Y, F, S; inv=true)
end

@testset "amari (inv=false)" begin
    matrices = ("nos4", "mesh3e1", "494_bus", "mhdb416", "685_bus")

    for name in matrices
        M = readmatrix(name)

        for UPLO in (:L, :U)
            F = cholesky!(ChordalCholesky{UPLO}(M))
            S = selinv!(copy(F))
            Sinv = F.P * inv(Matrix(M)) * F.P'

            Y = similar(F)
            rand!(Y.Dval)
            rand!(Y.Lval)
  
            Z = similar(F)
            rand!(Z.Dval)
            rand!(Z.Lval)

            T = similar(F)

            Ym = Symmetric(Matrix(triangular(Y)), UPLO)
            Zm = Symmetric(Matrix(triangular(Z)), UPLO)

            amari!(T, Y, Z, F, S; inv=false)

            Texact = -(Sinv * Ym * Sinv * Zm * Sinv + Sinv * Zm * Sinv * Ym * Sinv)

            TT = triangular(T)
            @test all(isapprox(Texact[i, j], v; rtol=1e-6, atol=1e-14) for (i, j, v) in zip(findnz(TT)...))
        end
    end

    M = SparseMatrixCSC{BigFloat}(readmatrix("nos4"))

    for UPLO in (:L, :U)
        F = cholesky!(ChordalCholesky{UPLO}(M))
        S = selinv!(copy(F))
        Sinv = F.P * inv(Matrix(M)) * F.P'

        Y = similar(F)
        rand!(Y.Dval)
        rand!(Y.Lval)

        Z = similar(F)
        rand!(Z.Dval)
        rand!(Z.Lval)

        T = similar(F)

        Ym = Symmetric(Matrix(triangular(Y)), UPLO)
        Zm = Symmetric(Matrix(triangular(Z)), UPLO)

        amari!(T, Y, Z, F, S; inv=false)

        Texact = -(Sinv * Ym * Sinv * Zm * Sinv + Sinv * Zm * Sinv * Ym * Sinv)

        TT = triangular(T)
        @test all(isapprox(Texact[i, j], v; rtol=1e-6, atol=1e-14) for (i, j, v) in zip(findnz(TT)...))
    end

    M = SparseMatrixCSC{Float64}(readmatrix("nos4"))
    F = cholesky!(ChordalCholesky(M))
    S = selinv!(copy(F))
    Y = similar(F)
    rand!(Y.Dval)
    rand!(Y.Lval)
    Z = similar(F)
    rand!(Z.Dval)
    rand!(Z.Lval)
    T = similar(F)
    @inferred amari!(T, Y, Z, F, S; inv=false)
    # @test_call target_modules = (CliqueTrees,) amari!(T, Y, Z, F, S; inv=false)
    # @test_opt target_modules = (CliqueTrees,) amari!(T, Y, Z, F, S; inv=false)
end

@testset "amari (inv=true)" begin
    matrices = ("nos4", "mesh3e1", "494_bus", "mhdb416", "685_bus")

    for name in matrices
        M = readmatrix(name)

        for UPLO in (:L, :U)
            F = cholesky!(ChordalCholesky{UPLO}(M))
            S = selinv!(copy(F))

            Y = similar(F)
            rand!(Y.Dval)
            rand!(Y.Lval)

            Z = similar(F)
            rand!(Z.Dval)
            rand!(Z.Lval)

            # Direct inv=true
            Y1 = copy(Y)
            Z1 = copy(Z)
            T1 = similar(F)
            amari!(T1, Y1, Z1, F, S; inv=true)

            # Roundtrip: fisher inv=true on inputs, amari inv=false, fisher inv=true on output, negate
            Y2 = copy(Y)
            Z2 = copy(Z)
            T2 = similar(F)
            fisher!(Y2, F, S; inv=true)
            fisher!(Z2, F, S; inv=true)
            amari!(T2, Y2, Z2, F, S; inv=false)
            fisher!(T2, F, S; inv=true)

            @test triangular(T1) ≈ triangular(T2)
        end
    end

    M = SparseMatrixCSC{BigFloat}(readmatrix("nos4"))

    for UPLO in (:L, :U)
        F = cholesky!(ChordalCholesky{UPLO}(M))
        S = selinv!(copy(F))

        Y = similar(F)
        rand!(Y.Dval)
        rand!(Y.Lval)

        Z = similar(F)
        rand!(Z.Dval)
        rand!(Z.Lval)

        # Direct inv=true
        Y1 = copy(Y)
        Z1 = copy(Z)
        T1 = similar(F)
        amari!(T1, Y1, Z1, F, S; inv=true)

        # Roundtrip
        Y2 = copy(Y)
        Z2 = copy(Z)
        T2 = similar(F)
        fisher!(Y2, F, S; inv=true)
        fisher!(Z2, F, S; inv=true)
        amari!(T2, Y2, Z2, F, S; inv=false)
        fisher!(T2, F, S; inv=true)

        @test triangular(T1) ≈ triangular(T2)
    end

    M = SparseMatrixCSC{Float64}(readmatrix("nos4"))
    F = cholesky!(ChordalCholesky(M))
    S = selinv!(copy(F))
    Y = copy(F)
    Z = copy(F)
    T = similar(F)
    @inferred amari!(T, Y, Z, F, S; inv=true)
    # @test_call target_modules = (CliqueTrees,) amari!(T, Y, Z, F, S; inv=true)
    # @test_opt target_modules = (CliqueTrees,) amari!(T, Y, Z, F, S; inv=true)
end

@testset "nullspace" begin
    using LinearAlgebra: nullspace

    for UPLO in (:L, :U)
        # Positive definite: B'B + I where B is square
        B = sprand(50, 50, 0.1)
        M = B' * B + I

        F = cholesky!(ChordalCholesky{UPLO}(Symmetric(M, UPLO)), RowMaximum())
        N = nullspace(F)
        @test size(N, 2) == 0

        F = ldlt!(ChordalLDLt{UPLO}(Symmetric(M, UPLO)), RowMaximum())
        N = nullspace(F)
        @test size(N, 2) == 0

        # Semidefinite: B'B where B is wide (m < n), nullity = n - m
        m, n = 50, 100
        B = sprand(m, n, 0.3)
        B[:, 1:m] += I  # guarantees full row rank
        M = B' * B

        F = cholesky!(ChordalCholesky{UPLO}(Symmetric(M, UPLO)), RowMaximum(); check=false)
        N = nullspace(F)
        @test size(N, 2) == n - m
        @test norm(M * N) < 1e-10

        F = ldlt!(ChordalLDLt{UPLO}(Symmetric(M, UPLO)), RowMaximum(); check=false)
        N = nullspace(F)
        @test size(N, 2) == n - m
        @test norm(M * N) < 1e-10
    end
end

"""
    AbstractRegularization

A dynamic regularization strategy. It can be passed to [`cholesky!`](@ref)
or [`ldlt!`](@ref) in order to compute a *modified* Cholesky (or LDLt) factorization.

### Modified Factorizations

If a matrix ``A`` is ill-conditioned (or even indefinite!), it is sometimes helpful
to perturb it by a small matrix ``E`` before computing a Cholesky factorization.

```math
    P (A + E) P^\\mathsf{T} = L L^\\mathsf{T}.
```

The diagonal matrix ``E`` can be chosen statically (before the factorization) dynamically
(during the factorization). Each `AbstractRegularization` object is an algorithm for
finding ``E``.

"""
abstract type AbstractRegularization end

function fisherroot!(
        Y::AbstractCholesky{UPLO, T},
        F::AbstractCholesky{UPLO, T},
        S::AbstractCholesky{UPLO, T};
        adj::Bool=false,
        inv::Bool=false,
        check::Bool=true,
    ) where {UPLO, T}
    info = fisherroot!(triangular(Y), triangular(F), triangular(S); adj, inv, check)
    Y.info[] = info
    return Y
end

function fisherroot!(
        Y::ChordalTriangular{:N, UPLO, T, I},
        F::ChordalTriangular{:N, UPLO, T, I},
        S::ChordalTriangular{:N, UPLO, T, I};
        adj::Bool=false,
        inv::Bool=false,
        check::Bool=true,
    ) where {UPLO, T, I <: Integer}
    @assert checksymbolic(Y, F, S)

    # Allocate workspace
    Uptr = FVector{I}(undef, F.S.nMptr)
    Uval = FVector{T}(undef, F.S.nMval)
    Fval = FVector{T}(undef, F.S.nFval * F.S.nFval)

    if adj && inv
        info = fisherroot_impl!(Uptr, Uval, Fval, F, S, Y, Val(true), Val(true))
    elseif adj
        info = fisherroot_impl!(Uptr, Uval, Fval, F, S, Y, Val(true), Val(false))
    elseif inv
        info = fisherroot_impl!(Uptr, Uval, Fval, F, S, Y, Val(false), Val(true))
    else
        info = fisherroot_impl!(Uptr, Uval, Fval, F, S, Y, Val(false), Val(false))
    end

    check && checkinfo(info, F.diag)

    return info
end

#
# adj=false, inv=false: fwd → scale
# adj=true,  inv=false: scale → bwd
# adj=false, inv=true:  scale → fwd
# adj=true,  inv=true:  bwd → scale
#
function fisherroot_impl!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        L::ChordalTriangular{:N, UPLO, T, I},
        S::ChordalTriangular{:N, UPLO, T, I},
        Y::ChordalTriangular{:N, UPLO, T, I},
        adj::Val{ADJ},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, ADJ, INV}
    if ADJ == INV
        # adj=false, inv=false or adj=true, inv=true
        if ADJ
            fisherroot_bwd!(Uptr, Uval, Fval, L, Y, inv)
        else
            fisherroot_fwd!(Uptr, Uval, Fval, L, Y, inv)
        end

        return fisherroot_scale!(Uptr, Uval, Fval, L, S, Y, adj, inv)
    else
        # adj=true, inv=false or adj=false, inv=true
        info = fisherroot_scale!(Uptr, Uval, Fval, L, S, Y, adj, inv)
        ispositive(info) && return info

        if ADJ
            fisherroot_bwd!(Uptr, Uval, Fval, L, Y, inv)
        else
            fisherroot_fwd!(Uptr, Uval, Fval, L, Y, inv)
        end

        return info
    end
end

function fisherroot_fwd!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        L::ChordalTriangular{:N, UPLO, T, I},
        Y::ChordalTriangular{:N, UPLO, T, I},
        inv::Val{INV},
        rng::AbstractRange{I} = vertices(L.S.res),
    ) where {UPLO, T, I <: Integer, INV}

    ns = zero(I); Uptr[one(I)] = one(I)

    for j in rng
        ns = fisherroot_fwd_loop!(
            Uptr, Uval, Fval,
            L.S.Dptr, L.S.Lptr,
            L.Dval, L.Lval,
            Y.Dval, Y.Lval,
            L.S.res, L.S.rel, L.S.chd, ns, j, L.uplo, inv
        )
    end

    return
end

function fisherroot_fwd_loop!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        LDval::AbstractVector{T},
        LLval::AbstractVector{T},
        YDval::AbstractVector{T},
        YLval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, INV}
    nn = eltypedegree(res, j)

    if isone(nn)
        return fisherroot_fwd_loop_nod!(
            Uptr, Uval, Fval,
            Dptr, Lptr,
            LDval, LLval,
            YDval, YLval,
            res, rel, chd, ns, j, uplo, inv
        )
    else
        return fisherroot_fwd_loop_snd!(
            Uptr, Uval, Fval,
            Dptr, Lptr,
            LDval, LLval,
            YDval, YLval,
            res, rel, chd, ns, nn, j, uplo, inv
        )
    end
end

function fisherroot_fwd_loop_snd!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        LDval::AbstractVector{T},
        LLval::AbstractVector{T},
        YDval::AbstractVector{T},
        YLval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        nn::I,
        j::I,
        uplo::Val{UPLO},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, INV}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁₁     ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₁₁ = view(F, oneto(nn), oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
    end
    #
    # Dp and Lp are indices into the diagonal and off-diagonal blocks
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    #
    # Y is the direction matrix at node j
    #
    #          res(j)
    #     Y = [ Y₁₁  ] res(j)
    #         [ Y₂₁  ] sep(j)
    #
    Y₁₁ = reshape(view(YDval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        Y₂₁ = reshape(view(YLval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        Y₂₁ = reshape(view(YLval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # L is the Cholesky factor at node j
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    L₁₁ = reshape(view(LDval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(LLval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(LLval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    #     F ← 0
    #
    zerotri!(F₁₁, uplo)
    zerorec!(F₂₁)
    zerotri!(F₂₂, uplo)

    for i in Iterators.reverse(neighbors(chd, j))
        #
        # add the update matrix for child i to F
        #
        #     F ← F + Rᵢ Uᵢ Rᵢᵀ
        #
        fisherroot_add_update!(F, Uptr, Uval, rel, ns, i, uplo)
        ns -= one(I)
    end
    #
    #     Y ← Y + F
    #
    #
    # U₂₂ is the update matrix for node j
    #
    if UPLO === :L
        sdR, sdL = Val(:R), Val(:L)
        trN, trC = Val(:N), Val(:C)
    else
        sdR, sdL = Val(:L), Val(:R)
        trN, trC = Val(:C), Val(:N)
    end

    if !INV
        α = -one(real(T))
        #
        #     Y ← Y + F
        #
        addtri!(Y₁₁, F₁₁, uplo)
        addrec!(Y₂₁, F₂₁)
        #
        #     Y₁₁ ← L₁₁⁻¹ Y₁₁ L₁₁⁻ᴴ
        #
        symmtri!(Y₁₁, uplo)
        trsm!(sdR, uplo, Val(:C), Val(:N), one(T), L₁₁, Y₁₁)
        trsm!(sdL, uplo, Val(:N), Val(:N), one(T), L₁₁, Y₁₁)
    else
        α = one(real(T))
    end

    if ispositive(na)
        ns += one(I)
        strt = Uptr[ns]
        stop = Uptr[ns + one(I)] = strt + na * na
        U₂₂ = reshape(view(Uval, strt:stop - one(I)), na, na)
        #
        #     U₂₂ ← F₂₂
        #
        copytri!(U₂₂, F₂₂, uplo)
        #
        #     Y₂₁ ← Y₂₁ L₁₁⁻ᴴ
        #
        if !INV
            trsm!(sdR, uplo, Val(:C), Val(:N), one(T), L₁₁, Y₂₁)
        end
        #
        #     U₂₂ ← U₂₂ +   L₂₁ Y₁₁ L₂₁ᴴ + α L₂₁ Y₂₁ᴴ + α Y₂₁ L₂₁ᴴ
        #     Y₂₁ ← Y₂₁ + α L₂₁ Y₁₁
        #
        gemmt!(uplo, trN, trC, α, L₂₁, Y₂₁, one(T), U₂₂)
        symm!(sdR, uplo, α, Y₁₁, L₂₁, one(T), Y₂₁)
        gemmt!(uplo, trN, trC, α, Y₂₁, L₂₁, one(T), U₂₂)
        #
        #     Y₂₁ ← Y₂₁ L₁₁ᴴ
        #
        if INV
            trmm!(sdR, uplo, Val(:C), Val(:N), one(T), L₁₁, Y₂₁)
        end
    end

    if INV
        #
        #     Y₁₁ ← L₁₁ Y₁₁ L₁₁ᴴ
        #
        symmtri!(Y₁₁, uplo)
        trmm!(sdR, uplo, Val(:C), Val(:N), one(T), L₁₁, Y₁₁)
        trmm!(sdL, uplo, Val(:N), Val(:N), one(T), L₁₁, Y₁₁)
        #
        #     Y ← Y + F
        #
        addtri!(Y₁₁, F₁₁, uplo)
        addrec!(Y₂₁, F₂₁)
    end

    return ns
end

# Fast path for nn = 1 (residual size is 1)
# In this case, diagonal blocks are scalars and off-diagonal blocks are vectors
function fisherroot_fwd_loop_nod!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        LDval::AbstractVector{T},
        LLval::AbstractVector{T},
        YDval::AbstractVector{T},
        YLval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, INV}
    #
    # nn = 1 (the size of the residual at node j)
    #
    nn = one(I)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) | = 1 + na
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           1   na
    #     F = [ f₁₁     ] 1
    #         [ f₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        f₂₁ = view(F, nn + one(I):nj, one(I))
    else
        f₂₁ = view(F, one(I), nn + one(I):nj)
    end
    #
    # Dp and Lp are indices into the diagonal and off-diagonal blocks
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    #
    # Y is the direction matrix at node j (y₁₁ is scalar, y₂₁ is vector)
    #
    y₁₁ = YDval[Dp]
    y₂₁ = view(YLval, Lp:Lp + na - one(I))
    #
    # L is the Cholesky factor at node j (l₁₁ is scalar, l₂₁ is vector)
    #
    l₁₁ = LDval[Dp]
    l₂₁ = view(LLval, Lp:Lp + na - one(I))
    #
    #     F ← 0
    #
    F[one(I)] = zero(T)
    zerorec!(f₂₁)
    zerotri!(F₂₂, uplo)

    for i in Iterators.reverse(neighbors(chd, j))
        #
        # add the update matrix for child i to F
        #
        #     F ← F + Rᵢ Uᵢ Rᵢᵀ
        #
        fisherroot_add_update!(F, Uptr, Uval, rel, ns, i, uplo)
        ns -= one(I)
    end
    #
    # Load f₁₁ after children updates
    #
    f₁₁ = F[one(I)]
    #
    #     Y ← Y + F
    #
    #
    # U₂₂ is the update matrix for node j
    #
    if !INV
        α = -one(real(T))
        #
        #     y₁₁ ← y₁₁ + f₁₁
        #
        y₁₁ += f₁₁
        addrec!(y₂₁, f₂₁)
        #
        #     y₁₁ ← l₁₁⁻¹ y₁₁ l₁₁⁻ᴴ = y₁₁ / |l₁₁|²
        #
        y₁₁ /= abs2(l₁₁)
    else
        α = one(real(T))
    end

    if ispositive(na)
        ns += one(I)
        strt = Uptr[ns]
        stop = Uptr[ns + one(I)] = strt + na * na
        U₂₂ = reshape(view(Uval, strt:stop - one(I)), na, na)
        #
        #     U₂₂ ← F₂₂
        #
        copytri!(U₂₂, F₂₂, uplo)
        #
        #     y₂₁ ← y₂₁ / conj(l₁₁)
        #
        if !INV
            rdiv!(y₂₁, conj(l₁₁))
        end
        #
        #     U₂₂ ← U₂₂ + α l₂₁ y₂₁ᴴ
        #
        gert!(uplo, α, l₂₁, y₂₁, U₂₂)
        #
        #     y₂₁ ← y₂₁ + α y₁₁ l₂₁
        #
        axpy!(α * y₁₁, l₂₁, y₂₁)
        #
        #     U₂₂ ← U₂₂ + α y₂₁ l₂₁ᴴ
        #
        gert!(uplo, α, y₂₁, l₂₁, U₂₂)
        #
        #     y₂₁ ← y₂₁ * conj(l₁₁)
        #
        if INV
            rmul!(y₂₁, conj(l₁₁))
        end
    end

    if INV
        #
        #     y₁₁ ← l₁₁ y₁₁ l₁₁ᴴ = y₁₁ * |l₁₁|²
        #
        y₁₁ *= abs2(l₁₁)
        #
        #     y₁₁ ← y₁₁ + f₁₁
        #
        y₁₁ += f₁₁
        addrec!(y₂₁, f₂₁)
    end
    #
    # Write back scalar
    #
    YDval[Dp] = y₁₁

    return ns
end

function fisherroot_bwd!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        L::ChordalTriangular{:N, UPLO, T, I},
        Y::ChordalTriangular{:N, UPLO, T, I},
        inv::Val{INV},
        rng::AbstractRange{I} = vertices(L.S.res),
    ) where {UPLO, T, I <: Integer, INV}

    ns = zero(I); Uptr[one(I)] = one(I)

    for j in reverse(rng)
        ns = fisherroot_bwd_loop!(
            Uptr, Uval, Fval,
            L.S.Dptr, L.S.Lptr,
            L.Dval, L.Lval,
            Y.Dval, Y.Lval,
            L.S.res, L.S.rel, L.S.chd, ns, j, L.uplo, inv
        )
    end

    return
end

function fisherroot_bwd_loop!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        LDval::AbstractVector{T},
        LLval::AbstractVector{T},
        YDval::AbstractVector{T},
        YLval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, INV}
    nn = eltypedegree(res, j)

    if isone(nn)
        return fisherroot_bwd_loop_nod!(
            Uptr, Uval, Fval,
            Dptr, Lptr,
            LDval, LLval,
            YDval, YLval,
            res, rel, chd, ns, j, uplo, inv
        )
    else
        return fisherroot_bwd_loop_snd!(
            Uptr, Uval, Fval,
            Dptr, Lptr,
            LDval, LLval,
            YDval, YLval,
            res, rel, chd, ns, nn, j, uplo, inv
        )
    end
end

function fisherroot_bwd_loop_snd!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        LDval::AbstractVector{T},
        LLval::AbstractVector{T},
        YDval::AbstractVector{T},
        YLval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        nn::I,
        j::I,
        uplo::Val{UPLO},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, INV}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁₁     ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₁₁ = view(F, oneto(nn), oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
    end
    #
    # Dp and Lp are indices into the diagonal and off-diagonal blocks
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    #
    # Y is the direction matrix at node j
    #
    #          res(j)
    #     Y = [ Y₁₁  ] res(j)
    #         [ Y₂₁  ] sep(j)
    #
    Y₁₁ = reshape(view(YDval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        Y₂₁ = reshape(view(YLval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        Y₂₁ = reshape(view(YLval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # L is the Cholesky factor at node j
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    L₁₁ = reshape(view(LDval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(LLval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(LLval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    #     F ← Y
    #
    if UPLO === :L
        sdR, sdL = Val(:R), Val(:L)
        trN, trC = Val(:C), Val(:N)
    else
        sdR, sdL = Val(:L), Val(:R)
        trN, trC = Val(:N), Val(:C)
    end

    if INV
        α = one(real(T))
        #
        #     F ← Y
        #
        copytri!(F₁₁, Y₁₁, uplo)
        copyrec!(F₂₁, Y₂₁)
        #
        #     Y₁₁ ← L₁₁ᴴ Y₁₁ L₁₁
        #
        symmtri!(Y₁₁, uplo)
        trmm!(sdR, uplo, Val(:N), Val(:N), one(T), L₁₁, Y₁₁)
        trmm!(sdL, uplo, Val(:C), Val(:N), one(T), L₁₁, Y₁₁)
    else
        α = -one(real(T))
    end
    #
    # S₂₂ is the update matrix from the parent of node j
    #
    if ispositive(na)
        strt = Uptr[ns]
        S₂₂ = reshape(view(Uval, strt:strt + na * na - one(I)), na, na)
        ns -= one(I)
        #
        #     F₂₂ ← S₂₂
        #
        copytri!(F₂₂, S₂₂, uplo)
        #
        #     Y₂₁ ← Y₂₁ L₁₁
        #
        if INV
            trmm!(sdR, uplo, Val(:N), Val(:N), one(T), L₁₁, Y₂₁)
        end
        #
        #     Y₁₁ ← Y₁₁ + L₂₁ᴴ S₂₂ L₂₁ + α L₂₁ᴴ Y₂₁ + α Y₂₁ᴴ L₂₁
        #     Y₂₁ ← Y₂₁ +    α S₂₂ L₂₁
        #
        gemmt!(uplo, trN, trC, α, L₂₁, Y₂₁, one(T), Y₁₁)
        symm!(sdL, uplo, α, S₂₂, L₂₁, one(T), Y₂₁)
        gemmt!(uplo, trN, trC, α, Y₂₁, L₂₁, one(T), Y₁₁)
        #
        #     Y₂₁ ← Y₂₁ L₁₁⁻¹
        #
        if !INV
            trsm!(sdR, uplo, Val(:N), Val(:N), one(T), L₁₁, Y₂₁)
        end
    end

    if !INV
        #
        #     Y₁₁ ← L₁₁⁻ᴴ Y₁₁ L₁₁⁻¹
        #
        symmtri!(Y₁₁, uplo)
        trsm!(sdR, uplo, Val(:N), Val(:N), one(T), L₁₁, Y₁₁)
        trsm!(sdL, uplo, Val(:C), Val(:N), one(T), L₁₁, Y₁₁)
        #
        #     F ← Y
        #
        copytri!(F₁₁, Y₁₁, uplo)
        copyrec!(F₂₁, Y₂₁)
    end

    for i in neighbors(chd, j)
        #
        # send update matrix to child i
        #
        #     Uᵢ ← Rᵢᵀ F Rᵢ
        #
        ns += one(I)
        fisherroot_get_update!(F, Uptr, Uval, rel, ns, i, uplo)
    end

    return ns
end

# Fast path for nn = 1 (residual size is 1)
# In this case, diagonal blocks are scalars and off-diagonal blocks are vectors
function fisherroot_bwd_loop_nod!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        LDval::AbstractVector{T},
        LLval::AbstractVector{T},
        YDval::AbstractVector{T},
        YLval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, INV}
    #
    # nn = 1 (the size of the residual at node j)
    #
    nn = one(I)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) | = 1 + na
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           1   na
    #     F = [ f₁₁     ] 1
    #         [ f₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        f₂₁ = view(F, nn + one(I):nj, one(I))
    else
        f₂₁ = view(F, one(I), nn + one(I):nj)
    end
    #
    # Dp and Lp are indices into the diagonal and off-diagonal blocks
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    #
    # Y is the direction matrix at node j (y₁₁ is scalar, y₂₁ is vector)
    #
    y₁₁ = YDval[Dp]
    y₂₁ = view(YLval, Lp:Lp + na - one(I))
    #
    # L is the Cholesky factor at node j (l₁₁ is scalar, l₂₁ is vector)
    #
    l₁₁ = LDval[Dp]
    l₂₁ = view(LLval, Lp:Lp + na - one(I))

    if INV
        α = one(real(T))
        #
        #     f₁₁ ← y₁₁, f₂₁ ← y₂₁
        #
        f₁₁ = y₁₁
        copyrec!(f₂₁, y₂₁)
        #
        #     y₁₁ ← l₁₁ᴴ y₁₁ l₁₁ = y₁₁ * |l₁₁|²
        #
        y₁₁ *= abs2(l₁₁)
    else
        α = -one(real(T))
        f₁₁ = zero(T)
    end
    #
    # S₂₂ is the update matrix from the parent of node j
    #
    if ispositive(na)
        strt = Uptr[ns]
        S₂₂ = reshape(view(Uval, strt:strt + na * na - one(I)), na, na)
        ns -= one(I)
        #
        #     F₂₂ ← S₂₂
        #
        copytri!(F₂₂, S₂₂, uplo)
        #
        #     y₂₁ ← y₂₁ * l₁₁
        #
        if INV
            rmul!(y₂₁, l₁₁)
        end
        #
        #     y₁₁ ← y₁₁ + α l₂₁ᴴ y₂₁ (dot product)
        #
        y₁₁ += α * dot(l₂₁, y₂₁)
        #
        #     y₂₁ ← y₂₁ + α S₂₂ l₂₁ (symv)
        #
        symv!(uplo, α, S₂₂, l₂₁, one(T), y₂₁)
        #
        #     y₁₁ ← y₁₁ + α y₂₁ᴴ l₂₁ (dot product)
        #
        y₁₁ += α * dot(y₂₁, l₂₁)
        #
        #     y₂₁ ← y₂₁ / l₁₁
        #
        if !INV
            rdiv!(y₂₁, l₁₁)
        end
    end

    if !INV
        #
        #     y₁₁ ← l₁₁⁻ᴴ y₁₁ l₁₁⁻¹ = y₁₁ / |l₁₁|²
        #
        y₁₁ /= abs2(l₁₁)
        #
        #     f₁₁ ← y₁₁, f₂₁ ← y₂₁
        #
        f₁₁ = y₁₁
        copyrec!(f₂₁, y₂₁)
    end
    #
    # Write back scalars
    #
    F[one(I)] = f₁₁
    YDval[Dp] = y₁₁

    for i in neighbors(chd, j)
        #
        # send update matrix to child i
        #
        #     Uᵢ ← Rᵢᵀ F Rᵢ
        #
        ns += one(I)
        fisherroot_get_update!(F, Uptr, Uval, rel, ns, i, uplo)
    end

    return ns
end

function fisherroot_scale!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        L::ChordalTriangular{:N, UPLO, T, I},
        S::ChordalTriangular{:N, UPLO, T, I},
        Y::ChordalTriangular{:N, UPLO, T, I},
        adj::Val{ADJ},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, ADJ, INV}

    ns = zero(I); Uptr[one(I)] = one(I)

    for j in reverse(vertices(L.S.res))
        ns, info = fisherroot_scale_loop!(
            Uptr, Uval, Fval,
            L.S.Dptr, L.S.Lptr,
            L.Dval, L.Lval,
            S.Dval, S.Lval,
            Y.Dval, Y.Lval,
            L.S.res, L.S.rel, L.S.chd, ns, j, L.uplo, adj, inv
        )
        ispositive(info) && return info
    end

    return zero(I)
end

function fisherroot_scale_loop!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        LDval::AbstractVector{T},
        LLval::AbstractVector{T},
        SDval::AbstractVector{T},
        SLval::AbstractVector{T},
        YDval::AbstractVector{T},
        YLval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        adj::Val{ADJ},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, ADJ, INV}
    nn = eltypedegree(res, j)

    if isone(nn)
        return fisherroot_scale_loop_nod!(
            Uptr, Uval, Fval,
            Dptr, Lptr,
            LDval, LLval,
            SDval, SLval,
            YDval, YLval,
            res, rel, chd, ns, j, uplo, adj, inv
        )
    else
        return fisherroot_scale_loop_snd!(
            Uptr, Uval, Fval,
            Dptr, Lptr,
            LDval, LLval,
            SDval, SLval,
            YDval, YLval,
            res, rel, chd, ns, nn, j, uplo, adj, inv
        )
    end
end

function fisherroot_scale_loop_snd!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        LDval::AbstractVector{T},
        LLval::AbstractVector{T},
        SDval::AbstractVector{T},
        SLval::AbstractVector{T},
        YDval::AbstractVector{T},
        YLval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        nn::I,
        j::I,
        uplo::Val{UPLO},
        adj::Val{ADJ},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, ADJ, INV}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁₁     ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₁₁ = view(F, oneto(nn), oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
    end
    #
    # Dp and Lp are indices into the diagonal and off-diagonal blocks
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    #
    # S is the selected inverse at node j
    #
    #          res(j)
    #     S = [ S₁₁  ] res(j)
    #         [ S₂₁  ] sep(j)
    #
    S₁₁ = reshape(view(SDval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        S₂₁ = reshape(view(SLval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        S₂₁ = reshape(view(SLval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    #     F ← S
    #
    copytri!(F₁₁, S₁₁, uplo)
    copyrec!(F₂₁, S₂₁)
    #
    # Y is the direction matrix at node j
    #
    #          res(j)
    #     Y = [ Y₁₁  ] res(j)
    #         [ Y₂₁  ] sep(j)
    #
    Y₁₁ = reshape(view(YDval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        Y₂₁ = reshape(view(YLval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        Y₂₁ = reshape(view(YLval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # L is the Cholesky factor at node j
    #
    #          res(j)
    #     L = [ L₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    L₁₁ = reshape(view(LDval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(LLval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(LLval, Lp:Lp + nn * na - one(I)), nn, na)
    end

    if UPLO === :L
        sdL = Val(:L)
    else
        sdL = Val(:R)
    end

    if ADJ
        trR = Val(:N)
    else
        trR = Val(:C)
    end
    #
    # S₂₂ is the update matrix from the parent of node j
    #
    if ispositive(na)
        strt = Uptr[ns]
        S₂₂ = reshape(view(Uval, strt:strt + na * na - one(I)), na, na)
        ns -= one(I)
        #
        #     F₂₂ ← S₂₂
        #
        copytri!(F₂₂, S₂₂, uplo)
        #
        #     S₂₂ ← chol(S₂₂)
        #
        info = potrf!(uplo, S₂₂)
        ispositive(info) && return ns, info
        #
        #     Y₂₁ ← S₂₂⁻ᴴ Y₂₁  or  Y₂₁ ← S₂₂ᴴ Y₂₁
        #
        if INV
            trsm!(sdL, uplo, trR, Val(:N), one(T), S₂₂, Y₂₁)
        else
            trmm!(sdL, uplo, trR, Val(:N), one(T), S₂₂, Y₂₁)
        end
    end

    for i in neighbors(chd, j)
        #
        # send update matrix to child i
        #
        #     Uᵢ ← Rᵢᵀ F Rᵢ
        #
        ns += one(I)
        fisherroot_get_update!(F, Uptr, Uval, rel, ns, i, uplo)
    end

    return ns, zero(I)
end

# Fast path for nn = 1 (residual size is 1)
# In this case, diagonal blocks are scalars and off-diagonal blocks are vectors
function fisherroot_scale_loop_nod!(
        Uptr::AbstractVector{I},
        Uval::AbstractVector{T},
        Fval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Lptr::AbstractVector{I},
        LDval::AbstractVector{T},
        LLval::AbstractVector{T},
        SDval::AbstractVector{T},
        SLval::AbstractVector{T},
        YDval::AbstractVector{T},
        YLval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        adj::Val{ADJ},
        inv::Val{INV},
    ) where {UPLO, T, I <: Integer, ADJ, INV}
    #
    # nn = 1 (the size of the residual at node j)
    #
    nn = one(I)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) | = 1 + na
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           1   na
    #     F = [ f₁₁     ] 1
    #         [ f₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        f₂₁ = view(F, nn + one(I):nj, one(I))
    else
        f₂₁ = view(F, one(I), nn + one(I):nj)
    end
    #
    # Dp and Lp are indices into the diagonal and off-diagonal blocks
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    #
    # S is the selected inverse at node j (s₁₁ is scalar, s₂₁ is vector)
    #
    s₁₁ = SDval[Dp]
    s₂₁ = view(SLval, Lp:Lp + na - one(I))
    #
    #     F ← S (f₁₁ ← s₁₁ is scalar, f₂₁ ← s₂₁ is vector copy)
    #
    F[one(I)] = s₁₁
    copyrec!(f₂₁, s₂₁)
    #
    # Y is the direction matrix at node j (y₂₁ is vector)
    #
    y₂₁ = view(YLval, Lp:Lp + na - one(I))

    if ADJ
        trR = Val(:N)
    else
        trR = Val(:C)
    end
    #
    # For UPLO === :U, we need to swap transpose for right-multiplication on vectors
    # Right mult by U → left mult by Uᵀ, so :N → :T
    # Right mult by Uᴴ → left mult by U* = Ū, which for real is U, so :C → :N
    #
    if UPLO === :U
        if ADJ
            trV = Val(:T)
        else
            trV = Val(:N)
        end
    else
        trV = trR
    end
    #
    # S₂₂ is the update matrix from the parent of node j
    #
    if ispositive(na)
        strt = Uptr[ns]
        S₂₂ = reshape(view(Uval, strt:strt + na * na - one(I)), na, na)
        ns -= one(I)
        #
        #     F₂₂ ← S₂₂
        #
        copytri!(F₂₂, S₂₂, uplo)
        #
        #     S₂₂ ← chol(S₂₂)
        #
        info = potrf!(uplo, S₂₂)
        ispositive(info) && return ns, info
        #
        #     y₂₁ ← S₂₂⁻ᴴ y₂₁  or  y₂₁ ← S₂₂ᴴ y₂₁ (trsv/trmv for vectors)
        #
        if INV
            trsv!(uplo, trV, Val(:N), S₂₂, y₂₁)
        else
            trmv!(uplo, trV, Val(:N), S₂₂, y₂₁)
        end
    end

    for i in neighbors(chd, j)
        #
        # send update matrix to child i
        #
        #     Uᵢ ← Rᵢᵀ F Rᵢ
        #
        ns += one(I)
        fisherroot_get_update!(F, Uptr, Uval, rel, ns, i, uplo)
    end

    return ns, zero(I)
end

function fisherroot_add_update!(
        F::AbstractMatrix{T},
        ptr::AbstractVector{I},
        val::AbstractVector{T},
        rel::AbstractGraph{I},
        ns::I,
        i::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    #
    # na is the size of the separator at node i
    #
    #     na = | sep(i) |
    #
    na = eltypedegree(rel, i)
    #
    # inj is the subset inclusion
    #
    #     inj: sep(i) → bag(parent(i))
    #
    inj = neighbors(rel, i)
    #
    # U is the update matrix from child i
    #
    strt = ptr[ns]
    U = reshape(view(val, strt:strt + na * na - one(I)), na, na)
    #
    # add U to F
    #
    #     F ← F + inj U injᵀ
    #
    addscattertri!(F, U, inj, uplo)

    return
end

function fisherroot_get_update!(
        F::AbstractMatrix{T},
        ptr::AbstractVector{I},
        val::AbstractVector{T},
        rel::AbstractGraph{I},
        ns::I,
        i::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    #
    # na is the size of the separator at node i
    #
    #     na = | sep(i) |
    #
    na = eltypedegree(rel, i)
    #
    # inj is the subset inclusion
    #
    #     inj: sep(i) → bag(parent(i))
    #
    inj = neighbors(rel, i)
    #
    # U is the update matrix for child i
    #
    strt = ptr[ns]
    stop = ptr[ns + one(I)] = strt + na * na
    U = reshape(view(val, strt:stop - one(I)), na, na)
    #
    # copy F into U
    #
    #     U ← injᵀ F inj
    #
    copygathertri!(U, F, inj, uplo)
    return
end

# ===== ger2! =====

function ger2!(α, x::AbstractVector{T}, y::AbstractVector{T}, A::AbstractMatrix{T}) where {T}
    @inbounds @fastmath for j in axes(A, 2)
        αyj = α * conj(y[j])

        for i in axes(A, 1)
            A[i, j] += x[i] * αyj
        end
    end

    return
end

# ===== ger! =====

function ger!(α, x::AbstractVector{T}, y::AbstractVector{T}, A::AbstractMatrix{T}) where {T <: BlasFloat}
    BLAS.ger!(convert(T, α), x, y, A)
    return
end

function ger!(α, x::AbstractVector{T}, y::AbstractVector{T}, A::AbstractMatrix{T}) where {T}
    m = size(A, 1)
    n = size(A, 2)
    maxdim = max(m, n)

    if maxdim <= THRESHOLD
        ger2!(α, x, y, A)
    else
        l = prevpow(2, maxdim) >> 1

        if m >= n
            x₁ = view(x,     1:l)
            x₂ = view(x, l + 1:m)
            A₁ = view(A,     1:l, :)
            A₂ = view(A, l + 1:m, :)

            ger!(α, x₁, y, A₁)
            ger!(α, x₂, y, A₂)
        else
            y₁ = view(y,     1:l)
            y₂ = view(y, l + 1:n)
            A₁ = view(A, :,     1:l)
            A₂ = view(A, :, l + 1:n)

            ger!(α, x, y₁, A₁)
            ger!(α, x, y₂, A₂)
        end
    end

    return
end

function complete!(
        F::AbstractCholesky{UPLO, T};
        check::Bool=true,
    ) where {UPLO, T}
    info = complete!(triangular(F); check)
    F.info[] = info
    return F
end

function complete!(
        L::ChordalTriangular{:N, UPLO, T, I};
        check::Bool=true,
    ) where {UPLO, T, I <: Integer}
    Mptr = FVector{I}(undef, L.S.nMptr)
    Mval = FVector{T}(undef, L.S.nMval)
    Fval = FVector{T}(undef, L.S.nFval * L.S.nFval)

    info = complete_impl!(Mptr, Mval, Fval, L)

    check && checkinfo(info, L.diag)

    return info
end

#
# Convenience wrapper that unpacks ChordalTriangular types.
#
function complete_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Fval::AbstractVector{T},
        L::ChordalTriangular{:N, UPLO, T, I},
    ) where {UPLO, T, I <: Integer}
    info = complete_impl!(
        Mptr, Mval,
        L.S.Dptr, L.Dval,
        L.S.Lptr, L.Lval,
        Fval,
        L.S.res, L.S.rel, L.S.chd,
        L.uplo)

    return info
end

function complete_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}

    ns = zero(I); Mptr[one(I)] = one(I)

    for j in reverse(vertices(res))
        ns, info = complete_loop!(Mptr, Mval, Dptr, Dval, Lptr, Lval, Fval, res, rel, chd, ns, j, uplo)
        ispositive(info) && return info
    end

    return zero(I)
end

function complete_loop!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    nn = eltypedegree(res, j)

    if isone(nn)
        return complete_loop_nod!(
            Mptr, Mval,
            Dptr, Dval,
            Lptr, Lval,
            Fval,
            res, rel, chd, ns, j, uplo
        )
    else
        return complete_loop_snd!(
            Mptr, Mval,
            Dptr, Dval,
            Lptr, Lval,
            Fval,
            res, rel, chd, ns, nn, j, uplo
        )
    end
end

function complete_loop_snd!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        nn::I,
        j::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁₁     ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₁₁ = view(F, oneto(nn),      oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
    end
    #
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ D₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # copy L into F
    #
    #     F₁₁ ← D₁₁
    #     F₂₁ ← L₂₁
    #
    copytri!(F₁₁, D₁₁, uplo)
    copyrec!(F₂₁, L₂₁)

    if ispositive(na)
        #
        # M₂₂ is the update matrix from the parent of node j
        #
        strt = Mptr[ns]
        M₂₂ = reshape(view(Mval, strt:strt + na * na - one(I)), na, na)
        ns -= one(I)
        #
        # copy M into F
        #
        #     F₂₂ ← M₂₂
        #
        copytri!(F₂₂, M₂₂, uplo)
        #
        # factorize M₂₂
        #
        #     M₂₂ ← chol(M₂₂)
        #
        info = potrf!(uplo, M₂₂)
        ispositive(info) && return ns, info
        #
        # solve
        #
        #     L₂₁ ← M₂₂⁻¹ L₂₁
        #
        if UPLO === :L
            trsm!(Val(:L), Val(:L), Val(:N), Val(:N), one(T), M₂₂, L₂₁)
        else
            trsm!(Val(:R), Val(:U), Val(:N), Val(:N), one(T), M₂₂, L₂₁)
        end
        #
        #     D₁₁ ← D₁₁ - L₂₁ᴴ L₂₁
        #
        if UPLO === :L
            syrk!(Val(:L), Val(:C), -one(real(T)), L₂₁, one(real(T)), D₁₁)
        else
            syrk!(Val(:U), Val(:N), -one(real(T)), L₂₁, one(real(T)), D₁₁)
        end
        #
        # solve
        #
        #     L₂₁ ← -M₂₂⁻ᴴ L₂₁
        #
        if UPLO === :L
            trsm!(Val(:L), Val(:L), Val(:C), Val(:N), -one(T), M₂₂, L₂₁)
        else
            trsm!(Val(:R), Val(:U), Val(:C), Val(:N), -one(T), M₂₂, L₂₁)
        end
    end
    #
    #     D₁₁ ← chol(D₁₁⁻¹)
    #
    if UPLO === :L
        loup = Val(:U)
    else
        loup = Val(:L)
    end

    revtri!(D₁₁, uplo)
    info = potrf!(loup, D₁₁)
    ispositive(info) && return ns, info
    revtri!(D₁₁, loup)

    if ispositive(na)
        #
        #     L₂₁ ← L₂₁ D₁₁⁻¹
        #
        if UPLO === :L
            trsm!(Val(:R), Val(:L), Val(:N), Val(:N), one(T), D₁₁, L₂₁)
        else
            trsm!(Val(:L), Val(:U), Val(:N), Val(:N), one(T), D₁₁, L₂₁)
        end
    end

    trtri!(uplo, Val(:N), D₁₁)

    for i in neighbors(chd, j)
        #
        # send update matrix to child i
        #
        #     Mᵢ ← Rᵢᵀ F Rᵢ
        #
        ns += one(I)
        complete_send!(F, Mptr, Mval, rel, ns, i, uplo)
    end

    return ns, zero(I)
end

# Fast path for nn = 1 (residual size is 1)
# In this case, diagonal blocks are scalars and off-diagonal blocks are vectors
function complete_loop_nod!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    #
    # nn = 1 (the size of the residual at node j)
    #
    nn = one(I)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) | = 1 + na
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           1   na
    #     F = [ f₁₁     ] 1
    #         [ f₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        f₂₁ = view(F, nn + one(I):nj, one(I))
    else
        f₂₁ = view(F, one(I), nn + one(I):nj)
    end
    #
    # L is part of the Cholesky factor (d₁₁ is scalar, l₂₁ is vector)
    #
    #          res(j)
    #     L = [ d₁₁  ] res(j)
    #         [ l₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    d₁₁ = Dval[Dp]
    l₂₁ = view(Lval, Lp:Lp + na - one(I))
    #
    # copy L into F
    #
    #     f₁₁ ← d₁₁
    #     f₂₁ ← l₂₁
    #
    F[one(I)] = d₁₁
    copyrec!(f₂₁, l₂₁)

    if ispositive(na)
        #
        # M₂₂ is the update matrix from the parent of node j
        #
        strt = Mptr[ns]
        M₂₂ = reshape(view(Mval, strt:strt + na * na - one(I)), na, na)
        ns -= one(I)
        #
        # copy M into F
        #
        #     F₂₂ ← M₂₂
        #
        copytri!(F₂₂, M₂₂, uplo)
        #
        # factorize M₂₂
        #
        #     M₂₂ ← chol(M₂₂)
        #
        info = potrf!(uplo, M₂₂)
        ispositive(info) && return ns, info
        #
        # solve
        #
        #     l₂₁ ← M₂₂⁻¹ l₂₁ (trsv for vectors)
        #
        if UPLO === :L
            trsv!(Val(:L), Val(:N), Val(:N), M₂₂, l₂₁)
        else
            trsv!(Val(:U), Val(:T), Val(:N), M₂₂, l₂₁)
        end
        #
        #     d₁₁ ← d₁₁ - l₂₁ᴴ l₂₁ (dot product)
        #
        d₁₁ -= dot(l₂₁, l₂₁)
        #
        # solve
        #
        #     l₂₁ ← -M₂₂⁻ᴴ l₂₁ (trsv for vectors, then negate)
        #
        if UPLO === :L
            trsv!(Val(:L), Val(:C), Val(:N), M₂₂, l₂₁)
        else
            trsv!(Val(:U), Val(:N), Val(:N), M₂₂, l₂₁)
        end

        rmul!(l₂₁, -one(T))
    end
    #
    #     d₁₁ ← sqrt(d₁₁) (scalar Cholesky, check positive definite)
    #
    if !ispositive(real(d₁₁))
        return ns, one(I)
    end

    d₁₁ = sqrt(d₁₁)

    if ispositive(na)
        #
        #     l₂₁ ← l₂₁ / d₁₁
        #
        rdiv!(l₂₁, d₁₁)
    end
    #
    #     d₁₁ ← 1 / d₁₁
    #
    d₁₁ = inv(d₁₁)
    #
    # Write back scalar
    #
    Dval[Dp] = d₁₁

    for i in neighbors(chd, j)
        #
        # send update matrix to child i
        #
        #     Mᵢ ← Rᵢᵀ F Rᵢ
        #
        ns += one(I)
        complete_send!(F, Mptr, Mval, rel, ns, i, uplo)
    end

    return ns, zero(I)
end

function complete_send!(
        F::AbstractMatrix{T},
        ptr::AbstractVector{I},
        val::AbstractVector{T},
        rel::AbstractGraph{I},
        ns::I,
        i::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    #
    # na is the size of the separator at node i
    #
    #     na = | sep(i) |
    #
    na = eltypedegree(rel, i)
    #
    # inj is the subset inclusion
    #
    #     inj: sep(i) → bag(parent(i))
    #
    inj = neighbors(rel, i)
    #
    # M is the update matrix for child i
    #
    strt = ptr[ns]
    stop = ptr[ns + one(I)] = strt + na * na
    M = reshape(view(val, strt:stop - one(I)), na, na)
    #
    # copy F into M
    #
    #     M ← Rᵢᵀ F Rᵢ
    #
    copygathertri!(M, F, inj, uplo)
    return
end

function uncholesky!(
        F::AbstractCholesky{UPLO, T},
    ) where {UPLO, T}
    F.info[] = unfactorize!(triangular(F), F.d)
    return F
end

function uncholesky!(
        L::ChordalTriangular{:N, UPLO, T, I},
    ) where {UPLO, T, I <: Integer}
    d = Ones{T}(ncl(L))
    return unfactorize!(L, d)
end

function unldlt!(
        F::AbstractLDLt{UPLO, T},
    ) where {UPLO, T}
    F.info[] = unfactorize!(triangular(F), F.d)
    return F
end

function unfactorize!(
        F::AbstractFactorization{DIAG, UPLO, T},
    ) where {DIAG, UPLO, T}
    F.info[] = unfactorize!(triangular(F), F.d)
    return F
end

function unfactorize!(
        L::ChordalTriangular{DIAG, UPLO, T, I},
        d::AbstractVector{T},
    ) where {DIAG, UPLO, T, I <: Integer}
    Mptr = FVector{I}(undef, L.S.nMptr)
    Mval = FVector{T}(undef, L.S.nMval)
    Fval = FVector{T}(undef, L.S.nFval * L.S.nFval)
    Wval = FVector{T}(undef, L.S.nFval * L.S.nFval)

    info = unchol_impl!(Mptr, Mval, Fval, Wval, L, d)
    return info
end

#
# Convenience wrapper that unpacks ChordalTriangular types (with d vector for LDLt).
#
function unchol_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Fval::AbstractVector{T},
        Wval::AbstractVector{T},
        L::ChordalTriangular{DIAG, UPLO, T, I},
        d::AbstractVector{T},
    ) where {DIAG, UPLO, T, I <: Integer}
    info = unchol_impl!(
        Mptr, Mval,
        L.S.Dptr, L.Dval,
        L.S.Lptr, L.Lval,
        d, Fval, Wval,
        L.S.res, L.S.rel, L.S.chd,
        L.uplo, L.diag)

    return info
end

#
# Convenience wrapper for Cholesky (creates d = Ones internally).
#
function unchol_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Fval::AbstractVector{T},
        Wval::AbstractVector{T},
        L::ChordalTriangular{:N, UPLO, T, I},
    ) where {UPLO, T, I <: Integer}
    d = Ones{T}(ncl(L))
    info = unchol_impl!(Mptr, Mval, Fval, Wval, L, d)
    return info
end

function unchol_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        Wval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {UPLO, DIAG, T, I <: Integer}

    ns = zero(I); Mptr[one(I)] = one(I)

    for j in vertices(res)
        ns = unchol_loop!(Mptr, Mval, Dptr, Dval, Lptr, Lval, d, Fval, Wval, res, rel, chd, ns, j, uplo, diag)
    end

    return zero(I)
end

function unchol_loop!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        Wval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {UPLO, DIAG, T, I <: Integer}
    nn = eltypedegree(res, j)

    if isone(nn)
        return unchol_loop_nod!(
            Mptr, Mval,
            Dptr, Dval,
            Lptr, Lval,
            d, Fval, Wval,
            res, rel, chd, ns, j, uplo, diag
        )
    else
        return unchol_loop_snd!(
            Mptr, Mval,
            Dptr, Dval,
            Lptr, Lval,
            d, Fval, Wval,
            res, rel, chd, ns, nn, j, uplo, diag
        )
    end
end

function unchol_loop_snd!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        Wval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        nn::I,
        j::I,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {UPLO, DIAG, T, I <: Integer}
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁₁     ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₁₁ = view(F, oneto(nn), oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
    end
    #
    # L is part of the Cholesky factor
    #
    #          res(j)
    #     L = [ D₁₁  ] res(j)
    #         [ L₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    d₁₁ = view(d, neighbors(res, j))
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
        side = Val(:R)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
        side = Val(:L)
    end
    #
    #     F ← 0
    #
    zerotri!(F, uplo)

    for i in Iterators.reverse(neighbors(chd, j))
        #
        # add the update matrix for child i to F
        #
        #     F ← F + Rᵢ Mᵢ Rᵢᵀ
        #
        unchol_recv!(F, Mptr, Mval, rel, ns, i, uplo)
        ns -= one(I)
    end
    #
    # M₂₂ is the update matrix for node j
    #
    # compute M₂₂ BEFORE modifying L₂₁
    #
    #     M₂₂ ← F₂₂ + L₂₁ D L₂₁ᵀ  (D = I for Cholesky, D = diag(d₁₁) for LDLt)
    #
    if ispositive(na)
        ns += one(I)
        strt = Mptr[ns]
        stop = Mptr[ns + one(I)] = strt + na * na
        M₂₂ = reshape(view(Mval, strt:stop - one(I)), na, na)
        copytri!(M₂₂, F₂₂, uplo)

        if UPLO === :L
            syrk!(Val(:L), Val(:N), one(real(T)), Wval, L₂₁, d₁₁, one(real(T)), M₂₂, diag)
        else
            syrk!(Val(:U), Val(:C), one(real(T)), Wval, L₂₁, d₁₁, one(real(T)), M₂₂, diag)
        end
        #
        # compute L D Lᵀ
        #
        #     L₂₁ ← L₂₁ D D₁₁ᵀ  (D = I for Cholesky)
        #
        cmul!(side, diag, L₂₁, d₁₁)
        trmm!(side, uplo, Val(:C), diag, one(T), D₁₁, L₂₁)
    end
    #
    #     D₁₁ ← D₁₁ D D₁₁ᵀ  (D = I for Cholesky, D = diag(d₁₁) for LDLt)
    #
    W₁₁ = reshape(view(Wval, oneto(nn * nn)), nn, nn)
    fill!(W₁₁, zero(T))
    copytri!(W₁₁, D₁₁, uplo)

    if DIAG === :U
        @inbounds for i in diagind(W₁₁)
            W₁₁[i] = one(T)
        end
    end

    cmul!(side, diag, W₁₁, d₁₁)
    trmm!(side, uplo, Val(:C), diag, one(T), D₁₁, W₁₁)

    copytri!(D₁₁, W₁₁, uplo)
    #
    # add contributions from children
    #
    #     D₁₁ ← D₁₁ + F₁₁
    #
    addtri!(D₁₁, F₁₁, uplo)

    if ispositive(na)
        #
        #     L₂₁ ← L₂₁ + F₂₁
        #
        addrec!(L₂₁, F₂₁)
    end

    return ns
end

# Fast path for nn = 1 (residual size is 1)
# In this case, diagonal blocks are scalars and off-diagonal blocks are vectors
function unchol_loop_nod!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Fval::AbstractVector{T},
        Wval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {UPLO, DIAG, T, I <: Integer}
    #
    # nn = 1 (the size of the residual at node j)
    #
    nn = one(I)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) | = 1 + na
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           1   na
    #     F = [ f₁₁     ] 1
    #         [ f₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        f₂₁ = view(F, nn + one(I):nj, one(I))
    else
        f₂₁ = view(F, one(I), nn + one(I):nj)
    end
    #
    # L is part of the Cholesky factor (dj is scalar, D₁₁ is scalar, l₂₁ is vector)
    #
    #          res(j)
    #     L = [ D₁₁  ] res(j)
    #         [ l₂₁  ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    dj = d[first(neighbors(res, j))]
    d₁₁ = Dval[Dp]
    l₂₁ = view(Lval, Lp:Lp + na - one(I))
    #
    #     F ← 0
    #
    zerotri!(F, uplo)

    for i in Iterators.reverse(neighbors(chd, j))
        #
        # add the update matrix for child i to F
        #
        #     F ← F + Rᵢ Mᵢ Rᵢᵀ
        #
        unchol_recv!(F, Mptr, Mval, rel, ns, i, uplo)
        ns -= one(I)
    end
    #
    # Load f₁₁ after children updates
    #
    f₁₁ = F[one(I)]
    #
    # M₂₂ is the update matrix for node j
    #
    # compute M₂₂ BEFORE modifying l₂₁
    #
    #     M₂₂ ← F₂₂ + l₂₁ D l₂₁ᴴ  (D = 1 for Cholesky, D = dj for LDLt)
    #
    if ispositive(na)
        ns += one(I)
        strt = Mptr[ns]
        stop = Mptr[ns + one(I)] = strt + na * na
        M₂₂ = reshape(view(Mval, strt:stop - one(I)), na, na)
        copytri!(M₂₂, F₂₂, uplo)
        #
        # syrk becomes syr! (rank-1 update): M₂₂ ← M₂₂ + dj * l₂₁ l₂₁ᴴ
        #
        syr!(uplo, dj, l₂₁, M₂₂)
        #
        # compute L D Lᵀ
        #
        #     l₂₁ ← l₂₁ * dj * conj(D₁₁)  (for DIAG === :N)
        #     l₂₁ ← l₂₁ * dj              (for DIAG === :U, unit diagonal D₁₁ = 1)
        #
        if DIAG === :N
            rmul!(l₂₁, dj * conj(d₁₁))
        else
            rmul!(l₂₁, dj)
        end
    end
    #
    #     D₁₁ ← D₁₁ D D₁₁ᴴ  (D = 1 for Cholesky, D = dj for LDLt)
    #
    #     For DIAG === :N: w₁₁ = D₁₁ * dj * conj(D₁₁) = dj * |D₁₁|²
    #     For DIAG === :U: w₁₁ = dj (unit diagonal D₁₁ = 1, so 1 * dj * 1 = dj)
    #
    if DIAG === :N
        w₁₁ = d₁₁ * dj * conj(d₁₁)
    else
        w₁₁ = dj
    end
    #
    # add contributions from children
    #
    #     D₁₁ ← w₁₁ + f₁₁
    #
    Dval[Dp] = w₁₁ + f₁₁

    if ispositive(na)
        #
        #     l₂₁ ← l₂₁ + f₂₁
        #
        addrec!(l₂₁, f₂₁)
    end

    return ns
end

function unchol_recv!(
        F::AbstractMatrix{T},
        ptr::AbstractVector{I},
        val::AbstractVector{T},
        rel::AbstractGraph{I},
        ns::I,
        i::I,
        uplo::Val{UPLO},
    ) where {UPLO, T, I <: Integer}
    #
    # na is the size of the separator at node i
    #
    #     na = | sep(i) |
    #
    na = eltypedegree(rel, i)
    #
    # inj is the subset inclusion
    #
    #     inj: sep(i) → bag(parent(i))
    #
    inj = neighbors(rel, i)
    #
    # M is the update matrix from child i
    #
    strt = ptr[ns]
    M = reshape(view(val, strt:strt + na * na - one(I)), na, na)
    #
    # add M to F
    #
    #     F ← F + inj M injᵀ
    #
    addscattertri!(F, M, inj, uplo)
    return
end

# ===== selinv(A, F) =====

@is_primitive MinimalCtx Tuple{typeof(selinv), HermOrSymSparse, ChordalCholesky}

function Mooncake.rrule!!(
        ::CoDual{typeof(selinv)},
        cdA::CoDual{<:HermOrSymSparse},
        cdF::CoDual{<:ChordalCholesky},
    )
    A, dA = primaltangent(cdA)
    B = selinv(A, primal(cdF))
    dB = zero(B)

    function pullback!!(::NoRData)
        selinv_rrule_impl!(dA, A, primal(cdF), B, dB)
        return NoRData(), NoRData(), NoRData()
    end

    return CoDual(B, tofdata(B, dB)), pullback!!
end

function Mooncake.frule!!(
        ::Dual{typeof(selinv)},
        cdA::Dual{<:HermOrSymSparse},
        cdF::Dual{<:ChordalCholesky},
    )
    A, dA = primaltangent(cdA)
    Y, dY = selinv_frule_impl(A, primal(cdF), dA)
    return Dual(Y, totangent(Y, dY))
end

# ===== trtri! =====

function trtri!(uplo::Val, diag::Val, A::AbstractMatrix{T}) where {T <: BlasFloat}
    LAPACK.trtri!(char(uplo), char(diag), A)
    return
end

function trtri!(uplo::Val{UPLO}, diag::Val{DIAG}, A::AbstractMatrix{T}) where {T, UPLO, DIAG}
    n = size(A, 1)

    if n <= THRESHOLD
        trtri2!(uplo, diag, A)
        return
    end

    m = prevpow(2, n) >> 1

    A₁₁ = view(A,     1:m,     1:m)
    A₂₂ = view(A, m + 1:n, m + 1:n)

    trtri!(uplo, diag, A₁₁)
    trtri!(uplo, diag, A₂₂)

    if UPLO === :L
        A₂₁ = view(A, m + 1:n, 1:m)
        trmm!(Val(:R), uplo, Val(:N), diag,  one(T), A₁₁, A₂₁)
        trmm!(Val(:L), uplo, Val(:N), diag, -one(T), A₂₂, A₂₁)
    else
        A₁₂ = view(A, 1:m, m + 1:n)
        trmm!(Val(:L), uplo, Val(:N), diag,  one(T), A₁₁, A₁₂)
        trmm!(Val(:R), uplo, Val(:N), diag, -one(T), A₂₂, A₁₂)
    end

    return
end

# ===== trtri2! =====

function trtri2!(::Val{:L}, ::Val{DIAG}, A::AbstractMatrix{T}) where {T, DIAG}
    n = size(A, 1)

    @inbounds @fastmath for j in 1:n
        if DIAG === :N
            A[j, j] = inv(A[j, j])
            Ajj = -A[j, j]
        else
            Ajj = -one(T)
        end

        for i in j + 1:n
            Aij = A[i, j] * Ajj

            for k in j + 1:i - 1
                Aij -= A[i, k] * A[k, j]
            end

            if DIAG === :N
                A[i, j] = Aij / A[i, i]
            else
                A[i, j] = Aij
            end
        end
    end

    return
end

function trtri2!(::Val{:U}, ::Val{DIAG}, A::AbstractMatrix{T}) where {T, DIAG}
    n = size(A, 1)

    @inbounds @fastmath for j in n:-1:1
        if DIAG === :N
            A[j, j] = inv(A[j, j])
            Ajj = -A[j, j]
        else
            Ajj = -one(T)
        end

        for i in j - 1:-1:1
            Aij = A[i, j] * Ajj

            for k in i + 1:j - 1
                Aij -= A[i, k] * A[k, j]
            end

            if DIAG === :N
                A[i, j] = Aij / A[i, i]
            else
                A[i, j] = Aij
            end
        end
    end

    return
end

# ===== trsx2! =====

function trsx2!(side::Val{SIDE}, uplo::Val{UPLO}, trans::Val{TRANS}, diag::Val{DIAG}, A::AbstractMatrix, B::AbstractVecOrMat) where {SIDE, UPLO, TRANS, DIAG}
    if isforward(UPLO, TRANS, SIDE)
        trsx2_fwd!(side, uplo, diag, A, B)
    else
        trsx2_bwd!(side, uplo, diag, A, B)
    end
end

function trsx2_fwd!(::Val{:R}, ::Val{UPLO}, ::Val{DIAG}, A::AbstractMatrix, B::AbstractVecOrMat) where {UPLO, DIAG}
    @inbounds @fastmath for j in axes(A, 1)
        for k in 1:j - 1
            if UPLO === :L
                Akj = A[j, k]
            else
                Akj = A[k, j]
            end

            for i in axes(B, 1)
                B[i, j] -= B[i, k] * Akj
            end
        end

        if DIAG === :N
            iAjj = inv(A[j, j])

            for i in axes(B, 1)
                B[i, j] *= iAjj
            end
        end
    end
end

function trsx2_fwd!(::Val{:L}, ::Val{UPLO}, ::Val{DIAG}, A::AbstractMatrix, B::AbstractVecOrMat) where {UPLO, DIAG}
    @inbounds @fastmath for j in axes(A, 1)
        for i in axes(B, 2)
            for k in 1:j - 1
                if UPLO === :U
                    B[j, i] -= A[k, j] * B[k, i]
                else
                    B[j, i] -= A[j, k] * B[k, i]
                end
            end

            if DIAG === :N
                B[j, i] *= inv(A[j, j])
            end
        end
    end
end

function trsx2_bwd!(::Val{:R}, ::Val{UPLO}, ::Val{DIAG}, A::AbstractMatrix, B::AbstractVecOrMat) where {UPLO, DIAG}
    @inbounds @fastmath for j in reverse(axes(A, 1))
        if DIAG === :N
            iAjj = inv(A[j, j])

            for i in axes(B, 1)
                B[i, j] *= iAjj
            end
        end

        for k in 1:j - 1
            if UPLO === :L
                Akj = A[j, k]
            else
                Akj = A[k, j]
            end

            for i in axes(B, 1)
                B[i, k] -= B[i, j] * Akj
            end
        end
    end
end

function trsx2_bwd!(::Val{:L}, ::Val{UPLO}, ::Val{DIAG}, A::AbstractMatrix, B::AbstractVecOrMat) where {UPLO, DIAG}
    @inbounds @fastmath for j in reverse(axes(A, 1))
        for i in axes(B, 2)
            if DIAG === :N
                B[j, i] *= inv(A[j, j])
            end

            for k in 1:j - 1
                if UPLO === :U
                    B[k, i] -= A[k, j] * B[j, i]
                else
                    B[k, i] -= A[j, k] * B[j, i]
                end
            end
        end
    end
end

# ===== trsx! =====

function trsx!(side::Val{SIDE}, uplo::Val{UPLO}, trans::Val{TRANS}, diag::Val, A::AbstractMatrix, B::AbstractVecOrMat) where {SIDE, UPLO, TRANS}
    n = size(A, 1)

    if n <= THRESHOLD
        trsx2!(side, uplo, trans, diag, A, B)
        return
    end

    m = prevpow(2, n) >> 1

    A₁₁ = view(A, 1:m, 1:m)
    A₂₂ = view(A, m+1:n, m+1:n)

    if UPLO === :L
        A₂₁ = view(A, m+1:n, 1:m)
    else
        A₂₁ = view(A, 1:m, m+1:n)
    end

    if B isa AbstractVector
        B₁ = view(B, 1:m)
        B₂ = view(B, m+1:n)
    elseif SIDE === :R
        B₁ = view(B, :, 1:m)
        B₂ = view(B, :, m+1:n)
    else
        B₁ = view(B, 1:m, :)
        B₂ = view(B, m+1:n, :)
    end

    if isforward(UPLO, TRANS, SIDE)
        trsx!(side, uplo, trans, diag, A₁₁, B₁)

        if B isa AbstractVector
            gemv!(trans, -1, A₂₁, B₁, 1, B₂)
        elseif SIDE === :R
            gemm!(Val(:N), trans, -1, B₁, A₂₁, 1, B₂)
        else
            gemm!(trans, Val(:N), -1, A₂₁, B₁, 1, B₂)
        end

        trsx!(side, uplo, trans, diag, A₂₂, B₂)
    else
        trsx!(side, uplo, trans, diag, A₂₂, B₂)

        if B isa AbstractVector
            gemv!(trans, -1, A₂₁, B₂, 1, B₁)
        elseif SIDE === :R
            gemm!(Val(:N), trans, -1, B₂, A₂₁, 1, B₁)
        else
            gemm!(trans, Val(:N), -1, A₂₁, B₂, 1, B₁)
        end

        trsx!(side, uplo, trans, diag, A₁₁, B₁)
    end
end

# ===== trsm! =====

function trsm!(side::Val, uplo::Val, tA::Val, diag::Val, α, A::AbstractMatrix{T}, B::AbstractMatrix{T}) where {T <: BlasFloat}
    BLAS.trsm!(char(side), char(uplo), char(tA), char(diag), convert(T, α), A, B)
    return
end

function trsm!(side::Val, uplo::Val, tA::Val, diag::Val, α, A::AbstractMatrix, B::AbstractMatrix)
    trsx!(side, uplo, tA, diag, A, B)
    lmul!(α, B)
    return
end

# ===== trsv! =====

function trsv!(uplo::Val, tA::Val, diag::Val, A::AbstractMatrix{T}, b::AbstractVector{T}) where {T <: BlasFloat}
    BLAS.trsv!(char(uplo), char(tA), char(diag), A, b)
    return
end

function trsv!(uplo::Val, tA::Val, diag::Val, A::AbstractMatrix, b::AbstractVector)
    trsx!(Val(:L), uplo, tA, diag, A, b)
    return
end

# ===== factorize! Level 3: ChordalTriangular all positional (SE99) =====

function factorize!(
        W::FactorizationWorkspace,
        L::ChordalTriangular{DIAG, UPLO, T, I},
        d::AbstractVector,
        signs::AbstractVector,
        reg::SE99,
        tol::Real,
    ) where {DIAG, UPLO, T, I <: Integer}
    R = initialize(L, signs, reg)

    if DIAG === :U
        @inbounds for j in fronts(L)
            D, res = diagblock(L, j)
            d[res] .= view(parent(D), diagind(D))
        end

        e = d
    else
        e = LinearAlgebra.diag(L)
    end

    chol_se99_impl!(W.Mptr, W.Mval, L.S.Dptr, L.Dval, L.S.Lptr, L.Lval, e, W.Eval, W.Fval, L.S.res, L.S.rel, L.S.sep, L.S.chd, L.uplo, signs, R, L.diag)

    return zero(I)
end

function chol_se99_impl!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Eval::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        sep::AbstractGraph{I},
        chd::AbstractGraph{I},
        uplo::Val{UPLO},
        S::AbstractVector{T},
        R::SE99,
        diag::Val{DIAG},
    ) where {T, I <: Integer, UPLO, DIAG}

    ns = zero(I); Mptr[one(I)] = one(I)
    phase = true
    deltapos = zero(real(T))
    deltaneg = zero(real(T))

    for j in vertices(res)
        ns, deltapos, deltaneg, phase = chol_se99_loop!(
            Mptr, Mval, Dptr, Dval, Lptr, Lval, d, Eval, Fval,
            res, rel, sep, chd, ns, j, uplo, S, R, diag, phase, deltapos, deltaneg
        )
    end
end

function chol_se99_loop!(
        Mptr::AbstractVector{I},
        Mval::AbstractVector{T},
        Dptr::AbstractVector{I},
        Dval::AbstractVector{T},
        Lptr::AbstractVector{I},
        Lval::AbstractVector{T},
        d::AbstractVector{T},
        Eval::AbstractVector{T},
        Fval::AbstractVector{T},
        res::AbstractGraph{I},
        rel::AbstractGraph{I},
        sep::AbstractGraph{I},
        chd::AbstractGraph{I},
        ns::I,
        j::I,
        uplo::Val{UPLO},
        S::AbstractVector{T},
        R::SE99,
        diag::Val{DIAG},
        phase::Bool,
        deltapos::Real,
        deltaneg::Real,
    ) where {T, I <: Integer, UPLO, DIAG}
    #
    # nn is the size of the residual at node j
    #
    #     nn = | res(j) |
    #
    nn = eltypedegree(res, j)
    #
    # na is the size of the separator at node j
    #
    #     na = | sep(j) |
    #
    na = eltypedegree(rel, j)
    #
    # nj is the size of the bag at node j
    #
    #     nj = | bag(j) |
    #
    nj = nn + na
    #
    # F is the frontal matrix at node j
    #
    #           nn  na
    #     F = [ F₁₁     ] nn
    #         [ F₂₁ F₂₂ ] na
    #
    F = reshape(view(Fval, oneto(nj * nj)), nj, nj)

    F₁₁ = view(F, oneto(nn),      oneto(nn))
    F₂₂ = view(F, nn + one(I):nj, nn + one(I):nj)

    if UPLO === :L
        F₂₁ = view(F, nn + one(I):nj, oneto(nn))
    else
        F₂₁ = view(F, oneto(nn), nn + one(I):nj)
    end
    #
    # L is part of the factor
    #
    #          res(j)
    #     L = [ D₁₁ ] res(j)
    #         [ L₂₁ ] sep(j)
    #
    Dp = Dptr[j]
    Lp = Lptr[j]
    d₁₁ = view(d, neighbors(res, j))
    S₁₁ = view(S, neighbors(res, j))
    S₂₂ = view(S, neighbors(sep, j))
    D₁₁ = reshape(view(Dval, Dp:Dp + nn * nn - one(I)), nn, nn)

    if UPLO === :L
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), na, nn)
    else
        L₂₁ = reshape(view(Lval, Lp:Lp + nn * na - one(I)), nn, na)
    end
    #
    # e₂₂ is the separator diagonal vector
    #
    #     e₂₂ = diag(F₂₂)
    #
    d₂₂ = view(d, neighbors(sep, j))
    e₂₂ = view(Eval, oneto(na))
    copyrec!(e₂₂, d₂₂)
    #
    #     F ← 0
    #
    zerotri!(F, uplo)

    for i in Iterators.reverse(neighbors(chd, j))
        #
        # add the update matrix for child i to F
        #
        #     F ← F + Rᵢ Sᵢ Rᵢᵀ
        #
        chol_send!(F, Mptr, Mval, rel, ns, i, uplo)
        ns -= one(I)
    end
    #
    # add F to L
    #
    #     L ← L + F
    #
    addtri!(D₁₁, F₁₁, uplo)
    addrec!(L₂₁, F₂₁)
    #
    # M₂₂ is the update matrix for node j
    #
    if ispositive(na)
        ns += one(I)
        strt = Mptr[ns]
        stop = Mptr[ns + one(I)] = strt + na * na
        M₂₂ = reshape(view(Mval, strt:stop - one(I)), na, na)
        #
        #     M₂₂ ← F₂₂
        #
        copytri!(M₂₂, F₂₂, uplo)
    else
        M₂₂ = reshape(view(Mval, one(I):zero(I)), zero(I), zero(I))
    end
    #
    # factorize D₁₁
    #
    #     D₁₁ ← cholesky(D₁₁)
    #
    deltapos, deltaneg, phase = chol_se99_kernel!(D₁₁, L₂₁, M₂₂, Fval, d₁₁, e₂₂, S₁₁, S₂₂, R, phase, deltapos, deltaneg, uplo, diag)
    #
    # copy separator diagonal back to global
    #
    #     d₂₂ ← e₂₂
    #
    copyrec!(d₂₂, e₂₂)

    return ns, deltapos, deltaneg, phase
end

function chol_se99_kernel!(
        L₁::AbstractMatrix{T},
        L₂::AbstractMatrix{T},
        M::AbstractMatrix{T},
        W::AbstractVector{T},
        d₁::AbstractVector{T},
        d₂::AbstractVector{T},
        S₁::AbstractVector{T},
        S₂::AbstractVector{T},
        R::SE99,
        phase::Bool,
        deltapos::Real,
        deltaneg::Real,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, UPLO, DIAG}
    @assert size(L₁, 1) == size(L₁, 2)
    @assert size(M, 1) == size(M, 2)
    #
    # factorize L₁
    #
    j = 1

    if phase
        j, deltapos, deltaneg, phase = chol_se99_factor!(L₁, L₂, W, d₁, d₂, S₁, S₂, R, deltapos, deltaneg, j, uplo, diag, Val(true))
    end

    if !phase
        j, deltapos, deltaneg, phase = chol_se99_factor!(L₁, L₂, W, d₁, d₂, S₁, S₂, R, deltapos, deltaneg, j, uplo, diag, Val(false))
    end

    if !isempty(M)
        if UPLO === :L
            trans = Val(:N)
        else
            trans = Val(:C)
        end
        #
        #     M ← M - L₂ D₁ L₂ᴴ
        #
        syrk!(uplo, trans, -one(real(T)), W, L₂, d₁, one(real(T)), M, diag)
    end

    return deltapos, deltaneg, phase
end

function chol_se99_factor_loop!(
        L₁::AbstractMatrix{T},
        L₂::AbstractMatrix{T},
        W::AbstractVector{T},
        d₁::AbstractVector{T},
        bstrt::Int,
        bstop::Int,
        uplo::Val{UPLO},
        diag::Val{DIAG},
    ) where {T, UPLO, DIAG}

    n = size(L₁, 1)
    bstop >= n && return

    Drr = view(L₁, bstop + 1:n, bstop + 1:n)
    dbb = view(d₁, bstrt:bstop)

    if UPLO === :L
        Drb = view(L₁, bstop + 1:n, bstrt:bstop)
        syrk!(Val(:L), Val(:N), -one(real(T)), W, Drb, dbb, one(real(T)), Drr, diag)
    else
        Drb = view(L₁, bstrt:bstop, bstop + 1:n)
        syrk!(Val(:U), Val(:C), -one(real(T)), W, Drb, dbb, one(real(T)), Drr, diag)
    end

    if !isempty(L₂)
        if UPLO === :L
            Lnb = view(L₂, :, bstrt:bstop)
            Lnr = view(L₂, :, bstop + 1:n)
            gemm!(Val(:N), Val(:C), -one(T), W, Lnb, Drb, dbb, one(T), Lnr, diag)
        else
            Lnb = view(L₂, bstrt:bstop, :)
            Lnr = view(L₂, bstop + 1:n, :)
            gemm!(Val(:C), Val(:N), -one(T), W, Drb, Lnb, dbb, one(T), Lnr, diag)
        end
    end

    return
end

function chol_se99_factor!(
        L₁::AbstractMatrix{T},
        L₂::AbstractMatrix{T},
        W::AbstractVector{T},
        d₁::AbstractVector{T},
        d₂::AbstractVector{T},
        S₁::AbstractVector{T},
        S₂::AbstractVector{T},
        R::SE99,
        deltapos::Real,
        deltaneg::Real,
        bstrt::Int,
        uplo::Val{UPLO},
        diag::Val{DIAG},
        phase::Val{PHASE},
    ) where {T, UPLO, DIAG, PHASE}

    n = size(L₁, 1)
    bstop = min(cld(bstrt, THRESHOLD) * THRESHOLD, n)

    @inbounds while bstrt <= n
        j, deltapos, deltaneg, newphase = chol_se99_factor_block!(L₁, L₂, d₁, d₂, S₁, S₂, R, deltapos, deltaneg, bstrt, bstop, uplo, diag, phase)

        if PHASE && !newphase
            j, deltapos, deltaneg = chol_se99_factor_block!(L₁, L₂, d₁, d₂, S₁, S₂, R, deltapos, deltaneg, j, bstop, uplo, diag, Val(false))
            chol_se99_factor_loop!(L₁, L₂, W, d₁, bstrt, bstop, uplo, diag)

            for cstrt in bstop + 1:THRESHOLD:n
                cstop = min(cstrt + THRESHOLD - 1, n)

                j, deltapos, deltaneg = chol_se99_factor_block!(L₁, L₂, d₁, d₂, S₁, S₂, R, deltapos, deltaneg, cstrt, cstop, uplo, diag, Val(false))
                chol_se99_factor_loop!(L₁, L₂, W, d₁, cstrt, cstop, uplo, diag)
            end

            return n + 1, deltapos, deltaneg, false
        end

        chol_se99_factor_loop!(L₁, L₂, W, d₁, bstrt, bstop, uplo, diag)

        bstrt = bstop + 1
        bstop = min(bstrt + THRESHOLD - 1, n)
    end

    return n + 1, deltapos, deltaneg, PHASE
end

function chol_se99_factor_block!(
        L₁::AbstractMatrix{T},
        L₂::AbstractMatrix{T},
        d₁::AbstractVector{T},
        d₂::AbstractVector{T},
        S₁::AbstractVector{T},
        S₂::AbstractVector{T},
        R::SE99,
        deltapos::Real,
        deltaneg::Real,
        bstrt::Int,
        bstop::Int,
        uplo::Val{:L},
        ::Val{DIAG},
        ::Val{PHASE},
    ) where {T, DIAG, PHASE}

    n = size(L₁, 1)

    @inbounds for j in bstrt:bstop
        #
        # Check A: diagonal acceptability
        #
        if PHASE && !checkdiag(R, S₁, S₂, d₁, d₂, real(S₁[j]) * real(d₁[j]), j)
            return j, deltapos, deltaneg, false
        end
        #
        # Left-looking update
        #
        for k in bstrt:j - 1
            Ljk = L₁[j, k]; cLjk = conj(Ljk)

            for i in j+1:n
                if DIAG === :N
                    L₁[i, j] -= L₁[i, k] * cLjk
                else
                    L₁[i, j] -= L₁[i, k] * d₁[k] * cLjk
                end
            end
        end

        for k in bstrt:j - 1
            Ljk = L₁[j, k]; cLjk = conj(Ljk)

            for i in axes(L₂, 1)
                if DIAG === :N
                    L₂[i, j] -= L₂[i, k] * cLjk
                else
                    L₂[i, j] -= L₂[i, k] * d₁[k] * cLjk
                end
            end
        end

        Ljj = real(d₁[j])

        if PHASE && !lookahead(R, S₁, S₂, L₁, L₂, d₁, d₂, j, uplo)
            return j, deltapos, deltaneg, false
        elseif !PHASE
            Ljj, deltapos, deltaneg = regularize(R, S₁, L₁, L₂, Ljj, j, deltapos, deltaneg, uplo)
        end

        if DIAG === :N
            L₁[j, j] = Ljj = sqrt(Ljj)
        else
            d₁[j] = Ljj
        end

        iLjj = inv(Ljj)

        for i in j+1:n
            L₁[i, j] *= iLjj
        end

        for i in axes(L₂, 1)
            L₂[i, j] *= iLjj
        end

        for i in j+1:n
            if DIAG === :N
                d₁[i] -= abs2(L₁[i, j])
            else
                d₁[i] -= Ljj * abs2(L₁[i, j])
            end
        end

        if PHASE
            for i in axes(L₂, 1)
                if DIAG === :N
                    d₂[i] -= abs2(L₂[i, j])
                else
                    d₂[i] -= Ljj * abs2(L₂[i, j])
                end
            end
        end
    end

    return bstop + 1, deltapos, deltaneg, PHASE
end

function chol_se99_factor_block!(
        L₁::AbstractMatrix{T},
        L₂::AbstractMatrix{T},
        d₁::AbstractVector{T},
        d₂::AbstractVector{T},
        S₁::AbstractVector{T},
        S₂::AbstractVector{T},
        R::SE99,
        deltapos::Real,
        deltaneg::Real,
        bstrt::Int,
        bstop::Int,
        uplo::Val{:U},
        ::Val{DIAG},
        ::Val{PHASE},
    ) where {T, DIAG, PHASE}

    n = size(L₁, 1)

    @inbounds for j in bstrt:bstop
        #
        # Check A: diagonal acceptability
        #
        if PHASE && !checkdiag(R, S₁, S₂, d₁, d₂, real(S₁[j]) * real(d₁[j]), j)
            return j, deltapos, deltaneg, false
        end
        #
        # Left-looking update
        #
        for i in j+1:n
            for k in bstrt:j-1
                if DIAG === :N
                    L₁[j, i] -= L₁[k, i] * conj(L₁[k, j])
                else
                    L₁[j, i] -= L₁[k, i] * d₁[k] * conj(L₁[k, j])
                end
            end
        end

        for i in axes(L₂, 2)
            for k in bstrt:j-1
                if DIAG === :N
                    L₂[j, i] -= L₂[k, i] * conj(L₁[k, j])
                else
                    L₂[j, i] -= L₂[k, i] * d₁[k] * conj(L₁[k, j])
                end
            end
        end

        Ljj = real(d₁[j])

        if PHASE && !lookahead(R, S₁, S₂, L₁, L₂, d₁, d₂, j, uplo)
            return j, deltapos, deltaneg, false
        elseif !PHASE
            Ljj, deltapos, deltaneg = regularize(R, S₁, L₁, L₂, Ljj, j, deltapos, deltaneg, uplo)
        end

        if DIAG === :N
            L₁[j, j] = Ljj = sqrt(Ljj)
        else
            d₁[j] = Ljj
        end

        iLjj = inv(Ljj)

        for i in j+1:n
            L₁[j, i] *= iLjj
        end

        for i in axes(L₂, 2)
            L₂[j, i] *= iLjj
        end

        for i in j+1:n
            if DIAG === :N
                d₁[i] -= abs2(L₁[j, i])
            else
                d₁[i] -= Ljj * abs2(L₁[j, i])
            end
        end

        if PHASE
            for i in axes(L₂, 2)
                if DIAG === :N
                    d₂[i] -= abs2(L₂[j, i])
                else
                    d₂[i] -= Ljj * abs2(L₂[j, i])
                end
            end
        end
    end

    return bstop + 1, deltapos, deltaneg, PHASE
end

include("regularization/abstract_regularization.jl")
include("regularization/no_regularization.jl")
include("regularization/dynamic_regularization.jl")
include("regularization/gmw81.jl")
include("regularization/se99.jl")

# Library Reference

```@meta
CurrentModule = CliqueTrees
```

## Lower Bound Algorithms
```@docs
LowerBoundAlgorithm
MMW
lowerbound
DEFAULT_LOWER_BOUND_ALGORITHM
```

## Dissection Algorithms
```@docs
DissectionAlgorithm
METISND
KaHyParND
DEFAULT_DISSECTION_ALGORITHM
```

## Elimination Algorithms

```@docs
EliminationAlgorithm
PermutationOrAlgorithm
DEFAULT_ELIMINATION_ALGORITHM
BFS
MCS
LexBFS
RCMMD
RCMGL
RCM
LexM
MCSM
AMD
SymAMD
AMF
MF
MMD
METIS
ND
Spectral
FlowCutter
BT
MinimalChordal
CompositeRotations
Compression
SafeRules
SafeSeparators
ConnectedComponents
permutation
```

## Supernodes

```@docs
SupernodeType
DEFAULT_SUPERNODE_TYPE
Nodal
Maximal
Fundamental
```

## Trees

```@docs
AbstractTree
rootindices
ancestorindices
```

### Trees

```@docs
Tree
eliminationtree
```

### Supernode Trees

```@docs
SupernodeTree
supernodetree
```

### Clique Trees

```@docs
Clique
CliqueTree
cliquetree
treewidth
separator
residual
```

## Filled Graphs

```@docs
FilledGraph
ischordal
isperfect
```

## Matrix Factorization
```@docs
Multifrontal.ChordalSymbolic
Multifrontal.ChordalCholesky
Multifrontal.ChordalLDLt
Multifrontal.ChordalTriangular
Multifrontal.DynamicRegularization
Multifrontal.Permutation
Multifrontal.symbolic
Multifrontal.cholesky!
Multifrontal.ldlt!
Multifrontal.selinv!
Multifrontal.complete!
```

# Multifrontal.jl

The Multifrontal.jl submodule implements sparse Cholesky and LDLt factorization in pure Julia.
The algorithms implemented in Multifrontal.jl are *supernodal*, partitioning the input matrix into
dense blocks on which they call BLAS level 3 matrix kernels. This distinguishes Multifrontal.jl from
similar libraries like [QDLDL.jl](https://github.com/oxfordcontrol/QDLDL.jl) and
[LDLFactorizations.jl](https://github.com/JuliaSmoothOptimizers/LDLFactorizations.jl), which
implement *simplicial* algorithms that proceed column-by-column. Simplicial algorithms are faster on extremely
sparse matrices, whereas supernodal algorithms are faster on everything else.

## Algorithms

### Cholesky Factorization

A Cholesky factorization represents a symmetric positive-definite matrix
``A`` as a product

```math
A = P^\mathsf{T} L L^\mathsf{T} P
```

where ``L`` is lower triangular and ``P`` is a permutation. In order
to compute a Cholesky factorization using Multifrontal.jl, construct
a `ChordalCholesky` object and call the function `cholesky!`.

```julia-repl
julia> using CliqueTrees.Multifrontal, LinearAlgebra

julia> A = [
           4  2  0  0  2
           2  5  0  0  3
           0  0  4  2  0
           0  0  2  5  2
           2  3  0  2  7
       ];

julia> F = cholesky!(ChordalCholesky(A))
5×5 FChordalCholesky{:L, Float64, Int64} with 10 stored entries:
 2.0   ⋅    ⋅    ⋅    ⋅
 0.0  2.0   ⋅    ⋅    ⋅
 0.0  1.0  2.0   ⋅    ⋅
 1.0  0.0  0.0  2.0   ⋅
 0.0  1.0  1.0  1.0  2.0
```

`ChordalCholesky` objects behave like factorizations in LinearAlgebra.jl.
You can solve linear systems using `/` and `\`.

```julia-repl
julia> b = [4, 2, 0, 0, 2];

julia> F \ b
5-element Vector{Float64}:
 1.0
 0.0
 0.0
 0.0
 0.0
```

Alternatively, you can access each part of the factorization as a field:
`F.L` and `F.P`.

```julia-repl
julia> F.P \ (F.L' \ (F.L \ (F.P' \ b)))
5-element Vector{Float64}:
 1.0
 0.0
 0.0
 0.0
 0.0
```

### LDLt Factorization

An LDLt factorization represents a symmetric quasi-definite matrix ``A`` as a product

```math
A = P^\mathsf{T} L D L^\mathsf{T} P
```

where ``D`` is diagonal, ``L`` is unit lower triangular, and ``P`` is a permutation.
In order to compute an LDLt factorization using Multifrontal.jl, construct
a `ChordalLDLt` object and call the function `ldlt!`.

```julia-repl
julia> using CliqueTrees.Multifrontal, LinearAlgebra

julia> A = [
          -4 -2  0  0  2
          -2 -5  0  0  3
           0  0  4  2  0
           0  0  2  5  2
           2  3  0  2  7
       ];

julia> F = ldlt!(ChordalLDLt(A))
5×5 FChordalLDLt{:L, Float64, Int64} with 12 stored entries:
 1.0    ⋅     ⋅    ⋅    ⋅
 0.0   1.0    ⋅    ⋅    ⋅
 0.0   0.5   1.0   ⋅    ⋅
 0.5   0.0   0.0  1.0   ⋅
 0.0  -0.5  -0.5  0.5  1.0

 4.0    ⋅     ⋅    ⋅    ⋅
  ⋅   -4.0    ⋅    ⋅    ⋅
  ⋅     ⋅   -4.0   ⋅    ⋅
  ⋅     ⋅     ⋅   4.0   ⋅
  ⋅     ⋅     ⋅    ⋅   8.0
```

`ChordalLDLt` objects behave like factorizations in LinearAlgebra.jl.
You can solve linear systems using `/` and `\`.

```julia-repl
julia> b = [-4, -2, 0, 0, 2];

julia> F \ b
5-element Vector{Float64}:
  1.0
 -0.0
  0.0
  0.0
  0.0
```

Alternatively, you can access each part of the factorization as a field:
`F.D`, `F.L`, and `F.P`.

```julia-repl
julia> F.P \ (F.L' \ (F.D \ (F.L \ (F.P' \ b))))
5-element Vector{Float64}:
  1.0
 -0.0
  0.0
  0.0
  0.0
```

The diagonal elements of ``D`` are called *pivots*. Sometimes, it is possible to
know the sign of each pivot before performing the factorization. This data
can be provided to the factorization algorithm using the keyword argument `signs`.

```julia-repl
julia> F = ldlt!(ChordalLDLt(A); signs=[-1, -1, 1, 1, 1])
5×5 FChordalLDLt{:L, Float64, Int64} with 12 stored entries:
 1.0    ⋅     ⋅    ⋅    ⋅
 0.0   1.0    ⋅    ⋅    ⋅
 0.0   0.5   1.0   ⋅    ⋅
 0.5   0.0   0.0  1.0   ⋅
 0.0  -0.5  -0.5  0.5  1.0

 4.0    ⋅     ⋅    ⋅    ⋅
  ⋅   -4.0    ⋅    ⋅    ⋅
  ⋅     ⋅   -4.0   ⋅    ⋅
  ⋅     ⋅     ⋅   4.0   ⋅
  ⋅     ⋅     ⋅    ⋅   8.0
```

### Benchmarks

Here are runtimes for the matrix [oilpan](https://sparse.tamu.edu/GHS_psdef/oilpan),
which has 73,752 columns and 2,148,558 nonzero entries.

| library                    | time (ms) |
| -------------------------- | --------- |
| CHOLMOD                    | 113       |
| Multifrontal.jl (LDLt)     | 126       |
| Multifrontal.jl (Cholesky) | 139       |
| QDLDL.jl                   | 582       |
| LDLFactorizations.jl       | 587       |
